/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/base/common/types","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/network","vs/base/common/cancellation","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/request/common/request","vs/platform/userDataSync/common/abstractSynchronizer","child_process","vs/platform/externalServices/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/jsonFormatter","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/languagePacks/common/languagePacks","vs/platform/native/electron-sandbox/native","vs/platform/configuration/common/configurationModels","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/electron-sandbox/services","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/storage/common/storageIpc","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/browser/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/defaultExtensionsProfileInit","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","string_decoder","util","minimist","assert","path","graceful-fs","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],re=function(X){for(var e=[],D=0,i=X.length;D<i;D++)e[D]=ne[X[D]];return e};define(ne[110],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(i,k){if(!i)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=D}),define(ne[51],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(A){return A?A.replace(/\$\((.*?)\)/g,(b,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=D;class i{constructor(b,C,R){this.id=b,this.definition=C,this.description=R,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function k(A,b){const C=["codicon","codicon-"+A];return b&&C.push("codicon-modifier-"+b),C}e.getClassNamesArray=k;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function C(E){if(E instanceof i)return["codicon","codicon-"+E.id];const v=b.exec(E.id);if(!v)return C(i.error);const[,y,d]=v,S=["codicon","codicon-"+y];return d&&S.push("codicon-modifier-"+d.substr(1)),S}A.asClassNameArray=C;function R(E){return C(E).join(" ")}A.asClassName=R;function I(E){return"."+C(E).join(".")}A.asCSSSelector=I})(L=e.CSSIcon||(e.CSSIcon={}))}),define(ne[60],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(A){return(b,C,R)=>{let I=null,E=null;if(typeof R.value=="function"?(I="value",E=R.value):typeof R.get=="function"&&(I="get",E=R.get),!E)throw new Error("not supported");R[I]=A(E,C)}}e.createDecorator=D;function i(A,b,C){let R=null,I=null;if(typeof C.value=="function"?(R="value",I=C.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(R="get",I=C.get),!I)throw new Error("not supported");const E=`$memoize$${b}`;C[R]=function(...v){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,v)}),this[E]}}e.memoize=i;function k(A,b,C){return D((R,I)=>{const E=`$debounce$${I}`,v=`$debounce$result$${I}`;return function(...y){this[v]||(this[v]=C?C():void 0),clearTimeout(this[E]),b&&(this[v]=b(this[v],...y),y=[this[v]]),this[E]=setTimeout(()=>{R.apply(this,y),this[v]=C?C():void 0},A)}})}e.debounce=k;function L(A,b,C){return D((R,I)=>{const E=`$throttle$timer$${I}`,v=`$throttle$result$${I}`,y=`$throttle$lastRun$${I}`,d=`$throttle$pending$${I}`;return function(...S){if(this[v]||(this[v]=C?C():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),b&&(this[v]=b(this[v],...S)),this[d])return;const w=this[y]+A;w<=Date.now()?(this[y]=Date.now(),R.apply(this,[this[v]]),this[v]=C?C():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),R.apply(this,[this[v]]),this[v]=C?C():void 0},w-Date.now()))}})}e.throttle=L}),define(ne[9],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?u.isErrorNoTelemetry(r)?new u(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(n=>{n(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=D,e.errorHandler=new D;function i(h){e.errorHandler.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=i;function k(h){C(h)||e.errorHandler.onUnexpectedError(h)}e.onUnexpectedError=k;function L(h){C(h)||e.errorHandler.onUnexpectedExternalError(h)}e.onUnexpectedExternalError=L;function A(h){if(h instanceof Error){const{name:r,message:n}=h,t=h.stacktrace||h.stack;return{$isError:!0,name:r,message:n,stack:t,noTelemetry:u.isErrorNoTelemetry(h)}}return h}e.transformErrorForSerialization=A;const b="Canceled";function C(h){return h instanceof R?!0:h instanceof Error&&h.name===b&&h.message===b}e.isCancellationError=C;class R extends Error{constructor(){super(b);this.name=this.message}}e.CancellationError=R;function I(){const h=new Error(b);return h.name=h.message,h}e.canceled=I;function E(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.illegalArgument=E;function v(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.illegalState=v;function y(h){return h?new Error(`readonly property '${h} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(h){const r=new Error(`${h} has been disposed`);return r.name="DISPOSED",r}e.disposed=d;function S(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.getErrorMessage=S;class w extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=w;class p extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=p;class m extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=m;class u extends Error{constructor(r){super(r);this.name="ErrorNoTelemetry"}static fromError(r){if(r instanceof u)return r;const n=new u;return n.message=r.message,n.stack=r.stack,n}static isErrorNoTelemetry(r){return r.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=u;class g extends Error{constructor(r){super(r||"An unexpected bug occurred.");Object.setPrototypeOf(this,g.prototype);debugger}}e.BugIndicatingError=g}),define(ne[18],re([0,1,9]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function i(G,te=0){return G[G.length-(1+te)]}e.tail=i;function k(G){if(G.length===0)throw new Error("Invalid tail call");return[G.slice(0,G.length-1),G[G.length-1]]}e.tail2=k;function L(G,te,se=(ce,he)=>ce===he){if(G===te)return!0;if(!G||!te||G.length!==te.length)return!1;for(let ce=0,he=G.length;ce<he;ce++)if(!se(G[ce],te[ce]))return!1;return!0}e.equals=L;function A(G,te){const se=G.length-1;te<se&&(G[te]=G[se]),G.pop()}e.removeFastWithoutKeepingOrder=A;function b(G,te,se){return C(G.length,ce=>se(G[ce],te))}e.binarySearch=b;function C(G,te){let se=0,ce=G-1;for(;se<=ce;){const he=(se+ce)/2|0,ve=te(he);if(ve<0)se=he+1;else if(ve>0)ce=he-1;else return he}return-(se+1)}e.binarySearch2=C;function R(G,te){let se=0,ce=G.length;if(ce===0)return 0;for(;se<ce;){const he=Math.floor((se+ce)/2);te(G[he])?ce=he:se=he+1}return se}e.findFirstInSorted=R;function I(G,te,se){if(G=G|0,G>=te.length)throw new TypeError("invalid index");const ce=te[Math.floor(te.length*Math.random())],he=[],ve=[],pe=[];for(const Ce of te){const be=se(Ce,ce);be<0?he.push(Ce):be>0?ve.push(Ce):pe.push(Ce)}return G<he.length?I(G,he,se):G<he.length+pe.length?pe[0]:I(G-(he.length+pe.length),ve,se)}e.quickSelect=I;function E(G,te){const se=[];let ce;for(const he of G.slice(0).sort(te))!ce||te(ce[0],he)!==0?(ce=[he],se.push(ce)):ce.push(he);return se}e.groupBy=E;function v(G,te,se){const ce=[];function he(Ce,be,Pe){if(be===0&&Pe.length===0)return;const Me=ce[ce.length-1];Me&&Me.start+Me.deleteCount===Ce?(Me.deleteCount+=be,Me.toInsert.push(...Pe)):ce.push({start:Ce,deleteCount:be,toInsert:Pe})}let ve=0,pe=0;for(;;){if(ve===G.length){he(ve,0,te.slice(pe));break}if(pe===te.length){he(ve,G.length-ve,[]);break}const Ce=G[ve],be=te[pe],Pe=se(Ce,be);Pe===0?(ve+=1,pe+=1):Pe<0?(he(ve,1,[]),ve+=1):Pe>0&&(he(ve,0,[be]),pe+=1)}return ce}e.sortedDiff=v;function y(G,te,se){const ce=v(G,te,se),he=[],ve=[];for(const pe of ce)he.push(...G.slice(pe.start,pe.start+pe.deleteCount)),ve.push(...pe.toInsert);return{removed:he,added:ve}}e.delta=y;function d(G,te,se){if(se===0)return[];const ce=G.slice(0,se).sort(te);return w(G,te,ce,se,G.length),ce}e.top=d;function S(G,te,se,ce,he){return se===0?Promise.resolve([]):new Promise((ve,pe)=>{(async()=>{const Ce=G.length,be=G.slice(0,se).sort(te);for(let Pe=se,Me=Math.min(se+ce,Ce);Pe<Ce;Pe=Me,Me=Math.min(Me+ce,Ce)){if(Pe>se&&await new Promise(Ye=>setTimeout(Ye)),he&&he.isCancellationRequested)throw new D.CancellationError;w(G,te,be,Pe,Me)}return be})().then(ve,pe)})}e.topAsync=S;function w(G,te,se,ce,he){for(const ve=se.length;ce<he;ce++){const pe=G[ce];if(te(pe,se[ve-1])<0){se.pop();const Ce=R(se,be=>te(pe,be)<0);se.splice(Ce,0,pe)}}}function p(G){return G.filter(te=>!!te)}e.coalesce=p;function m(G){let te=0;for(let se=0;se<G.length;se++)G[se]&&(G[te]=G[se],te+=1);G.length=te}e.coalesceInPlace=m;function u(G,te,se){G.splice(se,0,G.splice(te,1)[0])}e.move=u;function g(G){return!Array.isArray(G)||G.length===0}e.isFalsyOrEmpty=g;function h(G){return Array.isArray(G)&&G.length>0}e.isNonEmptyArray=h;function r(G,te=se=>se){const se=new Set;return G.filter(ce=>{const he=te(ce);return se.has(he)?!1:(se.add(he),!0)})}e.distinct=r;function n(G){const te=new Set;return se=>{const ce=G(se);return te.has(ce)?!1:(te.add(ce),!0)}}e.uniqueFilter=n;function t(G,te){const se=s(G,te);if(se!==-1)return G[se]}e.findLast=t;function s(G,te){for(let se=G.length-1;se>=0;se--){const ce=G[se];if(te(ce))return se}return-1}e.lastIndex=s;function a(G,te){return G.length>0?G[0]:te}e.firstOrDefault=a;function c(G,te){return G.length>0?G[G.length-1]:te}e.lastOrDefault=c;function o(G,te,se=(ce,he)=>ce===he){let ce=0;for(let he=0,ve=Math.min(G.length,te.length);he<ve&&se(G[he],te[he]);he++)ce++;return ce}e.commonPrefixLength=o;function l(G){return[].concat(...G)}e.flatten=l;function f(G,te){let se=typeof te=="number"?G:0;typeof te=="number"?se=G:(se=0,te=G);const ce=[];if(se<=te)for(let he=se;he<te;he++)ce.push(he);else for(let he=se;he>te;he--)ce.push(he);return ce}e.range=f;function P(G,te,se){return G.reduce((ce,he)=>(ce[te(he)]=se?se(he):he,ce),Object.create(null))}e.index=P;function U(G,te){return G.push(te),()=>_(G,te)}e.insert=U;function _(G,te){const se=G.indexOf(te);if(se>-1)return G.splice(se,1),te}e.remove=_;function F(G,te,se){const ce=G.slice(0,te),he=G.slice(te);return ce.concat(se,he)}e.arrayInsert=F;function T(G,te){let se;if(typeof te=="number"){let ce=te;se=()=>{const he=Math.sin(ce++)*179426549;return he-Math.floor(he)}}else se=Math.random;for(let ce=G.length-1;ce>0;ce-=1){const he=Math.floor(se()*(ce+1)),ve=G[ce];G[ce]=G[he],G[he]=ve}}e.shuffle=T;function N(G,te){const se=G.indexOf(te);se>-1&&(G.splice(se,1),G.unshift(te))}e.pushToStart=N;function z(G,te){const se=G.indexOf(te);se>-1&&(G.splice(se,1),G.push(te))}e.pushToEnd=z;function V(G,te){for(const se of te)G.push(se)}e.pushMany=V;function J(G,te){return Array.isArray(G)?G.map(te):te(G)}e.mapArrayOrNot=J;function $(G){return Array.isArray(G)?G:[G]}e.asArray=$;function Q(G){return G[Math.floor(Math.random()*G.length)]}e.getRandomElement=Q;function H(G,te){for(const se of G){const ce=te(se);if(ce!==void 0)return ce}}e.mapFind=H;function B(G,te,se){const ce=ie(G,te),he=G.length,ve=se.length;G.length=he+ve;for(let pe=he-1;pe>=ce;pe--)G[pe+ve]=G[pe];for(let pe=0;pe<ve;pe++)G[pe+ce]=se[pe]}e.insertInto=B;function Y(G,te,se,ce){const he=ie(G,te),ve=G.splice(he,se);return B(G,he,ce),ve}e.splice=Y;function ie(G,te){return te<0?Math.max(te+G.length,0):Math.min(te,G.length)}var ae;(function(G){function te(he){return he<0}G.isLessThan=te;function se(he){return he>0}G.isGreaterThan=se;function ce(he){return he===0}G.isNeitherLessOrGreaterThan=ce,G.greaterThan=1,G.lessThan=-1,G.neitherLessOrGreaterThan=0})(ae=e.CompareResult||(e.CompareResult={}));function W(G,te){return(se,ce)=>te(G(se),G(ce))}e.compareBy=W;function x(...G){return(te,se)=>{for(const ce of G){const he=ce(te,se);if(!ae.isNeitherLessOrGreaterThan(he))return he}return ae.neitherLessOrGreaterThan}}e.tieBreakComparators=x;const O=(G,te)=>G-te;e.numberComparator=O;function M(G,te){if(G.length===0)return;let se=G[0];for(let ce=1;ce<G.length;ce++){const he=G[ce];te(he,se)>0&&(se=he)}return se}e.findMaxBy=M;function q(G,te){if(G.length===0)return;let se=G[0];for(let ce=1;ce<G.length;ce++){const he=G[ce];te(he,se)>=0&&(se=he)}return se}e.findLastMaxBy=q;function j(G,te){return M(G,(se,ce)=>-te(se,ce))}e.findMinBy=j;class Z{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let se=this.firstIdx;for(;se<this.items.length&&te(this.items[se]);)se++;const ce=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ce}takeFromEndWhile(te){let se=this.lastIdx;for(;se>=0&&te(this.items[se]);)se--;const ce=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const se=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,se}}e.ArrayQueue=Z}),define(ne[74],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(i){const k=this;let L=!1,A;return function(){return L||(L=!0,A=i.apply(k,arguments)),A}}e.once=D}),define(ne[52],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(i){function k(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}i.is=k;const L=Object.freeze([]);function A(){return L}i.empty=A;function*b(n){yield n}i.single=b;function C(n){return n||L}i.from=C;function R(n){return!n||n[Symbol.iterator]().next().done===!0}i.isEmpty=R;function I(n){return n[Symbol.iterator]().next().value}i.first=I;function E(n,t){for(const s of n)if(t(s))return!0;return!1}i.some=E;function v(n,t){for(const s of n)if(t(s))return s}i.find=v;function*y(n,t){for(const s of n)t(s)&&(yield s)}i.filter=y;function*d(n,t){let s=0;for(const a of n)yield t(a,s++)}i.map=d;function*S(...n){for(const t of n)for(const s of t)yield s}i.concat=S;function*w(n){for(const t of n)for(const s of t)yield s}i.concatNested=w;function p(n,t,s){let a=s;for(const c of n)a=t(a,c);return a}i.reduce=p;function m(n,t){let s=0;for(const a of n)t(a,s++)}i.forEach=m;function*u(n,t,s=n.length){for(t<0&&(t+=n.length),s<0?s+=n.length:s>n.length&&(s=n.length);t<s;t++)yield n[t]}i.slice=u;function g(n,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,n];const a=n[Symbol.iterator]();for(let c=0;c<t;c++){const o=a.next();if(o.done)return[s,i.empty()];s.push(o.value)}return[s,{[Symbol.iterator](){return a}}]}i.consume=g;function h(n){return g(n)[0]}i.collect=h;function r(n,t,s=(a,c)=>a===c){const a=n[Symbol.iterator](),c=t[Symbol.iterator]();for(;;){const o=a.next(),l=c.next();if(o.done!==l.done)return!1;if(o.done)return!0;if(!s(o.value,l.value))return!1}}i.equals=r})(D=e.Iterable||(e.Iterable={}))}),define(ne[35],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var i;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(r){r.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function A(r,n=!1){let t=0;const s=r.length;let a="",c=0,o=16,l=0;function f(z){let V=0,J=0;for(;V<z;){const $=r.charCodeAt(t);if($>=48&&$<=57)J=J*16+$-48;else if($>=65&&$<=70)J=J*16+$-65+10;else if($>=97&&$<=102)J=J*16+$-97+10;else break;t++,V++}return V<z&&(J=-1),J}function P(z){t=z,a="",c=0,o=16,l=0}function U(){const z=t;if(r.charCodeAt(t)===48)t++;else for(t++;t<r.length&&R(r.charCodeAt(t));)t++;if(t<r.length&&r.charCodeAt(t)===46)if(t++,t<r.length&&R(r.charCodeAt(t)))for(t++;t<r.length&&R(r.charCodeAt(t));)t++;else return l=3,r.substring(z,t);let V=t;if(t<r.length&&(r.charCodeAt(t)===69||r.charCodeAt(t)===101))if(t++,(t<r.length&&r.charCodeAt(t)===43||r.charCodeAt(t)===45)&&t++,t<r.length&&R(r.charCodeAt(t))){for(t++;t<r.length&&R(r.charCodeAt(t));)t++;V=t}else l=3;return r.substring(z,V)}function _(){let z="",V=t;for(;;){if(t>=s){z+=r.substring(V,t),l=2;break}const J=r.charCodeAt(t);if(J===34){z+=r.substring(V,t),t++;break}if(J===92){if(z+=r.substring(V,t),t++,t>=s){l=2;break}switch(r.charCodeAt(t++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const Q=f(4);Q>=0?z+=String.fromCharCode(Q):l=4;break}default:l=5}V=t;continue}if(J>=0&&J<=31)if(C(J)){z+=r.substring(V,t),l=2;break}else l=6;t++}return z}function F(){if(a="",l=0,c=t,t>=s)return c=s,o=17;let z=r.charCodeAt(t);if(b(z)){do t++,a+=String.fromCharCode(z),z=r.charCodeAt(t);while(b(z));return o=15}if(C(z))return t++,a+=String.fromCharCode(z),z===13&&r.charCodeAt(t)===10&&(t++,a+=`
`),o=14;switch(z){case 123:return t++,o=1;case 125:return t++,o=2;case 91:return t++,o=3;case 93:return t++,o=4;case 58:return t++,o=6;case 44:return t++,o=5;case 34:return t++,a=_(),o=10;case 47:{const V=t-1;if(r.charCodeAt(t+1)===47){for(t+=2;t<s&&!C(r.charCodeAt(t));)t++;return a=r.substring(V,t),o=12}if(r.charCodeAt(t+1)===42){t+=2;const J=s-1;let $=!1;for(;t<J;){if(r.charCodeAt(t)===42&&r.charCodeAt(t+1)===47){t+=2,$=!0;break}t++}return $||(t++,l=1),a=r.substring(V,t),o=13}return a+=String.fromCharCode(z),t++,o=16}case 45:if(a+=String.fromCharCode(z),t++,t===s||!R(r.charCodeAt(t)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=U(),o=11;default:for(;t<s&&T(z);)t++,z=r.charCodeAt(t);if(c!==t){switch(a=r.substring(c,t),a){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return a+=String.fromCharCode(z),t++,o=16}}function T(z){if(b(z)||C(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let z;do z=F();while(z>=12&&z<=15);return z}return{setPosition:P,getPosition:()=>t,scan:n?N:F,getToken:()=>o,getTokenValue:()=>a,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>l}}e.createScanner=A;function b(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function C(r){return r===10||r===13||r===8232||r===8233}function R(r){return r>=48&&r<=57}var I;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(I||(I={}));function E(r,n){const t=[],s=new Object;let a;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function l(f,P,U,_){c.value=f,c.offset=P,c.length=U,c.type=_,c.colonOffset=void 0,a=c}try{u(r,{onObjectBegin:(f,P)=>{if(n<=f)throw s;a=void 0,o=n>f,t.push("")},onObjectProperty:(f,P,U)=>{if(n<P||(l(f,P,U,"property"),t[t.length-1]=f,n<=P+U))throw s},onObjectEnd:(f,P)=>{if(n<=f)throw s;a=void 0,t.pop()},onArrayBegin:(f,P)=>{if(n<=f)throw s;a=void 0,t.push(0)},onArrayEnd:(f,P)=>{if(n<=f)throw s;a=void 0,t.pop()},onLiteralValue:(f,P,U)=>{if(n<P||(l(f,P,U,h(f)),n<=P+U))throw s},onSeparator:(f,P,U)=>{if(n<=P)throw s;if(f===":"&&a&&a.type==="property")a.colonOffset=P,o=!1,a=void 0;else if(f===","){const _=t[t.length-1];typeof _=="number"?t[t.length-1]=_+1:(o=!0,t[t.length-1]=""),a=void 0}}})}catch(f){if(f!==s)throw f}return{path:t,previousNode:a,isAtPropertyKey:o,matches:f=>{let P=0;for(let U=0;P<f.length&&U<t.length;U++)if(f[P]===t[U]||f[P]==="*")P++;else if(f[P]!=="**")return!1;return P===f.length}}}e.getLocation=E;function v(r,n=[],t=L.DEFAULT){let s=null,a=[];const c=[];function o(f){Array.isArray(a)?a.push(f):s!==null&&(a[s]=f)}return u(r,{onObjectBegin:()=>{const f={};o(f),c.push(a),a=f,s=null},onObjectProperty:f=>{s=f},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const f=[];o(f),c.push(a),a=f,s=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:o,onError:(f,P,U)=>{n.push({error:f,offset:P,length:U})}},t),a[0]}e.parse=v;function y(r,n=[],t=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(f){s.type==="property"&&(s.length=f-s.offset,s=s.parent)}function c(f){return s.children.push(f),f}u(r,{onObjectBegin:f=>{s=c({type:"object",offset:f,length:-1,parent:s,children:[]})},onObjectProperty:(f,P,U)=>{s=c({type:"property",offset:P,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:f,offset:P,length:U,parent:s})},onObjectEnd:(f,P)=>{s.length=f+P-s.offset,s=s.parent,a(f+P)},onArrayBegin:(f,P)=>{s=c({type:"array",offset:f,length:-1,parent:s,children:[]})},onArrayEnd:(f,P)=>{s.length=f+P-s.offset,s=s.parent,a(f+P)},onLiteralValue:(f,P,U)=>{c({type:h(f),offset:P,length:U,parent:s,value:f}),a(P+U)},onSeparator:(f,P,U)=>{s.type==="property"&&(f===":"?s.colonOffset=P:f===","&&a(P))},onError:(f,P,U)=>{n.push({error:f,offset:P,length:U})}},t);const l=s.children[0];return l&&delete l.parent,l}e.parseTree=y;function d(r,n){if(!r)return;let t=r;for(const s of n)if(typeof s=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let a=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===s){t=c.children[1],a=!0;break}if(!a)return}else{const a=s;if(t.type!=="array"||a<0||!Array.isArray(t.children)||a>=t.children.length)return;t=t.children[a]}return t}e.findNodeAtLocation=d;function S(r){if(!r.parent||!r.parent.children)return[];const n=S(r.parent);if(r.parent.type==="property"){const t=r.parent.children[0].value;n.push(t)}else if(r.parent.type==="array"){const t=r.parent.children.indexOf(r);t!==-1&&n.push(t)}return n}e.getNodePath=S;function w(r){switch(r.type){case"array":return r.children.map(w);case"object":{const n=Object.create(null);for(const t of r.children){const s=t.children[1];s&&(n[t.children[0].value]=w(s))}return n}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=w;function p(r,n,t=!1){return n>=r.offset&&n<r.offset+r.length||t&&n===r.offset+r.length}e.contains=p;function m(r,n,t=!1){if(p(r,n,t)){const s=r.children;if(Array.isArray(s))for(let a=0;a<s.length&&s[a].offset<=n;a++){const c=m(s[a],n,t);if(c)return c}return r}}e.findNodeAtOffset=m;function u(r,n,t=L.DEFAULT){const s=A(r,!1);function a(W){return W?()=>W(s.getTokenOffset(),s.getTokenLength()):()=>!0}function c(W){return W?x=>W(x,s.getTokenOffset(),s.getTokenLength()):()=>!0}const o=a(n.onObjectBegin),l=c(n.onObjectProperty),f=a(n.onObjectEnd),P=a(n.onArrayBegin),U=a(n.onArrayEnd),_=c(n.onLiteralValue),F=c(n.onSeparator),T=a(n.onComment),N=c(n.onError),z=t&&t.disallowComments,V=t&&t.allowTrailingComma;function J(){for(;;){const W=s.scan();switch(s.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:z||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(W){case 12:case 13:z?$(10):T();break;case 16:$(1);break;case 15:case 14:break;default:return W}}}function $(W,x=[],O=[]){if(N(W),x.length+O.length>0){let M=s.getToken();for(;M!==17;){if(x.indexOf(M)!==-1){J();break}else if(O.indexOf(M)!==-1)break;M=J()}}}function Q(W){const x=s.getTokenValue();return W?_(x):l(x),J(),!0}function H(){switch(s.getToken()){case 11:{let W=0;try{W=JSON.parse(s.getTokenValue()),typeof W!="number"&&($(2),W=0)}catch{$(2)}_(W);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return J(),!0}function B(){return s.getToken()!==10?($(3,[],[2,5]),!1):(Q(!1),s.getToken()===6?(F(":"),J(),ae()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function Y(){o(),J();let W=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(W||$(4,[],[]),F(","),J(),s.getToken()===2&&V)break}else W&&$(6,[],[]);B()||$(4,[],[2,5]),W=!0}return f(),s.getToken()!==2?$(7,[2],[]):J(),!0}function ie(){P(),J();let W=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(W||$(4,[],[]),F(","),J(),s.getToken()===4&&V)break}else W&&$(6,[],[]);ae()||$(4,[],[4,5]),W=!0}return U(),s.getToken()!==4?$(8,[4],[]):J(),!0}function ae(){switch(s.getToken()){case 3:return ie();case 1:return Y();case 10:return Q(!0);default:return H()}}return J(),s.getToken()===17?t.allowEmptyContent?!0:($(4,[],[]),!1):ae()?(s.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=u;function g(r,n){const t=A(r),s=[];let a,c=0,o;do switch(o=t.getPosition(),a=t.scan(),a){case 12:case 13:case 17:c!==o&&s.push(r.substring(c,o)),n!==void 0&&s.push(t.getTokenValue().replace(/[^\r\n]/g,n)),c=t.getPosition();break}while(a!==17);return s.join("")}e.stripComments=g;function h(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=h}),define(ne[53],re([0,1,35]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(R,I,E){let v,y,d,S,w;if(I){for(S=I.offset,w=S+I.length,d=S;d>0&&!C(R,d-1);)d--;let o=w;for(;o<R.length&&!C(R,o);)o++;y=R.substring(d,o),v=A(y,E)}else y=R,v=0,d=0,S=0,w=R.length;const p=b(E,R);let m=!1,u=0,g;E.insertSpaces?g=L(" ",E.tabSize||4):g="	";const h=(0,D.createScanner)(y,!1);let r=!1;function n(){return p+L(g,v+u)}function t(){let o=h.scan();for(m=!1;o===15||o===14;)m=m||o===14,o=h.scan();return r=o===16||h.getTokenError()!==0,o}const s=[];function a(o,l,f){!r&&l<w&&f>S&&R.substring(l,f)!==o&&s.push({offset:l,length:f-l,content:o})}let c=t();if(c!==17){const o=h.getTokenOffset()+d,l=L(g,v);a(l,d,o)}for(;c!==17;){let o=h.getTokenOffset()+h.getTokenLength()+d,l=t(),f="";for(;!m&&(l===12||l===13);){const U=h.getTokenOffset()+d;a(" ",o,U),o=h.getTokenOffset()+h.getTokenLength()+d,f=l===12?n():"",l=t()}if(l===2)c!==1&&(u--,f=n());else if(l===4)c!==3&&(u--,f=n());else{switch(c){case 3:case 1:u++,f=n();break;case 5:case 12:f=n();break;case 13:m?f=n():f=" ";break;case 6:f=" ";break;case 10:if(l===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?f=" ":l!==5&&l!==17&&(r=!0);break;case 16:r=!0;break}m&&(l===12||l===13)&&(f=n())}const P=h.getTokenOffset()+d;a(f,o,P),c=l}return s}e.format=i;function k(R,I){const E=JSON.stringify(R,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?E.replace(/\r\n|\r|\n/g,I.eol):E}e.toFormattedString=k;function L(R,I){let E="";for(let v=0;v<I;v++)E+=R;return E}function A(R,I){let E=0,v=0;const y=I.tabSize||4;for(;E<R.length;){const d=R.charAt(E);if(d===" ")v++;else if(d==="	")v+=y;else break;E++}return Math.floor(v/y)}function b(R,I){for(let E=0;E<I.length;E++){const v=I.charAt(E);if(v==="\r")return E+1<I.length&&I.charAt(E+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return R&&R.eol||`
`}e.getEOL=b;function C(R,I){return`\r
`.indexOf(R.charAt(I))!==-1}e.isEOL=C}),define(ne[75],re([0,1,35,53]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(R,I,E){return L(R,I,void 0,E)}e.removeProperty=k;function L(R,I,E,v,y){const d=I.slice(),S=[],w=(0,D.parseTree)(R,S);let p,m;for(;d.length>0&&(m=d.pop(),p=(0,D.findNodeAtLocation)(w,d),p===void 0&&E!==void 0);)typeof m=="string"?E={[m]:E}:E=[E];if(p)if(p.type==="object"&&typeof m=="string"&&Array.isArray(p.children)){const u=(0,D.findNodeAtLocation)(p,[m]);if(u!==void 0)if(E===void 0){if(!u.parent)throw new Error("Malformed AST");const g=p.children.indexOf(u.parent);let h,r=u.parent.offset+u.parent.length;if(g>0){const n=p.children[g-1];h=n.offset+n.length}else h=p.offset+1,p.children.length>1&&(r=p.children[1].offset);return A(R,{offset:h,length:r-h,content:""},v)}else return A(R,{offset:u.offset,length:u.length,content:JSON.stringify(E)},v);else{if(E===void 0)return[];const g=`${JSON.stringify(m)}: ${JSON.stringify(E)}`,h=y?y(p.children.map(n=>n.children[0].value)):p.children.length;let r;if(h>0){const n=p.children[h-1];r={offset:n.offset+n.length,length:0,content:","+g}}else p.children.length===0?r={offset:p.offset+1,length:0,content:g}:r={offset:p.offset+1,length:0,content:g+","};return A(R,r,v)}}else if(p.type==="array"&&typeof m=="number"&&Array.isArray(p.children))if(E!==void 0){const u=`${JSON.stringify(E)}`;let g;if(p.children.length===0||m===0)g={offset:p.offset+1,length:0,content:p.children.length===0?u:u+","};else{const h=m===-1||m>p.children.length?p.children.length:m,r=p.children[h-1];g={offset:r.offset+r.length,length:0,content:","+u}}return A(R,g,v)}else{const u=m,g=p.children[u];let h;if(p.children.length===1)h={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===u){const r=p.children[u-1],n=r.offset+r.length,t=p.offset+p.length;h={offset:n,length:t-2-n,content:""}}else h={offset:g.offset,length:p.children[u+1].offset-g.offset,content:""};return A(R,h,v)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${p.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(R,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(E)},v)}}e.setProperty=L;function A(R,I,E){let v=b(R,I),y=I.offset,d=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;y>0&&!(0,i.isEOL)(v,y-1);)y--;for(;d<v.length&&!(0,i.isEOL)(v,d);)d++}const S=(0,i.format)(v,{offset:y,length:d-y},E);for(let p=S.length-1;p>=0;p--){const m=S[p];v=b(v,m),y=Math.min(y,m.offset),d=Math.max(d,m.offset+m.length),d+=m.content.length-m.length}const w=R.length-(v.length-d)-y;return[{offset:y,length:w,content:v.substring(y,d)}]}e.withFormatting=A;function b(R,I){return R.substring(0,I.offset)+I.content+R.substring(I.offset+I.length)}e.applyEdit=b;function C(R,I){const E=I.slice(0).sort((y,d)=>{const S=y.offset-d.offset;return S===0?y.length-d.length:S});let v=R.length;for(let y=E.length-1;y>=0;y--){const d=E[y];if(d.offset+d.length<=v)R=b(R,d);else throw new Error("Overlapping edit");v=d.offset}return R}e.applyEdits=C}),define(ne[111],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new D(()=>k(this.getValue()))}}e.Lazy=D}),define(ne[2],re([0,1,74,52]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let L=null;function A(a){L=a}if(e.setDisposableTracker=A,k){const a="__is_disposable_tracked__";A(new class{trackDisposable(c){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[a]||console.log(o)},3e3)}setParent(c,o){if(c&&c!==m.None)try{c[a]=!0}catch{}}markAsDisposed(c){if(c&&c!==m.None)try{c[a]=!0}catch{}}markAsSingleton(c){}})}function b(a){return L?.trackDisposable(a),a}function C(a){L?.markAsDisposed(a)}function R(a,c){L?.setParent(a,c)}function I(a,c){if(!!L)for(const o of a)L.setParent(o,c)}function E(a){return L?.markAsSingleton(a),a}e.markAsSingleton=E;class v extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=v;function y(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=y;function d(a){if(i.Iterable.is(a)){const c=[];for(const o of a)if(o)try{o.dispose()}catch(l){c.push(l)}if(c.length===1)throw c[0];if(c.length>1)throw new v(c);return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=d;function S(...a){const c=w(()=>d(a));return I(a,c),c}e.combinedDisposable=S;function w(a){const c=b({dispose:(0,D.once)(()=>{C(c),a()})});return c}e.toDisposable=w;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return R(c,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new p,b(this),R(this._store,this)}dispose(){C(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&R(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&R(c,null),c}}e.MutableDisposable=u;class g{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=g;class h{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(c){let o=c;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,C(this))},this}}e.SafeDisposable=h;class r{constructor(){this.references=new Map}acquire(c,...o){let l=this.references.get(c);l||(l={counter:0,object:this.createReferencedObject(c,...o)},this.references.set(c,l));const{object:f}=l,P=(0,D.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(c,l.object),this.references.delete(c))});return l.counter++,{object:f,dispose:P}}}e.ReferenceCollection=r;class n{constructor(c){this.referenceCollection=c}async acquire(c,...o){const l=this.referenceCollection.acquire(c,...o);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(f){throw l.dispose(),f}}}e.AsyncReferenceCollection=n;class t{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=t;function s(a){const c=new p;try{a(c)}finally{c.dispose()}}e.disposeOnReturn=s}),define(ne[112],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(L){this.element=L,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class i{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let L=this._first;for(;L!==D.Undefined;){const A=L.next;L.prev=D.Undefined,L.next=D.Undefined,L=A}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,A){const b=new D(L);if(this._first===D.Undefined)this._first=b,this._last=b;else if(A){const R=this._last;this._last=b,b.prev=R,R.next=b}else{const R=this._first;this._first=b,b.next=R,R.prev=b}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(b))}}shift(){if(this._first!==D.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==D.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==D.Undefined&&L.next!==D.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===D.Undefined&&L.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):L.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):L.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==D.Undefined;)yield L.element,L=L.next}}e.LinkedList=i}),function(){function X(k){const L=[];typeof k=="number"&&L.push("code/timeOrigin",k);function A(C){L.push(C,Date.now())}function b(){const C=[];for(let R=0;R<L.length;R+=2)C.push({name:L[R],startTime:L[R+1]});return C}return{mark:A,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(k+A.startTime)});return L}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function D(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=D(i))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var i in D)(typeof exports=="object"?exports:X)[i]=D[i]}}(typeof self!="undefined"?self:this,function(){return function(X){var e={};function D(i){if(e[i])return e[i].exports;var k=e[i]={i,l:!1,exports:{}};return X[i].call(k.exports,k,k.exports,D),k.l=!0,k.exports}return D.m=X,D.c=e,D.d=function(i,k,L){D.o(i,k)||Object.defineProperty(i,k,{enumerable:!0,get:L})},D.r=function(i){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},D.t=function(i,k){if(1&k&&(i=D(i)),8&k||4&k&&typeof i=="object"&&i&&i.__esModule)return i;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:i}),2&k&&typeof i!="string")for(var A in i)D.d(L,A,function(b){return i[b]}.bind(null,A));return L},D.n=function(i){var k=i&&i.__esModule?function(){return i.default}:function(){return i};return D.d(k,"a",k),k},D.o=function(i,k){return Object.prototype.hasOwnProperty.call(i,k)},D.p="",D(D.s=0)}([function(X,e,D){(function(i){var k;e=X.exports=O,k=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],C=e.src=[],R=0,I=R++;C[I]="0|[1-9]\\d*";var E=R++;C[E]="[0-9]+";var v=R++;C[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=R++;C[y]="("+C[I]+")\\.("+C[I]+")\\.("+C[I]+")";var d=R++;C[d]="("+C[E]+")\\.("+C[E]+")\\.("+C[E]+")";var S=R++;C[S]="(?:"+C[I]+"|"+C[v]+")";var w=R++;C[w]="(?:"+C[E]+"|"+C[v]+")";var p=R++;C[p]="(?:-("+C[S]+"(?:\\."+C[S]+")*))";var m=R++;C[m]="(?:-?("+C[w]+"(?:\\."+C[w]+")*))";var u=R++;C[u]="[0-9A-Za-z-]+";var g=R++;C[g]="(?:\\+("+C[u]+"(?:\\."+C[u]+")*))";var h=R++,r="v?"+C[y]+C[p]+"?"+C[g]+"?";C[h]="^"+r+"$";var n="[v=\\s]*"+C[d]+C[m]+"?"+C[g]+"?",t=R++;C[t]="^"+n+"$";var s=R++;C[s]="((?:<|>)?=?)";var a=R++;C[a]=C[E]+"|x|X|\\*";var c=R++;C[c]=C[I]+"|x|X|\\*";var o=R++;C[o]="[v=\\s]*("+C[c]+")(?:\\.("+C[c]+")(?:\\.("+C[c]+")(?:"+C[p]+")?"+C[g]+"?)?)?";var l=R++;C[l]="[v=\\s]*("+C[a]+")(?:\\.("+C[a]+")(?:\\.("+C[a]+")(?:"+C[m]+")?"+C[g]+"?)?)?";var f=R++;C[f]="^"+C[s]+"\\s*"+C[o]+"$";var P=R++;C[P]="^"+C[s]+"\\s*"+C[l]+"$";var U=R++;C[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=R++;C[_]="(?:~>?)";var F=R++;C[F]="(\\s*)"+C[_]+"\\s+",b[F]=new RegExp(C[F],"g");var T=R++;C[T]="^"+C[_]+C[o]+"$";var N=R++;C[N]="^"+C[_]+C[l]+"$";var z=R++;C[z]="(?:\\^)";var V=R++;C[V]="(\\s*)"+C[z]+"\\s+",b[V]=new RegExp(C[V],"g");var J=R++;C[J]="^"+C[z]+C[o]+"$";var $=R++;C[$]="^"+C[z]+C[l]+"$";var Q=R++;C[Q]="^"+C[s]+"\\s*("+n+")$|^$";var H=R++;C[H]="^"+C[s]+"\\s*("+r+")$|^$";var B=R++;C[B]="(\\s*)"+C[s]+"\\s*("+n+"|"+C[o]+")",b[B]=new RegExp(C[B],"g");var Y=R++;C[Y]="^\\s*("+C[o]+")\\s+-\\s+("+C[o]+")\\s*$";var ie=R++;C[ie]="^\\s*("+C[l]+")\\s+-\\s+("+C[l]+")\\s*$";var ae=R++;C[ae]="(<|>)?=?\\s*\\*";for(var W=0;W<35;W++)k(W,C[W]),b[W]||(b[W]=new RegExp(C[W]));function x(oe,ue){if(oe instanceof O)return oe;if(typeof oe!="string"||oe.length>L||!(ue?b[t]:b[h]).test(oe))return null;try{return new O(oe,ue)}catch{return null}}function O(oe,ue){if(oe instanceof O){if(oe.loose===ue)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof O))return new O(oe,ue);k("SemVer",oe,ue),this.loose=ue;var de=oe.trim().match(ue?b[t]:b[h]);if(!de)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Ie=+Ee;if(Ie>=0&&Ie<A)return Ie}return Ee}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=x,e.valid=function(oe,ue){var de=x(oe,ue);return de?de.version:null},e.clean=function(oe,ue){var de=x(oe.trim().replace(/^[=v]+/,""),ue);return de?de.version:null},e.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(oe){return k("SemVer.compare",this.version,this.loose,oe),oe instanceof O||(oe=new O(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},O.prototype.compareMain=function(oe){return oe instanceof O||(oe=new O(oe,this.loose)),q(this.major,oe.major)||q(this.minor,oe.minor)||q(this.patch,oe.patch)},O.prototype.comparePre=function(oe){if(oe instanceof O||(oe=new O(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var ue=0;do{var de=this.prerelease[ue],Ee=oe.prerelease[ue];if(k("prerelease compare",ue,de,Ee),de===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(de===void 0)return-1;if(de!==Ee)return q(de,Ee)}while(++ue)},O.prototype.inc=function(oe,ue){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,ue,de,Ee){typeof de=="string"&&(Ee=de,de=void 0);try{return new O(oe,de).inc(ue,Ee).version}catch{return null}},e.diff=function(oe,ue){if(te(oe,ue))return null;var de=x(oe),Ee=x(ue);if(de.prerelease.length||Ee.prerelease.length){for(var Ie in de)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&de[Ie]!==Ee[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in de)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&de[Ie]!==Ee[Ie])return Ie},e.compareIdentifiers=q;var M=/^[0-9]+$/;function q(oe,ue){var de=M.test(oe),Ee=M.test(ue);return de&&Ee&&(oe=+oe,ue=+ue),de&&!Ee?-1:Ee&&!de?1:oe<ue?-1:oe>ue?1:0}function j(oe,ue,de){return new O(oe,de).compare(new O(ue,de))}function Z(oe,ue,de){return j(oe,ue,de)>0}function G(oe,ue,de){return j(oe,ue,de)<0}function te(oe,ue,de){return j(oe,ue,de)===0}function se(oe,ue,de){return j(oe,ue,de)!==0}function ce(oe,ue,de){return j(oe,ue,de)>=0}function he(oe,ue,de){return j(oe,ue,de)<=0}function ve(oe,ue,de,Ee){var Ie;switch(ue){case"===":typeof oe=="object"&&(oe=oe.version),typeof de=="object"&&(de=de.version),Ie=oe===de;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof de=="object"&&(de=de.version),Ie=oe!==de;break;case"":case"=":case"==":Ie=te(oe,de,Ee);break;case"!=":Ie=se(oe,de,Ee);break;case">":Ie=Z(oe,de,Ee);break;case">=":Ie=ce(oe,de,Ee);break;case"<":Ie=G(oe,de,Ee);break;case"<=":Ie=he(oe,de,Ee);break;default:throw new TypeError("Invalid operator: "+ue)}return Ie}function pe(oe,ue){if(oe instanceof pe){if(oe.loose===ue)return oe;oe=oe.value}if(!(this instanceof pe))return new pe(oe,ue);k("comparator",oe,ue),this.loose=ue,this.parse(oe),this.semver===Ce?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(oe,ue){return q(ue,oe)},e.major=function(oe,ue){return new O(oe,ue).major},e.minor=function(oe,ue){return new O(oe,ue).minor},e.patch=function(oe,ue){return new O(oe,ue).patch},e.compare=j,e.compareLoose=function(oe,ue){return j(oe,ue,!0)},e.rcompare=function(oe,ue,de){return j(ue,oe,de)},e.sort=function(oe,ue){return oe.sort(function(de,Ee){return e.compare(de,Ee,ue)})},e.rsort=function(oe,ue){return oe.sort(function(de,Ee){return e.rcompare(de,Ee,ue)})},e.gt=Z,e.lt=G,e.eq=te,e.neq=se,e.gte=ce,e.lte=he,e.cmp=ve,e.Comparator=pe;var Ce={};function be(oe,ue){if(oe instanceof be)return oe.loose===ue?oe:new be(oe.raw,ue);if(oe instanceof pe)return new be(oe.value,ue);if(!(this instanceof be))return new be(oe,ue);if(this.loose=ue,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function Pe(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function Me(oe,ue,de,Ee,Ie,Ue,De,$e,Ae,Te,Ne,ee,le){return((ue=Pe(de)?"":Pe(Ee)?">="+de+".0.0":Pe(Ie)?">="+de+"."+Ee+".0":">="+ue)+" "+($e=Pe(Ae)?"":Pe(Te)?"<"+(+Ae+1)+".0.0":Pe(Ne)?"<"+Ae+"."+(+Te+1)+".0":ee?"<="+Ae+"."+Te+"."+Ne+"-"+ee:"<="+$e)).trim()}function Ye(oe,ue){for(var de=0;de<oe.length;de++)if(!oe[de].test(ue))return!1;if(ue.prerelease.length){for(de=0;de<oe.length;de++)if(k(oe[de].semver),oe[de].semver!==Ce&&oe[de].semver.prerelease.length>0){var Ee=oe[de].semver;if(Ee.major===ue.major&&Ee.minor===ue.minor&&Ee.patch===ue.patch)return!0}return!1}return!0}function He(oe,ue,de){try{ue=new be(ue,de)}catch{return!1}return ue.test(oe)}function We(oe,ue,de,Ee){var Ie,Ue,De,$e,Ae;switch(oe=new O(oe,Ee),ue=new be(ue,Ee),de){case">":Ie=Z,Ue=he,De=G,$e=">",Ae=">=";break;case"<":Ie=G,Ue=ce,De=Z,$e="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(He(oe,ue,Ee))return!1;for(var Te=0;Te<ue.set.length;++Te){var Ne=ue.set[Te],ee=null,le=null;if(Ne.forEach(function(fe){fe.semver===Ce&&(fe=new pe(">=0.0.0")),ee=ee||fe,le=le||fe,Ie(fe.semver,ee.semver,Ee)?ee=fe:De(fe.semver,le.semver,Ee)&&(le=fe)}),ee.operator===$e||ee.operator===Ae||(!le.operator||le.operator===$e)&&Ue(oe,le.semver)||le.operator===Ae&&De(oe,le.semver))return!1}return!0}pe.prototype.parse=function(oe){var ue=this.loose?b[Q]:b[H],de=oe.match(ue);if(!de)throw new TypeError("Invalid comparator: "+oe);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new O(de[2],this.loose):this.semver=Ce},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(oe){return k("Comparator.test",oe,this.loose),this.semver===Ce||(typeof oe=="string"&&(oe=new O(oe,this.loose)),ve(oe,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(oe,ue){if(!(oe instanceof pe))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new be(oe.value,ue),He(this.value,de,ue);if(oe.operator==="")return de=new be(this.value,ue),He(oe.semver,de,ue);var Ee=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),Ue=this.semver.version===oe.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),$e=ve(this.semver,"<",oe.semver,ue)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),Ae=ve(this.semver,">",oe.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return Ee||Ie||Ue&&De||$e||Ae},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(oe){var ue=this.loose;oe=oe.trim(),k("range",oe,ue);var de=ue?b[ie]:b[Y];oe=oe.replace(de,Me),k("hyphen replace",oe),oe=oe.replace(b[B],"$1$2$3"),k("comparator trim",oe,b[B]),oe=(oe=(oe=oe.replace(b[F],"$1~")).replace(b[V],"$1^")).split(/\s+/).join(" ");var Ee=ue?b[Q]:b[H],Ie=oe.split(" ").map(function(Ue){return function(De,$e){return k("comp",De),De=function(Ae,Te){return Ae.trim().split(/\s+/).map(function(Ne){return function(ee,le){k("caret",ee,le);var fe=le?b[$]:b[J];return ee.replace(fe,function(Se,me,we,Re,ke){var Le;return k("caret",ee,Se,me,we,Re,ke),Pe(me)?Le="":Pe(we)?Le=">="+me+".0.0 <"+(+me+1)+".0.0":Pe(Re)?Le=me==="0"?">="+me+"."+we+".0 <"+me+"."+(+we+1)+".0":">="+me+"."+we+".0 <"+(+me+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=me==="0"?we==="0"?">="+me+"."+we+"."+Re+ke+" <"+me+"."+we+"."+(+Re+1):">="+me+"."+we+"."+Re+ke+" <"+me+"."+(+we+1)+".0":">="+me+"."+we+"."+Re+ke+" <"+(+me+1)+".0.0"):(k("no pr"),Le=me==="0"?we==="0"?">="+me+"."+we+"."+Re+" <"+me+"."+we+"."+(+Re+1):">="+me+"."+we+"."+Re+" <"+me+"."+(+we+1)+".0":">="+me+"."+we+"."+Re+" <"+(+me+1)+".0.0"),k("caret return",Le),Le})}(Ne,Te)}).join(" ")}(De,$e),k("caret",De),De=function(Ae,Te){return Ae.trim().split(/\s+/).map(function(Ne){return function(ee,le){var fe=le?b[N]:b[T];return ee.replace(fe,function(Se,me,we,Re,ke){var Le;return k("tilde",ee,Se,me,we,Re,ke),Pe(me)?Le="":Pe(we)?Le=">="+me+".0.0 <"+(+me+1)+".0.0":Pe(Re)?Le=">="+me+"."+we+".0 <"+me+"."+(+we+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=">="+me+"."+we+"."+Re+ke+" <"+me+"."+(+we+1)+".0"):Le=">="+me+"."+we+"."+Re+" <"+me+"."+(+we+1)+".0",k("tilde return",Le),Le})}(Ne,Te)}).join(" ")}(De,$e),k("tildes",De),De=function(Ae,Te){return k("replaceXRanges",Ae,Te),Ae.split(/\s+/).map(function(Ne){return function(ee,le){ee=ee.trim();var fe=le?b[P]:b[f];return ee.replace(fe,function(Se,me,we,Re,ke,Le){k("xRange",ee,Se,me,we,Re,ke,Le);var _e=Pe(we),Fe=_e||Pe(Re),ze=Fe||Pe(ke);return me==="="&&ze&&(me=""),_e?Se=me===">"||me==="<"?"<0.0.0":"*":me&&ze?(Fe&&(Re=0),ze&&(ke=0),me===">"?(me=">=",Fe?(we=+we+1,Re=0,ke=0):ze&&(Re=+Re+1,ke=0)):me==="<="&&(me="<",Fe?we=+we+1:Re=+Re+1),Se=me+we+"."+Re+"."+ke):Fe?Se=">="+we+".0.0 <"+(+we+1)+".0.0":ze&&(Se=">="+we+"."+Re+".0 <"+we+"."+(+Re+1)+".0"),k("xRange return",Se),Se})}(Ne,Te)}).join(" ")}(De,$e),k("xrange",De),De=function(Ae,Te){return k("replaceStars",Ae,Te),Ae.trim().replace(b[ae],"")}(De,$e),k("stars",De),De}(Ue,ue)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Ue){return!!Ue.match(Ee)})),Ie=Ie.map(function(Ue){return new pe(Ue,ue)})},be.prototype.intersects=function(oe,ue){if(!(oe instanceof be))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Ee){return oe.set.some(function(Ie){return Ie.every(function(Ue){return Ee.intersects(Ue,ue)})})})})},e.toComparators=function(oe,ue){return new be(oe,ue).set.map(function(de){return de.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},be.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new O(oe,this.loose));for(var ue=0;ue<this.set.length;ue++)if(Ye(this.set[ue],oe))return!0;return!1},e.satisfies=He,e.maxSatisfying=function(oe,ue,de){var Ee=null,Ie=null;try{var Ue=new be(ue,de)}catch{return null}return oe.forEach(function(De){Ue.test(De)&&(Ee&&Ie.compare(De)!==-1||(Ie=new O(Ee=De,de)))}),Ee},e.minSatisfying=function(oe,ue,de){var Ee=null,Ie=null;try{var Ue=new be(ue,de)}catch{return null}return oe.forEach(function(De){Ue.test(De)&&(Ee&&Ie.compare(De)!==1||(Ie=new O(Ee=De,de)))}),Ee},e.validRange=function(oe,ue){try{return new be(oe,ue).range||"*"}catch{return null}},e.ltr=function(oe,ue,de){return We(oe,ue,"<",de)},e.gtr=function(oe,ue,de){return We(oe,ue,">",de)},e.outside=We,e.prerelease=function(oe,ue){var de=x(oe,ue);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(oe,ue,de){return oe=new be(oe,de),ue=new be(ue,de),oe.intersects(ue)},e.coerce=function(oe){if(oe instanceof O)return oe;if(typeof oe!="string")return null;var ue=oe.match(b[U]);return ue==null?null:x((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,D(1))},function(X,e){var D,i,k=X.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function b(w){if(D===setTimeout)return setTimeout(w,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(w,0);try{return D(w,0)}catch{try{return D.call(null,w,0)}catch{return D.call(this,w,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch{D=L}try{i=typeof clearTimeout=="function"?clearTimeout:A}catch{i=A}})();var C,R=[],I=!1,E=-1;function v(){I&&C&&(I=!1,C.length?R=C.concat(R):E=-1,R.length&&y())}function y(){if(!I){var w=b(v);I=!0;for(var p=R.length;p;){for(C=R,R=[];++E<p;)C&&C[E].run();E=-1,p=R.length}C=null,I=!1,function(m){if(i===clearTimeout)return clearTimeout(m);if((i===A||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(m);try{i(m)}catch{try{return i.call(null,m)}catch{return i.call(this,m)}}}(w)}}function d(w,p){this.fun=w,this.array=p}function S(){}k.nextTick=function(w){var p=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)p[m-1]=arguments[m];R.push(new d(w,p)),R.length!==1||I||b(y)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=S,k.addListener=S,k.once=S,k.off=S,k.removeListener=S,k.removeAllListeners=S,k.emit=S,k.prependListener=S,k.prependOnceListener=S,k.listeners=function(w){return[]},k.binding=function(w){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(w){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[113],re([0,1]),function(X,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(b,C,R){this.level=b,this.key=C,this.value=R,this.forward=[]}}const k=void 0;class L{constructor(b,C=2**16){this.comparator=b,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(C)|0),this._header=new i(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new i(this._maxLevel,k,k)}has(b){return Boolean(L._search(this,b,this.comparator))}get(b){return L._search(this,b,this.comparator)?.value}set(b,C){return L._insert(this,b,C,this.comparator)&&(this._size+=1),this}delete(b){const C=L._delete(this,b,this.comparator);return C&&(this._size-=1),C}forEach(b,C){let R=this._header.forward[0];for(;R;)b.call(C,R.value,R.key,this),R=R.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this._header.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this._header.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this._header.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",C=this._header.forward[0];for(;C;)b+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return b}static _search(b,C,R){let I=b._header;for(let E=b._level-1;E>=0;E--)for(;I.forward[E]&&R(I.forward[E].key,C)<0;)I=I.forward[E];if(I=I.forward[0],I&&R(I.key,C)===0)return I}static _insert(b,C,R,I){const E=[];let v=b._header;for(let y=b._level-1;y>=0;y--){for(;v.forward[y]&&I(v.forward[y].key,C)<0;)v=v.forward[y];E[y]=v}if(v=v.forward[0],v&&I(v.key,C)===0)return v.value=R,!1;{const y=L._randomLevel(b);if(y>b._level){for(let d=b._level;d<y;d++)E[d]=b._header;b._level=y}v=new i(y,C,R);for(let d=0;d<y;d++)v.forward[d]=E[d].forward[d],E[d].forward[d]=v;return!0}}static _randomLevel(b,C=.5){let R=1;for(;Math.random()<C&&R<b._maxLevel;)R+=1;return R}static _delete(b,C,R){const I=[];let E=b._header;for(let v=b._level-1;v>=0;v--){for(;E.forward[v]&&R(E.forward[v].key,C)<0;)E=E.forward[v];I[v]=E}if(E=E.forward[0],!E||R(E.key,C)!==0)return!1;for(let v=0;v<b._level&&I[v].forward[v]===E;v++)I[v].forward[v]=E.forward[v];for(;b._level>0&&b._header.forward[b._level-1]===k;)b._level-=1;return!0}}e.SkipList=L}),define(ne[41],re([0,1,9,2]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(g){const h=g;return h?typeof h.read=="function":!1}e.isReadable=k;function L(g){const h=g;return h?[h.on,h.pause,h.resume,h.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=L;function A(g){const h=g;return h?L(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=A;function b(g,h){return new C(g,h)}e.newWriteableStream=b;class C{constructor(h,r){this.reducer=h,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(r=>r(h))}emitError(h){this.listeners.error.length===0?(0,D.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(r=>r(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,r){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(h,r){if(this.state.destroyed)return;let n;switch(h){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const t=n.indexOf(r);t>=0&&n.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function R(g,h){const r=[];let n;for(;(n=g.read())!==null;)r.push(n);return h(r)}e.consumeReadable=R;function I(g,h,r){const n=[];let t;for(;(t=g.read())!==null&&n.length<r;)n.push(t);return t===null&&n.length>0?h(n):{read:()=>{if(n.length>0)return n.shift();if(typeof t!="undefined"){const s=t;return t=void 0,s}return g.read()}}}e.peekReadable=I;function E(g,h){return new Promise((r,n)=>{const t=[];v(g,{onData:s=>{h&&t.push(s)},onError:s=>{h?n(s):r(void 0)},onEnd:()=>{r(h?h(t):void 0)}})})}e.consumeStream=E;function v(g,h){let r=!1;return g.on("error",n=>{r||h.onError(n)}),g.on("end",()=>{r||h.onEnd()}),g.on("data",n=>{r||h.onData(n)}),(0,i.toDisposable)(()=>r=!0)}e.listenStream=v;function y(g,h){return new Promise((r,n)=>{const t=new i.DisposableStore,s=[],a=l=>{if(s.push(l),s.length>h)return t.dispose(),g.pause(),r({stream:g,buffer:s,ended:!1})},c=l=>n(l),o=()=>r({stream:g,buffer:s,ended:!0});t.add((0,i.toDisposable)(()=>g.removeListener("error",c))),g.on("error",c),t.add((0,i.toDisposable)(()=>g.removeListener("end",o))),g.on("end",o),t.add((0,i.toDisposable)(()=>g.removeListener("data",a))),g.on("data",a)})}e.peekStream=y;function d(g,h){const r=b(h);return r.end(g),r}e.toStream=d;function S(){const g=b(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=S;function w(g){let h=!1;return{read:()=>h?null:(h=!0,g)}}e.toReadable=w;function p(g,h,r){const n=b(r);return v(g,{onData:t=>n.write(h.data(t)),onError:t=>n.error(h.error?h.error(t):t),onEnd:()=>n.end()}),n}e.transform=p;function m(g,h,r){let n=!1;return{read:()=>{const t=h.read();return n?t:(n=!0,t!==null?r([g,t]):g)}}}e.prefixedReadable=m;function u(g,h,r){let n=!1;const t=b(r);return v(h,{onData:s=>n?t.write(s):(n=!0,t.write(r([g,s]))),onError:s=>t.error(s),onEnd:()=>{n||(n=!0,t.write(g)),t.end()}}),t}e.prefixedStream=u}),define(ne[16],re([0,1,41]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let k,L;class A{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return i?new A(Buffer.allocUnsafe(l)):new A(new Uint8Array(l))}static wrap(l){return i&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new A(l)}static fromString(l,f){return!(f?.dontUseNodeBuffer||!1)&&i?new A(Buffer.from(l)):(k||(k=new TextEncoder),new A(k.encode(l)))}static fromByteArray(l){const f=A.alloc(l.length);for(let P=0,U=l.length;P<U;P++)f.buffer[P]=l[P];return f}static concat(l,f){if(typeof f=="undefined"){f=0;for(let _=0,F=l.length;_<F;_++)f+=l[_].byteLength}const P=A.alloc(f);let U=0;for(let _=0,F=l.length;_<F;_++){const T=l[_];P.set(T,U),U+=T.byteLength}return P}clone(){const l=A.alloc(this.byteLength);return l.set(this),l}toString(){return i?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(l,f){return new A(this.buffer.subarray(l,f))}set(l,f){if(l instanceof A)this.buffer.set(l.buffer,f);else if(l instanceof Uint8Array)this.buffer.set(l,f);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),f);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return R(this.buffer,l)}writeUInt32BE(l,f){I(this.buffer,l,f)}readUInt32LE(l){return E(this.buffer,l)}writeUInt32LE(l,f){v(this.buffer,l,f)}readUInt8(l){return y(this.buffer,l)}writeUInt8(l,f){d(this.buffer,l,f)}}e.VSBuffer=A;function b(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0}e.readUInt16LE=b;function C(o,l,f){o[f+0]=l&255,l=l>>>8,o[f+1]=l&255}e.writeUInt16LE=C;function R(o,l){return o[l]*2**24+o[l+1]*2**16+o[l+2]*2**8+o[l+3]}e.readUInt32BE=R;function I(o,l,f){o[f+3]=l,l=l>>>8,o[f+2]=l,l=l>>>8,o[f+1]=l,l=l>>>8,o[f]=l}e.writeUInt32BE=I;function E(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0|o[l+2]<<16>>>0|o[l+3]<<24>>>0}e.readUInt32LE=E;function v(o,l,f){o[f+0]=l&255,l=l>>>8,o[f+1]=l&255,l=l>>>8,o[f+2]=l&255,l=l>>>8,o[f+3]=l&255}e.writeUInt32LE=v;function y(o,l){return o[l]}e.readUInt8=y;function d(o,l,f){o[f]=l}e.writeUInt8=d;function S(o){return D.consumeReadable(o,l=>A.concat(l))}e.readableToBuffer=S;function w(o){return D.toReadable(o)}e.bufferToReadable=w;function p(o){return D.consumeStream(o,l=>A.concat(l))}e.streamToBuffer=p;async function m(o){return o.ended?A.concat(o.buffer):A.concat([...o.buffer,await p(o.stream)])}e.bufferedStreamToBuffer=m;function u(o){return D.toStream(o,l=>A.concat(l))}e.bufferToStream=u;function g(o){return D.transform(o,{data:l=>typeof l=="string"?A.fromString(l):A.wrap(l)},l=>A.concat(l))}e.streamToBufferReadableStream=g;function h(o){return D.newWriteableStream(l=>A.concat(l),o)}e.newWriteableBufferStream=h;function r(o,l){return D.prefixedReadable(o,l,f=>A.concat(f))}e.prefixedBufferReadable=r;function n(o,l){return D.prefixedStream(o,l,f=>A.concat(f))}e.prefixedBufferStream=n;function t(o){let l=0,f=0,P=0;const U=new Uint8Array(Math.floor(o.length/4*3)),_=T=>{switch(f){case 3:U[P++]=l|T,f=0;break;case 2:U[P++]=l|T>>>2,l=T<<6,f=3;break;case 1:U[P++]=l|T>>>4,l=T<<4,f=2;break;default:l=T<<2,f=1}};for(let T=0;T<o.length;T++){const N=o.charCodeAt(T);if(N>=65&&N<=90)_(N-65);else if(N>=97&&N<=122)_(N-97+26);else if(N>=48&&N<=57)_(N-48+52);else if(N===43||N===45)_(62);else if(N===47||N===95)_(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${o[T]}`)}}const F=P;for(;f>0;)_(0);return A.wrap(U).slice(0,F)}e.decodeBase64=t;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:o},l=!0,f=!1){const P=f?a:s;let U="";const _=o.byteLength%3;let F=0;for(;F<o.byteLength-_;F+=3){const T=o[F+0],N=o[F+1],z=o[F+2];U+=P[T>>>2],U+=P[(T<<4|N>>>4)&63],U+=P[(N<<2|z>>>6)&63],U+=P[z&63]}if(_===1){const T=o[F+0];U+=P[T>>>2],U+=P[T<<4&63],l&&(U+="==")}else if(_===2){const T=o[F+0],N=o[F+1];U+=P[T>>>2],U+=P[(T<<4|N>>>4)&63],U+=P[N<<2&63],l&&(U+="=")}return U}e.encodeBase64=c}),define(ne[14],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(o){return Array.isArray(o)}e.isArray=D;function i(o){return typeof o=="string"}e.isString=i;function k(o){return Array.isArray(o)&&o.every(l=>i(l))}e.isStringArray=k;function L(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=L;function A(o){const l=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof l}e.isTypedArray=A;function b(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=b;function C(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=C;function R(o){return o===!0||o===!1}e.isBoolean=R;function I(o){return typeof o=="undefined"}e.isUndefined=I;function E(o){return!v(o)}e.isDefined=E;function v(o){return I(o)||o===null}e.isUndefinedOrNull=v;function y(o,l){if(!o)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=y;function d(o){if(v(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=d;function S(...o){const l=[];for(let f=0;f<o.length;f++){const P=o[f];if(v(P))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);l.push(P)}return l}e.assertAllDefined=S;const w=Object.prototype.hasOwnProperty;function p(o){if(!L(o))return!1;for(const l in o)if(w.call(o,l))return!1;return!0}e.isEmptyObject=p;function m(o){return typeof o=="function"}e.isFunction=m;function u(...o){return o.length>0&&o.every(m)}e.areFunctions=u;function g(o,l){const f=Math.min(o.length,l.length);for(let P=0;P<f;P++)h(o[P],l[P])}e.validateConstraints=g;function h(o,l){if(i(l)){if(typeof o!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(m(l)){try{if(o instanceof l)return}catch{}if(!v(o)&&o.constructor===l||l.length===1&&l.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function r(o){let l=[],f=Object.getPrototypeOf(o);for(;Object.prototype!==f;)l=l.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return l}e.getAllPropertyNames=r;function n(o){const l=[];for(const f of r(o))typeof o[f]=="function"&&l.push(f);return l}e.getAllMethodNames=n;function t(o,l){const f=U=>function(){const _=Array.prototype.slice.call(arguments,0);return l(U,_)},P={};for(const U of o)P[U]=f(U);return P}e.createProxyObject=t;function s(o){return o===null?void 0:o}e.withNullAsUndefined=s;function a(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=a;function c(o,l="Unreachable"){throw new Error(l)}e.assertNever=c}),define(ne[30],re([0,1,14]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const S=Array.isArray(d)?[]:{};return Object.keys(d).forEach(w=>{d[w]&&typeof d[w]=="object"?S[w]=i(d[w]):S[w]=d[w]}),S}e.deepClone=i;function k(d){if(!d||typeof d!="object")return d;const S=[d];for(;S.length>0;){const w=S.shift();Object.freeze(w);for(const p in w)if(L.call(w,p)){const m=w[p];typeof m=="object"&&!Object.isFrozen(m)&&!(0,D.isTypedArray)(m)&&S.push(m)}}return d}e.deepFreeze=k;const L=Object.prototype.hasOwnProperty;function A(d,S){return b(d,S,new Set)}e.cloneAndChange=A;function b(d,S,w){if((0,D.isUndefinedOrNull)(d))return d;const p=S(d);if(typeof p!="undefined")return p;if((0,D.isArray)(d)){const m=[];for(const u of d)m.push(b(u,S,w));return m}if((0,D.isObject)(d)){if(w.has(d))throw new Error("Cannot clone recursive data-structure");w.add(d);const m={};for(const u in d)L.call(d,u)&&(m[u]=b(d[u],S,w));return w.delete(d),m}return d}function C(d,S,w=!0){return(0,D.isObject)(d)?((0,D.isObject)(S)&&Object.keys(S).forEach(p=>{p in d?w&&((0,D.isObject)(d[p])&&(0,D.isObject)(S[p])?C(d[p],S[p],w):d[p]=S[p]):d[p]=S[p]}),d):S}e.mixin=C;function R(d,S){if(d===S)return!0;if(d==null||S===null||S===void 0||typeof d!=typeof S||typeof d!="object"||Array.isArray(d)!==Array.isArray(S))return!1;let w,p;if(Array.isArray(d)){if(d.length!==S.length)return!1;for(w=0;w<d.length;w++)if(!R(d[w],S[w]))return!1}else{const m=[];for(p in d)m.push(p);m.sort();const u=[];for(p in S)u.push(p);if(u.sort(),!R(m,u))return!1;for(w=0;w<m.length;w++)if(!R(d[m[w]],S[m[w]]))return!1}return!0}e.equals=R;function I(d){const S=new Set;return JSON.stringify(d,(w,p)=>{if((0,D.isObject)(p)||Array.isArray(p)){if(S.has(p))return"[Circular]";S.add(p)}return p})}e.safeStringify=I;function E(d,S){const w=Object.create(null);return!d||!S||Object.keys(S).forEach(m=>{const u=d[m],g=S[m];R(u,g)||(w[m]=g)}),w}e.distinct=E;function v(d,S){const w=S.toLowerCase(),p=Object.keys(d).find(m=>m.toLowerCase()===w);return p?d[p]:d[S]}e.getCaseInsensitive=v;function y(d,S){const w=Object.create(null);for(const[p,m]of Object.entries(d))S(p,m)&&(w[p]=m);return w}e.filter=y}),define(ne[31],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(k){return D.test(k)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(b){for(let C=0;C<b.length;C++)b[C]=Math.floor(Math.random()*256);return b};const L=new Uint8Array(16),A=[];for(let b=0;b<256;b++)A.push(b.toString(16).padStart(2,"0"));return function(){k(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let C=0,R="";return R+=A[L[C++]],R+=A[L[C++]],R+=A[L[C++]],R+=A[L[C++]],R+="-",R+=A[L[C++]],R+=A[L[C++]],R+="-",R+=A[L[C++]],R+=A[L[C++]],R+="-",R+=A[L[C++]],R+=A[L[C++]],R+="-",R+=A[L[C++]],R+=A[L[C++]],R+=A[L[C++]],R+=A[L[C++]],R+=A[L[C++]],R+=A[L[C++]],R}}()}),define(ne[114],re([0,1,269]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(L="utf8"){this.stringDecoder=new D.StringDecoder(L),this.remaining=null}write(L){const A=[],b=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(b.length<1)return A;let C=0,R,I=C;for(;I<b.length;)if(R=b.charCodeAt(I),R===13||R===10){if(A.push(b.substring(C,I)),I++,I<b.length){const E=R;R=b.charCodeAt(I),(E===13&&R===10||E===10&&R===13)&&I++}C=I}else I++;return this.remaining=C<b.length?b.substr(C):null,A}end(){return this.remaining}}e.LineDecoder=i}),define(ne[115],re([0,1,37]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(A){const b=A.replace(/\-/g,":").toLowerCase();return!i.has(b)}function L(){const A=(0,D.networkInterfaces)();for(const b in A){const C=A[b];if(C){for(const{mac:R}of C)if(k(R))return R}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(ne[116],re([0,1,76]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(b,C,R,I=1){let E=!1;return new Promise(v=>{const y=setTimeout(()=>{if(!E)return E=!0,v(0)},R);k(b,C,I,d=>{if(!E)return E=!0,clearTimeout(y),v(d)})})}e.findFreePort=i;function k(b,C,R,I){if(C===0)return I(0);const E=new D.Socket;E.once("connect",()=>(A(E),k(b+R,C-1,R,I))),E.once("data",()=>{}),E.once("error",v=>(A(E),v.code!=="ECONNREFUSED"?k(b+R,C-1,R,I):I(b))),E.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(b,C,R){let I=!1,E,v=1;const y=D.createServer({pauseOnConnect:!0});function d(S,w){I||(I=!0,y.removeAllListeners(),y.close(),E&&clearTimeout(E),w(S))}return new Promise(S=>{E=setTimeout(()=>{d(0,S)},R),y.on("listening",()=>{d(b,S)}),y.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&v<C?(b++,v++,y.listen(b,"127.0.0.1")):d(0,S)}),y.on("close",()=>{d(0,S)}),y.listen(b,"127.0.0.1")})}e.findFreePortFaster=L;function A(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(C){console.error(C)}}}),define(ne[117],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function i(L){return L instanceof k?!0:L instanceof Error&&L.name===D&&L.message===D}e.isOfflineError=i;class k extends Error{constructor(){super(D);this.name=this.message}}e.OfflineError=k}),define(ne[118],re([0,1,16,9,117]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(C,R){if(!navigator.onLine)throw new k.OfflineError;C.proxyAuthorization&&(C.headers={...C.headers||{},"Proxy-Authorization":C.proxyAuthorization});const I=new XMLHttpRequest;return new Promise((E,v)=>{I.open(C.type||"GET",C.url||"",!0,C.user,C.password),A(I,C),I.responseType="arraybuffer",I.onerror=y=>v(new Error(I.statusText&&"XHR failed: "+I.statusText||"XHR failed")),I.onload=y=>{E({res:{statusCode:I.status,headers:b(I)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(I.response)))})},I.ontimeout=y=>v(new Error(`XHR timeout: ${C.timeout}ms`)),C.timeout&&(I.timeout=C.timeout),I.send(C.data),R.onCancellationRequested(()=>{I.abort(),v((0,i.canceled)())})})}e.request=L;function A(C,R){if(R.headers){e:for(const I in R.headers){switch(I){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}C.setRequestHeader(I,R.headers[I])}}}function b(C){const R=Object.create(null);for(const I of C.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(I){const E=I.indexOf(":");R[I.substr(0,E).trim().toLowerCase()]=I.substr(E+1).trim()}return R}}),define(ne[119],re([10,11]),function(X,e){return X.create("vs/base/common/date",e)}),define(ne[61],re([0,1,119]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,k=i*60,L=k*24,A=L*7,b=L*30,C=L*365;function R(E,v,y){typeof E!="number"&&(E=E.getTime());const d=Math.round((new Date().getTime()-E)/1e3);if(d<-30)return(0,D.localize)(0,null,R(new Date().getTime()+d*1e3,!1));if(d<30)return(0,D.localize)(1,null);let S;return d<i?(S=d,v?S===1?y?(0,D.localize)(2,null,S):(0,D.localize)(3,null,S):y?(0,D.localize)(4,null,S):(0,D.localize)(5,null,S):S===1?y?(0,D.localize)(6,null,S):(0,D.localize)(7,null,S):y?(0,D.localize)(8,null,S):(0,D.localize)(9,null,S)):d<k?(S=Math.floor(d/i),v?S===1?y?(0,D.localize)(10,null,S):(0,D.localize)(11,null,S):y?(0,D.localize)(12,null,S):(0,D.localize)(13,null,S):S===1?y?(0,D.localize)(14,null,S):(0,D.localize)(15,null,S):y?(0,D.localize)(16,null,S):(0,D.localize)(17,null,S)):d<L?(S=Math.floor(d/k),v?S===1?y?(0,D.localize)(18,null,S):(0,D.localize)(19,null,S):y?(0,D.localize)(20,null,S):(0,D.localize)(21,null,S):S===1?y?(0,D.localize)(22,null,S):(0,D.localize)(23,null,S):y?(0,D.localize)(24,null,S):(0,D.localize)(25,null,S)):d<A?(S=Math.floor(d/L),v?S===1?(0,D.localize)(26,null,S):(0,D.localize)(27,null,S):S===1?(0,D.localize)(28,null,S):(0,D.localize)(29,null,S)):d<b?(S=Math.floor(d/A),v?S===1?y?(0,D.localize)(30,null,S):(0,D.localize)(31,null,S):y?(0,D.localize)(32,null,S):(0,D.localize)(33,null,S):S===1?y?(0,D.localize)(34,null,S):(0,D.localize)(35,null,S):y?(0,D.localize)(36,null,S):(0,D.localize)(37,null,S)):d<C?(S=Math.floor(d/b),v?S===1?y?(0,D.localize)(38,null,S):(0,D.localize)(39,null,S):y?(0,D.localize)(40,null,S):(0,D.localize)(41,null,S):S===1?y?(0,D.localize)(42,null,S):(0,D.localize)(43,null,S):y?(0,D.localize)(44,null,S):(0,D.localize)(45,null,S)):(S=Math.floor(d/C),v?S===1?y?(0,D.localize)(46,null,S):(0,D.localize)(47,null,S):y?(0,D.localize)(48,null,S):(0,D.localize)(49,null,S):S===1?y?(0,D.localize)(50,null,S):(0,D.localize)(51,null,S):y?(0,D.localize)(52,null,S):(0,D.localize)(53,null,S))}e.fromNow=R;function I(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(ne[120],re([10,11]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ne[38],re([0,1,18,14,120]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(E,v){return v&&(E.stack||E.stacktrace)?k.localize(0,null,b(E),A(E.stack)||A(E.stacktrace)):b(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function b(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?k.localize(1,null,E.message):E.message||k.localize(2,null)}function C(E=null,v=!1){if(!E)return k.localize(3,null);if(Array.isArray(E)){const y=D.coalesce(E),d=C(y[0],v);return y.length>1?k.localize(4,null,d,y.length):d}if(i.isString(E))return E;if(E.detail){const y=E.detail;if(y.error)return L(y.error,v);if(y.exception)return L(y.exception,v)}return E.stack?L(E,v):E.message?E.message:k.localize(5,null)}e.toErrorMessage=C;function R(E){const v=E;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=R;function I(E,v){let y;return typeof E=="string"?y=new Error(E):y=E,y.actions=v,y}e.createErrorWithActions=I}),define(ne[121],re([10,11]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(ne[122],re([0,1,121]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function i(k){switch(k){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=i}),define(ne[123],re([10,11]),function(X,e){return X.create("vs/base/common/platform",e)}),define(ne[4],re([0,1,123]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const i="en";let k=!1,L=!1,A=!1,b=!1,C=!1,R=!1,I=!1,E=!1,v=!1,y,d=i,S,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const m=typeof p?.versions?.electron=="string",u=m&&p?.type==="renderer";if(typeof navigator=="object"&&!u)w=navigator.userAgent,k=w.indexOf("Windows")>=0,L=w.indexOf("Macintosh")>=0,E=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=w.indexOf("Linux")>=0,R=!0,y=D.getConfiguredDefaultLocale(D.localize(0,null))||i,d=y;else if(typeof p=="object"){k=p.platform==="win32",L=p.platform==="darwin",A=p.platform==="linux",b=A&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,I=m,v=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=i,d=i;const o=p.env.VSCODE_NLS_CONFIG;if(o)try{const l=JSON.parse(o),f=l.availableLanguages["*"];y=l.locale,d=f||i,S=l._translationsConfigFile}catch{}C=!0}else console.error("Unable to resolve platform.");var g;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function h(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=h;let r=0;L?r=1:k?r=3:A&&(r=2),e.isWindows=k,e.isMacintosh=L,e.isLinux=A,e.isLinuxSnap=b,e.isNative=C,e.isElectron=I,e.isWeb=R,e.isWebWorker=R&&typeof e.globals.importScripts=="function",e.isIOS=E,e.isCI=v,e.platform=r,e.userAgent=w,e.language=d;var n;(function(o){function l(){return e.language}o.value=l;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=f;function P(){return e.language==="en"}o.isDefault=P})(n=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=S,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let P=0,U=o.length;P<U;P++){const _=o[P];if(_.id===f.data.vscodeScheduleAsyncWork){o.splice(P,1),_.callback();return}}});let l=0;return f=>{const P=++l;o.push({id:P,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:P},"*")}}return o=>setTimeout(o)})();var t;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||E?2:k?1:3;let s=!0,a=!1;function c(){if(!a){a=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,s=new Uint16Array(o.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[36],re([0,1,4]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const k=D.globals.vscode.process;i={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(ne[12],re([0,1,36]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,k=97,L=90,A=122,b=46,C=47,R=92,I=58,E=63;class v extends Error{constructor(g,h,r){let n;typeof h=="string"&&h.indexOf("not ")===0?(n="must not be",h=h.replace(/^not /,"")):n="must be";const t=g.indexOf(".")!==-1?"property":"argument";let s=`The "${g}" ${t} ${n} of type ${h}`;s+=`. Received type ${typeof r}`;super(s);this.code="ERR_INVALID_ARG_TYPE"}}function y(u,g){if(typeof u!="string")throw new v(g,"string",u)}function d(u){return u===C||u===R}function S(u){return u===C}function w(u){return u>=i&&u<=L||u>=k&&u<=A}function p(u,g,h,r){let n="",t=0,s=-1,a=0,c=0;for(let o=0;o<=u.length;++o){if(o<u.length)c=u.charCodeAt(o);else{if(r(c))break;c=C}if(r(c)){if(!(s===o-1||a===1))if(a===2){if(n.length<2||t!==2||n.charCodeAt(n.length-1)!==b||n.charCodeAt(n.length-2)!==b){if(n.length>2){const l=n.lastIndexOf(h);l===-1?(n="",t=0):(n=n.slice(0,l),t=n.length-1-n.lastIndexOf(h)),s=o,a=0;continue}else if(n.length!==0){n="",t=0,s=o,a=0;continue}}g&&(n+=n.length>0?`${h}..`:"..",t=2)}else n.length>0?n+=`${h}${u.slice(s+1,o)}`:n=u.slice(s+1,o),t=o-s-1;s=o,a=0}else c===b&&a!==-1?++a:a=-1}return n}function m(u,g){if(g===null||typeof g!="object")throw new v("pathObject","Object",g);const h=g.dir||g.root,r=g.base||`${g.name||""}${g.ext||""}`;return h?h===g.root?`${h}${r}`:`${h}${u}${r}`:r}e.win32={resolve(...u){let g="",h="",r=!1;for(let n=u.length-1;n>=-1;n--){let t;if(n>=0){if(t=u[n],y(t,"path"),t.length===0)continue}else g.length===0?t=D.cwd():(t=D.env[`=${g}`]||D.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==g.toLowerCase()&&t.charCodeAt(2)===R)&&(t=`${g}\\`));const s=t.length;let a=0,c="",o=!1;const l=t.charCodeAt(0);if(s===1)d(l)&&(a=1,o=!0);else if(d(l))if(o=!0,d(t.charCodeAt(1))){let f=2,P=f;for(;f<s&&!d(t.charCodeAt(f));)f++;if(f<s&&f!==P){const U=t.slice(P,f);for(P=f;f<s&&d(t.charCodeAt(f));)f++;if(f<s&&f!==P){for(P=f;f<s&&!d(t.charCodeAt(f));)f++;(f===s||f!==P)&&(c=`\\\\${U}\\${t.slice(P,f)}`,a=f)}}}else a=1;else w(l)&&t.charCodeAt(1)===I&&(c=t.slice(0,2),a=2,s>2&&d(t.charCodeAt(2))&&(o=!0,a=3));if(c.length>0)if(g.length>0){if(c.toLowerCase()!==g.toLowerCase())continue}else g=c;if(r){if(g.length>0)break}else if(h=`${t.slice(a)}\\${h}`,r=o,o&&g.length>0)break}return h=p(h,!r,"\\",d),r?`${g}\\${h}`:`${g}${h}`||"."},normalize(u){y(u,"path");const g=u.length;if(g===0)return".";let h=0,r,n=!1;const t=u.charCodeAt(0);if(g===1)return S(t)?"\\":u;if(d(t))if(n=!0,d(u.charCodeAt(1))){let a=2,c=a;for(;a<g&&!d(u.charCodeAt(a));)a++;if(a<g&&a!==c){const o=u.slice(c,a);for(c=a;a<g&&d(u.charCodeAt(a));)a++;if(a<g&&a!==c){for(c=a;a<g&&!d(u.charCodeAt(a));)a++;if(a===g)return`\\\\${o}\\${u.slice(c)}\\`;a!==c&&(r=`\\\\${o}\\${u.slice(c,a)}`,h=a)}}}else h=1;else w(t)&&u.charCodeAt(1)===I&&(r=u.slice(0,2),h=2,g>2&&d(u.charCodeAt(2))&&(n=!0,h=3));let s=h<g?p(u.slice(h),!n,"\\",d):"";return s.length===0&&!n&&(s="."),s.length>0&&d(u.charCodeAt(g-1))&&(s+="\\"),r===void 0?n?`\\${s}`:s:n?`${r}\\${s}`:`${r}${s}`},isAbsolute(u){y(u,"path");const g=u.length;if(g===0)return!1;const h=u.charCodeAt(0);return d(h)||g>2&&w(h)&&u.charCodeAt(1)===I&&d(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let g,h;for(let t=0;t<u.length;++t){const s=u[t];y(s,"path"),s.length>0&&(g===void 0?g=h=s:g+=`\\${s}`)}if(g===void 0)return".";let r=!0,n=0;if(typeof h=="string"&&d(h.charCodeAt(0))){++n;const t=h.length;t>1&&d(h.charCodeAt(1))&&(++n,t>2&&(d(h.charCodeAt(2))?++n:r=!1))}if(r){for(;n<g.length&&d(g.charCodeAt(n));)n++;n>=2&&(g=`\\${g.slice(n)}`)}return e.win32.normalize(g)},relative(u,g){if(y(u,"from"),y(g,"to"),u===g)return"";const h=e.win32.resolve(u),r=e.win32.resolve(g);if(h===r||(u=h.toLowerCase(),g=r.toLowerCase(),u===g))return"";let n=0;for(;n<u.length&&u.charCodeAt(n)===R;)n++;let t=u.length;for(;t-1>n&&u.charCodeAt(t-1)===R;)t--;const s=t-n;let a=0;for(;a<g.length&&g.charCodeAt(a)===R;)a++;let c=g.length;for(;c-1>a&&g.charCodeAt(c-1)===R;)c--;const o=c-a,l=s<o?s:o;let f=-1,P=0;for(;P<l;P++){const _=u.charCodeAt(n+P);if(_!==g.charCodeAt(a+P))break;_===R&&(f=P)}if(P!==l){if(f===-1)return r}else{if(o>l){if(g.charCodeAt(a+P)===R)return r.slice(a+P+1);if(P===2)return r.slice(a+P)}s>l&&(u.charCodeAt(n+P)===R?f=P:P===2&&(f=3)),f===-1&&(f=0)}let U="";for(P=n+f+1;P<=t;++P)(P===t||u.charCodeAt(P)===R)&&(U+=U.length===0?"..":"\\..");return a+=f,U.length>0?`${U}${r.slice(a,c)}`:(r.charCodeAt(a)===R&&++a,r.slice(a,c))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const g=e.win32.resolve(u);if(g.length<=2)return u;if(g.charCodeAt(0)===R){if(g.charCodeAt(1)===R){const h=g.charCodeAt(2);if(h!==E&&h!==b)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(w(g.charCodeAt(0))&&g.charCodeAt(1)===I&&g.charCodeAt(2)===R)return`\\\\?\\${g}`;return u},dirname(u){y(u,"path");const g=u.length;if(g===0)return".";let h=-1,r=0;const n=u.charCodeAt(0);if(g===1)return d(n)?u:".";if(d(n)){if(h=r=1,d(u.charCodeAt(1))){let a=2,c=a;for(;a<g&&!d(u.charCodeAt(a));)a++;if(a<g&&a!==c){for(c=a;a<g&&d(u.charCodeAt(a));)a++;if(a<g&&a!==c){for(c=a;a<g&&!d(u.charCodeAt(a));)a++;if(a===g)return u;a!==c&&(h=r=a+1)}}}}else w(n)&&u.charCodeAt(1)===I&&(h=g>2&&d(u.charCodeAt(2))?3:2,r=h);let t=-1,s=!0;for(let a=g-1;a>=r;--a)if(d(u.charCodeAt(a))){if(!s){t=a;break}}else s=!1;if(t===-1){if(h===-1)return".";t=h}return u.slice(0,t)},basename(u,g){g!==void 0&&y(g,"ext"),y(u,"path");let h=0,r=-1,n=!0,t;if(u.length>=2&&w(u.charCodeAt(0))&&u.charCodeAt(1)===I&&(h=2),g!==void 0&&g.length>0&&g.length<=u.length){if(g===u)return"";let s=g.length-1,a=-1;for(t=u.length-1;t>=h;--t){const c=u.charCodeAt(t);if(d(c)){if(!n){h=t+1;break}}else a===-1&&(n=!1,a=t+1),s>=0&&(c===g.charCodeAt(s)?--s==-1&&(r=t):(s=-1,r=a))}return h===r?r=a:r===-1&&(r=u.length),u.slice(h,r)}for(t=u.length-1;t>=h;--t)if(d(u.charCodeAt(t))){if(!n){h=t+1;break}}else r===-1&&(n=!1,r=t+1);return r===-1?"":u.slice(h,r)},extname(u){y(u,"path");let g=0,h=-1,r=0,n=-1,t=!0,s=0;u.length>=2&&u.charCodeAt(1)===I&&w(u.charCodeAt(0))&&(g=r=2);for(let a=u.length-1;a>=g;--a){const c=u.charCodeAt(a);if(d(c)){if(!t){r=a+1;break}continue}n===-1&&(t=!1,n=a+1),c===b?h===-1?h=a:s!==1&&(s=1):h!==-1&&(s=-1)}return h===-1||n===-1||s===0||s===1&&h===n-1&&h===r+1?"":u.slice(h,n)},format:m.bind(null,"\\"),parse(u){y(u,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return g;const h=u.length;let r=0,n=u.charCodeAt(0);if(h===1)return d(n)?(g.root=g.dir=u,g):(g.base=g.name=u,g);if(d(n)){if(r=1,d(u.charCodeAt(1))){let f=2,P=f;for(;f<h&&!d(u.charCodeAt(f));)f++;if(f<h&&f!==P){for(P=f;f<h&&d(u.charCodeAt(f));)f++;if(f<h&&f!==P){for(P=f;f<h&&!d(u.charCodeAt(f));)f++;f===h?r=f:f!==P&&(r=f+1)}}}}else if(w(n)&&u.charCodeAt(1)===I){if(h<=2)return g.root=g.dir=u,g;if(r=2,d(u.charCodeAt(2))){if(h===3)return g.root=g.dir=u,g;r=3}}r>0&&(g.root=u.slice(0,r));let t=-1,s=r,a=-1,c=!0,o=u.length-1,l=0;for(;o>=r;--o){if(n=u.charCodeAt(o),d(n)){if(!c){s=o+1;break}continue}a===-1&&(c=!1,a=o+1),n===b?t===-1?t=o:l!==1&&(l=1):t!==-1&&(l=-1)}return a!==-1&&(t===-1||l===0||l===1&&t===a-1&&t===s+1?g.base=g.name=u.slice(s,a):(g.name=u.slice(s,t),g.base=u.slice(s,a),g.ext=u.slice(t,a))),s>0&&s!==r?g.dir=u.slice(0,s-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let g="",h=!1;for(let r=u.length-1;r>=-1&&!h;r--){const n=r>=0?u[r]:D.cwd();y(n,"path"),n.length!==0&&(g=`${n}/${g}`,h=n.charCodeAt(0)===C)}return g=p(g,!h,"/",S),h?`/${g}`:g.length>0?g:"."},normalize(u){if(y(u,"path"),u.length===0)return".";const g=u.charCodeAt(0)===C,h=u.charCodeAt(u.length-1)===C;return u=p(u,!g,"/",S),u.length===0?g?"/":h?"./":".":(h&&(u+="/"),g?`/${u}`:u)},isAbsolute(u){return y(u,"path"),u.length>0&&u.charCodeAt(0)===C},join(...u){if(u.length===0)return".";let g;for(let h=0;h<u.length;++h){const r=u[h];y(r,"path"),r.length>0&&(g===void 0?g=r:g+=`/${r}`)}return g===void 0?".":e.posix.normalize(g)},relative(u,g){if(y(u,"from"),y(g,"to"),u===g||(u=e.posix.resolve(u),g=e.posix.resolve(g),u===g))return"";const h=1,r=u.length,n=r-h,t=1,s=g.length-t,a=n<s?n:s;let c=-1,o=0;for(;o<a;o++){const f=u.charCodeAt(h+o);if(f!==g.charCodeAt(t+o))break;f===C&&(c=o)}if(o===a)if(s>a){if(g.charCodeAt(t+o)===C)return g.slice(t+o+1);if(o===0)return g.slice(t+o)}else n>a&&(u.charCodeAt(h+o)===C?c=o:o===0&&(c=0));let l="";for(o=h+c+1;o<=r;++o)(o===r||u.charCodeAt(o)===C)&&(l+=l.length===0?"..":"/..");return`${l}${g.slice(t+c)}`},toNamespacedPath(u){return u},dirname(u){if(y(u,"path"),u.length===0)return".";const g=u.charCodeAt(0)===C;let h=-1,r=!0;for(let n=u.length-1;n>=1;--n)if(u.charCodeAt(n)===C){if(!r){h=n;break}}else r=!1;return h===-1?g?"/":".":g&&h===1?"//":u.slice(0,h)},basename(u,g){g!==void 0&&y(g,"ext"),y(u,"path");let h=0,r=-1,n=!0,t;if(g!==void 0&&g.length>0&&g.length<=u.length){if(g===u)return"";let s=g.length-1,a=-1;for(t=u.length-1;t>=0;--t){const c=u.charCodeAt(t);if(c===C){if(!n){h=t+1;break}}else a===-1&&(n=!1,a=t+1),s>=0&&(c===g.charCodeAt(s)?--s==-1&&(r=t):(s=-1,r=a))}return h===r?r=a:r===-1&&(r=u.length),u.slice(h,r)}for(t=u.length-1;t>=0;--t)if(u.charCodeAt(t)===C){if(!n){h=t+1;break}}else r===-1&&(n=!1,r=t+1);return r===-1?"":u.slice(h,r)},extname(u){y(u,"path");let g=-1,h=0,r=-1,n=!0,t=0;for(let s=u.length-1;s>=0;--s){const a=u.charCodeAt(s);if(a===C){if(!n){h=s+1;break}continue}r===-1&&(n=!1,r=s+1),a===b?g===-1?g=s:t!==1&&(t=1):g!==-1&&(t=-1)}return g===-1||r===-1||t===0||t===1&&g===r-1&&g===h+1?"":u.slice(g,r)},format:m.bind(null,"/"),parse(u){y(u,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return g;const h=u.charCodeAt(0)===C;let r;h?(g.root="/",r=1):r=0;let n=-1,t=0,s=-1,a=!0,c=u.length-1,o=0;for(;c>=r;--c){const l=u.charCodeAt(c);if(l===C){if(!a){t=c+1;break}continue}s===-1&&(a=!1,s=c+1),l===b?n===-1?n=c:o!==1&&(o=1):n!==-1&&(o=-1)}if(s!==-1){const l=t===0&&h?1:t;n===-1||o===0||o===1&&n===s-1&&n===t+1?g.base=g.name=u.slice(l,s):(g.name=u.slice(l,n),g.base=u.slice(l,s),g.ext=u.slice(n,s))}return t>0?g.dir=u.slice(0,t-1):h&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[124],re([0,1,12]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(I){const E=(0,D.extname)(I),v=i[E.toLowerCase()];return v!==void 0?v:A(I)}e.getMediaOrTextMime=L;function A(I){const E=(0,D.extname)(I);return k[E.toLowerCase()]}e.getMediaMime=A;function b(I){for(const E in k)if(k[E]===I)return E}e.getExtensionForMimeType=b;const C=/^(.+)\/(.+?)(;.+)?$/;function R(I,E){const v=C.exec(I);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:E?void 0:I}e.normalizeMimeType=R}),define(ne[77],re([0,1,4]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var k;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(b,...C){const R=C.reduce((v,y)=>(v[y]=!0,v),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(v=>!R[v]).forEach(v=>{for(let y=0;y<I.length;y++)if(v.search(I[y])!==-1){delete b[v];break}})}e.sanitizeProcessEnvironment=L;function A(b){!b||(delete b.DEBUG,D.isMacintosh&&delete b.DYLD_LIBRARY_PATH,D.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(ne[125],re([0,1,4]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=D.globals.performance&&typeof D.globals.performance.now=="function";class k{constructor(A){this._highResolution=i&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ne[3],re([0,1,9,74,2,112,125]),function(X,e,D,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const b=!1,C=!1;var R;(function(c){c.None=()=>k.Disposable.None;function o(M){if(C){const{onListenerDidAdd:q}=M,j=d.create();let Z=0;M.onListenerDidAdd=()=>{++Z==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),q?.()}}}function l(M){return(q,j=null,Z)=>{let G=!1,te;return te=M(se=>{if(!G)return te?te.dispose():G=!0,q.call(j,se)},null,Z),G&&te.dispose(),te}}c.once=l;function f(M,q,j){return N((Z,G=null,te)=>M(se=>Z.call(G,q(se)),null,te),j)}c.map=f;function P(M,q,j){return N((Z,G=null,te)=>M(se=>{q(se),Z.call(G,se)},null,te),j)}c.forEach=P;function U(M,q,j){return N((Z,G=null,te)=>M(se=>q(se)&&Z.call(G,se),null,te),j)}c.filter=U;function _(M){return M}c.signal=_;function F(...M){return(q,j=null,Z)=>(0,k.combinedDisposable)(...M.map(G=>G(te=>q.call(j,te),null,Z)))}c.any=F;function T(M,q,j,Z){let G=j;return f(M,te=>(G=q(G,te),G),Z)}c.reduce=T;function N(M,q){let j;const Z={onFirstListenerAdd(){j=M(G.fire,G)},onLastListenerRemove(){j?.dispose()}};q||o(Z);const G=new w(Z);return q?.add(G),G.event}function z(M,q,j=100,Z=!1,G,te){let se,ce,he,ve=0;const pe={leakWarningThreshold:G,onFirstListenerAdd(){se=M(be=>{ve++,ce=q(ce,be),Z&&!he&&(Ce.fire(ce),ce=void 0),clearTimeout(he),he=setTimeout(()=>{const Pe=ce;ce=void 0,he=void 0,(!Z||ve>1)&&Ce.fire(Pe),ve=0},j)})},onLastListenerRemove(){se.dispose()}};te||o(pe);const Ce=new w(pe);return te?.add(Ce),Ce.event}c.debounce=z;function V(M,q=(Z,G)=>Z===G,j){let Z=!0,G;return U(M,te=>{const se=Z||!q(te,G);return Z=!1,G=te,se},j)}c.latch=V;function J(M,q,j){return[c.filter(M,q,j),c.filter(M,Z=>!q(Z),j)]}c.split=J;function $(M,q=!1,j=[]){let Z=j.slice(),G=M(ce=>{Z?Z.push(ce):se.fire(ce)});const te=()=>{Z?.forEach(ce=>se.fire(ce)),Z=null},se=new w({onFirstListenerAdd(){G||(G=M(ce=>se.fire(ce)))},onFirstListenerDidAdd(){Z&&(q?setTimeout(te):te())},onLastListenerRemove(){G&&G.dispose(),G=null}});return se.event}c.buffer=$;class Q{constructor(q){this.event=q,this.disposables=new k.DisposableStore}map(q){return new Q(f(this.event,q,this.disposables))}forEach(q){return new Q(P(this.event,q,this.disposables))}filter(q){return new Q(U(this.event,q,this.disposables))}reduce(q,j){return new Q(T(this.event,q,j,this.disposables))}latch(){return new Q(V(this.event,void 0,this.disposables))}debounce(q,j=100,Z=!1,G){return new Q(z(this.event,q,j,Z,G,this.disposables))}on(q,j,Z){return this.event(q,j,Z)}once(q,j,Z){return l(this.event)(q,j,Z)}dispose(){this.disposables.dispose()}}function H(M){return new Q(M)}c.chain=H;function B(M,q,j=Z=>Z){const Z=(...ce)=>se.fire(j(...ce)),G=()=>M.on(q,Z),te=()=>M.removeListener(q,Z),se=new w({onFirstListenerAdd:G,onLastListenerRemove:te});return se.event}c.fromNodeEventEmitter=B;function Y(M,q,j=Z=>Z){const Z=(...ce)=>se.fire(j(...ce)),G=()=>M.addEventListener(q,Z),te=()=>M.removeEventListener(q,Z),se=new w({onFirstListenerAdd:G,onLastListenerRemove:te});return se.event}c.fromDOMEventEmitter=Y;function ie(M){return new Promise(q=>l(M)(q))}c.toPromise=ie;function ae(M,q){return q(void 0),M(j=>q(j))}c.runAndSubscribe=ae;function W(M,q){let j=null;function Z(te){j?.dispose(),j=new k.DisposableStore,q(te,j)}Z(void 0);const G=M(te=>Z(te));return(0,k.toDisposable)(()=>{G.dispose(),j?.dispose()})}c.runAndSubscribeWithStore=W;class x{constructor(q,j){this.obs=q,this._counter=0,this._hasChanged=!1;const Z={onFirstListenerAdd:()=>{q.addObserver(this)},onLastListenerRemove:()=>{q.removeObserver(this)}};j||o(Z),this.emitter=new w(Z),j&&j.add(this.emitter)}beginUpdate(q){this._counter++}handleChange(q,j){this._hasChanged=!0}endUpdate(q){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function O(M,q){return new x(M,q).emitter.event}c.fromObservable=O})(R=e.Event||(e.Event={}));class I{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${I._idPool++}`}start(o){this._stopWatch=new A.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}I._idPool=0;let E=-1;function v(c){const o=E;return E=c,{dispose(){E=o}}}e.setGlobalLeakWarningThreshold=v;class y{constructor(o,l=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,l){let f=E;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),f<=0||l<f)return;this._stacks||(this._stacks=new Map);const P=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,P+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let U,_=0;for(const[F,T]of this._stacks)(!U||_<T)&&(U=F,_=T);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${_}):`),console.warn(U)}return()=>{const U=this._stacks.get(o.value)||0;this._stacks.set(o.value,U-1)}}}class d{constructor(o){this.value=o}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(o,l,f){this.callback=o,this.callbackThis=l,this.stack=f,this.subscription=new k.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class w{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=E>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(b){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const l of o)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,l,f)=>{this._listeners||(this._listeners=new L.LinkedList);const P=this._listeners.isEmpty();P&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let U,_;this._leakageMon&&this._listeners.size>=30&&(_=d.create(),U=this._leakageMon.check(_,this._listeners.size+1)),b&&(_=_??d.create());const F=new S(o,l,_),T=this._listeners.push(F);P&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,l);const N=F.subscription.set(()=>{U?.(),this._disposed||(T(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return f instanceof k.DisposableStore?f.add(N):Array.isArray(f)&&f.push(N),N}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new m);for(const l of this._listeners)this._deliveryQueue.push(this,l,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=w;class p{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(o,l,f){this._queue.push(new u(o,l,f))}clear(o){const l=new L.LinkedList;for(const f of this._queue)f.emitter!==o&&l.push(f);this._queue=l}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(l){(0,D.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=p;class m extends p{clear(o){this._queue.clear()}}class u{constructor(o,l,f){this.emitter=o,this.listener=l,this.event=f}}class g extends w{async fireAsync(o,l,f){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const P of this._listeners)this._asyncDeliveryQueue.push([P,o]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[P,U]=this._asyncDeliveryQueue.shift(),_=[],F={...U,token:l,waitUntil:T=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");f&&(T=f(T,P.callback)),_.push(T)}};try{P.invoke(F)}catch(T){(0,D.onUnexpectedError)(T);continue}Object.freeze(_),await Promise.allSettled(_).then(T=>{for(const N of T)N.status==="rejected"&&(0,D.onUnexpectedError)(N.reason)})}}}}e.AsyncEmitter=g;class h extends w{constructor(o){super(o);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=h;class r extends h{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=r;class n extends w{constructor(o){super(o);this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]})}}e.MicrotaskEmitter=n;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const l={event:o,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const f=()=>{this.hasListeners&&this.unhook(l);const P=this.events.indexOf(l);this.events.splice(P,1)};return(0,k.toDisposable)((0,i.once)(f))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(l=>this.emitter.fire(l))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class s{constructor(){this.buffers=[]}wrapEvent(o){return(l,f,P)=>o(U=>{const _=this.buffers[this.buffers.length-1];_?_.push(()=>l.call(f,U)):l.call(f,U)},void 0,P)}bufferEvents(o){const l=[];this.buffers.push(l);const f=o();return this.buffers.pop(),l.forEach(P=>P()),f}}e.EventBufferer=s;class a{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=k.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(ne[21],re([0,1,3]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(b,C){const R=setTimeout(b.bind(C),0);return{dispose(){clearTimeout(R)}}});var k;(function(b){function C(R){return R===b.None||R===b.Cancelled||R instanceof L?!0:!R||typeof R!="object"?!1:typeof R.isCancellationRequested=="boolean"&&typeof R.onCancellationRequested=="function"}b.isCancellationToken=C,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(k=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=k.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(ne[126],re([0,1,21]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new D.CancellationTokenSource,C=this.task(b.token);return this.result={promise:C,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}e.Cache=i;class k{constructor(b){this.fn=b,this.lastCache=void 0,this.lastArgKey=void 0}get(b){const C=JSON.stringify(b);return this.lastArgKey!==C&&(this.lastArgKey=C,this.lastCache=this.fn(b)),this.lastCache}}e.LRUCachedFunction=k;class L{constructor(b){this.fn=b,this._map=new Map}get cachedValues(){return this._map}get(b){if(this._map.has(b))return this._map.get(b);const C=this.fn(b);return this._map.set(b,C),C}}e.CachedFunction=L}),define(ne[78],re([0,1,3,2]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=A=>({onDidChange:D.Event.None,value:A});e.staticObservableValue=k;class L extends i.Disposable{constructor(b){super();this._value=b,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(b){b!==this._value&&(this._value=b,this.changeEmitter.fire(b))}}e.MutableObservableValue=L}),define(ne[26],re([0,1,126,111]),function(X,e,D,i){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.isFalsyOrWhitespace=L;const A=/{(\d+)}/g;function b(ee,...le){return le.length===0?ee:ee.replace(A,function(fe,Se){const me=parseInt(Se,10);return isNaN(me)||me<0||me>=le.length?fe:le[me]})}e.format=b;const C=/{([^}]+)}/g;function R(ee,le){return ee.replace(C,(fe,Se)=>le[Se]??fe)}e.format2=R;function I(ee){return ee.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=I;function E(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function v(ee,le){let fe=0;const Se=le.charCodeAt(0);for(let me=ee.length-1;me>=0;me--)ee.charCodeAt(me)===Se&&fe++;return fe}e.count=v;function y(ee,le,fe="\u2026"){return ee.length<=le?ee:`${ee.substr(0,le)}${fe}`}e.truncate=y;function d(ee,le=" "){const fe=S(ee,le);return w(fe,le)}e.trim=d;function S(ee,le){if(!ee||!le)return ee;const fe=le.length;if(fe===0||ee.length===0)return ee;let Se=0;for(;ee.indexOf(le,Se)===Se;)Se=Se+fe;return ee.substring(Se)}e.ltrim=S;function w(ee,le){if(!ee||!le)return ee;const fe=le.length,Se=ee.length;if(fe===0||Se===0)return ee;let me=Se,we=-1;for(;we=ee.lastIndexOf(le,me-1),!(we===-1||we+fe!==me);){if(we===0)return"";me=we}return ee.substring(0,me)}e.rtrim=w;function p(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function m(ee){return ee.replace(/\*/g,"")}e.stripWildcards=m;function u(ee,le,fe={}){if(!ee)throw new Error("Cannot create regex from empty string");le||(ee=E(ee)),fe.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let Se="";return fe.global&&(Se+="g"),fe.matchCase||(Se+="i"),fe.multiline&&(Se+="m"),fe.unicode&&(Se+="u"),new RegExp(ee,Se)}e.createRegExp=u;function g(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function h(ee){return!!ee.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=h;function r(ee){return(ee.global?"g":"")+(ee.ignoreCase?"i":"")+(ee.multiline?"m":"")+(ee.unicode?"u":"")}e.regExpFlags=r;function n(ee){return ee.split(/\r\n|\r|\n/)}e.splitLines=n;function t(ee){for(let le=0,fe=ee.length;le<fe;le++){const Se=ee.charCodeAt(le);if(Se!==32&&Se!==9)return le}return-1}e.firstNonWhitespaceIndex=t;function s(ee,le=0,fe=ee.length){for(let Se=le;Se<fe;Se++){const me=ee.charCodeAt(Se);if(me!==32&&me!==9)return ee.substring(le,Se)}return ee.substring(le,fe)}e.getLeadingWhitespace=s;function a(ee,le=ee.length-1){for(let fe=le;fe>=0;fe--){const Se=ee.charCodeAt(fe);if(Se!==32&&Se!==9)return fe}return-1}e.lastNonWhitespaceIndex=a;function c(ee,le,fe){const Se=[];let me=0;for(const we of ee.matchAll(le)){if(Se.push(ee.slice(me,we.index)),we.index===void 0)throw new Error("match.index should be defined");me=we.index+we[0].length,Se.push(fe(we[0],...we.slice(1),we.index,ee,we.groups))}return Se.push(ee.slice(me)),Promise.all(Se).then(we=>we.join(""))}e.replaceAsync=c;function o(ee,le){return ee<le?-1:ee>le?1:0}e.compare=o;function l(ee,le,fe=0,Se=ee.length,me=0,we=le.length){for(;fe<Se&&me<we;fe++,me++){const Le=ee.charCodeAt(fe),_e=le.charCodeAt(me);if(Le<_e)return-1;if(Le>_e)return 1}const Re=Se-fe,ke=we-me;return Re<ke?-1:Re>ke?1:0}e.compareSubstring=l;function f(ee,le){return P(ee,le,0,ee.length,0,le.length)}e.compareIgnoreCase=f;function P(ee,le,fe=0,Se=ee.length,me=0,we=le.length){for(;fe<Se&&me<we;fe++,me++){let Le=ee.charCodeAt(fe),_e=le.charCodeAt(me);if(Le===_e)continue;if(Le>=128||_e>=128)return l(ee.toLowerCase(),le.toLowerCase(),fe,Se,me,we);_(Le)&&(Le-=32),_(_e)&&(_e-=32);const Fe=Le-_e;if(Fe!==0)return Fe}const Re=Se-fe,ke=we-me;return Re<ke?-1:Re>ke?1:0}e.compareSubstringIgnoreCase=P;function U(ee){return ee>=48&&ee<=57}e.isAsciiDigit=U;function _(ee){return ee>=97&&ee<=122}e.isLowerAsciiLetter=_;function F(ee){return ee>=65&&ee<=90}e.isUpperAsciiLetter=F;function T(ee,le){return ee.length===le.length&&P(ee,le)===0}e.equalsIgnoreCase=T;function N(ee,le){const fe=le.length;return le.length>ee.length?!1:P(ee,le,0,fe)===0}e.startsWithIgnoreCase=N;function z(ee,le){const fe=Math.min(ee.length,le.length);let Se;for(Se=0;Se<fe;Se++)if(ee.charCodeAt(Se)!==le.charCodeAt(Se))return Se;return fe}e.commonPrefixLength=z;function V(ee,le){const fe=Math.min(ee.length,le.length);let Se;const me=ee.length-1,we=le.length-1;for(Se=0;Se<fe;Se++)if(ee.charCodeAt(me-Se)!==le.charCodeAt(we-Se))return Se;return fe}e.commonSuffixLength=V;function J(ee){return 55296<=ee&&ee<=56319}e.isHighSurrogate=J;function $(ee){return 56320<=ee&&ee<=57343}e.isLowSurrogate=$;function Q(ee,le){return(ee-55296<<10)+(le-56320)+65536}e.computeCodePoint=Q;function H(ee,le,fe){const Se=ee.charCodeAt(fe);if(J(Se)&&fe+1<le){const me=ee.charCodeAt(fe+1);if($(me))return Q(Se,me)}return Se}e.getNextCodePoint=H;function B(ee,le){const fe=ee.charCodeAt(le-1);if($(fe)&&le>1){const Se=ee.charCodeAt(le-2);if(J(Se))return Q(Se,fe)}return fe}class Y{constructor(le,fe=0){this._str=le,this._len=le.length,this._offset=fe}get offset(){return this._offset}setOffset(le){this._offset=le}prevCodePoint(){const le=B(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=H(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=Y;class ie{constructor(le,fe=0){this._iterator=new Y(le,fe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const le=Ee.getInstance(),fe=this._iterator,Se=fe.offset;let me=le.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const we=fe.offset,Re=le.getGraphemeBreakType(fe.nextCodePoint());if(ue(me,Re)){fe.setOffset(we);break}me=Re}return fe.offset-Se}prevGraphemeLength(){const le=Ee.getInstance(),fe=this._iterator,Se=fe.offset;let me=le.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const we=fe.offset,Re=le.getGraphemeBreakType(fe.prevCodePoint());if(ue(Re,me)){fe.setOffset(we);break}me=Re}return Se-fe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ie;function ae(ee,le){return new ie(ee,le).nextGraphemeLength()}e.nextCharLength=ae;function W(ee,le){return new ie(ee,le).prevGraphemeLength()}e.prevCharLength=W;function x(ee,le){le>0&&$(ee.charCodeAt(le))&&le--;const fe=le+ae(ee,le);return[fe-W(ee,fe),fe]}e.getCharContainingOffset=x;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function M(ee){return O.test(ee)}e.containsRTL=M;const q=/^[\t\n\r\x20-\x7E]*$/;function j(ee){return q.test(ee)}e.isBasicASCII=j,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(ee){return e.UNUSUAL_LINE_TERMINATORS.test(ee)}e.containsUnusualLineTerminators=Z;function G(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.isFullWidthCharacter=G;function te(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.isEmojiImprecise=te;function se(ee,le){if(ee.length<le)return ee;const fe=/\b/g;let Se=0;for(;fe.test(ee)&&!(ee.length-fe.lastIndex<le);)Se=fe.lastIndex,fe.lastIndex+=1;return ee.substring(Se).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function pe(ee){return ee&&(ee=ee.replace(ce,""),ee=ee.replace(he,""),ee=ee.replace(ve,"")),ee}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function be(ee){return Ce(ee)?ee.substr(1):ee}e.stripUTF8BOM=be;function Pe(ee,le){if(!ee||!le||ee.length<le.length)return!1;const fe=le.length,Se=ee.toLowerCase();let me=0,we=-1;for(;me<fe;){const Re=Se.indexOf(le[me],we+1);if(Re<0)return!1;we=Re,me++}return!0}e.fuzzyContains=Pe;function Me(ee,le=!1){return ee?(le&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.containsUppercaseCharacter=Me;function Ye(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.uppercaseFirstLetter=Ye;function He(ee,le=1){if(le===0)return"";let fe=-1;do fe=ee.indexOf(`
`,fe+1),le--;while(le>0&&fe>=0);return fe===-1?ee:(ee[fe-1]==="\r"&&fe--,ee.substr(0,fe))}e.getNLines=He;function We(ee){const le=90-65+1;return ee=ee%(2*le),ee<le?String.fromCharCode(97+ee):String.fromCharCode(65+ee-le)}e.singleLetterHash=We;function oe(ee){return Ee.getInstance().getGraphemeBreakType(ee)}e.getGraphemeBreakType=oe;function ue(ee,le){return ee===0?le!==5&&le!==7:ee===2&&le===3?!1:ee===4||ee===2||ee===3||le===4||le===2||le===3?!0:!(ee===8&&(le===8||le===9||le===11||le===12)||(ee===11||ee===9)&&(le===9||le===10)||(ee===12||ee===10)&&le===10||le===5||le===13||le===7||ee===1||ee===13&&le===14||ee===6&&le===6)}var de;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(de=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ee{constructor(){this._data=Ie()}static getInstance(){return Ee._INSTANCE||(Ee._INSTANCE=new Ee),Ee._INSTANCE}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const fe=this._data,Se=fe.length/3;let me=1;for(;me<=Se;)if(le<fe[3*me])me=2*me;else if(le>fe[3*me+1])me=2*me+1;else return fe[3*me+2];return 0}}Ee._INSTANCE=null;function Ie(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(ee,le){if(ee===0)return 0;const fe=De(ee,le);if(fe!==void 0)return fe;const Se=new Y(le,ee);return Se.prevCodePoint(),Se.offset}e.getLeftDeleteOffset=Ue;function De(ee,le){const fe=new Y(le,ee);let Se=fe.prevCodePoint();for(;$e(Se)||Se===65039||Se===8419;){if(fe.offset===0)return;Se=fe.prevCodePoint()}if(!te(Se))return;let me=fe.offset;return me>0&&fe.prevCodePoint()===8205&&(me=fe.offset),me}function $e(ee){return 127995<=ee&&ee<=127999}var Ae;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={})),e.noBreakWhitespace="\xA0";class Te{constructor(le){this.confusableDictionary=le}static getInstance(le){return Te.cache.get(Array.from(le))}static getLocales(){return Te._locales.getValue()}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Te,k=Te,Te.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Te.cache=new D.LRUCachedFunction(ee=>{function le(_e){const Fe=new Map;for(let ze=0;ze<_e.length;ze+=2)Fe.set(_e[ze],_e[ze+1]);return Fe}function fe(_e,Fe){const ze=new Map(_e);for(const[Xe,nt]of Fe)ze.set(Xe,nt);return ze}function Se(_e,Fe){if(!_e)return Fe;const ze=new Map;for(const[Xe,nt]of _e)Fe.has(Xe)&&ze.set(Xe,nt);return ze}const me=k.ambiguousCharacterData.getValue();let we=ee.filter(_e=>!_e.startsWith("_")&&_e in me);we.length===0&&(we=["_default"]);let Re;for(const _e of we){const Fe=le(me[_e]);Re=Se(Re,Fe)}const ke=le(me._common),Le=fe(ke,Re);return new Te(Le)}),Te._locales=new i.Lazy(()=>Object.keys(Te.ambiguousCharacterData.getValue()).filter(ee=>!ee.startsWith("_")));class Ne{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ne.getRawData())),this._data}static isInvisibleCharacter(le){return Ne.getData().has(le)}static get codePoints(){return Ne.getData()}}e.InvisibleCharacters=Ne,Ne._data=void 0}),define(ne[42],re([0,1,12,4,26,14]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(a){return a===47||a===92}e.isPathSeparator=A;function b(a){return a.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=b;function C(a){return a.indexOf("/")===-1&&(a=b(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=C;function R(a,c=D.posix.sep){if(!a)return"";const o=a.length,l=a.charCodeAt(0);if(A(l)){if(A(a.charCodeAt(1))&&!A(a.charCodeAt(2))){let P=3;const U=P;for(;P<o&&!A(a.charCodeAt(P));P++);if(U!==P&&!A(a.charCodeAt(P+1))){for(P+=1;P<o;P++)if(A(a.charCodeAt(P)))return a.slice(0,P+1).replace(/[\\/]/g,c)}}return c}else if(p(l)&&a.charCodeAt(1)===58)return A(a.charCodeAt(2))?a.slice(0,2)+c:a.slice(0,2);let f=a.indexOf("://");if(f!==-1){for(f+=3;f<o;f++)if(A(a.charCodeAt(f)))return a.slice(0,f+1)}return""}e.getRoot=R;function I(a){if(!i.isWindows||!a||a.length<5)return!1;let c=a.charCodeAt(0);if(c!==92||(c=a.charCodeAt(1),c!==92))return!1;let o=2;const l=o;for(;o<a.length&&(c=a.charCodeAt(o),c!==92);o++);return!(l===o||(c=a.charCodeAt(o+1),isNaN(c)||c===92))}e.isUNC=I;const E=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(a,c=i.isWindows){const o=c?E:v;return!(!a||a.length===0||/^\s+$/.test(a)||(o.lastIndex=0,o.test(a))||c&&y.test(a)||a==="."||a===".."||c&&a[a.length-1]==="."||c&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=d;function S(a,c,o){const l=a===c;return!o||l?l:!a||!c?!1:(0,k.equalsIgnoreCase)(a,c)}e.isEqual=S;function w(a,c,o,l=D.sep){if(a===c)return!0;if(!a||!c||c.length>a.length)return!1;if(o){if(!(0,k.startsWithIgnoreCase)(a,c))return!1;if(c.length===a.length)return!0;let P=c.length;return c.charAt(c.length-1)===l&&P--,a.charAt(P)===l}return c.charAt(c.length-1)!==l&&(c+=l),a.indexOf(c)===0}e.isEqualOrParent=w;function p(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=p;function m(a,c){return i.isWindows&&a.endsWith(":")&&(a+=D.sep),(0,D.isAbsolute)(a)||(a=(0,D.join)(c,a)),a=(0,D.normalize)(a),i.isWindows?(a=(0,k.rtrim)(a,D.sep),a.endsWith(":")&&(a+=D.sep)):(a=(0,k.rtrim)(a,D.sep),a||(a=D.sep)),a}e.sanitizeFilePath=m;function u(a){const c=(0,D.normalize)(a);return i.isWindows?a.length>3?!1:g(c)&&(a.length===2||c.charCodeAt(2)===92):c===D.posix.sep}e.isRootOrDriveLetter=u;function g(a,c=i.isWindows){return c?p(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function h(a){return g(a)?a[0]:void 0}e.getDriveLetter=h;function r(a,c,o){return c.length>a.length?-1:a===c?0:(o&&(a=a.toLowerCase(),c=c.toLowerCase()),a.indexOf(c))}e.indexOfPath=r;function n(a){const c=a.split(":");let o,l,f;for(const P of c){const U=Number(P);(0,L.isNumber)(U)?l===void 0?l=U:f===void 0&&(f=U):o=o?[o,P].join(":"):P}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:l!==void 0?l:void 0,column:f!==void 0?f:l!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(a,c,o=8){let l="";for(let P=0;P<o;P++)l+=t.charAt(Math.floor(Math.random()*t.length));let f;return c?f=`${c}-${l}`:f=l,a?(0,D.join)(a,f):f}e.randomPath=s}),define(ne[62],re([0,1,26]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(p){return k(p,0)}e.hash=i;function k(p,m){switch(typeof p){case"object":return p===null?L(349,m):Array.isArray(p)?C(p,m):R(p,m);case"string":return b(p,m);case"boolean":return A(p,m);case"number":return L(p,m);case"undefined":return L(937,m);default:return L(617,m)}}e.doHash=k;function L(p,m){return(m<<5)-m+p|0}e.numberHash=L;function A(p,m){return L(p?433:863,m)}function b(p,m){m=L(149417,m);for(let u=0,g=p.length;u<g;u++)m=L(p.charCodeAt(u),m);return m}e.stringHash=b;function C(p,m){return m=L(104579,m),p.reduce((u,g)=>k(g,u),m)}function R(p,m){return m=L(181387,m),Object.keys(p).sort().reduce((u,g)=>(u=b(g,u),k(p[g],u)),m)}class I{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=k(m,this._value),this._value}}e.Hasher=I;var E;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function v(p,m,u=32){const g=u-m,h=~((1<<g)-1);return(p<<m|(h&p)>>>g)>>>0}function y(p,m=0,u=p.byteLength,g=0){for(let h=0;h<u;h++)p[m+h]=g}function d(p,m,u="0"){for(;p.length<m;)p=u+p;return p}function S(p,m=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(u=>u.toString(16).padStart(2,"0")).join(""):d((p>>>0).toString(16),m/4)}e.toHexString=S;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const u=m.length;if(u===0)return;const g=this._buff;let h=this._buffLen,r=this._leftoverHighSurrogate,n,t;for(r!==0?(n=r,t=-1,r=0):(n=m.charCodeAt(0),t=0);;){let s=n;if(D.isHighSurrogate(n))if(t+1<u){const a=m.charCodeAt(t+1);D.isLowSurrogate(a)?(t++,s=D.computeCodePoint(n,a)):s=65533}else{r=n;break}else D.isLowSurrogate(n)&&(s=65533);if(h=this._push(g,h,s),t++,t<u)n=m.charCodeAt(t);else break}this._buffLen=h,this._leftoverHighSurrogate=r}_push(m,u,g){return g<128?m[u++]=g:g<2048?(m[u++]=192|(g&1984)>>>6,m[u++]=128|(g&63)>>>0):g<65536?(m[u++]=224|(g&61440)>>>12,m[u++]=128|(g&4032)>>>6,m[u++]=128|(g&63)>>>0):(m[u++]=240|(g&1835008)>>>18,m[u++]=128|(g&258048)>>>12,m[u++]=128|(g&4032)>>>6,m[u++]=128|(g&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=w._bigBlock32,u=this._buffDV;for(let o=0;o<64;o+=4)m.setUint32(o,u.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)m.setUint32(o,v(m.getUint32(o-12,!1)^m.getUint32(o-32,!1)^m.getUint32(o-56,!1)^m.getUint32(o-64,!1),1),!1);let g=this._h0,h=this._h1,r=this._h2,n=this._h3,t=this._h4,s,a,c;for(let o=0;o<80;o++)o<20?(s=h&r|~h&n,a=1518500249):o<40?(s=h^r^n,a=1859775393):o<60?(s=h&r|h&n|r&n,a=2400959708):(s=h^r^n,a=3395469782),c=v(g,5)+s+t+a+m.getUint32(o*4,!1)&4294967295,t=n,n=r,r=v(h,30),h=g,g=c;this._h0=this._h0+g&4294967295,this._h1=this._h1+h&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))});var It=this&&this.__classPrivateFieldSet||function(X,e,D,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,D):k?k.value=D:e.set(X,D),D},Ke=this&&this.__classPrivateFieldGet||function(X,e,D,i){if(D==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?i:D==="a"?i.call(X):i?i.value:e.get(X)};define(ne[34],re([0,1,18,26]),function(X,e,D,i){"use strict";var k,L,A,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(a,c,o){let l=a.get(c);return l===void 0&&(l=o,a.set(c,l)),l}e.getOrSet=C;function R(a){const c=[];return a.forEach((o,l)=>{c.push(`${l} => ${o}`)}),`Map(${a.size}) {${c.join(", ")}}`}e.mapToString=R;function I(a){const c=[];return a.forEach(o=>{c.push(o)}),`Set(${a.size}) {${c.join(", ")}}`}e.setToString=I;class E{constructor(){this._value="",this._pos=0}reset(c){return this._value=c,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(c){const o=c.charCodeAt(0),l=this._value.charCodeAt(this._pos);return o-l}value(){return this._value[this._pos]}}e.StringIterator=E;class v{constructor(c=!0){this._caseSensitive=c}reset(c){return this._value=c,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let c=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(c)this._from++;else break;else c=!1;return this}cmp(c){return this._caseSensitive?(0,i.compareSubstring)(c,this._value,0,c.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(c,this._value,0,c.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=v;class y{constructor(c=!0,o=!0){this._splitOnBackslash=c,this._caseSensitive=o}reset(c){this._from=0,this._to=0,this._value=c,this._valueLen=c.length;for(let o=c.length-1;o>=0;o--,this._valueLen--){const l=this._value.charCodeAt(o);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let c=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(c)this._from++;else break;else c=!1}return this}cmp(c){return this._caseSensitive?(0,i.compareSubstring)(c,this._value,0,c.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(c,this._value,0,c.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var d;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(d||(d={}));class S{constructor(c,o){this._ignorePathCasing=c,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(c){return this._value=c,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(c)),this._pathIterator.reset(c.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(c)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(c){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(c,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(c,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(c);if(this._states[this._stateIdx]===4)return(0,i.compare)(c,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(c,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(p||(p={}));class m{constructor(c){this._iter=c}static forUris(c=()=>!1,o=()=>!1){return new m(new S(c,o))}static forPaths(c=!1){return new m(new y(void 0,!c))}static forStrings(){return new m(new E)}static forConfigKeys(){return new m(new v)}clear(){this._root=void 0}fill(c,o){if(o){const l=o.slice(0);(0,D.shuffle)(l);for(const f of l)this.set(f,c)}else{const l=c.slice(0);(0,D.shuffle)(l);for(const f of l)this.set(f[0],f[1])}}set(c,o){const l=this._iter.reset(c);let f;this._root||(this._root=new w,this._root.segment=l.value());const P=[];for(f=this._root;;){const _=l.cmp(f.segment);if(_>0)f.left||(f.left=new w,f.left.segment=l.value()),P.push([-1,f]),f=f.left;else if(_<0)f.right||(f.right=new w,f.right.segment=l.value()),P.push([1,f]),f=f.right;else if(l.hasNext())l.next(),f.mid||(f.mid=new w,f.mid.segment=l.value()),P.push([0,f]),f=f.mid;else break}const U=f.value;f.value=o,f.key=c;for(let _=P.length-1;_>=0;_--){const F=P[_][1];F.updateHeight();const T=F.balanceFactor();if(T<-1||T>1){const N=P[_][0],z=P[_+1][0];if(N===1&&z===1)P[_][1]=F.rotateLeft();else if(N===-1&&z===-1)P[_][1]=F.rotateRight();else if(N===1&&z===-1)F.right=P[_+1][1]=P[_+1][1].rotateRight(),P[_][1]=F.rotateLeft();else if(N===-1&&z===1)F.left=P[_+1][1]=P[_+1][1].rotateLeft(),P[_][1]=F.rotateRight();else throw new Error;if(_>0)switch(P[_-1][0]){case-1:P[_-1][1].left=P[_][1];break;case 1:P[_-1][1].right=P[_][1];break;case 0:P[_-1][1].mid=P[_][1];break}else this._root=P[0][1]}}return U}get(c){return this._getNode(c)?.value}_getNode(c){const o=this._iter.reset(c);let l=this._root;for(;l;){const f=o.cmp(l.segment);if(f>0)l=l.left;else if(f<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else break}return l}has(c){const o=this._getNode(c);return!(o?.value===void 0&&o?.mid===void 0)}delete(c){return this._delete(c,!1)}deleteSuperstr(c){return this._delete(c,!0)}_delete(c,o){const l=this._iter.reset(c),f=[];let P=this._root;for(;P;){const U=l.cmp(P.segment);if(U>0)f.push([-1,P]),P=P.left;else if(U<0)f.push([1,P]),P=P.right;else if(l.hasNext())l.next(),f.push([0,P]),P=P.mid;else break}if(!!P){if(o?(P.left=void 0,P.mid=void 0,P.right=void 0,P.height=1):(P.key=void 0,P.value=void 0),!P.mid&&!P.value)if(P.left&&P.right){const U=this._min(P.right),{key:_,value:F,segment:T}=U;this._delete(U.key,!1),P.key=_,P.value=F,P.segment=T}else{const U=P.left??P.right;if(f.length>0){const[_,F]=f[f.length-1];switch(_){case-1:F.left=U;break;case 0:F.mid=U;break;case 1:F.right=U;break}}else this._root=U}for(let U=f.length-1;U>=0;U--){const _=f[U][1];_.updateHeight();const F=_.balanceFactor();if(F>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),f[U][1]=_.rotateLeft()):F<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),f[U][1]=_.rotateRight()),U>0)switch(f[U-1][0]){case-1:f[U-1][1].left=f[U][1];break;case 1:f[U-1][1].right=f[U][1];break;case 0:f[U-1][1].mid=f[U][1];break}else this._root=f[0][1]}}}_min(c){for(;c.left;)c=c.left;return c}findSubstr(c){const o=this._iter.reset(c);let l=this._root,f;for(;l;){const P=o.cmp(l.segment);if(P>0)l=l.left;else if(P<0)l=l.right;else if(o.hasNext())o.next(),f=l.value||f,l=l.mid;else break}return l&&l.value||f}findSuperstr(c){const o=this._iter.reset(c);let l=this._root;for(;l;){const f=o.cmp(l.segment);if(f>0)l=l.left;else if(f<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(c){for(const[o,l]of this)c(l,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(c){const o=[];return this._dfsEntries(c,o),o[Symbol.iterator]()}_dfsEntries(c,o){!c||(c.left&&this._dfsEntries(c.left,o),c.value&&o.push([c.key,c.value]),c.mid&&this._dfsEntries(c.mid,o),c.right&&this._dfsEntries(c.right,o))}_isBalanced(){const c=o=>{if(!o)return!0;const l=o.balanceFactor();return l<-1||l>1?!1:c(o.left)&&c(o.right)};return c(this._root)}}e.TernarySearchTree=m;class u{constructor(c,o){this.uri=c,this.value=o}}class g{constructor(c,o){this[k]="ResourceMap",c instanceof g?(this.map=new Map(c.map),this.toKey=o??g.defaultToKey):(this.map=new Map,this.toKey=c??g.defaultToKey)}set(c,o){return this.map.set(this.toKey(c),new u(c,o)),this}get(c){return this.map.get(this.toKey(c))?.value}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,o){typeof o!="undefined"&&(c=c.bind(o));for(const[l,f]of this.map)c(f.value,f.uri,this)}*values(){for(const c of this.map.values())yield c.value}*keys(){for(const c of this.map.values())yield c.uri}*entries(){for(const c of this.map.values())yield[c.uri,c.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.map)yield[c.uri,c.value]}}e.ResourceMap=g,g.defaultToKey=a=>a.toString();class h{constructor(c,o){this[L]="ResourceSet",!c||typeof c=="function"?this._map=new g(c):(this._map=new g(o),c.forEach(this.add,this))}get size(){return this._map.size}add(c){return this._map.set(c,c),this}clear(){this._map.clear()}delete(c){return this._map.delete(c)}forEach(c,o){this._map.forEach((l,f)=>c.call(o,f,f,this))}has(c){return this._map.has(c)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=h;var r;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class n{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(c){return this._map.has(c)}get(c,o=0){const l=this._map.get(c);if(!!l)return o!==0&&this.touch(l,o),l.value}set(c,o,l=0){let f=this._map.get(c);if(f)f.value=o,l!==0&&this.touch(f,l);else{switch(f={key:c,value:o,next:void 0,previous:void 0},l){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(c,f),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const o=this._map.get(c);if(!!o)return this._map.delete(c),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}forEach(c,o){const l=this._state;let f=this._head;for(;f;){if(o?c.bind(o)(f.value,f.key,this):c(f.value,f.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const c=this,o=this._state;let l=this._head;const f={[Symbol.iterator](){return f},next(){if(c._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const P={value:l.key,done:!1};return l=l.next,P}else return{value:void 0,done:!0}}};return f}values(){const c=this,o=this._state;let l=this._head;const f={[Symbol.iterator](){return f},next(){if(c._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const P={value:l.value,done:!1};return l=l.next,P}else return{value:void 0,done:!0}}};return f}entries(){const c=this,o=this._state;let l=this._head;const f={[Symbol.iterator](){return f},next(){if(c._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const P={value:[l.key,l.value],done:!1};return l=l.next,P}else return{value:void 0,done:!0}}};return f}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(c>=this.size)return;if(c===0){this.clear();return}let o=this._head,l=this.size;for(;o&&l>c;)this._map.delete(o.key),o=o.next,l--;this._head=o,this._size=l,o&&(o.previous=void 0),this._state++}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const o=c.next,l=c.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}c.next=void 0,c.previous=void 0,this._state++}touch(c,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(c===this._head)return;const l=c.next,f=c.previous;c===this._tail?(f.next=void 0,this._tail=f):(l.previous=f,f.next=l),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(o===2){if(c===this._tail)return;const l=c.next,f=c.previous;c===this._head?(l.previous=void 0,this._head=l):(l.previous=f,f.next=l),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((o,l)=>{c.push([l,o])}),c}fromJSON(c){this.clear();for(const[o,l]of c)this.set(o,l)}}e.LinkedMap=n;class t extends n{constructor(c,o=1){super();this._limit=c,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,o=2){return super.get(c,o)}peek(c){return super.get(c,0)}set(c,o){return super.set(c,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=t;class s{constructor(c){b.set(this,void 0),It(this,b,c,"f")}get size(){return Ke(this,b,"f").size}forEach(c,o){Ke(this,b,"f").forEach(c,o)}get(c){return Ke(this,b,"f").get(c)}has(c){return Ke(this,b,"f").has(c)}entries(){return Ke(this,b,"f").entries()}keys(){return Ke(this,b,"f").keys()}values(){return Ke(this,b,"f").values()}[(b=new WeakMap,Symbol.iterator)](){return Ke(this,b,"f").entries()}}e.ReadonlyMapView=s}),define(ne[79],re([0,1,34]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new D.LRUCache(1e4);function k(R){return C(R,"NFC",i)}e.normalizeNFC=k;const L=new D.LRUCache(1e4);function A(R){return C(R,"NFD",L)}e.normalizeNFD=A;const b=/[^\u0000-\u0080]/;function C(R,I,E){if(!R)return R;const v=E.get(R);if(v)return v;let y;return b.test(R)?y=R.normalize(I):y=R,E.set(R,y),y}e.removeAccents=function(){const R=/[\u0300-\u036f]/g;return function(I){return A(I).replace(R,"")}}()}),define(ne[80],re([0,1,26]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(i||(i={})),function(k){const L="error",A="warning",b="warn",C="info",R="ignore";function I(v){return v?D.equalsIgnoreCase(L,v)?k.Error:D.equalsIgnoreCase(A,v)||D.equalsIgnoreCase(b,v)?k.Warning:D.equalsIgnoreCase(C,v)?k.Info:k.Ignore:k.Ignore}k.fromValue=I;function E(v){switch(v){case k.Error:return L;case k.Warning:return A;case k.Info:return C;default:return R}}k.toString=E}(i||(i={})),e.default=i}),define(ne[7],re([0,1,12,4]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function b(t,s){if(!t.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!k.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!L.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(t,s){return!t&&!s?"file":t}function R(t,s){switch(t){case"https":case"http":case"file":s?s[0]!==E&&(s=E+s):s=E;break}return s}const I="",E="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(s,a,c,o,l,f=!1){typeof s=="object"?(this.scheme=s.scheme||I,this.authority=s.authority||I,this.path=s.path||I,this.query=s.query||I,this.fragment=s.fragment||I):(this.scheme=C(s,f),this.authority=a||I,this.path=R(this.scheme,c||I),this.query=o||I,this.fragment=l||I,b(this,f))}static isUri(s){return s instanceof y?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return u(this,!1)}with(s){if(!s)return this;let{scheme:a,authority:c,path:o,query:l,fragment:f}=s;return a===void 0?a=this.scheme:a===null&&(a=I),c===void 0?c=this.authority:c===null&&(c=I),o===void 0?o=this.path:o===null&&(o=I),l===void 0?l=this.query:l===null&&(l=I),f===void 0?f=this.fragment:f===null&&(f=I),a===this.scheme&&c===this.authority&&o===this.path&&l===this.query&&f===this.fragment?this:new S(a,c,o,l,f)}static parse(s,a=!1){const c=v.exec(s);return c?new S(c[2]||I,n(c[4]||I),n(c[5]||I),n(c[7]||I),n(c[9]||I),a):new S(I,I,I,I,I)}static file(s){let a=I;if(i.isWindows&&(s=s.replace(/\\/g,E)),s[0]===E&&s[1]===E){const c=s.indexOf(E,2);c===-1?(a=s.substring(2),s=E):(a=s.substring(2,c),s=s.substring(c)||E)}return new S("file",a,s,I,I)}static from(s){const a=new S(s.scheme,s.authority,s.path,s.query,s.fragment);return b(a,!0),a}static joinPath(s,...a){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return i.isWindows&&s.scheme==="file"?c=y.file(D.win32.join(u(s,!0),...a)).path:c=D.posix.join(s.path,...a),s.with({path:c})}toString(s=!1){return g(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof y)return s;{const a=new S(s);return a._formatted=s.external,a._fsPath=s._sep===d?s.fsPath:null,a}}else return s}}e.URI=y;const d=i.isWindows?1:void 0;class S extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(s=!1){return s?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=d),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(t,s){let a,c=-1;for(let o=0;o<t.length;o++){const l=t.charCodeAt(o);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||s&&l===47)c!==-1&&(a+=encodeURIComponent(t.substring(c,o)),c=-1),a!==void 0&&(a+=t.charAt(o));else{a===void 0&&(a=t.substr(0,o));const f=w[l];f!==void 0?(c!==-1&&(a+=encodeURIComponent(t.substring(c,o)),c=-1),a+=f):c===-1&&(c=o)}}return c!==-1&&(a+=encodeURIComponent(t.substring(c))),a!==void 0?a:t}function m(t){let s;for(let a=0;a<t.length;a++){const c=t.charCodeAt(a);c===35||c===63?(s===void 0&&(s=t.substr(0,a)),s+=w[c]):s!==void 0&&(s+=t[a])}return s!==void 0?s:t}function u(t,s){let a;return t.authority&&t.path.length>1&&t.scheme==="file"?a=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?s?a=t.path.substr(1):a=t.path[1].toLowerCase()+t.path.substr(2):a=t.path,i.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=u;function g(t,s){const a=s?m:p;let c="",{scheme:o,authority:l,path:f,query:P,fragment:U}=t;if(o&&(c+=o,c+=":"),(l||o==="file")&&(c+=E,c+=E),l){let _=l.indexOf("@");if(_!==-1){const F=l.substr(0,_);l=l.substr(_+1),_=F.indexOf(":"),_===-1?c+=a(F,!1):(c+=a(F.substr(0,_),!1),c+=":",c+=a(F.substr(_+1),!1)),c+="@"}l=l.toLowerCase(),_=l.indexOf(":"),_===-1?c+=a(l,!1):(c+=a(l.substr(0,_),!1),c+=l.substr(_))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const _=f.charCodeAt(1);_>=65&&_<=90&&(f=`/${String.fromCharCode(_+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const _=f.charCodeAt(0);_>=65&&_<=90&&(f=`${String.fromCharCode(_+32)}:${f.substr(2)}`)}c+=a(f,!0)}return P&&(c+="?",c+=a(P,!1)),U&&(c+="#",c+=s?U:p(U,!1)),c}function h(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+h(t.substr(3)):t}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(t){return t.match(r)?t.replace(r,s=>h(s)):t}}),define(ne[127],re([0,1,7]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(R){const I=R;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=i;function k(R){const I=[];let E;try{const v=JSON.parse(R.arguments),y=v[v.length-1];y&&y.__$stack&&(v.pop(),E=y.__$stack),I.push(...v)}catch{I.push("Unable to log remote console arguments",R.arguments)}return{args:I,stack:E}}e.parse=k;function L(R){if(typeof R!="string")return L(k(R).stack);const I=R;if(I){const E=A(I),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(v&&v.length===4)return{uri:D.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=L;function A(R){if(!R)return R;const I=R.indexOf(`
`);return I===-1?R:R.substring(0,I)}function b(R,I){const{args:E,stack:v}=k(R),y=typeof E[0]=="string"&&E.length===1;let d=A(v);d&&(d=`(${d.trim()})`);let S=[];if(typeof E[0]=="string"?d&&y?S=[`%c[${I}] %c${E[0]} %c${d}`,C("blue"),C(""),C("grey")]:S=[`%c[${I}] %c${E[0]}`,C("blue"),C(""),...E.slice(1)]:S=[`%c[${I}]%`,C("blue"),...E],d&&!y&&S.push(d),typeof console[R.severity]!="function")throw new Error("Unknown console method");console[R.severity].apply(console,S)}e.log=b;function C(R){return`color: ${R}`}}),define(ne[63],re([0,1,16,26,7]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(R){return JSON.stringify(R,b)}e.stringify=L;function A(R){let I=JSON.parse(R);return I=C(I),I}e.parse=A;function b(R,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,i.regExpFlags)(I)}:I}function C(R,I=0){if(!R||I>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return k.URI.revive(R);case 2:return new RegExp(R.source,R.flags);case 14:return new Date(R.source)}if(R instanceof D.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let E=0;E<R.length;++E)R[E]=C(R[E],I+1);else for(const E in R)Object.hasOwnProperty.call(R,E)&&(R[E]=C(R[E],I+1))}return R}e.revive=C}),define(ne[20],re([0,1,4,7]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}setServerRootPath(C){this._remoteResourcesPath=`${C}/${k.vscodeRemoteResource}`}set(C,R,I){this._hosts[C]=R,this._ports[C]=I}setConnectionToken(C,R){this._connectionTokens[C]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(C){if(this._delegate)return this._delegate(C);const R=C.authority;let I=this._hosts[R];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const E=this._ports[R],v=this._connectionTokens[R];let y=`path=${encodeURIComponent(C.path)}`;return typeof v=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),i.URI.from({scheme:D.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${I}:${E}`,path:this._remoteResourcesPath,query:y})}}e.RemoteAuthorities=new L;class A{asBrowserUri(C,R){const I=this.toUri(C,R);return I.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===k.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${k.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?I.with({scheme:k.vscodeFileResource,authority:I.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(C,R){const I=this.toUri(C,R);return I.scheme===k.vscodeFileResource?I.with({scheme:k.file,authority:I.authority!==A.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(C,R){return i.URI.isUri(C)?C:i.URI.parse(R.toUrl(C))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(ne[17],re([0,1,42,20,12,4,26,7]),function(X,e,D,i,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(y){return(0,b.uriToFsPath)(y,!0)}e.originalFSPath=C;class R{constructor(d){this._ignorePathCasing=d}compare(d,S,w=!1){return d===S?0:(0,A.compare)(this.getComparisonKey(d,w),this.getComparisonKey(S,w))}isEqual(d,S,w=!1){return d===S?!0:!d||!S?!1:this.getComparisonKey(d,w)===this.getComparisonKey(S,w)}getComparisonKey(d,S=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,S,w=!1){if(d.scheme===S.scheme){if(d.scheme===i.Schemas.file)return D.isEqualOrParent(C(d),C(S),this._ignorePathCasing(d))&&d.query===S.query&&(w||d.fragment===S.fragment);if((0,e.isEqualAuthority)(d.authority,S.authority))return D.isEqualOrParent(d.path,S.path,this._ignorePathCasing(d),"/")&&d.query===S.query&&(w||d.fragment===S.fragment)}return!1}joinPath(d,...S){return b.URI.joinPath(d,...S)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let S;return d.scheme===i.Schemas.file?S=b.URI.file(k.dirname(C(d))).path:(S=k.posix.dirname(d.path),d.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),S="/")),d.with({path:S})}normalizePath(d){if(!d.path.length)return d;let S;return d.scheme===i.Schemas.file?S=b.URI.file(k.normalize(C(d))).path:S=k.posix.normalize(d.path),d.with({path:S})}relativePath(d,S){if(d.scheme!==S.scheme||!(0,e.isEqualAuthority)(d.authority,S.authority))return;if(d.scheme===i.Schemas.file){const m=k.relative(C(d),C(S));return L.isWindows?D.toSlashes(m):m}let w=d.path||"/";const p=S.path||"/";if(this._ignorePathCasing(d)){let m=0;for(const u=Math.min(w.length,p.length);m<u&&!(w.charCodeAt(m)!==p.charCodeAt(m)&&w.charAt(m).toLowerCase()!==p.charAt(m).toLowerCase());m++);w=p.substr(0,m)+w.substr(m)}return k.posix.relative(w,p)}resolvePath(d,S){if(d.scheme===i.Schemas.file){const w=b.URI.file(k.resolve(C(d),S));return d.with({authority:w.authority,path:w.path})}return S=D.toPosixPath(S),d.with({path:k.posix.resolve(d.path,S)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,S){return d===S||d!==void 0&&S!==void 0&&(0,A.equalsIgnoreCase)(d,S)}hasTrailingPathSeparator(d,S=k.sep){if(d.scheme===i.Schemas.file){const w=C(d);return w.length>D.getRoot(w).length&&w[w.length-1]===S}else{const w=d.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,S=k.sep){return(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,S=k.sep){let w=!1;if(d.scheme===i.Schemas.file){const p=C(d);w=p!==void 0&&p.length===D.getRoot(p).length&&p[p.length-1]===S}else{S="/";const p=d.path;w=p.length===1&&p.charCodeAt(p.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path+"/"}):d}}e.ExtUri=R,e.extUri=new R(()=>!1),e.extUriBiasedIgnorePathCase=new R(y=>y.scheme===i.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new R(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(y,d){const S=[];for(let w=0;w<y.length;w++){const p=d(y[w]);y.some((m,u)=>u===w?!1:(0,e.isEqualOrParent)(p,d(m)))||S.push(y[w])}return S}e.distinctParents=I;var E;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(S){const w=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(u=>{const[g,h]=u.split(":");g&&h&&w.set(g,h)});const m=S.path.substring(0,S.path.indexOf(";"));return m&&w.set(y.META_DATA_MIME,m),w}y.parseMetaData=d})(E=e.DataUri||(e.DataUri={}));function v(y,d,S){if(d){let w=y.path;return w&&w[0]!==k.posix.sep&&(w=k.posix.sep+w),y.with({scheme:S,authority:d,path:w})}return y.with({scheme:S})}e.toLocalResource=v}),define(ne[6],re([0,1,21,9,3,2,17,4]),function(X,e,D,i,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(x){return!!x&&typeof x.then=="function"}e.isThenable=C;function R(x){const O=new D.CancellationTokenSource,M=x(O.token),q=new Promise((j,Z)=>{const G=O.token.onCancellationRequested(()=>{G.dispose(),O.dispose(),Z(new i.CancellationError)});Promise.resolve(M).then(te=>{G.dispose(),O.dispose(),j(te)},te=>{G.dispose(),O.dispose(),Z(te)})});return new class{cancel(){O.cancel()}then(j,Z){return q.then(j,Z)}catch(j){return this.then(void 0,j)}finally(j){return q.finally(j)}}}e.createCancelablePromise=R;function I(x,O,M){return new Promise((q,j)=>{const Z=O.onCancellationRequested(()=>{Z.dispose(),q(M)});x.then(q,j).finally(()=>Z.dispose())})}e.raceCancellation=I;function E(x,O){return new Promise((M,q)=>{const j=O.onCancellationRequested(()=>{j.dispose(),q(new i.CancellationError)});x.then(M,q).finally(()=>j.dispose())})}e.raceCancellationError=E;async function v(x){let O=-1;const M=x.map((j,Z)=>j.then(G=>(O=Z,G))),q=await Promise.race(M);return x.forEach((j,Z)=>{Z!==O&&j.cancel()}),q}e.raceCancellablePromises=v;function y(x,O,M){let q;const j=setTimeout(()=>{q?.(void 0),M?.()},O);return Promise.race([x.finally(()=>clearTimeout(j)),new Promise(Z=>q=Z)])}e.raceTimeout=y;function d(x){return new Promise((O,M)=>{const q=x();C(q)?q.then(O,M):O(q)})}e.asPromise=d;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(M,M).then(q)})}return new Promise((M,q)=>{this.queuedPromise.then(M,q)})}return this.activePromise=O(),new Promise((M,q)=>{this.activePromise.then(j=>{this.activePromise=null,M(j)},j=>{this.activePromise=null,q(j)})})}}e.Throttler=S;class w{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=w;class p{constructor(){this.promiseMap=new Map}queue(O,M){const j=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(O)===j&&this.promiseMap.delete(O)});return this.promiseMap.set(O,j),j}}e.SequencerByKey=p;const m=(x,O)=>{let M=!0;const q=setTimeout(()=>{M=!1,O()},x);return{isTriggered:()=>M,dispose:()=>{clearTimeout(q),M=!1}}},u=x=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,x())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(O){this.defaultDelay=O,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,M=this.defaultDelay){this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Z)=>{this.doResolve=j,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}}));const q=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=M===e.MicrotaskDelay?u(q):m(M,q),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=g;class h{constructor(O){this.delayer=new g(O),this.throttler=new S}trigger(O,M){return this.delayer.trigger(()=>this.throttler.queue(O),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=h;class r{constructor(){this._isOpen=!1,this._promise=new Promise((O,M)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class n extends r{constructor(O){super();this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function t(x,O){return O?new Promise((M,q)=>{const j=setTimeout(()=>{Z.dispose(),M()},x),Z=O.onCancellationRequested(()=>{clearTimeout(j),Z.dispose(),q(new i.CancellationError)})}):R(M=>t(x,M))}e.timeout=t;function s(x,O=0){const M=setTimeout(x,O);return(0,L.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=s;function a(x){const O=[];let M=0;const q=x.length;function j(){return M<q?x[M++]():null}function Z(G){G!=null&&O.push(G);const te=j();return te?te.then(Z):Promise.resolve(O)}return Promise.resolve(null).then(Z)}e.sequence=a;function c(x,O=q=>!!q,M=null){let q=0;const j=x.length,Z=()=>{if(q>=j)return Promise.resolve(M);const G=x[q++];return Promise.resolve(G()).then(se=>O(se)?Promise.resolve(se):Z())};return Z()}e.first=c;function o(x,O=q=>!!q,M=null){if(x.length===0)return Promise.resolve(M);let q=x.length;const j=()=>{q=-1;for(const Z of x)Z.cancel?.()};return new Promise((Z,G)=>{for(const te of x)te.then(se=>{--q>=0&&O(se)?(j(),Z(se)):q===0&&Z(M)}).catch(se=>{--q>=0&&(j(),G(se))})})}e.firstParallel=o;class l{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(O){return this._size++,new Promise((M,q)=>{this.outstandingPromises.push({factory:O,c:M,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const M=O.factory();M.then(O.c,O.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class f extends l{constructor(){super(1)}}e.Queue=f;class P{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const O=new H;return this.drainers.add(O),O.p}isDrained(){for(const[,O]of this.queues)if(O.size>0)return!1;return!0}queueFor(O,M=A.extUri){const q=M.getComparisonKey(O);let j=this.queues.get(q);return j||(j=new f,k.Event.once(j.onDrained)(()=>{j?.dispose(),this.queues.delete(q),this.onDidQueueDrain()}),this.queues.set(q,j)),j}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const O of this.drainers)O.complete();this.drainers.clear()}dispose(){for(const[,O]of this.queues)O.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=P;class U{constructor(O,M){this._token=-1,typeof O=="function"&&typeof M=="number"&&this.setIfNotSet(O,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},M)}setIfNotSet(O,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},M))}}e.TimeoutTimer=U;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,M){this.cancel(),this._token=setInterval(()=>{O()},M)}}e.IntervalTimer=_;class F{constructor(O,M){this.timeoutToken=-1,this.runner=O,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=F;class T{constructor(O,M){M%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.runner=O,this.timeout=M,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(O=this.timeout){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(O/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=T;class N extends F{constructor(O,M){super(O,M);this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner?.(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class z extends L.Disposable{constructor(O,M){super();this.options=O,this.handler=M,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.options.maxBufferedWork)return!1}else if(this.pending+O.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...O),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,b.setTimeout0)(()=>{if(O)return;const M=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(x,O)=>{const M=requestIdleCallback(x,typeof O=="number"?{timeout:O}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(M))}}}}();class V{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function J(x,O,M){let q;for(let j=0;j<M;j++)try{return await x()}catch(Z){q=Z,await t(O)}throw q}e.retry=J;class ${hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(O,M,q){return this._pending={taskId:O,cancel:()=>q?.(),promise:M},M.then(()=>this.donePending(O),()=>this.donePending(O)),M}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let M,q;const j=new Promise((Z,G)=>{M=Z,q=G});this._next={run:O,promise:j,promiseResolve:M,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=$;class Q{constructor(O,M=()=>Date.now()){this.interval=O,this.nowFn=M,this.lastIncrementTime=0,this.value=0}increment(){const O=this.nowFn();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;class H{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,M)=>{this.completeCallback=O,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(O){return new Promise(M=>{this.completeCallback(O),this.resolved=!0,M()})}error(O){return new Promise(M=>{this.errorCallback(O),this.rejected=!0,M()})}cancel(){new Promise(O=>{this.errorCallback(new i.CancellationError),this.rejected=!0,O()})}}e.DeferredPromise=H;var B;(function(x){async function O(q){let j;const Z=await Promise.all(q.map(G=>G.then(te=>te,te=>{j||(j=te)})));if(typeof j!="undefined")throw j;return Z}x.settled=O;function M(q){return new Promise(async(j,Z)=>{try{await q(j,Z)}catch(G){Z(G)}})}x.withAsyncBody=M})(B=e.Promises||(e.Promises={}));var Y;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(Y||(Y={}));class ie{constructor(O){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const M={emitOne:q=>this.emitOne(q),emitMany:q=>this.emitMany(q),reject:q=>this.reject(q)};try{await Promise.resolve(O(M)),this.resolve()}catch(q){this.reject(q)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}static fromArray(O){return new ie(M=>{M.emitMany(O)})}static fromPromise(O){return new ie(async M=>{M.emitMany(await O)})}static fromPromises(O){return new ie(async M=>{await Promise.all(O.map(async q=>M.emitOne(await q)))})}static merge(O){return new ie(async M=>{await Promise.all(O.map(async q=>{for await(const j of q)M.emitOne(j)}))})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(O<this._results.length)return{done:!1,value:this._results[O++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(O,M){return new ie(async q=>{for await(const j of O)q.emitOne(M(j))})}map(O){return ie.map(this,O)}static filter(O,M){return new ie(async q=>{for await(const j of O)M(j)&&q.emitOne(j)})}filter(O){return ie.filter(this,O)}static coalesce(O){return ie.filter(O,M=>!!M)}coalesce(){return ie.coalesce(this)}static async toPromise(O){const M=[];for await(const q of O)M.push(q);return M}toPromise(){return ie.toPromise(this)}emitOne(O){this._state===0&&(this._results.push(O),this._onStateChanged.fire())}emitMany(O){this._state===0&&(this._results=this._results.concat(O),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(O){this._state===0&&(this._state=2,this._error=O,this._onStateChanged.fire())}}e.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class ae extends ie{constructor(O,M){super(M);this._source=O}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ae;function W(x){const O=new D.CancellationTokenSource,M=x(O.token);return new ae(O,async q=>{const j=O.token.onCancellationRequested(()=>{j.dispose(),O.dispose(),q.reject(new i.CancellationError)});try{for await(const Z of M){if(O.token.isCancellationRequested)return;q.emitOne(Z)}j.dispose(),O.dispose()}catch(Z){j.dispose(),O.dispose(),q.reject(Z)}})}e.createCancelableAsyncIterable=W}),define(ne[81],re([0,1,18,6,42,34,12,4,26]),function(X,e,D,i,k,L,A,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",E="[^/\\\\]",v=/\//g;function y(H,B){switch(H){case 0:return"";case 1:return`${E}*?`;default:return`(?:${I}|${E}+${I}${B?`|${I}${E}+`:""})*?`}}function d(H,B){if(!H)return[];const Y=[];let ie=!1,ae=!1,W="";for(const x of H){switch(x){case B:if(!ie&&!ae){Y.push(W),W="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}W+=x}return W&&Y.push(W),Y}e.splitGlobAware=d;function S(H){if(!H)return"";let B="";const Y=d(H,e.GLOB_SPLIT);if(Y.every(ie=>ie===e.GLOBSTAR))B=".*";else{let ie=!1;Y.forEach((ae,W)=>{if(ae===e.GLOBSTAR){if(ie)return;B+=y(2,W===Y.length-1)}else{let x=!1,O="",M=!1,q="";for(const j of ae){if(j!=="}"&&x){O+=j;continue}if(M&&(j!=="]"||!q)){let Z;j==="-"?Z=j:(j==="^"||j==="!")&&!q?Z="^":j===e.GLOB_SPLIT?Z="":Z=(0,C.escapeRegExpCharacters)(j),q+=Z;continue}switch(j){case"{":x=!0;continue;case"[":M=!0;continue;case"}":{B+=`(?:${d(O,",").map(te=>S(te)).join("|")})`,x=!1,O="";break}case"]":{B+="["+q+"]",M=!1,q="";break}case"?":B+=E;continue;case"*":B+=y(1);continue;default:B+=(0,C.escapeRegExpCharacters)(j)}}W<Y.length-1&&(Y[W+1]!==e.GLOBSTAR||W+2<Y.length)&&(B+=I)}ie=ae===e.GLOBSTAR})}return B}const w=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new L.LRUCache(1e4),n=function(){return!1},t=function(){return null};function s(H,B){if(!H)return t;let Y;typeof H!="string"?Y=H.pattern:Y=H,Y=Y.trim();const ie=`${Y}_${!!B.trimForExclusions}`;let ae=r.get(ie);if(ae)return a(ae,H);let W;return w.test(Y)?ae=o(Y.substr(4),Y):(W=p.exec(c(Y,B)))?ae=l(W[1],Y):(B.trimForExclusions?u:m).test(Y)?ae=f(Y,B):(W=g.exec(c(Y,B)))?ae=P(W[1].substr(1),Y,!0):(W=h.exec(c(Y,B)))?ae=P(W[1],Y,!1):ae=U(Y),r.set(ie,ae),a(ae,H)}function a(H,B){if(typeof B=="string")return H;const Y=function(ie,ae){return(0,k.isEqualOrParent)(ie,B.base,!b.isLinux)?H(ie.substr(B.base.length+1),ae):null};return Y.allBasenames=H.allBasenames,Y.allPaths=H.allPaths,Y.basenames=H.basenames,Y.patterns=H.patterns,Y}function c(H,B){return B.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function o(H,B){return function(Y,ie){return typeof Y=="string"&&Y.endsWith(H)?B:null}}function l(H,B){const Y=`/${H}`,ie=`\\${H}`,ae=function(x,O){return typeof x!="string"?null:O?O===H?B:null:x===H||x.endsWith(Y)||x.endsWith(ie)?B:null},W=[H];return ae.basenames=W,ae.patterns=[B],ae.allBasenames=W,ae}function f(H,B){const Y=$(H.slice(1,-1).split(",").map(O=>s(O,B)).filter(O=>O!==t),H),ie=Y.length;if(!ie)return t;if(ie===1)return Y[0];const ae=function(O,M){for(let q=0,j=Y.length;q<j;q++)if(Y[q](O,M))return H;return null},W=Y.find(O=>!!O.allBasenames);W&&(ae.allBasenames=W.allBasenames);const x=Y.reduce((O,M)=>M.allPaths?O.concat(M.allPaths):O,[]);return x.length&&(ae.allPaths=x),ae}function P(H,B,Y){const ie=A.sep===A.posix.sep,ae=ie?H:H.replace(v,A.sep),W=A.sep+ae,x=A.posix.sep+H;let O;return Y?O=function(M,q){return typeof M=="string"&&(M===ae||M.endsWith(W)||!ie&&(M===H||M.endsWith(x)))?B:null}:O=function(M,q){return typeof M=="string"&&(M===ae||!ie&&M===H)?B:null},O.allPaths=[(Y?"*/":"./")+H],O}function U(H){try{const B=new RegExp(`^${S(H)}$`);return function(Y){return B.lastIndex=0,typeof Y=="string"&&B.test(Y)?H:null}}catch{return t}}function _(H,B,Y){return!H||typeof B!="string"?!1:F(H)(B,void 0,Y)}e.match=_;function F(H,B={}){if(!H)return n;if(typeof H=="string"||T(H)){const Y=s(H,B);if(Y===t)return n;const ie=function(ae,W){return!!Y(ae,W)};return Y.allBasenames&&(ie.allBasenames=Y.allBasenames),Y.allPaths&&(ie.allPaths=Y.allPaths),ie}return V(H,B)}e.parse=F;function T(H){const B=H;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=T;function N(H){return H.allBasenames||[]}e.getBasenameTerms=N;function z(H){return H.allPaths||[]}e.getPathTerms=z;function V(H,B){const Y=$(Object.getOwnPropertyNames(H).map(O=>J(O,H[O],B)).filter(O=>O!==t)),ie=Y.length;if(!ie)return t;if(!Y.some(O=>!!O.requiresSiblings)){if(ie===1)return Y[0];const O=function(j,Z){let G;for(let te=0,se=Y.length;te<se;te++){const ce=Y[te](j,Z);if(typeof ce=="string")return ce;(0,i.isThenable)(ce)&&(G||(G=[]),G.push(ce))}return G?(async()=>{for(const te of G){const se=await te;if(typeof se=="string")return se}return null})():null},M=Y.find(j=>!!j.allBasenames);M&&(O.allBasenames=M.allBasenames);const q=Y.reduce((j,Z)=>Z.allPaths?j.concat(Z.allPaths):j,[]);return q.length&&(O.allPaths=q),O}const ae=function(O,M,q){let j,Z;for(let G=0,te=Y.length;G<te;G++){const se=Y[G];se.requiresSiblings&&q&&(M||(M=(0,A.basename)(O)),j||(j=M.substr(0,M.length-(0,A.extname)(O).length)));const ce=se(O,M,j,q);if(typeof ce=="string")return ce;(0,i.isThenable)(ce)&&(Z||(Z=[]),Z.push(ce))}return Z?(async()=>{for(const G of Z){const te=await G;if(typeof te=="string")return te}return null})():null},W=Y.find(O=>!!O.allBasenames);W&&(ae.allBasenames=W.allBasenames);const x=Y.reduce((O,M)=>M.allPaths?O.concat(M.allPaths):O,[]);return x.length&&(ae.allPaths=x),ae}function J(H,B,Y){if(B===!1)return t;const ie=s(H,Y);if(ie===t)return t;if(typeof B=="boolean")return ie;if(B){const ae=B.when;if(typeof ae=="string"){const W=(x,O,M,q)=>{if(!q||!ie(x,O))return null;const j=ae.replace("$(basename)",M),Z=q(j);return(0,i.isThenable)(Z)?Z.then(G=>G?H:null):Z?H:null};return W.requiresSiblings=!0,W}}return ie}function $(H,B){const Y=H.filter(O=>!!O.basenames);if(Y.length<2)return H;const ie=Y.reduce((O,M)=>{const q=M.basenames;return q?O.concat(q):O},[]);let ae;if(B){ae=[];for(let O=0,M=ie.length;O<M;O++)ae.push(B)}else ae=Y.reduce((O,M)=>{const q=M.patterns;return q?O.concat(q):O},[]);const W=function(O,M){if(typeof O!="string")return null;if(!M){let j;for(j=O.length;j>0;j--){const Z=O.charCodeAt(j-1);if(Z===47||Z===92)break}M=O.substr(j)}const q=ie.indexOf(M);return q!==-1?ae[q]:null};W.basenames=ie,W.patterns=ae,W.allBasenames=ie;const x=H.filter(O=>!O.basenames);return x.push(W),x}function Q(H,B){return(0,D.equals)(H,B,(Y,ie)=>typeof Y=="string"&&typeof ie=="string"?Y===ie:typeof Y!="string"&&typeof ie!="string"?Y.base===ie.base&&Y.pattern===ie.pattern:!1)}e.patternsEquals=Q}),define(ne[128],re([0,1,7]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(I){return I.toJSON()}class k{constructor(E){this._uriTransformer=E}transformIncoming(E){const v=this._uriTransformer.transformIncoming(E);return v===E?E:i(D.URI.from(v))}transformOutgoing(E){const v=this._uriTransformer.transformOutgoing(E);return v===E?E:i(D.URI.from(v))}transformOutgoingURI(E){const v=this._uriTransformer.transformOutgoing(E);return v===E?E:D.URI.from(v)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function L(I,E,v){if(!I||v>200)return null;if(typeof I=="object"){if(I instanceof D.URI)return E.transformOutgoing(I);for(const y in I)if(Object.hasOwnProperty.call(I,y)){const d=L(I[y],E,v+1);d!==null&&(I[y]=d)}}return null}function A(I,E){const v=L(I,E,0);return v===null?I:v}e.transformOutgoingURIs=A;function b(I,E,v,y){if(!I||y>200)return null;if(typeof I=="object"){if(I.$mid===1)return v?D.URI.revive(E.transformIncoming(I)):E.transformIncoming(I);for(const d in I)if(Object.hasOwnProperty.call(I,d)){const S=b(I[d],E,v,y+1);S!==null&&(I[d]=S)}}return null}function C(I,E){const v=b(I,E,!1,0);return v===null?I:v}e.transformIncomingURIs=C;function R(I,E){const v=b(I,E,!0,0);return v===null?I:v}e.transformAndReviveIncomingURIs=R}),define(ne[129],re([0,1,37,9,34,31,115]),function(X,e,D,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,E=0;const v=(0,D.networkInterfaces)();for(const y in v){const d=v[y];if(d)for(const{mac:S,internal:w}of d)w||(E+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(I+=1))}this._value=E>0?I/E:0}return this._value}};let b;async function C(){return b||(b=(async()=>await R()||L.generateUuid())()),b}e.getMachineId=C;async function R(){try{const I=await new Promise((v,y)=>{X(["crypto"],v,y)}),E=(0,A.getMac)();return I.createHash("sha256").update(E,"utf8").digest("hex")}catch(I){i.onUnexpectedError(I);return}}}),define(ne[27],re([0,1,54,37,270,6,42,79,12,4,17,7]),function(X,e,D,i,k,L,A,b,C,R,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function y(V,J=v.UNLINK){if((0,A.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");return J===v.UNLINK?S(V):d(V)}async function d(V){try{const J=(0,A.randomPath)((0,i.tmpdir)());try{await D.promises.rename(V,J)}catch{return S(V)}S(J).catch($=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function S(V){return(0,k.promisify)(D.rm)(V,{recursive:!0,force:!0,maxRetries:3})}function w(V){if((0,A.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function p(V,J){return g(await(J?m(V):(0,k.promisify)(D.readdir)(V)))}async function m(V){try{return await(0,k.promisify)(D.readdir)(V,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const J=[],$=await p(V);for(const Q of $){let H=!1,B=!1,Y=!1;try{const ie=await e.Promises.lstat((0,C.join)(V,Q));H=ie.isFile(),B=ie.isDirectory(),Y=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}J.push({name:Q,isFile:()=>H,isDirectory:()=>B,isSymbolicLink:()=>Y})}return J}function u(V){return g(D.readdirSync(V))}e.readdirSync=u;function g(V){return V.map(J=>typeof J=="string"?R.isMacintosh?(0,b.normalizeNFC)(J):J:(J.name=R.isMacintosh?(0,b.normalizeNFC)(J.name):J.name,J))}async function h(V){const J=await p(V),$=[];for(const Q of J)await n.existsDirectory((0,C.join)(V,Q))&&$.push(Q);return $}function r(V,J=1e3){return new Promise($=>{let Q=!1;const H=setInterval(()=>{Q||(Q=!0,D.access(V,B=>{Q=!1,B&&(clearInterval(H),$(void 0))}))},J)})}e.whenDeleted=r;var n;(function(V){async function J(H){let B;try{if(B=await e.Promises.lstat(H),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(R.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ie}throw Y}}V.stat=J;async function $(H){try{const{stat:B,symbolicLink:Y}=await V.stat(H);return B.isFile()&&Y?.dangling!==!0}catch{}return!1}V.existsFile=$;async function Q(H){try{const{stat:B,symbolicLink:Y}=await V.stat(H);return B.isDirectory()&&Y?.dangling!==!0}catch{}return!1}V.existsDirectory=Q})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new L.ResourceQueue;function s(V,J,$){return t.queueFor(E.URI.file(V),I.extUriBiasedIgnorePathCase).queue(()=>{const Q=f($);return new Promise((H,B)=>o(V,J,Q,Y=>Y?B(Y):H()))})}let a=!0;function c(V){a=V}e.configureFlushOnWrite=c;function o(V,J,$,Q){if(!a)return D.writeFile(V,J,{mode:$.mode,flag:$.flag},Q);D.open(V,$.flag,$.mode,(H,B)=>{if(H)return Q(H);D.writeFile(B,J,Y=>{if(Y)return D.close(B,()=>Q(Y));D.fdatasync(B,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),c(!1)),D.close(B,ae=>Q(ae))))})})}function l(V,J,$){const Q=f($);if(!a)return D.writeFileSync(V,J,{mode:Q.mode,flag:Q.flag});const H=D.openSync(V,Q.flag,Q.mode);try{D.writeFileSync(H,J);try{D.fdatasyncSync(H)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),c(!1)}}finally{D.closeSync(H)}}e.writeFileSync=l;function f(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function P(V,J){if(V!==J)try{await e.Promises.rename(V,J)}catch($){if(V.toLowerCase()!==J.toLowerCase()&&$.code==="EXDEV"||V.endsWith("."))await U(V,J,{preserveSymlinks:!1}),await y(V,v.MOVE);else throw $}}async function U(V,J,$){return F(V,J,{root:{source:V,target:J},options:$,handledSourcePaths:new Set})}const _=511;async function F(V,J,$){if($.handledSourcePaths.has(V))return;$.handledSourcePaths.add(V);const{stat:Q,symbolicLink:H}=await n.stat(V);if(H){if($.options.preserveSymlinks)try{return await z(V,J,$)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(H.dangling)return}return Q.isDirectory()?T(V,J,Q.mode&_,$):N(V,J,Q.mode&_)}async function T(V,J,$,Q){await e.Promises.mkdir(J,{recursive:!0,mode:$});const H=await p(V);for(const B of H)await F((0,C.join)(V,B),(0,C.join)(J,B),Q)}async function N(V,J,$){await e.Promises.copyFile(V,J),await e.Promises.chmod(J,$)}async function z(V,J,$){let Q=await e.Promises.readlink(V);(0,A.isEqualOrParent)(Q,$.root.source,!R.isLinux)&&(Q=(0,C.join)($.root.target,Q.substr($.root.source.length+1))),await e.Promises.symlink(Q,J)}e.Promises=new class{get access(){return(0,k.promisify)(D.access)}get stat(){return(0,k.promisify)(D.stat)}get lstat(){return(0,k.promisify)(D.lstat)}get utimes(){return(0,k.promisify)(D.utimes)}get read(){return(V,J,$,Q,H)=>new Promise((B,Y)=>{D.read(V,J,$,Q,H,(ie,ae,W)=>ie?Y(ie):B({bytesRead:ae,buffer:W}))})}get readFile(){return(0,k.promisify)(D.readFile)}get write(){return(V,J,$,Q,H)=>new Promise((B,Y)=>{D.write(V,J,$,Q,H,(ie,ae,W)=>ie?Y(ie):B({bytesWritten:ae,buffer:W}))})}get appendFile(){return(0,k.promisify)(D.appendFile)}get fdatasync(){return(0,k.promisify)(D.fdatasync)}get truncate(){return(0,k.promisify)(D.truncate)}get rename(){return(0,k.promisify)(D.rename)}get copyFile(){return(0,k.promisify)(D.copyFile)}get open(){return(0,k.promisify)(D.open)}get close(){return(0,k.promisify)(D.close)}get symlink(){return(0,k.promisify)(D.symlink)}get readlink(){return(0,k.promisify)(D.readlink)}get chmod(){return(0,k.promisify)(D.chmod)}get mkdir(){return(0,k.promisify)(D.mkdir)}get unlink(){return(0,k.promisify)(D.unlink)}get rmdir(){return(0,k.promisify)(D.rmdir)}get realpath(){return(0,k.promisify)(D.realpath)}async exists(V){try{return await e.Promises.access(V),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return h}get writeFile(){return s}get rm(){return y}get move(){return P}get copy(){return U}}}),define(ne[130],re([0,1,54,12,4,26,27]),function(X,e,D,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function b(v){if(k.isLinux)return v;const y=(0,i.dirname)(v);if(v===y)return v;const d=((0,i.basename)(v)||v).toLowerCase();try{const w=(0,A.readdirSync)(y).filter(p=>p.toLowerCase()===d);if(w.length===1){const p=b(y);if(p)return(0,i.join)(p,w[0])}else if(w.length>1){const p=w.indexOf(d);if(p>=0){const m=b(y);if(m)return(0,i.join)(m,w[p])}}}catch{}return null}e.realcaseSync=b;async function C(v){if(k.isLinux)return v;const y=(0,i.dirname)(v);if(v===y)return v;const d=((0,i.basename)(v)||v).toLowerCase();try{const w=(await A.Promises.readdir(y)).filter(p=>p.toLowerCase()===d);if(w.length===1){const p=await C(y);if(p)return(0,i.join)(p,w[0])}else if(w.length>1){const p=w.indexOf(d);if(p>=0){const m=await C(y);if(m)return(0,i.join)(m,w[p])}}}catch{}return null}e.realcase=C;async function R(v){try{return await A.Promises.realpath(v)}catch{const d=E(v);return await A.Promises.access(d,D.constants.R_OK),d}}e.realpath=R;function I(v){try{return D.realpathSync(v)}catch{const d=E(v);return D.accessSync(d,D.constants.R_OK),d}}e.realpathSync=I;function E(v){return(0,L.rtrim)((0,i.normalize)(v),i.sep)}}),define(ne[82],re([0,1,37,12,27]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,A=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var C;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(C||(C={}));let R;switch(process.arch){case"ia32":case"x32":R=1;break;case"arm":case"arm64":R=2;break;default:R=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class E{constructor(h,r,n){this.exePath=h,this.displayName=r,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:g=!1}={}){return g?R===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:g=!1,findPreview:h=!1}={}){const r=v({useAlternateBitness:g});if(!r)return null;const n=i.join(r,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(n))return null;let t=-1,s=null;for(const o of await k.Promises.readdir(n)){let l=-1;if(h){const P=o.indexOf("-");if(P<0)continue;const U=o.substring(0,P);if(!L.test(U)||o.substring(P+1)!=="preview")continue;l=parseInt(U,10)}else{if(!L.test(o))continue;l=parseInt(o,10)}if(l<=t)continue;const f=i.join(n,o,"pwsh.exe");!await k.SymlinkSupport.existsFile(f)||(s=f,t=l)}if(!s)return null;const a=r.includes("x86")?" (x86)":"",c=h?" Preview":"";return new E(s,`PowerShell${c}${a}`,!0)}async function d({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const h=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:r,pwshMsixName:n}=g?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(h))if(r.test(t)){const s=i.join(h,t,"pwsh.exe");return new E(s,n)}return null}function S(){const g=i.join(D.homedir(),".dotnet","tools","pwsh.exe");return new E(g,".NET Core PowerShell Global Tool")}function w(){const g=i.join(process.env.windir,R===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(g,"Windows PowerShell",!0)}async function*p(){let g=await y();g&&(yield g),g=await y({useAlternateBitness:!0}),g&&(yield g),g=await d(),g&&(yield g),g=S(),g&&(yield g),g=await y({findPreview:!0}),g&&(yield g),g=await d({findPreview:!0}),g&&(yield g),g=await y({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=w(),g&&(yield g)}async function*m(){for await(const g of p())await g.exists()&&(yield g)}e.enumeratePowerShellInstallations=m;async function u(){for await(const g of m())return g;return null}e.getFirstAvailablePowerShellInstallation=u}),define(ne[131],re([0,1,48,20]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(A){return new Promise((b,C)=>{let R;const I=new Map;function E(y,d,S,w,p){const m=I.get(d);if(y===A||m){const u={name:v(S),cmd:S,pid:y,ppid:d,load:w,mem:p};I.set(y,u),y===A&&(R=u),m&&(m.children||(m.children=[]),m.children.push(u),m.children.length>1&&(m.children=m.children.sort((g,h)=>g.pid-h.pid)))}}function v(y){const d=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,w=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,u=/--crashes-directory/,g=/\\pipe\\winpty-control/,h=/conhost\.exe/,r=/--type=([a-zA-Z-]+)/;if(u.exec(y))return"electron-crash-reporter";if(g.exec(y))return"winpty-process";if(h.exec(y))return"console-window-host (Windows internal process)";let n=r.exec(y);if(n&&n.length===2){if(n[1]==="renderer")return d.exec(y)?"shared-process":S.exec(y)?"issue-reporter":w.exec(y)?"process-explorer":"window";if(n[1]==="utility"){if(p.exec(y))return"utility-network-service";if(m.exec(y))return"extension-host"}return n[1]}const t=/[a-zA-Z-]+\.js/g;let s="";do n=t.exec(y),n&&(s+=n+" ");while(n);return s&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${s}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,S)=>{X(["windows-process-tree"],d,S)}).then(d=>{d.getProcessList(A,S=>{if(!S){C(new Error(`Root process ${A} not found`));return}d.getProcessCpuUsage(S,w=>{const p=new Map;w.forEach(m=>{const u=y(m.commandLine||"");p.set(m.pid,{name:v(u),cmd:u,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),R=p.get(A),R?(p.forEach(m=>{const u=p.get(m.ppid);u&&(u.children||(u.children=[]),u.children.push(m))}),p.forEach(m=>{m.children&&(m.children=m.children.sort((u,g)=>u.pid-g.pid))}),b(R)):C(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[R];const S=[];for(;d.length;){const p=d.shift();p&&(S.push(p.pid),p.children&&(d=d.concat(p.children)))}let w=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",X).fsPath);w+=" "+S.join(" "),(0,D.exec)(w,{},(p,m,u)=>{if(p||u)C(p||new Error(u.toString()));else{const g=m.toString().split(`
`);for(let h=0;h<S.length;h++){const r=I.get(S[h]);r.load=parseFloat(g[h])}if(!R){C(new Error(`Root process ${A} not found`));return}b(R)}})};(0,D.exec)("which ps",{},(d,S,w)=>{if(d||w)if(process.platform!=="linux")C(d||new Error(w.toString()));else{const p=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh",X).fsPath);(0,D.exec)(p,{},(m,u,g)=>{m||g?C(m||new Error(g.toString())):(L(u,E),y())})}else{const p=S.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${p} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,g,h)=>{u||h&&!h.includes("screen size is bogus")?C(u||new Error(h.toString())):(L(g,E),process.platform==="linux"?y():R?b(R):C(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=k;function L(A,b){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,R=A.toString().split(`
`);for(const I of R){const E=C.exec(I.trim());E&&E.length===6&&b(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var ge=this&&this.__decorate||function(X,e,D,i){var k=arguments.length,L=k<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,D):i,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(X,e,D,i);else for(var b=X.length-1;b>=0;b--)(A=X[b])&&(L=(k<3?A(L):k>3?A(e,D,L):A(e,D))||L);return k>3&&L&&Object.defineProperty(e,D,L),L};define(ne[39],re([0,1,18,6,16,21,60,9,3,2,63,26,14]),function(X,e,D,i,k,L,A,b,C,R,I,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function w(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(p||(p={}));class m{constructor(B){this.buffer=B,this.pos=0}read(B){const Y=this.buffer.slice(this.pos,this.pos+B);return this.pos+=Y.byteLength,Y}}class u{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}var g;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(g||(g={}));function h(H){const B=k.VSBuffer.alloc(4);return B.writeUInt32BE(H,0),B}function r(H){return H.read(4).readUInt32BE(0)}function n(H){const B=k.VSBuffer.alloc(1);return B.writeUInt8(H,0),B}const t={Undefined:n(g.Undefined),String:n(g.String),Buffer:n(g.Buffer),VSBuffer:n(g.VSBuffer),Array:n(g.Array),Object:n(g.Object)},s=typeof Buffer!="undefined";function a(H,B){if(typeof B=="undefined")H.write(t.Undefined);else if(typeof B=="string"){const Y=k.VSBuffer.fromString(B);H.write(t.String),H.write(h(Y.byteLength)),H.write(Y)}else if(s&&Buffer.isBuffer(B)){const Y=k.VSBuffer.wrap(B);H.write(t.Buffer),H.write(h(Y.byteLength)),H.write(Y)}else if(B instanceof k.VSBuffer)H.write(t.VSBuffer),H.write(h(B.byteLength)),H.write(B);else if(Array.isArray(B)){H.write(t.Array),H.write(h(B.length));for(const Y of B)a(H,Y)}else{const Y=k.VSBuffer.fromString(JSON.stringify(B));H.write(t.Object),H.write(h(Y.byteLength)),H.write(Y)}}function c(H){switch(H.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return H.read(r(H)).toString();case g.Buffer:return H.read(r(H)).buffer;case g.VSBuffer:return H.read(r(H));case g.Array:{const Y=r(H),ie=[];for(let ae=0;ae<Y;ae++)ie.push(c(H));return ie}case g.Object:return JSON.parse(H.read(r(H)).toString())}}class o{constructor(B,Y,ie=null,ae=1e3){this.protocol=B,this.ctx=Y,this.logger=ie,this.timeoutDelay=ae,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(B,Y){this.channels.set(B,Y),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case 200:{const Y=this.send([B.type]);this.logger?.logOutgoing(Y,0,1,w(B.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([B.type,B.id],B.data);this.logger?.logOutgoing(Y,B.id,1,w(B.type),B.data);return}}}send(B,Y=void 0){const ie=new u;return a(ie,B),a(ie,Y),this.sendBuffer(ie.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onRawMessage(B){const Y=new m(B),ie=c(Y),ae=c(Y),W=ie[0];switch(W){case 100:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${d(W)}: ${ie[2]}.${ie[3]}`,ae),this.onPromise({type:W,id:ie[1],channelName:ie[2],name:ie[3],arg:ae});case 102:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${d(W)}: ${ie[2]}.${ie[3]}`,ae),this.onEventListen({type:W,id:ie[1],channelName:ie[2],name:ie[3],arg:ae});case 101:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${d(W)}`),this.disposeActiveRequest({type:W,id:ie[1]});case 103:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${d(W)}`),this.disposeActiveRequest({type:W,id:ie[1]})}}onPromise(B){const Y=this.channels.get(B.channelName);if(!Y){this.collectPendingRequest(B);return}const ie=new L.CancellationTokenSource;let ae;try{ae=Y.call(this.ctx,B.name,B.arg,ie.token)}catch(O){ae=Promise.reject(O)}const W=B.id;ae.then(O=>{this.sendResponse({id:W,data:O,type:201}),this.activeRequests.delete(B.id)},O=>{O instanceof Error?this.sendResponse({id:W,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:W,data:O,type:203}),this.activeRequests.delete(B.id)});const x=(0,R.toDisposable)(()=>ie.cancel());this.activeRequests.set(B.id,x)}onEventListen(B){const Y=this.channels.get(B.channelName);if(!Y){this.collectPendingRequest(B);return}const ie=B.id,W=Y.listen(this.ctx,B.name,B.arg)(x=>this.sendResponse({id:ie,data:x,type:204}));this.activeRequests.set(B.id,W)}disposeActiveRequest(B){const Y=this.activeRequests.get(B.id);Y&&(Y.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let Y=this.pendingRequests.get(B.channelName);Y||(Y=[],this.pendingRequests.set(B.channelName,Y));const ie=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:B,timeoutTimer:ie})}flushPendingRequests(B){const Y=this.pendingRequests.get(B);if(Y){for(const ie of Y)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.onPromise(ie.request);break;case 102:this.onEventListen(ie.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,R.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=o;var l;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class f{constructor(B,Y=null){this.protocol=B,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ie=>this.onBuffer(ie)),this.logger=Y}getChannel(B){const Y=this;return{call(ie,ae,W){return Y.isDisposed?Promise.reject(b.canceled()):Y.requestPromise(B,ie,ae,W)},listen(ie,ae){return Y.isDisposed?C.Event.None:Y.requestEvent(B,ie,ae)}}}requestPromise(B,Y,ie,ae=L.CancellationToken.None){const W=this.lastRequestId++,O={id:W,type:100,channelName:B,name:Y,arg:ie};if(ae.isCancellationRequested)return Promise.reject(b.canceled());let M;return new Promise((j,Z)=>{if(ae.isCancellationRequested)return Z(b.canceled());const G=()=>{const he=ve=>{switch(ve.type){case 201:this.handlers.delete(W),j(ve.data);break;case 202:{this.handlers.delete(W);const pe=new Error(ve.data.message);pe.stack=ve.data.stack,pe.name=ve.data.name,Z(pe);break}case 203:this.handlers.delete(W),Z(ve.data);break}};this.handlers.set(W,he),this.sendRequest(O)};let te=null;this.state===p.Idle?G():(te=(0,i.createCancelablePromise)(he=>this.whenInitialized()),te.then(()=>{te=null,G()}));const se=()=>{te?(te.cancel(),te=null):this.sendRequest({id:W,type:101}),Z(b.canceled())},ce=ae.onCancellationRequested(se);M=(0,R.combinedDisposable)((0,R.toDisposable)(se),ce),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(B,Y,ie){const ae=this.lastRequestId++,x={id:ae,type:102,channelName:B,name:Y,arg:ie};let O=null;const M=new C.Emitter({onFirstListenerAdd:()=>{O=(0,i.createCancelablePromise)(j=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(M),this.sendRequest(x)})},onLastListenerRemove:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(M),this.sendRequest({id:ae,type:103}))}}),q=j=>M.fire(j.data);return this.handlers.set(ae,q),M.event}sendRequest(B){switch(B.type){case 100:case 102:{const Y=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger?.logOutgoing(Y,B.id,0,`${d(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const Y=this.send([B.type,B.id]);this.logger?.logOutgoing(Y,B.id,0,d(B.type));return}}}send(B,Y=void 0){const ie=new u;return a(ie,B),a(ie,Y),this.sendBuffer(ie.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onBuffer(B){const Y=new m(B),ie=c(Y),ae=c(Y),W=ie[0];switch(W){case 200:return this.logger?.logIncoming(B.byteLength,0,0,w(W)),this.onResponse({type:ie[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(B.byteLength,ie[1],0,w(W),ae),this.onResponse({type:ie[0],id:ie[1],data:ae})}}onResponse(B){if(B.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(B.id)?.(B)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,R.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ge([A.memoize],f.prototype,"onDidInitializePromise",null),e.ChannelClient=f;class P{constructor(B){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,B(({protocol:Y,onDidClientDisconnect:ie})=>{C.Event.once(Y.onMessage)(W=>{const x=new m(W),O=c(x),M=new o(Y,O),q=new f(Y);this.channels.forEach((Z,G)=>M.registerChannel(G,Z));const j={channelServer:M,channelClient:q,ctx:O};this._connections.add(j),this._onDidAddConnection.fire(j),ie(()=>{M.dispose(),q.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const B=[];return this._connections.forEach(Y=>B.push(Y)),B}getChannel(B,Y){const ie=this;return{call(ae,W,x){let O;if((0,v.isFunction)(Y)){const q=(0,D.getRandomElement)(ie.connections.filter(Y));O=q?Promise.resolve(q):C.Event.toPromise(C.Event.filter(ie.onDidAddConnection,Y))}else O=Y.routeCall(ie,ae,W);const M=O.then(q=>q.channelClient.getChannel(B));return _(M).call(ae,W,x)},listen(ae,W){if((0,v.isFunction)(Y))return ie.getMulticastEvent(B,Y,ae,W);const x=Y.routeEvent(ie,ae,W).then(O=>O.channelClient.getChannel(B));return _(x).listen(ae,W)}}}getMulticastEvent(B,Y,ie,ae){const W=this;let x=new R.DisposableStore;const O=new C.Emitter({onFirstListenerAdd:()=>{x=new R.DisposableStore;const M=new C.EventMultiplexer,q=new Map,j=G=>{const se=G.channelClient.getChannel(B).listen(ie,ae),ce=M.add(se);q.set(G,ce)},Z=G=>{const te=q.get(G);!te||(te.dispose(),q.delete(G))};W.connections.filter(Y).forEach(j),C.Event.filter(W.onDidAddConnection,Y)(j,void 0,x),W.onDidRemoveConnection(Z,void 0,x),M.event(O.fire,O,x),x.add(M)},onLastListenerRemove:()=>{x.dispose()}});return O.event}registerChannel(B,Y){this.channels.set(B,Y),this._connections.forEach(ie=>{ie.channelServer.registerChannel(B,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=P;class U{constructor(B,Y,ie=null){const ae=new u;a(ae,Y),B.send(ae.buffer),this.channelClient=new f(B,ie),this.channelServer=new o(B,Y,ie)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,Y){this.channelServer.registerChannel(B,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function _(H){return{call(B,Y,ie){return H.then(ae=>ae.call(B,Y,ie))},listen(B,Y){const ie=new C.Relay;return H.then(ae=>ie.input=ae.listen(B,Y)),ie.event}}}e.getDelayedChannel=_;function F(H){let B=!1;return{call(Y,ie,ae){return B?H.call(Y,ie,ae):(0,i.timeout)(0).then(()=>B=!0).then(()=>H.call(Y,ie,ae))},listen(Y,ie){if(B)return H.listen(Y,ie);const ae=new C.Relay;return(0,i.timeout)(0).then(()=>B=!0).then(()=>ae.input=H.listen(Y,ie)),ae.event}}}e.getNextTickChannel=F;class T{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const Y of B.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await C.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=T;var N;(function(H){function B(W,x){const O=W,M=x&&x.disableMarshalling,q=new Map;for(const j in O)ie(j)&&q.set(j,C.Event.buffer(O[j],!0));return new class{listen(j,Z,G){const te=q.get(Z);if(te)return te;if(ae(Z)){const se=O[Z];if(typeof se=="function")return se.call(O,G)}throw new Error(`Event not found: ${Z}`)}call(j,Z,G){const te=O[Z];if(typeof te=="function"){if(!M&&Array.isArray(G))for(let se=0;se<G.length;se++)G[se]=(0,I.revive)(G[se]);return te.apply(O,G)}throw new Error(`Method not found: ${Z}`)}}}H.fromService=B;function Y(W,x){const O=x&&x.disableMarshalling;return new Proxy({},{get(M,q){if(typeof q=="string")return x?.properties?.has(q)?x.properties.get(q):ae(q)?function(j){return W.listen(q,j)}:ie(q)?W.listen(q):async function(...j){let Z;x&&!(0,v.isUndefinedOrNull)(x.context)?Z=[x.context,...j]:Z=j;const G=await W.call(q,Z);return O?G:(0,I.revive)(G)};throw new Error(`Property not found: ${String(q)}`)}})}H.toService=Y;function ie(W){return W[0]==="o"&&W[1]==="n"&&E.isUpperAsciiLetter(W.charCodeAt(2))}function ae(W){return/^onDynamic/.test(W)&&E.isUpperAsciiLetter(W.charCodeAt(9))}})(N=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const B=H.toString();if(B!=="[object Object]")return B}return H}function J(H){return Array.isArray(H)?H.map(V):V(H)}function $(H,B,Y,ie,ae,W,x){x=J(x);const O=z[ae],M=O[ie%O.length];let q=[`%c[${H}]%c[${String(B).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(W)?(q=q.concat(x),q.push(")")):q.push(x),console.log.apply(console,q)}e.logWithColors=$;class Q{constructor(B,Y){this._outgoingPrefix=B,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,Y,ie,ae,W){this._totalOutgoing+=B,$(this._outgoingPrefix,this._totalOutgoing,B,Y,ie,ae,W)}logIncoming(B,Y,ie,ae,W){this._totalIncoming+=B,$(this._incomingPrefix,this._totalIncoming,B,Y,ie,ae,W)}}e.IPCLogger=Q}),define(ne[132],re([0,1,16,3,39]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(C){this.port=C,this.onMessage=i.Event.fromDOMEventEmitter(this.port,"message",R=>D.VSBuffer.wrap(R.data)),C.start()}send(C){this.port.postMessage(C.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class A extends k.IPCClient{constructor(C,R){const I=new L(C);super(I,R);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=A}),define(ne[83],re([0,1,16,3,2,39]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var b;(function(s){s.enableDiagnostics=!1,s.records=[];const a=new WeakMap;let c=0;function o(f,P){if(!a.has(f)){const U=String(++c);a.set(f,U)}return a.get(f)}function l(f,P,U,_){if(!s.enableDiagnostics)return;const F=o(f,P);if(_ instanceof D.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const T=D.VSBuffer.alloc(_.byteLength);T.set(_),s.records.push({timestamp:Date.now(),id:F,label:P,type:U,buff:T})}else s.records.push({timestamp:Date.now(),id:F,label:P,type:U,data:_})}s.traceSocketEvent=l})(b=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let R=null;function I(){return R||(R=D.VSBuffer.alloc(0)),R}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,c){if(a===0)return I();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const P=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=a),P}if(this._chunks[0].byteLength>a){const P=this._chunks[0].slice(0,a);return c&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),P}const o=D.VSBuffer.alloc(a);let l=0,f=0;for(;a>0;){const P=this._chunks[f];if(P.byteLength>a){const U=P.slice(0,a);o.set(U,l),l+=a,c&&(this._chunks[f]=P.slice(a),this._totalLength-=a),a-=a}else o.set(P,l),l+=P.byteLength,c?(this._chunks.shift(),this._totalLength-=P.byteLength):f++,a-=P.byteLength}return o}}e.ChunkStream=E;var v;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume"})(v||(v={}));function y(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(a,c,o,l){this.type=a,this.id=c,this.ack=o,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends k.Disposable{constructor(a){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,l=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new S(o,l,f,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(a){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=D.VSBuffer.alloc(13);c.writeUInt8(a.type,0),c.writeUInt32BE(a.id,1),c.writeUInt32BE(a.ack,5),c.writeUInt32BE(a.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",a.data),this._writeSoon(c,a.data)}_bufferAdd(a,c){const o=this._totalLength===0;return this._data.push(a,c),this._totalLength+=a.byteLength+c.byteLength,o}_bufferTake(){const a=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,c){this._bufferAdd(a,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const a=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this._socket.write(a)}}class m extends k.Disposable{constructor(a){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new S(1,0,0,a))}}e.Protocol=m;class u extends L.IPCClient{constructor(a,c,o=null){super(a,c,o);this.protocol=a}static fromSocket(a,c){return new u(new m(a),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=u;class g{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=g;class h{constructor(a){this.data=a,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){const a=[];let c=0,o=this._first;for(;o;)a[c++]=o.data,o=o.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const c=new h(a);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class n{constructor(){this.lastRuns=[];const a=Date.now();for(let c=0;c<n._HISTORY_LENGTH;c++)this.lastRuns[c]=a-1e3*c;setInterval(()=>{for(let c=n._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const a=Date.now(),c=(1+n._HISTORY_LENGTH)*1e3;let o=0;for(let l=0;l<n._HISTORY_LENGTH;l++)a-this.lastRuns[l]<=c&&o++;return 1-o/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class t{constructor(a,c=null,o=n.getInstance()){this._onControlMessage=new g,this.onControlMessage=this._onControlMessage.event,this._onMessage=new g,this.onMessage=this._onMessage.event,this._onDidDispose=new g,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new g,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new g,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=a,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),c&&this._socketReader.acceptChunk(c)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new S(5,0,0,I());this._socketWriter.write(a),this._socketWriter.flush()}sendPause(){const a=new S(7,0,0,I());this._socketWriter.write(a)}sendResume(){const a=new S(8,0,0,I());this._socketWriter.write(a)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,c){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=a,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const a=new S(3,0,this._incomingAckId,I());this._socketWriter.write(a);const c=this._outgoingUnackMsg.toArray();for(let o=0,l=c.length;o<l;o++)this._socketWriter.write(c[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new S(6,0,0,I())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data);break}case 2:{this._onControlMessage.fire(a.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let o=0,l=c.length;o<l;o++)this._socketWriter.write(c[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new S(1,c,this._incomingAckId,a);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(a){const c=new S(2,0,0,a);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const a=this._outgoingUnackMsg.peek(),c=Date.now()-a.writtenTime,o=Date.now()-this._socketReader.lastReadTime,l=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&o>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const f=Math.max(2e4-c,2e4-o,2e4-l,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},f)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new S(3,0,this._incomingAckId,I());this._socketWriter.write(a)}}e.PersistentProtocol=t}),define(ne[133],re([0,1,84,3,39,132]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends k.IPCServer{static getOnDidClientConnect(){const C=i.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(R,I)=>I);return i.Event.map(C,R=>{const{port1:I,port2:E}=new MessageChannel,y={protocol:new L.Protocol(I),onDidClientDisconnect:i.Event.fromDOMEventEmitter(I,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",R,[E]),y})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(ne[134],re([0,1,16,9,3,2,12,4,31,39,83]),function(X,e,D,i,k,L,A,b,C,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function E(){return{crypto:X.__$__nodeRequire("crypto"),zlib:X.__$__nodeRequire("zlib"),net:X.__$__nodeRequire("net"),os:X.__$__nodeRequire("os")}}class v{constructor(o,l=""){this.debugLabel=l,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=f=>{if(this.traceSocketEvent("error",{code:f?.code,message:f?.message}),f){if(f.code==="EPIPE")return;(0,i.onUnexpectedError)(f)}},this.socket.on("error",this._errorListener)}traceSocketEvent(o,l){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,l)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(o){const l=f=>{this.traceSocketEvent("read",f),o(D.VSBuffer.wrap(f))};return this.socket.on("data",l),{dispose:()=>this.socket.off("data",l)}}onClose(o){const l=f=>{this.traceSocketEvent("close",{hadError:f}),o({type:0,hadError:f,error:void 0})};return this.socket.on("close",l),{dispose:()=>this.socket.off("close",l)}}onEnd(o){const l=()=>{this.traceSocketEvent("nodeEndReceived"),o()};return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(o){if(!this.socket.destroyed)try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,l=>{if(l){if(l.code==="EPIPE")return;(0,i.onUnexpectedError)(l)}})}catch(l){if(l.code==="EPIPE")return;(0,i.onUnexpectedError)(l)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,l)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const f=()=>{this.socket.off("close",f),this.socket.off("end",f),this.socket.off("error",f),this.socket.off("timeout",f),this.socket.off("drain",f),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",f),this.socket.on("end",f),this.socket.on("error",f),this.socket.on("timeout",f),this.socket.on("drain",f)})}}e.NodeSocket=v;var y;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var d;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(d||(d={}));class S extends L.Disposable{constructor(o,l,f,P){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:l,inflateBytesLength:f?.byteLength||0,recordInflateBytes:P}),this._flowManager=this._register(new w(this,l,f,P,this._onData,(U,_)=>this._write(U,_))),this._register(this._flowManager.onError(U=>{console.error(U),(0,i.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(U=>this._onClose.fire(U)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(o,l){this.socket.traceSocketEvent(o,l)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this._onData.event(o)}onClose(o){return this._onClose.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this._flowManager.writeMessage(o)}_write(o,l){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let f=2;o.byteLength<126?f+=0:o.byteLength<2**16?f+=2:f+=8;const P=D.VSBuffer.alloc(f);if(l?P.writeUInt8(194,0):P.writeUInt8(130,0),o.byteLength<126)P.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){P.writeUInt8(126,1);let U=1;P.writeUInt8(o.byteLength>>>8&255,++U),P.writeUInt8(o.byteLength>>>0&255,++U)}else{P.writeUInt8(127,1);let U=1;P.writeUInt8(0,++U),P.writeUInt8(0,++U),P.writeUInt8(0,++U),P.writeUInt8(0,++U),P.writeUInt8(o.byteLength>>>24&255,++U),P.writeUInt8(o.byteLength>>>16&255,++U),P.writeUInt8(o.byteLength>>>8&255,++U),P.writeUInt8(o.byteLength>>>0&255,++U)}this.socket.write(D.VSBuffer.concat([P,o]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(o){if(o.byteLength!==0){for(this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const l=this._incomingData.peek(this._state.readLen),f=l.readUInt8(0),P=(f&128)>>>7,U=(f&64)>>>6,_=l.readUInt8(1),F=(_&128)>>>7,T=_&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(T===126?2:0)+(T===127?8:0),this._state.fin=P,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(U)),this._state.firstFrameOfMessage=Boolean(P),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const l=this._incomingData.read(this._state.readLen),f=l.readUInt8(1),P=(f&128)>>>7;let U=f&127,_=1;U===126?U=l.readUInt8(++_)*2**8+l.readUInt8(++_):U===127&&(U=l.readUInt8(++_)*0+l.readUInt8(++_)*0+l.readUInt8(++_)*0+l.readUInt8(++_)*0+l.readUInt8(++_)*2**24+l.readUInt8(++_)*2**16+l.readUInt8(++_)*2**8+l.readUInt8(++_));let F=0;P&&(F=l.readUInt8(++_)*2**24+l.readUInt8(++_)*2**16+l.readUInt8(++_)*2**8+l.readUInt8(++_)),this._state.state=3,this._state.readLen=U,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const l=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",l),u(l,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",l),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(l,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class w extends L.Disposable{constructor(o,l,f,P,U,_){super();this._tracer=o,this._onData=U,this._writeFn=_,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,l?(this._zlibInflateStream=this._register(new p(this._tracer,P,f,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}writeMessage(o){this._writeQueue.push(o),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const o=this._writeQueue.shift();if(this._zlibDeflateStream){const l=await this._deflateMessage(this._zlibDeflateStream,o);this._writeFn(l,!0)}else this._writeFn(o,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(o,l){return new Promise((f,P)=>{o.write(l),o.flush(U=>f(U))})}acceptFrame(o,l,f){this._readQueue.push({data:o,isCompressed:l,isLastFrameOfMessage:f}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const o=this._readQueue.shift();if(this._zlibInflateStream&&o.isCompressed){const l=await this._inflateFrame(this._zlibInflateStream,o.data,o.isLastFrameOfMessage);this._onData.fire(l)}else this._onData.fire(o.data)}this._isProcessingReadQueue=!1}}_inflateFrame(o,l,f){return new Promise((P,U)=>{o.write(l),f&&o.write(D.VSBuffer.fromByteArray([0,0,255,255])),o.flush(_=>P(_))})}}class p extends L.Disposable{constructor(o,l,f,P){super();this._tracer=o,this._recordInflateBytes=l,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=E().zlib.createInflateRaw(P),this._zlibInflate.on("error",U=>{this._tracer.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibInflate.on("data",U=>{this._tracer.traceSocketEvent("zlibInflateData",U),this._pendingInflateData.push(D.VSBuffer.wrap(U))}),f&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",f.buffer),this._zlibInflate.write(f.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}write(o){this._recordInflateBytes&&this._recordedInflateBytes.push(o.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",o),this._zlibInflate.write(o.buffer)}flush(o){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const l=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,o(l)})}}class m extends L.Disposable{constructor(o,l){super();this._tracer=o,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=E().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",f=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:f?.message,code:f?.code}),this._onError.fire(f)}),this._zlibDeflate.on("data",f=>{this._tracer.traceSocketEvent("zlibDeflateData",f),this._pendingDeflateData.push(D.VSBuffer.wrap(f))})}write(o){this._tracer.traceSocketEvent("zlibDeflateWrite",o.buffer),this._zlibDeflate.write(o.buffer)}flush(o){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let l=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,l=l.slice(0,l.byteLength-4),o(l)})}}function u(c,o){if(o===0)return;const l=c.byteLength>>>2;for(let T=0;T<l;T++){const N=c.readUInt32BE(T*4);c.writeUInt32BE(N^o,T*4)}const f=l*4,P=c.byteLength-f,U=o>>>24&255,_=o>>>16&255,F=o>>>8&255;P>=1&&c.writeUInt8(c.readUInt8(f)^U,f),P>=2&&c.writeUInt8(c.readUInt8(f+1)^_,f+1),P>=3&&c.writeUInt8(c.readUInt8(f+2)^F,f+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const g={[2]:107,[1]:103};function h(){const c=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):o=(0,A.join)(E().os.tmpdir(),`vscode-ipc-${c}.sock`),n(o),o}e.createRandomIPCHandle=h;function r(c,o,l){const f=E().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${f}-${l}-${o}-sock`;let P;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?P=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${f.substr(0,8)}-${l}-${o}.sock`):P=(0,A.join)(c,`${l}-${o}.sock`),n(P),P}e.createStaticIPCHandle=r;function n(c){const o=g[b.platform];typeof o=="number"&&c.length>=o&&console.warn(`WARNING: IPC handle "${c}" is longer than ${o} chars, try a shorter --user-data-dir`)}class t extends R.IPCServer{constructor(o){super(t.toClientConnectionEvent(o));this.server=o}static toClientConnectionEvent(o){const l=k.Event.fromNodeEventEmitter(o,"connection");return k.Event.map(l,f=>({protocol:new I.Protocol(new v(f,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(f,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function s(c){return new Promise((o,l)=>{const f=E().net.createServer();f.on("error",l),f.listen(c,()=>{f.removeListener("error",l),o(new t(f))})})}e.serve=s;function a(c,o){return new Promise((l,f)=>{const P=E().net.createConnection(c,()=>{P.removeListener("error",f),l(I.Client.fromSocket(new v(P,`ipc-client${o}`),o))});P.once("error",f)})}e.connect=a}),define(ne[85],re([0,1,6,3,2,14]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function b(E){const v=E;return v?.changed instanceof Map||v?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var C;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(C=e.StorageState||(e.StorageState={}));class R extends k.Disposable{constructor(v,y=Object.create(null)){super();this.database=v,this.options=y,this._onDidChangeStorage=this._register(new i.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(R.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((y,d)=>this.accept(d,y)),v.deleted?.forEach(y=>this.accept(y,void 0))}accept(v,y){if(this.state===C.Closed)return;let d=!1;(0,L.isUndefinedOrNull)(y)?d=this.cache.delete(v):this.cache.get(v)!==y&&(this.cache.set(v,y),d=!0),d&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,y){const d=this.cache.get(v);return(0,L.isUndefinedOrNull)(d)?y:d}getBoolean(v,y){const d=this.get(v);return(0,L.isUndefinedOrNull)(d)?y:d==="true"}getNumber(v,y){const d=this.get(v);return(0,L.isUndefinedOrNull)(d)?y:parseInt(d,10)}async set(v,y){if(this.state===C.Closed)return;if((0,L.isUndefinedOrNull)(y))return this.delete(v);const d=String(y);if(this.cache.get(v)!==d)return this.cache.set(v,d),this.pendingInserts.set(v,d),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async delete(v){if(!(this.state===C.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(v){if(!!this.hasPending)return this.doFlush(v)}async doFlush(v){return this.flushDelayer.trigger(()=>this.flushPending(),v)}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=R,R.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert?.forEach((y,d)=>this.items.set(d,y)),v.delete?.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=I}),define(ne[135],re([10,11]),function(X,e){return X.create("vs/base/node/processes",e)}),define(ne[86],re([0,1,48,42,20,30,12,4,36,77,14,114,27,135]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function d(h){switch(h){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(h,r){if(b.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};r&&(n.cwd=r);const t=D.execFile("taskkill",["/T","/F","/PID",h.pid.toString()],n);return new Promise(s=>{t.once("error",a=>{s({success:!1,error:a})}),t.once("exit",(a,c)=>{s(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?d(n.status):1})}else if(b.isLinux||b.isMacintosh)try{const n=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(t=>{D.execFile(n,[h.pid.toString()],{encoding:"utf8",shell:!0},(s,a,c)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else h.kill("SIGKILL");return Promise.resolve({success:!0})}function w(h=C.env){return h.comspec||"cmd.exe"}e.getWindowsShell=w;class p{constructor(r,n,t,s){if(n!==void 0&&t!==void 0&&s!==void 0)this.cmd=r,this.args=n,this.shell=t,this.options=s;else{const a=r;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(C.env).forEach(c=>{a[c]=C.env[c]}),Object.keys(this.options.env).forEach(c=>{a[c]=this.options.env[c]}),this.options.env=a}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const n=r.lastIndexOf(A.sep);return n!==-1&&(r=r.substring(n+1)),p.WellKnowCommands[r]?r:"other"}start(r){return b.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(C.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(n=>{let t,s;const a=new Promise((c,o)=>{t=c,s=o});if(n){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=D.exec(c,this.options,(o,l,f)=>{this.childProcess=null;const P=o;P&&P.killed?s({killed:this.terminateRequested,stdout:l.toString(),stderr:f.toString()}):this.handleExec(t,r,o,l,f)})}else{let c=null;const o=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,t,r,s);const f={terminated:this.terminateRequested};I.isNumber(l)&&(f.cmdCode=l),t(f)};if(this.shell&&b.isWindows){const l=L.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let f=!1,P=!1;const U=[];let _=this.ensureQuotes(this.cmd);U.push(_.value),f=_.quoted,this.args&&this.args.forEach(T=>{_=this.ensureQuotes(T),U.push(_.value),P=P&&_.quoted});const F=["/s","/c"];f?P?F.push('"'+U.join(" ")+'"'):U.length>1?F.push('"'+U[0]+'" '+U.slice(1).join(" ")):F.push('"'+U[0]+'"'):F.push(U.join(" ")),c=D.spawn(w(),F,l)}else this.cmd&&(c=D.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(I.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",l=>{this.childProcess=null,s({terminated:this.terminateRequested,error:l})}),c.pid&&(this.childProcess.on("close",o),this.handleSpawn(c,t,r,s,!0)))}return a})}handleClose(r,n,t,s){}ensureQuotes(r){return p.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,S(r,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!b.isWindows)return r(!1);const n=D.spawn(w(),["/s","/c"]);n.on("error",t=>r(!0)),n.on("exit",t=>r(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class m extends p{constructor(r,n,t,s){super(r,n,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,n,t,s,a){[s,a].forEach((c,o)=>{const l=new E.LineDecoder;l.write(c).forEach(U=>{n({line:U,source:o===0?0:1})});const P=l.end();P&&n({line:P,source:o===0?0:1})}),r({terminated:this.terminateRequested,error:t})}handleSpawn(r,n,t,s,a){const c=new E.LineDecoder,o=new E.LineDecoder;r.stdout.on("data",l=>{c.write(l).forEach(P=>t({line:P,source:0}))}),r.stderr.on("data",l=>{o.write(l).forEach(P=>t({line:P,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=o}handleClose(r,n,t,s){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&t({line:a,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=m;function u(h){let r=[],n=!1;const t=function(s){if(n){r.push(s);return}(!h.send(s,c=>{if(c&&console.error(c),n=!1,r.length>0){const o=r.slice(0);r=[],o.forEach(l=>t(l))}})||b.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=u;var g;(function(h){async function r(n,t,s){if(A.isAbsolute(n))return n;if(t===void 0&&(t=C.cwd()),A.dirname(n)!=="."||(s===void 0&&I.isString(C.env.PATH)&&(s=C.env.PATH.split(A.delimiter)),s===void 0||s.length===0))return A.join(t,n);async function c(o){if(await v.Promises.exists(o)){let l;try{l=await v.Promises.stat(o)}catch(f){f.message.startsWith("EACCES")&&(l=await v.Promises.lstat(o))}return l?!l.isDirectory():!1}return!1}for(const o of s){let l;if(A.isAbsolute(o)?l=A.join(o,n):l=A.join(t,o,n),await c(l))return l;let f=l+".com";if(await c(f)||(f=l+".exe",await c(f)))return f}return A.join(t,n)}h.findExecutable=r})(g=e.win32||(e.win32={}))}),define(ne[136],re([0,1,37,4,82,86]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(y,d){return y===1?i.isWindows?E():L.getWindowsShell(d):R(y,d)}e.getSystemShell=A;function b(y,d){return y===1?i.isWindows?v(d):L.getWindowsShell(d):R(y,d)}e.getSystemShellSync=b;let C=null;function R(y,d){if(i.isLinux&&y===2||i.isMacintosh&&y===3)return"/bin/bash";if(!C){let S;if(i.isWindows)S="/bin/bash";else{if(S=d.SHELL,!S)try{S=(0,D.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}C=S}return C}let I=null;async function E(){return I||(I=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),I}function v(y){if(I)return I;const d=i.isWindows&&parseFloat((0,D.release)())>=10,S=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${y.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?w:L.getWindowsShell(y)}}),define(ne[64],re([0,1,48,6,16,21,127,9,3,2,30,86,77,39]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends y.ChannelServer{constructor(p){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",m=>k.VSBuffer.wrap(Buffer.from(m,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=d;class S{constructor(p,m){this.modulePath=p,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new C.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new i.Delayer(u),this.child=null,this._client=null}getChannel(p){const m=this;return{call(u,g,h){return m.requestPromise(p,u,g,h)},listen(u,g){return m.requestEvent(p,u,g)}}}requestPromise(p,m,u,g=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const h=this.getCachedChannel(p),r=(0,i.createCancelablePromise)(s=>h.call(m,u,s)),n=g.onCancellationRequested(()=>r.cancel()),t=(0,R.toDisposable)(()=>r.cancel());return this.activeRequests.add(t),r.finally(()=>{n.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),r}requestEvent(p,m,u){if(!this.disposeDelayer)return C.Event.None;this.disposeDelayer.cancel();let g;const h=new C.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(p).listen(m,u)(h.fire,h),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return h.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),(0,v.removeDangerousEnvVariables)(m.env),this.child=(0,D.fork)(this.modulePath,p,m);const u=new C.Emitter;C.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,A.isRemoteConsoleLog)(a)){(0,A.log)(a,`IPC Library: ${this.options.serverName}`);return}u.fire(k.VSBuffer.wrap(Buffer.from(a,"base64")))});const h=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,r=a=>this.child&&this.child.connected&&h.send(a.buffer.toString("base64")),n=u.event,t={send:r,onMessage:n};this._client=new y.ChannelClient(t);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,c)=>{process.removeListener("exit",s),this.activeRequests.forEach(o=>(0,R.dispose)(o)),this.activeRequests.clear(),a!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:c})})}return this._client}getCachedChannel(p){let m=this.channels.get(p);return m||(m=this.client.getChannel(p),this.channels.set(p,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(ne[137],re([10,11]),function(X,e){return X.create("vs/base/node/zip",e)}),define(ne[138],re([10,11]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[139],re([10,11]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(ne[140],re([10,11]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(ne[141],re([10,11]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[142],re([10,11]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[143],re([10,11]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[144],re([10,11]),function(X,e){return X.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[145],re([10,11]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[146],re([10,11]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[147],re([10,11]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[148],re([10,11]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(ne[149],re([10,11]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ne[150],re([10,11]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(ne[151],re([10,11]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[152],re([10,11]),function(X,e){return X.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[153],re([10,11]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(ne[154],re([10,11]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(ne[155],re([10,11]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[156],re([10,11]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[157],re([10,11]),function(X,e){return X.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[158],re([10,11]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[159],re([10,11]),function(X,e){return X.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[160],re([10,11]),function(X,e){return X.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[161],re([10,11]),function(X,e){return X.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[162],re([10,11]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[163],re([10,11]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[164],re([10,11]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[165],re([10,11]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(ne[87],re([0,1,61,60,20,12,36,17,7]),function(X,e,D,i,k,L,A,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class R{constructor(S,w,p){this._args=S,this.paths=w,this.productService=p,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,L.dirname)(k.FileAccess.asFileUri("",X).fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return C.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(C.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=A.env.VSCODE_PORTABLE;return S?C.URI.file((0,L.join)(S,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,L.resolve)(S):(0,L.normalize)((0,L.join)(k.FileAccess.asFileUri("",X).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,L.resolve)(S):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,L.resolve)(S);const w=A.env.VSCODE_EXTENSIONS;if(w)return w;const p=A.env.VSCODE_PORTABLE;return p?(0,L.join)(p,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(w=>/^[^:/?#]+?:\/\//.test(w)?C.URI.parse(w):C.URI.file((0,L.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?C.URI.parse(S):C.URI.file((0,L.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return C.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=A.env.VSCODE_PORTABLE;return S?C.URI.file((0,L.join)(S,"policy.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}ge([i.memoize],R.prototype,"appRoot",null),ge([i.memoize],R.prototype,"userHome",null),ge([i.memoize],R.prototype,"userDataPath",null),ge([i.memoize],R.prototype,"appSettingsHome",null),ge([i.memoize],R.prototype,"tmpDir",null),ge([i.memoize],R.prototype,"cacheHome",null),ge([i.memoize],R.prototype,"stateResource",null),ge([i.memoize],R.prototype,"userRoamingDataHome",null),ge([i.memoize],R.prototype,"userDataSyncHome",null),ge([i.memoize],R.prototype,"userDataSyncLogResource",null),ge([i.memoize],R.prototype,"editSessionsLogResource",null),ge([i.memoize],R.prototype,"sync",null),ge([i.memoize],R.prototype,"machineSettingsResource",null),ge([i.memoize],R.prototype,"workspaceStorageHome",null),ge([i.memoize],R.prototype,"localHistoryHome",null),ge([i.memoize],R.prototype,"keyboardLayoutResource",null),ge([i.memoize],R.prototype,"argvResource",null),ge([i.memoize],R.prototype,"isExtensionDevelopment",null),ge([i.memoize],R.prototype,"untitledWorkspacesHome",null),ge([i.memoize],R.prototype,"installSourcePath",null),ge([i.memoize],R.prototype,"builtinExtensionsPath",null),ge([i.memoize],R.prototype,"extensionsPath",null),ge([i.memoize],R.prototype,"extensionDevelopmentLocationURI",null),ge([i.memoize],R.prototype,"extensionDevelopmentKind",null),ge([i.memoize],R.prototype,"extensionTestsLocationURI",null),ge([i.memoize],R.prototype,"debugExtensionHost",null),ge([i.memoize],R.prototype,"serviceMachineIdResource",null),ge([i.memoize],R.prototype,"telemetryLogResource",null),ge([i.memoize],R.prototype,"disableWorkspaceTrust",null),ge([i.memoize],R.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=R;function I(d,S){return y(d["inspect-extensions"],d["inspect-brk-extensions"],5870,S,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=I;function E(d,S){return y(d["inspect-search"],d["inspect-brk-search"],5876,S,d.extensionEnvironment)}e.parseSearchPort=E;function v(d,S){return y(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,S,d.extensionEnvironment)}e.parsePtyHostPort=v;function y(d,S,w,p,m,u){const h=Number(S||d)||(p?null:w),r=h?Boolean(!!S):!1;let n;if(u)try{n=JSON.parse(u)}catch{}return{port:h,break:r,debugId:m,env:n}}}),define(ne[166],re([0,1,271,4,139]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(12,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(13,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},category:{type:"string",cat:"e",description:(0,k.localize)(16,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(17,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(18,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(19,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(21,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(22,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(23,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(24,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(25,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(26,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(27,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(28,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(29,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(31,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(32,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function b(d,S,w=A){const p={},m=["_"],u=[];for(const n in S){const t=S[n];t.alias&&(p[n]=t.alias),t.type==="string"||t.type==="string[]"?(m.push(n),t.deprecates&&m.push(...t.deprecates)):t.type==="boolean"&&(u.push(n),t.deprecates&&u.push(...t.deprecates))}const g=D(d,{string:m,boolean:u,alias:p}),h={},r=g;h._=g._.map(n=>String(n)).filter(n=>n.length>0),delete r._;for(const n in S){const t=S[n];t.alias&&delete r[t.alias];let s=r[n];if(t.deprecates)for(const a of t.deprecates)r.hasOwnProperty(a)&&(s||(s=r[a],s&&w.onDeprecatedOption(a,t.deprecationMessage||(0,k.localize)(34,null,n))),delete r[a]);if(typeof s!="undefined"){if(t.type==="string[]"){if(Array.isArray(s)||(s=[s]),!t.allowEmptyValue){const a=s.filter(c=>c.length>0);a.length!==s.length&&(w.onEmptyValue(n),s=a.length>0?a:void 0)}}else t.type==="string"&&(Array.isArray(s)?(s=s.pop(),w.onMultipleValues(n,s)):!s&&!t.allowEmptyValue&&(w.onEmptyValue(n),s=void 0));h[n]=s,t.deprecationMessage&&w.onDeprecatedOption(n,t.deprecationMessage)}delete r[n]}for(const n in r)w.onUnknownOption(n);return h}e.parseArgs=b;function C(d,S){let w="";return S.args&&(Array.isArray(S.args)?w=` <${S.args.join("> <")}>`:w=` <${S.args}>`),S.alias?`-${S.alias} --${d}${w}`:`--${d}${w}`}function R(d,S){let w=0;const p=[];for(const h in d){const r=d[h],n=C(h,r);w=Math.max(w,n.length),p.push([n,r.description])}const m=w+2+1;if(S-m<25)return p.reduce((h,r)=>h.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);const u=S-m-1,g=[];for(const h of p){const r=h[0],n=E(h[1],u),t=I(m-r.length-2);g.push("  "+r+t+n[0]);for(let s=1;s<n.length;s++)g.push(I(m)+n[s])}return g}e.formatOptions=R;function I(d){return" ".repeat(d)}function E(d,S){const w=[];for(;d.length;){const p=d.length<S?d.length:d.lastIndexOf(" ",S),m=d.slice(0,p).trim();d=d.slice(p),w.push(m)}return w}function v(d,S,w,p,m){const u=process.stdout.isTTY&&process.stdout.columns||80,g=m?.noInputFiles!==!0?`[${(0,k.localize)(35,null)}...]`:"",h=[`${d} ${w}`];h.push(""),h.push(`${(0,k.localize)(36,null)}: ${S} [${(0,k.localize)(37,null)}]${g}`),h.push(""),m?.noPipe!==!0&&(i.isWindows?h.push((0,k.localize)(38,null,S)):h.push((0,k.localize)(39,null,S)),h.push(""));const r={};for(const n in p){const t=p[n];if(t.description&&t.cat){let s=r[t.cat];s||(r[t.cat]=s={}),s[n]=t}}for(const n in r){const t=n,s=r[t];s&&(h.push(L[t]),h.push(...R(s,u)),h.push(""))}return h.join(`
`)}e.buildHelpMessage=v;function y(d,S){return`${d||(0,k.localize)(40,null)}
${S||(0,k.localize)(41,null)}
${process.arch}`}e.buildVersionMessage=y}),define(ne[167],re([0,1,272,140,166]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function A(v,y){const d={onUnknownOption:w=>{console.warn((0,i.localize)(0,null,w))},onMultipleValues:(w,p)=>{console.warn((0,i.localize)(1,null,w,p))},onEmptyValue:w=>{console.warn((0,i.localize)(2,null,w))},onDeprecatedOption:(w,p)=>{console.warn((0,i.localize)(3,null,w,p))}},S=(0,k.parseArgs)(v,k.OPTIONS,y?d:void 0);return S.goto&&S._.forEach(w=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,i.localize)(4,null))),S["max-memory"]&&D(parseInt(S["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),S}function b(v){const y=v.findIndex(d=>!/^-/.test(d));if(y>-1)return[...v.slice(0,y),...v.slice(y+1)]}function C(v){let[,...y]=v;process.env.VSCODE_DEV&&(y=b(y)||[]);const d=!E(process.env);return A(y,d)}e.parseMainProcessArgv=C;function R(v){const[,,...y]=v;return A(y,!0)}e.parseCLIProcessArgv=R;function I(v,...y){const d=v.indexOf("--");return d===-1?v.push(...y):v.splice(d,0,...y),v}e.addArg=I;function E(v){return v.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function X(e,D,i,k){function L(b){const C=A(b),R=[C];return e.isAbsolute(C)||R.unshift(k),e.resolve(...R)}function A(b){const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let R=process.env.VSCODE_APPDATA;if(R)return e.join(R,i);const I=b["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(R=process.env.APPDATA,!R){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");R=e.join(E,"AppData","Roaming")}break;case"darwin":R=e.join(D.homedir(),"Library","Application Support");break;case"linux":R=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(R,i)}return{getUserDataPath:L}}if(typeof define=="function")define(ne[168],re([0,273,37,20,17,36]),function(e,D,i,k,L,A){const b=L.dirname(k.FileAccess.asFileUri("",e)),C=e.__$__nodeRequire(L.joinPath(b,"package.json").fsPath);return X(D,i,C.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),i=require("os");module.exports=X(D,i,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[169],re([0,1,37,87,168]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends i.AbstractNativeEnvironmentService{constructor(b,C){super(b,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,k.getUserDataPath)(b)},C)}}e.NativeEnvironmentService=L}),define(ne[170],re([0,1,7]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,b=/^\s*url\s*=\s*(.+\S)\s*$/mg,C=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function R(w){const p=w.match(A);return p?p[1]:null}function I(w){if(w.indexOf("://")===-1){const p=w.match(i);return p?R(p[2]):null}try{const p=D.URI.parse(w);if(p.authority)return R(p.authority)}catch{}return null}function E(w,p){const m=new Set;let u;for(;u=b.exec(w);){const h=I(u[1]);h&&m.add(h)}const g=new Set(p);return Array.from(m).map(h=>g.has(h)?h:h.replace(C,"a"))}e.getDomainsOfRemotes=E;function v(w){const p=w.match(L);return p?p[2]:null}function y(w,p,m){return w&&p?(m&&p.endsWith(".git")&&(p=p.substr(0,p.length-4)),p.indexOf("/")===0?`${w}${p}`:`${w}/${p}`):null}function d(w,p){if(w.indexOf("://")===-1){const m=w.match(k);if(m)return y(m[2],m[3],p)}try{const m=D.URI.parse(w);if(m.authority)return y(v(m.authority),m.path,p)}catch{}return null}function S(w,p=!1){const m=[];let u;for(;u=b.exec(w);){const g=d(u[1],p);g&&m.push(g)}return m}e.getRemotes=S}),define(ne[171],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,A,b,C){return this.channel.call("promptImportantExtensionsInstallNotification",[L,A,b,C])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class i{constructor(L){this.service=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,b){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(b[0],b[1],b[2],b[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(ne[65],re([0,1,17,80,147,55]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function C(p){return p=p.trim(),p==="*"||A.test(p)}e.isValidVersionStr=C;function R(p){if(!C(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=p.match(A);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=R;function I(p){if(!p)return null;const m=p.majorBase,u=p.majorMustEqual,g=p.minorBase;let h=p.minorMustEqual;const r=p.patchBase;let n=p.patchMustEqual;p.hasCaret&&(m===0||(h=!1),n=!1);let t=0;if(p.preRelease){const s=b.exec(p.preRelease);if(s){const[,a,c,o]=s;t=Date.UTC(Number(a),Number(c)-1,Number(o))}}return{majorBase:m,majorMustEqual:u,minorBase:g,minorMustEqual:h,patchBase:r,patchMustEqual:n,isMinimum:p.hasGreaterEquals,notBefore:t}}e.normalizeVersion=I;function E(p,m,u){let g;typeof p=="string"?g=I(R(p)):g=p;let h;m instanceof Date?h=m.getTime():typeof m=="string"&&(h=new Date(m).getTime());let r;if(typeof u=="string"?r=I(R(u)):r=u,!g||!r)return!1;const n=g.majorBase,t=g.minorBase,s=g.patchBase;let a=r.majorBase,c=r.minorBase,o=r.patchBase;const l=r.notBefore;let f=r.majorMustEqual,P=r.minorMustEqual,U=r.patchMustEqual;return r.isMinimum?n>a?!0:n<a?!1:t>c?!0:t<c||h&&h<l?!1:s>=o:(n===1&&a===0&&(!f||!P||!U)&&(a=1,c=0,o=0,f=!0,P=!1,U=!1),n<a?!1:n>a?!f:t<c?!1:t>c?!P:s<o?!1:s>o?!U:!(h&&h<l))}e.isValidVersion=E;function v(p,m,u,g,h){const r=[];if(typeof g.publisher!="undefined"&&typeof g.publisher!="string")return r.push([i.default.Error,k.localize(0,null)]),r;if(typeof g.name!="string")return r.push([i.default.Error,k.localize(1,null,"name")]),r;if(typeof g.version!="string")return r.push([i.default.Error,k.localize(2,null,"version")]),r;if(!g.engines)return r.push([i.default.Error,k.localize(3,null,"engines")]),r;if(typeof g.engines.vscode!="string")return r.push([i.default.Error,k.localize(4,null,"engines.vscode")]),r;if(typeof g.extensionDependencies!="undefined"&&!w(g.extensionDependencies))return r.push([i.default.Error,k.localize(5,null,"extensionDependencies")]),r;if(typeof g.activationEvents!="undefined"){if(!w(g.activationEvents))return r.push([i.default.Error,k.localize(6,null,"activationEvents")]),r;if(typeof g.main=="undefined"&&typeof g.browser=="undefined")return r.push([i.default.Error,k.localize(7,null,"activationEvents","main")]),r}if(typeof g.extensionKind!="undefined"&&typeof g.main=="undefined"&&r.push([i.default.Warning,k.localize(8,null,"extensionKind")]),typeof g.main!="undefined"){if(typeof g.main!="string")return r.push([i.default.Error,k.localize(9,null,"main")]),r;{const s=(0,D.joinPath)(u,g.main);(0,D.isEqualOrParent)(s,u)||r.push([i.default.Warning,k.localize(10,null,s.path,u.path)])}if(typeof g.activationEvents=="undefined")return r.push([i.default.Error,k.localize(11,null,"activationEvents","main")]),r}if(typeof g.browser!="undefined"){if(typeof g.browser!="string")return r.push([i.default.Error,k.localize(12,null,"browser")]),r;{const s=(0,D.joinPath)(u,g.browser);(0,D.isEqualOrParent)(s,u)||r.push([i.default.Warning,k.localize(13,null,s.path,u.path)])}if(typeof g.activationEvents=="undefined")return r.push([i.default.Error,k.localize(14,null,"activationEvents","browser")]),r}if(!L.valid(g.version))return r.push([i.default.Error,k.localize(15,null)]),r;const n=[];if(!y(p,m,g,h,n))for(const s of n)r.push([i.default.Error,s]);return r}e.validateExtensionManifest=v;function y(p,m,u,g,h){return g||typeof u.main=="undefined"&&typeof u.browser=="undefined"?!0:S(p,m,u.engines.vscode,h)}e.isValidExtensionVersion=y;function d(p,m,u){return p==="*"||S(m,u,p)}e.isEngineValid=d;function S(p,m,u,g=[]){const h=I(R(u));if(!h)return g.push(k.localize(16,null,u)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return g.push(k.localize(17,null,u)),!1}else if(!h.majorMustEqual)return g.push(k.localize(18,null,u)),!1;return E(p,m,h)?!0:(g.push(k.localize(19,null,p,u)),!1)}function w(p){if(!Array.isArray(p))return!1;for(let m=0,u=p.length;m<u;m++)if(typeof p[m]!="string")return!1;return!0}}),define(ne[49],re([0,1,16,31]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(L,A,b){let C=b&&b.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const I=(await A.readFile(L.serviceMachineIdResource)).value.toString();C=(0,i.isUUID)(I)?I:null}catch{C=null}if(!C){C=(0,i.generateUuid)();try{await A.writeFile(L.serviceMachineIdResource,D.VSBuffer.fromString(C))}catch{}}return b?.store("storage.serviceMachineId",C,-1,1),C}e.getServiceMachineId=k}),define(ne[56],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(k,L=[],A=!1){this.ctor=k,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=D}),define(ne[88],re([0,1,56]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function k(A,b,C){b instanceof D.SyncDescriptor||(b=new D.SyncDescriptor(b,[],C)),i.push([A,b])}e.registerSingleton=k;function L(){return i}e.getSingletonServiceDescriptors=L}),define(ne[172],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=D;class i{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const A of this._nodes.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const b=this.lookupOrInsertNode(L),C=this.lookupOrInsertNode(A);b.outgoing.set(this._hashFn(A),C),C.incoming.set(this._hashFn(L),b)}removeNode(L){const A=this._hashFn(L);this._nodes.delete(A);for(const b of this._nodes.values())b.outgoing.delete(A),b.incoming.delete(A)}lookupOrInsertNode(L){const A=this._hashFn(L);let b=this._nodes.get(A);return b||(b=new D(L),this._nodes.set(A,b)),b}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[A,b]of this._nodes)L.push(`${A}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this._nodes){const b=new Set([L]),C=this._findCycle(A,b);if(C)return C}}_findCycle(L,A){for(const[b,C]of L.outgoing){if(A.has(b))return[...A,b].join(" -> ");A.add(b);const R=this._findCycle(C,A);if(R)return R;A.delete(b)}}}e.Graph=i}),define(ne[5],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function b(C){return C[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=b})(D=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function i(A,b,C){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:A,index:C}):(b[D.DI_DEPENDENCIES]=[{id:A,index:C}],b[D.DI_TARGET]=b)}function k(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const b=function(C,R,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(b,C,I)};return b.toString=()=>A,D.serviceIds.set(A,b),b}e.createDecorator=k;function L(A){return A}e.refineServiceDecorator=L}),define(ne[173],re([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ne[19],re([0,1,14,7,5]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function L(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof i.URI)}e.isConfigurationOverrides=L;function A(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||D.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=A;var b;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=C;function R(p,m){const u=Object.create(null);for(const g in p)I(u,g,p[g],m);return u}e.toValuesTree=R;function I(p,m,u,g){const h=m.split("."),r=h.pop();let n=p;for(let t=0;t<h.length;t++){const s=h[t];let a=n[s];switch(typeof a){case"undefined":a=n[s]=Object.create(null);break;case"object":break;default:g(`Ignoring ${m} as ${h.slice(0,t+1).join(".")} is ${JSON.stringify(a)}`);return}n=a}if(typeof n=="object"&&n!==null)try{n[r]=u}catch{g(`Ignoring ${m} as ${h.join(".")} is ${JSON.stringify(n)}`)}else g(`Ignoring ${m} as ${h.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=I;function E(p,m){const u=m.split(".");v(p,u)}e.removeFromValueTree=E;function v(p,m){const u=m.shift();if(m.length===0){delete p[u];return}if(Object.keys(p).indexOf(u)!==-1){const g=p[u];typeof g=="object"&&!Array.isArray(g)&&(v(g,m),Object.keys(g).length===0&&delete p[u])}}function y(p,m,u){function g(n,t){let s=n;for(const a of t){if(typeof s!="object"||s===null)return;s=s[a]}return s}const h=m.split("."),r=g(p,h);return typeof r=="undefined"?u:r}e.getConfigurationValue=y;function d(p,m,u){Object.keys(m).forEach(g=>{g!=="__proto__"&&(g in p?D.isObject(p[g])&&D.isObject(m[g])?d(p[g],m[g],u):u&&(p[g]=m[g]):p[g]=m[g])})}e.merge=d;function S(p,m,u){const g=p.inspect(m),h=p.inspect(u);return typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:g.defaultValue}e.getMigratedSettingValue=S;function w(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(ne[174],re([0,1,4,26,5]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",D.isMacintosh),L.set("isLinux",D.isLinux),L.set("isWindows",D.isWindows),L.set("isWeb",D.isWeb),L.set("isMacNative",D.isMacintosh&&!D.isWeb),L.set("isEdge",D.isEdge),L.set("isFirefox",D.isFirefox),L.set("isChrome",D.isChrome),L.set("isSafari",D.isSafari);const A=Object.prototype.hasOwnProperty;var b;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(b=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return E.INSTANCE}static true(){return v.INSTANCE}static has(T){return y.create(T)}static equals(T,N){return d.create(T,N)}static notEquals(T,N){return p.create(T,N)}static regex(T,N){return t.create(T,N)}static in(T,N){return S.create(T,N)}static notIn(T,N){return w.create(T,N)}static not(T){return m.create(T)}static and(...T){return c.create(T,null)}static or(...T){return o.create(T,null,!0)}static greater(T,N){return g.create(T,N)}static greaterEquals(T,N){return h.create(T,N)}static smaller(T,N){return r.create(T,N)}static smallerEquals(T,N){return n.create(T,N)}static deserialize(T,N=!1){if(!!T)return this._deserializeOrExpression(T,N)}static _deserializeOrExpression(T,N){const z=T.split("||");return o.create(z.map(V=>this._deserializeAndExpression(V,N)),null,!0)}static _deserializeAndExpression(T,N){const z=T.split("&&");return c.create(z.map(V=>this._deserializeOne(V,N)),null)}static _deserializeOne(T,N){if(T=T.trim(),T.indexOf("!=")>=0){const z=T.split("!=");return p.create(z[0].trim(),this._deserializeValue(z[1],N))}if(T.indexOf("==")>=0){const z=T.split("==");return d.create(z[0].trim(),this._deserializeValue(z[1],N))}if(T.indexOf("=~")>=0){const z=T.split("=~");return t.create(z[0].trim(),this._deserializeRegexValue(z[1],N))}if(T.indexOf(" not in ")>=0){const z=T.split(" not in ");return w.create(z[0].trim(),z[1].trim())}if(T.indexOf(" in ")>=0){const z=T.split(" in ");return S.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const z=T.split(">=");return h.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const z=T.split(">");return g.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const z=T.split("<=");return n.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const z=T.split("<");return r.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(T)?m.create(T.substr(1).trim()):y.create(T)}static _deserializeValue(T,N){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;const z=/^'([^']*)'$/.exec(T);return z?z[1].trim():T}static _deserializeRegexValue(T,N){if((0,i.isFalsyOrWhitespace)(T)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const z=T.indexOf("/"),V=T.lastIndexOf("/");if(z===V||z<0){if(N)throw new Error(`bad regexp-value '${T}', missing /-enclosure`);return console.warn(`bad regexp-value '${T}', missing /-enclosure`),null}const J=T.slice(z+1,V),$=T[V+1]==="i"?"i":"";try{return new RegExp(J,$)}catch(Q){if(N)throw new Error(`bad regexp-value '${T}', parse error: ${Q}`);return console.warn(`bad regexp-value '${T}', parse error: ${Q}`),null}}}e.ContextKeyExpr=C;function R(F,T){const N=F?F.substituteConstants():void 0,z=T?T.substituteConstants():void 0;return!N&&!z?!0:!N||!z?!1:N.equals(z)}e.expressionsAreEqualWithConstantSubstitution=R;function I(F,T){return F.cmp(T)}class E{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class v{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class y{constructor(T,N){this.key=T,this.negated=N,this.type=2}static create(T,N=null){const z=L.get(T);return typeof z=="boolean"?z?v.INSTANCE:E.INSTANCE:new y(T,N)}cmp(T){return T.type!==this.type?this.type-T.type:f(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=L.get(this.key);return typeof T=="boolean"?T?v.INSTANCE:E.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class d{constructor(T,N,z){this.key=T,this.value=N,this.negated=z,this.type=4}static create(T,N,z=null){if(typeof N=="boolean")return N?y.create(T,z):m.create(T,z);const V=L.get(T);return typeof V=="boolean"?N===(V?"true":"false")?v.INSTANCE:E.INSTANCE:new d(T,N,z)}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=L.get(this.key);if(typeof T=="boolean"){const N=T?"true":"false";return this.value===N?v.INSTANCE:E.INSTANCE}return this}evaluate(T){return T.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(T){return T.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class S{constructor(T,N){this.key=T,this.valueKey=N,this.type=10,this.negated=null}static create(T,N){return new S(T,N)}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.valueKey,T.key,T.valueKey)}equals(T){return T.type===this.type?this.key===T.key&&this.valueKey===T.valueKey:!1}substituteConstants(){return this}evaluate(T){const N=T.getValue(this.valueKey),z=T.getValue(this.key);return Array.isArray(N)?N.includes(z):typeof z=="string"&&typeof N=="object"&&N!==null?A.call(N,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(T){return T.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=S;class w{constructor(T,N){this.key=T,this.valueKey=N,this.type=11,this._negated=S.create(T,N)}static create(T,N){return new w(T,N)}cmp(T){return T.type!==this.type?this.type-T.type:this._negated.cmp(T._negated)}equals(T){return T.type===this.type?this._negated.equals(T._negated):!1}substituteConstants(){return this}evaluate(T){return!this._negated.evaluate(T)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(T){return T.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=w;class p{constructor(T,N,z){this.key=T,this.value=N,this.negated=z,this.type=5}static create(T,N,z=null){if(typeof N=="boolean")return N?m.create(T,z):y.create(T,z);const V=L.get(T);return typeof V=="boolean"?N===(V?"true":"false")?E.INSTANCE:v.INSTANCE:new p(T,N,z)}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=L.get(this.key);if(typeof T=="boolean"){const N=T?"true":"false";return this.value===N?E.INSTANCE:v.INSTANCE}return this}evaluate(T){return T.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(T){return T.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class m{constructor(T,N){this.key=T,this.negated=N,this.type=3}static create(T,N=null){const z=L.get(T);return typeof z=="boolean"?z?E.INSTANCE:v.INSTANCE:new m(T,N)}cmp(T){return T.type!==this.type?this.type-T.type:f(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=L.get(this.key);return typeof T=="boolean"?T?E.INSTANCE:v.INSTANCE:this}evaluate(T){return!T.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(T){return T.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function u(F,T){if(typeof F=="string"){const N=parseFloat(F);isNaN(N)||(F=N)}return typeof F=="string"||typeof F=="number"?T(F):E.INSTANCE}class g{constructor(T,N,z){this.key=T,this.value=N,this.negated=z,this.type=12}static create(T,N,z=null){return u(N,V=>new g(T,V,z))}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=g;class h{constructor(T,N,z){this.key=T,this.value=N,this.negated=z,this.type=13}static create(T,N,z=null){return u(N,V=>new h(T,V,z))}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=h;class r{constructor(T,N,z){this.key=T,this.value=N,this.negated=z,this.type=14}static create(T,N,z=null){return u(N,V=>new r(T,V,z))}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class n{constructor(T,N,z){this.key=T,this.value=N,this.negated=z,this.type=15}static create(T,N,z=null){return u(N,V=>new n(T,V,z))}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(T,N){this.key=T,this.regexp=N,this.type=7,this.negated=null}static create(T,N){return new t(T,N)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.key<T.key)return-1;if(this.key>T.key)return 1;const N=this.regexp?this.regexp.source:"",z=T.regexp?T.regexp.source:"";return N<z?-1:N>z?1:0}equals(T){if(T.type===this.type){const N=this.regexp?this.regexp.source:"",z=T.regexp?T.regexp.source:"";return this.key===T.key&&N===z}return!1}substituteConstants(){return this}evaluate(T){const N=T.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const T=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${T}`}keys(){return[this.key]}map(T){return T.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(T){this._actual=T,this.type=8}static create(T){return new s(T)}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new s(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function a(F){let T=null;for(let N=0,z=F.length;N<z;N++){const V=F[N].substituteConstants();if(F[N]!==V&&T===null){T=[];for(let J=0;J<N;J++)T[J]=F[J]}T!==null&&(T[N]=V)}return T===null?F:T}class c{constructor(T,N){this.expr=T,this.negated=N,this.type=6}static create(T,N){return c._normalizeArr(T,N)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let N=0,z=this.expr.length;N<z;N++){const V=I(this.expr[N],T.expr[N]);if(V!==0)return V}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].equals(T.expr[N]))return!1;return!0}return!1}substituteConstants(){const T=a(this.expr);return T===this.expr?this:c.create(T,this.negated)}evaluate(T){for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].evaluate(T))return!1;return!0}static _normalizeArr(T,N){const z=[];let V=!1;for(const J of T)if(!!J){if(J.type===1){V=!0;continue}if(J.type===0)return E.INSTANCE;if(J.type===6){z.push(...J.expr);continue}z.push(J)}if(z.length===0&&V)return v.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(I);for(let J=1;J<z.length;J++)z[J-1].equals(z[J])&&(z.splice(J,1),J--);if(z.length===1)return z[0];for(;z.length>1;){const J=z[z.length-1];if(J.type!==9)break;z.pop();const $=z.pop(),Q=z.length===0,H=o.create(J.expr.map(B=>c.create([B,$],null)),null,Q);H&&(z.push(H),z.sort(I))}return z.length===1?z[0]:new c(z,N)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const N of this.expr)T.push(...N.keys());return T}map(T){return new c(this.expr.map(N=>N.map(T)),null)}negate(){if(!this.negated){const T=[];for(const N of this.expr)T.push(N.negate());this.negated=o.create(T,this,!0)}return this.negated}}class o{constructor(T,N){this.expr=T,this.negated=N,this.type=9}static create(T,N,z){return o._normalizeArr(T,N,z)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let N=0,z=this.expr.length;N<z;N++){const V=I(this.expr[N],T.expr[N]);if(V!==0)return V}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].equals(T.expr[N]))return!1;return!0}return!1}substituteConstants(){const T=a(this.expr);return T===this.expr?this:o.create(T,this.negated,!1)}evaluate(T){for(let N=0,z=this.expr.length;N<z;N++)if(this.expr[N].evaluate(T))return!0;return!1}static _normalizeArr(T,N,z){let V=[],J=!1;if(T){for(let $=0,Q=T.length;$<Q;$++){const H=T[$];if(!!H){if(H.type===0){J=!0;continue}if(H.type===1)return v.INSTANCE;if(H.type===9){V=V.concat(H.expr);continue}V.push(H)}}if(V.length===0&&J)return E.INSTANCE;V.sort(I)}if(V.length!==0){if(V.length===1)return V[0];for(let $=1;$<V.length;$++)V[$-1].equals(V[$])&&(V.splice($,1),$--);if(V.length===1)return V[0];if(z){for(let $=0;$<V.length;$++)for(let Q=$+1;Q<V.length;Q++)U(V[$],V[Q])&&(V.splice(Q,1),Q--);if(V.length===1)return V[0]}return new o(V,N)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const N of this.expr)T.push(...N.keys());return T}map(T){return new o(this.expr.map(N=>N.map(T)),null)}negate(){if(!this.negated){const T=[];for(const N of this.expr)T.push(N.negate());for(;T.length>1;){const N=T.shift(),z=T.shift(),V=[];for(const $ of _(N))for(const Q of _(z))V.push(c.create([$,Q],null));const J=T.length===0;T.unshift(o.create(V,null,J))}this.negated=T[0]}return this.negated}}class l extends y{constructor(T,N,z){super(T,null);this._defaultValue=N,typeof z=="object"?l._info.push({...z,key:T}):z!==!0&&l._info.push({key:T,description:z,type:N!=null?typeof N:void 0})}static all(){return l._info.values()}bindTo(T){return T.createKey(this.key,this._defaultValue)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return d.create(this.key,T)}notEqualsTo(T){return p.create(this.key,T)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(F,T){return F<T?-1:F>T?1:0}function P(F,T,N,z){return F<N?-1:F>N?1:T<z?-1:T>z?1:0}function U(F,T){if(T.type===6&&F.type!==9&&F.type!==6){for(const V of T.expr)if(F.equals(V))return!0}const N=F.negate(),z=_(N).concat(_(T));z.sort(I);for(let V=0;V<z.length;V++){const $=z[V].negate();for(let Q=V+1;Q<z.length;Q++){const H=z[Q];if($.equals(H))return!0}}return!1}e.implies=U;function _(F){return F.type===9?F.expr:[F]}}),define(ne[89],re([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function i(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=i;class k{async getPerformanceInfo(A,b){return{}}async getSystemInfo(A,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,b){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=k}),define(ne[90],re([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ne[15],re([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[28],re([0,1,142,5]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDefaultExtensionsProfileInitService=e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function L(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function A(p,m){switch(p){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function b(p,m){return m==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function C(p,m,u){return b(m,u)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===u?!0:R(u).includes(p)}e.isTargetPlatformCompatible=C;function R(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=R;function I(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=I;var E;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var v;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var y;(function(p){p.Install="install",p.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var d;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var S;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(m,u){super(m);this.code=u,this.name=u}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,i.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,i.createDecorator)("IExtensionManagementCLIService"),e.IDefaultExtensionsProfileInitService=(0,i.createDecorator)("IDefaultExtensionsProfileInitService")}),define(ne[175],re([0,1,3,2,63,30,7,128,28]),function(X,e,D,i,k,L,A,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function R(w,p){return A.URI.revive(p?p.transformIncoming(w):w)}function I(w,p){return p?p.transformOutgoingURI(w):w}function E(w,p){p=p||b.DefaultURITransformer;const m=w.manifest;return{...(0,b.transformAndReviveIncomingURIs)({...w,manifest:void 0},p),manifest:m}}function v(w,p){return p?(0,L.cloneAndChange)(w,m=>m instanceof A.URI?p.transformOutgoingURI(m):void 0):w}class y{constructor(p,m){this.service=p,this.getUriTransformer=m,this.onInstallExtension=D.Event.buffer(p.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(p.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(p.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(p.onDidUninstallExtension,!0)}listen(p,m){const u=this.getUriTransformer(p);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,g=>g.map(h=>({...h,local:h.local?v(h.local,u):h.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(p,m,u){const g=this.getUriTransformer(p);switch(m){case"zip":return this.service.zip(E(u[0],g)).then(h=>I(h,g));case"unzip":return this.service.unzip(R(u[0],g));case"install":return this.service.install(R(u[0],g),(0,k.revive)(u[1]));case"getManifest":return this.service.getManifest(R(u[0],g));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(u[0]);case"installFromGallery":return this.service.installFromGallery(u[0],(0,k.revive)(u[1]));case"uninstall":return this.service.uninstall(E(u[0],g),(0,k.revive)(u[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(E(u[0],g));case"getInstalled":return this.service.getInstalled(u[0],A.URI.revive(u[1])).then(h=>h.map(r=>v(r,g)));case"getMetadata":return this.service.getMetadata(E(u[0],g));case"updateMetadata":return this.service.updateMetadata(E(u[0],g),u[1]).then(h=>v(h,g));case"updateExtensionScope":return this.service.updateExtensionScope(E(u[0],g),u[1]).then(h=>v(h,g));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class d extends i.Disposable{constructor(p){super();this.channel=p,this._onInstallExtension=this._register(new D.Emitter),this._onDidInstallExtensions=this._register(new D.Emitter),this._onUninstallExtension=this._register(new D.Emitter),this._onDidUninstallExtension=this._register(new D.Emitter),this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?A.URI.revive(m.source):m.source,profileLocation:A.URI.revive(m.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(u=>({...u,local:u.local?E(u.local,null):u.local,source:this.isUriComponents(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire({identifier:m.identifier,profileLocation:A.URI.revive(m.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire({...m,profileLocation:A.URI.revive(m.profileLocation)})))}get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}isUriComponents(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(p){const m=await this.getTargetPlatform();return p.allTargetPlatforms.some(u=>(0,C.isTargetPlatformCompatible)(u,p.allTargetPlatforms,m))}zip(p){return Promise.resolve(this.channel.call("zip",[p]).then(m=>A.URI.revive(m)))}unzip(p){return Promise.resolve(this.channel.call("unzip",[p]))}install(p,m){return Promise.resolve(this.channel.call("install",[p,m])).then(u=>E(u,null))}getManifest(p){return Promise.resolve(this.channel.call("getManifest",[p]))}installFromGallery(p,m){return Promise.resolve(this.channel.call("installFromGallery",[p,m])).then(u=>E(u,null))}uninstall(p,m){return Promise.resolve(this.channel.call("uninstall",[p,m]))}reinstallFromGallery(p){return Promise.resolve(this.channel.call("reinstallFromGallery",[p]))}getInstalled(p=null,m){return Promise.resolve(this.channel.call("getInstalled",[p,m])).then(u=>u.map(g=>E(g,null)))}getMetadata(p){return Promise.resolve(this.channel.call("getMetadata",[p]))}updateMetadata(p,m){return Promise.resolve(this.channel.call("updateMetadata",[p,m])).then(u=>E(u,null))}updateExtensionScope(p,m){return Promise.resolve(this.channel.call("updateExtensionScope",[p,m])).then(u=>E(u,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class S{constructor(p){this.service=p}listen(p,m){throw new Error("Invalid listen")}call(p,m,u){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=S}),define(ne[91],re([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function k(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var L;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[13],re([0,1,34,12,26,14,7,149,5]),function(X,e,D,i,k,L,A,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function R($){return $.create===!0}e.isFileOpenForWriteOptions=R;var I;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var E;(function($){$[$.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var v;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileClone=32768]="FileClone"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y($){return!!($.capabilities&2)}e.hasReadWriteCapability=y;function d($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=d;function S($){return!!($.capabilities&32768)}e.hasFileCloneCapability=S;function w($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function p($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=p;function m($){return y($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var u;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(Q,H){super(Q);this.code=H}}e.FileSystemProviderError=g;function h($,Q){const H=new g($.toString(),Q);return n(H,Q),H}e.createFileSystemProviderError=h;function r($){return $||h((0,b.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=r;function n($,Q){return $.name=Q?`${Q} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=n;function t($){if(!$)return u.Unknown;if($ instanceof g)return $.code;const Q=/^(.+) \(FileSystemError\)$/.exec($.name);if(!Q)return u.Unknown;switch(Q[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=t;function s($){if($ instanceof P)return $.fileOperationResult;switch(t($)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var a;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class c{constructor(Q,H,B){this.resource=Q,this.operation=H,this.target=B}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=c;var o;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(Q,H){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=Q;const B=new Map;for(const Y of Q){const ie=B.get(Y.type);switch(ie?ie.push([Y.resource,Y]):B.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,ie]of B)switch(Y){case 1:this.added=D.TernarySearchTree.forUris(()=>H),this.added.fill(ie);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>H),this.updated.fill(ie);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>H),this.deleted.fill(ie);break}}contains(Q,...H){return this.doContains(Q,{includeChildren:!1},...H)}affects(Q,...H){return this.doContains(Q,{includeChildren:!0},...H)}doContains(Q,H,...B){if(!Q)return!1;const Y=B.length>0;return!!((!Y||B.includes(1))&&(this.added?.get(Q)||H.includeChildren&&this.added?.findSuperstr(Q))||(!Y||B.includes(0))&&(this.updated?.get(Q)||H.includeChildren&&this.updated?.findSuperstr(Q))||(!Y||B.includes(2))&&(this.deleted?.findSubstr(Q)||H.includeChildren&&this.deleted?.findSuperstr(Q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function f($,Q,H){return!$||!Q||$===Q||Q.length>$.length?!1:(Q.charAt(Q.length-1)!==i.sep&&(Q+=i.sep),H?(0,k.startsWithIgnoreCase)($,Q):$.indexOf(Q)===0)}e.isParent=f;class P extends Error{constructor(Q,H,B){super(Q);this.fileOperationResult=H,this.options=B}}e.FileOperationError=P;class U extends P{constructor(Q,H,B){super(Q,2,B);this.stat=H}}e.NotModifiedSinceFileOperationError=U;var _;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function T($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=T;async function N($,Q){if(!Q.hasProvider(A.URI.from({scheme:$.scheme})))return new Promise(H=>{const B=Q.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===$.scheme&&Y.added&&(B.dispose(),H())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(Q){return(0,L.isNumber)(Q)||(Q=0),Q<z.KB?(0,b.localize)(1,null,Q.toFixed(0)):Q<z.MB?(0,b.localize)(2,null,(Q/z.KB).toFixed(2)):Q<z.GB?(0,b.localize)(3,null,(Q/z.MB).toFixed(2)):Q<z.TB?(0,b.localize)(4,null,(Q/z.GB).toFixed(2)):(0,b.localize)(5,null,(Q/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var V;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function J($){return{maxFileSize:$===0?300*z.MB:16*z.GB,maxHeapSize:$===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=J});var K=this&&this.__param||function(X,e){return function(D,i){e(D,i,X)}};define(ne[176],re([0,1,177,41,13]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(b){this.fileService=b}async checksum(b){const C=(await this.fileService.readFileStream(b)).value;return new Promise((R,I)=>{const E=(0,D.createHash)("md5");(0,i.listenStream)(C,{onData:v=>E.update(v.buffer),onError:v=>I(v),onEnd:()=>R(E.digest("base64").replace(/=+$/,""))})})}};L=ge([K(0,k.IFileService)],L),e.ChecksumService=L}),define(ne[178],re([0,1,16,38,9,3,2,41,7,31,13]),function(X,e,D,i,k,L,A,b,C,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends A.Disposable{constructor(y,d){super();this.channel=y,this.extraCapabilities=d,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,R.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,d){const{buffer:S}=await this.channel.call("readFile",[y,d]);return S}readFileStream(y,d,S){const w=(0,b.newWriteableStream)(m=>D.VSBuffer.concat(m.map(u=>D.VSBuffer.wrap(u))).buffer),p=this.channel.listen("readFileStream",[y,d])(m=>{if(m instanceof D.VSBuffer)w.write(m.buffer);else{if(m==="end")w.end();else{let u=m;u instanceof Error||(u=(0,I.createFileSystemProviderError)((0,i.toErrorMessage)(u),I.FileSystemProviderErrorCode.Unknown)),w.error(u),w.end()}p.dispose()}});return S.onCancellationRequested(()=>{w.error((0,k.canceled)()),w.end(),p.dispose()}),w}writeFile(y,d,S){return this.channel.call("writeFile",[y,D.VSBuffer.wrap(d),S])}open(y,d){return this.channel.call("open",[y,d])}close(y){return this.channel.call("close",[y])}async read(y,d,S,w,p){const[m,u]=await this.channel.call("read",[y,d,p]);return S.set(m.buffer.slice(0,u),w),u}write(y,d,S,w,p){return this.channel.call("write",[y,d,D.VSBuffer.wrap(S),w,p])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,d){return this.channel.call("delete",[y,d])}rename(y,d,S){return this.channel.call("rename",[y,d,S])}copy(y,d,S){return this.channel.call("copy",[y,d,S])}cloneFile(y,d){return this.channel.call("cloneFile",[y,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const d=y;this._onDidChange.fire(d.map(S=>({resource:C.URI.revive(S.resource),type:S.type})))}else{const d=y;this._onDidWatchError.fire(d)}}))}watch(y,d){const S=(0,R.generateUuid)();return this.channel.call("watch",[this.sessionId,S,y,d]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=E}),define(ne[92],re([0,1,16,9,150,13]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(I,E,v,y,d,S){let w;try{await b(I,E,v,y,d,S)}catch(p){w=p}finally{w&&d.errorTransformer&&(w=d.errorTransformer(w)),typeof w!="undefined"&&v.error(w),v.end()}}e.readFileIntoStream=A;async function b(I,E,v,y,d,S){C(S);const w=await I.open(E,{create:!1});try{C(S);let p=0,m=0,u=d&&typeof d.length=="number"?d.length:void 0,g=D.VSBuffer.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),h=d&&typeof d.position=="number"?d.position:0,r=0;do m=await I.read(w,h,g.buffer,r,g.byteLength-r),h+=m,r+=m,p+=m,typeof u=="number"&&(u-=m),r===g.byteLength&&(await v.write(y(g)),g=D.VSBuffer.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),r=0);while(m>0&&(typeof u!="number"||u>0)&&C(S)&&R(p,d));if(r>0){let n=r;typeof u=="number"&&(n=Math.min(r,u)),v.write(y(g.slice(0,n)))}}catch(p){throw(0,L.ensureFileSystemProviderError)(p)}finally{await I.close(w)}}function C(I){if(I.isCancellationRequested)throw(0,i.canceled)();return!0}function R(I,E){if(E?.limits){if(typeof E.limits.memory=="number"&&I>E.limits.memory)throw(0,L.createFileSystemProviderError)((0,k.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&I>E.limits.size)throw(0,L.createFileSystemProviderError)((0,k.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[57],re([0,1,81,2,12,4,7,13]),function(X,e,D,i,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function C(p){return p.recursive===!0}e.isRecursiveWatchRequest=C;class R extends i.Disposable{constructor(m,u,g,h){super();this.onFileChanges=m,this.onLogMessage=u,this.verboseLogging=g,this.options=h,this.watcherDisposables=this._register(new i.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new i.DisposableStore;this.watcherDisposables.value=m,this.watcher=this.createWatcher(m),this.watcher.setVerboseLogging(this.verboseLogging),m.add(this.watcher.onDidChangeFile(u=>this.onFileChanges(u))),m.add(this.watcher.onDidLogMessage(u=>this.onLogMessage(u))),m.add(this.watcher.onDidError(u=>this.onError(u)))}onError(m){this.options.restartOnError?this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`):this.error(m)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.watcher?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.watcher?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${m}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=R,R.MAX_RESTARTS=5;class I extends R{constructor(m,u,g){super(m,u,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class E extends R{constructor(m,u,g){super(m,u,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function v(p){return p.map(m=>({type:m.type,resource:A.URI.file(m.path)}))}e.toFileChanges=v;function y(p){const m=new w;for(const u of p)m.processEvent(u);return m.coalesce()}e.coalesceEvents=y;function d(p,m){return typeof m=="string"&&!m.startsWith(D.GLOBSTAR)&&!(0,k.isAbsolute)(m)?{base:p,pattern:m}:m}e.normalizeWatcherPattern=d;function S(p,m){const u=[];for(const g of m)u.push((0,D.parse)(d(p,g)));return u}e.parseWatcherPatterns=S;class w{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(m){return L.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const u=this.mapPathToChange.get(this.toKey(m));let g=!1;if(u){const h=u.type,r=m.type;u.path!==m.path&&(m.type===2||m.type===1)?g=!0:h===1&&r===2?(this.mapPathToChange.delete(this.toKey(m)),this.coalesced.delete(u)):h===2&&r===1?u.type=0:h===1&&r===0||(u.type=r)}else g=!0;g&&(this.coalesced.add(m),this.mapPathToChange.set(this.toKey(m),m))}coalesce(){const m=[],u=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(m.push(g),!1):!0).sort((g,h)=>g.path.length-h.path.length).filter(g=>u.some(h=>(0,b.isParent)(g.path,h,!L.isLinux))?!1:(u.push(g.path),!0)).concat(m)}}}),define(ne[179],re([0,1,54,6,21,42,2,79,12,4,130,27,57]),function(X,e,D,i,k,L,A,b,C,R,I,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends A.Disposable{constructor(w,p,m,u){super();this.request=w,this.onDidFilesChange=p,this.onLogMessage=m,this.verboseLogging=u,this.throttledFileChangesWorker=new i.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},g=>this.onDidFilesChange(g)),this.fileChangesDelayer=this._register(new i.ThrottledDelayer(y.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,v.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,v.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const w=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await E.Promises.stat(w);this._register(await this.doWatch(w,p.isDirectory()))}catch(w){w.code!=="ENOENT"?this.error(w):this.trace(w)}}async normalizePath(w){let p=w.path;try{p=await E.Promises.realpath(w.path),w.path===p&&(p=await(0,I.realcase)(w.path)??w.path),w.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${p})`)}catch{}return p}async doWatch(w,p){if(R.isMacintosh&&(0,L.isEqualOrParent)(w,"/Volumes/",!0))return this.error(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const m=new k.CancellationTokenSource(this.cts.token),u=new A.DisposableStore;try{const g=(0,C.basename)(w),h=(0,D.watch)(w);u.add((0,A.toDisposable)(()=>{h.removeAllListeners(),h.close()})),this.trace(`Started watching: '${w}'`);const r=new Set;if(p)try{for(const t of await E.Promises.readdir(w))r.add(t)}catch(t){this.error(t)}const n=new Map;u.add((0,A.toDisposable)(()=>{for(const[,t]of n)t.dispose();n.clear()})),h.on("error",(t,s)=>{this.error(`Failed to watch ${w} for changes using fs.watch() (${t}, ${s})`),this.dispose()}),h.on("change",(t,s)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${s}`);let a="";if(s&&(a=s.toString(),R.isMacintosh&&(a=(0,b.normalizeNFC)(a))),!(!a||t!=="change"&&t!=="rename"))if(p)if(t==="rename"){n.get(a)?.dispose();const c=setTimeout(async()=>{if(n.delete(a),a===g&&!await E.Promises.exists(w)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.existsChildStrictCase((0,C.join)(w,a));if(m.token.isCancellationRequested)return;let l;o?r.has(a)?l=0:(l=1,r.add(a)):(r.delete(a),l=2),this.onFileChange({path:(0,C.join)(this.request.path,a),type:l})},y.FILE_DELETE_HANDLER_DELAY);n.set(a,(0,A.toDisposable)(()=>clearTimeout(c)))}else{let c;r.has(a)?c=0:(c=1,r.add(a)),this.onFileChange({path:(0,C.join)(this.request.path,a),type:c})}else if(t==="rename"||a!==g){const c=setTimeout(async()=>{const o=await E.Promises.exists(w);m.token.isCancellationRequested||(o?(this.onFileChange({path:this.request.path,type:0},!0),u.add(await this.doWatch(w,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);u.clear(),u.add((0,A.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(g){await E.Promises.exists(w)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${w} for changes using fs.watch() (${g.toString()})`)}return(0,A.toDisposable)(()=>{m.dispose(!0),u.dispose()})}async onFileChange(w,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!p&&this.excludes.some(m=>m(w.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${w.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(m=>m(w.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${w.path}`):this.fileChangesBuffer.push(w);try{await this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const u=(0,v.coalesceEvents)(m);if(u.length>0){if(this.verboseLogging)for(const h of u)this.trace(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);this.throttledFileChangesWorker.work(u)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(w){if(R.isLinux)return E.Promises.exists(w);try{const p=(0,C.basename)(w);return(await E.Promises.readdir((0,C.dirname)(w))).some(u=>u===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(w){this.verboseLogging=w}error(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}warn(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}trace(w){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.FILE_DELETE_HANDLER_DELAY=100,y.FILE_CHANGES_HANDLER_DELAY=50;async function d(S,w,p,m,u=512){const g=await E.Promises.open(S,"r"),h=Buffer.allocUnsafe(u),r=new k.CancellationTokenSource(m);let n,t=!1;const s={path:S,excludes:[],recursive:!1},a=new y(s,c=>{(async()=>{for(const{type:o}of c)if(o===0){if(t)return;t=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:l}=await E.Promises.read(g,h,0,u,null);if(!l||r.token.isCancellationRequested)break;w(h.slice(0,l))}}catch(l){n=new Error(l),r.dispose(!0)}finally{t=!1}}})()});return await a.ready,p(),new Promise((c,o)=>{r.token.onCancellationRequested(async()=>{a.dispose();try{await E.Promises.close(g)}catch(l){n=new Error(l)}n?o(n):c()})})}e.watchFileContents=d}),define(ne[180],re([0,1,3,81,2,4,179]),function(X,e,D,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends k.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(R){const I=this.normalizeRequests(R),E=I.filter(y=>{const d=this.watchers.get(y.path);return d?!(0,i.patternsEquals)(d.request.excludes,y.excludes)||!(0,i.patternsEquals)(d.request.includes,y.includes):!0}),v=Array.from(this.watchers.values()).filter(({request:y})=>!I.find(d=>d.path===y.path&&(0,i.patternsEquals)(d.excludes,y.excludes)&&(0,i.patternsEquals)(d.includes,y.includes))).map(({request:y})=>y.path);E.length&&this.trace(`Request to start watching: ${E.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const y of v)this.stopWatching(y);for(const y of E)this.startWatching(y)}startWatching(R){const I=new A.NodeJSFileWatcherLibrary(R,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),E={request:R,instance:I};this.watchers.set(R.path,E)}async stop(){for(const[R]of this.watchers)this.stopWatching(R);this.watchers.clear()}stopWatching(R){const I=this.watchers.get(R);I&&(this.watchers.delete(R),I.instance.dispose())}normalizeRequests(R){const I=new Map;for(const E of R){const v=L.isLinux?E.path:E.path.toLowerCase();I.set(v,E)}return Array.from(I.values())}async setVerboseLogging(R){this.verboseLogging=R;for(const[,I]of this.watchers)I.instance.setVerboseLogging(R)}trace(R){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(R)})}toMessage(R,I){return I?`[File Watcher (node.js)] ${R} (path: ${I.request.path})`:`[File Watcher (node.js)] ${R}`}}e.NodeJSWatcher=b}),define(ne[181],re([0,1,57,180]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends D.AbstractNonRecursiveWatcherClient{constructor(A,b,C){super(A,b,C);this.init()}createWatcher(){return new i.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ne[182],re([0,1,20,39,64,57]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends L.AbstractUniversalWatcherClient{constructor(C,R,I){super(C,R,I);this.init()}createWatcher(C){const R=C.add(new k.Client(D.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(R.onDidProcessExit(({code:I,signal:E})=>this.onError(`terminated by itself with code ${I}, signal: ${E}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(R.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ne[93],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...k){this._entries=new Map;for(const[L,A]of k)this.set(L,A)}set(k,L){const A=this._entries.get(k);return this._entries.set(k,L),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=D}),define(ne[183],re([0,1,6,9,56,172,5,93]),function(X,e,D,i,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class R extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class I{constructor(d=new b.ServiceCollection,S=!1,w){this._activeInstantiations=new Set,this._services=d,this._strict=S,this._parent=w,this._services.set(A.IInstantiationService,this)}createChild(d){return new I(d,this._strict,this)}invokeFunction(d,...S){const w=v.traceInvocation(d);let p=!1;try{return d({get:u=>{if(p)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(u,w);if(!g)throw new Error(`[invokeFunction] unknown service '${u}'`);return g}},...S)}finally{p=!0,w.stop()}}createInstance(d,...S){let w,p;return d instanceof k.SyncDescriptor?(w=v.traceCreation(d.ctor),p=this._createInstance(d.ctor,d.staticArguments.concat(S),w)):(w=v.traceCreation(d),p=this._createInstance(d,S,w)),w.stop(),p}_createInstance(d,S=[],w){const p=A._util.getServiceDependencies(d).sort((g,h)=>g.index-h.index),m=[];for(const g of p){const h=this._getOrCreateServiceInstance(g.id,w);h||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${g.id}.`,!1),m.push(h)}const u=p.length>0?p[0].index:S.length;if(S.length!==u){console.trace(`[createInstance] First service dependency of ${d.name} at position ${u+1} conflicts with ${S.length} static arguments`);const g=u-S.length;g>0?S=S.concat(new Array(g)):S=S.slice(0,u)}return new d(...[...S,...m])}_setServiceInstance(d,S){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,S);else if(this._parent)this._parent._setServiceInstance(d,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const S=this._services.get(d);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):S}_getOrCreateServiceInstance(d,S){const w=this._getServiceInstanceOrDescriptor(d);return w instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,w,S.branch(d,!0)):(S.branch(d,!1),w)}_safeCreateAndCacheServiceInstance(d,S,w){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,S,w)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,S,w){const p=new L.Graph(g=>g.id.toString());let m=0;const u=[{id:d,desc:S,_trace:w}];for(;u.length;){const g=u.pop();if(p.lookupOrInsertNode(g),m++>1e3)throw new R(p);for(const h of A._util.getServiceDependencies(g.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(h.id);if(r||this._throwIfStrict(`[createInstance] ${d} depends on ${h.id} which is NOT registered.`,!0),r instanceof k.SyncDescriptor){const n={id:h.id,desc:r,_trace:g._trace.branch(h.id,!0)};p.insertEdge(g,n),u.push(n)}}}for(;;){const g=p.roots();if(g.length===0){if(!p.isEmpty())throw new R(p);break}for(const{data:h}of g){if(this._getServiceInstanceOrDescriptor(h.id)instanceof k.SyncDescriptor){const n=this._createServiceInstanceWithOwner(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this._setServiceInstance(h.id,n)}p.removeNode(h)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,S,w=[],p,m){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(S,w,p,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,S,w,p,m);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(d,S=[],w,p){if(w){const m=new D.IdleValue(()=>this._createInstance(d,S,p));return new Proxy(Object.create(null),{get(u,g){if(g in u)return u[g];const h=m.value;let r=h[g];return typeof r!="function"||(r=r.bind(h),u[g]=r),r},set(u,g,h){return m.value[g]=h,!0}})}else return this._createInstance(d,S,p)}_throwIfStrict(d,S){if(S&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=I;var E;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(E||(E={}));class v{constructor(d,S){this.type=d,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return C?new v(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(d){return C?new v(0,d.name):v._None}branch(d,S){const w=new v(2,d.toString());return this._dep.push([d,S,w]),w}stop(){const d=Date.now()-this._start;v._totals+=d;let S=!1;function w(m,u){const g=[],h=new Array(m+1).join("	");for(const[r,n,t]of u._dep)if(n&&t){S=!0,g.push(`${h}CREATES -> ${r}`);const s=w(m+1,t);s&&g.push(s)}else g.push(`${h}uses -> ${r}`);return g.join(`
`)}const p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(d>2||S)&&console.log(p.join(`
`))}}e.Trace=v,v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(ne[184],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(k,L){this.server=k,this.router=L}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,L){this.server.registerChannel(k,L)}}e.MessagePortMainProcessService=D}),define(ne[94],re([0,1,39,56,88,5]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(y,d,S){const w=S.getChannel(y);return b(d)?new d.channelClientCtor(w):D.ProxyChannel.toService(w,d?.proxyOptions)}}function b(v){return!!v?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let C=class extends A{constructor(y,d,S){super(y,d,S)}};C=ge([K(2,e.IMainProcessService)],C);function R(v,y,d){(0,k.registerSingleton)(v,new i.SyncDescriptor(C,[y,d],d?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=R,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let I=class extends A{constructor(y,d,S){super(y,d,S)}};I=ge([K(2,e.ISharedProcessService)],I);function E(v,y,d){(0,k.registerSingleton)(v,new i.SyncDescriptor(I,[y,d],d?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(ne[66],re([0,1,21,2,4,152,28,5]),function(X,e,D,i,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,b.createDecorator)("languagePackService");let C=class extends i.Disposable{constructor(I){super();this.extensionGalleryService=I}async getAvailableLanguages(){const I=new D.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let E;try{E=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const y=E.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(S=>S.startsWith("lp-"))).map(d=>{const S=d.properties.localizedLanguages?.[0],w=this.getLocale(d);return{...this.createQuickPickItem({locale:w,label:S}),extensionId:d.identifier.id,galleryExtension:d}});return y.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),y}getLocale(I){return I.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(I){const E=I.label??I.locale;let v=I.locale!==I.label?I.locale:void 0;return I.locale.toLowerCase()===k.language.toLowerCase()&&(v||(v=""),v+=(0,L.localize)(0,null)),{id:I.locale,label:E,description:v}}};C=ge([K(0,A.IExtensionGalleryService)],C),e.LanguagePackBaseService=C}),define(ne[185],re([0,1,2,66]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends D.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=ge([K(0,i.ILanguagePackService)],k),e.LocalizationsUpdater=k}),define(ne[8],re([0,1,38,3,2,4,5]),function(X,e,D,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function b(){return new Date().toISOString()}var C;(function(n){n[n.Trace=0]="Trace",n[n.Debug=1]="Debug",n[n.Info=2]="Info",n[n.Warning=3]="Warning",n[n.Error=4]="Error",n[n.Critical=5]="Critical",n[n.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function R(n,t,s){switch(t){case C.Trace:n.trace(s);break;case C.Debug:n.debug(s);break;case C.Info:n.info(s);break;case C.Warning:n.warn(s);break;case C.Error:n.error(s);break;case C.Critical:n.critical(s);break;default:throw new Error("Invalid log level")}}e.log=R;function I(n){let t="";for(let s=0;s<n.length;s++){let a=n[s];if(typeof a=="object")try{a=JSON.stringify(a)}catch{}t+=(s>0?" ":"")+a}return t}e.format=I;class E extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class v extends E{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(C.Trace)&&this.log(C.Trace,I([t,...s]))}debug(t,...s){this.checkLogLevel(C.Debug)&&this.log(C.Debug,I([t,...s]))}info(t,...s){this.checkLogLevel(C.Info)&&this.log(C.Info,I([t,...s]))}warn(t,...s){this.checkLogLevel(C.Warning)&&this.log(C.Warning,I([t,...s]))}error(t,...s){if(this.checkLogLevel(C.Error))if(t instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=t.stack,this.log(C.Error,I(a))}else this.log(C.Error,I([t,...s]))}critical(t,...s){this.checkLogLevel(C.Critical)&&this.log(C.Critical,I([t,...s]))}flush(){}}e.AbstractMessageLogger=v;class y extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...s){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${b()}][0m`,t,...s):console.log(`[main ${b()}]`,t,...s))}debug(t,...s){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${b()}][0m`,t,...s):console.log(`[main ${b()}]`,t,...s))}info(t,...s){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${b()}][0m`,t,...s):console.log(`[main ${b()}]`,t,...s))}warn(t,...s){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${b()}][0m`,t,...s):console.warn(`[main ${b()}]`,t,...s))}error(t,...s){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${b()}][0m`,t,...s):console.error(`[main ${b()}]`,t,...s))}critical(t,...s){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${b()}][0m`,t,...s):console.error(`[main ${b()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class d extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=d;class S extends E{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class w extends E{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const a of this.logServices)a.trace(t,...s)}debug(t,...s){for(const a of this.logServices)a.debug(t,...s)}info(t,...s){for(const a of this.logServices)a.info(t,...s)}warn(t,...s){for(const a of this.logServices)a.warn(t,...s)}error(t,...s){for(const a of this.logServices)a.error(t,...s)}critical(t,...s){for(const a of this.logServices)a.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=w;class p extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=p;class m extends k.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(a))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let a=this.loggers.get(t.toString());return a||(a=this.doCreateLogger(t,s?.always?C.Trace:this.logLevel,s),this.loggers.set(t.toString(),a),s?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=m;class u{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(t){}getLevel(){return C.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=u;function g(n){if(n.verbose)return C.Trace;if(typeof n.logLevel=="string"){const t=h(n.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function h(n){switch(n){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=h;function r(n){switch(n){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=r}),define(ne[186],re([0,1,6,9,2,12,27,15,8]),function(X,e,D,i,k,L,A,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let R=class extends k.Disposable{constructor(E,v){super();this.environmentService=E,this.logService=v,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,L.basename)(this.environmentService.logsPath),v=(0,L.dirname)(this.environmentService.logsPath),S=(await A.Promises.readdir(v)).filter(p=>/^\d{8}T\d{6}$/.test(p)).sort().filter(p=>p!==E),w=S.slice(0,Math.max(0,S.length-9));w.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(p=>A.Promises.rm((0,L.join)(v,p)))))}catch(E){(0,i.onUnexpectedError)(E)}}};R=ge([K(0,b.IEnvironmentService),K(1,C.ILogService)],R),e.LogsDataCleaner=R}),define(ne[187],re([0,1,6,9,2,12,27,15,8]),function(X,e,D,i,k,L,A,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let R=class gt extends k.Disposable{constructor(E,v,y){super();this.backupWorkspacesPath=E,this.environmentService=v,this.logService=y,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),y=JSON.parse(E).emptyWorkspaceInfos.map(S=>S.backupFolder),d=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(d.map(async S=>{S.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||S===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||y.indexOf(S)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${S}.`),await A.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(E){(0,i.onUnexpectedError)(E)}}};R.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,R.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",R=ge([K(1,b.INativeEnvironmentService),K(2,C.ILogService)],R),e.StorageDataCleaner=R}),define(ne[188],re([0,1,18,6,9,3,2,12,57,8]),function(X,e,D,i,k,L,A,b,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends A.Disposable{constructor(v,y){super();this.logService=v,this.options=y,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new i.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}watch(v,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,y):this.watchNonRecursive(v,y)}watchUniversal(v,y){const d={path:this.toFilePath(v),excludes:y.excludes,includes:y.includes,recursive:y.recursive},S=(0,D.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,k.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,C.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===R.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===R.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const y of this.universalPathsToWatch)(0,C.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const y of this.universalPathsToWatch)(0,C.isRecursiveWatchRequest)(y)&&v.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,y){const d={path:this.toFilePath(v),excludes:y.excludes,includes:y.includes,recursive:!1},S=(0,D.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,k.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,C.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===R.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===R.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,b.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(ne[189],re([0,1,18,6,16,21,3,62,52,2,34,20,190,17,41,148,13,92,8]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class extends R.Disposable{constructor(h){super();this.logService=h,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new i.ResourceQueue)}registerProvider(h,r){if(this.provider.has(h))throw new Error(`A filesystem provider for the scheme '${h}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${h}`);const n=new R.DisposableStore;return this.provider.set(h,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:h,provider:r}),n.add(r.onDidChangeFile(t=>this._onDidFilesChange.fire(new w.FileChangesEvent(t,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&n.add(r.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),n.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:h}))),(0,R.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:h,provider:r}),this.provider.delete(h),(0,R.dispose)(n)})}getProvider(h){return this.provider.get(h)}async activateProvider(h){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:h,join(n){r.push(n)}}),!this.provider.has(h)&&await i.Promises.settled(r)}async canHandleResource(h){return await this.activateProvider(h.scheme),this.hasProvider(h)}hasProvider(h){return this.provider.has(h.scheme)}hasCapability(h,r){const n=this.provider.get(h.scheme);return!!(n&&n.capabilities&r)}listCapabilities(){return C.Iterable.map(this.provider,([h,r])=>({scheme:h,capabilities:r.capabilities}))}async withProvider(h){if(!(0,y.isAbsolutePath)(h))throw new w.FileOperationError((0,S.localize)(0,null,this.resourceForError(h)),8);await this.activateProvider(h.scheme);const r=this.provider.get(h.scheme);if(!r){const n=new Error;throw n.name="ENOPRO",n.message=(0,S.localize)(1,null,h.toString()),n}return r}async withReadProvider(h){const r=await this.withProvider(h);if((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r)||(0,w.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${h.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(h){const r=await this.withProvider(h);if((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${h.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(h,r){try{return await this.doResolveFile(h,r)}catch(n){throw(0,w.toFileSystemProviderErrorCode)(n)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,S.localize)(2,null,this.resourceForError(h)),1):(0,w.ensureFileSystemProviderError)(n)}}async doResolveFile(h,r){const n=await this.withProvider(h),t=this.isPathCaseSensitive(n),s=r?.resolveTo,a=r?.resolveSingleChildDescendants,c=r?.resolveMetadata,o=await n.stat(h);let l;return this.toFileStat(n,h,o,void 0,!!c,(f,P)=>(l||(l=I.TernarySearchTree.forUris(()=>!t),l.set(h,!0),s&&l.fill(!0,s)),l.get(f.resource)||l.findSuperstr(f.resource.with({query:null,fragment:null}))?!0:f.isDirectory&&a?P===1:!1))}async toFileStat(h,r,n,t,s,a){const{providerExtUri:c}=this.getExtUri(h),o={resource:r,name:c.basename(r),isFile:(n.type&w.FileType.File)!=0,isDirectory:(n.type&w.FileType.Directory)!=0,isSymbolicLink:(n.type&w.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&w.FilePermission.Readonly)||Boolean(h.capabilities&2048),etag:(0,w.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(o.isDirectory&&a(o,t)){try{const l=await h.readdir(r),f=await i.Promises.settled(l.map(async([P,U])=>{try{const _=c.joinPath(r,P),F=s?await h.stat(_):{type:U};return await this.toFileStat(h,_,F,l.length,s,a)}catch(_){return this.logService.trace(_),null}}));o.children=(0,D.coalesce)(f)}catch(l){this.logService.trace(l),o.children=[]}return o}return o}async resolveAll(h){return i.Promises.settled(h.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(h){const r=await this.withProvider(h),n=await r.stat(h);return this.toFileStat(r,h,n,void 0,!0,()=>!1)}async exists(h){const r=await this.withProvider(h);try{return!!await r.stat(h)}catch{return!1}}async canCreateFile(h,r){try{await this.doValidateCreateFile(h,r)}catch(n){return n}return!0}async doValidateCreateFile(h,r){if(!r?.overwrite&&await this.exists(h))throw new w.FileOperationError((0,S.localize)(3,null,this.resourceForError(h)),3,r)}async createFile(h,r=k.VSBuffer.fromString(""),n){await this.doValidateCreateFile(h,n);const t=await this.writeFile(h,r);return this._onDidRunOperation.fire(new w.FileOperationEvent(h,0,t)),t}async writeFile(h,r,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h),{providerExtUri:s}=this.getExtUri(t);try{await this.validateWriteFile(t,h,n)||await this.mkdirp(t,s.dirname(h));let c;if((0,w.hasReadWriteCapability)(t)&&!(r instanceof k.VSBuffer))if((0,d.isReadableStream)(r)){const o=await(0,d.peekStream)(r,3);o.ended?c=k.VSBuffer.concat(o.buffer):c=o}else c=(0,d.peekReadable)(r,o=>k.VSBuffer.concat(o),3);else c=r;!(0,w.hasOpenReadWriteCloseCapability)(t)||(0,w.hasReadWriteCapability)(t)&&c instanceof k.VSBuffer?await this.doWriteUnbuffered(t,h,n,c):await this.doWriteBuffered(t,h,n,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this._onDidRunOperation.fire(new w.FileOperationEvent(h,4))}catch(a){throw new w.FileOperationError((0,S.localize)(4,null,this.resourceForError(h),(0,w.ensureFileSystemProviderError)(a).toString()),(0,w.toFileOperationResult)(a),n)}return this.resolve(h,{resolveMetadata:!0})}async validateWriteFile(h,r,n){if(!!n?.unlock&&!(h.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(r)));let s;try{s=await h.stat(r)}catch{return}if((s.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,S.localize)(6,null,this.resourceForError(r)),0,n);if(this.throwIfFileIsReadonly(r,s),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==w.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&n.mtime<s.mtime&&n.etag!==(0,w.etag)({mtime:n.mtime,size:s.size}))throw new w.FileOperationError((0,S.localize)(7,null),3,n);return s}async readFile(h,r,n){const t=await this.withReadProvider(h);return r?.atomic?this.doReadFileAtomic(t,h,r,n):this.doReadFile(t,h,r,n)}async doReadFileAtomic(h,r,n,t){return new Promise((s,a)=>{this.writeQueue.queueFor(r,this.getExtUri(h).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(h,r,n,t);s(c)}catch(c){a(c)}})})}async doReadFile(h,r,n,t){const s=await this.doReadFileStream(h,r,{...n,preferUnbuffered:!0},t);return{...s,value:await(0,k.streamToBuffer)(s.value)}}async readFileStream(h,r,n){const t=await this.withReadProvider(h);return this.doReadFileStream(t,h,r,n)}async doReadFileStream(h,r,n,t){const s=new L.CancellationTokenSource(t),a=this.validateReadFile(r,n).then(o=>o,o=>{throw s.cancel(),o});let c;try{return typeof n?.etag=="string"&&n.etag!==w.ETAG_DISABLED&&await a,n?.atomic&&(0,w.hasFileAtomicReadCapability)(h)||!((0,w.hasOpenReadWriteCloseCapability)(h)||(0,w.hasFileReadStreamCapability)(h))||(0,w.hasReadWriteCapability)(h)&&n?.preferUnbuffered?c=this.readFileUnbuffered(h,r,n):(0,w.hasFileReadStreamCapability)(h)?c=this.readFileStreamed(h,r,s.token,n):c=this.readFileBuffered(h,r,s.token,n),{...await a,value:c}}catch(o){c&&await(0,d.consumeStream)(c);const l=(0,S.localize)(8,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(o).toString());throw o instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(l,o.stat,n):new w.FileOperationError(l,(0,w.toFileOperationResult)(o),n)}}readFileStreamed(h,r,n,t=Object.create(null)){const s=h.readFileStream(r,t,n);return(0,d.transform)(s,{data:a=>a instanceof k.VSBuffer?a:k.VSBuffer.wrap(a),error:a=>new w.FileOperationError((0,S.localize)(9,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(a).toString()),(0,w.toFileOperationResult)(a),t)},a=>k.VSBuffer.concat(a))}readFileBuffered(h,r,n,t=Object.create(null)){const s=(0,k.newWriteableBufferStream)();return(0,p.readFileIntoStream)(h,r,s,a=>a,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new w.FileOperationError((0,S.localize)(10,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(a).toString()),(0,w.toFileOperationResult)(a),t)},n),s}readFileUnbuffered(h,r,n){const t=(0,d.newWriteableStream)(s=>k.VSBuffer.concat(s));return(async()=>{try{let s;n?.atomic&&(0,w.hasFileAtomicReadCapability)(h)?s=await h.readFile(r,{atomic:!0}):s=await h.readFile(r),typeof n?.position=="number"&&(s=s.slice(n.position)),typeof n?.length=="number"&&(s=s.slice(0,n.length)),this.validateReadFileLimits(r,s.byteLength,n),t.end(k.VSBuffer.wrap(s))}catch(s){t.error(s),t.end()}})(),t}async validateReadFile(h,r){const n=await this.resolve(h,{resolveMetadata:!0});if(n.isDirectory)throw new w.FileOperationError((0,S.localize)(11,null,this.resourceForError(h)),0,r);if(typeof r?.etag=="string"&&r.etag!==w.ETAG_DISABLED&&r.etag===n.etag)throw new w.NotModifiedSinceFileOperationError((0,S.localize)(12,null),n,r);return this.validateReadFileLimits(h,n.size,r),n}validateReadFileLimits(h,r,n){if(n?.limits){let t;if(typeof n.limits.memory=="number"&&r>n.limits.memory&&(t=9),typeof n.limits.size=="number"&&r>n.limits.size&&(t=7),typeof t=="number")throw new w.FileOperationError((0,S.localize)(13,null,this.resourceForError(h)),t)}}async canMove(h,r,n){return this.doCanMoveCopy(h,r,"move",n)}async canCopy(h,r,n){return this.doCanMoveCopy(h,r,"copy",n)}async doCanMoveCopy(h,r,n,t){if(h.toString()!==r.toString())try{const s=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h):await this.withReadProvider(h),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(s,h,a,r,n,t)}catch(s){return s}return!0}async move(h,r,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),a=await this.doMoveCopy(t,h,s,r,"move",!!n),c=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(h,a==="move"?2:3,c)),c}async copy(h,r,n){const t=await this.withReadProvider(h),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),a=await this.doMoveCopy(t,h,s,r,"copy",!!n),c=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(h,a==="copy"?3:2,c)),c}async doMoveCopy(h,r,n,t,s,a){if(r.toString()===t.toString())return s;const{exists:c,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(h,r,n,t,s,a);if(c&&!o&&a&&await this.del(t,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(t)),s==="copy"){if(h===n&&(0,w.hasFileFolderCopyCapability)(h))await h.copy(r,t,{overwrite:a});else{const l=await this.resolve(r);l.isDirectory?await this.doCopyFolder(h,l,n,t):await this.doCopyFile(h,r,n,t)}return s}else return h===n?(await h.rename(r,t,{overwrite:a}),s):(await this.doMoveCopy(h,r,n,t,"copy",a),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(h,r,n,t){if((0,w.hasOpenReadWriteCloseCapability)(h)&&(0,w.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(h,r,n,t);if((0,w.hasOpenReadWriteCloseCapability)(h)&&(0,w.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(h,r,n,t);if((0,w.hasReadWriteCapability)(h)&&(0,w.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(h,r,n,t);if((0,w.hasReadWriteCapability)(h)&&(0,w.hasReadWriteCapability)(n))return this.doPipeUnbuffered(h,r,n,t)}async doCopyFolder(h,r,n,t){await n.mkdir(t),Array.isArray(r.children)&&await i.Promises.settled(r.children.map(async s=>{const a=this.getExtUri(n).providerExtUri.joinPath(t,s.name);return s.isDirectory?this.doCopyFolder(h,await this.resolve(s.resource),n,a):this.doCopyFile(h,s.resource,n,a)}))}async doValidateMoveCopy(h,r,n,t,s,a){let c=!1;if(h===n){const{providerExtUri:l,isPathCaseSensitive:f}=this.getExtUri(h);if(f||(c=l.isEqual(r,t)),c&&s==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(r),this.resourceForError(t)));if(!c&&l.isEqualOrParent(t,r))throw new Error((0,S.localize)(15,null,this.resourceForError(r),this.resourceForError(t)))}const o=await this.exists(t);if(o&&!c){if(!a)throw new w.FileOperationError((0,S.localize)(16,null,this.resourceForError(r),this.resourceForError(t)),4);if(h===n){const{providerExtUri:l}=this.getExtUri(h);if(l.isEqualOrParent(r,t))throw new Error((0,S.localize)(17,null,this.resourceForError(r),this.resourceForError(t)))}}return{exists:o,isSameResourceWithDifferentPathCase:c}}getExtUri(h){const r=this.isPathCaseSensitive(h);return{providerExtUri:r?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(h){return!!(h.capabilities&1024)}async createFolder(h){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(h),h);await this.mkdirp(r,h);const n=await this.resolve(h,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(h,0,n)),n}async mkdirp(h,r){const n=[],{providerExtUri:t}=this.getExtUri(h);for(;!t.isEqual(r,t.dirname(r));)try{if(((await h.stat(r)).type&w.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(r)));break}catch(s){if((0,w.toFileSystemProviderErrorCode)(s)!==w.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(t.basename(r)),r=t.dirname(r)}for(let s=n.length-1;s>=0;s--){r=t.joinPath(r,n[s]);try{await h.mkdir(r)}catch(a){if((0,w.toFileSystemProviderErrorCode)(a)!==w.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(h,r){try{await this.doValidateDelete(h,r)}catch(n){return n}return!0}async doValidateDelete(h,r){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(h),h);if(!!r?.useTrash&&!(n.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(h)));let s;try{s=await n.stat(h)}catch{}if(s)this.throwIfFileIsReadonly(h,s);else throw new w.FileOperationError((0,S.localize)(20,null,this.resourceForError(h)),1);if(!!!r?.recursive){const c=await this.resolve(h);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(h)))}return n}async del(h,r){const n=await this.doValidateDelete(h,r),t=!!r?.useTrash,s=!!r?.recursive;await n.delete(h,{recursive:s,useTrash:t}),this._onDidRunOperation.fire(new w.FileOperationEvent(h,1))}async cloneFile(h,r){const n=await this.withProvider(h),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(n===t&&this.getExtUri(n).providerExtUri.isEqual(h,r))return;if(n===t&&(0,w.hasFileCloneCapability)(n))return n.cloneFile(h,r);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r));const s=this.writeQueue.queueFor(h,this.getExtUri(n).providerExtUri);return n===t&&(0,w.hasFileFolderCopyCapability)(n)?s.queue(()=>n.copy(h,r,{overwrite:!0})):s.queue(()=>this.doCopyFile(n,h,t,r))}watch(h,r={recursive:!1,excludes:[]}){const n=new R.DisposableStore;let t=!1,s=()=>{t=!0};return n.add((0,R.toDisposable)(()=>s())),(async()=>{try{const a=await this.doWatch(h,r);t?(0,R.dispose)(a):s=()=>(0,R.dispose)(a)}catch(a){this.logService.error(a)}})(),n}async doWatch(h,r){const n=await this.withProvider(h),t=(0,b.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(h),r]);let s=this.activeWatchers.get(t);return s||(s={count:0,disposable:n.watch(h,r)},this.activeWatchers.set(t,s)),s.count+=1,(0,R.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,R.dispose)(s.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,h]of this.activeWatchers)(0,R.dispose)(h.disposable);this.activeWatchers.clear()}async doWriteBuffered(h,r,n,t){return this.writeQueue.queueFor(r,this.getExtUri(h).providerExtUri).queue(async()=>{const s=await h.open(r,{create:!0,unlock:n?.unlock??!1});try{(0,d.isReadableStream)(t)||(0,d.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(h,s,t):await this.doWriteReadableBufferedQueued(h,s,t)}catch(a){throw(0,w.ensureFileSystemProviderError)(a)}finally{await h.close(s)}})}async doWriteStreamBufferedQueued(h,r,n){let t=0,s;if((0,d.isReadableBufferedStream)(n)){if(n.buffer.length>0){const a=k.VSBuffer.concat(n.buffer);await this.doWriteBuffer(h,r,a,a.byteLength,t,0),t+=a.byteLength}if(n.ended)return;s=n.stream}else s=n;return new Promise((a,c)=>{(0,d.listenStream)(s,{onData:async o=>{s.pause();try{await this.doWriteBuffer(h,r,o,o.byteLength,t,0)}catch(l){return c(l)}t+=o.byteLength,setTimeout(()=>s.resume())},onError:o=>c(o),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(h,r,n){let t=0,s;for(;(s=n.read())!==null;)await this.doWriteBuffer(h,r,s,s.byteLength,t,0),t+=s.byteLength}async doWriteBuffer(h,r,n,t,s,a){let c=0;for(;c<t;)c+=await h.write(r,s+c,n.buffer,a+c,t-c)}async doWriteUnbuffered(h,r,n,t){return this.writeQueue.queueFor(r,this.getExtUri(h).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(h,r,n,t))}async doWriteUnbufferedQueued(h,r,n,t){let s;t instanceof k.VSBuffer?s=t:(0,d.isReadableStream)(t)?s=await(0,k.streamToBuffer)(t):(0,d.isReadableBufferedStream)(t)?s=await(0,k.bufferedStreamToBuffer)(t):s=(0,k.readableToBuffer)(t),await h.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(h,r,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(h,r,n,t))}async doPipeBufferedQueued(h,r,n,t){let s,a;try{s=await h.open(r,{create:!1}),a=await n.open(t,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,l=0,f=0;do f=await h.read(s,o,c.buffer,l,c.byteLength-l),await this.doWriteBuffer(n,a,c,f,o,l),o+=f,l+=f,l===c.byteLength&&(l=0);while(f>0)}catch(c){throw(0,w.ensureFileSystemProviderError)(c)}finally{await i.Promises.settled([typeof s=="number"?h.close(s):Promise.resolve(),typeof a=="number"?n.close(a):Promise.resolve()])}}async doPipeUnbuffered(h,r,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(h,r,n,t))}async doPipeUnbufferedQueued(h,r,n,t){return n.writeFile(t,await h.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(h,r,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(h,r,n,t))}async doPipeUnbufferedToBufferedQueued(h,r,n,t){const s=await n.open(t,{create:!0,unlock:!1});try{const a=await h.readFile(r);await this.doWriteBuffer(n,s,k.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,w.ensureFileSystemProviderError)(a)}finally{await n.close(s)}}async doPipeBufferedToUnbuffered(h,r,n,t){const s=await(0,k.streamToBuffer)(this.readFileBuffered(h,r,L.CancellationToken.None));await this.doWriteUnbuffered(n,t,void 0,s)}throwIfFileSystemIsReadonly(h,r){if(h.capabilities&2048)throw new w.FileOperationError((0,S.localize)(22,null,this.resourceForError(r)),6);return h}throwIfFileIsReadonly(h,r){if((r.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,S.localize)(23,null,this.resourceForError(h)),6)}resourceForError(h){return h.scheme===E.Schemas.file?h.fsPath:h.toString(!0)}};u=ge([K(0,m.ILogService)],u),e.FileService=u}),define(ne[191],re([0,1,54,274,6,34,16,3,42,2,12,4,17,41,27,151,13,92,188,38,182,181]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p,m,u,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(D)}catch(n){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(n)}`)}})();class r extends m.AbstractDiskFileSystemProvider{constructor(t,s){super(t,s);this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new L.ResourceMap(a=>v.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:s,symbolicLink:a}=await d.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(s,a),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(t){try{const s=await d.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),a=[];return await Promise.all(s.map(async c=>{try{let o;c.isSymbolicLink()?o=(await this.stat((0,v.joinPath)(t,c.name))).type:o=this.toType(c),a.push([c.name,o])}catch(o){this.logService.trace(o)}})),a}catch(s){throw this.toFileSystemProviderError(s)}}toType(t,s){let a;return s?.dangling?a=w.FileType.Unknown:t.isFile()?a=w.FileType.File:t.isDirectory()?a=w.FileType.Directory:a=w.FileType.Unknown,s&&(a|=w.FileType.SymbolicLink),a}async createResourceLock(t){const s=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let a;for(;a=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await a.wait();const c=new k.Barrier;return this.resourceLocks.set(t,c),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,R.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(t)===c&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),c.open()})}async readFile(t,s){let a;try{s?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),a=await this.createResourceLock(t));const c=this.toFilePath(t);return await d.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{a?.dispose()}}readFileStream(t,s,a){const c=(0,y.newWriteableStream)(o=>A.VSBuffer.concat(o.map(l=>A.VSBuffer.wrap(l))).buffer);return(0,p.readFileIntoStream)(this,t,c,o=>o.buffer,{...s,bufferSize:256*1024},a),c}async writeFile(t,s,a){let c;try{const o=this.toFilePath(t);if(!a.create||!a.overwrite){if(await d.Promises.exists(o)){if(!a.overwrite)throw(0,w.createFileSystemProviderError)((0,S.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,w.createFileSystemProviderError)((0,S.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:a.unlock}),await this.write(c,0,s,0,s.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(t,o)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(t){r.canFlush=t}async open(t,s){const a=this.toFilePath(t);let c;(0,w.isFileOpenForWriteOptions)(s)&&(c=await this.createResourceLock(t));let o;try{if((0,w.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:f}=await d.SymlinkSupport.stat(a);f.mode&128||await d.Promises.chmod(a,f.mode|128)}catch(f){this.logService.trace(f)}let l;if((0,w.isFileOpenForWriteOptions)(s)){if(E.isWindows)try{await d.Promises.truncate(a,0),l="r+"}catch(f){f.code!=="ENOENT"&&this.logService.trace(f)}l||(l="w")}else l="r";o=await d.Promises.open(a,l)}catch(l){throw c?.dispose(),(0,w.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(t,l):this.toFileSystemProviderError(l)}if(this.mapHandleToPos.set(o,0),(0,w.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(o,t),c){const l=this.mapHandleToLock.get(o);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${a})`),this.mapHandleToLock.set(o,c),l&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${a})`),l.dispose())}return o}async close(t){const s=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&r.canFlush)try{await d.Promises.fdatasync(t)}catch(a){r.configureFlushOnWrite(!1),this.logService.error(a)}return await d.Promises.close(t)}catch(a){throw this.toFileSystemProviderError(a)}finally{s&&(this.mapHandleToLock.get(t)===s&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),s.dispose())}}async read(t,s,a,c,o){const l=this.normalizePos(t,s);let f=null;try{f=(await d.Promises.read(t,a,c,o,l)).bytesRead}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(t,l,f)}return f}normalizePos(t,s){return s===this.mapHandleToPos.get(t)?null:s}updatePos(t,s,a){const c=this.mapHandleToPos.get(t);typeof c=="number"&&(typeof s=="number"||(typeof a=="number"?this.mapHandleToPos.set(t,c+a):this.mapHandleToPos.delete(t)))}async write(t,s,a,c,o){return(0,k.retry)(()=>this.doWrite(t,s,a,c,o),100,3)}async doWrite(t,s,a,c,o){const l=this.normalizePos(t,s);let f=null;try{f=(await d.Promises.write(t,a,c,o,l)).bytesWritten}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),P)}finally{this.updatePos(t,l,f)}return f}async mkdir(t){try{await d.Promises.mkdir(this.toFilePath(t))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(t,s){try{const a=this.toFilePath(t);s.recursive?await d.Promises.rm(a,d.RimRafMode.MOVE):await d.Promises.unlink(a)}catch(a){throw this.toFileSystemProviderError(a)}}async rename(t,s,a){const c=this.toFilePath(t),o=this.toFilePath(s);if(c!==o)try{await this.validateTargetDeleted(t,s,"move",a.overwrite),await d.Promises.move(c,o)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,S.localize)(2,null,(0,I.basename)(c),(0,I.basename)((0,I.dirname)(o)),l.toString()))),this.toFileSystemProviderError(l)}}async copy(t,s,a){const c=this.toFilePath(t),o=this.toFilePath(s);if(c!==o)try{await this.validateTargetDeleted(t,s,"copy",a.overwrite),await d.Promises.copy(c,o,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,S.localize)(3,null,(0,I.basename)(c),(0,I.basename)((0,I.dirname)(o)),l.toString()))),this.toFileSystemProviderError(l)}}async validateTargetDeleted(t,s,a,c){const o=this.toFilePath(t),l=this.toFilePath(s);let f=!1;if(!!(this.capabilities&1024)||(f=(0,C.isEqual)(o,l,!0)),f&&a==="copy")throw(0,w.createFileSystemProviderError)((0,S.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!f&&await d.Promises.exists(l)){if(!c)throw(0,w.createFileSystemProviderError)((0,S.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(t,s){return this.doCloneFile(t,s,!1)}async doCloneFile(t,s,a){const c=this.toFilePath(t),o=this.toFilePath(s),l=!!(this.capabilities&1024);if((0,C.isEqual)(c,o,!l))return;const f=new R.DisposableStore;try{const[P,U]=await Promise.all([this.createResourceLock(t),this.createResourceLock(s)]);f.add(P),f.add(U),a&&await d.Promises.mkdir((0,I.dirname)(o),{recursive:!0}),await d.Promises.copyFile(c,o)}catch(P){if(P.code==="ENOENT"&&!a)return this.doCloneFile(t,s,!0);throw this.toFileSystemProviderError(P)}finally{f.dispose()}}createUniversalWatcher(t,s,a){return new g.UniversalWatcherClient(c=>t(c),c=>s(c),a)}createNonRecursiveWatcher(t,s,a){return new h.NodeJSWatcherClient(c=>t(c),c=>s(c),a)}toFileSystemProviderError(t){if(t instanceof w.FileSystemProviderError)return t;let s;switch(t.code){case"ENOENT":s=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=w.FileSystemProviderErrorCode.NoPermissions;break;default:s=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(t,s)}async toFileSystemProviderWriteError(t,s){let a=this.toFileSystemProviderError(s);if(t&&a.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.toFilePath(t));c.mode&128||(a=(0,w.createFileSystemProviderError)(s,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return a}}e.DiskFileSystemProvider=r,r.canFlush=!0}),define(ne[95],re([0,1,3,7,8]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(v){this.service=v,this.onDidChangeLogLevel=D.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(v,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=L;class A{constructor(v){this.channel=v}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(v){A.setLevel(this.channel,v)}static setLevel(v,y){return v.call("setLevel",y)}}e.LogLevelChannelClient=A;class b{constructor(v){this.loggerService=v,this.loggers=new Map}listen(v,y){throw new Error(`Event not found: ${y}`)}async call(v,y,d){switch(y){case"createLogger":this.createLogger(i.URI.revive(d[0]),d[1]);return;case"log":return this.log(i.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(v,y){this.loggers.set(v.toString(),this.loggerService.createLogger(v,y))}consoleLog(v,y){let d=console.log;switch(v){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(v,y){const d=this.loggers.get(v.toString());if(!d)throw new Error("Create the logger before logging");for(const[S,w]of y)(0,k.log)(d,S,w)}}e.LoggerChannel=b;class C extends k.AbstractLoggerService{constructor(v,y,d){super(v,y);this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(v,y)=>{this.channel.call("consoleLog",[v,y])}})}doCreateLogger(v,y,d){return new R(this.channel,v,y,d)}}e.LoggerChannelClient=C;class R extends k.AbstractMessageLogger{constructor(v,y,d,S){super(S?.always);this.channel=v,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(v,y){const d=[[v,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(v){this.channel.call("log",[this.file,v])}}class I extends k.LogService{constructor(v,y){super(y);this.parent=v,this._register(v.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(v){super.setLevel(v),this.parent.setLevel(v)}}e.FollowerLogService=I}),define(ne[67],re([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ne[58],re([0,1,3,52,2,5]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class A extends k.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(R){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...R,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(R),i.Iterable.reduce(this.policies.entries(),(E,[v,y])=>({...E,[v]:y}),{})}getPolicyValue(R){return this.policies.get(R)}serialize(){return i.Iterable.reduce(Object.entries(this.policyDefinitions),(R,[I,E])=>({...R,[I]:{definition:E,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=A;class b{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(ne[192],re([0,1,3,2,58]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(C){this.service=C,this.disposables=new i.DisposableStore}listen(C,R){switch(R){case"onDidChange":return D.Event.map(this.service.onDidChange,I=>I.reduce((E,v)=>({...E,[v]:this.service.getPolicyValue(v)??null}),{}),this.disposables)}throw new Error(`Event not found: ${R}`)}call(C,R,I){switch(R){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(I)}throw new Error(`Call not found: ${R}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class A extends k.AbstractPolicyService{constructor(C,R){super();this.channel=R;for(const I in C){const{definition:E,value:v}=C[I];this.policyDefinitions[I]=E,v!==void 0&&this.policies.set(I,v)}this.channel.listen("onDidChange")(I=>{for(const E in I){const v=I[E];v===null?this.policies.delete(E):this.policies.set(E,v)}this._onDidChange.fire(Object.keys(I))})}async initializePolicies(C){const R=await this.channel.call("registerPolicyDefinitions",C);for(const I in R)this.policies.set(I,R[I])}}e.PolicyChannelClient=A}),define(ne[96],re([0,1,20,4,36,17]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const b=i.globals.vscode.context.configuration();if(b)A=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const b=(0,L.dirname)(D.FileAccess.asFileUri("",X));A=X.__$__nodeRequire((0,L.joinPath)(b,"product.json").fsPath);const C=X.__$__nodeRequire((0,L.joinPath)(b,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:C.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(ne[24],re([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[193],re([0,1,6,9,2,12,27,8,24]),function(X,e,D,i,k,L,A,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let R=class extends k.Disposable{constructor(E,v,y){super();this.productService=v,this.logService=y,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const v=Date.now(),y=(0,L.dirname)(E),d=(0,L.basename)(E),S=await A.Promises.readdir(y);await Promise.all(S.map(async w=>{if(w===d)return;const p=(0,L.join)(y,w),m=await A.Promises.stat(p);if(m.isDirectory()&&v-m.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),A.Promises.rm(p)}))}catch(v){(0,i.onUnexpectedError)(v)}}};R=ge([K(1,C.IProductService),K(2,b.ILogService)],R),e.CodeCacheCleaner=R}),define(ne[194],re([0,1,6,9,2,12,27,15,8,24]),function(X,e,D,i,k,L,A,b,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends k.Disposable{constructor(v,y,d){super();this.environmentService=v,this.logService=y,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const v=Object.create(null),y=JSON.parse(await A.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const m of Object.keys(y)){const u=y[m];v[`${u.hash}.${m}`]=!0}const d=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(d))return;const w=await A.Promises.readdir(d);for(const m of w){if(v[m]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${m}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${m}`),await A.Promises.rm((0,L.join)(d,m))}const p=Date.now();for(const m of Object.keys(v)){const u=(0,L.join)(d,m),g=await A.Promises.readdir(u);for(const h of g){if(h==="tcf.json")continue;const r=(0,L.join)(u,h),n=await A.Promises.stat(r);n.isDirectory()&&p-n.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(m,h)}`),await A.Promises.rm(r))}}}catch(v){(0,i.onUnexpectedError)(v)}}};I=ge([K(0,b.INativeEnvironmentService),K(1,C.ILogService),K(2,R.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(ne[195],re([0,1,12,5]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,i.createDecorator)("IV8InspectProfilingService");var k;(function(L){function A(b,C="noAbsolutePaths"){for(const R of b.nodes)R.callFrame&&R.callFrame.url&&((0,D.isAbsolute)(R.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(R.callFrame.url))&&(R.callFrame.url=(0,D.join)(C,(0,D.basename)(R.callFrame.url)));return b}L.rewriteAbsolutePaths=A})(k=e.Utils||(e.Utils={}))}),define(ne[196],re([0,1,31]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class i{constructor(){this._sessions=new Map}async startProfiling(L){const b=await(await new Promise((R,I)=>{X(["v8-inspect-profiler"],R,I)})).startProfiling({port:L.port,checkForPaused:!0}),C=(0,D.generateUuid)();return this._sessions.set(C,b),C}async stopProfiling(L){const A=this._sessions.get(L);if(!A)throw new Error(`UNKNOWN session '${L}'`);const b=await A.stop();return this._sessions.delete(L),b.profile}}e.InspectProfilingService=i}),define(ne[40],re([0,1,110,14]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,b){D.ok(i.isString(A)),D.ok(i.isObject(b)),D.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,b)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(ne[97],re([0,1,3,40]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class L{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,R){this.schemasById[k(C)]=R,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new L;i.Registry.add(e.Extensions.JSONContribution,A)}),define(ne[43],re([0,1,18,3,14,138,19,97,40]),function(X,e,D,i,k,L,A,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var R;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(R=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=C.Registry.as(b.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,n=!0){this.registerConfigurations([r],n)}registerConfigurations(r,n=!0){const t=this.doRegisterConfigurations(r,n);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(r){const n=this.doDeregisterConfigurations(r);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:r,remove:n}){const t=[];t.push(...this.doDeregisterConfigurations(n)),t.push(...this.doRegisterConfigurations(r,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(r){const n=[],t=[];for(const{overrides:s,source:a}of r)for(const c in s)if(n.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const o=this.configurationDefaultsOverrides.get(c),l=o?.valuesSources??new Map;if(a)for(const _ of Object.keys(s[c]))l.set(_,a);const f={...o?.value||{},...s[c]};this.configurationDefaultsOverrides.set(c,{source:a,value:f,valuesSources:l});const P=(0,A.getLanguageTagSettingPlainKey)(c),U={type:"object",default:f,description:L.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:k.isString(a)?void 0:a,defaultValueSource:a};t.push(...S(c)),this.configurationProperties[c]=U,this.defaultLanguageConfigurationOverridesNode.properties[c]=U}else{this.configurationDefaultsOverrides.set(c,{value:s[c],source:a});const o=this.configurationProperties[c];o&&(this.updatePropertyDefaultValue(c,o),this.updateSchema(c,o))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const n=[];for(const{overrides:t,source:s}of r)for(const a in t){const c=this.configurationDefaultsOverrides.get(a),o=k.isString(s)?s:s?.id,l=k.isString(c?.source)?c?.source:c?.source?.id;if(o===l)if(n.push(a),this.configurationDefaultsOverrides.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const f=this.configurationProperties[a];f&&(this.updatePropertyDefaultValue(a,f),this.updateSchema(a,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const n of r)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,n){const t=[];return r.forEach(s=>{t.push(...this.validateAndRegisterProperties(s,n,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),t}doDeregisterConfigurations(r){const n=[],t=s=>{if(s.properties)for(const a in s.properties){n.push(a);const c=this.configurationProperties[a];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[a],this.removeFromSchema(a,s.properties[a])}s.allOf?.forEach(a=>t(a))};for(const s of r){t(s);const a=this.configurationContributors.indexOf(s);a!==-1&&this.configurationContributors.splice(a,1)}return n}validateAndRegisterProperties(r,n=!0,t,s,a=3){a=k.isUndefinedOrNull(r.scope)?a:r.scope;const c=[],o=r.properties;if(o)for(const f in o){const P=o[f];if(n&&u(f,P)){delete o[f];continue}if(P.source=t,P.defaultDefaultValue=o[f].default,this.updatePropertyDefaultValue(f,P),e.OVERRIDE_PROPERTY_REGEX.test(f)?P.scope=void 0:(P.scope=k.isUndefinedOrNull(P.scope)?a:P.scope,P.restricted=k.isUndefinedOrNull(P.restricted)?!!s?.includes(f):P.restricted),o[f].hasOwnProperty("included")&&!o[f].included){this.excludedConfigurationProperties[f]=o[f],delete o[f];continue}else this.configurationProperties[f]=o[f],o[f].policy?.name&&this.policyConfigurations.set(o[f].policy.name,f);!o[f].deprecationMessage&&o[f].markdownDeprecationMessage&&(o[f].deprecationMessage=o[f].markdownDeprecationMessage),c.push(f)}const l=r.allOf;if(l)for(const f of l)c.push(...this.validateAndRegisterProperties(f,n,t,s,a));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const n=t=>{const s=t.properties;if(s)for(const c in s)this.updateSchema(c,s[c]);t.allOf?.forEach(n)};n(r)}updateSchema(r,n){switch(e.allSettings.properties[r]=n,n.scope){case 1:e.applicationSettings.properties[r]=n;break;case 2:e.machineSettings.properties[r]=n;break;case 6:e.machineOverridableSettings.properties[r]=n;break;case 3:e.windowSettings.properties[r]=n;break;case 4:e.resourceSettings.properties[r]=n;break;case 5:e.resourceSettings.properties[r]=n,this.resourceLanguageSettingsSchema.properties[r]=n;break}}removeFromSchema(r,n){switch(delete e.allSettings.properties[r],n.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const n=`[${r}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,t),e.allSettings.properties[n]=t,e.applicationSettings.properties[n]=t,e.machineSettings.properties[n]=t,e.machineOverridableSettings.properties[n]=t,e.windowSettings.properties[n]=t,e.resourceSettings.properties[n]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,n){const t=this.configurationDefaultsOverrides.get(r);let s=t?.value,a=t?.source;k.isUndefined(s)&&(s=n.defaultDefaultValue,a=void 0),k.isUndefined(s)&&(s=p(n.type)),n.default=s,n.defaultValueSource=a}}const y="\\[([^\\]]+)\\]",d=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(h){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(h)){let n=d.exec(h);for(;n?.length;){const t=n[1].trim();t&&r.push(t),n=d.exec(h)}}return(0,D.distinct)(r)}e.overrideIdentifiersFromKey=S;function w(h){return h.reduce((r,n)=>`${r}[${n}]`,"")}e.keyFromOverrideIdentifiers=w;function p(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const m=new v;C.Registry.add(e.Extensions.Configuration,m);function u(h,r){return h.trim()?e.OVERRIDE_PROPERTY_REGEX.test(h)?L.localize(7,null,h):m.getConfigurationProperties()[h]!==void 0?L.localize(8,null,h):r.policy?.name&&m.getPolicyConfigurations().get(r.policy?.name)!==void 0?L.localize(9,null,h,r.policy?.name,m.getPolicyConfigurations().get(r.policy?.name)):null:L.localize(6,null)}e.validateProperty=u;function g(){const h=[],r=m.getConfigurationProperties();for(const n of Object.keys(r))h.push([n,r[n].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.getScopes=g}),define(ne[68],re([0,1,18,3,35,2,34,30,14,7,19,43,40]),function(X,e,D,i,k,L,A,b,C,R,I,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(n={},t=[],s=[]){this._contents=n,this._keys=t,this._overrides=s,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const s=this.getContentsForOverrideIdentifer(t);return s?n?(0,I.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const s of this.overrides)s.identifiers.includes(n)&&t.push(...s.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return D.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=b.deepClone(this.contents),s=b.deepClone(this.overrides),a=[...this.keys];for(const c of n)if(!c.isEmpty()){this.mergeContents(t,c.contents);for(const o of c.overrides){const[l]=s.filter(f=>D.equals(f.identifiers,o.identifiers));l?(this.mergeContents(l.contents,o.contents),l.keys.push(...o.keys),l.keys=D.distinct(l.keys)):s.push(b.deepClone(o))}for(const o of c.keys)a.indexOf(o)===-1&&a.push(o)}return new y(t,a,s)}freeze(){return this.frozen=!0,this}clone(){return new y(b.deepClone(this.contents),[...this.keys],b.deepClone(this.overrides))}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const s={};for(const a of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[a];const o=t[a];o&&(typeof c=="object"&&typeof o=="object"?(c=b.deepClone(c),this.mergeContents(c,o)):c=o),s[a]=c}return new y(s,this.keys,this.overrides)}mergeContents(n,t){for(const s of Object.keys(t)){if(s in n&&C.isObject(n[s])&&C.isObject(t[s])){this.mergeContents(n[s],t[s]);continue}n[s]=b.deepClone(t[s])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?b.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,s=null;const a=c=>{c&&(s?this.mergeContents(s,c):s=b.deepClone(c))};for(const c of this.overrides)D.equals(c.identifiers,[n])?t=c.contents:c.identifiers.includes(n)&&a(c.contents);return a(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,I.addToValueTree)(this.contents,n,t,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,I.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let s=0;s<t;s++)n.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,n)}removeKey(n){const t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=y;class d{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!C.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:s,keys:a,overrides:c,restricted:o}=this.doParseRaw(n,t);this._configurationModel=new y(s,a,c),this._restrictedConfigurations=o||[]}doParseContent(n){let t={},s=null,a=[];const c=[],o=[];function l(P){Array.isArray(a)?a.push(P):s!==null&&(a[s]=P)}const f={onObjectBegin:()=>{const P={};l(P),c.push(a),a=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const P=[];l(P),c.push(a),a=P,s=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:l,onError:(P,U,_)=>{o.push({error:P,offset:U,length:_})}};if(n)try{k.visit(n,f),t=a[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return t}doParseRaw(n,t){const s=v.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),a=this.filter(n,s,!0,t);n=a.raw;const c=(0,I.toValuesTree)(n,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),o=Object.keys(n),l=this.toOverrides(n,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:c,keys:o,overrides:l,restricted:a.restricted}}filter(n,t,s,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:n,restricted:[]};const c={},o=[];for(const l in n)if(E.OVERRIDE_PROPERTY_REGEX.test(l)&&s){const f=this.filter(n[l],t,!1,a);c[l]=f.raw,o.push(...f.restricted)}else{const f=t[l],P=f?typeof f.scope!="undefined"?f.scope:3:void 0;f?.restricted&&o.push(l),(P===void 0||a.scopes===void 0||a.scopes.includes(P))&&(a.skipRestricted&&f?.restricted||(c[l]=n[l]))}return{raw:c,restricted:o}}toOverrides(n,t){const s=[];for(const a of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(a)){const c={};for(const o in n[a])c[o]=n[a][o];s.push({identifiers:(0,E.overrideIdentifiersFromKey)(a),keys:Object.keys(c),contents:(0,I.toValuesTree)(c,t)})}return s}}e.ConfigurationModelParser=d;class S extends L.Disposable{constructor(n,t,s,a){super();this.userSettingsResource=n,this.scopes=t,this.fileService=a,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.any(i.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),i.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&s.isEqual(c.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class w{constructor(n,t,s,a,c=new y,o=new y,l=new A.ResourceMap,f=new y,P=new A.ResourceMap,U=!0){this._defaultConfiguration=n,this._policyConfiguration=t,this._applicationConfiguration=s,this._localUserConfiguration=a,this._remoteUserConfiguration=c,this._workspaceConfiguration=o,this._folderConfigurations=l,this._memoryConfiguration=f,this._memoryConfigurationByResource=P,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(n,t,s){return this.getConsolidatedConfigurationModel(n,t,s).getValue(n)}updateValue(n,t,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new y,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,t===void 0?a.removeValue(n):a.setValue(n,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,s){const a=this.getConsolidatedConfigurationModel(n,t,s),c=this.getFolderConfigurationModelForResource(t.resource,s),o=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,l=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),f=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),P=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),U=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),_=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),F=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),T=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,N=c?t.overrideIdentifier?c.freeze().override(t.overrideIdentifier).getValue(n):c.freeze().getValue(n):void 0,z=t.overrideIdentifier?o.override(t.overrideIdentifier).getValue(n):o.getValue(n),V=a.getValue(n),J=D.distinct(a.overrides.map($=>$.identifiers).flat()).filter($=>a.getOverrideValue(n,$)!==void 0);return{defaultValue:l,policyValue:f,applicationValue:P,userValue:U,userLocalValue:_,userRemoteValue:F,workspaceValue:T,workspaceFolderValue:N,memoryValue:z,value:V,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,policy:f!==void 0?{value:f}:void 0,application:P!==void 0?{value:P,override:t.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:U!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:c?.freeze().getValue(n),override:t.overrideIdentifier?c?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:o.getValue(n),override:t.overrideIdentifier?o.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:J.length?J:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const s=[];if(!t){const{added:a,updated:c,removed:o}=g(this._defaultConfiguration,n);t=[...a,...c,...o]}for(const a of t)for(const c of(0,E.overrideIdentifiersFromKey)(a)){const o=this._defaultConfiguration.getKeysForOverrideIdentifier(c),l=n.getKeysForOverrideIdentifier(c),f=[...l.filter(P=>o.indexOf(P)===-1),...o.filter(P=>l.indexOf(P)===-1),...o.filter(P=>!b.equals(this._defaultConfiguration.override(c).getValue(P),n.override(c).getValue(P)))];s.push([c,f])}return this.updateDefaultConfiguration(n),{keys:t,overrides:s}}compareAndUpdatePolicyConfiguration(n){const{added:t,updated:s,removed:a}=g(this._policyConfiguration,n),c=[...t,...s,...a];return c.length&&this.updatePolicyConfiguration(n),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:t,updated:s,removed:a,overrides:c}=g(this.applicationConfiguration,n),o=[...t,...s,...a];return o.length&&this.updateApplicationConfiguration(n),{keys:o,overrides:c}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:s,removed:a,overrides:c}=g(this.localUserConfiguration,n),o=[...t,...s,...a];return o.length&&this.updateLocalUserConfiguration(n),{keys:o,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:s,removed:a,overrides:c}=g(this.remoteUserConfiguration,n),o=[...t,...s,...a];return o.length&&this.updateRemoteUserConfiguration(n),{keys:o,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:s,removed:a,overrides:c}=g(this.workspaceConfiguration,n),o=[...t,...s,...a];return o.length&&this.updateWorkspaceConfiguration(n),{keys:o,overrides:c}}compareAndUpdateFolderConfiguration(n,t){const s=this.folderConfigurations.get(n),{added:a,updated:c,removed:o,overrides:l}=g(s,t),f=[...a,...c,...o];return(f.length||!s)&&this.updateFolderConfiguration(n,t),{keys:f,overrides:l}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:a,removed:c,overrides:o}=g(t,void 0);return{keys:[...s,...a,...c],overrides:o}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,t,s){let a=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier&&(a=a.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(a=a.merge(this._policyConfiguration)),a}getConsolidatedConfigurationModelForResource({resource:n},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const a=t.getFolder(n);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const c=this._memoryConfigurationByResource.get(n);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(n);a?(t=s.merge(a),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=s}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const s=t.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:s,overrides:a,keys:c}=this._folderConfigurations.get(t);return n.push([t,{contents:s,overrides:a,keys:c}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(a=>t.add(a))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.policy),a=this.parseConfigurationModel(n.application),c=this.parseConfigurationModel(n.user),o=this.parseConfigurationModel(n.workspace),l=n.folders.reduce((f,P)=>(f.set(R.URI.revive(P[0]),this.parseConfigurationModel(P[1])),f),new A.ResourceMap);return new w(t,s,a,c,new y,o,l,new y,new A.ResourceMap,!1)}static parseConfigurationModel(n){return new y(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=w;function p(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const n=new Set,t=new Map;for(const a of r)a.keys.forEach(c=>n.add(c)),a.overrides.forEach(([c,o])=>{const l=(0,A.getOrSet)(t,c,new Set);o.forEach(f=>l.add(f))});const s=[];return t.forEach((a,c)=>s.push([c,[...a.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=p;class m{constructor(n,t,s,a){this.change=n,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const c=new Set;n.keys.forEach(l=>c.add(l)),n.overrides.forEach(([,l])=>l.forEach(f=>c.add(f))),this.affectedKeys=[...c.values()];const o=new y;this.affectedKeys.forEach(l=>o.setValue(l,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!b.equals(s,a)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let s=(0,I.toValuesTree)({[t]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(n=n[a],!n)return!1;s=s[a]}return!0}}e.ConfigurationChangeEvent=m;class u extends m{constructor(n,t,s,a){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=s,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=u;function g(r,n){const{added:t,removed:s,updated:a}=h(n,r),c=[],o=r?.getAllOverrideIdentifiers()||[],l=n?.getAllOverrideIdentifiers()||[];if(n){const f=l.filter(P=>!o.includes(P));for(const P of f)c.push([P,n.getKeysForOverrideIdentifier(P)])}if(r){const f=o.filter(P=>!l.includes(P));for(const P of f)c.push([P,r.getKeysForOverrideIdentifier(P)])}if(n&&r){for(const f of o)if(l.includes(f)){const P=h({contents:r.getOverrideValue(void 0,f)||{},keys:r.getKeysForOverrideIdentifier(f)},{contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)});c.push([f,[...P.added,...P.removed,...P.updated]])}}return{added:t,removed:s,updated:a,overrides:c}}function h(r,n){const t=r?n?r.keys.filter(c=>n.keys.indexOf(c)===-1):[...r.keys]:[],s=n?r?n.keys.filter(c=>r.keys.indexOf(c)===-1):[...n.keys]:[],a=[];if(r&&n){for(const c of n.keys)if(r.keys.indexOf(c)!==-1){const o=(0,I.getConfigurationValue)(n.contents,c),l=(0,I.getConfigurationValue)(r.contents,c);b.equals(o,l)||a.push(c)}}return{added:t,removed:s,updated:a}}}),define(ne[197],re([0,1,18,3,2,30,14,19,68,43,8,58,40]),function(X,e,D,i,k,L,A,b,C,R,I,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class y extends k.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(v.Registry.as(R.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:u})=>this.onDidUpdateConfiguration(m,u))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(m,u){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:m})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=y;class d extends C.ConfigurationModel{constructor(m={}){const u=v.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),g=Object.keys(u),h=Object.create(null),r=[];for(const n in u){const t=m[n],s=t!==void 0?t:u[n].default;(0,b.addToValueTree)(h,n,s,a=>console.error(`Conflict in default settings: ${a}`))}for(const n of Object.keys(h))R.OVERRIDE_PROPERTY_REGEX.test(n)&&r.push({identifiers:(0,R.overrideIdentifiersFromKey)(n),keys:Object.keys(h[n]),contents:(0,b.toValuesTree)(h[n],t=>console.error(`Conflict in default settings file: ${t}`))});super(h,g,r)}}e.DefaultConfigurationModel=d;class S{constructor(){this.onDidChangeConfiguration=i.Event.None,this.configurationModel=new C.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let w=class extends k.Disposable{constructor(m,u,g){super();this.defaultConfiguration=m,this.policyService=u,this.logService=g,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new C.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(m=>this.onDidChangePolicies(m))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:m})=>this.update(await this.registerPolicyDefinitions(m),!0))),this._configurationModel}async registerPolicyDefinitions(m){const u={},g=[],h=v.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(const r of m){const n=h[r];if(!n){g.push(r);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}g.push(r),u[n.policy.name]={type:n.type}}}return(0,A.isEmptyObject)(u)||await this.policyService.registerPolicyDefinitions(u),g}onDidChangePolicies(m){const u=v.Registry.as(R.Extensions.Configuration).getPolicyConfigurations(),g=(0,D.coalesce)(m.map(h=>u.get(h)));this.update(g,!0)}update(m,u){const g=v.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),h=[],r=this._configurationModel.isEmpty();for(const n of m){const t=g[n]?.policy?.name;if(t){const s=this.policyService.getPolicyValue(t);(r?s!==void 0:!(0,L.equals)(this._configurationModel.getValue(n),s))&&h.push([n,s])}else this._configurationModel.getValue(n)!==void 0&&h.push([n,void 0])}if(h.length){const n=this._configurationModel;this._configurationModel=new C.ConfigurationModel;for(const t of n.keys)this._configurationModel.setValue(t,n.getValue(t));for(const[t,s]of h)s===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,s);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};w=ge([K(1,E.IPolicyService),K(2,I.ILogService)],w),e.PolicyConfiguration=w}),define(ne[198],re([0,1,6,3,2,17,19,68,197,58]),function(X,e,D,i,k,L,A,b,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends k.Disposable{constructor(v,y,d,S){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new C.DefaultConfiguration),this.policyConfiguration=d instanceof R.NullPolicyService?new C.NullPolicyConfiguration:this._register(new C.PolicyConfiguration(this.defaultConfiguration,d,S)),this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,y)),this.configuration=new b.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new b.ConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:w,properties:p})=>this.onDidDefaultConfigurationChange(w,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(w=>this.onDidPolicyConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[v,y,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new b.Configuration(v,y,new b.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(v,y){const d=typeof v=="string"?v:void 0,S=(0,A.isConfigurationOverrides)(v)?v:(0,A.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(d,S,void 0)}updateValue(v,y,d,S){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(d,y,2)}onDidDefaultConfigurationChange(v,y){const d=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(v,y);this.trigger(S,d,7)}onDidPolicyConfigurationChange(v){const y=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(v);this.trigger(d,y,7)}trigger(v,y,d){const S=new b.ConfigurationChangeEvent(v,{data:y},this.configuration);S.source=d,S.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(v){switch(v){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(ne[199],re([0,1,9,5]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends D.ErrorNoTelemetry{constructor(b,C=k.Unknown,R){super(b);this._message=b,this._code=C,this._detail=R,this.isHandled=C===k.NotAvailable&&R===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(b){return b instanceof L&&b._code===k.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof L&&b._code===k.NoResolverFound}static isHandled(b){return b instanceof L&&b.isHandled}}e.RemoteAuthorityResolverError=L}),define(ne[98],re([0,1,20]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(R){return R.scheme===D.Schemas.vscodeRemote?R.authority:void 0}e.getRemoteAuthority=i;function k(R){if(!R)return;const I=R.indexOf("+");return I<0?R:R.substr(0,I)}e.getRemoteName=k;function L(R){return`/${R.quality??"oss"}-${R.commit??"dev"}`}e.getRemoteServerRootPath=L;function A(R){const{host:I,port:E}=C(R);if(typeof E=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:E}}e.parseAuthorityWithPort=A;function b(R,I){let{host:E,port:v}=C(R);return typeof v=="undefined"&&(v=I),{host:E,port:v}}e.parseAuthorityWithOptionalPort=b;function C(R){const I=R.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const E=R.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const v=R.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:R,port:void 0}}}),define(ne[44],re([0,1,26,5,98]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=L;function A(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));var C;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));class R{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,w){if(typeof S=="undefined"||S===null)return typeof w=="undefined"||w===null;if(typeof w=="undefined"||w===null)return!1;if(typeof S=="string"||typeof w=="string"){const p=typeof S=="string"?S:S.value,m=typeof w=="string"?w:w.value;return D.equalsIgnoreCase(p,m)}return S._lower===w._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=R;function I(d){return E(d)}e.isApplicationScopedExtension=I;function E(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function v(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function y(d,S){if(S){const w=`onResolveRemoteAuthority:${(0,k.getRemoteName)(S)}`;return d.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[32],re([0,1,26,28,44,4,7,9,36]),function(X,e,D,i,k,L,A,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,D.compareIgnoreCase)(n.id,t.id)===0}e.areSameExtensions=R;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{constructor(t,s,a="undefined"){this.version=s,this.targetPlatform=a,this.id=t.id}static create(t){const s=t.manifest?t.manifest.version:t.version,a=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new E(t.identifier,s,a)}static parse(t){const s=I.exec(t);return s&&s[1]&&s[2]?new E({id:s[1]},s[2],s[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof E?R(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=E;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(n){const t=v.exec(n);return t&&t[1]?[S(t[1]),t[2]]:[S(n),void 0]}e.getIdAndVersion=y;function d(n,t){return`${n}.${t}`}e.getExtensionId=d;function S(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function w(n,t){return S(d(n,t))}e.getGalleryExtensionId=w;function p(n,t){const s=[],a=c=>{for(const o of s)if(o.some(l=>R(t(l),t(c))))return o;return null};for(const c of n){const o=a(c);o?o.push(c):s.push([c])}return s}e.groupByExtension=p;function m(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function u(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),...n.telemetryData}}e.getGalleryExtensionTelemetryData=u,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function g(n,t){const s=[],a=t.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const c=a.shift();if(c&&s.every(o=>!R(o.identifier,{id:c}))){const o=n.filter(l=>R(l.identifier,{id:c}));o.length===1&&(s.push(o[0]),a.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=g;async function h(n,t){if(!L.isLinux)return!1;let s;try{s=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(c))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=h;async function r(n,t){const s=await h(n,t),a=(0,i.getTargetPlatform)(s?"alpine":L.platform,C.arch);return t.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=r}),define(ne[45],re([0,1,6,16,2,34,7,32,13,5,8]),function(X,e,D,i,k,L,A,b,C,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,R.createDecorator)("IExtensionsProfileScannerService");let E=class extends k.Disposable{constructor(y,d){super();this.fileService=y,this.logService=d,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(y){return this.withProfileExtensions(y)}addExtensionsToProfile(y,d){return this.withProfileExtensions(d,S=>(S=S.filter(w=>y.some(([p])=>!(0,b.areSameExtensions)(w.identifier,p.identifier))),S.push(...y.map(([w,p])=>({identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:p}))),S))}removeExtensionFromProfile(y,d){return this.withProfileExtensions(d,S=>S.filter(w=>!(0,b.areSameExtensions)(w.identifier,y)))}async withProfileExtensions(y,d){return this.getResourceAccessQueue(y).queue(async()=>{let S=[];try{const w=await this.fileService.readFile(y),p=JSON.parse(w.value.toString());for(const m of p){if(!m.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",m);continue}if(!m.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",m);continue}if(!m.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",m);continue}S.push({identifier:m.identifier,location:A.URI.revive(m.location),version:m.version,metadata:m.metadata})}}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}if(d){S=d(S);const w=S.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(y,i.VSBuffer.fromString(JSON.stringify(w)))}return S})}getResourceAccessQueue(y){let d=this.resourcesAccessQueueMap.get(y);return d||(d=new D.Queue,this.resourcesAccessQueueMap.set(y,d)),d}};E=ge([K(0,C.IFileService),K(1,I.ILogService)],E),e.ExtensionsProfileScannerService=E}),define(ne[200],re([0,1,21,32]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function k(L,A,b,C,R){try{const I=await L.getExtensionsControlManifest();if(!I.deprecated)return;const E=await L.getInstalled(1);for(const[v,y]of Object.entries(I.deprecated)){if(!y?.extension)continue;const{id:d,autoMigrate:S,preRelease:w}=y.extension;if(!S)continue;const p=E.find(u=>(0,i.areSameExtensions)(u.identifier,{id:v}));if(!p)continue;const m=(await A.getExtensions([{id:d,preRelease:w}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!m){R.info(`Skipping migrating '${p.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{R.info(`Migrating '${p.identifier.id}' extension to '${d}' extension...`);const u=!C.getDisabledExtensions().some(h=>(0,i.areSameExtensions)(h,p.identifier));await L.uninstall(p),R.info(`Uninstalled the unsupported extension '${p.identifier.id}'`);let g=E.find(h=>(0,i.areSameExtensions)(h.identifier,{id:d}));(!g||!g.isPreReleaseVersion&&u)&&(g=await L.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:p.isMachineScoped,operation:4}),R.info(`Installed the pre-release extension '${g.identifier.id}'`),u||(await C.disableExtension(g.identifier),R.info(`Disabled the pre-release extension '${g.identifier.id}' because the unsupported extension '${p.identifier.id}' is disabled`)),S.storage&&(b.addToMigrationList((0,i.getExtensionId)(p.manifest.publisher,p.manifest.name),(0,i.getExtensionId)(g.manifest.publisher,g.manifest.name)),R.info("Added pre-release extension to the storage migration list"))),R.info(`Migrated '${p.identifier.id}' extension to '${d}' extension.`)}catch(u){R.error(u)}}}catch(I){R.error(I)}}e.migrateUnsupportedExtensions=k}),define(ne[201],re([0,1,6,9,2,4,17,55,7,31,27,15,28,32,13,8]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let w=class extends k.Disposable{constructor(m,u,g,h){super();this.fileService=u,this.extensionGalleryService=g,this.logService=h,this.extensionsDownloadDir=C.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,u){await this.cleanUpPromise;const g=this.getName(m),h=(0,A.joinPath)(this.extensionsDownloadDir,g);if(!await this.fileService.exists(h)){const r=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,R.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(m,r,u);try{await this.rename(r,h,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(r)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,r.path),n}}return h}async delete(m){await this.cleanUpPromise,await this.fileService.del(m)}async rename(m,u,g){try{await I.Promises.rename(m.fsPath,u.fsPath)}catch(h){if(L.isWindows&&h&&h.code==="EPERM"&&Date.now()<g)return this.logService.info(`Failed renaming ${m} to ${u} with 'EPERM' error. Trying again...`),this.rename(m,u,g);throw h}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const u=[],g=[];for(const n of m.children){const t=y.ExtensionKey.parse(n.name);t&&g.push([t,n])}const h=(0,y.groupByExtension)(g,([n])=>n),r=[];for(const n of h)n.sort((t,s)=>b.rcompare(t[0].version,s[0].version)),u.push(...n.slice(1).map(t=>t[1].resource)),r.push(n[0][1]);r.sort((n,t)=>n.mtime-t.mtime),u.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(u.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?y.ExtensionKey.create(m).toString().toLowerCase():(0,R.generateUuid)()}};w=ge([K(0,E.INativeEnvironmentService),K(1,d.IFileService),K(2,v.IExtensionGalleryService),K(3,S.ILogService)],w),e.ExtensionsDownloader=w}),define(ne[202],re([0,1,2,12,27,44]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends D.Disposable{constructor(C,R){super();this.environmentService=C,this.extensionsManifestCache=(0,i.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(R.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(R.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(C){C.some(R=>!!R.local)&&this.invalidate()}onDidUnInstallExtension(C){C.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(ne[203],re([0,1,177,18,6,2,20,12,27,15,28,32,8,66]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let d=class extends y.LanguagePackBaseService{constructor(m,u,g,h){super(g);this.extensionManagementService=m,this.logService=h,this.cache=this._register(new S(u,h)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getInstalledLanguages(){const m=await this.cache.getLanguagePacks(),u=Object.keys(m).map(g=>{const h=m[g];return{...this.createQuickPickItem({locale:g,label:h.label}),extensionId:h.extensions[0].extensionIdentifier.id}});return u.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),u}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const u=await this.cache.getLanguagePacks();Object.keys(u).some(g=>u[g]&&u[g].extensions.some(h=>(0,E.areSameExtensions)(h.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,u]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(u);return!(0,i.equals)(Object.keys(m),Object.keys(g))}};d=ge([K(0,I.IExtensionManagementService),K(1,R.INativeEnvironmentService),K(2,I.IExtensionGalleryService),K(3,v.ILogService)],d),e.NativeLanguagePackService=d;let S=class extends L.Disposable{constructor(m,u){super();this.logService=u,this.languagePacks={},this.languagePacksFilePath=(0,b.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(u=>{Object.keys(u).forEach(g=>delete u[g]),this.createLanguagePacksFromExtensions(u,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...u){for(const g of u)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,g);Object.keys(m).forEach(g=>this.updateHash(m[g]))}createLanguagePacksFromExtension(m,u){const g=u.identifier,h=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const r of h)if(u.location.scheme===A.Schemas.file&&w(r)){let n=m[r.languageId];n||(n={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},m[r.languageId]=n);const t=n.extensions.filter(s=>(0,E.areSameExtensions)(s.extensionIdentifier,g))[0];t?t.version=u.manifest.version:n.extensions.push({extensionIdentifier:g,version:u.manifest.version});for(const s of r.translations)n.translations[s.id]=(0,b.join)(u.location.fsPath,s.path)}}updateHash(m){if(m){const u=(0,D.createHash)("md5");for(const g of m.extensions)u.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);m.hash=u.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let u=null;return C.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(u=m(g),g)).then(g=>{for(const r of Object.keys(g))g[r]||delete g[r];this.languagePacks=g,this.initializedCache=!0;const h=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",h),C.Promises.writeFile(this.languagePacksFilePath,h)}).then(()=>u,g=>this.logService.error(g))})}};S=ge([K(0,R.INativeEnvironmentService),K(1,v.ILogService)],S);function w(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const m of p.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ne[204],re([0,1,6,16,21,9,3,2,31,83,199,98]),function(X,e,D,i,k,L,A,b,C,R,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const v=30*1e3;var y;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(y=e.ConnectionType||(e.ConnectionType={}));function d(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function S(W){const x=new k.CancellationTokenSource;return setTimeout(()=>x.cancel(),W),x.token}function w(W,x){if(W.isCancellationRequested||x.isCancellationRequested)return k.CancellationToken.Cancelled;const O=new k.CancellationTokenSource;return W.onCancellationRequested(()=>O.cancel()),x.onCancellationRequested(()=>O.cancel()),O.token}class p{constructor(x){this._state="pending",this._disposables=new b.DisposableStore,this.promise=new Promise((O,M)=>{this._resolvePromise=O,this._rejectPromise=M}),x.isCancellationRequested?this._timeout():this._disposables.add(x.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(x){this._state==="pending"?this._disposables.add(x):x.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const x=new Error("Time limit reached");return x.code="ETIMEDOUT",x.syscall="connect",x}resolve(x){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(x))}reject(x){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(x))}}function m(W,x){const O=new p(x);return O.registerDisposable(W.onControlMessage(M=>{const q=JSON.parse(M.toString()),j=H(q);j?O.reject(j):O.resolve(q)})),O.promise}function u(W,x,O,M,q,j,Z,G){const te=new p(G);return x.connect(O,M,q,j,Z,(se,ce)=>{te.didTimeout?(se&&W.error(se),ce?.dispose()):se||!ce?te.reject(se):te.resolve(ce)}),te.promise}function g(W,x){const O=new p(x);return W.then(M=>{O.didTimeout||O.resolve(M)},M=>{O.didTimeout||O.reject(M)}),O.promise}async function h(W,x,O,M){const q=ie(W,x);W.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let j;try{j=await u(W.logService,W.socketFactory,W.host,W.port,(0,E.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,`renderer-${d(x)}-${W.reconnectionToken}`,M)}catch(ce){throw W.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),W.logService.error(ce),ce}W.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let Z,G;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(j,null),Z=W.reconnectionProtocol,G=!1):(Z=new R.PersistentProtocol(j,null),G=!0),W.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const te=await g(W.signService.createNewMessage((0,C.generateUuid)()),M),se={type:"auth",auth:W.connectionToken||"00000000000000000000",data:te.data};Z.sendControl(i.VSBuffer.fromString(JSON.stringify(se)));try{const ce=await m(Z,w(M,S(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(W.logService.trace(`${q} 4/6. received SignRequest control message.`),!await g(W.signService.validate(te,ce.signedData),M)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const ve=await g(W.signService.sign(ce.data),M),pe={type:"connectionType",commit:W.commit,signedData:ve,desiredConnectionType:x};return O&&(pe.args=O),W.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(i.VSBuffer.fromString(JSON.stringify(pe))),{protocol:Z,ownsProtocol:G}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(W.logService.error(`${q} the handshake timed out. Error:`),W.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${q} received error control message when negotiating connection. Error:`),W.logService.error(ce)),G&&Q(Z),ce}}async function r(W,x,O,M){const q=Date.now(),j=ie(W,x),{protocol:Z,ownsProtocol:G}=await h(W,x,O,M),te=new p(M);return te.registerDisposable(Z.onControlMessage(se=>{const ce=JSON.parse(se.toString()),he=H(ce);he?(W.logService.error(`${j} received error control message when negotiating connection. Error:`),W.logService.error(he),G&&Q(Z),te.reject(he)):(W.reconnectionProtocol&&W.reconnectionProtocol.endAcceptReconnection(),W.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${ae(q)}!`),te.resolve({protocol:Z,firstMessage:ce}))})),te.promise}async function n(W,x){const{protocol:O}=await r(W,1,void 0,x);return{protocol:O}}async function t(W,x,O){const{protocol:M,firstMessage:q}=await r(W,2,x,O),j=q&&q.debugPort;return{protocol:M,debugPort:j}}async function s(W,x,O){const M=Date.now(),q=ie(W,3),{protocol:j}=await h(W,3,x,O);return W.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${ae(M)}!`),j}async function a(W,x,O){const{host:M,port:q,connectionToken:j}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,host:M,port:q,connectionToken:j,reconnectionToken:x,reconnectionProtocol:O,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function c(W,x,O){return l(W,async M=>{const{protocol:q}=await n(M,k.CancellationToken.None);return new J(W,x,O,M.reconnectionToken,q)})}e.connectRemoteAgentManagement=c;async function o(W,x){return l(W,async O=>{const{protocol:M,debugPort:q}=await t(O,x,k.CancellationToken.None);return new $(W,x,O.reconnectionToken,M,q)})}e.connectRemoteAgentExtensionHost=o;async function l(W,x){const O=5;for(let M=1;;M++)try{const q=(0,C.generateUuid)(),j=await a(W,q,null);return await x(j)}catch(q){if(M<O)W.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(q);else throw W.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(q),V.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(q)),q}}async function f(W,x,O){const M=await a(W,(0,C.generateUuid)(),null);return await s(M,{host:x,port:O},k.CancellationToken.None)}e.connectRemoteAgentTunnel=f;function P(W){return(0,D.createCancelablePromise)(x=>new Promise((O,M)=>{const q=setTimeout(O,W*1e3);x.onCancellationRequested(()=>{clearTimeout(q),O()})}))}var U;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(U=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class _{constructor(x,O){this.reconnectionToken=x,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=_;class F{constructor(x,O,M,q){this.reconnectionToken=x,this.millisSinceLastIncomingData=O,this.durationSeconds=M,this.cancellableTimer=q,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class T{constructor(x,O,M){this.reconnectionToken=x,this.millisSinceLastIncomingData=O,this.attempt=M,this.type=2}}e.ReconnectionRunningEvent=T;class N{constructor(x,O,M){this.reconnectionToken=x,this.millisSinceLastIncomingData=O,this.attempt=M,this.type=4}}e.ConnectionGainEvent=N;class z{constructor(x,O,M,q){this.reconnectionToken=x,this.millisSinceLastIncomingData=O,this.attempt=M,this.handled=q,this.type=3}}e.ReconnectionPermanentFailureEvent=z;class V extends b.Disposable{constructor(x,O,M,q,j){super();this._connectionType=x,this._options=O,this.reconnectionToken=M,this.protocol=q,this._reconnectionFailureIsFatal=j,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(q.onSocketClose(Z=>{const G=Y(this._connectionType,this.reconnectionToken,!0);Z?Z.type===0?(this._options.logService.info(`${G} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this._options.logService.error(Z.error)):(this._options.logService.info(`${G} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this._options.logService.error(Z.event)):this._options.logService.info(`${G} received socket close event.`),this._beginReconnecting()})),this._register(q.onSocketTimeout(()=>{const Z=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} received socket timeout event.`),this._beginReconnecting()})),V._instances.push(this),this._register((0,b.toDisposable)(()=>{const Z=V._instances.indexOf(this);Z>=0&&V._instances.splice(Z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(V._permanentFailureMillisSinceLastIncomingData,V._permanentFailureAttempt,V._permanentFailureHandled)}static triggerPermanentFailure(x,O,M){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=x,this._permanentFailureAttempt=O,this._permanentFailureHandled=M,this._instances.forEach(q=>q._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(x=>x._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(x=>x._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||V._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const x=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${x} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const q=M<O.length?O[M]:O[O.length-1];try{if(q>0){const Z=P(q);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,Z)),this._options.logService.info(`${x} waiting for ${q} seconds before reconnecting...`);try{await Z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${x} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this._options.logService.info(`${x} resolving connection...`);const j=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${x} connecting to ${j.host}:${j.port}...`),await this._reconnect(j,S(v)),this._options.logService.info(`${x} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${x} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this._options.logService.error(`${x} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(j)){this._options.logService.info(`${x} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this._options.logService.info(`${x} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((0,L.isCancellationError)(j)){this._options.logService.info(`${x} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if(j instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${x} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,I.RemoteAuthorityResolverError.isHandled(j));break}this._options.logService.error(`${x} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(x,O,M){this._reconnectionFailureIsFatal?V.triggerPermanentFailure(x,O,M):this._gotoPermanentFailure(x,O,M)}_gotoPermanentFailure(x,O,M){this._onDidStateChange.fire(new z(this.reconnectionToken,x,O,M)),Q(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=V,V._permanentFailure=!1,V._permanentFailureMillisSinceLastIncomingData=0,V._permanentFailureAttempt=0,V._permanentFailureHandled=!1,V._instances=[];class J extends V{constructor(x,O,M,q,j){super(1,x,q,j,!0);this.client=this._register(new R.Client(j,{remoteAuthority:O,clientId:M},x.ipcLogger))}async _reconnect(x,O){await n(x,O)}}e.ManagementPersistentConnection=J;class $ extends V{constructor(x,O,M,q,j){super(2,x,M,q,!1);this._startArguments=O,this.debugPort=j}async _reconnect(x,O){await t(x,this._startArguments,O)}}e.ExtensionHostPersistentConnection=$;function Q(W){try{W.acceptDisconnect();const x=W.getSocket();W.dispose(),x.dispose()}catch(x){(0,L.onUnexpectedError)(x)}}function H(W){if(W&&W.type==="error"){const x=new Error(`Connection error: ${W.reason}`);return x.code="VSCODE_CONNECTION_ERROR",x}return null}function B(W,x){for(;W.length<x;)W+=" ";return W}function Y(W,x,O){return`[remote-connection][${B(d(W),13)}][${x.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function ie(W,x){return`${Y(x,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function ae(W){return`${Date.now()-W} ms`}}),define(ne[205],re([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[206],re([0,1,76,134]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,L,A,b,C,R){const I=v=>R(v,void 0),E=D.createConnection({host:k,port:L},()=>{E.removeListener("error",I);const v=Buffer.alloc(16);for(let w=0;w<16;w++)v[w]=Math.round(Math.random()*256);const y=v.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${L}${A}?${b}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];E.write(d.join(`\r
`)+`\r
\r
`);const S=w=>{w.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",S),R(void 0,new i.NodeSocket(E,C)))};E.on("data",S)});E.setNoDelay(!0),E.once("error",I)}}}),define(ne[207],re([0,1,118,19,8]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(b,C){this.configurationService=b,this.logService=C}async request(b,C){this.logService.trace("RequestService#request (browser) - begin",b.url),b.proxyAuthorization||(b.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const R=await(0,D.request)(b,C);return this.logService.trace("RequestService#request (browser) - success",b.url),R}catch(R){throw this.logService.error("RequestService#request (browser) - error",b.url,R),R}}async resolveProxy(b){}};L=ge([K(0,i.IConfigurationService),K(1,k.ILogService)],L),e.RequestService=L}),define(ne[46],re([0,1,16,153,43,5,40]),function(X,e,D,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function b(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=b;function C(S){return S.res.statusCode===204}async function R(S){return C(S)?null:(await(0,D.streamToBuffer)(S.stream)).toString()}e.asText=R;async function I(S){if(!b(S))throw new Error("Server returned "+S.res.statusCode);return R(S)}e.asTextOrError=I;async function E(S){if(!b(S))throw new Error("Server returned "+S.res.statusCode);if(C(S))return null;const p=(await(0,D.streamToBuffer)(S.stream)).toString();try{return JSON.parse(p)}catch(m){throw m.message+=`:
`+p,m}}e.asJson=E;function v(S){d(S)}e.updateProxyConfigurationsScope=v;let y;function d(S){const w=A.Registry.as(k.Extensions.Configuration),p=y;y={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[y],remove:p?[p]:[]})}d(2)}),define(ne[208],re([0,1,21,20,13,46]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(C,R){this.requestService=C,this.fileService=R}async download(C,R,I=D.CancellationToken.None){if(C.scheme===i.Schemas.file||C.scheme===i.Schemas.vscodeRemote){await this.fileService.copy(C,R);return}const E={type:"GET",url:C.toString(!0)},v=await this.requestService.request(E,I);if(v.res.statusCode===200)await this.fileService.writeFile(R,v.stream);else{const y=await(0,L.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${y}`)}}};A=ge([K(0,L.IRequestService),K(1,k.IFileService)],A),e.DownloadService=A}),define(ne[209],re([0,1,18,21,2,17,170,13,8,24,46]),function(X,e,D,i,k,L,A,b,C,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let E=class extends k.Disposable{constructor(y,d,S,w){super();this.fileService=y,this.productService=d,this.requestService=S,this.logService=w,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,p])=>this.allConfigBasedTips.set(p.configPath,p))}getConfigBasedTips(y){return this.getValidConfigBasedTips(y)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(y){const d=[];for(const[S,w]of this.allConfigBasedTips)if(!(w.configScheme&&w.configScheme!==y.scheme))try{const p=await this.fileService.readFile((0,L.joinPath)(y,S)),m=new Map;Object.entries(w.recommendations).forEach(([g,h])=>{if((0,D.isNonEmptyArray)(h.remotes))for(const r of h.remotes)m.set(r,{extensionId:g,extensionName:h.name,configName:w.configName,important:!!h.important,isExtensionPack:!!h.isExtensionPack,whenNotInstalled:h.whenNotInstalled});else d.push({extensionId:g,extensionName:h.name,configName:w.configName,important:!!h.important,isExtensionPack:!!h.isExtensionPack,whenNotInstalled:h.whenNotInstalled})});const u=(0,A.getDomainsOfRemotes)(p.value.toString(),[...m.keys()]);for(const g of u){const h=m.get(g);h&&d.push(h)}}catch{}return d}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const y=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},i.CancellationToken.None);if(y.res.statusCode!==200)return[];const d=await(0,I.asJson)(y);return d?d.workspaceRecommendations||[]:[]}catch(y){return this.logService.error(y),[]}}};E=ge([K(0,b.IFileService),K(1,R.IProductService),K(2,I.IRequestService),K(3,C.ILogService)],E),e.ExtensionTipsService=E}),define(ne[210],re([0,1,16,21]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(b){this.service=b}listen(b,C){throw new Error("Invalid listen")}call(b,C,R,I=i.CancellationToken.None){switch(C){case"request":return this.service.request(R[0],I).then(async({res:E,stream:v})=>{const y=await(0,D.streamToBuffer)(v);return[{statusCode:E.statusCode,headers:E.headers},y]});case"resolveProxy":return this.service.resolveProxy(R[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class L{constructor(b){this.channel=b}async request(b,C){const[R,I]=await this.channel.call("request",[b],C);return{res:R,stream:(0,D.bufferToStream)(I)}}async resolveProxy(b){return this.channel.call("resolveProxy",[b])}}e.RequestChannelClient=L}),define(ne[211],re([0,1,207,210]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class k{constructor(A,b,C){this.configurationService=b,this.logService=C,this.browserRequestService=new D.RequestService(b,C),this.mainRequestService=new i.RequestChannelClient(A.getChannel("request"))}request(A,b){return this.getRequestService().request(A,b)}async resolveProxy(A){return this.getRequestService().resolveProxy(A)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=k}),define(ne[99],re([0,1,62,5]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function k(L){return(0,D.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=k,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[212],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[213],re([0,1,84,6,21,3,2,20,31,8,99,212]),function(X,e,D,i,k,L,A,b,C,R,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let v=class{constructor(S){this.logService=S,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(S){const w=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${w})`);const p=(0,I.hash)(S);this.processeDisposables.has(p)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${w})`),this.doDisposeWorker(S));const m=new k.CancellationTokenSource;let u,g,h;this.processeDisposables.set(p,s=>{m.dispose(!0),u?.terminate(S,k.CancellationToken.None),g?.close(),h?.close(),this.processeDisposables.delete(p);const a=this.processResolvers.get(p);a&&(this.processResolvers.delete(p),a({reason:s}))}),u=await this.getOrCreateWebWorker(S);const r=new Promise(s=>{this.processResolvers.set(p,s)});if(m.token.isCancellationRequested)return r;const{port1:n,port2:t}=new MessageChannel;return g=n,h=t,await u.spawn(S,h,m.token),m.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${w})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[g])),r}getOrCreateWebWorker(S){let w=this.workers.get(S.process.moduleId);if(!w){this.logService.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const p=new y(S.process.type,this.logService);w=p.init(),p.onDidProcessSelfTerminate(({configuration:m,reason:u})=>{this.doDisposeWorker(m,u)}),this.workers.set(S.process.moduleId,w)}return w}async disposeWorker(S){return this.doDisposeWorker(S)}doDisposeWorker(S,w){const p=this.processeDisposables.get((0,I.hash)(S));p&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),p(w))}};v=ge([K(0,R.ILogService)],v),e.SharedProcessWorkerService=v;class y extends A.Disposable{constructor(S,w){super();this.type=S,this.logService=w,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const S=new i.DeferredPromise,w=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return w.onerror=p=>{this.logService.error(`SharedProcess: worker error (${this.type})`,p.message)},w.onmessageerror=p=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,p)},w.onmessage=p=>{const{id:m,message:u,configuration:g,nonce:h}=p.data;switch(m){case E.SharedProcessWorkerMessages.Ready:S.complete(w);break;case E.SharedProcessWorkerMessages.Ack:if(h){const r=this.mapMessageNonceToPendingMessageResolve.get(h);r&&(this.mapMessageNonceToPendingMessageResolve.delete(h),r())}break;case E.SharedProcessWorkerMessages.SelfTerminated:g&&u&&this._onDidProcessSelfTerminate.fire({configuration:g,reason:JSON.parse(u)});break;case E.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,u);break;case E.SharedProcessWorkerMessages.Info:u&&this.logService.info(u);break;case E.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,u);break;case E.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,u);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,p)}},w.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async send(S,w,p){const m=await this.workerReady;if(!w.isCancellationRequested)return new Promise(u=>{const g=(0,C.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(g,u);const h={...S,nonce:g};p?m.postMessage(h,[p]):m.postMessage(h),w.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(g)&&u()})})}spawn(S,w,p){const m={id:E.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:b.FileAccess.asFileUri("bootstrap-fork",X).fsPath}};return this.send(m,p,w)}terminate(S,w){const p={id:E.SharedProcessWorkerMessages.Terminate,configuration:S};return this.send(p,w)}}}),define(ne[214],re([0,1,60,20,169]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends k.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.vscodeUserData})}}ge([D.memoize],L.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=L}),define(ne[215],re([0,1,48,12,154,21,38,9,4,31,136,167,6]),function(X,e,D,i,k,L,A,b,C,R,I,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let d;async function S(p,m,u){return m["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(u)&&!m["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(u)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=v.Promises.withAsyncBody(async(g,h)=>{const r=new L.CancellationTokenSource,n=setTimeout(()=>{r.dispose(!0),h(new Error((0,k.localize)(0,null)))},y);try{g(await w(p,r.token))}catch(t){!(0,b.isCancellationError)(t)&&!r.token.isCancellationRequested?h(new Error((0,k.localize)(1,null,(0,A.toErrorMessage)(t)))):g({})}finally{clearTimeout(n),r.dispose()}})),d)}e.getResolvedShellEnv=S;async function w(p,m){const u=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",u);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",g);const h=(0,R.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(h+"(.*)"+h),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",n);const t=await(0,I.getSystemShell)(C.OS,n);return p.trace("getUnixShellEnvironment#shell",t),new Promise((s,a)=>{if(m.isCancellationRequested)return a((0,b.canceled)());const c=(0,i.basename)(t);let o,l;const f=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(o=`& '${process.execPath}' ${f} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,l=["-Login","-Command"]):(o=`'${process.execPath}' ${f} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,c==="tcsh"?l=["-ic"]:l=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),o);const P=(0,D.spawn)(t,[...l,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});m.onCancellationRequested(()=>(P.kill(),a((0,b.canceled)()))),P.on("error",F=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(F)),a(F)});const U=[];P.stdout.on("data",F=>U.push(F));const _=[];P.stderr.on("data",F=>_.push(F)),P.on("close",(F,T)=>{const N=Buffer.concat(U).toString("utf8");p.trace("getUnixShellEnvironment#raw",N);const z=Buffer.concat(_).toString("utf8");if(z.trim()&&p.trace("getUnixShellEnvironment#stderr",z),F||T)return a(new Error((0,k.localize)(2,null,F,T)));const V=r.exec(N),J=V?V[1]:"{}";try{const $=JSON.parse(J);u?$.ELECTRON_RUN_AS_NODE=u:delete $.ELECTRON_RUN_AS_NODE,g?$.ELECTRON_NO_ATTACH_CONSOLE=g:delete $.ELECTRON_NO_ATTACH_CONSOLE,delete $.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",$),s($)}catch($){p.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)($)),a($)}})})}}),define(ne[100],re([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[216],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((k,L)=>X(["vsda"],k,L))}async createNewMessage(k){try{const L=await this.vsda(),A=new L.validator;if(A){const b=String(D._nextId++);return this.validators.set(b,A),{id:b,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,L){if(!k.id)return!0;const A=this.validators.get(k.id);if(!A)return!1;this.validators.delete(k.id);try{return A.validate(L)==="ok"}catch{return!1}}async sign(k){try{const L=await this.vsda(),A=new L.signer;if(A)return A.sign(k)}catch{}return k}}e.SignService=D,D._nextId=1}),define(ne[217],re([0,1,3,2]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class k extends i.Disposable{constructor(I,E,v){super();this.channel=I,this.profile=E,this.workspace=v}async getItems(){const I={profile:this.profile,workspace:this.workspace},E=await this.channel.call("getItems",I);return new Map(E)}updateItems(I){const E={profile:this.profile,workspace:this.workspace};return I.insert&&(E.insert=Array.from(I.insert.entries())),I.delete&&(E.delete=Array.from(I.delete.values())),this.channel.call("updateItems",E)}}class L extends k{constructor(I,E){super(I,E,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(I=>this.onDidChangeStorage(I)))}onDidChangeStorage(I){(Array.isArray(I.changed)||Array.isArray(I.deleted))&&this._onDidChangeItemsExternal.fire({changed:I.changed?new Map(I.changed):void 0,deleted:I.deleted?new Set(I.deleted):void 0})}}class A extends L{constructor(I){super(I,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=A;class b extends L{constructor(I,E){super(I,E)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=b;class C extends k{constructor(I,E){super(I,void 0,E);this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=C}),define(ne[101],re([0,1,4,36,7,31]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(R){if(D.platform===2&&/^penguin(\.|$)/i.test(R))return"chromebook"}async function b(R,I,E,v,y,d,S,w,p,m){const u=Object.create(null);u["common.machineId"]=S,u.sessionID=(0,L.generateUuid)()+Date.now(),u.commitHash=y,u.version=d,u["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,D.PlatformToString)(D.platform),u["common.nodePlatform"]=i.platform,u["common.nodeArch"]=v,u["common.product"]=m||"desktop",w&&(u["common.msftInternal"]=w);let g=0;const h=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),D.isLinuxSnap&&(u["common.snap"]="true");const r=A(E);r&&(u["common.platformDetail"]=r);try{const n=await R.readFile(k.URI.file(p));u["common.source"]=n.value.toString().slice(0,30)}catch{}return u}e.resolveCommonProperties=b;function C(R){const I=i.env.USERDNSDOMAIN;if(!I)return!1;const E=I.toLowerCase();return R.some(v=>E===v)}e.verifyMicrosoftInternalDomain=C}),define(ne[22],re([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[218],re([0,1,37,52,6,35,20,12,4,7,129,27,131,89,13,24,22]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function m(n,t){const s=`${n}::${t.join(":")}`,a=p.get(s);if(a)return a;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,l=new Map,f=2e4;function P(_,F,T,N){const z=F.substring(_.length+1);return k.Promises.withAsyncBody(async V=>{let J;try{J=await E.Promises.readdir(F,{withFileTypes:!0})}catch{V();return}if(N.count>=f){N.count+=J.length,N.maxReached=!0,V();return}let $=J.length;if($===0){V();return}let Q=J;N.count+J.length>f&&(N.maxReached=!0,$=f-N.count,Q=J.slice(0,$)),N.count+=J.length;for(const H of Q)if(H.isDirectory()){if(T.includes(H.name)||await P(_,(0,b.join)(F,H.name),T,N),--$==0){V();return}}else{const B=H.name.lastIndexOf(".");if(B>=0){const Y=H.name.substring(B+1);Y&&o.set(Y,(o.get(Y)??0)+1)}for(const Y of c)Y.relativePathPattern?.test(z)!==!1&&Y.filePattern.test(H.name)&&l.set(Y.tag,(l.get(Y.tag)??0)+1);if(--$==0){V();return}}})}const U=k.Promises.withAsyncBody(async _=>{const F={count:0,maxReached:!1};await P(n,n,t,F);const T=await h(n);_({configFiles:u(l),fileTypes:u(o),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:T})});return p.set(s,U),U}e.collectWorkspaceStats=m;function u(n){return[...i.Iterable.map(n.entries(),([t,s])=>({name:t,count:s}))].sort((t,s)=>s.count-t.count)}function g(){const n={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(n.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),n}e.getMachineInfo=g;async function h(n){try{const t=new Map,s=(0,b.join)(n,".vscode","launch.json"),a=await E.Promises.readFile(s),c=[],o=(0,L.parse)(a.toString(),c);if(c.length)return console.log(`Unable to parse ${s}`),[];if((0,L.getNodeType)(o)==="object"&&o.configurations)for(const l of o.configurations){const f=l.type;f&&(t.has(f)?t.set(f,t.get(f)+1):t.set(f,1))}return u(t)}catch{return[]}}e.collectLaunchConfigs=h;let r=class{constructor(t,s){this.telemetryService=t,this.productService=s}formatMachineInfo(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}formatEnvironment(t){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const a=D.cpus();return a&&a.length>0&&s.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),s.push(`Memory (System):  ${(D.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||s.push(`Load (avg):       ${D.loadavg().map(c=>Math.round(c)).join(", ")}`),s.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,v.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async a=>{let[c,o]=a,l=this.formatProcessList(t,c);return s.forEach(f=>{if((0,y.isRemoteDiagnosticError)(f))l+=`
${f.errorMessage}`,o+=`
${f.errorMessage}`;else if(l+=`

Remote: ${f.hostName}`,f.processes&&(l+=`
${this.formatProcessList(t,f.processes)}`),f.workspaceMetadata){o+=`
|  Remote: ${f.hostName}`;for(const P of Object.keys(f.workspaceMetadata)){const U=f.workspaceMetadata[P];let _=`${U.fileCount} files`;U.maxFilesReached&&(_=`more than ${_}`),o+=`|    Folder (${P}): ${_}`,o+=this.formatWorkspaceStats(U)}}}),{processInfo:l,workspaceInfo:o}})}async getSystemInfo(t,s){const{memory:a,vmHint:c,os:o,cpus:l}=g(),f={os:o,memory:a,cpus:l,vmHint:c,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return C.isWindows||(f.load=`${D.loadavg().map(P=>Math.round(P)).join(", ")}`),C.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(t,s){const a=[];return(0,v.listProcesses)(t.mainPID).then(async c=>(a.push(""),a.push(this.formatEnvironment(t)),a.push(""),a.push(this.formatProcessList(t,c)),t.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.formatWorkspaceMetadata(t))),s.forEach(o=>{if((0,y.isRemoteDiagnosticError)(o))a.push(`
${o.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${o.hostName}`),a.push(this.formatMachineInfo(o.machineInfo)),o.processes&&a.push(this.formatProcessList(t,o.processes)),o.workspaceMetadata)for(const l of Object.keys(o.workspaceMetadata)){const f=o.workspaceMetadata[l];let P=`${f.fileCount} files`;f.maxFilesReached&&(P=`more than ${P}`),a.push(`Folder (${l}): ${P}`),a.push(this.formatWorkspaceStats(f))}}),a.push(""),a.push(""),a.join(`
`)))}formatWorkspaceStats(t){const s=[],a=60;let c=0;const o=(U,_)=>{const F=` ${U}(${_})`;c+F.length>a?(s.push(l),l="|                 ",c=l.length):c+=F.length,l+=F};let l="|      File types:";const f=10,P=t.fileTypes.length>f?f:t.fileTypes.length;for(let U=0;U<P;U++){const _=t.fileTypes[U];o(_.name,_.count)}if(s.push(l),t.configFiles.length>=0&&(l="|      Conf files:",c=0,t.configFiles.forEach(U=>{o(U.name,U.count)}),s.push(l)),t.launchConfigFiles.length>0){let U="|      Launch Configs:";t.launchConfigFiles.forEach(_=>{U+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),s.push(U)}return s.join(`
`)}expandGPUFeatures(t){const s=Math.max(...Object.keys(t).map(a=>a.length));return Object.keys(t).map(a=>`${a}:  ${" ".repeat(s-a.length)}  ${t[a]}`).join(`
                  `)}formatWorkspaceMetadata(t){const s=[],a=[];return t.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(s.push(`|  Window (${c.title})`),c.folderURIs.forEach(o=>{const l=R.URI.revive(o);if(l.scheme===A.Schemas.file){const f=l.fsPath;a.push(m(f,["node_modules",".git"]).then(P=>{let U=`${P.fileCount} files`;P.maxFilesReached&&(U=`more than ${U}`),s.push(`|    Folder (${(0,b.basename)(f)}): ${U}`),s.push(this.formatWorkspaceStats(P))}).catch(P=>{s.push(`|      Error: Unable to collect workspace stats for folder ${f} (${P.toString()})`)}))}else s.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(c=>s.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(t,s){const a=new Map;t.windows.forEach(o=>a.set(o.pid,o.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(t.mainPID,a,c,s,0),c.join(`
`)}formatProcessItem(t,s,a,c,o){const l=o===0;let f;l?f=c.pid===t?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(o)} ${c.name}`,c.name==="window"&&(f=`${f} (${s.get(c.pid)})`));const P=process.platform==="win32"?c.mem:D.totalmem()*(c.mem/100);a.push(`${c.load.toFixed(0).padStart(5," ")}	${(P/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(c.children)&&c.children.forEach(U=>this.formatProcessItem(t,s,a,U,o+1))}async getWorkspaceFileExtensions(t){const s=new Set;for(const{uri:a}of t.folders){const c=R.URI.revive(a);if(c.scheme!==A.Schemas.file)continue;const o=c.fsPath;try{(await m(o,["node_modules",".git"])).fileTypes.forEach(f=>s.add(f.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const a=R.URI.revive(s);if(a.scheme!==A.Schemas.file)continue;const c=a.fsPath;try{const o=await m(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),o.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),o.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),o.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};r=ge([K(0,w.ITelemetryService),K(1,S.IProductService)],r),e.DiagnosticsService=r}),define(ne[102],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(L){this.appenders=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,{eventName:b,data:C}){return this.appenders.forEach(R=>R.log(b,C)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class i{constructor(L){this.channel=L}log(L,A){return this.channel.call("log",{eventName:L,data:A}).then(void 0,b=>`Failed to log telemetry: ${console.warn(b)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(ne[50],re([0,1,30,78,14,19,101,22]),function(X,e,D,i,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,i.staticObservableValue)(0)}publicLog(r,n){return Promise.resolve(void 0)}publicLog2(r,n){return this.publicLog(r,n)}publicLogError(r,n){return Promise.resolve(void 0)}publicLogError2(r,n){return this.publicLogError(r,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=C,e.NullTelemetryService=new C;class R{async publicLog(r,n,t){}async publicLogError(r,n,t){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(h,r){return r.onDidChangeConfiguration(n=>{n.source!==7&&h.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(n.source),configurationKeys:p(n.sourceConfig)})})}e.configurationTelemetry=I;function E(h,r){return!(r.disableTelemetry||!h.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=E;function v(h){const r=h.getValue(b.TELEMETRY_SETTING_ID),n=h.getValue("telemetry.enableCrashReporter");if(h.getValue(b.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function y(h){const r={},n={},t={};w(h,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const a=t[s];typeof a=="number"?n[s]=a:typeof a=="boolean"?n[s]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${a.length}`),r[s]=a.substring(0,8191)):typeof a!="undefined"&&a!==null&&(r[s]=a)}return{properties:r,measurements:n}}e.validateTelemetryData=y;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function S(h){if(!h)return"none";for(const r of d)if(h.startsWith(`${r}+`))return r;return"other"}e.cleanRemoteAuthority=S;function w(h,r,n=0,t){if(!!h)for(const s of Object.getOwnPropertyNames(h)){const a=h[s],c=t?t+s:s;Array.isArray(a)?r[c]=(0,D.safeStringify)(a):a instanceof Date?r[c]=a.toISOString():(0,k.isObject)(a)?n<2?w(a,r,n+1,c+"."):r[c]=(0,D.safeStringify)(a):r[c]=a}}function p(h){if(!h)return[];const r=[];return m(r,"",h),r}function m(h,r,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(t=>m(h,r?`${r}.${t}`:t,n[t])):h.push(r)}function u(h,r){const n=h.msftInternalDomains||[],t=r.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(n)||t}e.isInternalTelemetry=u;function g(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.getPiiPathsFromEnvironment=g}),define(ne[219],re([0,1,49,50]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(L,A,b,C,R,I,E){const v={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${A.nameShort})`},y=await(0,D.getServiceMachineId)(b,R,I),{sessionId:d}=await E.getTelemetryInfo();return(0,i.supportsTelemetry)(A,b)&&(0,i.getTelemetryLevel)(C)===3&&(v["X-Market-User-Id"]=y,v["VSCode-SessionId"]=d),v}e.resolveMarketplaceHeaders=k}),define(ne[220],re([0,1,9,30,50]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function A(C,R,I){const E=await new Promise((w,p)=>{X(["@microsoft/1ds-core-js"],w,p)}),v=await new Promise((w,p)=>{X(["@microsoft/1ds-post-js"],w,p)}),y=new E.AppInsightsCore,d=new v.PostChannel,S={instrumentationKey:C,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(I){S.extensionConfig={};const w={alwaysUseXhrOverride:!0,httpXHROverride:I};S.extensionConfig[d.identifier]=w}return y.initialize(S,[]),y.addTelemetryInitializer(w=>{R&&(w.ext=w.ext??{},w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),y}class b{constructor(R,I,E,v,y){this._isInternalTelemetry=R,this._eventPrefix=I,this._defaultData=E,this._xhrOverride=y,this.endPointUrl=L,this._defaultData||(this._defaultData={}),typeof v=="function"?this._aiCoreOrKey=v():this._aiCoreOrKey=v,this._asyncAiCore=null}_withAIClient(R){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){R(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=A(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(I=>{R(I)},I=>{(0,D.onUnexpectedError)(I),console.error(I)})}}log(R,I){if(!this._aiCoreOrKey)return;I=(0,i.mixin)(I,this._defaultData),I=(0,k.validateTelemetryData)(I);const E=this._eventPrefix+"/"+R;try{this._withAIClient(v=>{v.pluginVersionString=I?.properties.version??"Unknown",v.track({name:E,baseData:{name:E,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(R=>{this._withAIClient(I=>{I.unload(!0,()=>{this._aiCoreOrKey=void 0,R(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=b}),define(ne[221],re([0,1,220]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemWebAppender=void 0;class i extends D.AbstractOneDataSystemAppender{constructor(L,A,b,C){super(L,A,b,C);fetch(this.endPointUrl,{method:"POST"}).catch(R=>{this._aiCoreOrKey=void 0})}}e.OneDataSystemWebAppender=i}),define(ne[103],re([0,1,2,15,8,50]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends D.Disposable{constructor(C,R,I=""){super();this.prefix=I;const E=C.getLogger(R.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(C.createLogger(R.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(C,R){this.logger.trace(`${this.prefix}telemetry/${C}`,(0,L.validateTelemetryData)(R))}};A=ge([K(0,k.ILoggerService),K(1,i.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(ne[104],re([0,1,2,30,78,4,26,155,19,43,96,24,40,22,50]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(m,u,g){this._configurationService=u,this._productService=g,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const h of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(h),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(m,u){this._experimentProperties[m]=u}_updateTelemetryLevel(){let m=(0,d.getTelemetryLevel)(this._configurationService);const u=this._productService.enabledTelemetryLevels;if(u){this._sendErrorTelemetry=this.sendErrorTelemetry?u.error:!1;const g=u.usage?3:u.error?2:0;m=Math.min(m,g)}this.telemetryLevel.value=m}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const m=await this._commonProperties,u=m.sessionID,g=m["common.machineId"],h=m["common.firstSessionDate"],r=m["common.msftInternal"];return{sessionId:u,machineId:g,firstSessionDate:h,msftInternal:r}}dispose(){this._disposables.dispose()}_log(m,u,g,h){return this.telemetryLevel.value<u?Promise.resolve(void 0):this._commonProperties.then(r=>{g=(0,i.mixin)(g,r),g=(0,i.mixin)(g,this._experimentProperties),g=(0,i.cloneAndChange)(g,n=>{if(typeof n=="string")return this._cleanupInfo(n,h)}),this._appenders.forEach(n=>n.log(m,g))},r=>{console.error(r)})}publicLog(m,u,g){return this._log(m,3,u,g)}publicLog2(m,u,g){return this.publicLog(m,u,g)}publicLogError(m,u){return this._sendErrorTelemetry?this._log(m,2,u,!0):Promise.resolve(void 0)}publicLogError2(m,u){return this.publicLogError(m,u)}_anonymizeFilePaths(m){let u=m;const g=[];for(const t of this._cleanupPatterns)for(;;){const s=t.exec(m);if(!s)break;g.push([s.index,t.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let n=0;for(u="";;){const t=r.exec(m);if(!t)break;!h.test(t[0])&&g.every(([s,a])=>t.index<s||t.index>=a)&&(u+=m.substring(n,t.index)+"<REDACTED: user-file-path>",n=r.lastIndex)}return n<m.length&&(u+=m.substr(n)),u}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const u=m.toLowerCase(),g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const h of g)if(h.regex.test(u))return`<REDACTED: ${h.label}>`;return m}_cleanupInfo(m,u){let g=m;u&&(g=this._anonymizeFilePaths(g));for(const h of this._cleanupPatterns)g=g.replace(h,"");return g=this._removePropertiesWithPossibleUserInfo(g),g}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=ge([K(1,C.IConfigurationService),K(2,E.IProductService)],S),e.TelemetryService=S;function w(){const p=(0,b.localize)(0,null,I.default.nameLong),m=I.default.privacyStatementUrl?(0,b.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,b.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=L.isWeb?"":(0,b.localize)(3,null),g=(0,b.localize)(4,null),h=(0,b.localize)(5,null),r=(0,b.localize)(6,null),n=(0,b.localize)(7,null),t=`
|       | ${g} | ${h} | ${r} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,b.localize)(8,null);return`
${p} ${m} ${u}

&nbsp;

${n}
${t}

&nbsp;

${s}
`}v.Registry.as(R.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,b.localize)(10,null),(0,b.localize)(11,null),(0,b.localize)(12,null),(0,b.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(R.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,b.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,b.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,b.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[222],re([0,1,20,64,19,15,8,24,22,102,103,104]),function(X,e,D,i,k,L,A,b,C,R,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let v=class{constructor(d,S,w,p,m){this.configurationService=d,this.telemetryService=S,this.loggerService=w,this.environmentService=p,this.productService=m,this.customTelemetryServices=new Map}async getCustomTelemetryService(d){if(!this.customTelemetryServices.has(d.id)){const{machineId:S,sessionId:w}=await this.telemetryService.getTelemetryInfo(),p=Object.create(null);p["common.vscodemachineid"]=S,p["common.vscodesessionid"]=w;const m=[d.id,JSON.stringify(p),d.aiKey],g=new i.Client(D.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),h=[new R.TelemetryAppenderClient(g),new I.TelemetryLogAppender(this.loggerService,this.environmentService,`[${d.id}] `)];this.customTelemetryServices.set(d.id,new E.TelemetryService({appenders:h,sendErrorTelemetry:d.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(d.id)}async publicLog(d,S,w){await(await this.getCustomTelemetryService(d)).publicLog(S,w)}async publicLogError(d,S,w){await(await this.getCustomTelemetryService(d)).publicLogError(S,w)}};v=ge([K(0,k.IConfigurationService),K(1,C.ITelemetryService),K(2,A.ILoggerService),K(3,L.IEnvironmentService),K(4,b.IProductService)],v),e.CustomEndpointTelemetryService=v}),define(ne[223],re([0,1,6,21,3,2,8]),function(X,e,D,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let b=class extends L.Disposable{constructor(R,I){super();this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new k.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=R===void 0?15e3:R}createRequest(R){return new Promise((I,E)=>{const v=++this._lastRequestId;this._pendingRequests.set(v,I),this._onCreateRequest.fire({requestId:v,...R});const y=new i.CancellationTokenSource;(0,D.timeout)(this._timeout,y.token).then(()=>E(`Request ${v} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(v,[(0,L.toDisposable)(()=>y.cancel())])})}acceptReply(R,I){const E=this._pendingRequests.get(R);E?(this._pendingRequests.delete(R),(0,L.dispose)(this._pendingRequestDisposables.get(R)||[]),this._pendingRequestDisposables.delete(R),E(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${R}`)}};b=ge([K(1,A.ILogService)],b),e.RequestStore=b}),define(ne[105],re([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(u){u.Shell="terminal.integrated.shell.",u.ShellArgs="terminal.integrated.shellArgs.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(u){u.ShellLinux="terminal.integrated.shell.linux",u.ShellMacOs="terminal.integrated.shell.osx",u.ShellWindows="terminal.integrated.shell.windows",u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationShellLinux="terminal.integrated.automationShell.linux",u.AutomationShellMacOs="terminal.integrated.automationShell.osx",u.AutomationShellWindows="terminal.integrated.automationShell.windows",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ShellArgsLinux="terminal.integrated.shellArgs.linux",u.ShellArgsMacOs="terminal.integrated.shellArgs.osx",u.ShellArgsWindows="terminal.integrated.shellArgs.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",u.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",u.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(u){u.FileName="ptyhost"})(L=e.TerminalLogConstants||(e.TerminalLogConstants={}));var A;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(A=e.PosixShellType||(e.PosixShellType={}));var b;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(b=e.WindowsShellType||(e.WindowsShellType={}));var C;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(C=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.Log="log",u.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var I;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(I=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var v;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(v=e.TerminalLocation||(e.TerminalLocation={}));var y;(function(u){u.TerminalView="view",u.Editor="editor"})(y=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var w;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(w=e.ProfileSource||(e.ProfileSource={}));var p;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(p=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var m;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(m=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[224],re([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ne[225],re([0,1,37,20,30,12,4,36,26,14,27]),function(X,e,D,i,k,L,A,b,C,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let h=0;return g&&g.length===4&&(h=parseInt(g[3])),h}e.getWindowsBuildNumber=E;async function v(g,h,r,n=b.env,t=I.Promises.exists){if(L.isAbsolute(g))return await t(g)?g:void 0;if(h===void 0&&(h=b.cwd()),L.dirname(g)!=="."){const o=L.join(h,g);return await t(o)?o:void 0}const a=(0,k.getCaseInsensitive)(n,"PATH");if(r===void 0&&(0,R.isString)(a)&&(r=a.split(L.delimiter)),r===void 0||r.length===0){const o=L.join(h,g);return await t(o)?o:void 0}for(const o of r){let l;if(L.isAbsolute(o)?l=L.join(o,g):l=L.join(h,o,g),await t(l))return l;if(A.isWindows){let f=l+".com";if(await t(f)||(f=l+".exe",await t(f)))return f}}const c=L.join(h,g);return await t(c)?c:void 0}e.findExecutable=v;function y(g,h,r){if(!h.enabled||!g.executable||g.isFeatureTerminal||g.hideFromUser||g.ignoreShellIntegration)return;const n=g.args,t=b.platform==="win32"?L.basename(g.executable).toLowerCase():L.basename(g.executable),s=L.dirname(i.FileAccess.asFileUri("",X).fsPath);let a;const c={VSCODE_INJECTION:"1"};if(A.isWindows){if(t==="pwsh.exe")return!n||m(n)?a=e.shellIntegrationArgs.get(d.WindowsPwsh):p(n)&&(a=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),a?(a&&(a=[...a],a[a.length-1]=(0,C.format)(a[a.length-1],s,"")),{newArgs:a,envMixin:c}):void 0;r.warn(`Shell integration cannot be enabled for executable "${g.executable}" and args`,g.args);return}switch(t){case"bash":return!n||n.length===0?a=e.shellIntegrationArgs.get(d.Bash):u(n)&&(c.VSCODE_SHELL_LOGIN="1",a=e.shellIntegrationArgs.get(d.Bash)),a?(a=[...a],a[a.length-1]=(0,C.format)(a[a.length-1],s),{newArgs:a,envMixin:c}):void 0;case"pwsh":return!n||m(n)?a=e.shellIntegrationArgs.get(d.Pwsh):p(n)&&(a=e.shellIntegrationArgs.get(d.PwshLogin)),a?(a=[...a],a[a.length-1]=(0,C.format)(a[a.length-1],s,""),{newArgs:a,envMixin:c}):void 0;case"zsh":{if(!n||n.length===0?a=e.shellIntegrationArgs.get(d.Zsh):u(n)?a=e.shellIntegrationArgs.get(d.ZshLogin):(n===e.shellIntegrationArgs.get(d.Zsh)||n===e.shellIntegrationArgs.get(d.ZshLogin))&&(a=n),!a)return;a=[...a],a[a.length-1]=(0,C.format)(a[a.length-1],s);const o=L.join(D.tmpdir(),"vscode-zsh");c.ZDOTDIR=o;const l=[];return l.push({source:L.join(s,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.join(o,".zshrc")}),l.push({source:L.join(s,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.join(o,".zprofile")}),l.push({source:L.join(s,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.join(o,".zshenv")}),l.push({source:L.join(s,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.join(o,".zlogin")}),{newArgs:a,envMixin:c,filesToCopy:l}}}r.warn(`Shell integration cannot be enabled for executable "${g.executable}" and args`,g.args)}e.getShellIntegrationInjection=y;var d;(function(g){g.WindowsPwsh="windows-pwsh",g.WindowsPwshLogin="windows-pwsh-login",g.Pwsh="pwsh",g.PwshLogin="pwsh-login",g.Zsh="zsh",g.ZshLogin="zsh-login",g.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],w=["-nol","-nologo"];function p(g){return typeof g=="string"?S.includes(g.toLowerCase()):g.length===1&&S.includes(g[0].toLowerCase())||g.length===2&&(S.includes(g[0].toLowerCase())||S.includes(g[1].toLowerCase()))&&(w.includes(g[0].toLowerCase())||w.includes(g[1].toLowerCase()))}function m(g){return typeof g=="string"?w.includes(g.toLowerCase()):g.length===0||g?.length===1&&w.includes(g[0].toLowerCase())}function u(g){return g==="string"&&S.includes(g.toLowerCase())||typeof g!="string"&&g.length===1&&S.includes(g[0].toLowerCase())}}),define(ne[226],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function i(L){return L===D.HIGH_CONTRAST_DARK||L===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function k(L){return L===D.DARK||L===D.HIGH_CONTRAST_DARK}e.isDark=k}),define(ne[106],re([0,1,51,3,2,5,40,226]),function(X,e,D,i,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var C;(function(w){function p(m){return m&&typeof m=="object"&&typeof m.id=="string"}w.isThemeColor=p})(C=e.ThemeColor||(e.ThemeColor={}));function R(w){return{id:w}}e.themeColorFromId=R;var I;(function(w){function p(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||C.isThemeColor(s.color))}w.isThemeIcon=p;const m=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function u(s){const a=m.exec(s);if(!a)return;const[,c]=a;return{id:c}}w.fromString=u;function g(s){return{id:s}}w.fromId=g;function h(s,a){let c=s.id;const o=c.lastIndexOf("~");return o!==-1&&(c=c.substring(0,o)),a&&(c=`${c}~${a}`),{id:c}}w.modify=h;function r(s){const a=s.id.lastIndexOf("~");if(a!==-1)return s.id.substring(a+1)}w.getModifier=r;function n(s,a){return s.id===a.id&&s.color?.id===a.color?.id}w.isEqual=n;function t(s,a){return{id:s.id,color:a?R(a):void 0}}w.asThemeIcon=t,w.asClassNameArray=D.CSSIcon.asClassNameArray,w.asClassName=D.CSSIcon.asClassName,w.asCSSSelector=D.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function E(w){switch(w){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case b.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const m=this.themingParticipants.indexOf(p);this.themingParticipants.splice(m,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const y=new v;A.Registry.add(e.Extensions.ThemingContribution,y);function d(w){return y.onColorThemeChange(w)}e.registerThemingParticipant=d;class S extends k.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(m=>this.onThemeChange(m)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,m){let u=this.theme.getColor(p);return u&&m&&(u=m(u,this.theme)),u?u.toString():null}}e.Themable=S}),define(ne[227],re([0,1,51,7,157,106]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(v,y){const d=[{name:null,description:(0,k.localize)(0,null)}];return d.push(...v.map(S=>({name:S.profileName,description:b(S)}))),y&&d.push(...y.map(S=>({name:S.title,description:C(S)}))),{values:d.map(S=>S.name),markdownDescriptions:d.map(S=>S.description)}}e.createProfileSchemaEnums=A;function b(v){let y=`$(${L.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:D.Codicon.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?y+=`
- args: "${v.args}"`:y+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(y+=`
- overrideName: ${v.overrideName}`),v.color&&(y+=`
- color: ${v.color}`),v.env&&(y+=`
- env: ${JSON.stringify(v.env)}`),y}function C(v){return`$(${L.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:D.Codicon.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function R(v,y){if(!v&&!y)return!0;if(typeof v=="string"&&typeof y=="string")return v===y;if(Array.isArray(v)&&Array.isArray(y)){if(v.length!==y.length)return!1;for(let d=0;d<v.length;d++)if(v[d]!==y[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=R;function I(v,y){if(!v&&!y)return!0;if(!v||!y)return!1;if(L.ThemeIcon.isThemeIcon(v)&&L.ThemeIcon.isThemeIcon(y))return v.id===y.id&&v.color===y.color;if(typeof v=="object"&&v&&"light"in v&&"dark"in v&&typeof y=="object"&&y&&"light"in y&&"dark"in y){const d=v,S=y;if((i.URI.isUri(d.light)||E(d.light))&&(i.URI.isUri(d.dark)||E(d.dark))&&(i.URI.isUri(S.light)||E(S.light))&&(i.URI.isUri(S.dark)||E(S.dark)))return d.light.path===S.light.path&&d.dark.path===S.dark.path}if(i.URI.isUri(v)&&i.URI.isUri(y)||E(v)||E(y)){const d=v,S=y;return d.path===S.path&&d.scheme===S.scheme}return!1}e.terminalIconsEqual=I;function E(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.isUriComponents=E}),define(ne[228],re([0,1,51,156,43,40,227]),function(X,e,D,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(D.Codicon.getAll(),g=>g.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),g=>`$(${g.id})`)};const b={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),...e.terminalIconSchema},color:{description:(0,i.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},C={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...b}},R={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...b}},I=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),v=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),w={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},R],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},R],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},R],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:v},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...b}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...b}},{type:"null"},C]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...b}},{type:"null"},C]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...b}},{type:"null"},C]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function p(){L.Registry.as(k.Extensions.Configuration).registerConfiguration(w),u()}e.registerTerminalPlatformConfiguration=p;let m;function u(g,h){const r=L.Registry.as(k.Extensions.Configuration);let n;g&&(n=(0,A.createProfileSchemaEnums)(g?.profiles,h));const t=m;m={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:g?.os===3?n?.values:void 0,markdownEnumDescriptions:g?.os===3?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:g?.os===2?n?.values:void 0,markdownEnumDescriptions:g?.os===2?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:g?.os===1?n?.values:void 0,markdownEnumDescriptions:g?.os===1?n?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[m],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=u}),define(ne[229],re([0,1,48,51,12,4,27,82,225,106]),function(X,e,D,i,k,L,A,b,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,E=!0;function v(n,t,s,a,c=process.env,o,l,f,P){return o=o||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},L.isWindows?y(s,o,c,l,a.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:a.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:a.getValue("terminal.integrated.defaultProfile.windows"),P,f):g(o,l,s,n&&typeof n=="object"?{...n}:a.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:a.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),P,f,c)}e.detectAvailableProfiles=v;async function y(n,t,s,a,c,o,l,f,P){const U=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${U?"Sysnative":"System32"}`;let F=!1;(0,C.getWindowsBuildNumber)()>=16299&&(F=!0),await w(f);const T=new Map;n&&(T.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),T.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),T.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),T.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),T.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0})),h(o,T);const N=await d(T.entries(),l,t,s,a,P);if(n||!n&&c)try{const z=await m(`${_}\\${F?"wsl":"bash"}.exe`,l);for(const V of z)(!o||!(V.profileName in o))&&N.push(V)}catch{E&&(a?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return N}async function d(n,t,s,a=process.env,c,o){const l=[];for(const[f,P]of n){if(P===null)continue;let U,_,F;if("source"in P){const z=I?.get(P.source);if(!z)continue;U=z.paths,_=P.args||z.args,P.icon?F=S(P.icon):z.icon&&(F=z.icon)}else U=Array.isArray(P.path)?P.path:[P.path],_=L.isWindows||Array.isArray(P.args)?P.args:void 0,F=S(P.icon);const T=await o?.(U)||U.slice(),N=await r(f,t,T,s,a,_,P.env,P.overrideName,P.isAutoDetected,c);N?(N.isAutoDetected=P.isAutoDetected,N.icon=F,N.color=P.color,l.push(N)):c?.debug("Terminal profile not validated",f,U)}return c?.debug("Validated terminal profiles",l),l}function S(n){return typeof n=="string"?{id:n}:n}async function w(n){I&&!n||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:n||await p(),icon:R.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function p(){const n=[];for await(const t of(0,b.enumeratePowerShellInstallations)())n.push(t.exePath);return n}async function m(n,t){const s=[],a=await new Promise((l,f)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(P,U)=>{if(P)return f("Problem occurred when getting wsl distros");l(U)})});if(!a)return[];const c=new RegExp(/[\r?\n]/),o=a.split(c).filter(l=>l.trim().length>0&&l!=="");for(const l of o){if(l===""||l.startsWith("docker-desktop"))continue;const f=`${l} (WSL)`,P={profileName:f,path:n,args:["-d",`${l}`],isDefault:f===t,icon:u(l),isAutoDetected:!1};s.push(P)}return s}function u(n){return n.includes("Ubuntu")?R.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):n.includes("Debian")?R.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):R.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function g(n,t,s,a,c,o,l,f){const P=new Map;if(s){const U=(await n.readFile("/etc/shells")).toString(),_=o||U.split(`
`).filter(T=>T.trim().indexOf("#")!==0&&T.trim().length>0),F=new Map;for(const T of _){let N=(0,k.basename)(T),z=F.get(N)||0;z++,z>1&&(N=`${N} (${z})`),F.set(N,z),P.set(N,{path:T,isAutoDetected:!0})}}return h(a,P),await d(P.entries(),c,n,f,t,l)}function h(n,t){if(!!n)for(const[s,a]of Object.entries(n))a===null||!("path"in a)&&!("source"in a)?t.delete(s):(a.icon=a.icon||t.get(s)?.icon,t.set(s,a))}async function r(n,t,s,a,c,o,l,f,P,U){if(s.length===0)return Promise.resolve(void 0);const _=s.shift();if(_==="")return r(n,t,s,a,c,o,l,f,P);const F={profileName:n,path:_,args:o,env:l,overrideName:f,isAutoDetected:P,isDefault:n===t};if((0,k.basename)(_)===_){const N=c.PATH?c.PATH.split(k.delimiter):void 0,z=await(0,C.findExecutable)(_,void 0,N,void 0,a.existsFile);return z?(F.path=z,F.isFromPath=!0,F):r(n,t,s,a,c,o)}return await a.existsFile((0,k.normalize)(_))?F:r(n,t,s,a,c,o,l,f,P)}}),define(ne[230],re([0,1,3,2,20,4,39,64,19,15,87,215,8,95,223,105,228,229]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let u=0,g=class extends i.Disposable{constructor(r,n,t,s){super();this._reconnectConstants=r,this._configurationService=n,this._environmentService=t,this._logService=s,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,w.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,i.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(r){return this._logService.error("ptyHost was unable to resolve shell environment",r),{}}}_startPtyHost(){const r={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:u,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?r.debugBrk=n.port:!n.break&&n.port&&(r.debug=n.port));const t=new b.Client(k.FileAccess.asFileUri("bootstrap-fork",X).fsPath,r);this._onPtyHostStart.fire(),A.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(o=>{this._onPtyHostExit.fire(o.code),this._isDisposed||(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const a=t.getChannel(S.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(a,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(a,this._logService.getLevel())}));const c=A.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(c.onProcessData(o=>this._onProcessData.fire(o))),this._register(c.onProcessReady(o=>this._onProcessReady.fire(o))),this._register(c.onProcessExit(o=>this._onProcessExit.fire(o))),this._register(c.onDidChangeProperty(o=>this._onDidChangeProperty.fire(o))),this._register(c.onProcessReplay(o=>this._onProcessReplay.fire(o))),this._register(c.onProcessOrphanQuestion(o=>this._onProcessOrphanQuestion.fire(o))),this._register(c.onDidRequestDetach(o=>this._onDidRequestDetach.fire(o))),[t,c]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(r,n,t,s,a,c,o,l,f,P,U){const _=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),F=await this._proxy.createProcess(r,n,t,s,a,c,o,l,f,P,U);return clearTimeout(_),u=Math.max(u,F),F}updateTitle(r,n,t){return this._proxy.updateTitle(r,n,t)}updateIcon(r,n,t){return this._proxy.updateIcon(r,n,t)}attachToProcess(r){return this._proxy.attachToProcess(r)}detachFromProcess(r){return this._proxy.detachFromProcess(r)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(r){return this._proxy.start(r)}shutdown(r,n){return this._proxy.shutdown(r,n)}input(r,n){return this._proxy.input(r,n)}processBinary(r,n){return this._proxy.processBinary(r,n)}resize(r,n,t){return this._proxy.resize(r,n,t)}acknowledgeDataEvent(r,n){return this._proxy.acknowledgeDataEvent(r,n)}setUnicodeVersion(r,n){return this._proxy.setUnicodeVersion(r,n)}getInitialCwd(r){return this._proxy.getInitialCwd(r)}getCwd(r){return this._proxy.getCwd(r)}getLatency(r){return this._proxy.getLatency(r)}orphanQuestionReply(r){return this._proxy.orphanQuestionReply(r)}installAutoReply(r,n){return this._proxy.installAutoReply(r,n)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(r){return this._proxy.uninstallAutoReply(r)}getDefaultSystemShell(r){return this._proxy.getDefaultSystemShell(r)}async getProfiles(r,n,t,s=!1){const a=await this._shellEnv;return(0,p.detectAvailableProfiles)(n,t,s,this._configurationService,a,void 0,this._logService,this._resolveVariables.bind(this,r))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(r){return this._proxy.getWslPath(r)}getRevivedPtyNewId(r){return this._proxy.getRevivedPtyNewId(r)}setTerminalLayoutInfo(r){return this._proxy.setTerminalLayoutInfo(r)}async getTerminalLayoutInfo(r){return await this._proxy.getTerminalLayoutInfo(r)}async requestDetachInstance(r,n){return this._proxy.requestDetachInstance(r,n)}async acceptDetachInstanceReply(r,n){return this._proxy.acceptDetachInstanceReply(r,n)}async serializeTerminalState(r){return this._proxy.serializeTerminalState(r)}async reviveTerminalProcesses(r,n){return this._proxy.reviveTerminalProcesses(r,n)}async refreshProperty(r,n){return this._proxy.refreshProperty(r,n)}async updateProperty(r,n,t){return this._proxy.updateProperty(r,n,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(r,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:r,originalText:n})}async acceptPtyHostResolvedVariables(r,n){this._resolveVariablesRequestStore.acceptReply(r,n)}};g=ge([K(1,C.IConfigurationService),K(2,R.IEnvironmentService),K(3,v.ILogService)],g),e.PtyHostService=g}),define(ne[69],re([0,1,3,4,5,8]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var A;(function(S){S.Http="http",S.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var b;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(b=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function R(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=E;function v(S,w){return w?w!==1&&S<1024:!i.isWindows&&S<1024}e.isPortPrivileged=v;class y{constructor(w,p,m){this.remoteAddress=w,this.localAddress=p,this._dispose=m,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=y;let d=class{constructor(w){this.logService=w,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w){return this._tunnelProvider=w,w?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],p=Array.from(this._tunnels.values());for(const m of p){const u=Array.from(m.values());for(const g of u){const h=await g.value;h&&w.push(h)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:p}of w.values())await p.then(m=>m?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,p,m,u,g=!1,h,r){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${m} on local port ${u}.`),!w)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(m)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.retainOrCreateTunnel(w,p,m,u,g,h,r);return n?n.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(t);return(t.tunnelRemoteHost!==p||t.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const p=this._tunnels.get(w.tunnelRemoteHost);if(p){const m=p.get(w.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,m))}}}}async tryDisposeTunnel(w,p,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${p}.`);const u=m.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(p),u}}async closeTunnel(w,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${p} `);const m=this._tunnels.get(w);if(m&&m.has(p)){const u=m.get(p);u.refcount=0,await this.tryDisposeTunnel(w,p,u)}}addTunnelToMap(w,p,m){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(p,{refcount:1,value:m})}async removeEmptyTunnelFromMap(w,p){const m=this._tunnels.get(w);m&&(await m.get(p)||m.delete(p),m.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,p){const m=[w];I(w)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):E(w)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const u=m.map(g=>this._tunnels.get(g));for(const g of u){const h=g?.get(p);if(h)return h}}canTunnel(w){return!!R(w)}createWithProvider(w,p,m,u,g,h,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${m} on local port ${u}.`);const n=m;this._factoryInProgress.add(n);const s={elevationRequired:g?v(u===void 0?m:u):!1},a={remoteAddress:{host:p,port:m},localAddressPort:u,privacy:h,public:h?h!==b.Private:void 0,protocol:r},c=w.forwardPort(a,s);return c?(this.addTunnelToMap(p,m,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(n)})):this._factoryInProgress.delete(n),c}};d=ge([K(0,L.ILogService)],d),e.AbstractTunnelService=d}),define(ne[231],re([0,1,8,69,2,9,6]),function(X,e,D,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class b extends k.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let C=class Pt extends k.Disposable{constructor(I,E){super();this._tunnelService=I,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Pt._lastId)}}async startTunnel(I,E,v,y,d,S){const w=new b,p=await Promise.resolve(this._tunnelService.openTunnel(I,w,v,y,d,S));if(!p)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${v}:${y} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),w.dispose(),await p.dispose(),(0,L.canceled)();return w.setTunnel(p),this._tunnels.set(E,w),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${p.localAddress} (local) to ${v}:${y} (remote).`),{tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress}}async setAddress(I,E){const v=this._tunnels.get(I);!v||v.setAddress(E)}async destroyTunnel(I){const E=this._tunnels.get(I);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await E.dispose();return}this._disposedTunnels.add(I)}};C._lastId=0,C=ge([K(0,i.ISharedTunnelsService),K(1,D.ILogService)],C),e.SharedProcessTunnelService=C}),define(ne[232],re([0,1,76,116,206,6,2,19,8,24,204,69,100]),function(X,e,D,i,k,L,A,b,C,R,I,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(m,u,g,h,r){let n;for(let t=3;t&&(n&&n.dispose(),n=await new d(m,u,g,h,r).waitForReady(),!(r&&i.BROWSER_RESTRICTED_PORTS[r]||!i.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));t--);return n}class d extends A.Disposable{constructor(u,g,h,r,n){super();this.defaultTunnelHost=g,this.suggestedLocalPort=n,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=u,this._server=D.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=t=>this._onConnection(t),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=h}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(g=>{g()})}async waitForReady(){let u=await(0,i.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),g=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address(),g||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address()),this.tunnelLocalPort=g.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${g.port}`,this}async _onConnection(u){u.pause();const g=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,h=await(0,I.connectRemoteAgentTunnel)(this._options,g,this.tunnelRemotePort),r=h.getSocket().socket,n=h.readEntireBuffer();h.dispose(),n.byteLength>0&&u.write(n.buffer),u.on("end",()=>{u.localAddress&&this._socketsDispose.delete(u.localAddress),r.end()}),u.on("close",()=>r.end()),u.on("error",()=>{u.localAddress&&this._socketsDispose.delete(u.localAddress),r.destroy()}),r.on("end",()=>u.end()),r.on("close",()=>u.end()),r.on("error",()=>{u.destroy()}),u.pipe(r),r.pipe(u),u.localAddress&&this._socketsDispose.set(u.localAddress,()=>{u.end(),r.end()})}}let S=class extends E.AbstractTunnelService{constructor(u,g,h,r,n){super(g);this.socketFactory=u,this.signService=h,this.productService=r,this.configurationService=n}get defaultTunnelHost(){const u=this.configurationService.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(u,g,h,r,n,t,s){const a=this.getTunnelFromMap(g,h);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,g,h,r,n,t,s);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${g}:${h} on local port ${r}.`);const c={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},o=y(c,this.defaultTunnelHost,g,h,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(g,h,o),o}}};S=ge([K(1,C.ILogService),K(2,v.ISignService),K(3,R.IProductService),K(4,b.IConfigurationService)],S),e.BaseTunnelService=S;let w=class extends S{constructor(u,g,h,r){super(k.nodeSocketFactory,u,g,h,r)}};w=ge([K(0,C.ILogService),K(1,v.ISignService),K(2,R.IProductService),K(3,b.IConfigurationService)],w),e.TunnelService=w;let p=class extends A.Disposable{constructor(u,g,h,r){super();this.logService=u,this.productService=g,this.signService=h,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(u,g,h,r,n,t,s,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${h}:${r} on local port ${n}.`),!this._tunnelServices.has(u)){const c=new w(this.logService,this.signService,this.productService,this.configurationService);this._register(c),this._tunnelServices.set(u,c),c.onTunnelClosed(async()=>{(await c.tunnels).length===0&&(c.dispose(),this._tunnelServices.delete(u))})}return this._tunnelServices.get(u).openTunnel(g,h,r,n,t,s,a)}};p=ge([K(0,C.ILogService),K(1,R.IProductService),K(2,v.ISignService),K(3,b.IConfigurationService)],p),e.SharedTunnelsService=p}),define(ne[33],re([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ne[233],re([0,1,3,2,7,15,32,13,8,33]),function(X,e,D,i,k,L,A,b,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends i.Disposable{constructor(v,y,d,S,w){super();this.extensionsManagementService=v,this.logService=S,this.uriIdentityService=w,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(m=>{this.installedExtensions=m.map(u=>u.identifier),this.startTimestamp=Date.now()}),this._register(v.onInstallExtension(m=>this.onInstallExtension(m))),this._register(v.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(v.onDidUninstallExtension(m=>this.onDidUninstallExtension(m)));const p=k.URI.file(d.extensionsPath);this._register(y.watch(p)),this._register(D.Event.filter(y.onDidFilesChange,m=>m.rawChanges.some(u=>this.doesChangeAffects(u,p)))(()=>this.onDidChange()))}doesChangeAffects(v,y){return v.type!==1&&v.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(v.resource),y)?!1:this.uriIdentityService.extUri.isEqual(v.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(v.resource).startsWith(".")}onInstallExtension(v){this.addInstallingExtension(v.identifier)}onDidInstallExtensions(v){for(const y of v)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(v){v.error||this.removeInstalledExtension(v.identifier)}addInstallingExtension(v){this.removeInstallingExtension(v),this.installingExtensions.push(v)}removeInstallingExtension(v){this.installingExtensions=this.installingExtensions.filter(y=>!(0,A.areSameExtensions)(y,v))}addInstalledExtension(v){this.installedExtensions&&(this.removeInstalledExtension(v),this.installedExtensions.push(v))}removeInstalledExtension(v){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,A.areSameExtensions)(y,v)))}async onDidChange(){if(this.installedExtensions){const v=await this.extensionsManagementService.getInstalled(),y=v.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(w=>(0,A.areSameExtensions)(w,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),d=this.installedExtensions.filter(S=>this.installingExtensions.some(w=>(0,A.areSameExtensions)(w,S))?!1:v.every(w=>!(0,A.areSameExtensions)(w.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=v.map(S=>S.identifier),(y.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:d})}}};I=ge([K(1,b.IFileService),K(2,L.INativeEnvironmentService),K(3,C.ILogService),K(4,R.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(ne[234],re([0,1,33,88,13,17,113,3,2]),function(X,e,D,i,k,L,A,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class R{constructor(v){this.uri=v,this.time=R._clock++}touch(){return this.time=R._clock++,this}}R._clock=0;let I=class{constructor(v){this._fileService=v,this._dispooables=new C.DisposableStore,this._limit=2**16;const y=new Map,d=S=>{let w=y.get(S.scheme);return w===void 0&&(w=v.hasProvider(S)&&!this._fileService.hasCapability(S,1024),y.set(S.scheme,w)),w};this._dispooables.add(b.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(S=>{y.delete(S.scheme)})),this.extUri=new L.ExtUri(d),this._canonicalUris=new A.SkipList((S,w)=>this.extUri.compare(S,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(v){this._fileService.hasProvider(v)&&(v=(0,L.normalizePath)(v));const y=this._canonicalUris.get(v);return y?y.touch().uri.with({fragment:v.fragment}):(this._canonicalUris.set(v,new R(v)),this._checkTrim(),v)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const v=[...this._canonicalUris.entries()].sort((d,S)=>d[1].touch<S[1].touch?1:d[1].touch>S[1].touch?-1:0);R._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let d=0;d<y;d++)this._canonicalUris.set(v[d][0],v[d][1].touch())}};I=ge([K(0,k.IFileService)],I),e.UriIdentityService=I,(0,i.registerSingleton)(D.IUriIdentityService,I,!0)}),define(ne[235],re([0,1,3,2,13,41,34,16]),function(X,e,D,i,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class C extends i.Disposable{constructor(I,E,v,y){super();this.fileSystemScheme=I,this.fileSystemProvider=E,this.userDataScheme=v,this.logService=y,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(d=>this.handleFileChanges(d)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(I,E){this.watchResources.set(I,I);const v=this.fileSystemProvider.watch(this.toFileSystemResource(I),E);return(0,i.toDisposable)(()=>{this.watchResources.delete(I),v.dispose()})}stat(I){return this.fileSystemProvider.stat(this.toFileSystemResource(I))}mkdir(I){return this.fileSystemProvider.mkdir(this.toFileSystemResource(I))}rename(I,E,v){return this.fileSystemProvider.rename(this.toFileSystemResource(I),this.toFileSystemResource(E),v)}readFile(I){return this.fileSystemProvider.readFile(this.toFileSystemResource(I),{atomic:!0})}readFileStream(I,E,v){const y=(0,L.newWriteableStream)(d=>b.VSBuffer.concat(d.map(S=>b.VSBuffer.wrap(S))).buffer);return(async()=>{try{const d=await this.readFile(I);y.end(d)}catch(d){y.error(d),y.end()}})(),y}readdir(I){return this.fileSystemProvider.readdir(this.toFileSystemResource(I))}writeFile(I,E,v){return this.fileSystemProvider.writeFile(this.toFileSystemResource(I),E,v)}delete(I,E){return this.fileSystemProvider.delete(this.toFileSystemResource(I),E)}copy(I,E,v){if((0,k.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(I),this.toFileSystemResource(E),v);throw new Error("copy not supported")}handleFileChanges(I){const E=[];for(const v of I){if(v.resource.scheme!==this.fileSystemScheme)continue;const y=this.toUserDataResource(v.resource);this.watchResources.findSubstr(y)&&E.push({resource:y,type:v.type})}E.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(E))}toFileSystemResource(I){return I.with({scheme:this.fileSystemScheme})}toUserDataResource(I){return I.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=C}),define(ne[59],re([0,1,75]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(A,b,C,R){const I=(0,D.setProperty)(A,b,C,R)[0];return I&&(A=A.substring(0,I.offset)+I.content+A.substring(I.offset+I.length)),A}e.edit=i;function k(A,b,C){let R=C;for(;R>=0;){if(A.charAt(R)===b.charAt(b.length-1)&&b.length===1)return R+1;if(R--,b.length===2&&R>=0&&A.charAt(R)===b.charAt(0))return R+2}return 0}e.getLineStartOffset=k;function L(A,b,C){let R=C;for(;R>=0;)if(A.charAt(R)===b.charAt(b.length-1)&&b.length===1||(R++,b.length===2&&R>=0&&A.charAt(R)===b.charAt(1)))return R;return A.length-1}e.getLineEndOffset=L}),define(ne[236],re([0,1,30,55,14]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(v,y,d,S,w){const p=[],m=[],u=[];if(!y){const _=v.filter(({identifier:F})=>w.every(T=>T.toLowerCase()!==F.id.toLowerCase()));return{local:{added:p,removed:m,updated:u},remote:_.length>0?{added:_,updated:[],removed:[],all:_}:null}}v=v.map(I),y=y.map(I),d=d?d.map(I):null;const g=new Map,h=_=>{_.uuid&&g.set(_.id.toLowerCase(),_.uuid)};v.forEach(({identifier:_})=>h(_)),y.forEach(({identifier:_})=>h(_)),d?.forEach(({identifier:_})=>h(_));const r=_=>{const F=_.identifier.uuid||g.get(_.identifier.id.toLowerCase());return F?`uuid:${F}`:`id:${_.identifier.id.toLowerCase()}`},n=(_,F)=>(_.set(r(F),F),_),t=v.reduce(n,new Map),s=y.reduce(n,new Map),a=y.reduce((_,F)=>{const T=r(F);F=(0,D.deepClone)(F);const N=t.get(T);return N&&(N.installed&&(F.installed=!0),F.version||(F.version=N.version)),n(_,F)},new Map),c=d?d.reduce(n,new Map):null,o=S.reduce(n,new Map),l=w.reduce((_,F)=>{const T=g.get(F.toLowerCase());return _.add(T?`uuid:${T}`:`id:${F.toLowerCase()}`)},new Set),f=A(t,s,l);if(f.added.size>0||f.removed.size>0||f.updated.size>0){const _=A(c,t,l),F=A(c,s,l),T=(N,z)=>{const V=t.get(N);if(V){const J=s.get(N),$=z?J:V;return{...$,version:J.version&&(!V.installed||i.gt(J.version,V.version))?J.version:V.version,state:b(V,J,c?.get(N)),preRelease:(0,k.isUndefined)($.preRelease)?V.preRelease:V.installed?$.preRelease:J.preRelease}}};for(const N of F.removed.values()){const z=t.get(N);z&&m.push(z.identifier)}for(const N of F.added.values())if(_.added.has(N)){if(f.updated.has(N)){const z=T(N,!0);z&&(u.push(E(z,N)),a.set(N,z))}}else{const z=s.get(N);z.installed&&p.push(E(z,N))}for(const N of F.updated.values()){const z=T(N,!0);z&&(u.push(E(z,N)),a.set(N,z))}for(const N of _.added.values())F.added.has(N)||a.set(N,t.get(N));for(const N of _.updated.values())if(!F.removed.has(N)&&!F.updated.has(N)){const z=T(N,!1);z&&(a.get(N)?.installed&&(z.installed=!0),a.set(N,z))}for(const N of _.removed.values())!o.has(N)&&!F.updated.has(N)&&c?.get(N)?.installed&&a.delete(N)}const P=[],U=A(s,a,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(U.added.size>0||U.updated.size>0||U.removed.size>0)&&a.forEach((_,F)=>P.push(E(_,F))),{local:{added:p,removed:m,updated:u},remote:P.length?{added:[...U.added].map(_=>a.get(_)),updated:[...U.updated].map(_=>a.get(_)),removed:[...U.removed].map(_=>s.get(_)),all:P}:null}}e.merge=L;function A(v,y,d,{checkInstalledProperty:S,checkVersionProperty:w}={checkInstalledProperty:!1,checkVersionProperty:!1}){const p=v?[...v.keys()].filter(r=>!d.has(r)):[],m=[...y.keys()].filter(r=>!d.has(r)),u=m.filter(r=>p.indexOf(r)===-1).reduce((r,n)=>(r.add(n),r),new Set),g=p.filter(r=>m.indexOf(r)===-1).reduce((r,n)=>(r.add(n),r),new Set),h=new Set;for(const r of p){if(g.has(r))continue;const n=v.get(r),t=y.get(r);(!t||n.disabled!==t.disabled||n.installed&&t.installed&&n.preRelease!==t.preRelease||!R(n.state,t.state)||w&&n.version!==t.version||S&&n.installed!==t.installed)&&h.add(r)}return{added:u,removed:g,updated:h}}function b(v,y,d){const S=v.state,w=y.state,p=d?.state;if(!y.version||S&&i.gt(v.version,y.version))return S;if(w&&i.gt(y.version,v.version)||!S)return w;if(!w)return S;const m=(0,D.deepClone)(S),u=p?C(p,w):{added:Object.keys(w).reduce((h,r)=>(h.add(r),h),new Set),removed:new Set,updated:new Set},g=p?C(p,S):{added:Object.keys(S).reduce((h,r)=>(h.add(r),h),new Set),removed:new Set,updated:new Set};for(const h of[...u.added.values(),...u.updated.values()])m[h]=w[h];for(const h of u.removed.values())g.updated.has(h)||delete m[h];return m}function C(v,y){const d=Object.keys(v),S=Object.keys(y),w=S.filter(u=>d.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),p=d.filter(u=>S.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),m=new Set;for(const u of d){if(p.has(u))continue;const g=v[u],h=y[u];(0,D.equals)(g,h)||m.add(u)}return{added:w,removed:p,updated:m}}function R(v={},y={}){const{added:d,removed:S,updated:w}=C(v,y);return d.size===0&&S.size===0&&w.size===0}function I(v){return{...v,disabled:!!v.disabled,installed:!!v.installed}}function E(v,y){const d={identifier:{id:v.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0},preRelease:!!v.preRelease};return v.version&&(d.version=v.version),v.disabled&&(d.disabled=!0),v.installed&&(d.installed=!0),v.state&&(d.state=v.state),d}}),define(ne[107],re([0,1,18,19,5]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(b){this.configurationService=b}hasToNeverSyncExtension(b){return this.getConfiguredIgnoredExtensions().includes(b.toLowerCase())}hasToAlwaysSyncExtension(b){return this.getConfiguredIgnoredExtensions().includes(`-${b.toLowerCase()}`)}updateIgnoredExtensions(b,C){let R=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return R=R.filter(I=>I!==b&&I!==`-${b}`),C&&R.push(b.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",R.length?R:void 0,2)}updateSynchronizedExtensions(b,C){let R=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return R=R.filter(I=>I!==b&&I!==`-${b}`),C&&R.push(`-${b.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",R.length?R:void 0,2)}getIgnoredExtensions(b){const C=b.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),R=this.getConfiguredIgnoredExtensions().map(v=>v.toLowerCase()),I=[],E=[];if(Array.isArray(R))for(const v of R)v.startsWith("-")?E.push(v.substring(1)):I.push(v);return(0,D.distinct)([...C,...I].filter(v=>E.indexOf(v)===-1))}getConfiguredIgnoredExtensions(){let b=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return b!==void 0||(b=this.configurationService.inspect("sync.ignoredExtensions").userValue,b!==void 0)?b:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};L=ge([K(0,i.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(ne[237],re([0,1,18,35,30,174,59]),function(X,e,D,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function b(g){return(0,i.parse)(g)||[]}e.parseKeybindings=b;async function C(g,h,r,n,t){const s=b(g),a=b(h),c=r?b(r):null,o=[...s,...a,...c||[]].map(J=>J.key),l=await t.resolveUserBindings(o),f=I(s,a,c,l);if(!f.hasLocalForwarded&&!f.hasRemoteForwarded)return{mergeContent:g,hasChanges:!1,hasConflicts:!1};if(!f.hasLocalForwarded&&f.hasRemoteForwarded)return{mergeContent:h,hasChanges:!0,hasConflicts:!1};if(f.hasLocalForwarded&&!f.hasRemoteForwarded)return{mergeContent:g,hasChanges:!0,hasConflicts:!1};const P=v(s),U=v(a),_=c?v(c):null,F=d(P,U,l),T=_?d(_,P,l):{added:[...P.keys()].reduce((J,$)=>(J.add($),J),new Set),removed:new Set,updated:new Set},N=_?d(_,U,l):{added:[...U.keys()].reduce((J,$)=>(J.add($),J),new Set),removed:new Set,updated:new Set},z=R(F,T,N);let V=g;for(const J of z.removed.values())z.conflicts.has(J)||(V=m(V,J,n));for(const J of z.added.values()){if(z.conflicts.has(J))continue;const $=U.get(J);if($.some(Q=>Q.command!==`-${J}`&&f.conflicts.has(l[Q.key]))){z.conflicts.add(J);continue}V=p(V,$,n)}for(const J of z.updated.values()){if(z.conflicts.has(J))continue;const $=U.get(J);if($.some(Q=>Q.command!==`-${J}`&&f.conflicts.has(l[Q.key]))){z.conflicts.add(J);continue}V=u(V,J,$,n)}return{mergeContent:V,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.merge=C;function R(g,h,r){const n=new Set,t=new Set,s=new Set,a=new Set;for(const c of h.removed.values())r.updated.has(c)&&a.add(c);for(const c of r.removed.values())a.has(c)||(h.updated.has(c)?a.add(c):t.add(c));for(const c of h.added.values())a.has(c)||r.added.has(c)&&g.updated.has(c)&&a.add(c);for(const c of r.added.values())a.has(c)||(h.added.has(c)?g.updated.has(c)&&a.add(c):n.add(c));for(const c of h.updated.values())a.has(c)||r.updated.has(c)&&g.updated.has(c)&&a.add(c);for(const c of r.updated.values())a.has(c)||(h.updated.has(c)?g.updated.has(c)&&a.add(c):s.add(c));return{added:n,removed:t,updated:s,conflicts:a}}function I(g,h,r,n){const t=new Set,s=E(g,n),a=E(h,n),c=r?E(r,n):null,o=y(s,a);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const l=c?y(c,s):{added:[...s.keys()].reduce((T,N)=>(T.add(N),T),new Set),removed:new Set,updated:new Set};if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const f=c?y(c,a):{added:[...a.keys()].reduce((T,N)=>(T.add(N),T),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:P,removed:U,updated:_,conflicts:F}=R(o,l,f);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:P,removed:U,updated:_,conflicts:F}}function E(g,h){const r=new Map;for(const n of g){const t=h[n.key];let s=r.get(t);s||(s=[],r.set(t,s)),s.push(n)}return r}function v(g){const h=new Map;for(const r of g){const n=r.command[0]==="-"?r.command.substring(1):r.command;let t=h.get(n);t||(t=[],h.set(n,t)),t.push(r)}return h}function y(g,h){const r=[...g.keys()],n=[...h.keys()],t=n.filter(c=>r.indexOf(c)===-1).reduce((c,o)=>(c.add(o),c),new Set),s=r.filter(c=>n.indexOf(c)===-1).reduce((c,o)=>(c.add(o),c),new Set),a=new Set;for(const c of r){if(s.has(c))continue;const o=g.get(c).map(f=>({...f,key:c})),l=h.get(c).map(f=>({...f,key:c}));(0,D.equals)(o,l,(f,P)=>w(f,P))||a.add(c)}return{added:t,removed:s,updated:a}}function d(g,h,r){const n=[...g.keys()],t=[...h.keys()],s=t.filter(o=>n.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),a=n.filter(o=>t.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),c=new Set;for(const o of n){if(a.has(o))continue;const l=g.get(o).map(P=>({...P,key:r[P.key]})),f=h.get(o).map(P=>({...P,key:r[P.key]}));S(l,f)||c.add(o)}return{added:s,removed:a,updated:c}}function S(g,h){return!(!(0,D.equals)(g.filter(({command:r})=>r[0]!=="-"),h.filter(({command:r})=>r[0]!=="-"),(r,n)=>w(r,n))||!(0,D.equals)(g.filter(({command:r})=>r[0]==="-"),h.filter(({command:r})=>r[0]==="-"),(r,n)=>w(r,n)))}function w(g,h){if(g.command!==h.command||g.key!==h.key)return!1;const r=L.ContextKeyExpr.deserialize(g.when),n=L.ContextKeyExpr.deserialize(h.when);return!(r&&!n||!r&&n||r&&n&&!r.equals(n)||!k.equals(g.args,h.args))}function p(g,h,r){for(const n of h)g=A.edit(g,[-1],n,r);return g}function m(g,h,r){const n=b(g);for(let t=n.length-1;t>=0;t--)(n[t].command===h||n[t].command===`-${h}`)&&(g=A.edit(g,[t],void 0,r));return g}function u(g,h,r,n){const t=b(g),s=t.findIndex(a=>a.command===h||a.command===`-${h}`);for(let a=t.length-1;a>=0;a--)(t[a].command===h||t[a].command===`-${h}`)&&(g=A.edit(g,[a],void 0,n));for(let a=r.length-1;a>=0;a--)g=A.edit(g,[s],r[a],n);return g}}),define(ne[238],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(L,A,b){const C={},R={},I=new Set;if(!A)return{local:{added:C,updated:R,removed:[...I.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const E=i(L,A);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:C,updated:R,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=i(b,L),y=i(b,A),d={},S={},w=new Set,p=new Set;for(const m of v.removed.values())y.updated.has(m)?C[m]=A[m]:w.add(m);for(const m of y.removed.values())p.has(m)||(v.updated.has(m)?p.add(m):I.add(m));for(const m of v.updated.values())p.has(m)||(y.updated.has(m)?E.updated.has(m)&&p.add(m):S[m]=L[m]);for(const m of y.updated.values())p.has(m)||(v.updated.has(m)?E.updated.has(m)&&p.add(m):L[m]!==void 0&&(R[m]=A[m]));for(const m of v.added.values())p.has(m)||(y.added.has(m)?E.updated.has(m)&&p.add(m):d[m]=L[m]);for(const m of y.added.values())p.has(m)||(v.added.has(m)?E.updated.has(m)&&p.add(m):C[m]=A[m]);return{local:{added:C,removed:[...I.values()],updated:R},remote:{added:d,removed:[...w.values()],updated:S},conflicts:[...p.values()]}}e.merge=D;function i(L,A){const b=L?Object.keys(L):[],C=A?Object.keys(A):[],R=C.filter(v=>b.indexOf(v)===-1).reduce((v,y)=>(v.add(y),v),new Set),I=b.filter(v=>C.indexOf(v)===-1).reduce((v,y)=>(v.add(y),v),new Set),E=new Set;for(const v of b){if(I.has(v))continue;const y=L[v],d=A[v];y!==d&&E.add(v)}return{added:R,removed:I,updated:E}}function k(L,A){const{added:b,removed:C,updated:R}=i(L,A);return b.size===0&&C.size===0&&R.size===0}e.areSame=k}),define(ne[25],re([0,1,18,17,14,163,43,28,5,97,40]),function(X,e,D,i,k,L,A,b,C,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const c=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(o=>!!c[o].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function v(){const c=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(c).filter(P=>!!c[P].ignoreSync),l=Object.keys(c).filter(P=>c[P].scope===2||c[P].scope===6),f=E();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...o,...l,...f])}e.getDefaultIgnoredSettings=v,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function y(){const c="vscode://schemas/ignoredSettings",o=I.Registry.as(A.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:b.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=I.Registry.as(R.Extensions.JSONContribution),f=()=>{const P=E(),U=v().filter(N=>N!==e.CONFIGURATION_SYNC_STORE_KEY),_=Object.keys(A.allSettings.properties).filter(N=>U.indexOf(N)===-1),F=U.filter(N=>P.indexOf(N)===-1),T={items:{type:"string",enum:[..._,...F.map(N=>`-${N}`)]}};l.registerSchema(c,T)};return o.onDidUpdateConfiguration(()=>f())}e.registerConfiguration=y;function d(c){return c&&(0,k.isObject)(c)&&(0,k.isString)(c.id)&&(0,k.isArray)(c.scopes)}e.isAuthenticationProvider=d;var S;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function w(c,o,l){return l.joinPath(o.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=w,e.IUserDataSyncStoreManagementService=(0,C.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,C.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,C.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function p(c){const o={};return o[e.HEADER_EXECUTION_ID]=c,o}e.createSyncHeaders=p;var m;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.RequestProtocolNotSupported="RequestProtocolNotSupported",c.RequestPathNotEscaped="RequestPathNotEscaped",c.RequestHeadersNotObject="RequestHeadersNotObject",c.NoRef="NoRef",c.EmptyResponse="EmptyResponse",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(m=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class u extends Error{constructor(o,l,f,P){super(o);this.code=l,this.resource=f,this.operationId=P,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=u;class g extends u{constructor(o,l,f,P,U){super(o,f,void 0,U);this.url=l,this.serverCode=P}}e.UserDataSyncStoreError=g;class h extends u{constructor(o,l){super(o,l)}}e.UserDataAutoSyncError=h,function(c){function o(l){if(l instanceof c)return l;const f=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(f&&f[1]){const P=f[2]==="unknown"?void 0:f[2],U=f[3]==="unknown"?void 0:f[3];return new c(l.message,f[1],P,U)}return new c(l.message,"Unknown")}c.toUserDataSyncError=o}(u=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var n;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(n=e.Change||(e.Change={}));var t;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(c){return`sync.enable.${c}`}e.getEnablementKey=s,e.IUserDataSyncEnablementService=(0,C.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,C.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,C.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,C.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,C.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function a(c,o){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:o.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(l=>(0,i.isEqualOrParent)(c,(0,i.joinPath)(o.userDataSyncHome,l,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=a}),define(ne[239],re([0,1,30,25]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(b,C,R,I,E){if(!C)return{remote:Object.keys(b).length>0?b:null,local:{added:{},removed:[],updated:{}}};const v=L(b,C);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const y=R?L(R,C):{added:Object.keys(C).reduce((m,u)=>(m.add(u),m),new Set),removed:new Set,updated:new Set},d=R?L(R,b):{added:Object.keys(b).reduce((m,u)=>(m.add(u),m),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},w=D.deepClone(C),p=!R;for(const m of d.added.values())m!==i.SYNC_SERVICE_URL_TYPE&&p&&y.added.has(m)||(w[m]=b[m]);for(const m of d.updated.values())w[m]=b[m];for(const m of d.removed.values())I.unregistered.includes(m)||delete w[m];for(const m of y.added.values()){const u=C[m];if(I.machine.includes(m)){E.info(`GlobalState: Skipped adding ${m} in local storage because it is declared as machine scoped.`);continue}if(R&&d.added.has(m))continue;const g=b[m];g&&g.value===u.value||m===i.SYNC_SERVICE_URL_TYPE&&p&&d.added.has(m)||(g?S.updated[m]=u:S.added[m]=u)}for(const m of y.updated.values()){const u=C[m];if(I.machine.includes(m)){E.info(`GlobalState: Skipped updating ${m} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(m)||d.removed.has(m))continue;const g=b[m];g&&g.value===u.value||(S.updated[m]=u)}for(const m of y.removed.values()){if(I.machine.includes(m)){E.trace(`GlobalState: Skipped removing ${m} in local storage because it is declared as machine scoped.`);continue}d.updated.has(m)||d.removed.has(m)||S.removed.push(m)}return{local:S,remote:A(w,C)?null:w}}e.merge=k;function L(b,C){const R=Object.keys(b),I=Object.keys(C),E=I.filter(d=>R.indexOf(d)===-1).reduce((d,S)=>(d.add(S),d),new Set),v=R.filter(d=>I.indexOf(d)===-1).reduce((d,S)=>(d.add(S),d),new Set),y=new Set;for(const d of R){if(v.has(d))continue;const S=b[d],w=C[d];D.equals(S,w)||y.add(d)}return{added:E,removed:v,updated:y}}function A(b,C){const{added:R,removed:I,updated:E}=L(b,C);return R.size===0&&I.size===0&&E.size===0}}),define(ne[240],re([0,1,18,35,75,53,30,59,25]),function(X,e,D,i,k,L,A,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function R(o,l,f){let P=[];f?P=E(f):P=I(l);const U=[],_=[...(0,C.getDisallowedIgnoredSettings)()];if(Array.isArray(P))for(const F of P)F.startsWith("-")?_.push(F.substring(1)):U.push(F);return(0,D.distinct)([...o,...U].filter(F=>_.indexOf(F)===-1))}e.getIgnoredSettings=R;function I(o){let l=o.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=o.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const l=(0,i.parse)(o);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function v(o,l){const f=(0,i.parse)(o)||{};let P="{}";for(const U of Object.keys(f)){const _=(0,k.setProperty)(P,[U],f[U],l);P=(0,k.applyEdits)(P,_)}return P}e.removeComments=v;function y(o,l,f,P){if(f.length){const U=c(l),_=(0,i.parse)(l)||{},F=(0,i.parse)(o);if(!F)return o;const T=[];for(const N of f){const z=_[N],V=F[N];z===void 0?o=b.edit(o,[N],void 0,P):V!==void 0?o=b.edit(o,[N],z,P):T.push(r(N,U))}T.sort((N,z)=>N.startOffset-z.startOffset),T.forEach(N=>o=m(N.setting.key,l,o,P))}return o}e.updateIgnoredSettings=y;function d(o,l,f,P,U,_){const F=y(o,l,P,_),T=f!==F,N=f!==l;if(!T&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(T&&!N)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(N&&!T)return{conflictsSettings:[],localContent:y(l,o,P,_),remoteContent:null,hasConflicts:!1};if(f===null&&w(o)){const j=S(o,l,P)?null:y(l,o,P,_);return{conflictsSettings:[],localContent:j,remoteContent:null,hasConflicts:!1}}let z=o,V=l;const J=(0,i.parse)(o),$=(0,i.parse)(l),Q=f?(0,i.parse)(f):null,H=P.reduce((j,Z)=>(j.add(Z),j),new Set),B=p(J,$,H),Y=p(Q,J,H),ie=p(Q,$,H),ae=new Map,W=new Set,x=j=>{W.add(j);const Z=U.filter(({key:G})=>G===j)[0];Z?(z=b.edit(z,[j],Z.value,_),V=b.edit(V,[j],Z.value,_)):ae.set(j,{key:j,localValue:J[j],remoteValue:$[j]})};for(const j of Y.removed.values())ie.updated.has(j)?x(j):V=b.edit(V,[j],void 0,_);for(const j of ie.removed.values())W.has(j)||(Y.updated.has(j)?x(j):z=b.edit(z,[j],void 0,_));for(const j of Y.updated.values())W.has(j)||(ie.updated.has(j)?B.updated.has(j)&&x(j):V=b.edit(V,[j],J[j],_));for(const j of ie.updated.values())W.has(j)||(Y.updated.has(j)?B.updated.has(j)&&x(j):z=b.edit(z,[j],$[j],_));for(const j of Y.added.values())W.has(j)||(ie.added.has(j)?B.updated.has(j)&&x(j):V=m(j,z,V,_));for(const j of ie.added.values())W.has(j)||(Y.added.has(j)?B.updated.has(j)&&x(j):z=m(j,V,z,_));const O=ae.size>0||!S(z,V,P),M=O||!S(z,o,[]),q=O||!S(V,l,[]);return{localContent:M?z:null,remoteContent:q?V:null,conflictsSettings:[...ae.values()],hasConflicts:O}}e.merge=d;function S(o,l,f){if(o===l)return!0;const P=(0,i.parse)(o),U=(0,i.parse)(l),_=f.reduce((N,z)=>(N.add(z),N),new Set),F=c(o).filter(N=>!(N.setting&&_.has(N.setting.key))),T=c(l).filter(N=>!(N.setting&&_.has(N.setting.key)));if(F.length!==T.length)return!1;for(let N=0;N<F.length;N++){const z=F[N],V=T[N];if(z.setting&&V.setting){if(z.setting.key!==V.setting.key||!A.equals(P[z.setting.key],U[z.setting.key]))return!1}else if(!z.setting&&!V.setting){if(z.value!==V.value)return!1}else return!1}return!0}e.areSame=S;function w(o){return o?c(o).length===0:!0}e.isEmpty=w;function p(o,l,f){const P=o?Object.keys(o).filter(N=>!f.has(N)):[],U=Object.keys(l).filter(N=>!f.has(N)),_=U.filter(N=>P.indexOf(N)===-1).reduce((N,z)=>(N.add(z),N),new Set),F=P.filter(N=>U.indexOf(N)===-1).reduce((N,z)=>(N.add(z),N),new Set),T=new Set;if(o)for(const N of P){if(F.has(N))continue;const z=o[N],V=l[N];A.equals(z,V)||T.add(N)}return{added:_,removed:F,updated:T}}function m(o,l,f,P){const U=(0,i.parse)(l),_=c(l),F=c(f),T=u(o,_,F);return g(f,o,U[o],T,F,P)}e.addSetting=m;function u(o,l,f){const P=l.findIndex(_=>_.setting?.key===o),U=l[P-1];if(U){if(U.setting){const F=r(U.setting.key,f);if(F)return{index:f.indexOf(F),insertAfter:!0}}else{const F=n(P,l);if(F){const T=r(F.setting.key,f);if(T){const N=t(f.indexOf(T),f),z=s(l,F,l[P]);if(N){const V=s(f,T,N),J=a(z,V);return J?{index:f.indexOf(J),insertAfter:!0}:{index:f.indexOf(N),insertAfter:!1}}else{const V=s(f,T,f[f.length-1]),J=a(z,V);return J?{index:f.indexOf(J),insertAfter:!0}:{index:f.length-1,insertAfter:!0}}}}}const _=l[P+1];if(_)if(_.setting){const F=r(_.setting.key,f);if(F)return{index:f.indexOf(F),insertAfter:!1}}else{const F=t(P,l);if(F){const T=r(F.setting.key,f);if(T){const N=n(f.indexOf(T),f),z=s(l,l[P],F);if(N){const V=s(f,N,T),J=a(z.reverse(),V.reverse());return J?{index:f.indexOf(J),insertAfter:!1}:{index:f.indexOf(N),insertAfter:!0}}else{const V=s(f,f[0],T),J=a(z.reverse(),V.reverse());return J?{index:f.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:f.length-1,insertAfter:!0}}function g(o,l,f,P,U,_){let F;return P.index===-1?F=(0,k.setProperty)(o,[l],f,_):F=h(o,l,f,P,U,_).map(T=>(0,k.withFormatting)(o,T,_)[0]),(0,k.applyEdits)(o,F)}function h(o,l,f,P,U,_){const F=`${JSON.stringify(l)}: ${JSON.stringify(f)}`,T=(0,L.getEOL)(_,o),N=U[P.index];if(P.insertAfter){const z=[];if(N.setting)z.push({offset:N.endOffset,length:0,content:","+F});else{const V=t(P.index,U),J=n(P.index,U),$=J?.setting?.commaOffset;J&&$===void 0&&z.push({offset:J.endOffset,length:0,content:","});const Q=$!==void 0&&$>N.endOffset;z.push({offset:Q?$+1:N.endOffset,length:0,content:V?T+F+",":T+F})}return z}else{if(N.setting)return[{offset:N.startOffset,length:0,content:F+","}];const z=(U[P.index-1]&&!U[P.index-1].setting?T:"")+F+(t(P.index,U)?",":"")+T;return[{offset:N.startOffset,length:0,content:z}]}}function r(o,l){return l.filter(f=>f.setting?.key===o)[0]}function n(o,l){for(let f=o-1;f>=0;f--)if(l[f].setting)return l[f]}function t(o,l){for(let f=o+1;f<l.length;f++)if(l[f].setting)return l[f]}function s(o,l,f){const P=o.indexOf(l),U=o.indexOf(f);return o.filter((_,F)=>P<F&&F<U)}function a(o,l){if(o.length&&l.length){let f=0;for(;f<l.length&&f<o.length;f++)if(o[f].value!==l[f].value)return l[f-1];return l[f-1]}}function c(o){const l=[];let f=-1,P,U;const _={onObjectBegin:F=>{f++},onObjectProperty:(F,T,N)=>{f===0&&(P=T,U=F)},onObjectEnd:(F,T)=>{f--,f===0&&l.push({startOffset:P,endOffset:F+T,value:o.substring(P,F+T),setting:{key:U,commaOffset:void 0}})},onArrayBegin:(F,T)=>{f++},onArrayEnd:(F,T)=>{f--,f===0&&l.push({startOffset:P,endOffset:F+T,value:o.substring(P,F+T),setting:{key:U,commaOffset:void 0}})},onLiteralValue:(F,T,N)=>{f===0&&l.push({startOffset:P,endOffset:T+N,value:o.substring(P,T+N),setting:{key:U,commaOffset:void 0}})},onSeparator:(F,T,N)=>{if(f===0&&F===","){let z=l.length-1;for(;z>=0&&!l[z].setting;z--);const V=l[z];V&&l.splice(z,1,{startOffset:V.startOffset,endOffset:V.endOffset,value:V.value,setting:{key:V.setting.key,commaOffset:T}})}},onComment:(F,T)=>{f===0&&l.push({startOffset:F,endOffset:F+T,value:o.substring(F,F+T)})}};return(0,i.visit)(o,_),l}}),define(ne[70],re([0,1,3,2,5,25]),function(X,e,D,i,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,k.createDecorator)("IUserDataSyncAccountService");let A=class extends i.Disposable{constructor(C,R){super();this.userDataSyncStoreService=C,this.logService=R,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(C.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(C.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(C){(C&&this._account?C.token!==this._account.token||C.authenticationProviderId!==this._account.authenticationProviderId:C!==this._account)&&(this._account=C,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(C))}};A=ge([K(0,L.IUserDataSyncStoreService),K(1,L.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(ne[241],re([0,1,6,16,61,2,17,19,15,13,25]),function(X,e,D,i,k,L,A,b,C,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends L.Disposable{constructor(y,d,S,w){super();this.environmentService=y,this.fileService=d,this.configurationService=S,this.logService=w,I.ALL_SYNC_RESOURCES.forEach(p=>this.cleanUpBackup(p))}async getAllRefs(y){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),S=await this.fileService.resolve(d);return S.children?S.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.getCreationTime(p)})):[]}async resolveContent(y,d){if(!d){const S=await this.getAllRefs(y);S.length&&(d=S[S.length-1].ref)}if(d){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,y,d);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(y,d){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),w=(0,A.joinPath)(S,`${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(w,i.VSBuffer.fromString(d))}catch(p){this.logService.error(p)}try{this.cleanUpBackup(y)}catch{}}async cleanUpBackup(y){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,y);try{try{if(!await this.fileService.exists(d))return}catch{return}const S=await this.fileService.resolve(d);if(S.children){const w=S.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort(),p=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let m=w.filter(g=>Date.now()-this.getCreationTime(g)>p);const u=w.length-m.length;u<10&&(m=m.slice(10-u)),await D.Promises.settled(m.map(async g=>{this.logService.info("Deleting from backup",g.resource.path),await this.fileService.del(g.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(y){return y.ctime||new Date(parseInt(y.name.substring(0,4)),parseInt(y.name.substring(4,6))-1,parseInt(y.name.substring(6,8)),parseInt(y.name.substring(9,11)),parseInt(y.name.substring(11,13)),parseInt(y.name.substring(13,15))).getTime()}};E=ge([K(0,C.IEnvironmentService),K(1,R.IFileService),K(2,b.IConfigurationService),K(3,I.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(ne[242],re([0,1,2,7]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(v){this.service=v}listen(v,y){switch(y){case"onError":return this.service.onError}throw new Error(`Event not found: ${y}`)}call(v,y,d){switch(y){case"triggerSync":return this.service.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class L{constructor(v){this.service=v}listen(v,y){throw new Error(`Event not found: ${y}`)}call(v,y,d){switch(y){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(i.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class A{constructor(v){this.channel=v}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(v){return this.channel.call("resolveUserKeybindings",[v])}async resolveFormattingOptions(v){return this.channel.call("resolveFormattingOptions",[v])}}e.UserDataSyncUtilServiceClient=A;class b{constructor(v){this.service=v}listen(v,y){switch(y){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${y}`)}async call(v,y,d){switch(y){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(d[0],d[1]);case"setEnablements":return this.service.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=b;class C{constructor(v){this.service=v}listen(v,y){switch(y){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(v,y,d){switch(y){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=C;class R{constructor(v){this.service=v}listen(v,y){switch(y){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(v,y,d){switch(y){case"switch":return this.service.switch(d[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=R;class I extends D.Disposable{constructor(v){super();this.channel=v,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(v){return this.channel.call("switch",[v])}async getPreviousUserDataSyncStore(){const v=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(v)}revive(v){return{url:i.URI.revive(v.url),type:v.type,defaultUrl:i.URI.revive(v.defaultUrl),insidersUrl:i.URI.revive(v.insidersUrl),stableUrl:i.URI.revive(v.stableUrl),canSwitch:v.canSwitch,authenticationProviders:v.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(ne[243],re([0,1,15,8]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends i.AbstractLogger{constructor(A,b){super();this.logger=this._register(A.createLogger(b.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...b){this.logger.trace(A,...b)}debug(A,...b){this.logger.debug(A,...b)}info(A,...b){this.logger.info(A,...b)}warn(A,...b){this.logger.warn(A,...b)}error(A,...b){this.logger.error(A,...b)}critical(A,...b){this.logger.critical(A,...b)}flush(){this.logger.flush()}};k=ge([K(0,i.ILoggerService),K(1,D.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(ne[244],re([0,1,3,2,14,7,25]),function(X,e,D,i,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class b{constructor(E,v){this.service=E,this.logService=v,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(E,v){switch(v){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${v}`)}async call(E,v,y){try{return await this._call(E,v,y)}catch(d){throw this.logService.error(d),d}}async _call(E,v,y){switch(v){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(y[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(y[0],L.URI.revive(y[1]),y[2],y[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(y[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(y[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(y[0]);case"getAssociatedResources":return this.service.getAssociatedResources(y[0],{created:y[1].created,uri:L.URI.revive(y[1].uri)});case"getMachineId":return this.service.getMachineId(y[0],{created:y[1].created,uri:L.URI.revive(y[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(v.startsWith("manualSync/")){const d=v.substring("manualSync/".length),S=y[0],w=this.getManualSyncTask(S);switch(y=y.slice(1),d){case"preview":return w.preview();case"accept":return w.accept(L.URI.revive(y[0]),y[1]);case"merge":return w.merge(L.URI.revive(y[0]));case"discard":return w.discard(L.URI.revive(y[0]));case"discardConflicts":return w.discardConflicts();case"apply":return w.apply();case"pull":return w.pull();case"push":return w.push();case"stop":return w.stop();case"_getStatus":return w.status;case"dispose":return this.disposeManualSyncTask(w)}}throw new Error("Invalid call")}getManualSyncTask(E){const v=this.manualSyncTasks.get(this.createKey(E));if(!v)throw new Error(`Manual sync taks not found: ${E}`);return v.manualSyncTask}async createManualSyncTask(){const E=new i.DisposableStore,v=E.add(await this.service.createManualSyncTask());return E.add(v.onSynchronizeResources(y=>this.onManualSynchronizeResources.fire({manualSyncTaskId:v.id,data:y}))),this.manualSyncTasks.set(this.createKey(v.id),{manualSyncTask:v,disposables:E}),{id:v.id,manifest:v.manifest,status:v.status}}disposeManualSyncTask(E){E.dispose();const v=this.createKey(E.id);this.manualSyncTasks.get(v)?.disposables.dispose(),this.manualSyncTasks.delete(v)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=b;class C extends i.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(v,y,d){return E.call(v,y,d).then(null,S=>{throw A.UserDataSyncError.toUserDataSyncError(S)})},listen(v,y){return E.listen(v,y)}},this.channel.call("_getInitialData").then(([v,y,d])=>{this.updateStatus(v),this.updateConflicts(y),d&&this.updateLastSyncTime(d),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(v=>this.updateConflicts(v))),this._register(this.channel.listen("onSyncErrors")(v=>this._onSyncErrors.fire(v.map(([y,d])=>[y,A.UserDataSyncError.toUserDataSyncError(d)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:v,status:y}=await this.channel.call("createManualSyncTask"),d=this,S=new R(E,v,y,{async call(w,p,m){return d.channel.call(`manualSync/${w}`,[E,...(0,k.isArray)(p)?p:[p]],m)},listen(w,p){return D.Event.map(D.Event.filter(d.channel.listen(`manualSync/${w}`,p),m=>!S.isDiposed()&&m.manualSyncTaskId===E),m=>m.data)}});return S}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,v,y,d){return this.channel.call("accept",[E,v,y,d])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:y,uri:d})=>({created:y,uri:L.URI.revive(d)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:y,uri:d})=>({created:y,uri:L.URI.revive(d)}))}async getAssociatedResources(E,v){return(await this.channel.call("getAssociatedResources",[E,v])).map(({resource:d,comparableResource:S})=>({resource:L.URI.revive(d),comparableResource:L.URI.revive(S)}))}async getMachineId(E,v){return this.channel.call("getMachineId",[E,v])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([v,y])=>[v,y.map(d=>({...d,baseResource:L.URI.revive(d.baseResource),localResource:L.URI.revive(d.localResource),remoteResource:L.URI.revive(d.remoteResource),previewResource:L.URI.revive(d.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=C;class R extends i.Disposable{constructor(E,v,y,d){super();this.id=E,this.manifest=v,this._disposed=!1,this._status=y;const S=this;this.channel={async call(w,p,m){try{const u=await d.call(w,p,m);return S.isDiposed()||(S._status=await d.call("_getStatus")),u}catch(u){throw A.UserDataSyncError.toUserDataSyncError(u)}},listen(w,p){return d.listen(w,p)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,v){const y=await this.channel.call("accept",[E,v]);return this.deserializePreviews(y)}async merge(E){const v=await this.channel.call("merge",[E]);return this.deserializePreviews(v)}async discard(E){const v=await this.channel.call("discard",[E]);return this.deserializePreviews(v)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([v,y])=>[v,{isLastSyncFromCurrentMachine:y.isLastSyncFromCurrentMachine,resourcePreviews:y.resourcePreviews.map(d=>({...d,baseResource:L.URI.revive(d.baseResource),localResource:L.URI.revive(d.localResource),remoteResource:L.URI.revive(d.remoteResource),previewResource:L.URI.revive(d.previewResource),acceptedResource:L.URI.revive(d.acceptedResource)}))}])}}}),define(ne[245],re([0,1,6,3,2]),function(X,e,D,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends k.Disposable{constructor({onDidOpenWindow:b,onDidFocusWindow:C,getActiveWindowId:R}){super();this.disposables=this._register(new k.DisposableStore),i.Event.latch(i.Event.any(b,C))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>R()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(b){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=b}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(ne[246],re([0,1,165,12,34,17,7,5,20]),function(X,e,D,i,k,L,A,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function R(t){const s=t;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=R;function I(t){if(t.configuration)return{id:t.id,configPath:t.configuration};if(t.folders.length===1)return{id:t.id,uri:t.folders[0].uri}}e.toWorkspaceIdentifier=I;function E(t){const s=t;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=E;function v(t){const s=t;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const a=t;if(a?.configPath)return{id:a.id,configPath:A.URI.revive(a.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=v;var y;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function d(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=d;function S(t){const s=t;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=S;class w{constructor(s,a,c,o,l){this._id=s,this._transient=c,this._configuration=o,this._ignorePathCasing=l,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=a}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class p{constructor(s,a){this.raw=a,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,L.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function m(t){return new p({uri:t,index:0,name:(0,L.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=m,e.WORKSPACE_EXTENSION="code-workspace";const u=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(t,s){return L.extUriBiasedIgnorePathCase.isEqualOrParent(t,s.untitledWorkspacesHome)}e.isUntitledWorkspace=g;function h(t){let s;return A.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===C.Schemas.tmp}e.isTemporaryWorkspace=h;function r(t,s){return!g(t,s)&&!h(t)}e.isSavedWorkspace=r;function n(t){return(typeof t=="string"?(0,i.extname)(t):(0,L.extname)(t))===u}e.hasWorkspaceFileExtension=n}),define(ne[29],re([0,1,62,3,2,17,14,7,158,15,13,5,8,246,34,33,6,31]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function m(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&b.URI.isUri(n.location)&&b.URI.isUri(n.globalStorageHome)&&b.URI.isUri(n.settingsResource)&&b.URI.isUri(n.keybindingsResource)&&b.URI.isUri(n.tasksResource)&&b.URI.isUri(n.snippetsHome)&&((0,A.isUndefined)(n.extensionsResource)||b.URI.isUri(n.extensionsResource)))}e.isUserDataProfile=m,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,E.createDecorator)("IUserDataProfilesService");function u(r,n){return{id:r.id,isDefault:r.isDefault,name:r.name,location:b.URI.revive(r.location).with({scheme:n}),globalStorageHome:b.URI.revive(r.globalStorageHome).with({scheme:n}),settingsResource:b.URI.revive(r.settingsResource).with({scheme:n}),keybindingsResource:b.URI.revive(r.keybindingsResource).with({scheme:n}),tasksResource:b.URI.revive(r.tasksResource).with({scheme:n}),snippetsHome:b.URI.revive(r.snippetsHome).with({scheme:n}),extensionsResource:b.URI.revive(r.extensionsResource)?.with({scheme:n})}}e.reviveProfile=u,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function g(r,n,t){return{id:(0,D.hash)(n.path).toString(16),name:r,location:n,isDefault:!1,globalStorageHome:(0,L.joinPath)(n,"globalStorage"),settingsResource:(0,L.joinPath)(n,"settings.json"),keybindingsResource:(0,L.joinPath)(n,"keybindings.json"),tasksResource:(0,L.joinPath)(n,"tasks.json"),snippetsHome:(0,L.joinPath)(n,"snippets"),extensionsResource:(0,L.joinPath)(n,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:t}}e.toUserDataProfile=g;let h=class extends k.Disposable{constructor(n,t,s,a){super();this.environmentService=n,this.fileService=t,this.uriIdentityService=s,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new i.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new i.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new i.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return this.profilesObject.profiles}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(c=>g(c.name,c.location,c.useDefaultFlags)):[];let t;const s=new d.ResourceMap;if(n.length){const c=this.getStoredProfileAssociations();if(c.workspaces)for(const[o,l]of Object.entries(c.workspaces)){const f=b.URI.parse(o),P=b.URI.parse(l),U=n.find(_=>this.uriIdentityService.extUri.isEqual(_.location,P));U&&s.set(f,U)}if(c.emptyWindow){const o=b.URI.parse(c.emptyWindow);t=n.find(l=>this.uriIdentityService.extUri.isEqual(l.location,o))}}const a=g((0,C.localize)(0,null),this.environmentService.userRoamingDataHome);n.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0?a.extensionsResource:void 0}),this._profilesObject={profiles:n,workspaces:s,emptyWindow:t}}return this._profilesObject}getProfile(n){const t=this.getWorkspace(n);return(b.URI.isUri(t)?this.profilesObject.workspaces.get(t):this.profilesObject.emptyWindow)??this.defaultProfile}getWorkspace(n){return(0,y.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,y.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}async createProfile(n,t,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(this.getStoredProfiles().some(o=>o.name===n))throw new Error(`Profile with name ${n} already exists`);const a=g(n,(0,L.joinPath)(this.profilesHome,(0,D.hash)((0,p.generateUuid)()).toString(16)),t);await this.fileService.createFolder(a.location);const c=[];return this._onWillCreateProfile.fire({profile:a,join(o){c.push(o)}}),await w.Promises.settled(c),this.updateProfiles([a],[],[]),s&&await this.setProfileForWorkspace(a,s),a}async updateProfile(n,t,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(c=>c.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=g(t,a.location,s),this.updateProfiles([],[],[a]),a}async setProfileForWorkspace(n,t){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(a=>a.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);this.updateWorkspaceAssociation(t,s)}async unsetWorkspace(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n)}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const t=this.profiles.find(a=>a.id===n.id);if(!t)throw new Error(`Profile '${n.name}' does not exist`);const s=[];this._onWillRemoveProfile.fire({profile:t,join(a){s.push(a)}}),await w.Promises.settled(s),t.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])t.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[t],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(t.location,{recursive:!0})}catch(a){this.logService.error(a)}}updateProfiles(n,t,s){const a=[];for(let c of[...this.profilesObject.profiles,...n])c.isDefault||t.some(o=>c.id===o.id)||(c=s.find(o=>c.id===o.id)??c,a.push({location:c.location,name:c.name,useDefaultFlags:c.useDefaultFlags}));this.saveStoredProfiles(a),this._profilesObject=void 0,this.triggerProfilesChanges(n,t,s)}triggerProfilesChanges(n,t,s){this._onDidChangeProfiles.fire({added:n,removed:t,updated:s,all:this.profiles})}updateWorkspaceAssociation(n,t){const s=this.getWorkspace(n);b.URI.isUri(s)?(this.profilesObject.workspaces.delete(s),t&&!t.isDefault&&this.profilesObject.workspaces.set(s,t)):this.profilesObject.emptyWindow=t?.isDefault?void 0:t,this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[s,a]of this.profilesObject.workspaces.entries())n[s.toString()]=a.location.toString();const t=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:t}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};h.PROFILES_KEY="userDataProfiles",h.PROFILE_ASSOCIATIONS_KEY="profileAssociations",h=ge([K(0,R.IEnvironmentService),K(1,I.IFileService),K(2,S.IUriIdentityService),K(3,v.ILogService)],h),e.UserDataProfilesService=h}),define(ne[247],re([0,1,18,6,21,9,3,2,4,7,141,28,32,44,8,24,22,29]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends b.Disposable{constructor(t,s,a,c,o){super();this.galleryService=t,this.telemetryService=s,this.logService=a,this.productService=c,this.userDataProfilesService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,b.toDisposable)(()=>{this.installingExtensions.forEach(l=>l.cancel()),this.uninstallingExtensions.forEach(l=>l.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const s=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,E.isTargetPlatformCompatible)(a,t.allTargetPlatforms,s))}async installFromGallery(t,s={}){try{if(!this.galleryService.isEnabled())throw new E.ExtensionManagementError(I.localize(0,null),E.ExtensionManagementErrorCode.Internal);const a=await this.checkAndGetCompatibleVersion(t,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.installExtension(a.manifest,a.extension,s)}catch(a){throw h(this.telemetryService,"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(t),error:a}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(a),g(a)}}async uninstall(t,s={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,s)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(1,null));const s=await this.getTargetPlatform(),[a]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:s,compatible:!0},k.CancellationToken.None);if(!a)throw new Error(I.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(a)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,s,a){const c=U=>`${v.ExtensionKey.create(U).toString()}${a.profileLocation?`-${a.profileLocation.toString()}`:""}`;if(!R.URI.isUri(s)){const U=this.installingExtensions.get(c(s));if(U){this.logService.info("Extensions is already requested to install",s.identifier.id);const{local:_}=await U.waitUntilTaskIsFinished();return _}a={...a,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],l=[],f=this.createInstallExtensionTask(t,s,a);R.URI.isUri(s)||this.installingExtensions.set(c(s),f),this._onInstallExtension.fire({identifier:f.identifier,source:s,profileLocation:a.profileLocation}),this.logService.info("Installing extension:",f.identifier.id),o.push({task:f,manifest:t});let P=!1;try{if(a.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",f.identifier.id);else try{const _=await this.getAllDepsAndPackExtensionsToInstall(f.identifier,t,!!a.installOnlyNewlyAddedFromExtensionPack,!!a.installPreReleaseVersion,a.profileLocation);for(const{gallery:F,manifest:T}of _){P=P||!!T.extensionDependencies?.some(z=>(0,v.areSameExtensions)({id:z},f.identifier));const N=c(F);if(this.installingExtensions.has(N))this.logService.info("Extension is already requested to install",F.identifier.id);else{const z=this.createInstallExtensionTask(T,F,{...a,donotIncludePackAndDependencies:!0});this.installingExtensions.set(N,z),this._onInstallExtension.fire({identifier:z.identifier,source:F,profileLocation:a.profileLocation}),this.logService.info("Installing extension:",z.identifier.id),o.push({task:z,manifest:T})}}}catch(_){if(R.URI.isUri(f.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",f.identifier.id,_.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",f.identifier.id,_.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",f.identifier.id),_}const U=o.reduce((_,{task:F,manifest:T})=>(_.set(F.identifier.id.toLowerCase(),{task:F,manifest:T}),_),new Map);for(;U.size;){let _;const F=[...U.values()].filter(({manifest:T})=>!T.extensionDependencies?.some(N=>U.has(N.toLowerCase())));F.length?_=U.size===1?F:F.filter(({task:T})=>!(T===f&&!P)):(this.logService.info("Found extensions with circular dependencies",F.map(({task:T})=>T.identifier.id)),_=[...U.values()]),await this.joinAllSettled(_.map(async({task:T})=>{const N=new Date().getTime();try{const{local:z}=await T.run();if(await this.joinAllSettled(this.participants.map(V=>V.postInstall(z,T.source,a,k.CancellationToken.None))),!R.URI.isUri(T.source)){const V=T.operation===3,J=V?void 0:(new Date().getTime()-T.source.lastUpdated)/1e3;if(h(this.telemetryService,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(T.source),duration:new Date().getTime()-N,durationSinceUpdate:J}),C.isWeb&&T.operation!==3)try{await this.galleryService.reportStatistic(z.manifest.publisher,z.manifest.name,z.manifest.version,"install")}catch{}}l.push({local:z,identifier:T.identifier,operation:T.operation,source:T.source,context:a.context,profileLocation:a.profileLocation,applicationScoped:z.isApplicationScoped})}catch(z){throw R.URI.isUri(T.source)||h(this.telemetryService,T.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(T.source),duration:new Date().getTime()-N,error:z}),this.logService.error("Error while installing the extension:",T.identifier.id),z}finally{U.delete(T.identifier.id.toLowerCase())}}))}return l.forEach(({identifier:_})=>this.logService.info("Extension installed successfully:",_.id)),this._onDidInstallExtensions.fire(l),l.filter(({identifier:_})=>(0,v.areSameExtensions)(_,f.identifier))[0].local}catch(U){if(o.forEach(({task:_})=>_.cancel()),l.length)try{const _=await Promise.allSettled(l.map(({local:F})=>this.createUninstallExtensionTask(F,{versionOnly:!0,profileLocation:a.profileLocation}).run()));for(let F=0;F<_.length;F++){const T=_[F],{identifier:N}=l[F];T.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,L.getErrorMessage)(T.reason))}}catch(_){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(_),l.map(({identifier:F})=>F.id))}throw this._onDidInstallExtensions.fire(o.map(({task:_})=>({identifier:_.identifier,operation:2,source:_.source,context:a.context,profileLocation:a.profileLocation}))),U}finally{for(const{task:U}of o)if(!R.URI.isUri(U.source)){const _=c(U.source);this.installingExtensions.delete(_)||this.logService.warn("Installation task is not found in the cache",_)}}}async joinAllSettled(t){const s=[],a=[],c=await Promise.allSettled(t);for(const o of c)o.status==="fulfilled"?s.push(o.value):a.push(o.reason);if(a.length)throw u(a);return s}async getAllDepsAndPackExtensionsToInstall(t,s,a,c,o){if(!this.galleryService.isEnabled())return[];let l=await this.getInstalled(void 0,o);const f=[t,...l.map(_=>_.identifier)],P=[],U=async(_,F)=>{const T=F.extensionDependencies||[],N=[...T];if(F.extensionPack){const z=a?l.find(V=>(0,v.areSameExtensions)(V.identifier,_)):void 0;for(const V of F.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(J=>(0,v.areSameExtensions)({id:J},{id:V}))||N.every(J=>!(0,v.areSameExtensions)({id:J},{id:V}))&&N.push(V)}if(N.length){const z=[...f,...P.map(J=>J.gallery.identifier)],V=N.filter(J=>z.every($=>!(0,v.areSameExtensions)($,{id:J})));if(V.length){const J=await this.galleryService.getExtensions(V.map($=>({id:$,preRelease:c})),k.CancellationToken.None);for(const $ of J){if(z.find(B=>(0,v.areSameExtensions)(B,$.identifier)))continue;const Q=T.some(B=>(0,v.areSameExtensions)({id:B},$.identifier));let H;try{H=await this.checkAndGetCompatibleVersion($,!1,c)}catch(B){if(B instanceof E.ExtensionManagementError&&B.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Q){this.logService.info("Skipping the packed extension as it cannot be installed",$.identifier.id);continue}else throw B}P.push({gallery:H.extension,manifest:H.manifest}),await U(H.extension.identifier,H.manifest)}}}};return await U(t,s),l=await this.getInstalled(void 0,o),P.filter(_=>!l.some(F=>(0,v.areSameExtensions)(F.identifier,_.gallery.identifier)))}async checkAndGetCompatibleVersion(t,s,a){if((await this.getExtensionsControlManifest()).malicious.some(f=>(0,v.areSameExtensions)(t.identifier,f)))throw new E.ExtensionManagementError(I.localize(3,null,t.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const f=await this.getTargetPlatform();throw new E.ExtensionManagementError(I.localize(4,null,t.identifier.id,this.productService.nameLong,(0,E.TargetPlatformToString)(f)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(t,s,a);if(o){if(a&&!s&&t.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(I.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],k.CancellationToken.None))[0]?new E.ExtensionManagementError(I.localize(6,null,t.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(I.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const l=await this.galleryService.getManifest(o,k.CancellationToken.None);if(l===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(l.version!==o.version)throw new E.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:l}}async getCompatibleVersion(t,s,a){const c=await this.getTargetPlatform();let o=null;return!s&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(o=(await this.galleryService.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:c,compatible:!0},k.CancellationToken.None))[0]||null),!o&&await this.galleryService.isExtensionCompatible(t,a,c)&&(o=t),o||(s?o=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:c,compatible:!0},k.CancellationToken.None))[0]||null:o=await this.galleryService.getCompatibleExtension(t,a,c)),o}async uninstallExtension(t,s){const a=U=>`${U.id.toLowerCase()}${s.versionOnly?`-${t.manifest.version}`:""}${s.profileLocation?`@${s.profileLocation.toString()}`:""}`,c=this.uninstallingExtensions.get(a(t.identifier));if(c)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),c.waitUntilTaskIsFinished();const o=(U,_)=>{const F=this.createUninstallExtensionTask(U,_);return this.uninstallingExtensions.set(a(F.extension.identifier),F),s.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,s.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${U.identifier.id}@${U.manifest.version}`),this._onUninstallExtension.fire({identifier:U.identifier,profileLocation:s.profileLocation,applicationScoped:U.isApplicationScoped}),F},l=(U,_)=>{_?s.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,s.profileLocation.toString(),_.message):this.logService.error("Failed to uninstall extension:",`${U.identifier.id}@${U.manifest.version}`,_.message):s.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${U.identifier.id}@${U.manifest.version}`,s.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${U.identifier.id}@${U.manifest.version}`),h(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,v.getLocalExtensionTelemetryData)(U),error:_}),this._onDidUninstallExtension.fire({identifier:U.identifier,version:U.manifest.version,error:_?.code,profileLocation:s.profileLocation,applicationScoped:U.isApplicationScoped})},f=[],P=[];try{f.push(o(t,s));const U=await this.getInstalled(1,s.profileLocation);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const _=this.getAllPackExtensionsToUninstall(t,U);for(const F of _)this.uninstallingExtensions.has(a(F.identifier))?this.logService.info("Extensions is already requested to uninstall",F.identifier.id):f.push(o(F,s))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(f.map(_=>_.extension),U,t),await this.joinAllSettled(f.map(async _=>{try{if(await _.run(),await this.joinAllSettled(this.participants.map(F=>F.postUninstall(_.extension,s,k.CancellationToken.None))),_.extension.identifier.uuid)try{await this.galleryService.reportStatistic(_.extension.manifest.publisher,_.extension.manifest.name,_.extension.manifest.version,"uninstall")}catch{}l(_.extension)}catch(F){const T=F instanceof E.ExtensionManagementError?F:new E.ExtensionManagementError((0,L.getErrorMessage)(F),E.ExtensionManagementErrorCode.Internal);throw l(_.extension,T),T}finally{P.push(_)}}))}catch(U){const _=U instanceof E.ExtensionManagementError?U:new E.ExtensionManagementError((0,L.getErrorMessage)(U),E.ExtensionManagementErrorCode.Internal);for(const F of f){try{F.cancel()}catch{}P.includes(F)||l(F.extension,_)}throw _}finally{for(const U of f)this.uninstallingExtensions.delete(a(U.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",U.extension.identifier.id)}}checkForDependents(t,s,a){for(const c of t){const o=this.getDependents(c,s);if(o.length){const l=o.filter(f=>!t.some(P=>(0,v.areSameExtensions)(P.identifier,f.identifier)));if(l.length)throw new Error(this.getDependentsErrorMessage(c,l,a))}}}getDependentsErrorMessage(t,s,a){return a===t?s.length===1?I.localize(8,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?I.localize(9,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):I.localize(10,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?I.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?I.localize(12,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):I.localize(13,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(t,s,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const c=t.manifest.extensionPack?t.manifest.extensionPack:[];if(c.length){const o=s.filter(f=>!f.isBuiltin&&c.some(P=>(0,v.areSameExtensions)({id:P},f.identifier))),l=[];for(const f of o)l.push(...this.getAllPackExtensionsToUninstall(f,s,a));return[...o,...l]}return[]}getDependents(t,s){return s.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(c=>(0,v.areSameExtensions)({id:c},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,s,a){return a.profileLocation&&(0,y.isApplicationScopedExtension)(t)&&(a={...a,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,s,a)}createUninstallExtensionTask(t,s){return s.profileLocation&&t.isApplicationScoped&&(s={...s,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,s)}};m=ge([K(0,E.IExtensionGalleryService),K(1,w.ITelemetryService),K(2,d.ILogService),K(3,S.IProductService),K(4,p.IUserDataProfilesService)],m),e.AbstractExtensionManagementService=m;function u(n){const t=Array.isArray(n)?n:[n];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((s,a)=>new Error(`${s.message}${s.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=u;function g(n){if(n instanceof E.ExtensionManagementError)return n;const t=new E.ExtensionManagementError(n.message,E.ExtensionManagementErrorCode.Internal);return t.stack=n.stack,t}function h(n,t,{extensionData:s,duration:a,error:c,durationSinceUpdate:o}){const l=c?c instanceof E.ExtensionManagementError?c.code:E.ExtensionManagementErrorCode.Internal:void 0;n.publicLog(t,{...s,success:!c,duration:a,errorcode:l,durationSinceUpdate:o})}e.reportTelemetry=h;class r{constructor(){this.barrier=new i.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(t=>new Promise((s,a)=>{const c=t.onCancellationRequested(()=>{c.dispose(),a(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=r}),define(ne[71],re([0,1,18,6,30,16,9,35,122,2,20,12,4,17,55,80,14,7,143,15,32,44,65,13,5,8,24,3,63,45,29,33]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p,m,u,g,h,r,n,t,s,a,c,o,l,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var U;(function(J){function $(Q,H){if(Q===H)return!0;const B=Object.keys(Q),Y=new Set;for(const ie of Object.keys(H))Y.add(ie);if(B.length!==Y.size)return!1;for(const ie of B){if(Q[ie]!==H[ie])return!1;Y.delete(ie)}return Y.size===0}J.equals=$})(U=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let _=class extends R.Disposable{constructor($,Q,H,B,Y,ie,ae,W,x,O,M){super();this.systemExtensionsLocation=$,this.userExtensionsLocation=Q,this.extensionsControlLocation=H,this.cacheLocation=B,this.userDataProfilesService=Y,this.extensionsProfileScannerService=ie,this.fileService=ae,this.logService=W,this.environmentService=x,this.productService=O,this.instantiationService=M,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,y.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(N,(0,y.joinPath)(this.cacheLocation,h.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(N,(0,y.joinPath)(this.cacheLocation,h.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(T,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,g.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions($,Q){const[H,B]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(Q)]),Y=await this.scanExtensionsUnderDevelopment($,[...H,...B]);return this.dedupExtensions(H,B,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const Q=[];Q.push(this.scanDefaultSystemExtensions(!!$.useCache,$.language)),Q.push(this.scanDevSystemExtensions($.language,!!$.checkControlFile));const[H,B]=await Promise.all(Q);return this.applyScanOptions([...H,...B],0,$,!1)}async scanUserExtensions($){this.logService.trace("Started scanning user extensions");const Q=await this.createExtensionScannerInput($.profileLocation??this.userExtensionsLocation,!!$.profileLocation,1,!$.includeUninstalled,$.language);let B=await($.useCache&&!Q.devMode&&Q.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(Q);return B=await this.applyScanOptions(B,1,$,!0),this.logService.trace("Scanned user extensions:",B.length),B}async scanExtensionsUnderDevelopment($,Q){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const H=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(B=>B.scheme===I.Schemas.file).map(async B=>{const Y=await this.createExtensionScannerInput(B,!1,1,!0,$.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(Y)).map(ae=>(ae.type=Q.find(W=>(0,g.areSameExtensions)(W.identifier,ae.identifier))?.type??ae.type,this.extensionsScanner.validate(ae,Y)))}))).flat();return this.applyScanOptions(H,"development",$,!0)}return[]}async scanExistingExtension($,Q,H){const B=await this.createExtensionScannerInput($,!1,Q,!0,H.language),Y=await this.extensionsScanner.scanExtension(B);return!Y||!H.includeInvalid&&!Y.isValid?null:Y}async scanOneOrMultipleExtensions($,Q,H){const B=await this.createExtensionScannerInput($,!1,Q,!0,H.language),Y=await this.extensionsScanner.scanOneOrMultipleExtensions(B);return this.applyScanOptions(Y,Q,H,!0)}async scanMetadata($){const Q=(0,y.joinPath)($,"package.json"),H=(await this.fileService.readFile(Q)).value.toString();return JSON.parse(H).__metadata}async updateMetadata($,Q){const H=(0,y.joinPath)($,"package.json"),B=(await this.fileService.readFile(H)).value.toString(),Y=JSON.parse(B);Q.isMachineScoped=Q.isMachineScoped||void 0,Q.isBuiltin=Q.isBuiltin||void 0,Q.installedTimestamp=Q.installedTimestamp||void 0,Y.__metadata={...Y.__metadata,...Q},await this.fileService.writeFile((0,y.joinPath)($,"package.json"),L.VSBuffer.fromString(JSON.stringify(Y,null,"	")))}async applyScanOptions($,Q,H,B){return H.includeAllVersions||($=this.dedupExtensions(Q===0?$:void 0,Q===1?$:void 0,Q==="development"?$:void 0,await this.getTargetPlatform(),B)),H.includeInvalid||($=$.filter(Y=>Y.isValid)),$.sort((Y,ie)=>{const ae=E.basename(Y.location.fsPath),W=E.basename(ie.location.fsPath);return ae<W?-1:ae>W?1:0})}dedupExtensions($,Q,H,B,Y){const ie=(W,x,O)=>{if(W.isValid&&!x.isValid)return!1;if(W.isValid===x.isValid){if(Y&&d.gt(W.manifest.version,x.manifest.version))return this.logService.debug(`Skipping extension ${x.location.path} with lower version ${x.manifest.version} in favour of ${W.location.path} with version ${W.manifest.version}`),!1;if(d.eq(W.manifest.version,x.manifest.version)){if(W.type===0)return this.logService.debug(`Skipping extension ${x.location.path} in favour of system extension ${W.location.path} with same version`),!1;if(W.targetPlatform===B)return this.logService.debug(`Skipping extension ${x.location.path} from different target platform ${x.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${W.location.path} with ${x.location.path}.`):this.logService.debug(`Overwriting user extension ${W.location.path} with ${x.location.path}.`),!0},ae=new Map;return $?.forEach(W=>{const x=h.ExtensionIdentifier.toKey(W.identifier.id),O=ae.get(x);(!O||ie(O,W,!1))&&ae.set(x,W)}),Q?.forEach(W=>{const x=h.ExtensionIdentifier.toKey(W.identifier.id),O=ae.get(x);if(!O&&$&&W.type===0){this.logService.debug(`Skipping obsolete system extension ${W.location.path}.`);return}(!O||ie(O,W,!1))&&ae.set(x,W)}),H?.forEach(W=>{const x=h.ExtensionIdentifier.toKey(W.identifier.id),O=ae.get(x);(!O||ie(O,W,!0))&&ae.set(x,W),ae.set(x,W)}),[...ae.values()]}async scanDefaultSystemExtensions($,Q){this.logService.trace("Started scanning system extensions");const H=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,Q),Y=await($&&!H.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(H);return this.logService.trace("Scanned system extensions:",Y.length),Y}async scanDevSystemExtensions($,Q){const H=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!H?.length)return[];this.logService.trace("Started scanning dev system extensions");const B=Q?await this.getBuiltInExtensionControl():{},Y=[],ie=p.URI.file(E.normalize(E.join(I.FileAccess.asFileUri("",X).fsPath,"..",".build","builtInExtensions")));for(const W of H){const x=B[W.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":Y.push((0,y.joinPath)(ie,W.name));break;default:Y.push(p.URI.file(x));break}}const ae=await Promise.all(Y.map(async W=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(W,!1,0,!0,$))));return this.logService.trace("Scanned dev system extensions:",ae.length),(0,D.coalesce)(ae)}async getBuiltInExtensionControl(){try{const $=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse($.value.toString())}catch{return{}}}async createExtensionScannerInput($,Q,H,B,Y,ie=!0){const ae=await this.getTranslations(Y??v.language),W=await this.getMtime($),x=Q?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=x?await this.getMtime(x):void 0;return new F($,W,x,O,Q,H,B,ie,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,Y,ae)}async getMtime($){try{const Q=await this.fileService.stat($);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};_=ge([K(4,f.IUserDataProfilesService),K(5,l.IExtensionsProfileScannerService),K(6,n.IFileService),K(7,s.ILogService),K(8,u.IEnvironmentService),K(9,a.IProductService),K(10,t.IInstantiationService)],_),e.AbstractExtensionsScannerService=_;class F{constructor($,Q,H,B,Y,ie,ae,W,x,O,M,q,j,Z){this.location=$,this.mtime=Q,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=B,this.profile=Y,this.type=ie,this.excludeObsolete=ae,this.validate=W,this.productVersion=x,this.productDate=O,this.productCommit=M,this.devMode=q,this.language=j,this.translations=Z}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,Q){return(0,y.isEqual)($.location,Q.location)&&$.mtime===Q.mtime&&(0,y.isEqual)($.applicationExtensionslocation,Q.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&$.profile===Q.profile&&$.type===Q.type&&$.excludeObsolete===Q.excludeObsolete&&$.validate===Q.validate&&$.productVersion===Q.productVersion&&$.productDate===Q.productDate&&$.productCommit===Q.productCommit&&$.devMode===Q.devMode&&$.language===Q.language&&U.equals($.translations,Q.translations)}}let T=class extends R.Disposable{constructor($,Q,H,B,Y){super();this.obsoleteFile=$,this.extensionsProfileScannerService=Q,this.uriIdentityService=H,this.fileService=B,this.logService=Y}async scanExtensions($){const Q=$.profile?await this.scanExtensionsFromProfile($):await this.scanExtensionsFromLocation($);let H={};if($.excludeObsolete&&$.type===1)try{const B=(await this.fileService.readFile(this.obsoleteFile)).value.toString();H=JSON.parse(B)}catch{}return(0,w.isEmptyObject)(H)?Q:Q.filter(B=>!H[g.ExtensionKey.create(B).toString()])}async scanExtensionsFromLocation($){const Q=await this.fileService.resolve($.location);if(!Q.children?.length)return[];const H=await Promise.all(Q.children.map(async B=>{if(!B.isDirectory||$.type===1&&(0,y.basename)(B.resource).indexOf(".")===0)return null;const Y=new F(B.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(Y)}));return(0,D.coalesce)(H).sort((B,Y)=>B.location.path<Y.location.path?-1:1)}async scanExtensionsFromProfile($){let Q=await this.scanExtensionsFromProfileResource($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual($.location,$.applicationExtensionslocation)){Q=Q.filter(B=>!B.metadata?.isApplicationScoped);const H=await this.scanExtensionsFromProfileResource($.applicationExtensionslocation,B=>!!B.metadata?.isApplicationScoped,$);Q.push(...H)}return Q}async scanExtensionsFromProfileResource($,Q,H){const B=await this.extensionsProfileScannerService.scanProfileExtensions($);if(!B.length)return[];const Y=await Promise.all(B.map(async ie=>{if(Q(ie)){const ae=new F(ie.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ae,ie.metadata)}return null}));return(0,D.coalesce)(Y)}async scanOneOrMultipleExtensions($){try{if(await this.fileService.exists((0,y.joinPath)($.location,"package.json"))){const Q=await this.scanExtension($);return Q?[Q]:[]}else return await this.scanExtensions($)}catch(Q){return this.logService.error(`Error scanning extensions at ${$.location.path}:`,(0,A.getErrorMessage)(Q)),[]}}async scanExtension($,Q){try{let H=await this.scanExtensionManifest($.location);if(H){H.publisher||(H.publisher=h.UNDEFINED_PUBLISHER),Q=Q??H.__metadata,delete H.__metadata;const B=(0,g.getGalleryExtensionId)(H.publisher,H.name),Y=Q?.id?{id:B,uuid:Q.id}:{id:B},ie=Q?.isSystem?0:$.type,ae=ie===0||!!Q?.isBuiltin;H=await this.translateManifest($.location,H,F.createNlsConfiguration($));const W={type:ie,identifier:Y,manifest:H,location:$.location,isBuiltin:ae,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return $.validate?this.validate(W,$):W}}catch(H){$.type!==0&&this.logService.error(H)}return null}validate($,Q){let H=!0;const B=(0,r.validateExtensionManifest)(Q.productVersion,Q.productDate,Q.location,$.manifest,$.isBuiltin);for(const[Y,ie]of B)Y===S.default.Error&&(H=!1,this.logService.error(this.formatMessage(Q.location,ie)));return $.isValid=H,$.validations=B,$}async scanExtensionManifest($){const Q=(0,y.joinPath)($,"package.json");let H;try{H=(await this.fileService.readFile(Q)).value.toString()}catch(Y){return(0,n.toFileOperationResult)(Y)!==1&&this.logService.error(this.formatMessage($,(0,m.localize)(0,null,Q.path,Y.message))),null}let B;try{B=JSON.parse(H)}catch{const ie=[];(0,b.parse)(H,ie);for(const ae of ie)this.logService.error(this.formatMessage($,(0,m.localize)(1,null,Q.path,ae.offset,ae.length,(0,C.getParseErrorMessage)(ae.error))));return null}return(0,b.getNodeType)(B)!=="object"?(this.logService.error(this.formatMessage($,(0,m.localize)(2,null,Q.path))),null):B}async translateManifest($,Q,H){const B=await this.getLocalizedMessages($,Q,H);if(B)try{const Y=[],ie=await this.resolveOriginalMessageBundle(B.default,Y);if(Y.length>0)return Y.forEach(W=>{this.logService.error(this.formatMessage($,(0,m.localize)(3,null,B.default?.path,(0,C.getParseErrorMessage)(W.error))))}),Q;if((0,b.getNodeType)(B)!=="object")return this.logService.error(this.formatMessage($,(0,m.localize)(4,null,B.default?.path))),Q;const ae=B.values||Object.create(null);this.replaceNLStrings(H.pseudo,Q,ae,ie,$)}catch{}return Q}async getLocalizedMessages($,Q,H){const B=(0,y.joinPath)($,"package.nls.json"),Y=(x,O)=>{O.forEach(M=>{this.logService.error(this.formatMessage($,(0,m.localize)(5,null,x?.path,(0,C.getParseErrorMessage)(M.error))))})},ie=x=>{this.logService.error(this.formatMessage($,(0,m.localize)(6,null,x?.path)))},ae=`${Q.publisher}.${Q.name}`,W=H.translations[ae];if(W)try{const x=p.URI.file(W),O=(await this.fileService.readFile(x)).value.toString(),M=[],q=(0,b.parse)(O,M);return M.length>0?(Y(x,M),{values:void 0,default:B}):(0,b.getNodeType)(q)!=="object"?(ie(x),{values:void 0,default:B}):{values:q.contents?q.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.fileService.exists(B))return;let O;try{O=await this.findMessageBundles($,H)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const M=(await this.fileService.readFile(O.localized)).value.toString(),q=[],j=(0,b.parse)(M,q);return q.length>0?(Y(O.localized,q),{values:void 0,default:O.original}):(0,b.getNodeType)(j)!=="object"?(ie(O.localized),{values:void 0,default:O.original}):{values:j,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle($,Q){if($)try{const H=(await this.fileService.readFile($)).value.toString();return(0,b.parse)(H,Q)}catch{return null}else return null}findMessageBundles($,Q){return new Promise((H,B)=>{const Y=ie=>{const ae=(0,y.joinPath)($,`package.nls.${ie}.json`);this.fileService.exists(ae).then(W=>{W&&H({localized:ae,original:(0,y.joinPath)($,"package.nls.json")});const x=ie.lastIndexOf("-");x===-1?H({localized:(0,y.joinPath)($,"package.nls.json"),original:null}):(ie=ie.substring(0,x),Y(ie))})};if(Q.devMode||Q.pseudo||!Q.language)return H({localized:(0,y.joinPath)($,"package.nls.json"),original:null});Y(Q.language)})}replaceNLStrings($,Q,H,B,Y){const ie=(ae,W,x)=>{const O=ae[W];if((0,w.isString)(O)){const M=O,q=M.length;if(q>1&&M[0]==="%"&&M[q-1]==="%"){const j=M.substr(1,q-2);let Z=H[j];Z===void 0&&B&&(Z=B[j]);let G=typeof Z=="string"?Z:Z.message;if(G!==void 0)if($&&(G="\uFF3B"+G.replace(/[aouei]/g,"$&$&")+"\uFF3D"),x&&B&&(W==="title"||W==="category")){const te=B[j],se={value:G,original:typeof te=="string"?te:te?.message};ae[W]=se}else ae[W]=G;else this.logService.warn(this.formatMessage(Y,(0,m.localize)(7,null,j)))}}else if((0,w.isObject)(O))for(const M in O)O.hasOwnProperty(M)&&(M==="commands"?ie(O,M,!0):ie(O,M,x));else if((0,w.isArray)(O))for(let M=0;M<O.length;M++)ie(O,M,x)};for(const ae in Q)Q.hasOwnProperty(ae)&&ie(Q,ae)}formatMessage($,Q){return`[${$.path}]: ${Q}`}};T=ge([K(1,l.IExtensionsProfileScannerService),K(2,P.IUriIdentityService),K(3,n.IFileService),K(4,s.ILogService)],T);let N=class extends T{constructor($,Q,H,B,Y,ie){super(Q,H,B,Y,ie);this.cacheFile=$,this.cacheValidatorThrottler=this._register(new i.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions($){const Q=await this.readExtensionCache();if(this.input=$,Q&&Q.input&&F.equals(Q.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),Q.result.map(B=>(B.location=p.URI.revive(B.location),B));const H=await super.scanExtensions($);return await this.writeExtensionCache({input:$,result:H}),H}async readExtensionCache(){try{const $=await this.fileService.readFile(this.cacheFile),Q=JSON.parse($.value.toString());return{result:Q.result,input:(0,o.revive)(Q.input)}}catch($){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)($))}return null}async writeExtensionCache($){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify($)))}catch(Q){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(Q))}}async validateCache(){if(!this.input)return;const $=await this.readExtensionCache();if(!$)return;const Q=$.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(H,Q))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(B){this.logService.error(B)}}};N=ge([K(2,l.IExtensionsProfileScannerService),K(3,P.IUriIdentityService),K(4,n.IFileService),K(5,s.ILogService)],N);function z(J,$){const Q=(0,g.getExtensionId)(J.manifest.publisher,J.manifest.name);return{id:Q,identifier:new h.ExtensionIdentifier(Q),isBuiltin:J.type===0,isUserBuiltin:J.type===1&&J.isBuiltin,isUnderDevelopment:$,extensionLocation:J.location,uuid:J.identifier.uuid,targetPlatform:J.targetPlatform,...J.manifest}}e.toExtensionDescription=z;class V extends _{constructor($,Q,H,B,Y,ie,ae,W,x,O,M){super($,Q,(0,y.joinPath)(H,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(B,h.MANIFEST_CACHE_FOLDER),Y,ie,ae,W,x,O,M);this.translationsPromise=(async()=>{if(v.translationsConfigFile)try{const q=await this.fileService.readFile(p.URI.file(v.translationsConfigFile));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}getTranslations($){return this.translationsPromise}}e.NativeExtensionsScannerService=V}),define(ne[248],re([0,1,2,17,28,45,13,29]),function(X,e,D,i,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitService=void 0;let C=class extends D.Disposable{constructor(I,E,v,y){super();this.userDataProfilesService=I,this.fileService=E,this.extensionManagementService=v,this.extensionsProfileScannerService=y}async initialize(){const I=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(I)}catch{}const E=await this.extensionManagementService.getInstalled(1),v=await Promise.all(E.map(async y=>[y,await this.extensionManagementService.getMetadata(y)]));await this.extensionsProfileScannerService.addExtensionsToProfile(v,I)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,i.joinPath)(this.userDataProfilesService.defaultProfile.location,b.EXTENSIONS_RESOURCE_NAME)}};C=ge([K(0,b.IUserDataProfilesService),K(1,A.IFileService),K(2,k.IExtensionManagementService),K(3,L.IExtensionsProfileScannerService)],C),e.DefaultExtensionsProfileInitService=C}),define(ne[249],re([0,1,48,6,38,3,2,20,12,27,8,29]),function(X,e,D,i,k,L,A,b,C,R,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends A.Disposable{constructor(d,S){super();this.userDataProfilesService=d,this.logService=S,this.processesLimiter=new i.Limiter(5)}async postUninstall(d){const S=this.parseScript(d,"uninstall");return S&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),w=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${w}`)))),R.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,w=>this.logService.error("Error while removing extension storage path",w))}parseScript(d,S){const w=`vscode:${S}`;if(d.location.scheme===b.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[w]=="string"){const p=d.manifest.scripts[w].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${w} should be a node script`),null):{script:(0,C.join)(d.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(d,S,w,p,m){return new Promise((u,g)=>{const h=this.start(d,S,w,m);let r;const n=t=>{r&&(clearTimeout(r),r=null),t?g(t):u(void 0)};h.on("error",t=>{n((0,k.toErrorMessage)(t)||"Unknown")}),h.on("exit",(t,s)=>{n(t?`post-${S} process exited with code ${t}`:void 0)}),p&&(r=setTimeout(()=>{r=null,h.kill(),g("timed out")},5e3))})}start(d,S,w,p){const m={silent:!0,execArgv:void 0},u=(0,D.fork)(d,[`--type=extension-post-${S}`,...w],m);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const g=L.Event.fromNodeEventEmitter(u.stdout,"data"),h=L.Event.fromNodeEventEmitter(u.stderr,"data");g(t=>this.logService.info(p.identifier.id,p.manifest.version,`post-${S}`,t)),h(t=>this.logService.error(p.identifier.id,p.manifest.version,`post-${S}`,t));const r=L.Event.any(L.Event.map(g,t=>({data:`%c${t}`,format:[""]})),L.Event.map(h,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(r,(t,s)=>t?{data:t.data+s.data,format:[...t.format,...s.format]}:{data:s.data,format:s.format},100)(t=>{console.group(p.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),u}getExtensionStoragePath(d){return(0,C.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};v=ge([K(0,E.IUserDataProfilesService),K(1,I.ILogService)],v),e.ExtensionsLifecycle=v}),define(ne[250],re([0,1,7,15,45,71,13,5,8,24,29]),function(X,e,D,i,k,L,A,b,C,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let E=class extends L.NativeExtensionsScannerService{constructor(y,d,S,w,p,m,u){super(D.URI.file(p.builtinExtensionsPath),D.URI.file(p.extensionsPath),p.userHome,D.URI.file(p.userDataPath),y,d,S,w,p,m,u)}};E=ge([K(0,I.IUserDataProfilesService),K(1,k.IExtensionsProfileScannerService),K(2,A.IFileService),K(3,C.ILogService),K(4,i.INativeEnvironmentService),K(5,R.IProductService),K(6,b.IInstantiationService)],E),e.ExtensionsScannerService=E}),define(ne[23],re([0,1,6,3,2,190,14,85,5,29]),function(X,e,D,i,k,L,A,b,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const I="__$__targetStorageMarker";e.IStorageService=(0,C.createDecorator)("storageService");var E;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var y;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class d extends k.Disposable{constructor(u={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=u,this._onDidChangeValue=this._register(new i.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new i.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new i.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(u,g){if(g===I){switch(u){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:u})}else this._onDidChangeValue.fire({scope:u,key:g,target:this.getKeyTargets(u)[g]})}emitWillSaveState(u){this._onWillSaveState.fire({reason:u})}get(u,g,h){return this.getStorage(g)?.get(u,h)}getBoolean(u,g,h){return this.getStorage(g)?.getBoolean(u,h)}getNumber(u,g,h){return this.getStorage(g)?.getNumber(u,h)}store(u,g,h,r){if((0,A.isUndefinedOrNull)(g)){this.remove(u,h);return}this.withPausedEmitters(()=>{this.updateKeyTarget(u,h,r),this.getStorage(h)?.set(u,g)})}remove(u,g){this.withPausedEmitters(()=>{this.updateKeyTarget(u,g,void 0),this.getStorage(g)?.delete(u)})}withPausedEmitters(u){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{u()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(u,g){const h=[],r=this.getKeyTargets(u);for(const n of Object.keys(r))r[n]===g&&h.push(n);return h}updateKeyTarget(u,g,h){const r=this.getKeyTargets(g);typeof h=="number"?r[u]!==h&&(r[u]=h,this.getStorage(g)?.set(I,JSON.stringify(r))):typeof r[u]=="number"&&(delete r[u],this.getStorage(g)?.set(I,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(u){switch(u){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(u){const g=this.get(I,u);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}isNew(u){return this.getBoolean(e.IS_NEW_KEY,u)===!0}async flush(u=E.NONE){this._onWillSaveState.fire({reason:u});const g=this.getStorage(-1),h=this.getStorage(0),r=this.getStorage(1);switch(u){case E.NONE:await D.Promises.settled([g?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await D.Promises.settled([g?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.getStorage(-1)?.items??new Map,g=this.getStorage(0)?.items??new Map,h=this.getStorage(1)?.items??new Map;return p(u,g,h,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(u,g){return this.emitWillSaveState(E.NONE),(0,R.isUserDataProfile)(u)?this.switchToProfile(u,g):this.switchToWorkspace(u,g)}canSwitchProfile(u,g){return!(u.id===g.id||S(g)&&S(u))}switchData(u,g,h,r){this.withPausedEmitters(()=>{if(r)for(const[n,t]of u)g.set(n,t);else{const n=new Set;for(const[t,s]of u)n.add(t),g.get(t)!==s&&this.emitDidChangeValue(h,t);for(const[t]of g.items)n.has(t)||this.emitDidChangeValue(h,t)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function S(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class w extends d{constructor(){super();this.applicationStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.profileStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(u=>this.emitDidChangeValue(1,u))),this._register(this.profileStorage.onDidChangeStorage(u=>this.emitDidChangeValue(0,u))),this._register(this.applicationStorage.onDidChangeStorage(u=>this.emitDidChangeValue(-1,u)))}getStorage(u){switch(u){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=w;async function p(m,u,g,h,r,n){const t=_=>{try{return JSON.parse(_)}catch{return _}},s=new Map,a=new Map;m.forEach((_,F)=>{s.set(F,_),a.set(F,t(_))});const c=new Map,o=new Map;u.forEach((_,F)=>{c.set(F,_),o.set(F,t(_))});const l=new Map,f=new Map;g.forEach((_,F)=>{l.set(F,_),f.set(F,t(_))}),console.group(h!==r?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const P=[];if(s.forEach((_,F)=>{P.push({key:F,value:_})}),console.table(P),console.groupEnd(),console.log(a),h!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const _=[];c.forEach((F,T)=>{_.push({key:T,value:F})}),console.table(_),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${n})`);const U=[];l.forEach((_,F)=>{U.push({key:F,value:_})}),console.table(U),console.groupEnd(),console.log(f)}e.logStorage=p}),define(ne[251],re([0,1,3,2,14,28,32,23]),function(X,e,D,i,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let C=class extends i.Disposable{constructor(E,v){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new R(E)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"}))),this._register(v.onDidInstallExtensions(y=>y.forEach(({local:d,operation:S})=>{d&&S===4&&this._removeFromDisabledExtensions(d.identifier)})))}async enableExtension(E,v){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:v}),!0):!1}async disableExtension(E,v){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:v}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){const v=this.getDisabledExtensions();return v.every(y=>!(0,A.areSameExtensions)(y,E))?(v.push(E),this._setDisabledExtensions(v),!0):!1}_removeFromDisabledExtensions(E){const v=this.getDisabledExtensions();for(let y=0;y<v.length;y++){const d=v[y];if((0,A.areSameExtensions)(d,E))return v.splice(y,1),this._setDisabledExtensions(v),!0}return!1}_setDisabledExtensions(E){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,v){this.storageManger.set(E,v,0)}};C=ge([K(0,b.IStorageService),K(1,L.IExtensionManagementService)],C),e.GlobalExtensionEnablementService=C;class R extends i.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(v=>this.onDidStorageChange(v)))}get(E,v){let y;return v===0?((0,k.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,v)),y=this.storage[E]):y=this._get(E,v),JSON.parse(y)}set(E,v,y){const d=JSON.stringify(v.map(({id:w,uuid:p})=>({id:w,uuid:p})));this._get(E,y)!==d&&(y===0&&(v.length?this.storage[E]=d:delete this.storage[E]),this._set(E,v.length?d:void 0,y))}onDidStorageChange(E){if(E.scope===0&&!(0,k.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const y=this.get(E.key,E.scope);delete this.storage[E.key];const d=this.get(E.key,E.scope),S=y.filter(p=>!d.some(m=>(0,A.areSameExtensions)(p,m))),w=d.filter(p=>!y.some(m=>(0,A.areSameExtensions)(m,p)));(S.length||w.length)&&this._onDidChange.fire([...S,...w])}}_get(E,v){return this.storageService.get(E,v,"[]")}_set(E,v,y){v?this.storageService.store(E,v,y,1):this.storageService.remove(E,y)}}e.StorageManager=R}),define(ne[252],re([0,1,18,21,9,4,36,14,7,19,15,28,32,65,13,8,24,46,219,23,22]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p,m,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const h=L.isWeb?"web":(0,E.getTargetPlatform)(L.platform,A.arch);var r;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function n(...O){return String(O.reduce((M,q)=>M|q,0))}var t;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class l{constructor(M=o){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(M,q=this.state.pageSize){return new l({...this.state,pageNumber:M,pageSize:q})}withFilter(M,...q){const j=[...this.state.criteria,...q.length?q.map(Z=>({filterType:M,value:Z})):[{filterType:M}]];return new l({...this.state,criteria:j})}withSortBy(M){return new l({...this.state,sortBy:M})}withSortOrder(M){return new l({...this.state,sortOrder:M})}withFlags(...M){return new l({...this.state,flags:M.reduce((q,j)=>q|j,0)})}withAssetTypes(...M){return new l({...this.state,assetTypes:M})}withSource(M){return new l({...this.state,source:M})}get raw(){const{criteria:M,pageNumber:q,pageSize:j,sortBy:Z,sortOrder:G,flags:te,assetTypes:se}=this.state;return{filters:[{criteria:M,pageNumber:q,pageSize:j,sortBy:Z,sortOrder:G}],assetTypes:se,flags:te}}get searchText(){const M=this.state.criteria.filter(q=>q.filterType===t.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function f(O,M){const q=(O||[]).filter(j=>j.statisticName===M)[0];return q?q.value:0}function P(O){const M="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(j=>j.assetType.indexOf(M)===0).reduce((j,Z)=>{const G=F(O,Z.assetType);return G&&j.push([Z.assetType.substring(M.length),G]),j},[])}function U(O){if(O.properties){const M=O.properties.filter(Z=>Z.key===s.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=M.filter(Z=>q.test(Z.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return F(O,s.Repository)}function _(O){return{uri:`${O.fallbackAssetUri}/${s.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${s.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function F(O,M){return O.files.filter(j=>j.assetType===M)[0]?{uri:`${O.assetUri}/${M}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${M}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function T(O,M){const q=O.properties?O.properties.filter(Z=>Z.key===M):[],j=q.length>0&&q[0].value;return j?j.split(",").map(Z=>(0,v.adoptToGalleryExtensionId)(Z)):[]}function N(O){const M=O.properties?O.properties.filter(q=>q.key===a.Engine):[];return M.length>0&&M[0].value||""}function z(O){const M=O.properties?O.properties.filter(q=>q.key===a.PreRelease):[];return M.length>0&&M[0].value==="true"}function V(O){const M=O.properties?O.properties.filter(j=>j.key===a.LocalizedLanguages):[],q=M.length>0&&M[0].value||"";return q?q.split(","):[]}function J(O){return O.properties?.find(M=>M.key===a.SponsorLink)?.value}function $(O){return O.indexOf("preview")!==-1}function Q(O){return O.targetPlatform?(0,E.toTargetPlatform)(O.targetPlatform):"undefined"}function H(O){const M=(0,D.distinct)(O.versions.map(Q)),q=!!O.tags?.includes(E.WEB_EXTENSION_TAG),j=M.indexOf("web");return q?j===-1&&M.push("web"):j!==-1&&M.splice(j,1),M}function B(O,M){const q=(0,E.getFallbackTargetPlarforms)(M);for(let j=0;j<O.length;j++){const Z=O[j];if(Z.version===O[j-1]?.version){let G=j;const te=Q(Z);if(te===M)for(;G>0&&O[G-1].version===Z.version;)G--;else if(q.includes(te))for(;G>0&&O[G-1].version===Z.version&&Q(O[G-1])!==M;)G--;G!==j&&(O.splice(j,1),O.splice(G,0,Z))}}return O}e.sortExtensionVersions=B;function Y(O,M,q){O.telemetryData={index:M,querySource:q}}function ie(O,M,q){const j=O.versions[0],Z={manifest:F(M,s.Manifest),readme:F(M,s.Details),changelog:F(M,s.Changelog),license:F(M,s.License),repository:U(M),download:_(M),icon:F(M,s.Icon),coreTranslations:P(M)};return{identifier:{id:(0,v.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:M.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(j),description:O.shortDescription||"",installCount:f(O.statistics,"install"),rating:f(O.statistics,"averagerating"),ratingCount:f(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:q,assets:Z,properties:{dependencies:T(M,a.Dependency),extensionPack:T(M,a.ExtensionPack),engine:N(M),localizedLanguages:V(M),targetPlatform:Q(M),isPreReleaseVersion:z(M)},hasPreReleaseVersion:z(j),hasReleaseVersion:!0,preview:$(O.flags)}}let ae=class{constructor(M,q,j,Z,G,te,se,ce){this.requestService=q,this.logService=j,this.environmentService=Z,this.telemetryService=G,this.fileService=te,this.productService=se,this.configurationService=ce;const he=se.extensionsGallery;this.extensionsGalleryUrl=he&&he.serviceUrl,this.extensionsControlUrl=he&&he.controlUrl,this.commonHeadersPromise=(0,m.resolveMarketplaceHeaders)(se.version,se,this.environmentService,this.configurationService,this.fileService,M,this.telemetryService)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,q,j){const Z=i.CancellationToken.isCancellationToken(q)?{}:q,G=i.CancellationToken.isCancellationToken(q)?q:j,te=[],se=[],ce=[],he=[];let ve=!0;for(const be of M){be.uuid?se.push(be.uuid):te.push(be.id);const Pe=!!(be.version||be.preRelease);ce.push({id:be.id,uuid:be.uuid,includePreRelease:Pe}),be.version&&he.push({id:be.id,uuid:be.uuid,version:be.version}),ve=ve&&!!be.hasPreRelease&&!Pe}if(!se.length&&!te.length)return[];let pe=new l().withPage(1,M.length);se.length&&(pe=pe.withFilter(t.ExtensionId,...se)),te.length&&(pe=pe.withFilter(t.ExtensionName,...te)),(Z.queryAllVersions||ve)&&(pe=pe.withFlags(pe.flags,r.IncludeVersions)),Z.source&&(pe=pe.withSource(Z.source));const{extensions:Ce}=await this.queryGalleryExtensions(pe,{targetPlatform:Z.targetPlatform??h,includePreRelease:ce,versions:he,compatible:!!Z.compatible},G);return Z.source&&Ce.forEach((be,Pe)=>Y(be,Pe,Z.source)),Ce}async getCompatibleExtension(M,q,j){if((0,E.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(M,q,j))return M;const Z=new l().withFlags(r.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,M.identifier.uuid),{extensions:G}=await this.queryGalleryExtensions(Z,{targetPlatform:j,compatible:!0,includePreRelease:q},i.CancellationToken.None);return G[0]||null}async isExtensionCompatible(M,q,j){if(!(0,E.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,j)||!q&&M.properties.isPreReleaseVersion)return!1;let Z=M.properties.engine;if(!Z){const G=await this.getManifest(M,i.CancellationToken.None);if(!G)throw new Error("Manifest was not found");Z=G.engines.vscode}return(0,y.isEngineValid)(Z,this.productService.version,this.productService.date)}async isValidVersion(M,q,j,Z,G){if(!(0,E.isTargetPlatformCompatible)(Q(M),Z,G)||q!=="any"&&z(M)!==(q==="prerelease"))return!1;if(j)try{const te=await this.getEngine(M);if(!(0,y.isEngineValid)(te,this.productService.version,this.productService.date))return!1}catch(te){return this.logService.error(`Error while getting the engine for the version ${M.version}.`,(0,k.getErrorMessage)(te)),!1}return!0}async query(M,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=M.text||"";const Z=M.pageSize??50;let G=new l().withPage(1,Z);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,pe,Ce)=>(G=G.withFilter(t.Category,Ce||pe),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,pe,Ce)=>(G=G.withFilter(t.Tag,Ce||pe),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(t.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),G=G.withFilter(t.SearchText,j)),G=G.withSortBy(0)):M.ids?G=G.withFilter(t.ExtensionId,...M.ids):M.names?G=G.withFilter(t.ExtensionName,...M.names):G=G.withSortBy(4),typeof M.sortBy=="number"&&(G=G.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(G=G.withSortOrder(M.sortOrder)),M.source&&(G=G.withSource(M.source));const te=async(ve,pe)=>{const{extensions:Ce,total:be}=await this.queryGalleryExtensions(ve,{targetPlatform:h,compatible:!1,includePreRelease:!!M.includePreRelease},pe);return Ce.forEach((Pe,Me)=>Y(Pe,(ve.pageNumber-1)*ve.pageSize+Me,M.source)),{extensions:Ce,total:be}},{extensions:se,total:ce}=await te(G,q),he=async(ve,pe)=>{if(pe.isCancellationRequested)throw new k.CancellationError;const{extensions:Ce}=await te(G.withPage(ve+1),pe);return Ce};return{firstPage:se,total:ce,pageSize:G.pageSize,getPage:he}}async queryGalleryExtensions(M,q,j){const Z=M.flags;!!(M.flags&r.IncludeLatestVersionOnly)&&!!(M.flags&r.IncludeVersions)&&(M=M.withFlags(M.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(M.flags&r.IncludeLatestVersionOnly)&&!(M.flags&r.IncludeVersions)&&(M=M.withFlags(M.flags,r.IncludeLatestVersionOnly)),q.versions?.length&&(M=M.withFlags(M.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),M=M.withFlags(M.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:G,total:te}=await this.queryRawGalleryExtensions(M,j);if(!(M.flags&r.IncludeLatestVersionOnly)){const ve=[];for(const pe of G){const Ce=await this.toGalleryExtensionWithCriteria(pe,q);Ce&&ve.push(Ce)}return{extensions:ve,total:te}}const ce=[],he=new Map;for(let ve=0;ve<G.length;ve++){const pe=G[ve],Ce={id:(0,v.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},be=(0,b.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(Me=>(0,v.areSameExtensions)(Me,Ce))?.includePreRelease;if(q.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(H(pe),q.targetPlatform))continue;const Pe=await this.toGalleryExtensionWithCriteria(pe,q);!Pe||Pe.properties.isPreReleaseVersion&&(!be||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==q.targetPlatform&&Pe.hasPreReleaseVersion?he.set(pe.extensionId,ve):ce.push([ve,Pe])}if(he.size){const ve=new Date().getTime(),pe=new l().withFlags(Z&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,he.size).withFilter(t.ExtensionId,...he.keys()),{extensions:Ce}=await this.queryGalleryExtensions(pe,q,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ve,count:he.size});for(const be of Ce){const Pe=he.get(be.identifier.uuid);ce.push([Pe,be])}}return{extensions:ce.sort((ve,pe)=>ve[0]-pe[0]).map(([,ve])=>ve),total:te}}async toGalleryExtensionWithCriteria(M,q){const j={id:(0,v.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},Z=q.versions?.find(ce=>(0,v.areSameExtensions)(ce,j))?.version,G=(0,b.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(ce=>(0,v.areSameExtensions)(ce,j))?.includePreRelease,te=H(M),se=B(M.versions,q.targetPlatform);if(q.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(te,q.targetPlatform))return null;for(let ce=0;ce<se.length;ce++){const he=se[ce];if(!(Z&&he.version!==Z)){if(await this.isValidVersion(he,G?"any":"release",q.compatible,te,q.targetPlatform))return ie(M,he,te);if(Z&&he.version===Z)return null}}return Z||q.compatible?null:ie(M,M.versions[0],te)}async queryRawGalleryExtensions(M,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,r.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,n(r.Unpublished));const j=await this.commonHeadersPromise,Z=JSON.stringify(M.raw),G={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},te=new Date().getTime();let se,ce,he=0;try{if(se=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:G},q),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:he};const ve=await(0,p.asJson)(se);if(ve){const pe=ve.results[0],Ce=pe.extensions,be=pe.resultMetadata&&pe.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return he=be&&be.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:Ce,total:he}}return{galleryExtensions:[],total:he}}catch(ve){throw ce=ve,ve}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-te,success:!!se&&(0,p.isSuccess)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:ce?(0,k.isCancellationError)(ce)?"canceled":(0,k.getErrorMessage)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(M,q,j,Z){if(!this.isEnabled())return;const G=L.isWeb?this.api(`/itemName/${M}.${q}/version/${j}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${M}/extensions/${q}/${j}/stats?statType=${Z}`),te=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.commonHeadersPromise,Accept:te};try{await this.requestService.request({type:"POST",url:G,headers:ce},i.CancellationToken.None)}catch{}}async download(M,q,j){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const Z=(0,v.getGalleryExtensionTelemetryData)(M),G=new Date().getTime(),te=ve=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Z,duration:ve}),se=j===2?"install":j===3?"update":"",ce=se?{uri:`${M.assets.download.uri}${C.URI.parse(M.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${M.assets.download.fallbackUri}${C.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:M.assets.download,he=await this.getAsset(ce);await this.fileService.writeFile(q,he.stream),te(new Date().getTime()-G)}async getReadme(M,q){if(M.assets.readme){const j=await this.getAsset(M.assets.readme,{},q);return await(0,p.asTextOrError)(j)||""}return""}async getManifest(M,q){if(M.assets.manifest){const j=await this.getAsset(M.assets.manifest,{},q),Z=await(0,p.asTextOrError)(j);return Z?JSON.parse(Z):null}return null}async getManifestFromRawExtensionVersion(M,q){const j=F(M,s.Manifest);if(!j)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},G=await this.getAsset(j,{headers:Z});return await(0,p.asJson)(G)}async getCoreTranslation(M,q){const j=M.assets.coreTranslations.filter(Z=>Z[0]===q.toUpperCase())[0];if(j){const Z=await this.getAsset(j[1]),G=await(0,p.asTextOrError)(Z);return G?JSON.parse(G):null}return null}async getChangelog(M,q){if(M.assets.changelog){const j=await this.getAsset(M.assets.changelog,{},q);return await(0,p.asTextOrError)(j)||""}return""}async getAllCompatibleVersions(M,q,j){let Z=new l().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?Z=Z.withFilter(t.ExtensionId,M.identifier.uuid):Z=Z.withFilter(t.ExtensionName,M.identifier.id);const{galleryExtensions:G}=await this.queryRawGalleryExtensions(Z,i.CancellationToken.None);if(!G.length)return[];const te=H(G[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(te,j))return[];const se=[];await Promise.all(G[0].versions.map(async ve=>{try{await this.isValidVersion(ve,q?"any":"release",!0,te,j)&&se.push(ve)}catch{}}));const ce=[],he=new Set;for(const ve of B(se,j))he.has(ve.version)||(he.add(ve.version),ce.push({version:ve.version,date:ve.lastUpdated,isPreReleaseVersion:z(ve)}));return ce}async getAsset(M,q={},j=i.CancellationToken.None){const Z=await this.commonHeadersPromise,G={type:"GET"},te={...Z,...q.headers||{}};q={...q,...G,headers:te};const se=M.uri,ce=M.fallbackUri,he={...q,url:se};try{const ve=await this.requestService.request(he,j);if(ve.res.statusCode===200)return ve;const pe=await(0,p.asTextOrError)(ve);throw new Error(`Expected 200, got back ${ve.res.statusCode} instead.

${pe}`)}catch(ve){if((0,k.isCancellationError)(ve))throw ve;const pe=(0,k.getErrorMessage)(ve);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:se,message:pe});const Ce={...q,url:ce};return this.requestService.request(Ce,j)}}async getEngine(M){let q=N(M);if(!q){const j=await this.getManifestFromRawExtensionVersion(M,i.CancellationToken.None);if(!j)throw new Error("Manifest was not found");q=j.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,p.asJson)(M),j=[],Z={};if(q){for(const G of q.malicious)j.push({id:G});if(q.migrateToPreRelease)for(const[G,te]of Object.entries(q.migrateToPreRelease))(!te.engine||(0,y.isEngineValid)(te.engine,this.productService.version,this.productService.date))&&(Z[G.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[G,te]of Object.entries(q.deprecated))te&&(Z[G.toLowerCase()]=(0,b.isBoolean)(te)?{}:te)}return{malicious:j,deprecated:Z}}};ae=ge([K(1,p.IRequestService),K(2,S.ILogService),K(3,I.IEnvironmentService),K(4,g.ITelemetryService),K(5,d.IFileService),K(6,w.IProductService),K(7,R.IConfigurationService)],ae);let W=class extends ae{constructor(M,q,j,Z,G,te,se,ce){super(M,q,j,Z,G,te,se,ce)}};W=ge([K(0,u.IStorageService),K(1,p.IRequestService),K(2,S.ILogService),K(3,I.IEnvironmentService),K(4,g.ITelemetryService),K(5,d.IFileService),K(6,w.IProductService),K(7,R.IConfigurationService)],W),e.ExtensionGalleryService=W;let x=class extends ae{constructor(M,q,j,Z,G,te,se){super(void 0,M,q,j,Z,G,te,se)}};x=ge([K(0,p.IRequestService),K(1,S.ILogService),K(2,I.IEnvironmentService),K(3,g.ITelemetryService),K(4,d.IFileService),K(5,w.IProductService),K(6,R.IConfigurationService)],x),e.ExtensionGalleryServiceWithNoStorageService=x}),define(ne[72],re([0,1,5,3,2,23,32,24,18,8,14]),function(X,e,D,i,k,L,A,b,C,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let v=class Qe extends k.Disposable{constructor(d,S,w){super();this.storageService=d,this.productService=S,this.logService=w,this._onDidChangeExtensionStorageToSync=this._register(new i.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Qe.readAllExtensionsWithKeysForSync(d),this._register(this.storageService.onDidChangeValue(p=>this.onDidChangeStorageValue(p)))}static toKey(d){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const S=E.exec(d);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(d,S){const w=await d.getInstalled(),p=[];for(const[m,u]of Qe.readAllExtensionsWithKeysForSync(S)){const g=w.find(h=>(0,A.areSameExtensions)(h.identifier,{id:m}))?.manifest.version;for(const h of u)g!==h&&p.push(Qe.toKey({id:m,version:h}))}for(const m of p)S.remove(m,0)}static readAllExtensionsWithKeysForSync(d){const S=new Map,w=d.keys(0,1);for(const p of w){const m=Qe.fromKey(p);if(m){let u=S.get(m.id.toLowerCase());u||S.set(m.id.toLowerCase(),u=[]),u.push(m.version)}}return S}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const S=Qe.fromKey(d.key);if(S){if(this.storageService.get(d.key,0)===void 0)this.extensionsWithKeysForSync.delete(S.id.toLowerCase());else{let w=this.extensionsWithKeysForSync.get(S.id.toLowerCase());w||this.extensionsWithKeysForSync.set(S.id.toLowerCase(),w=[]),w.push(S.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(d){if((0,I.isString)(d))return d;const S=d.manifest?d.manifest.publisher:d.publisher,w=d.manifest?d.manifest.name:d.name;return(0,A.getExtensionId)(S,w)}getExtensionState(d,S){const w=this.getExtensionId(d),p=this.storageService.get(w,S?0:1);if(p)try{return JSON.parse(p)}catch(m){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${S}): ${m}`)}}setExtensionState(d,S,w){const p=this.getExtensionId(d);S===void 0?this.storageService.remove(p,w?0:1):this.storageService.store(p,JSON.stringify(S),w?0:1,1)}setKeysForSync(d,S){this.storageService.store(Qe.toKey(d),JSON.stringify(S),0,1)}getKeysForSync(d){const S=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],w=this.storageService.get(Qe.toKey(d),0),p=w?JSON.parse(w):void 0;return p&&S?(0,C.distinct)([...p,...S]):p||S}addToMigrationList(d,S){if(d!==S){const w=this.migrationList.filter(p=>!p.includes(d)&&!p.includes(S));w.push([d,S]),this.migrationList=w}}getSourceExtensionToMigrate(d){const S=this.migrationList.find(([,w])=>d===w);return S?S[0]:void 0}get migrationList(){const d=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const S=JSON.parse(d);if((0,I.isArray)(S))return S}catch{}return[]}set migrationList(d){d.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(d),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};v=ge([K(0,L.IStorageService),K(1,b.IProductService),K(2,R.ILogService)],v),e.ExtensionStorageService=v}),define(ne[253],re([0,1,18,6,3,12,4,36,7,144,15,28,32,209,91,13,8,67,24,46,23,22]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p,m,u,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",n="extensionTips/lastPromptedMediumImpExeTime";let t=class extends y.ExtensionTipsService{constructor(a,c,o,l,f,P,U,_,F,T){super(U,_,F,T);this.environmentService=a,this.telemetryService=c,this.extensionManagementService=o,this.storageService=l,this.nativeHostService=f,this.extensionRecommendationNotificationService=P,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&Object.entries(_.exeBasedExtensionTips).forEach(([N,z])=>{const V=[],J=[],$=[];Object.entries(z.recommendations).forEach(([Q,H])=>{H.important?z.important?V.push({extensionId:Q,extensionName:H.name,isExtensionPack:!!H.isExtensionPack}):J.push({extensionId:Q,extensionName:H.name,isExtensionPack:!!H.isExtensionPack}):$.push({extensionId:Q,extensionName:H.name,isExtensionPack:!!H.isExtensionPack})}),V.length&&this.highImportanceExecutableTips.set(N,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:V}),J.length&&this.mediumImportanceExecutableTips.set(N,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:J}),$.length&&this.allOtherExecutableTips.set(N,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:$})}),(0,i.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...a,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),o=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(a,o),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,o)}groupImportantTipsByExe(a,c){const o=new Map;a.forEach(_=>o.set(_.extensionId.toLowerCase(),_));const{installed:l,uninstalled:f}=this.groupByInstalled([...o.keys()],c);for(const _ of l){const F=o.get(_);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:F.exeName})}for(const _ of f){const F=o.get(_);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:F.exeName})}const P=this.getPromptedExecutableTips(),U=new Map;for(const _ of f){const F=o.get(_);if(F&&(!P[F.exeName]||!P[F.exeName].includes(F.extensionId))){let T=U.get(F.exeName);T||(T=[],U.set(F.exeName,T)),T.push(F)}}return U}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[a,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(o=>{switch(o){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(a);break;case"incompatibleWindow":{const l=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(l(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const l=this._register((0,i.disposableTimeout)(()=>{l.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const a=this.getLastPromptedMediumExeTime(),c=Date.now()-a,o=7*24*60*60*1e3;if(c<o){const P=this._register((0,i.disposableTimeout)(()=>{P.dispose(),this.promptMediumImportanceExeBasedTip()},o-c));return}const[l,f]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(f).then(P=>{switch(P){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(l),this.addToRecommendedExecutables(f[0].exeName,f);const U=this._register((0,i.disposableTimeout)(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},o));break}case"ignored":this.mediumImportanceTipsByExe.delete(l),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const U=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(U(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const U=this._register((0,i.disposableTimeout)(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(a){const c=await this.extensionManagementService.getInstalled(1),o=a.filter(f=>!f.whenNotInstalled||f.whenNotInstalled.every(P=>c.every(U=>!(0,v.areSameExtensions)(U.identifier,{id:P})))).map(({extensionId:f})=>f.toLowerCase()),l=(0,R.localize)(0,null,a[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,l,`@exe:"${a[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let a=this.storageService.getNumber(n,-1);return a||(a=Date.now(),this.updateLastPromptedMediumExeTime(a)),a}updateLastPromptedMediumExeTime(a){this.storageService.store(n,a,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,-1,"{}"))}addToRecommendedExecutables(a,c){const o=this.getPromptedExecutableTips();o[a]=c.map(({extensionId:l})=>l.toLowerCase()),this.storageService.store(r,JSON.stringify(o),-1,0)}groupByInstalled(a,c){const o=[],l=[],f=c.reduce((P,U)=>(P.add(U.identifier.id.toLowerCase()),P),new Set);return a.forEach(P=>{f.has(P.toLowerCase())?o.push(P):l.push(P)}),{installed:o,uninstalled:l}}async getValidExecutableBasedExtensionTips(a){const c=[],o=new Map;for(const l of a.keys()){const f=a.get(l);if(!f||!(0,D.isNonEmptyArray)(f.recommendations))continue;const P=[];A.isWindows?f.windowsPath&&P.push(f.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(P.push((0,L.join)("/usr/local/bin",l)),P.push((0,L.join)("/usr/bin",l)),P.push((0,L.join)(this.environmentService.userHome.fsPath,l)));for(const U of P){let _=o.get(U);if(_===void 0&&(_=await this.fileService.exists(C.URI.file(U)),o.set(U,_)),_)for(const{extensionId:F,extensionName:T,isExtensionPack:N,whenNotInstalled:z}of f.recommendations)c.push({extensionId:F,extensionName:T,isExtensionPack:N,exeName:l,exeFriendlyName:f.exeFriendlyName,windowsPath:f.windowsPath,whenNotInstalled:z})}}return c}};t=ge([K(0,I.INativeEnvironmentService),K(1,h.ITelemetryService),K(2,E.IExtensionManagementService),K(3,g.IStorageService),K(4,p.INativeHostService),K(5,d.IExtensionRecommendationNotificationService),K(6,S.IFileService),K(7,m.IProductService),K(8,u.IRequestService),K(9,w.ILogService)],t),e.ExtensionTipsService=t}),define(ne[254],re([0,1,6,2,17,85,23,217]),function(X,e,D,i,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class C extends A.AbstractStorageService{constructor(I,E,v,y){super();this.initialWorkspace=I,this.initialProfiles=E,this.mainProcessService=v,this.environmentService=y,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new i.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new i.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const I=this._register(new b.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),E=this._register(new L.Storage(I));return this._register(E.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v))),E}createProfileStorage(I){this.profileStorageDisposables.clear(),this.profileStorageProfile=I;let E;if((0,A.isProfileUsingDefaultStorage)(I))E=this.applicationStorage;else{const v=this.profileStorageDisposables.add(new b.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),I));E=this.profileStorageDisposables.add(new L.Storage(v))}return this.profileStorageDisposables.add(E.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),E}createWorkspaceStorage(I){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=I?.id;let E;if(I){const v=this.workspaceStorageDisposables.add(new b.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),I));E=this.workspaceStorageDisposables.add(new L.Storage(v)),this.workspaceStorageDisposables.add(E.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)))}return E}async doInitialize(){await D.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(I){switch(I){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(I){switch(I){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(I,E){if(!this.canSwitchProfile(this.profileStorageProfile,I))return;const v=this.profileStorage,y=v.items;v!==this.applicationStorage&&await v.close(),this.profileStorage=this.createProfileStorage(I),await this.profileStorage.init(),this.switchData(y,this.profileStorage,0,E)}async switchToWorkspace(I,E){const v=this.workspaceStorage,y=v?.items??new Map;await v?.close(),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init(),this.switchData(y,this.workspaceStorage,1,E)}}e.NativeStorageService=C}),define(ne[255],re([0,1,3,2,17,15,94,29]),function(X,e,D,i,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let C=class extends i.Disposable{constructor(I,E,v){super();this._profiles=[],this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.channel=E.getChannel("userDataProfiles"),this.profilesHome=(0,k.joinPath)(v.userRoamingDataHome,"profiles"),this._profiles=I.map(y=>(0,b.reviveProfile)(y,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(y=>{const d=y.added.map(p=>(0,b.reviveProfile)(p,this.profilesHome.scheme)),S=y.removed.map(p=>(0,b.reviveProfile)(p,this.profilesHome.scheme)),w=y.updated.map(p=>(0,b.reviveProfile)(p,this.profilesHome.scheme));this._profiles=y.all.map(p=>(0,b.reviveProfile)(p,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:d,removed:S,updated:w,all:this.profiles})}))}get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}async createProfile(I,E,v){const y=await this.channel.call("createProfile",[I,E,v]);return(0,b.reviveProfile)(y,this.profilesHome.scheme)}async setProfileForWorkspace(I,E){await this.channel.call("setProfileForWorkspace",[I,E])}removeProfile(I){return this.channel.call("removeProfile",[I])}async updateProfile(I,E,v){const y=await this.channel.call("updateProfile",[I,E,v]);return(0,b.reviveProfile)(y,this.profilesHome.scheme)}getProfile(I){throw new Error("Not implemented")}};C=ge([K(1,A.IMainProcessService),K(2,L.IEnvironmentService)],C),e.UserDataProfilesNativeService=C}),define(ne[47],re([0,1,18,6,16,21,3,35,2,26,14,7,159,19,15,13,8,49,23,22,33,25,29]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p,m,u,g,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function n(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=n;let t=class extends C.Disposable{constructor(l,f,P,U,_,F,T,N,z,V,J){super();this.resource=l,this.fileService=f,this.environmentService=P,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=F,this.userDataSyncEnablementService=T,this.telemetryService=N,this.logService=z,this.configurationService=V,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new i.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,R.uppercaseFirstLetter)(this.resource),this.extUri=J.extUri,this.syncFolder=this.extUri.joinPath(P.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,h.PREVIEW_DIR_NAME),this.lastSyncResource=(0,h.getLastSyncResourceUri)(l,P,this.extUri),this.currentMachineIdPromise=(0,p.getServiceMachineId)(P,f,U)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const f=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(f)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?await this.hasRemoteChanged(l):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){this._status!==l&&(this._status=l,this._onDidChangStatus.fire(l))}async sync(l,f={}){await this._sync(l,!0,this.getUserDataSyncConfiguration(),f)}async preview(l,f,P={}){return this._sync(l,!1,f,P)}async apply(l,f={}){try{this.syncHeaders={...f};const P=await this.doApply(l);return this.setStatus(P),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,f,P,U){try{if(this.syncHeaders={...U},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const F=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(l,F);return _=await this.performSync(T,F,f,P),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(l){const f=await this.resolveContent(l);if(!f)return!1;const P=this.parseSyncData(f);if(!P)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const U=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,U),F=await this.isRemoteDataFromCurrentMachine(_),T=await this.generateSyncPreview({ref:_.ref,syncData:P},U,F,this.getUserDataSyncConfiguration(),L.CancellationToken.None),N=[];for(const z of T){const V=await this.getAcceptResult(z,z.remoteResource,void 0,L.CancellationToken.None),{remoteChange:J}=await this.getAcceptResult(z,z.previewResource,z.remoteContent,L.CancellationToken.None);N.push([z,{...V,remoteChange:J!==0?J:2}])}await this.applyResult(_,U,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const f=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===f}async getLatestRemoteUserData(l,f){if(f){const P=l&&l.latest?l.latest[this.resource]:void 0;if(f.ref===P||P===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async performSync(l,f,P,U){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new h.UserDataSyncError((0,v.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,f,P,U)}catch(_){if(_ instanceof h.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,f,P,U);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.performSync(l,f,P,U)}throw _}}async doSync(l,f,P,U){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,i.createCancelablePromise)(F=>this.doGenerateSyncResourcePreview(l,f,P,U,F)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:F})=>F==="conflict")?"hasConflicts":P?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(l){return await this.updateSyncResourcePreview(l,async f=>{const P=await this.getMergeResult(f,L.CancellationToken.None);await this.fileService.writeFile(f.previewResource,k.VSBuffer.fromString(P?.content||""));const U=P&&!P.hasConflicts?await this.getAcceptResult(f,f.previewResource,void 0,L.CancellationToken.None):void 0;return f.acceptResult=U,f.mergeState=P.hasConflicts?"conflict":U?"accepted":"preview",f.localChange=U?U.localChange:P.localChange,f.remoteChange=U?U.remoteChange:P.remoteChange,f}),this.syncPreviewPromise}async accept(l,f){return await this.updateSyncResourcePreview(l,async P=>{const U=await this.getAcceptResult(P,l,f,L.CancellationToken.None);return P.acceptResult=U,P.mergeState="accepted",P.localChange=U.localChange,P.remoteChange=U.remoteChange,P}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async f=>{const P=await this.getMergeResult(f,L.CancellationToken.None);return await this.fileService.writeFile(f.previewResource,k.VSBuffer.fromString(P.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=P.localChange,f.remoteChange=P.remoteChange,f}),this.syncPreviewPromise}async updateSyncResourcePreview(l,f){if(!this.syncPreviewPromise)return;let P=await this.syncPreviewPromise;const U=P.resourcePreviews.findIndex(({localResource:_,remoteResource:F,previewResource:T})=>this.extUri.isEqual(_,l)||this.extUri.isEqual(F,l)||this.extUri.isEqual(T,l));U!==-1&&(this.syncPreviewPromise=(0,i.createCancelablePromise)(async _=>{const F=[...P.resourcePreviews];return F[U]=await f(F[U]),{...P,resourcePreviews:F}}),P=await this.syncPreviewPromise,this.updateConflicts(P.resourcePreviews),P.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const f=await this.syncPreviewPromise;return f.resourcePreviews.some(({mergeState:P})=>P==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:P})=>P!=="accepted")?"syncing":(await this.applyResult(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(P=>[P,P.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(l){const f=l.filter(({mergeState:P})=>P==="conflict");(0,D.equals)(this._conflicts,f,(P,U)=>this.extUri.isEqual(P.previewResource,U.previewResource))||(this._conflicts=f,this._onDidChangeConflicts.fire(f))}async hasPreviouslySynced(){const l=await this.getLastSyncUserData();return!!l&&l.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:f,ref:P})=>({created:f,uri:this.toRemoteBackupResource(P)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:f,ref:P})=>({created:f,uri:this.toLocalBackupResource(P)}))}toRemoteBackupResource(l){return E.URI.from({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return E.URI.from({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const f=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(f))){const{content:P}=await this.getUserData(f);if(P)return this.parseSyncData(P)?.machineId}}async resolveContent(l){const f=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(f))){const{content:P}=await this.getUserData(f);return P}return this.extUri.isEqual(l,this.toLocalBackupResource(f))?this.userDataSyncBackupStoreService.resolveContent(this.resource,f):null}async resolvePreviewContent(l){const f=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(f)for(const P of f.resourcePreviews){if(this.extUri.isEqual(P.acceptedResource,l))return P.acceptResult?P.acceptResult.content:null;if(this.extUri.isEqual(P.remoteResource,l))return P.remoteContent;if(this.extUri.isEqual(P.localResource,l))return P.localContent;if(this.extUri.isEqual(P.baseResource,l))return P.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(l,f,P,U,_){const F=await this.isRemoteDataFromCurrentMachine(l),T=await this.generateSyncPreview(l,f,F,U,_),N=[];for(const z of T){const V=z.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)N.push({...z,acceptedResource:V,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=P?await this.getMergeResult(z,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(z.previewResource,k.VSBuffer.fromString(J?.content||""));const $=J&&!J.hasConflicts?await this.getAcceptResult(z,z.previewResource,void 0,_):void 0;N.push({...z,acceptResult:$,mergeState:J?.hasConflicts?"conflict":$?"accepted":"preview",localChange:$?$.localChange:J?J.localChange:z.localChange,remoteChange:$?$.remoteChange:J?J.remoteChange:z.remoteChange})}}return{remoteUserData:l,lastSyncUserData:f,resourcePreviews:N,isLastSyncFromCurrentMachine:F}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),f=JSON.parse(l.value.toString()),P=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=f.version&&P&&f.version!==P,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${P}.`),await this.resetLocal(),null;const U=f;if(U.content===null)return{ref:f.ref,syncData:null};const _=JSON.parse(U.content);if(n(_))return{...f,syncData:_,content:void 0}}catch(l){l instanceof S.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,f={}){if(f.ref||f.content||f.version)throw new Error("Cannot have core properties as additional");const P=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),U={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:P,...f};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(U)))}async getRemoteUserData(l){const{ref:f,content:P}=await this.getUserData(l);let U=null;return P!==null&&(U=this.parseSyncData(P)),{ref:f,syncData:U}}parseSyncData(l){try{const f=JSON.parse(l);if(n(f))return f}catch(f){this.logService.error(f)}throw new h.UserDataSyncError((0,v.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,I.isString)(l)){const f=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:f}}else{const f=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,f,this.syncHeaders)}}async updateRemoteUserData(l,f){const P=await this.currentMachineIdPromise,U={version:this.version,machineId:P,content:l};return f=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(U),f,this.syncHeaders),{ref:f,syncData:U}}async backupLocal(l){const f={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(f))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=ge([K(1,S.IFileService),K(2,d.IEnvironmentService),K(3,m.IStorageService),K(4,h.IUserDataSyncStoreService),K(5,h.IUserDataSyncBackupStoreService),K(6,h.IUserDataSyncEnablementService),K(7,u.ITelemetryService),K(8,h.IUserDataSyncLogService),K(9,y.IConfigurationService),K(10,g.IUriIdentityService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(l,f,P,U,_,F,T,N,z,V,J,$){super(f,P,U,_,F,T,N,z,V,J,$);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(Q=>this.onFileChanges(Q)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(l,f,P){try{f?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(l),P?void 0:f):await this.fileService.createFile(this.file,k.VSBuffer.fromString(l),{overwrite:P})}catch(U){throw U instanceof S.FileOperationError&&U.fileOperationResult===1||U instanceof S.FileOperationError&&U.fileOperationResult===3?new h.UserDataSyncError(U.message,"LocalPreconditionFailed"):U}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};s=ge([K(2,S.IFileService),K(3,d.IEnvironmentService),K(4,m.IStorageService),K(5,h.IUserDataSyncStoreService),K(6,h.IUserDataSyncBackupStoreService),K(7,h.IUserDataSyncEnablementService),K(8,u.ITelemetryService),K(9,h.IUserDataSyncLogService),K(10,y.IConfigurationService),K(11,g.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let a=class extends s{constructor(l,f,P,U,_,F,T,N,z,V,J,$,Q){super(l,f,P,U,_,F,T,N,z,V,$,Q);this.userDataSyncUtilService=J,this._formattingOptions=void 0}hasErrors(l,f){const P=[],U=(0,b.parse)(l,P,{allowEmptyContent:!0,allowTrailingComma:!0});return P.length>0||!(0,I.isUndefined)(U)&&f!==Array.isArray(U)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};a=ge([K(2,S.IFileService),K(3,d.IEnvironmentService),K(4,m.IStorageService),K(5,h.IUserDataSyncStoreService),K(6,h.IUserDataSyncBackupStoreService),K(7,h.IUserDataSyncEnablementService),K(8,u.ITelemetryService),K(9,h.IUserDataSyncLogService),K(10,h.IUserDataSyncUtilService),K(11,y.IConfigurationService),K(12,g.IUriIdentityService)],a),e.AbstractJsonFileSynchroniser=a;let c=class{constructor(l,f,P,U,_,F){this.resource=l,this.userDataProfilesService=f,this.environmentService=P,this.logService=U,this.fileService=_,this.extUri=F.extUri,this.lastSyncResource=(0,h.getLastSyncResourceUri)(this.resource,P,this.extUri)}async initialize({ref:l,content:f}){if(!f){this.logService.info("Remote content does not exist.",this.resource);return}const P=this.parseSyncData(f);if(!!P)try{await this.doInitialize({ref:l,syncData:P})}catch(U){this.logService.error(U)}}parseSyncData(l){try{const f=JSON.parse(l);if(n(f))return f}catch(f){this.logService.error(f)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,f={}){const P={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...f};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(P)))}};c=ge([K(1,r.IUserDataProfilesService),K(2,d.IEnvironmentService),K(3,w.ILogService),K(4,S.IFileService),K(5,g.IUriIdentityService)],c),e.AbstractInitializer=c}),define(ne[256],re([0,1,6,21,9,3,53,26,7,19,15,28,32,72,13,8,23,22,33,29,47,236,107,25]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p,m,u,g,h,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(c,o){const l=JSON.parse(c.content);if(c.version===1||c.version===2){const f=(await o.getInstalled(0)).filter(P=>P.isBuiltin);for(const P of l)c.version===1&&(P.enabled===!1&&(P.disabled=!0),delete P.enabled),c.version===2&&f.every(U=>!(0,v.areSameExtensions)(U.identifier,P.identifier))&&(P.installed=!0)}return l}let s=class mt extends g.AbstractSynchroniser{constructor(o,l,f,P,U,_,F,T,N,z,V,J,$,Q,H){super("extensions",l,o,f,P,U,J,$,N,V,H);this.extensionManagementService=_,this.extensionEnablementService=F,this.ignoredExtensionsManagementService=T,this.extensionGalleryService=z,this.extensionStorageService=Q,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,B=>B.some(({local:Y})=>!!Y)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,B=>!B.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(o,l){const f=o.syncData?await t(o.syncData,this.extensionManagementService):null,P=l?.skippedExtensions||[],U=l?.syncData?await t(l.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0),F=this.getLocalExtensions(_),T=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);f?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:N,remote:z}=(0,h.merge)(F,f,U,P,T),V={local:N,remote:z,content:this.getPreviewContent(F,N.added,N.updated,N.removed),localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:z!==null?2:0},J=this.stringify(F,!1);return[{skippedExtensions:P,baseResource:this.baseResource,baseContent:U?this.stringify(U,!1):J,localResource:this.localResource,localContent:J,localExtensions:F,remoteResource:this.remoteResource,remoteContent:f?this.stringify(f,!1):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const l=o.syncData?await t(o.syncData,this.extensionManagementService):null,f=await this.extensionManagementService.getInstalled(void 0),P=this.getLocalExtensions(f),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),{remote:_}=(0,h.merge)(P,l,l,o.skippedExtensions||[],U);return _!==null}getPreviewContent(o,l,f,P){const U=[...l,...f],_=new Set,F=T=>{_.add(T.id.toLowerCase()),T.uuid&&_.add(T.uuid)};U.forEach(({identifier:T})=>F(T)),P.forEach(F);for(const T of o)_.has(T.identifier.id.toLowerCase())||T.identifier.uuid&&_.has(T.identifier.uuid)||U.push(T);return this.stringify(U,!1)}async getMergeResult(o,l){return{...o.previewResult,hasConflicts:!1}}async getAcceptResult(o,l,f,P){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(o);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(o);if(this.extUri.isEqual(l,this.previewResource))return o.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(o){const l=await this.extensionManagementService.getInstalled(),f=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),P=(0,h.merge)(o.localExtensions,null,null,o.skippedExtensions,f),{local:U,remote:_}=P;return{content:o.localContent,local:U,remote:_,localChange:U.added.length>0||U.removed.length>0||U.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(o){const l=await this.extensionManagementService.getInstalled(),f=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),P=o.remoteContent?JSON.parse(o.remoteContent):null;if(P!==null){const U=(0,h.merge)(o.localExtensions,P,o.localExtensions,[],f),{local:_,remote:F}=U;return{content:o.remoteContent,local:_,remote:F,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:o.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(o,l,f,P){let{skippedExtensions:U,localExtensions:_}=f[0][0];const{local:F,remote:T,localChange:N,remoteChange:z}=f[0][1];if(N===0&&z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),N!==0&&(await this.backupLocal(JSON.stringify(_)),U=await this.updateLocalExtensions(F.added,F.removed,F.updated,U)),T){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const V=JSON.stringify(T.all);o=await this.updateRemoteUserData(V,P?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${T.added.length?` Added: ${JSON.stringify(T.added.map(J=>J.identifier.id))}.`:""}${T.updated.length?` Updated: ${JSON.stringify(T.updated.map(J=>J.identifier.id))}.`:""}${T.removed.length?` Removed: ${JSON.stringify(T.removed.map(J=>J.identifier.id))}.`:""}`)}l?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(o,{skippedExtensions:U}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${U.length?` Skipped: ${JSON.stringify(U.map(V=>V.identifier.id))}.`:""}`))}async getAssociatedResources({uri:o}){return[{resource:this.extUri.joinPath(o,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(o){if(this.extUri.isEqual(o,mt.EXTENSIONS_DATA_URI)){const f=await this.extensionManagementService.getInstalled(),P=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),U=this.getLocalExtensions(f).filter(_=>!P.some(F=>(0,v.areSameExtensions)({id:F},_.identifier)));return this.stringify(U,!0)}if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)){const f=await this.resolvePreviewContent(o);return f&&this.stringify(JSON.parse(f),!0)}let l=await super.resolveContent(o);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(o)),l){const f=this.parseSyncData(l);if(f)switch(this.extUri.basename(o)){case"extensions.json":return this.stringify(this.parseExtensions(f),!0)}}return null}stringify(o,l){return o.sort((f,P)=>!f.identifier.uuid&&P.identifier.uuid?-1:f.identifier.uuid&&!P.identifier.uuid?1:(0,b.compare)(f.identifier.id,P.identifier.id)),l?(0,A.toFormattedString)(o,{}):JSON.stringify(o)}async hasLocalData(){try{const o=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(o).some(f=>f.installed||f.disabled))return!0}catch{}return!1}async updateLocalExtensions(o,l,f,P){const U=[],_=[],F=await this.extensionManagementService.getInstalled();if(l.length){const N=F.filter(({identifier:z,isBuiltin:V})=>!V&&l.some(J=>(0,v.areSameExtensions)(z,J)));await D.Promises.settled(N.map(async z=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,z.identifier.id),await this.extensionManagementService.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,z.identifier.id),U.push(z.identifier)}))}(o.length||f.length)&&await D.Promises.settled([...o,...f].map(async N=>{const z=F.find(J=>(0,v.areSameExtensions)(J.identifier,N.identifier));if(z&&z.isBuiltin){N.state&&z.manifest.version===N.version&&this.updateExtensionState(N.state,z,z.manifest.version),this.extensionEnablementService.getDisabledExtensions().some($=>(0,v.areSameExtensions)($,N.identifier))!==!!N.disabled&&(N.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,N.identifier.id),await this.extensionEnablementService.disableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,N.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,N.identifier.id),await this.extensionEnablementService.enableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,N.identifier.id))),U.push(N.identifier);return}const V=(await this.extensionGalleryService.getExtensions([{...N.identifier,preRelease:N.preRelease}],i.CancellationToken.None))[0];if(N.state&&(z?z.manifest.version===N.version:!!V)&&this.updateExtensionState(N.state,z||V,z?.manifest.version),V)try{this.extensionEnablementService.getDisabledExtensions().some($=>(0,v.areSameExtensions)($,N.identifier))!==!!N.disabled&&(N.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,N.identifier.id,V.version),await this.extensionEnablementService.disableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,N.identifier.id,V.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,N.identifier.id,V.version),await this.extensionEnablementService.enableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,N.identifier.id,V.version))),(!z||z.preRelease!==N.preRelease)&&(await this.extensionManagementService.canInstall(V)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,N.identifier.id,V.version),await this.extensionManagementService.installFromGallery(V,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:N.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,N.identifier.id,V.version),U.push(V.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,V.displayName||V.identifier.id),_.push(N)))}catch(J){_.push(N),J instanceof E.ExtensionManagementError&&[E.ExtensionManagementErrorCode.Incompatible,E.ExtensionManagementErrorCode.IncompatiblePreRelease,E.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(J.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,V.displayName||V.identifier.id):(this.logService.error(J),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,V.displayName||V.identifier.id))}else _.push(N),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,N.identifier.id)}));const T=[];for(const N of P)U.some(z=>(0,v.areSameExtensions)(z,N.identifier))||T.push(N);for(const N of _)T.some(z=>(0,v.areSameExtensions)(z.identifier,N.identifier))||T.push(N);return T}updateExtensionState(o,l,f){const P=this.extensionStorageService.getExtensionState(l,!0)||{},U=f?this.extensionStorageService.getKeysForSync({id:l.identifier.id,version:f}):void 0;U?U.forEach(_=>{P[_]=o[_]}):Object.keys(o).forEach(_=>P[_]=o[_]),this.extensionStorageService.setExtensionState(l,P,!0)}parseExtensions(o){return JSON.parse(o.content)}getLocalExtensions(o){const l=this.extensionEnablementService.getDisabledExtensions();return o.map(f=>{const{identifier:P,isBuiltin:U,manifest:_,preRelease:F}=f,T={identifier:P,preRelease:F,version:_.version};l.some(N=>(0,v.areSameExtensions)(N,P))&&(T.disabled=!0),U||(T.installed=!0);try{const N=this.extensionStorageService.getKeysForSync({id:P.id,version:_.version});if(N){const z=this.extensionStorageService.getExtensionState(f,!0)||{};T.state=Object.keys(z).reduce((V,J)=>(N.includes(J)&&(V[J]=z[J]),V),{})}}catch(N){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,k.getErrorMessage)(N))}return T})}};s.EXTENSIONS_DATA_URI=C.URI.from({scheme:n.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),s=ge([K(0,I.IEnvironmentService),K(1,d.IFileService),K(2,w.IStorageService),K(3,n.IUserDataSyncStoreService),K(4,n.IUserDataSyncBackupStoreService),K(5,E.IExtensionManagementService),K(6,E.IGlobalExtensionEnablementService),K(7,r.IIgnoredExtensionsManagementService),K(8,n.IUserDataSyncLogService),K(9,E.IExtensionGalleryService),K(10,R.IConfigurationService),K(11,n.IUserDataSyncEnablementService),K(12,p.ITelemetryService),K(13,y.IExtensionStorageService),K(14,m.IUriIdentityService)],s),e.ExtensionsSynchroniser=s;let a=class extends g.AbstractInitializer{constructor(o,l,f,P,U,_,F){super("extensions",P,U,_,f,F);this.extensionManagementService=o,this.ignoredExtensionsManagementService=l}async parseExtensions(o){return o.syncData?await t(o.syncData,this.extensionManagementService):null}generatePreview(o,l){const f=[],P=[],U=[];for(const _ of o){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const F=l.find(T=>(0,v.areSameExtensions)(T.identifier,_.identifier));F?(f.push(F),_.disabled&&U.push(_.identifier)):_.installed&&(P.push({..._.identifier,preRelease:!!_.preRelease}),_.disabled&&U.push(_.identifier))}return{installedExtensions:f,newExtensions:P,disabledExtensions:U,remoteExtensions:o}}};a=ge([K(0,E.IExtensionManagementService),K(1,r.IIgnoredExtensionsManagementService),K(2,d.IFileService),K(3,u.IUserDataProfilesService),K(4,I.IEnvironmentService),K(5,S.ILogService),K(6,m.IUriIdentityService)],a),e.AbstractExtensionsInitializer=a}),define(ne[257],re([0,1,16,9,3,35,53,4,7,31,19,15,13,8,49,23,22,33,47,59,239,25,29]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p,m,u,g,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const n="globalState.argv.",t=["locale"];function s(f,P){const U=f.storage?Object.keys(f.storage).sort():[],_={};return U.forEach(F=>_[F]=f.storage[F]),f.storage=_,P?(0,A.toFormattedString)(f,{}):JSON.stringify(f)}const a=1;let c=class vt extends m.AbstractSynchroniser{constructor(P,U,_,F,T,N,z,V,J,$){super("globalState",P,T,J,U,_,N,z,F,V,$);this.storageService=J,this.version=a,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(P.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(P.onDidFilesChange,Q=>Q.contains(this.environmentService.argvResource)),k.Event.filter(J.onDidChangeValue,Q=>Q.scope===0&&Q.target!==void 0?Q.target===0:J.keys(0,0).includes(Q.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(P,U,_){const F=P.syncData?JSON.parse(P.syncData.content):null;U=U===null&&_?P:U;const T=U&&U.syncData?JSON.parse(U.syncData.content):null,N=await this.getLocalGlobalState();F?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const z=this.getStorageKeys(T),{local:V,remote:J}=(0,g.merge)(N.storage,F?F.storage:null,T?T.storage:null,z,this.logService),$={content:null,local:V,remote:J,localChange:Object.keys(V.added).length>0||Object.keys(V.updated).length>0||V.removed.length>0?2:0,remoteChange:J!==null?2:0},Q=s(N,!1);return[{baseResource:this.baseResource,baseContent:T?s(T,!1):Q,localResource:this.localResource,localContent:Q,localUserData:N,remoteResource:this.remoteResource,remoteContent:F?s(F,!1):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource,storageKeys:z}]}async hasRemoteChanged(P){const U=P.syncData?JSON.parse(P.syncData.content):null;if(U===null)return!0;const _=await this.getLocalGlobalState(),F=this.getStorageKeys(U),{remote:T}=(0,g.merge)(_.storage,U.storage,U.storage,F,this.logService);return T!==null}async getMergeResult(P,U){return{...P.previewResult,hasConflicts:!1}}async getAcceptResult(P,U,_,F){if(this.extUri.isEqual(U,this.localResource))return this.acceptLocal(P);if(this.extUri.isEqual(U,this.remoteResource))return this.acceptRemote(P);if(this.extUri.isEqual(U,this.previewResource))return P.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async acceptLocal(P){return{content:P.localContent,local:{added:{},removed:[],updated:{}},remote:P.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(P){if(P.remoteContent!==null){const U=JSON.parse(P.remoteContent),{local:_,remote:F}=(0,g.merge)(P.localUserData.storage,U.storage,null,P.storageKeys,this.logService);return{content:P.remoteContent,local:_,remote:F,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:P.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(P,U,_,F){const{localUserData:T}=_[0][0],{local:N,remote:z,localChange:V,remoteChange:J}=_[0][1];if(V===0&&J===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),V!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(T)),await this.writeLocalGlobalState(N),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),J!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const $=JSON.stringify({storage:z});P=await this.updateRemoteUserData($,F?null:P.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}U?.ref!==P.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(P),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:P}){return[{resource:this.extUri.joinPath(P,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(P){if(this.extUri.isEqual(P,vt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return s(_,!0)}if(this.extUri.isEqual(this.remoteResource,P)||this.extUri.isEqual(this.baseResource,P)||this.extUri.isEqual(this.localResource,P)||this.extUri.isEqual(this.acceptedResource,P)){const _=await this.resolvePreviewContent(P);return _&&s(JSON.parse(_),!0)}let U=await super.resolveContent(P);if(U)return U;if(U=await super.resolveContent(this.extUri.dirname(P)),U){const _=this.parseSyncData(U);if(_)switch(this.extUri.basename(P)){case"globalState.json":return s(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:P}=await this.getLocalGlobalState();if(Object.keys(P).length>1||P[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const P={},U=await this.getLocalArgvContent(),_=(0,L.parse)(U);for(const F of t)_[F]!==void 0&&(P[`${n}${F}`]={version:1,value:_[F]});for(const F of this.storageService.keys(0,0)){const T=this.storageService.get(F,0);T&&(P[F]={version:1,value:T})}return{storage:P}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const P=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),P.value.toString()}catch(P){this.logService.debug((0,i.getErrorMessage)(P))}return"{}"}async writeLocalGlobalState({added:P,removed:U,updated:_}){const F={},T={},N=(V,J)=>{for(const $ of V){if($.startsWith(n)){F[$.substring(n.length)]=J?J[$].value:void 0;continue}if(J){const Q=J[$];Q.value!==String(this.storageService.get($,0))&&(T[$]=Q.value)}else this.storageService.get($,0)!==void 0&&(T[$]=void 0)}};if(N(Object.keys(P),P),N(Object.keys(_),_),N(U),Object.keys(F).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(F),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(T).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const V of Object.keys(T))this.storageService.store(V,T[V],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(T))}}async updateArgv(P){const U=await this.getLocalArgvContent();let _=U;for(const F of Object.keys(P))_=(0,u.edit)(_,[F],P[F],{});U!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(P){const U=this.storageService.keys(0,0),_=this.storageService.keys(0,1),F=[...U,..._],T=P?.storage?Object.keys(P.storage).filter(N=>!N.startsWith(n)&&!F.includes(N)&&this.storageService.get(N,0)!==void 0):[];if(!b.isWeb){const N=[...h.ALL_SYNC_RESOURCES.map(z=>(0,h.getEnablementKey)(z)),h.SYNC_SERVICE_URL_TYPE];T.push(...N),_.push(...N)}return{user:U,machine:_,unregistered:T}}};c.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:h.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),c=ge([K(0,v.IFileService),K(1,h.IUserDataSyncStoreService),K(2,h.IUserDataSyncBackupStoreService),K(3,h.IUserDataSyncLogService),K(4,E.IEnvironmentService),K(5,h.IUserDataSyncEnablementService),K(6,w.ITelemetryService),K(7,I.IConfigurationService),K(8,S.IStorageService),K(9,p.IUriIdentityService)],c),e.GlobalStateSynchroniser=c;let o=class extends m.AbstractInitializer{constructor(P,U,_,F,T,N){super("globalState",_,F,T,U,N);this.storageService=P}async doInitialize(P){const U=P.syncData?JSON.parse(P.syncData.content):null;if(!U){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},F={};for(const T of Object.keys(U.storage))T.startsWith(n)?_[T.substring(n.length)]=U.storage[T].value:this.storageService.get(T,0)===void 0&&(F[T]=U.storage[T].value);if(Object.keys(_).length){let T="{}";try{T=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const N of Object.keys(_))T=(0,u.edit)(T,[N],_[N],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(T))}if(Object.keys(F).length)for(const T of Object.keys(F))this.storageService.store(T,F[T],0,0)}};o=ge([K(0,S.IStorageService),K(1,v.IFileService),K(2,r.IUserDataProfilesService),K(3,E.IEnvironmentService),K(4,h.IUserDataSyncLogService),K(5,p.IUriIdentityService)],o),e.GlobalStateInitializer=o;let l=class{constructor(P,U,_,F,T){this.userDataSyncStoreClient=P,this.storageService=U,this.environmentService=_,this.fileService=F,this.logService=T}getSyncStoreType(P){return this.parseGlobalState(P)?.storage[h.SYNC_SERVICE_URL_TYPE]?.value}async sync(P){const U=(0,h.createSyncHeaders)((0,R.generateUuid)());try{return await this.doSync(P,U)}catch(_){if(_ instanceof h.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(P,U)}throw _}}async doSync(P,U){const _=await this.userDataSyncStoreClient.read("globalState",null,U),F=this.parseGlobalState(_)||{storage:{}};F.storage[h.SYNC_SERVICE_URL_TYPE]={value:P,version:a};const T=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),N={version:a,machineId:T,content:s(F,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(N),_.ref,U)}parseGlobalState({content:P}){if(!P)return null;const U=JSON.parse(P);if((0,m.isSyncData)(U))return U?JSON.parse(U.content):null;throw new Error("Invalid remote data")}};l=ge([K(1,S.IStorageService),K(2,E.IEnvironmentService),K(3,v.IFileService),K(4,y.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(ne[258],re([0,1,18,16,3,35,4,14,160,19,15,13,23,22,33,29,47,237,25]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function u(r,n,t){try{const s=JSON.parse(r);if(!n)return(0,b.isUndefined)(s.all)?null:s.all;switch(A.OS){case 2:return(0,b.isUndefined)(s.mac)?null:s.mac;case 3:return(0,b.isUndefined)(s.linux)?null:s.linux;case 1:return(0,b.isUndefined)(s.windows)?null:s.windows}}catch(s){return t.error(s),null}}e.getKeybindingsContentFromSyncContent=u;let g=class extends w.AbstractJsonFileSynchroniser{constructor(n,t,s,a,c,o,l,f,P,U,_,F){super(l.defaultProfile.keybindingsResource,"keybindings",o,f,P,n,t,c,_,s,U,a,F);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.filter(a.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(n,t,s,a){const c=n.syncData?u(n.syncData.content,a.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&s?n:t;const o=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),f=await this.getFormattingOptions();let P=null,U=!1,_=!1,F=!1;if(c){let z=l?l.value.toString():"[]";if(z=z||"[]",this.hasErrors(z,!0))throw new m.UserDataSyncError((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==z||o!==c){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const V=await(0,p.merge)(z,c,o,f,this.userDataSyncUtilService);V.hasChanges&&(P=V.mergeContent,F=V.hasConflicts,U=F||V.mergeContent!==z,_=F||V.mergeContent!==c)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),P=l.value.toString(),_=!0);const T={content:P,localChange:U?l?2:1:0,remoteChange:_?2:0,hasConflicts:F},N=l?l.value.toString():null;return[{fileContent:l,baseResource:this.baseResource,baseContent:o!==null?o:N,localResource:this.localResource,localContent:N,localChange:T.localChange,remoteResource:this.remoteResource,remoteContent:c,remoteChange:T.remoteChange,previewResource:this.previewResource,previewResult:T,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(n){const t=this.getKeybindingsContentFromLastSyncUserData(n);if(t===null)return!0;const s=await this.getLocalFileContent(),a=s?s.value.toString():"",c=await this.getFormattingOptions(),o=await(0,p.merge)(a||"[]",t,t,c,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==t}async getMergeResult(n,t){return n.previewResult}async getAcceptResult(n,t,s,a){if(this.extUri.isEqual(t,this.localResource))return{content:n.fileContent?n.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:n.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(n,t,s,a){const{fileContent:c}=s[0][0];let{content:o,localChange:l,remoteChange:f}=s[0][1];if(l===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o,!0)))throw new m.UserDataSyncError((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),c&&await this.backupLocal(this.toSyncContent(c.value.toString())),await this.updateLocalFileContent(o||"[]",c,a),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),f!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const P=this.toSyncContent(o||"[]",n.syncData?.content);n=await this.updateRemoteUserData(P,a?null:n.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==n.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(n,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const n=await this.getLocalFileContent();if(n){const t=(0,L.parse)(n.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(n){if(n.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:n}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(n,"keybindings.json"),comparableResource:t}]}async resolveContent(n){if(this.extUri.isEqual(this.remoteResource,n)||this.extUri.isEqual(this.baseResource,n)||this.extUri.isEqual(this.localResource,n)||this.extUri.isEqual(this.acceptedResource,n))return this.resolvePreviewContent(n);let t=await super.resolveContent(n);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(n)),t){const s=this.parseSyncData(t);if(s)switch(this.extUri.basename(n)){case"keybindings.json":return u(s.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(n){return!n.syncData||n.platformSpecific!==void 0&&n.platformSpecific!==this.syncKeybindingsPerPlatform()?null:u(n.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(n,t){let s={};try{s=JSON.parse(t||"{}")}catch(a){this.logService.error(a)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=n,A.OS){case 2:s.mac=n;break;case 3:s.linux=n;break;case 1:s.windows=n;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};g=ge([K(0,m.IUserDataSyncStoreService),K(1,m.IUserDataSyncBackupStoreService),K(2,m.IUserDataSyncLogService),K(3,R.IConfigurationService),K(4,m.IUserDataSyncEnablementService),K(5,E.IFileService),K(6,S.IUserDataProfilesService),K(7,I.IEnvironmentService),K(8,v.IStorageService),K(9,m.IUserDataSyncUtilService),K(10,y.ITelemetryService),K(11,d.IUriIdentityService)],g),e.KeybindingsSynchroniser=g;let h=class extends w.AbstractInitializer{constructor(n,t,s,a,c){super("keybindings",t,s,a,n,c)}async doInitialize(n){const t=n.syncData?this.getKeybindingsContentFromSyncContent(n.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,i.VSBuffer.fromString(t)),await this.updateLastSyncUserData(n)}async isEmpty(){try{const n=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,L.parse)(n.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(n){return n.fileOperationResult===1}}getKeybindingsContentFromSyncContent(n){try{return u(n,!0,this.logService)}catch(t){return this.logService.error(t),null}}};h=ge([K(0,E.IFileService),K(1,S.IUserDataProfilesService),K(2,I.IEnvironmentService),K(3,m.IUserDataSyncLogService),K(4,d.IUriIdentityService)],h),e.KeybindingsInitializer=h}),define(ne[259],re([0,1,16,3,161,19,68,15,28,13,23,22,33,29,47,59,240,25]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(r){return r&&r.settings&&typeof r.settings=="string"&&Object.keys(r).length===1}function u(r){const n=JSON.parse(r);return m(n)?n:{settings:r}}e.parseSettingsSyncContent=u;let g=class extends d.AbstractJsonFileSynchroniser{constructor(n,t,s,a,c,o,l,f,P,U,_,F,T){super(t.defaultProfile.settingsResource,"settings",n,s,a,c,o,U,_,l,f,P,T);this.extensionManagementService=F,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(n){const t=await this.getLastSyncUserData(),s=await this.getLatestRemoteUserData(n,t),a=this.getSettingsSyncContent(s),c=new A.ConfigurationModelParser(p.USER_DATA_SYNC_CONFIGURATION_SCOPE);return a?.settings&&c.parse(a.settings),c.configurationModel.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(n,t,s){const a=await this.getLocalFileContent(),c=await this.getFormattingOptions(),o=this.getSettingsSyncContent(n);t=t===null&&s?n:t;const l=t?this.getSettingsSyncContent(t):null,f=await this.getIgnoredSettings();let P=null,U=!1,_=!1,F=!1;if(o){let z=a?a.value.toString().trim():"{}";z=z||"{}",this.validateContent(z),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const V=(0,w.merge)(z,o.settings,l?l.settings:null,f,[],c);P=V.localContent||V.remoteContent,U=V.localContent!==null,_=V.remoteContent!==null,F=V.hasConflicts}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),P=a.value.toString().trim()||"{}",this.validateContent(P),_=!0);const T={content:P,localChange:U?2:0,remoteChange:_?2:0,hasConflicts:F},N=a?a.value.toString():null;return[{fileContent:a,baseResource:this.baseResource,baseContent:l?l.settings:N,localResource:this.localResource,localContent:N,localChange:T.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:T.remoteChange,previewResource:this.previewResource,previewResult:T,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(n){const t=this.getSettingsSyncContent(n);if(t===null)return!0;const s=await this.getLocalFileContent(),a=s?s.value.toString().trim():"",c=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,w.merge)(a||"{}",t.settings,t.settings,c,[],o).remoteContent!==null}async getMergeResult(n,t){const s=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return{...n.previewResult,content:n.previewResult.content?(0,w.updateIgnoredSettings)(n.previewResult.content,"{}",a,s):null}}async getAcceptResult(n,t,s,a){const c=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:n.fileContent?(0,w.updateIgnoredSettings)(n.fileContent.value.toString(),"{}",o,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:n.remoteContent!==null?(0,w.updateIgnoredSettings)(n.remoteContent,n.fileContent?n.fileContent.value.toString():"{}",o,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:s!==null?(0,w.updateIgnoredSettings)(s,n.fileContent?n.fileContent.value.toString():"{}",o,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(n,t,s,a){const{fileContent:c}=s[0][0];let{content:o,localChange:l,remoteChange:f}=s[0][1];if(l===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(o,c,a),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),f!==0){const P=await this.getFormattingOptions(),U=this.getSettingsSyncContent(n),_=await this.getIgnoredSettings(o);o=(0,w.updateIgnoredSettings)(o,U?U.settings:"{}",_,P),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),n=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),a?null:n.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==n.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(n),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const n=await this.getLocalFileContent();if(n){const t=await this.getFormattingOptions(),s=(0,S.edit)(n.value.toString(),[p.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,w.isEmpty)(s)}}catch(n){if(n.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:n}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(n,"settings.json"),comparableResource:t}]}async resolveContent(n){if(this.extUri.isEqual(this.remoteResource,n)||this.extUri.isEqual(this.localResource,n)||this.extUri.isEqual(this.acceptedResource,n)||this.extUri.isEqual(this.baseResource,n))return this.resolvePreviewContent(n);let t=await super.resolveContent(n);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(n)),t){const s=this.parseSyncData(t);if(s){const a=this.parseSettingsSyncContent(s.content);if(a)switch(this.extUri.basename(n)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(n){let t=await super.resolvePreviewContent(n);if(t){const s=await this.getFormattingOptions(),a=await this.getIgnoredSettings();t=(0,w.updateIgnoredSettings)(t,"{}",a,s)}return t}getSettingsSyncContent(n){return n.syncData?this.parseSettingsSyncContent(n.syncData.content):null}parseSettingsSyncContent(n){try{return u(n)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(n){return{settings:n}}async getIgnoredSettings(n){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const s=i.Event.any(i.Event.filter(this.extensionManagementService.onDidInstallExtensions,a=>a.some(({local:c})=>!!c)),i.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{s.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,w.getIgnoredSettings)(t,this.configurationService,n)}validateContent(n){if(this.hasErrors(n,!1))throw new p.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}};g=ge([K(0,R.IFileService),K(1,y.IUserDataProfilesService),K(2,b.IEnvironmentService),K(3,I.IStorageService),K(4,p.IUserDataSyncStoreService),K(5,p.IUserDataSyncBackupStoreService),K(6,p.IUserDataSyncLogService),K(7,p.IUserDataSyncUtilService),K(8,L.IConfigurationService),K(9,p.IUserDataSyncEnablementService),K(10,E.ITelemetryService),K(11,C.IExtensionManagementService),K(12,v.IUriIdentityService)],g),e.SettingsSynchroniser=g;let h=class extends d.AbstractInitializer{constructor(n,t,s,a,c){super("settings",t,s,a,n,c)}async doInitialize(n){const t=n.syncData?this.parseSettingsSyncContent(n.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,D.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(n)}async isEmpty(){try{const n=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,w.isEmpty)(n.value.toString().trim())}catch(n){return n.fileOperationResult===1}}parseSettingsSyncContent(n){try{return u(n)}catch(t){this.logService.error(t)}return null}};h=ge([K(0,R.IFileService),K(1,y.IUserDataProfilesService),K(2,b.IEnvironmentService),K(3,p.IUserDataSyncLogService),K(4,v.IUriIdentityService)],h),e.SettingsInitializer=h}),define(ne[260],re([0,1,16,3,30,19,15,13,23,22,33,29,47,238,25]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let S=class extends v.AbstractSynchroniser{constructor(m,u,g,h,r,n,t,s,a,c,o){super("snippets",u,m,h,r,n,a,c,t,s,o);this.version=1,this.snippetsFolder=g.defaultProfile.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(i.Event.filter(this.fileService.onDidFilesChange,l=>l.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,u,g){const h=await this.getSnippetsFileContents(),r=this.toSnippetsContents(h),n=m.syncData?this.parseSnippets(m.syncData):null;u=u===null&&g?m:u;const t=u&&u.syncData?this.parseSnippets(u.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,y.merge)(r,n,t);return this.getResourcePreviews(s,h,n||{},t||{})}async hasRemoteChanged(m){const u=m.syncData?this.parseSnippets(m.syncData):null;if(u===null)return!0;const g=await this.getSnippetsFileContents(),h=this.toSnippetsContents(g),r=(0,y.merge)(h,u,u);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async getMergeResult(m,u){return m.previewResult}async getAcceptResult(m,u,g,h){if(this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(u,this.syncPreviewFolder))return g===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:g,localChange:g===null?m.fileContent!==null?3:0:2,remoteChange:g===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async applyResult(m,u,g,h){const r=g.map(([n,t])=>({...n,acceptResult:t}));r.every(({localChange:n,remoteChange:t})=>n===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),r.some(({localChange:n})=>n!==0)&&(await this.updateLocalBackup(r),await this.updateLocalSnippets(r,h)),r.some(({remoteChange:n})=>n!==0)&&(m=await this.updateRemoteSnippets(r,m,h)),u?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of r)try{await this.fileService.del(n)}catch{}}getResourcePreviews(m,u,g,h){const r=new Map;for(const n of Object.keys(m.local.added)){const t={content:m.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(m.local.updated)){const t={content:m.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},s=u[n]?u[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:h[n]??s,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[n],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of m.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=u[n]?u[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:h[n]??s,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[n],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(m.remote.added)){const t={content:m.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},s=u[n]?u[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:h[n]??s,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[n],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(m.remote.updated)){const t={content:m.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},s=u[n]?u[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:h[n]??s,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[n],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of m.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:h[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of m.conflicts){const t={content:u[n]?u[n].value.toString():null,hasConflicts:!0,localChange:u[n]?2:1,remoteChange:g[n]?2:1},s=u[n]?u[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:h[n]??s,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[n]||null,localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(u))if(!r.has(n)){const t={content:u[n]?u[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=u[n]?u[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:h[n]??s,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[n]||null,localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async getAssociatedResources({uri:m}){const u=await super.resolveContent(m);if(u){const g=this.parseSyncData(u);if(g){const h=this.parseSnippets(g),r=[];for(const n of Object.keys(h)){const t=this.extUri.joinPath(m,n),s=this.extUri.joinPath(this.snippetsFolder,n),a=await this.fileService.exists(s);r.push({resource:t,comparableResource:a?s:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})})}return r}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let u=await super.resolveContent(m);if(u)return u;if(u=await super.resolveContent(this.extUri.dirname(m)),u){const g=this.parseSyncData(u);if(g)return this.parseSnippets(g)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch{}return!1}async updateLocalBackup(m){const u={};for(const g of m)g.fileContent&&(u[this.extUri.basename(g.localResource)]=g.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(u)))}async updateLocalSnippets(m,u){for(const{fileContent:g,acceptResult:h,localResource:r,remoteResource:n,localChange:t}of m)if(t!==0){const s=n?this.extUri.basename(n):this.extUri.basename(r),a=this.extUri.joinPath(this.snippetsFolder,s);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(a)),await this.fileService.del(a),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(a))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(a)),await this.fileService.createFile(a,D.VSBuffer.fromString(h.content),{overwrite:u}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(a))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(a)),await this.fileService.writeFile(a,D.VSBuffer.fromString(h.content),u?void 0:g),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(a)))}}async updateRemoteSnippets(m,u,g){const h=u.syncData?this.parseSnippets(u.syncData):{},r=(0,k.deepClone)(h);for(const{acceptResult:n,localResource:t,remoteResource:s,remoteChange:a}of m)if(a!==0){const c=t?this.extUri.basename(t):this.extUri.basename(s);a===3?delete r[c]:r[c]=n.content}return(0,y.areSame)(h,r)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),u=await this.updateRemoteUserData(JSON.stringify(r),g?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),u}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const u={};for(const g of Object.keys(m))u[g]=m[g].value.toString();return u}async getSnippetsFileContents(){const m={};let u;try{u=await this.fileService.resolve(this.snippetsFolder)}catch(g){if(g instanceof b.FileOperationError&&g.fileOperationResult===1)return m;throw g}for(const g of u.children||[]){const h=g.resource,r=this.extUri.extname(h);if(r===".json"||r===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,h),t=await this.fileService.readFile(h);m[n]=t}}return m}};S=ge([K(0,A.IEnvironmentService),K(1,b.IFileService),K(2,E.IUserDataProfilesService),K(3,C.IStorageService),K(4,d.IUserDataSyncStoreService),K(5,d.IUserDataSyncBackupStoreService),K(6,d.IUserDataSyncLogService),K(7,L.IConfigurationService),K(8,d.IUserDataSyncEnablementService),K(9,R.ITelemetryService),K(10,I.IUriIdentityService)],S),e.SnippetsSynchroniser=S;let w=class extends v.AbstractInitializer{constructor(m,u,g,h,r){super("snippets",u,g,h,m,r)}async doInitialize(m){const u=m.syncData?JSON.parse(m.syncData.content):null;if(!u){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const h of Object.keys(u)){const r=u[h];if(r){const n=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,h);await this.fileService.createFile(n,D.VSBuffer.fromString(r)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};w=ge([K(0,b.IFileService),K(1,E.IUserDataProfilesService),K(2,A.IEnvironmentService),K(3,d.IUserDataSyncLogService),K(4,I.IUriIdentityService)],w),e.SnippetsInitializer=w}),define(ne[261],re([0,1,16,19,15,13,23,22,33,29,47,25]),function(X,e,D,i,k,L,A,b,C,R,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function v(w,p){try{return JSON.parse(w).tasks}catch(m){return p.error(m),null}}e.getTasksContentFromSyncContent=v;let y=class extends I.AbstractFileSynchroniser{constructor(p,m,u,g,h,r,n,t,s,a,c){super(c.defaultProfile.tasksResource,"tasks",r,n,t,p,m,h,s,u,g,a);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(p,m,u,g){const h=p.syncData?v(p.syncData.content,this.logService):null;m=m===null&&u?p:m;const r=m?.syncData?v(m.syncData.content,this.logService):null,n=await this.getLocalFileContent();let t=null,s=!1,a=!1,c=!1;if(h){const f=n?n.value.toString():null;if(!r||r!==f||r!==h){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const P=S(f,h,r);t=P.content,c=P.hasConflicts,s=P.hasLocalChanged,a=P.hasRemoteChanged}}else n&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=n.value.toString(),a=!0);const o={content:t,localChange:s?n?2:1:0,remoteChange:a?2:0,hasConflicts:c},l=n?n.value.toString():null;return[{fileContent:n,baseResource:this.baseResource,baseContent:r!==null?r:l,localResource:this.localResource,localContent:l,localChange:o.localChange,remoteResource:this.remoteResource,remoteContent:h,remoteChange:o.remoteChange,previewResource:this.previewResource,previewResult:o,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(p){const m=p?.syncData?v(p.syncData.content,this.logService):null;if(m===null)return!0;const u=await this.getLocalFileContent(),g=u?u.value.toString():null,h=S(g,m,m);return h.hasLocalChanged||h.hasRemoteChanged}async getMergeResult(p,m){return p.previewResult}async getAcceptResult(p,m,u,g){if(this.extUri.isEqual(m,this.localResource))return{content:p.fileContent?p.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(m,this.remoteResource))return{content:p.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(m,this.previewResource))return u===void 0?{content:p.previewResult.content,localChange:p.previewResult.localChange,remoteChange:p.previewResult.remoteChange}:{content:u,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async applyResult(p,m,u,g){const{fileContent:h}=u[0][0],{content:r,localChange:n,remoteChange:t}=u[0][1];if(n===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),n!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),h&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(h.value.toString()))),await this.updateLocalFileContent(r||"{}",h,g),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const s=JSON.stringify(this.toTasksSyncContent(r||"{}"));p=await this.updateRemoteUserData(s,g?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}m?.ref!==p.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(p),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:p}){const m=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(p,"tasks.json"),comparableResource:m}]}async resolveContent(p){if(this.extUri.isEqual(this.remoteResource,p)||this.extUri.isEqual(this.baseResource,p)||this.extUri.isEqual(this.localResource,p)||this.extUri.isEqual(this.acceptedResource,p))return this.resolvePreviewContent(p);let m=await super.resolveContent(p);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(p)),m){const u=this.parseSyncData(m);if(u)switch(this.extUri.basename(p)){case"tasks.json":return v(u.content,this.logService)}}return null}toTasksSyncContent(p){return{tasks:p}}};y=ge([K(0,E.IUserDataSyncStoreService),K(1,E.IUserDataSyncBackupStoreService),K(2,E.IUserDataSyncLogService),K(3,i.IConfigurationService),K(4,E.IUserDataSyncEnablementService),K(5,L.IFileService),K(6,k.IEnvironmentService),K(7,A.IStorageService),K(8,b.ITelemetryService),K(9,C.IUriIdentityService),K(10,R.IUserDataProfilesService)],y),e.TasksSynchroniser=y;let d=class extends I.AbstractInitializer{constructor(p,m,u,g,h){super("tasks",m,u,g,p,h);this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(p){const m=p.syncData?v(p.syncData.content,this.logService):null;if(!m){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(m)),await this.updateLastSyncUserData(p)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};d=ge([K(0,L.IFileService),K(1,R.IUserDataProfilesService),K(2,k.IEnvironmentService),K(3,E.IUserDataSyncLogService),K(4,C.IUriIdentityService)],d),e.TasksInitializer=d;function S(w,p,m){if(w===null&&p===null&&m===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===p)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const u=m!==w,g=m!==p;return!u&&!g?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:u&&!g?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:g&&!u?{content:p,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[262],re([0,1,3,2,4,15,23,22,25]),function(X,e,D,i,k,L,A,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const R="sync.enable";let I=class extends i.Disposable{constructor(v,y,d,S){super();this.storageService=v,this.telemetryService=y,this.environmentService=d,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(v.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(R,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(v){v&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(R,{enabled:v}),this.storageService.store(R,v,-1,1))}isResourceEnabled(v){return this.storageService.getBoolean((0,C.getEnablementKey)(v),-1,!0)}setResourceEnablement(v,y){if(this.isResourceEnabled(v)!==y){const d=(0,C.getEnablementKey)(v);this.storeResourceEnablement(d,y)}}getResourceSyncStateVersion(v){}storeResourceEnablement(v,y){this.storageService.store(v,y,-1,k.isWeb?0:1)}onDidStorageChange(v){if(v.scope!==-1)return;if(R===v.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const y=C.ALL_SYNC_RESOURCES.filter(d=>(0,C.getEnablementKey)(d)===v.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}};I=ge([K(0,A.IStorageService),K(1,b.ITelemetryService),K(2,L.IEnvironmentService),K(3,C.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(ne[73],re([0,1,3,2,4,26,164,15,13,5,24,49,23,25]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,R.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",S="Safari",w="Chrome",p="Edge",m="Firefox",u="Android";function g(n){switch(n){case S:case w:case p:case m:case u:case(0,k.PlatformToString)(0):return!0}return!1}e.isWebPlatform=g;function h(){return k.isSafari?S:k.isChrome?w:k.isEdge?p:k.isFirefox?m:k.isAndroid?u:(0,k.PlatformToString)(k.isWeb?0:k.platform)}let r=class it extends i.Disposable{constructor(t,s,a,c,o,l){super();this.storageService=a,this.userDataSyncStoreService=c,this.logService=o,this.productService=l,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(t,s,a)}async getMachines(t){const s=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(c=>({...c,isCurrent:c.id===s}))}async addCurrentMachine(t){const s=await this.currentMachineIdPromise,a=await this.readMachinesData(t);a.machines.some(({id:c})=>c===s)||(a.machines.push({id:s,name:this.computeCurrentMachineName(a.machines),platform:h()}),await this.writeMachinesData(a))}async removeCurrentMachine(t){const s=await this.currentMachineIdPromise,a=await this.readMachinesData(t),c=a.machines.filter(({id:o})=>o!==s);c.length!==a.machines.length&&(a.machines=c,await this.writeMachinesData(a))}async renameMachine(t,s,a){const c=await this.readMachinesData(a),o=c.machines.find(({id:l})=>l===t);if(o){o.name=s,await this.writeMachinesData(c);const l=await this.currentMachineIdPromise;t===l&&this.storageService.store(d,s,-1,1)}}async setEnablements(t){const s=await this.readMachinesData();for(const[a,c]of t){const o=s.machines.find(l=>l.id===a);o&&(o.disabled=c?void 0:!0)}await this.writeMachinesData(s)}computeCurrentMachineName(t){const s=this.storageService.get(d,-1);if(s)return s;const a=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${h()} (${this.productService.nameShort})`,c=new RegExp(`${(0,L.escapeRegExpCharacters)(a)}\\s#(\\d+)`);let o=0;for(const l of t){const f=c.exec(l.name),P=f?parseInt(f[1]):0;o=P>o?P:o}return`${a} #${o+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const s=this.parse(this.userData);if(s.version!==it.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return s}async writeMachinesData(t){const s=JSON.stringify(t),a=await this.userDataSyncStoreService.write(it.RESOURCE,s,this.userData?.ref||null);this.userData={ref:a,content:s},this._onDidChange.fire()}async readUserData(t){if(this.userData){const s=t&&t.latest?t.latest[it.RESOURCE]:void 0;if(this.userData.ref===s)return this.userData;if(s===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(it.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.logService.error(s)}return{version:it.VERSION,machines:[]}}};r.VERSION=1,r.RESOURCE="machines",r=ge([K(0,b.IEnvironmentService),K(1,C.IFileService),K(2,v.IStorageService),K(3,y.IUserDataSyncStoreService),K(4,y.IUserDataSyncLogService),K(5,I.IProductService)],r),e.UserDataSyncMachinesService=r}),define(ne[263],re([0,1,6,61,38,9,3,2,4,17,7,162,24,23,22,25,70,73]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const m="sync.disableMachineEventually",u="sync.sessionId",g="sync.storeUrl",h="sync.productQuality";let r=class extends b.Disposable{constructor(s,a,c,o,l,f,P,U,_,F){super();this.userDataSyncStoreManagementService=a,this.userDataSyncStoreService=c,this.userDataSyncEnablementService=o,this.userDataSyncService=l,this.logService=f,this.userDataSyncAccountService=P,this.telemetryService=U,this.userDataSyncMachinesService=_,this.storageService=F,this.autoSync=this._register(new b.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=a.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=s.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(a.onDidChangeUserDataSyncStore(()=>{(0,R.isEqual)(this.syncUrl,a.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=a.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(P.onDidChangeAccount(()=>this.updateAutoSync())),this._register(c.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(l.onDidChangeLocal(T=>this.triggerSync([T],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,T])=>T)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const s=this.storageService.get(g,-1);return s?I.URI.parse(s):void 0}set syncUrl(s){s?this.storageService.store(g,s.toString(),-1,1):this.storageService.remove(g,-1)}get productQuality(){return this.storageService.get(h,-1)}set productQuality(s){s?this.storageService.store(h,s,-1,1):this.storageService.remove(h,-1)}updateAutoSync(){const{enabled:s,message:a}=this.isAutoSyncEnabled();s?this.autoSync.value===void 0&&(this.autoSync.value=new n(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(c=>this.onDidFinishSync(c))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(a&&this.logService.info(a),this.autoSync.clear()):a&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(a))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(s,a,c){try{this.userDataSyncAccountService.account&&!c&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(u,-1),s?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(o){if(a)this.logService.error(o),this.updateEnablement(!1);else throw o}}updateEnablement(s){this.userDataSyncEnablementService.isEnabled()!==s&&(this.userDataSyncEnablementService.setEnablement(s),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(s){if(!s){this.successiveFailures=0;return}const a=S.UserDataSyncError.toUserDataSyncError(s);a instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:a.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),a.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):a.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):a.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):a.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):a.code==="UpgradeRequired"||a.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):a.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${a.resource} content with newer version than of client. Requires client upgrade.`)):a.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${a.resource} content with older version than of client. Requires server reset.`)):a.code==="ServiceChanged"||a.code==="DefaultServiceChanged"?C.isWeb&&a.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(a),this.successiveFailures++),this._onError.fire(a)}async disableMachineEventually(){this.storageService.store(m,!0,-1,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(m,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(m,-1)}async triggerSync(s,a,c){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(a&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...s),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",c)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};r=ge([K(0,v.IProductService),K(1,S.IUserDataSyncStoreManagementService),K(2,S.IUserDataSyncStoreService),K(3,S.IUserDataSyncEnablementService),K(4,S.IUserDataSyncService),K(5,S.IUserDataSyncLogService),K(6,w.IUserDataSyncAccountService),K(7,d.ITelemetryService),K(8,p.IUserDataSyncMachinesService),K(9,y.IStorageService)],r),e.UserDataAutoSyncService=r;class n extends b.Disposable{constructor(s,a,c,o,l,f,P,U){super();this.lastSyncUrl=s,this.interval=a,this.userDataSyncStoreManagementService=c,this.userDataSyncStoreService=o,this.userDataSyncService=l,this.userDataSyncMachinesService=f,this.logService=P,this.storageService=U,this.intervalHandler=this._register(new b.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,b.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(n.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(n.INTERVAL_SYNCING,!1),this.interval)}sync(s,a){const c=(0,D.createCancelablePromise)(async o=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(l){if((0,L.isCancellationError)(l))return}return this.doSync(s,a,o)});return this.syncPromise=c,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,R.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const s=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),a=this.userDataSyncStoreManagementService.userDataSyncStore;return!!a&&!!s&&(!(0,R.isEqual)(a.defaultUrl,s.defaultUrl)||!(0,R.isEqual)(a.insidersUrl,s.insidersUrl)||!(0,R.isEqual)(a.stableUrl,s.stableUrl))}async doSync(s,a,c){this.logService.info(`Auto Sync: Triggered by ${s}`),this._onDidStartSync.fire();let o;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,a),c.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const l=this.storageService.get(u,-1);if(l&&this.manifest&&l!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const f=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(c.isCancellationRequested)return;const P=f.find(U=>U.isCurrent);if(P?.disabled)throw new S.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(U){throw new S.UserDataAutoSyncError((0,k.toErrorMessage)(U),U instanceof S.UserDataSyncError?U.code:"Unknown")}if(this.manifest&&this.manifest.session!==l&&this.storageService.store(u,this.manifest.session,-1,1),c.isCancellationRequested)return;P||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(l){this.logService.error(l),o=l}this._onDidFinishSync.fire(o)}register(s){return super._register(s)}}n.INTERVAL_SYNCING="Interval"}),define(ne[264],re([0,1,18,6,38,3,2,17,14,31,19,28,5,23,22,256,257,258,259,260,261,25]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p,m,u,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const r="sync.lastSyncTime";let n=class extends A.Disposable{constructor(o,l,f,P,U,_,F,T){super();this.userDataSyncStoreService=o,this.userDataSyncStoreManagementService=l,this.instantiationService=f,this.configurationService=P,this.logService=U,this.telemetryService=_,this.storageService=F,this.userDataSyncEnablementService=T,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(r,-1,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(o,l){this.checkEnablement();const f=(0,R.generateUuid)();try{const T=(0,h.createSyncHeaders)(f);l&&(T["Cache-Control"]="no-cache"),o=await this.userDataSyncStoreService.manifest(o,T)}catch(T){const N=h.UserDataSyncError.toUserDataSyncError(T);throw this.reportUserDataSyncError(N,f),N}const P=!1,U=this,_=this.getEnabledSynchronizers();let F;return{manifest:o,async run(){if(P)throw new Error("Can run a task only once");return F=(0,i.createCancelablePromise)(T=>U.sync(_,o,f,T)),F.finally(()=>F=void 0)},async stop(){if(F&&F.cancel(),U.status!=="idle")return U.stop(_)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new h.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const o=(0,R.generateUuid)(),l=(0,h.createSyncHeaders)(o);let f;try{f=await this.userDataSyncStoreService.manifest(null,l)}catch(_){const F=h.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(F,o),F}await this.resetLocal();const P=this.getEnabledSynchronizers(),U=async()=>{await this.stop(P),await this.resetLocal()};return new t(o,f,l,P,U,this.configurationService,this.logService)}async sync(o,l,f,P){if(P.isCancellationRequested||!o.length)return;const U=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const _=(0,h.createSyncHeaders)(f);for(const F of o){if(P.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(F.resource))return;try{await F.sync(l,_)}catch(T){let N=!1;if(T instanceof h.UserDataSyncError)switch(T.code){case"TooLarge":T=new h.UserDataSyncError(T.message,T.code,F.resource),N=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":N=!0;break}const z=h.UserDataSyncError.toUserDataSyncError(T);if(this.reportUserDataSyncError(z,f),N)throw z;this.logService.error(T),this.logService.error(`${F.resource}: ${(0,k.toErrorMessage)(T)}`),this._syncErrors.push([F.resource,z])}}this.logService.info(`Sync done. Took ${new Date().getTime()-U}ms`),this.updateLastSyncTime()}catch(_){const F=h.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(F,f),F}finally{this.updateStatus(o),this._onSyncErrors.fire(this._syncErrors)}}async stop(o){if(this.status!=="idle")for(const l of o)try{l.status!=="idle"&&await l.stop()}catch(f){this.logService.error(f)}}async replace(o){this.checkEnablement(),await this.performSynchronizerAction(async l=>{if(await l.replace(o))return!0})}async accept(o,l,f,P){this.checkEnablement(),await this.performSynchronizerAction(async U=>{if(U.resource===o)return await U.accept(l,f),P&&await U.apply(!1,(0,h.createSyncHeaders)((0,R.generateUuid)())),!0})}async resolveContent(o){return this.performSynchronizerAction(async l=>{const f=await l.resolveContent(o);if(f)return f})}async getRemoteSyncResourceHandles(o){return await this.performSynchronizerAction(async f=>{if(f.resource===o)return f.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(o){return await this.performSynchronizerAction(async f=>{if(f.resource===o)return f.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(o,l){return await this.performSynchronizerAction(async P=>{if(P.resource===o)return P.getAssociatedResources(l)})||[]}async getMachineId(o,l){return await this.performSynchronizerAction(async P=>{if(P.resource===o)return await P.getMachineId(l)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async l=>{if(l.resource!=="globalState"&&await l.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async l=>{if(await l.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(o){this.logService.error(o)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(r,-1),this.synchronizers.value){for(const o of this.synchronizers.value.enabled)try{await o.resetLocal()}catch(l){this.logService.error(`${o.resource}: ${(0,k.toErrorMessage)(l)}`),this.logService.error(l)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(o){const l=new A.DisposableStore;try{const f=this.synchronizers.value||l.add(this.instantiationService.createInstance(s,()=>{},()=>{},()=>{})),P=[...f.enabled,...f.disabled.map(U=>l.add(f.createSynchronizer(U)))];for(const U of P){const _=await o(U);if(!(0,C.isUndefined)(_))return _}return null}finally{l.dispose()}}setStatus(o){const l=this._status;this._status!==o&&(this._status=o,this._onDidChangeStatus.fire(o),l==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(o){this.updateConflicts(o);const l=this.computeStatus(o);this.setStatus(l)}updateConflicts(o){const l=this.computeConflicts(o);(0,D.equals)(this._conflicts,l,([f,P],[U,_])=>f===f&&(0,D.equals)(P,_,(F,T)=>(0,b.isEqual)(F.previewResource,T.previewResource)))||(this._conflicts=this.computeConflicts(o),this._onDidChangeConflicts.fire(l))}computeConflicts(o){return o.filter(l=>l.status==="hasConflicts").map(l=>[l.resource,l.conflicts.map(a)])}computeStatus(o){return this.userDataSyncStoreManagementService.userDataSyncStore?o.some(l=>l.status==="hasConflicts")?"hasConflicts":o.some(l=>l.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(r,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(o,l){this.telemetryService.publicLog2("sync/error",{code:o.code,serverCode:o instanceof h.UserDataSyncStoreError?String(o.serverCode):void 0,url:o instanceof h.UserDataSyncStoreError?o.url:void 0,resource:o.resource,executionId:l,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(s,o=>this.updateStatus(o),o=>this.updateConflicts(o),o=>this._onDidChangeLocal.fire(o))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};n=ge([K(0,h.IUserDataSyncStoreService),K(1,h.IUserDataSyncStoreManagementService),K(2,v.IInstantiationService),K(3,I.IConfigurationService),K(4,h.IUserDataSyncLogService),K(5,d.ITelemetryService),K(6,y.IStorageService),K(7,h.IUserDataSyncEnablementService)],n),e.UserDataSyncService=n;class t extends A.Disposable{constructor(o,l,f,P,U,_,F){super();this.id=o,this.manifest=l,this.syncHeaders=f,this.synchronisers=P,this.onStop=U,this.configurationService=_,this.logService=F,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(o=>o.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(o=>o.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,i.createCancelablePromise)(o=>this.getPreviews(o))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(o){throw this.logService.error(o),o}}async accept(o,l){try{return await this.performAction(o,f=>f.accept(o,l))}catch(f){throw this.logService.error(f),f}}async merge(o){try{return o?await this.performAction(o,l=>l.merge(o)):await this.mergeAll()}catch(l){throw this.logService.error(l),l}}async discard(o){try{return await this.performAction(o,l=>l.discard(o))}catch(l){throw this.logService.error(l),l}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const o=[];for(const[,l]of this.previews)for(const f of l.resourcePreviews)f.mergeState==="conflict"&&o.push(f.previewResource);for(const l of o)await this.discard(l);return this.previews}catch(o){throw this.logService.error(o),o}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const o=[];for(const[l,f]of this.previews){this.synchronizingResources.push([l,f.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const P=this.synchronisers.find(_=>_.resource===l);for(const _ of f.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&await P.merge(_.previewResource);const U=await P.apply(!1,this.syncHeaders);U&&o.push(this.toSyncResourcePreview(P.resource,U)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}catch(o){throw this.logService.error(o),o}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,l]of this.previews){this.synchronizingResources.push([o,l.resourcePreviews.map(P=>P.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const f=this.synchronisers.find(P=>P.resource===o);for(const P of l.resourcePreviews)await f.accept(P.remoteResource);await f.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(P=>P[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,l]of this.previews){this.synchronizingResources.push([o,l.resourcePreviews.map(P=>P.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const f=this.synchronisers.find(P=>P.resource===o);for(const P of l.resourcePreviews)await f.accept(P.localResource);await f.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(P=>P[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async stop(){await this.onStop(),this.reset()}async performAction(o,l){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const f=this.previews.findIndex(([,V])=>V.resourcePreviews.some(({localResource:J,previewResource:$,remoteResource:Q})=>(0,b.isEqual)(o,J)||(0,b.isEqual)(o,$)||(0,b.isEqual)(o,Q)));if(f===-1)return this.previews;const[P,U]=this.previews[f],_=U.resourcePreviews.find(({localResource:V,remoteResource:J,previewResource:$})=>(0,b.isEqual)(V,o)||(0,b.isEqual)(J,o)||(0,b.isEqual)($,o));if(!_)return this.previews;let F=this.synchronizingResources.find(V=>V[0]===P);F||(F=[P,[]],this.synchronizingResources.push(F)),F[1].some(V=>(0,b.isEqual)(V,_.localResource))||(F[1].push(_.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const T=this.synchronisers.find(V=>V.resource===this.previews[f][0]),N=await l(T);N?this.previews.splice(f,1,this.toSyncResourcePreview(T.resource,N)):this.previews.splice(f,1);const z=this.synchronizingResources.findIndex(V=>V[0]===P);return this.synchronizingResources[z][1].splice(F[1].findIndex(V=>(0,b.isEqual)(V,_.localResource)),1),F[1].length||(this.synchronizingResources.splice(z,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const o=[];for(const[l,f]of this.previews){this.synchronizingResources.push([l,f.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const P=this.synchronisers.find(_=>_.resource===l);let U=f;for(const _ of f.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&(U=await P.merge(_.previewResource));U&&o.push(this.toSyncResourcePreview(P.resource,U)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}async getPreviews(o){const l=[],f=await this.getUserDataSyncConfiguration();for(const P of this.synchronisers){if(o.isCancellationRequested)return[];const U=await P.preview(this.manifest,f,this.syncHeaders);U&&l.push(this.toSyncResourcePreview(P.resource,U))}return l}async getUserDataSyncConfiguration(){const o=this.configurationService.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE),l=this.synchronisers.find(f=>f instanceof m.SettingsSynchroniser);if(l){const f=await l.getRemoteUserDataSyncConfiguration(this.manifest);return{...o,...f}}return o}toSyncResourcePreview(o,l){return[o,{isLastSyncFromCurrentMachine:l.isLastSyncFromCurrentMachine,resourcePreviews:l.resourcePreviews.map(a)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let s=class extends A.Disposable{constructor(o,l,f,P,U,_,F){super();this.onDidChangeStatus=o,this.onDidChangeConflicts=l,this.onDidChangeLocal=f,this.userDataSyncEnablementService=P,this.instantiationService=U,this.extensionGalleryService=_,this.logService=F,this._enabled=[],this._register(P.onDidChangeResourceEnablement(([T,N])=>this.onDidChangeResourceEnablement(T,N))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,T])=>T.dispose())));for(const T of h.ALL_SYNC_RESOURCES)P.isResourceEnabled(T)&&this.registerSynchronizer(T)}get enabled(){return this._enabled.sort((o,l)=>o[1]-l[1]).map(([o])=>o)}get disabled(){return h.ALL_SYNC_RESOURCES.filter(o=>!this.userDataSyncEnablementService.isResourceEnabled(o))}onDidChangeResourceEnablement(o,l){l?this.registerSynchronizer(o):this.deRegisterSynchronizer(o)}registerSynchronizer(o){if(this._enabled.some(([U])=>U.resource===o))return;if(o==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const l=new A.DisposableStore,f=l.add(this.createSynchronizer(o));l.add(f.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),l.add(f.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),l.add(f.onDidChangeLocal(()=>this.onDidChangeLocal(o)));const P=this.getOrder(o);this._enabled.push([f,P,l])}deRegisterSynchronizer(o){const l=this._enabled.findIndex(([f])=>f.resource===o);if(l!==-1){const f=this._enabled.splice(l,1);for(const[P,,U]of f){if(P.status!=="idle"){const _=P.conflicts.length>0;P.stop(),_&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}U.dispose()}}}createSynchronizer(o){switch(o){case"settings":return this.instantiationService.createInstance(m.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(p.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(u.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(g.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(w.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(S.ExtensionsSynchroniser)}}getOrder(o){switch(o){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};s=ge([K(3,h.IUserDataSyncEnablementService),K(4,v.IInstantiationService),K(5,E.IExtensionGalleryService),K(6,h.IUserDataSyncLogService)],s);function a(c){return{baseResource:c.baseResource,localResource:c.localResource,previewResource:c.previewResource,remoteResource:c.remoteResource,acceptedResource:c.acceptedResource,localChange:c.localChange,remoteChange:c.remoteChange,mergeState:c.mergeState}}}),define(ne[265],re([0,1,6,21,9,3,2,124,4,17,14,7,31,19,15,13,24,46,49,23,25]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p,m,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const h="sync.previous.store",r="sync.donot-make-requests-until",n="sync.user-session-id",t="sync.machine-session-id",s=100,a=1e3*60*5;let c=class extends A.Disposable{constructor(_,F,T){super();this.productService=_,this.configurationService=F,this.storageService=T,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(T.onDidChangeValue,N=>N.key===g.SYNC_SERVICE_URL_TYPE&&N.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(g.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(_){this.storageService.store(g.SYNC_SERVICE_URL_TYPE,_,-1,C.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[g.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(g.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(_,F){_=C.isWeb&&_?.web?{..._,..._.web}:_;const T={..._||{},...F||{}};if(T&&(0,I.isString)(T.url)&&(0,I.isObject)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(N=>(0,I.isArray)(T.authenticationProviders[N].scopes))){const N=T,z=!!N.canSwitch&&!F?.url,V=N.url===N.insidersUrl?"insiders":"stable",J=(z?this.userDataSyncStoreType:void 0)||V,$=F?.url||(J==="insiders"?N.insidersUrl:J==="stable"?N.stableUrl:N.url);return{url:E.URI.parse($),type:J,defaultType:V,defaultUrl:E.URI.parse(N.url),stableUrl:E.URI.parse(N.stableUrl),insidersUrl:E.URI.parse(N.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(N.authenticationProviders).reduce((Q,H)=>(Q.push({id:H,scopes:N.authenticationProviders[H].scopes}),Q),[])}}}};c=ge([K(0,w.IProductService),K(1,y.IConfigurationService),K(2,u.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let o=class extends c{constructor(_,F,T){super(_,F,T);const N=this.storageService.get(h,-1);N&&(this.previousConfigurationSyncStore=JSON.parse(N));const z=this.productService[g.CONFIGURATION_SYNC_STORE_KEY];z?this.storageService.store(h,JSON.stringify(z),-1,1):this.storageService.remove(h,-1)}async switch(_){_!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=_,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};o=ge([K(0,w.IProductService),K(1,y.IConfigurationService),K(2,u.IStorageService)],o),e.UserDataSyncStoreManagementService=o;let l=class extends A.Disposable{constructor(_,F,T,N,z,V,J){super();this.requestService=T,this.logService=N,this.storageService=J,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(_),this.commonHeadersPromise=(0,m.getServiceMachineId)(z,V,J).then($=>{const Q={"X-Client-Name":`${F.applicationName}${C.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(Q["X-Client-Commit"]=F.commit),Q}),this.session=new P(s,a,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(_,F){this.authToken={token:_,type:F}}updateUserDataSyncStoreUrl(_){this.userDataSyncStoreUrl=_?(0,R.joinPath)(_,"v1"):void 0}initDonotMakeRequestsUntil(){const _=this.storageService.getNumber(r,-1);_&&Date.now()<_&&this.setDonotMakeRequestsUntil(new Date(_))}setDonotMakeRequestsUntil(_){this._donotMakeRequestsUntil?.getTime()!==_?.getTime()&&(this._donotMakeRequestsUntil=_,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(F=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(r,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",_),T={},N=await this.request(F.toString(),{type:"GET",headers:T},[],i.CancellationToken.None);return(await(0,p.asJson)(N)||[]).map(({url:V,created:J})=>({ref:(0,R.relativePath)(F,F.with({path:V})),created:J*1e3}))}async resolveContent(_,F,T={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",_,F).toString();T={...T},T["Cache-Control"]="no-cache";const z=await this.request(N,{type:"GET",headers:T},[],i.CancellationToken.None);return await(0,p.asTextOrError)(z)}async delete(_,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const T=F!==null?(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",_,F).toString():(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",_).toString(),N={};await this.request(T,{type:"DELETE",headers:N},[],i.CancellationToken.None)}async read(_,F,T={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",_,"latest").toString();T={...T},T["Cache-Control"]="no-cache",F&&(T["If-None-Match"]=F.ref);const z=await this.request(N,{type:"GET",headers:T},[304],i.CancellationToken.None);let V=null;if(z.res.statusCode===304&&(V=F),V===null){const J=z.res.headers.etag;if(!J)throw new g.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",z.res.statusCode,z.res.headers[g.HEADER_OPERATION_ID]);const $=await(0,p.asTextOrError)(z);if(!$&&z.res.statusCode===304)throw new g.UserDataSyncStoreError("Empty response",N,"EmptyResponse",z.res.statusCode,z.res.headers[g.HEADER_OPERATION_ID]);V={ref:J,content:$}}return V}async write(_,F,T,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",_).toString();N={...N},N["Content-Type"]=b.Mimes.text,T&&(N["If-Match"]=T);const V=await this.request(z,{type:"POST",data:F,headers:N},[],i.CancellationToken.None),J=V.res.headers.etag;if(!J)throw new g.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",V.res.statusCode,V.res.headers[g.HEADER_OPERATION_ID]);return J}async manifest(_,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const T=(0,R.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",_&&(F["If-None-Match"]=_.ref);const N=await this.request(T,{type:"GET",headers:F},[304],i.CancellationToken.None);let z=null;if(N.res.statusCode===304&&(z=_),!z){const J=N.res.headers.etag;if(!J)throw new g.UserDataSyncStoreError("Server did not return the ref",T,"NoRef",N.res.statusCode,N.res.headers[g.HEADER_OPERATION_ID]);const $=await(0,p.asTextOrError)(N);if(!$&&N.res.statusCode===304)throw new g.UserDataSyncStoreError("Empty response",T,"EmptyResponse",N.res.statusCode,N.res.headers[g.HEADER_OPERATION_ID]);$&&(z={...JSON.parse($),ref:J})}const V=this.storageService.get(n,-1);return V&&z&&V!==z.session&&this.clearSession(),z===null&&V&&this.clearSession(),z&&this.storageService.store(n,z.session,-1,1),z}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":b.Mimes.text};await this.request(_,{type:"DELETE",headers:F},[],i.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(n,-1),this.storageService.remove(t,-1)}async request(_,F,T,N){if(!this.authToken)throw new g.UserDataSyncStoreError("No Auth Token Available",_,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new g.UserDataSyncStoreError(`${F.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const z=await this.commonHeadersPromise;F.headers={...F.headers||{},...z,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:_,type:F.type,headers:{...F.headers,authorization:void 0}});let V;try{V=await this.session.request(_,F,N)}catch(H){if(!(H instanceof g.UserDataSyncStoreError)){let B="RequestFailed";const Y=(0,k.getErrorMessage)(H).toLowerCase();Y.includes("xhr timeout")?B="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?B="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?B="RequestPathNotEscaped":Y.includes("headers must be an object")?B="RequestHeadersNotObject":(0,k.isCancellationError)(H)&&(B="RequestCanceled"),H=new g.UserDataSyncStoreError(`Connection refused for the request '${_}'.`,_,B,void 0,void 0)}throw this.logService.info("Request failed",_),H}const J=V.res.headers[g.HEADER_OPERATION_ID],$={url:_,status:V.res.statusCode,"execution-id":F.headers[g.HEADER_EXECUTION_ID],"operation-id":J},Q=(0,p.isSuccess)(V)||V.res.statusCode&&T.indexOf(V.res.statusCode)!==-1;if(Q?this.logService.trace("Request succeeded",$):this.logService.info("Request failed",$),V.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new g.UserDataSyncStoreError(`Request '${_}' failed because of Unauthorized (401).`,_,"Unauthorized",V.res.statusCode,J);if(this._onTokenSucceed.fire(),V.res.statusCode===409)throw new g.UserDataSyncStoreError(`${F.type} request '${_}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,_,"Conflict",V.res.statusCode,J);if(V.res.statusCode===410)throw new g.UserDataSyncStoreError(`${F.type} request '${_}' failed because the requested resource is not longer available (410).`,_,"Gone",V.res.statusCode,J);if(V.res.statusCode===412)throw new g.UserDataSyncStoreError(`${F.type} request '${_}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,_,"PreconditionFailed",V.res.statusCode,J);if(V.res.statusCode===413)throw new g.UserDataSyncStoreError(`${F.type} request '${_}' failed because of too large payload (413).`,_,"TooLarge",V.res.statusCode,J);if(V.res.statusCode===426)throw new g.UserDataSyncStoreError(`${F.type} request '${_}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,_,"UpgradeRequired",V.res.statusCode,J);if(V.res.statusCode===429){const H=V.res.headers["retry-after"];throw H?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(H)*1e3)),new g.UserDataSyncStoreError(`${F.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",V.res.statusCode,J)):new g.UserDataSyncStoreError(`${F.type} request '${_}' failed because of too many requests (429).`,_,"RemoteTooManyRequests",V.res.statusCode,J)}if(!Q)throw new g.UserDataSyncStoreError("Server returned "+V.res.statusCode,_,"Unknown",V.res.statusCode,J);return V}addSessionHeaders(_){let F=this.storageService.get(t,-1);F===void 0&&(F=(0,v.generateUuid)(),this.storageService.store(t,F,-1,1)),_["X-Machine-Session-Id"]=F;const T=this.storageService.get(n,-1);T!==void 0&&(_["X-User-Session-Id"]=T)}};l=ge([K(1,w.IProductService),K(2,p.IRequestService),K(3,g.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,S.IFileService),K(6,u.IStorageService)],l),e.UserDataSyncStoreClient=l;let f=class extends l{constructor(_,F,T,N,z,V,J){super(_.userDataSyncStore?.url,F,T,N,z,V,J);this._register(_.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(_.userDataSyncStore?.url)))}};f=ge([K(0,g.IUserDataSyncStoreManagementService),K(1,w.IProductService),K(2,p.IRequestService),K(3,g.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,S.IFileService),K(6,u.IStorageService)],f),e.UserDataSyncStoreService=f;class P{constructor(_,F,T,N){this.limit=_,this.interval=F,this.requestService=T,this.logService=N,this.requests=[],this.startTime=void 0}request(_,F,T){if(this.isExpired()&&this.reset(),F.url=_,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new g.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,_,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(_),this.requestService.request(F,T)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=P}),define(ne[266],re([0,1,3,67,24,23,22,263,25,70,73]),function(X,e,D,i,k,L,A,b,C,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends b.UserDataAutoSyncService{constructor(y,d,S,w,p,m,u,g,h,r,n){super(y,d,S,w,p,u,g,h,r,n);this._register(D.Event.debounce(D.Event.any(D.Event.map(m.onDidFocusWindow,()=>"windowFocus"),D.Event.map(m.onDidOpenWindow,()=>"windowOpen")),(t,s)=>t?[...t,s]:[s],1e3)(t=>this.triggerSync(t,!0,!1)))}};E=ge([K(0,k.IProductService),K(1,C.IUserDataSyncStoreManagementService),K(2,C.IUserDataSyncStoreService),K(3,C.IUserDataSyncEnablementService),K(4,C.IUserDataSyncService),K(5,i.INativeHostService),K(6,C.IUserDataSyncLogService),K(7,R.IUserDataSyncAccountService),K(8,A.ITelemetryService),K(9,I.IUserDataSyncMachinesService),K(10,L.IStorageService)],E),e.UserDataAutoSyncService=E}),define(ne[108],re([0,1,54,6,12,14,27,137,275,276]),function(X,e,D,i,k,L,A,b,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(r,n){let t=n.message;switch(r){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t);this.type=r,this.cause=n}}e.ExtractError=I;function E(h){const r=h.externalFileAttributes>>16||33188;return[448,56,7].map(n=>r&n).reduce((n,t)=>n+t,r&61440)}function v(h){if(h instanceof I)return h;let r;return/end of central directory record signature not found/.test(h.message)&&(r="CorruptZip"),new I(r,h)}function y(h,r,n,t,s,a){const c=k.dirname(r),o=k.join(t,c);if(!o.startsWith(t))return Promise.reject(new Error(b.localize(0,null,r)));const l=k.join(t,r);let f;return a.onCancellationRequested(()=>{f&&f.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((P,U)=>{if(!a.isCancellationRequested)try{f=(0,D.createWriteStream)(l,{mode:n}),f.once("close",()=>P()),f.once("error",U),h.once("error",U),h.pipe(f)}catch(_){U(_)}}))}function d(h,r,n,t){let s=(0,i.createCancelablePromise)(()=>Promise.resolve()),a=0;return t.onCancellationRequested(()=>{s.cancel(),h.close()}),new Promise((c,o)=>{const l=new i.Sequencer,f=P=>{P.isCancellationRequested||(a++,h.readEntry())};h.once("error",o),h.once("close",()=>s.then(()=>{t.isCancellationRequested||h.entryCount===a?c():o(new I("Incomplete",new Error(b.localize(1,null,a,h.entryCount))))},o)),h.readEntry(),h.on("entry",P=>{if(t.isCancellationRequested)return;if(!n.sourcePathRegex.test(P.fileName)){f(t);return}const U=P.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(U)){const T=k.join(r,U);s=(0,i.createCancelablePromise)(N=>A.Promises.mkdir(T,{recursive:!0}).then(()=>f(N)).then(void 0,o));return}const _=w(h,P),F=E(P);s=(0,i.createCancelablePromise)(T=>l.queue(()=>_.then(N=>y(N,U,F,r,n,T).then(()=>f(T)))).then(null,o))})})}function S(h,r=!1){return new Promise((n,t)=>{(0,C.open)(h,r?{lazyEntries:!0}:void 0,(s,a)=>{s?t(v(s)):n((0,L.assertIsDefined)(a))})})}function w(h,r){return new Promise((n,t)=>{h.openReadStream(r,(s,a)=>{s?t(v(s)):n((0,L.assertIsDefined)(a))})})}function p(h,r){return new Promise((n,t)=>{const s=new R.ZipFile;r.forEach(c=>{c.contents?s.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&s.addFile(c.localPath,c.path)}),s.end();const a=(0,D.createWriteStream)(h);s.outputStream.pipe(a),s.outputStream.once("error",t),a.once("error",t),a.once("finish",()=>n(h))})}e.zip=p;function m(h,r,n={},t){const s=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let a=S(h,!0);return n.overwrite&&(a=a.then(c=>A.Promises.rm(r).then(()=>c))),a.then(c=>d(c,r,{sourcePathRegex:s},t))}e.extract=m;function u(h,r){return S(h).then(n=>new Promise((t,s)=>{n.on("entry",a=>{a.fileName===r&&w(n,a).then(c=>t(c),c=>s(c))}),n.once("close",()=>s(new Error(b.localize(2,null,r))))}))}function g(h,r){return u(h,r).then(n=>new Promise((t,s)=>{const a=[];n.once("error",s),n.on("data",c=>a.push(c)),n.on("end",()=>t(Buffer.concat(a)))}))}e.buffer=g}),define(ne[267],re([0,1,108,146]),function(X,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(L){return(0,D.buffer)(L,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=k}),define(ne[109],re([0,1,6,38,9,2,20,12,4,17,55,14,7,31,27,108,145,90,15,247,28,32,45,71,201,249,267,202,233,44,65,13,5,8,24,22,33,29]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p,m,u,g,h,r,n,t,s,a,c,o,l,f,P,U,_,F,T,N,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,U.refineServiceDecorator)(g.IServerExtensionManagementService);let V=class extends u.AbstractExtensionManagementService{constructor(W,x,O,M,q,j,Z,G,te,se,ce,he){super(W,x,O,se,he);this.environmentService=M,this.extensionsScannerService=q,this.extensionsProfileScannerService=j,this.downloadService=Z,this.fileService=te,this.installGalleryExtensionsTasks=new Map;const ve=this._register(G.createInstance(s.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(J,Ce=>ve.postUninstall(Ce))),this.manifestCache=this._register(new c.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(G.createInstance(t.ExtensionsDownloader));const pe=this._register(new o.ExtensionsWatcher(this,te,M,O,ce));this._register(pe.onDidChangeExtensionsByAnotherSource(({added:Ce,removed:be})=>{Ce.length&&this._onDidInstallExtensions.fire(Ce.map(Pe=>({identifier:Pe.identifier,operation:1,local:Pe}))),be.forEach(Pe=>this._onDidUninstallExtension.fire({identifier:Pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,h.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const x=await this.collectFiles(W),O=await(0,S.zip)((0,R.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)()).fsPath,x);return v.URI.file(O)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const x=await this.downloadVsix(W),O=b.resolve(x.fsPath);return(0,a.getManifest)(O)}getInstalled(W,x){return this.extensionsScanner.scanExtensions(W??null,x)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(W,x={}){this.logService.trace("ExtensionManagementService#install",W.toString());const O=await this.downloadVsix(W),M=await(0,a.getManifest)(b.resolve(O.fsPath));if(M.engines&&M.engines.vscode&&!(0,f.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(w.localize(0,null,(0,h.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,O,x)}getMetadata(W){return this.extensionsScannerService.scanMetadata(W.location)}async updateMetadata(W,x){this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id);const O={...x};return x.isPreReleaseVersion&&(O.preRelease=!0),W=await this.extensionsScanner.updateMetadata(W,O),this.manifestCache.invalidate(),W}async updateExtensionScope(W,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.updateMetadata(W,{isMachineScoped:x}),this.manifestCache.invalidate(),W}removeUninstalledExtensions(W){return this.extensionsScanner.cleanUp(W)}async downloadVsix(W){if(W.scheme===A.Schemas.file)return W;const x=(0,R.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)());return await this.downloadService.download(W,x),x}doCreateInstallExtensionTask(W,x,O){let M;if(v.URI.isUri(x))M=new H(W,x,O,this.galleryService,this.extensionsScanner,this.logService);else{const q=h.ExtensionKey.create(x).toString();M=this.installGalleryExtensionsTasks.get(q),M||(this.installGalleryExtensionsTasks.set(q,M=new Q(W,x,O,this.extensionsDownloader,this.extensionsScanner,this.logService)),M.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(q)))}return O.profileLocation?new B(M,O.profileLocation,this.extensionsProfileScannerService):M}doCreateUninstallExtensionTask(W,x){return x.profileLocation?new ie(W,x.profileLocation,this.extensionsProfileScannerService):new Y(W,x,this.extensionsScanner)}async collectFiles(W){const x=async M=>{let q=await d.Promises.readdir(M);q=q.map(G=>b.join(M,G));const j=await Promise.all(q.map(G=>d.Promises.stat(G)));let Z=Promise.resolve([]);return j.forEach((G,te)=>{const se=q[te];G.isFile()&&(Z=Z.then(ce=>[...ce,se])),G.isDirectory()&&(Z=Z.then(ce=>x(se).then(he=>[...ce,...he])))}),Z};return(await x(W.location.fsPath)).map(M=>({path:`extension/${b.relative(W.location.fsPath,M)}`,localPath:M}))}};V=ge([K(0,g.IExtensionGalleryService),K(1,T.ITelemetryService),K(2,_.ILogService),K(3,m.INativeEnvironmentService),K(4,n.IExtensionsScannerService),K(5,r.IExtensionsProfileScannerService),K(6,p.IDownloadService),K(7,U.IInstantiationService),K(8,P.IFileService),K(9,F.IProductService),K(10,N.IUriIdentityService),K(11,z.IUserDataProfilesService)],V),e.ExtensionManagementService=V;let J=class extends L.Disposable{constructor(W,x,O,M){super();this.beforeRemovingExtension=W,this.fileService=x,this.extensionsScannerService=O,this.logService=M,this.uninstalledPath=(0,R.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(W){await this.removeUninstalledExtensions(),W&&await this.removeOutdatedExtensions()}async scanExtensions(W,x){const O={includeInvalid:!0,profileLocation:x};let M=[];return W===null||W===0?M.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},O)):W===1&&M.push(...await this.extensionsScannerService.scanUserExtensions(O)),M=W!==null?M.filter(q=>q.type===W):M,Promise.all(M.map(q=>this.toLocalExtension(q)))}async scanUserExtensions(W){const x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!W,includeInvalid:!0});return Promise.all(x.map(O=>this.toLocalExtension(O)))}async extractUserExtension(W,x,O,M){const q=W.toString(),j=b.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),Z=b.join(this.extensionsScannerService.userExtensionsLocation.fsPath,q);try{await d.Promises.rm(Z)}catch{throw new g.ExtensionManagementError(w.localize(1,null,Z,W.id),g.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(W,x,j,M),O={...O,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(v.URI.file(j),O);try{await this.rename(W,j,Z,Date.now()+2*60*1e3),this.logService.info("Renamed to",Z)}catch(G){try{await d.Promises.rm(j)}catch{}if(G.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",W.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(G)}. Deleted from extracted location`,j),G}return this.scanLocalExtension(v.URI.file(Z),1)}async updateMetadata(W,x){return await this.extensionsScannerService.updateMetadata(W.location,x),this.scanLocalExtension(W.location,W.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...W){const x=W.map(O=>h.ExtensionKey.create(O));await this.withUninstalledExtensions(O=>{x.forEach(M=>O[M.toString()]=!0)})}async setInstalled(W){await this.withUninstalledExtensions(M=>delete M[W.toString()]);const O=(await this.scanUserExtensions(!0)).find(M=>h.ExtensionKey.create(M).equals(W))||null;return O?this.updateMetadata(O,{installedTimestamp:Date.now()}):null}async removeExtension(W,x){this.logService.trace(`Deleting ${x} extension from disk`,W.identifier.id,W.location.fsPath),await d.Promises.rm(W.location.fsPath),this.logService.info("Deleted from disk",W.identifier.id,W.location.fsPath)}async removeUninstalledExtension(W){await this.removeExtension(W,"uninstalled"),await this.withUninstalledExtensions(x=>delete x[h.ExtensionKey.create(W).toString()])}async withUninstalledExtensions(W){return this.uninstalledFileLimiter.queue(async()=>{let x;try{x=await d.Promises.readFile(this.uninstalledPath,"utf8")}catch(M){if(M.code!=="ENOENT")throw M}let O={};if(x)try{O=JSON.parse(x)}catch{}return W&&(W(O),Object.keys(O).length?await d.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await d.Promises.rm(this.uninstalledPath)),O})}async extractAtLocation(W,x,O,M){this.logService.trace(`Started extracting the extension from ${x} to ${O}`);try{await d.Promises.rm(O)}catch(q){throw new g.ExtensionManagementError(this.joinErrors(q).message,g.ExtensionManagementErrorCode.Delete)}try{await(0,S.extract)(x,O,{sourcePath:"extension",overwrite:!0},M),this.logService.info(`Extracted extension to ${O}:`,W.id)}catch(q){try{await d.Promises.rm(O)}catch{}let j=g.ExtensionManagementErrorCode.Extract;throw q instanceof S.ExtractError&&(q.type==="CorruptZip"?j=g.ExtensionManagementErrorCode.CorruptZip:q.type==="Incomplete"&&(j=g.ExtensionManagementErrorCode.IncompleteZip)),new g.ExtensionManagementError(q.message,j)}}async rename(W,x,O,M){try{await d.Promises.rename(x,O)}catch(q){if(C.isWindows&&q&&q.code==="EPERM"&&Date.now()<M)return this.logService.info(`Failed renaming ${x} to ${O} with 'EPERM' error. Trying again...`,W.id),this.rename(W,x,O,M);throw new g.ExtensionManagementError(q.message||w.localize(2,null,x,O),q.code||g.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(W,x){const O=await this.extensionsScannerService.scanExistingExtension(W,x,{includeInvalid:!0});if(O)return this.toLocalExtension(O);throw new Error(w.localize(3,null,W.path))}async toLocalExtension(W){const x=await this.fileService.resolve(W.location);let O,M;return x.children&&(O=x.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,M=x.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource),{identifier:W.identifier,type:W.type,isBuiltin:W.isBuiltin||!!W.metadata?.isBuiltin,location:W.location,manifest:W.manifest,targetPlatform:W.targetPlatform,validations:W.validations,isValid:W.isValid,readmeUrl:O,changelogUrl:M,publisherDisplayName:W.metadata?.publisherDisplayName||null,publisherId:W.metadata?.publisherId||null,isApplicationScoped:!!W.metadata?.isApplicationScoped,isMachineScoped:!!W.metadata?.isMachineScoped,isPreReleaseVersion:!!W.metadata?.isPreReleaseVersion,preRelease:!!W.metadata?.preRelease,installedTimestamp:W.metadata?.installedTimestamp,updated:!!W.metadata?.updated}}async removeUninstalledExtensions(){const W=await this.getUninstalledExtensions(),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const j of x)W[h.ExtensionKey.create(j).toString()]||O.add(j.identifier.id.toLowerCase());const M=(0,h.groupByExtension)(x,j=>j.identifier);await D.Promises.settled(M.map(async j=>{const Z=j.sort((G,te)=>I.rcompare(G.manifest.version,te.manifest.version))[0];O.has(Z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Z))}));const q=x.filter(j=>W[h.ExtensionKey.create(j).toString()]);await D.Promises.settled(q.map(j=>this.removeUninstalledExtension(j)))}async removeOutdatedExtensions(){const W=await this.extensionsScannerService.scanSystemExtensions({}),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=[],M=await this.extensionsScannerService.getTargetPlatform(),q=(0,h.groupByExtension)(x,j=>j.identifier);for(const j of q)if(j.length>1&&O.push(...j.sort((Z,G)=>{const te=I.rcompare(Z.manifest.version,G.manifest.version);return te!==0?te:Z.targetPlatform===M?-1:1}).slice(1)),j[0].type===0){const Z=W.find(G=>(0,h.areSameExtensions)(G.identifier,j[0].identifier));(!Z||I.gte(Z.manifest.version,j[0].manifest.version))&&O.push(j[0])}await D.Promises.settled(O.map(j=>this.removeExtension(j,"outdated")))}joinErrors(W){const x=Array.isArray(W)?W:[W];return x.length===1?x[0]instanceof Error?x[0]:new Error(x[0]):x.reduce((O,M)=>new Error(`${O.message}${O.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}};J=ge([K(1,P.IFileService),K(2,n.IExtensionsScannerService),K(3,_.ILogService)],J);class $ extends u.AbstractExtensionTask{constructor(W,x,O,M,q){super();this.identifier=W,this.source=x,this.options=O,this.extensionsScanner=M,this.logService=q,this._operation=2}get operation(){return(0,E.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(W,x){try{const O=await this.unsetUninstalledAndGetLocal(W.key);if(O)return W.metadata?this.extensionsScanner.updateMetadata(O,W.metadata):O}catch{throw C.isMacintosh?new g.ExtensionManagementError(w.localize(4,null),g.ExtensionManagementErrorCode.Internal):new g.ExtensionManagementError(w.localize(5,null),g.ExtensionManagementErrorCode.Internal)}return this.extract(W,x)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const O=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),O}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.toString()]}async extract({zipPath:W,key:x,metadata:O},M){const q=await this.extensionsScanner.extractUserExtension(x,W,O,M);return this.logService.info("Extracting completed.",x.id),q}}class Q extends ${constructor(W,x,O,M,q,j){super(x.identifier,x,O,q,j);this.manifest=W,this.gallery=x,this.extensionsDownloader=M}async doRun(W){const O=(await this.extensionsScanner.scanExtensions(null,void 0)).find(j=>(0,h.areSameExtensions)(j.identifier,this.gallery.identifier));O&&(this._operation=3);const M={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,l.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,E.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(O,M),metadata:M};const q=await this.downloadExtension(this.gallery,this._operation);try{const j=await this.installExtension({zipPath:q,key:h.ExtensionKey.create(this.gallery),metadata:M},W);return O&&!this.options.profileLocation&&(O.targetPlatform!==j.targetPlatform||I.neq(O.manifest.version,j.manifest.version))&&await this.extensionsScanner.setUninstalled(O),{local:j,metadata:M}}catch(j){throw await this.deleteDownloadedVSIX(q),j}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(v.URI.file(W))}catch(x){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,k.getErrorMessage)(x))}}async downloadExtension(W,x){let O;try{this.logService.trace("Started downloading extension:",W.identifier.id),O=(await this.extensionsDownloader.downloadExtension(W,x)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,O)}catch(M){throw new g.ExtensionManagementError((0,u.joinErrors)(M).message,g.ExtensionManagementErrorCode.Download)}try{return await(0,a.getManifest)(O),O}catch(M){throw await this.deleteDownloadedVSIX(O),new g.ExtensionManagementError((0,u.joinErrors)(M).message,g.ExtensionManagementErrorCode.Invalid)}}}class H extends ${constructor(W,x,O,M,q,j){super({id:(0,h.getGalleryExtensionId)(W.publisher,W.name)},x,O,q,j);this.manifest=W,this.location=x,this.galleryService=M}async doRun(W){const x=new h.ExtensionKey(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1,void 0)).find(Z=>(0,h.areSameExtensions)(this.identifier,Z.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,W);if(q.isApplicationScoped=(0,l.isApplicationScopedExtension)(this.manifest),q.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=3,x.equals(new h.ExtensionKey(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(w.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&I.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const Z=await this.unsetUninstalledAndGetLocal(x);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch{throw new Error(w.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:b.resolve(this.location.fsPath),key:x,metadata:q},W),metadata:q}}async getMetadata(W,x,O){try{let[M]=await this.galleryService.getExtensions([{id:W,version:x}],O);if(M||([M]=await this.galleryService.getExtensions([{id:W}],O)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class B{constructor(W,x,O){this.task=W,this.profileLocation=x,this.extensionsProfileScannerService=O,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const W=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[W.local,W.metadata]],this.profileLocation),W}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class Y extends u.AbstractExtensionTask{constructor(W,x,O){super();this.extension=W,this.options=x,this.extensionsScanner=O}async doRun(W){const x=[],O=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=h.ExtensionKey.create(this.extension);x.push(...O.filter(q=>M.equals(h.ExtensionKey.create(q))))}else x.push(...O.filter(M=>(0,h.areSameExtensions)(M.identifier,this.extension.identifier)));if(!x.length)throw new Error(w.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const M of x)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(q){throw new Error(w.localize(9,null,(0,i.toErrorMessage)(q)))}}}class ie extends u.AbstractExtensionTask{constructor(W,x,O){super();this.extension=W,this.profileLocation=x,this.extensionsProfileScannerService=O}async doRun(W){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ne[268],re([0,1,2,28,32,45,72,200,109,44,5,8,23,33,29]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const S={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let w=class extends D.Disposable{constructor(u,g,h,r,n,t,s,a){super();this.userDataProfilesService=g,u.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,b.migrateUnsupportedExtensions)(u,h,r,n,a),A.ExtensionStorageService.removeOutdatedExtensionVersions(u,s),this._register(t.createInstance(p))}};w=ge([K(0,C.INativeServerExtensionManagementService),K(1,d.IUserDataProfilesService),K(2,i.IExtensionGalleryService),K(3,A.IExtensionStorageService),K(4,i.IGlobalExtensionEnablementService),K(5,I.IInstantiationService),K(6,v.IStorageService),K(7,E.ILogService)],w),e.ExtensionsCleaner=w;let p=class extends D.Disposable{constructor(u,g,h,r,n){super();this.extensionManagementService=u,this.userDataProfilesService=g,this.extensionsProfileScannerService=h,this.uriIdentityService=r,this.logService=n,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new D.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:u,removed:g,all:h}){try{await Promise.all(g.map(r=>r.extensionsResource?this.removeExtensionsFromProfile(r.extensionsResource):Promise.resolve()))}catch(r){this.logService.error(r)}if(h.length===1){this.profileModeDisposables.clear();const r=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{r.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{u.length&&(await Promise.all(u.map(r=>r.extensionsResource?this.populateExtensionsFromProfile(r.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new D.DisposableStore,this.profileModeDisposables.value.add((0,D.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(r=>this.onDidChangeProfiles(r))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(r=>this.onDidInstallExtensions(r))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(r=>this.onDidUninstallExtension(r))),await this.uninstallExtensionsNotInProfiles()))}catch(r){this.logService.error(r)}}async uninstallExtensionsNotInProfiles(){const g=(await this.extensionManagementService.getAllUserInstalled()).filter(h=>!this.profileExtensionsLocations.has(this.getKey(h.identifier,h.manifest.version)));g.length&&await Promise.all(g.map(h=>this.extensionManagementService.uninstall(h,S)))}async onDidInstallExtensions(u){for(const{local:g,profileLocation:h}of u)!g||!h||this.addExtensionWithKey(this.getKey(g.identifier,g.manifest.version),h)}async onDidUninstallExtension(u){!u.profileLocation||!u.version||this.removeExtensionWithKey(this.getKey(u.identifier,u.version),u.profileLocation)&&await this.uninstallExtensions([{identifier:u.identifier,version:u.version}])}async populateExtensionsFromProfile(u){const g=await this.extensionsProfileScannerService.scanProfileExtensions(u);for(const h of g)this.addExtensionWithKey(this.getKey(h.identifier,h.version),u)}async removeExtensionsFromProfile(u){const g=[];for(const h of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(h,u))continue;const r=this.fromKey(h);r&&g.push(r)}g.length&&await this.uninstallExtensions(g)}addExtensionWithKey(u,g){let h=this.profileExtensionsLocations.get(u);h||(h=[],this.profileExtensionsLocations.set(u,h)),h.push(g)}removeExtensionWithKey(u,g){const h=this.profileExtensionsLocations.get(u);if(h){const r=h.findIndex(n=>this.uriIdentityService.extUri.isEqual(n,g));r>-1&&h.splice(r,1)}return h?.length?!1:(this.profileExtensionsLocations.delete(u),!0)}async uninstallExtensions(u){const h=(await this.extensionManagementService.getAllUserInstalled()).filter(r=>u.some(n=>this.getKey(r.identifier,r.manifest.version)===this.getKey(n.identifier,n.version)));h.length&&await Promise.all(h.map(r=>this.extensionManagementService.uninstall(r,S)))}getKey(u,g){return`${R.ExtensionIdentifier.toKey(u.id)}@${g}`}fromKey(u){const[g,h]=(0,k.getIdAndVersion)(u);return h?{identifier:{id:g},version:h}:void 0}};p=ge([K(0,C.INativeServerExtensionManagementService),K(1,d.IUserDataProfilesService),K(2,L.IExtensionsProfileScannerService),K(3,y.IUriIdentityService),K(4,E.ILogService)],p)}),define(ne[277],re([0,1,84,37,38,9,2,20,17,7,39,133,193,268,194,185,186,187,173,176,19,198,89,218,90,208,15,214,251,252,28,175,253,109,91,171,13,189,191,56,5,183,93,184,94,66,203,8,95,67,96,24,46,23,254,101,22,102,103,104,50,222,105,224,230,72,107,25,70,241,242,243,73,262,264,244,265,266,245,100,216,69,232,205,231,99,213,33,234,4,235,178,196,195,71,250,29,45,192,58,255,221,248,211]),function(X,e,D,i,k,L,A,b,C,R,I,E,v,y,d,S,w,p,m,u,g,h,r,n,t,s,a,c,o,l,f,P,U,_,F,T,N,z,V,J,$,Q,H,B,Y,ie,ae,W,x,O,M,q,j,Z,G,te,se,ce,he,ve,pe,Ce,be,Pe,Me,Ye,He,We,oe,ue,de,Ee,Ie,Ue,De,$e,Ae,Te,Ne,ee,le,fe,Se,me,we,Re,ke,Le,_e,Fe,ze,Xe,nt,pt,Rt,Dt,kt,St,Lt,yt,Tt,At,_t,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ut extends A.Disposable{constructor(ye){super();this.configuration=ye,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",qe=(xe,Ze)=>this.onDisposeWorker(Ze);D.ipcRenderer.on(Oe,qe),this._register((0,A.toDisposable)(()=>D.ipcRenderer.removeListener(Oe,qe)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,We.registerConfiguration)(),ye.invokeFunction(Oe=>{const qe=Oe.get(W.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(qe)}),this._register((0,A.combinedDisposable)(ye.createInstance(v.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(d.LanguagePackCachedDataCleaner),ye.createInstance(p.StorageDataCleaner,this.configuration.backupWorkspacesPath),ye.createInstance(w.LogsDataCleaner),ye.createInstance(S.LocalizationsUpdater),ye.createInstance(y.ExtensionsCleaner)))}async initServices(){const ye=new H.ServiceCollection,Oe={_serviceBrand:void 0,...M.default};ye.set(q.IProductService,Oe);const qe=new I.StaticRouter(Ge=>Ge==="main"),xe=new B.MessagePortMainProcessService(this.server,qe);ye.set(Y.IMainProcessService,xe);const Ze=this.configuration.policiesData?new Lt.PolicyChannelClient(this.configuration.policiesData,xe.getChannel("policy")):new yt.NullPolicyService;ye.set(yt.IPolicyService,Ze);const je=new c.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(a.INativeEnvironmentService,je);const ot=new x.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),et=new x.LoggerChannelClient(this.configuration.logLevel,ot.onDidChangeLogLevel,xe.getChannel("logger"));ye.set(W.ILoggerService,et);const lt=this._register(new W.MultiplexLogService([this._register(new W.ConsoleLogger(this.configuration.logLevel)),this._register(et.createLogger((0,C.joinPath)(R.URI.file(je.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Be=this._register(new x.FollowerLogService(ot,lt));ye.set(W.ILogService,Be),this.sharedProcessWorkerService=new ke.SharedProcessWorkerService(Be),ye.set(Re.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new z.FileService(Be));ye.set(N.IFileService,Je);const ut=this._register(new V.DiskFileSystemProvider(Be));Je.registerProvider(b.Schemas.file,ut);const ht=this._register(new ze.FileUserDataProvider(b.Schemas.file,this._register(new Xe.DiskFileSystemProviderClient(xe.getChannel(Xe.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Fe.isLinux})),b.Schemas.vscodeUserData,Be));Je.registerProvider(b.Schemas.vscodeUserData,ht);const tt=this._register(new Tt.UserDataProfilesNativeService(this.configuration.profiles,xe,je));ye.set(kt.IUserDataProfilesService,tt);const Ve=this._register(new h.ConfigurationService(tt.defaultProfile.settingsResource,Je,Ze,Be));ye.set(g.IConfigurationService,Ve);const rt=new G.NativeStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},xe,je);ye.set(Z.IStorageService,rt),this._register((0,A.toDisposable)(()=>rt.flush())),await Promise.all([Ve.initialize(),rt.initialize()]),ye.set(Le.IUriIdentityService,new _e.UriIdentityService(Je)),ye.set(j.IRequestService,new Ot.SharedProcessRequestService(xe,Ve,Be)),ye.set(m.IChecksumService,new J.SyncDescriptor(u.ChecksumService)),ye.set(pt.IV8InspectProfilingService,new J.SyncDescriptor(nt.InspectProfilingService));const at=I.ProxyChannel.toService(xe.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(O.INativeHostService,at),ye.set(t.IDownloadService,new J.SyncDescriptor(s.DownloadService));const dt=this._register(new Ne.ActiveWindowManager(at)),Ft=new I.StaticRouter(Ge=>dt.getActiveClientId().then(ft=>Ge===ft));ye.set(F.IExtensionRecommendationNotificationService,new T.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Ft)));let ct;const st=[],Et=(0,pe.isInternalTelemetry)(Oe,Ve);if((0,pe.supportsTelemetry)(Oe,je)){const Ge=new he.TelemetryLogAppender(et,je);st.push(Ge);const{installSourcePath:ft}=je;if(Oe.aiConfig?.ariaKey){const Ct=new At.OneDataSystemWebAppender(Et,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,A.toDisposable)(()=>Ct.flush())),st.push(Ct)}ct=new ve.TelemetryService({appenders:st,commonProperties:(0,te.resolveCommonProperties)(Je,(0,i.release)(),(0,i.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Et,ft),sendErrorTelemetry:!0,piiPaths:(0,pe.getPiiPathsFromEnvironment)(je)},Ve,Oe)}else{ct=pe.NullTelemetryService;const Ge=pe.NullAppender;st.push(Ge)}this.server.registerChannel("telemetryAppender",new ce.TelemetryAppenderChannel(st)),ye.set(se.ITelemetryService,ct);const Nt=new Ce.CustomEndpointTelemetryService(Ve,ct,et,je,Oe);ye.set(se.ICustomEndpointTelemetryService,Nt),ye.set(St.IExtensionsProfileScannerService,new J.SyncDescriptor(St.ExtensionsProfileScannerService)),ye.set(Rt.IExtensionsScannerService,new J.SyncDescriptor(Dt.ExtensionsScannerService)),ye.set(_.INativeServerExtensionManagementService,new J.SyncDescriptor(_.ExtensionManagementService)),ye.set(f.IDefaultExtensionsProfileInitService,new J.SyncDescriptor(_t.DefaultExtensionsProfileInitService)),ye.set(f.IExtensionGalleryService,new J.SyncDescriptor(l.ExtensionGalleryService)),ye.set(f.IExtensionTipsService,new J.SyncDescriptor(U.ExtensionTipsService)),ye.set(ie.ILanguagePackService,new J.SyncDescriptor(ae.NativeLanguagePackService)),ye.set(r.IDiagnosticsService,new J.SyncDescriptor(n.DiagnosticsService)),ye.set(oe.IUserDataSyncAccountService,new J.SyncDescriptor(oe.UserDataSyncAccountService)),ye.set(We.IUserDataSyncLogService,new J.SyncDescriptor(Ee.UserDataSyncLogService)),ye.set(We.IUserDataSyncUtilService,new de.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),ye.set(f.IGlobalExtensionEnablementService,new J.SyncDescriptor(o.GlobalExtensionEnablementService)),ye.set(He.IIgnoredExtensionsManagementService,new J.SyncDescriptor(He.IgnoredExtensionsManagementService)),ye.set(Ye.IExtensionStorageService,new J.SyncDescriptor(Ye.ExtensionStorageService)),ye.set(We.IUserDataSyncStoreManagementService,new J.SyncDescriptor(Ae.UserDataSyncStoreManagementService)),ye.set(We.IUserDataSyncStoreService,new J.SyncDescriptor(Ae.UserDataSyncStoreService)),ye.set(Ie.IUserDataSyncMachinesService,new J.SyncDescriptor(Ie.UserDataSyncMachinesService)),ye.set(We.IUserDataSyncBackupStoreService,new J.SyncDescriptor(ue.UserDataSyncBackupStoreService)),ye.set(We.IUserDataSyncEnablementService,new J.SyncDescriptor(Ue.UserDataSyncEnablementService)),ye.set(We.IUserDataSyncService,new J.SyncDescriptor(De.UserDataSyncService));const bt=new Me.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ve.getValue("terminal.integrated.persistentSessionScrollback")??100},Ve,je,Be);return bt.initialize(),ye.set(Pe.ILocalPtyService,this._register(bt)),ye.set(ee.ISignService,new J.SyncDescriptor(le.SignService)),ye.set(fe.ISharedTunnelsService,new J.SyncDescriptor(Se.SharedTunnelsService)),ye.set(me.ISharedProcessTunnelService,new J.SyncDescriptor(we.SharedProcessTunnelService)),new Q.InstantiationService(ye)}initChannels(ye){const Oe=new P.ExtensionManagementChannel(ye.get(f.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const qe=I.ProxyChannel.fromService(ye.get(ie.ILanguagePackService));this.server.registerChannel("languagePacks",qe);const xe=I.ProxyChannel.fromService(ye.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",xe);const Ze=new P.ExtensionTipsChannel(ye.get(f.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ze);const je=I.ProxyChannel.fromService(ye.get(m.IChecksumService));this.server.registerChannel("checksum",je);const ot=I.ProxyChannel.fromService(ye.get(pt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",ot);const et=new de.UserDataSyncMachinesServiceChannel(ye.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",et);const lt=I.ProxyChannel.fromService(ye.get(se.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",lt);const Be=new de.UserDataSyncAccountServiceChannel(ye.get(oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Be);const Je=new de.UserDataSyncStoreManagementServiceChannel(ye.get(We.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Je);const ut=new $e.UserDataSyncChannel(ye.get(We.IUserDataSyncService),ye.get(W.ILogService));this.server.registerChannel("userDataSync",ut);const ht=this._register(ye.get($.IInstantiationService).createInstance(Te.UserDataAutoSyncService)),tt=new de.UserDataAutoSyncChannel(ht);this.server.registerChannel("userDataAutoSync",tt);const Ve=ye.get(Pe.ILocalPtyService),rt=I.ProxyChannel.fromService(Ve);this.server.registerChannel(be.TerminalIpcChannels.LocalPty,rt);const at=I.ProxyChannel.fromService(ye.get(me.ISharedProcessTunnelService));this.server.registerChannel(me.ipcSharedProcessTunnelChannelName,at);const dt=I.ProxyChannel.fromService(ye.get(Re.ISharedProcessWorkerService));this.server.registerChannel(Re.ipcSharedProcessWorkerChannelName,dt),this.server.registerChannel("IDefaultExtensionsProfileInitService",I.ProxyChannel.fromService(ye.get(f.IDefaultExtensionsProfileInitService)))}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,L.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Oe=>{const qe=(0,k.toErrorMessage)(Oe,!0);!qe||ye.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function Mt(wt){const ye=new Ut(wt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Mt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
