/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var X=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/resources","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/workspace/common/workspace","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/base/common/uuid","fs","os","vs/base/common/extpath","vs/base/common/strings","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/platform/policy/common/policy","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","vs/base/common/decorators","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/parts/ipc/node/ipc.net","vs/base/node/processes","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/color","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/decoder","string_decoder","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/backup/electron-main/backupMainService","vs/platform/storage/electron-main/storageIpc","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","path","graceful-fs","vscode-policy-watcher","zlib","vs/code/electron-main/main"],J=function(z){for(var e=[],S=0,t=z.length;S<t;S++)e[S]=X[z[S]];return e};define(X[116],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function S(t,D){if(!t)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=S}),define(X[117],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function S(M){return M?M.replace(/\$\((.*?)\)/g,(v,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=S;class t{constructor(v,f,p){this.id=v,this.definition=f,this.description=p,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(M,v){const f=["codicon","codicon-"+M];return v&&f.push("codicon-modifier-"+v),f}e.getClassNamesArray=D;var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function f(k){if(k instanceof t)return["codicon","codicon-"+k.id];const y=v.exec(k.id);if(!y)return f(t.error);const[,g,u]=y,b=["codicon","codicon-"+g];return u&&b.push("codicon-modifier-"+u.substr(1)),b}M.asClassNameArray=f;function p(k){return f(k).join(" ")}M.asClassName=p;function C(k){return"."+f(k).join(".")}M.asCSSSelector=C})(R=e.CSSIcon||(e.CSSIcon={}))}),define(X[118],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function S(v,f){const p=Math.pow(10,f);return Math.round(v*p)/p}class t{constructor(f,p,C,k=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,p))|0,this.b=Math.min(255,Math.max(0,C))|0,this.a=S(Math.max(Math.min(1,k),0),3)}static equals(f,p){return f.r===p.r&&f.g===p.g&&f.b===p.b&&f.a===p.a}}e.RGBA=t;class D{constructor(f,p,C,k){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=S(Math.max(Math.min(1,p),0),3),this.l=S(Math.max(Math.min(1,C),0),3),this.a=S(Math.max(Math.min(1,k),0),3)}static equals(f,p){return f.h===p.h&&f.s===p.s&&f.l===p.l&&f.a===p.a}static fromRGBA(f){const p=f.r/255,C=f.g/255,k=f.b/255,y=f.a,g=Math.max(p,C,k),u=Math.min(p,C,k);let b=0,m=0;const E=(u+g)/2,I=g-u;if(I>0){switch(m=Math.min(E<=.5?I/(2*E):I/(2-2*E),1),g){case p:b=(C-k)/I+(C<k?6:0);break;case C:b=(k-p)/I+2;break;case k:b=(p-C)/I+4;break}b*=60,b=Math.round(b)}return new D(b,m,E,y)}static _hue2rgb(f,p,C){return C<0&&(C+=1),C>1&&(C-=1),C<1/6?f+(p-f)*6*C:C<1/2?p:C<2/3?f+(p-f)*(2/3-C)*6:f}static toRGBA(f){const p=f.h/360,{s:C,l:k,a:y}=f;let g,u,b;if(C===0)g=u=b=k;else{const m=k<.5?k*(1+C):k+C-k*C,E=2*k-m;g=D._hue2rgb(E,m,p+1/3),u=D._hue2rgb(E,m,p),b=D._hue2rgb(E,m,p-1/3)}return new t(Math.round(g*255),Math.round(u*255),Math.round(b*255),y)}}e.HSLA=D;class R{constructor(f,p,C,k){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=S(Math.max(Math.min(1,p),0),3),this.v=S(Math.max(Math.min(1,C),0),3),this.a=S(Math.max(Math.min(1,k),0),3)}static equals(f,p){return f.h===p.h&&f.s===p.s&&f.v===p.v&&f.a===p.a}static fromRGBA(f){const p=f.r/255,C=f.g/255,k=f.b/255,y=Math.max(p,C,k),g=Math.min(p,C,k),u=y-g,b=y===0?0:u/y;let m;return u===0?m=0:y===p?m=((C-k)/u%6+6)%6:y===C?m=(k-p)/u+2:m=(p-C)/u+4,new R(Math.round(m*60),b,y,f.a)}static toRGBA(f){const{h:p,s:C,v:k,a:y}=f,g=k*C,u=g*(1-Math.abs(p/60%2-1)),b=k-g;let[m,E,I]=[0,0,0];return p<60?(m=g,E=u):p<120?(m=u,E=g):p<180?(E=g,I=u):p<240?(E=u,I=g):p<300?(m=u,I=g):p<=360&&(m=g,I=u),m=Math.round((m+b)*255),E=Math.round((E+b)*255),I=Math.round((I+b)*255),new t(m,E,I,y)}}e.HSVA=R;class M{constructor(f){if(f)if(f instanceof t)this.rgba=f;else if(f instanceof D)this._hsla=f,this.rgba=D.toRGBA(f);else if(f instanceof R)this._hsva=f,this.rgba=R.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(f){return M.Format.CSS.parseHex(f)||M.red}get hsla(){return this._hsla?this._hsla:D.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}equals(f){return!!f&&t.equals(this.rgba,f.rgba)&&D.equals(this.hsla,f.hsla)&&R.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=M._relativeLuminanceForComponent(this.rgba.r),p=M._relativeLuminanceForComponent(this.rgba.g),C=M._relativeLuminanceForComponent(this.rgba.b),k=.2126*f+.7152*p+.0722*C;return S(k,4)}static _relativeLuminanceForComponent(f){const p=f/255;return p<=.03928?p/12.92:Math.pow((p+.055)/1.055,2.4)}getContrastRatio(f){const p=this.getRelativeLuminance(),C=f.getRelativeLuminance();return p>C?(p+.05)/(C+.05):(C+.05)/(p+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const p=this.getRelativeLuminance(),C=f.getRelativeLuminance();return p>C}isDarkerThan(f){const p=this.getRelativeLuminance(),C=f.getRelativeLuminance();return p<C}lighten(f){return new M(new D(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new M(new D(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:p,g:C,b:k,a:y}=this.rgba;return new M(new t(p,C,k,y*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const p=f.rgba,C=this.rgba.a,k=p.a,y=C+k*(1-C);if(y<1e-6)return M.transparent;const g=this.rgba.r*C/y+p.r*k*(1-C)/y,u=this.rgba.g*C/y+p.g*k*(1-C)/y,b=this.rgba.b*C/y+p.b*k*(1-C)/y;return new M(new t(g,u,b,y))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:p,g:C,b:k,a:y}=this.rgba;return new M(new t(f.rgba.r-y*(f.rgba.r-p),f.rgba.g-y*(f.rgba.g-C),f.rgba.b-y*(f.rgba.b-k),1))}flatten(...f){const p=f.reduceRight((C,k)=>M._flatten(k,C));return M._flatten(this,p)}static _flatten(f,p){const C=1-f.rgba.a;return new M(new t(C*p.rgba.r+f.rgba.a*f.rgba.r,C*p.rgba.g+f.rgba.a*f.rgba.g,C*p.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(f,p,C){if(f.isLighterThan(p))return f;C=C||.5;const k=f.getRelativeLuminance(),y=p.getRelativeLuminance();return C=C*(y-k)/y,f.lighten(C)}static getDarkerColor(f,p,C){if(f.isDarkerThan(p))return f;C=C||.5;const k=f.getRelativeLuminance(),y=p.getRelativeLuminance();return C=C*(k-y)/k,f.darken(C)}}e.Color=M,M.white=new M(new t(255,255,255,1)),M.black=new M(new t(0,0,0,1)),M.red=new M(new t(255,0,0,1)),M.blue=new M(new t(0,0,255,1)),M.green=new M(new t(0,255,0,1)),M.cyan=new M(new t(0,255,255,1)),M.lightgrey=new M(new t(211,211,211,1)),M.transparent=new M(new t(0,0,0,0)),function(v){let f;(function(p){let C;(function(k){function y(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:v.Format.CSS.formatRGBA(r)}k.formatRGB=y;function g(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}k.formatRGBA=g;function u(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:v.Format.CSS.formatHSLA(r)}k.formatHSL=u;function b(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}k.formatHSLA=b;function m(r){const n=r.toString(16);return n.length!==2?"0"+n:n}function E(r){return`#${m(r.rgba.r)}${m(r.rgba.g)}${m(r.rgba.b)}`}k.formatHex=E;function I(r,n=!1){return n&&r.rgba.a===1?v.Format.CSS.formatHex(r):`#${m(r.rgba.r)}${m(r.rgba.g)}${m(r.rgba.b)}${m(Math.round(r.rgba.a*255))}`}k.formatHexA=I;function w(r){return r.isOpaque()?v.Format.CSS.formatHex(r):v.Format.CSS.formatRGBA(r)}k.format=w;function h(r){const n=r.length;if(n===0||r.charCodeAt(0)!==35)return null;if(n===7){const i=16*l(r.charCodeAt(1))+l(r.charCodeAt(2)),s=16*l(r.charCodeAt(3))+l(r.charCodeAt(4)),o=16*l(r.charCodeAt(5))+l(r.charCodeAt(6));return new v(new t(i,s,o,1))}if(n===9){const i=16*l(r.charCodeAt(1))+l(r.charCodeAt(2)),s=16*l(r.charCodeAt(3))+l(r.charCodeAt(4)),o=16*l(r.charCodeAt(5))+l(r.charCodeAt(6)),a=16*l(r.charCodeAt(7))+l(r.charCodeAt(8));return new v(new t(i,s,o,a/255))}if(n===4){const i=l(r.charCodeAt(1)),s=l(r.charCodeAt(2)),o=l(r.charCodeAt(3));return new v(new t(16*i+i,16*s+s,16*o+o))}if(n===5){const i=l(r.charCodeAt(1)),s=l(r.charCodeAt(2)),o=l(r.charCodeAt(3)),a=l(r.charCodeAt(4));return new v(new t(16*i+i,16*s+s,16*o+o,(16*a+a)/255))}return null}k.parseHex=h;function l(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(C=p.CSS||(p.CSS={}))})(f=v.Format||(v.Format={}))}(M=e.Color||(e.Color={}))}),define(X[51],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function S(M){return(v,f,p)=>{let C=null,k=null;if(typeof p.value=="function"?(C="value",k=p.value):typeof p.get=="function"&&(C="get",k=p.get),!k)throw new Error("not supported");p[C]=M(k,f)}}e.createDecorator=S;function t(M,v,f){let p=null,C=null;if(typeof f.value=="function"?(p="value",C=f.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(p="get",C=f.get),!C)throw new Error("not supported");const k=`$memoize$${v}`;f[p]=function(...y){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,y)}),this[k]}}e.memoize=t;function D(M,v,f){return S((p,C)=>{const k=`$debounce$${C}`,y=`$debounce$result$${C}`;return function(...g){this[y]||(this[y]=f?f():void 0),clearTimeout(this[k]),v&&(this[y]=v(this[y],...g),g=[this[y]]),this[k]=setTimeout(()=>{p.apply(this,g),this[y]=f?f():void 0},M)}})}e.debounce=D;function R(M,v,f){return S((p,C)=>{const k=`$throttle$timer$${C}`,y=`$throttle$result$${C}`,g=`$throttle$lastRun$${C}`,u=`$throttle$pending$${C}`;return function(...b){if(this[y]||(this[y]=f?f():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),v&&(this[y]=v(this[y],...b)),this[u])return;const m=this[g]+M;m<=Date.now()?(this[g]=Date.now(),p.apply(this,[this[y]]),this[y]=f?f():void 0):(this[u]=!0,this[k]=setTimeout(()=>{this[u]=!1,this[g]=Date.now(),p.apply(this,[this[y]]),this[y]=f?f():void 0},m-Date.now()))}})}e.throttle=R}),define(X[19],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?w.isErrorNoTelemetry(r)?new w(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(n=>{n(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=S,e.errorHandler=new S;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function D(l){f(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function R(l){f(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=R;function M(l){if(l instanceof Error){const{name:r,message:n}=l,i=l.stacktrace||l.stack;return{$isError:!0,name:r,message:n,stack:i,noTelemetry:w.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=M;const v="Canceled";function f(l){return l instanceof p?!0:l instanceof Error&&l.name===v&&l.message===v}e.isCancellationError=f;class p extends Error{constructor(){super(v);this.name=this.message}}e.CancellationError=p;function C(){const l=new Error(v);return l.name=l.message,l}e.canceled=C;function k(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=k;function y(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=y;function g(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function u(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=u;function b(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=b;class m extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=m;class E extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=E;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;class w extends Error{constructor(r){super(r);this.name="ErrorNoTelemetry"}static fromError(r){if(r instanceof w)return r;const n=new w;return n.message=r.message,n.stack=r.stack,n}static isErrorNoTelemetry(r){return r.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=w;class h extends Error{constructor(r){super(r||"An unexpected bug occurred.");Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(X[25],J([0,1,19]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(U,j=0){return U[U.length-(1+j)]}e.tail=t;function D(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=D;function R(U,j,Z=(re,le)=>re===le){if(U===j)return!0;if(!U||!j||U.length!==j.length)return!1;for(let re=0,le=U.length;re<le;re++)if(!Z(U[re],j[re]))return!1;return!0}e.equals=R;function M(U,j){const Z=U.length-1;j<Z&&(U[j]=U[Z]),U.pop()}e.removeFastWithoutKeepingOrder=M;function v(U,j,Z){return f(U.length,re=>Z(U[re],j))}e.binarySearch=v;function f(U,j){let Z=0,re=U-1;for(;Z<=re;){const le=(Z+re)/2|0,ge=j(le);if(ge<0)Z=le+1;else if(ge>0)re=le-1;else return le}return-(Z+1)}e.binarySearch2=f;function p(U,j){let Z=0,re=U.length;if(re===0)return 0;for(;Z<re;){const le=Math.floor((Z+re)/2);j(U[le])?re=le:Z=le+1}return Z}e.findFirstInSorted=p;function C(U,j,Z){if(U=U|0,U>=j.length)throw new TypeError("invalid index");const re=j[Math.floor(j.length*Math.random())],le=[],ge=[],Ee=[];for(const De of j){const Ce=Z(De,re);Ce<0?le.push(De):Ce>0?ge.push(De):Ee.push(De)}return U<le.length?C(U,le,Z):U<le.length+Ee.length?Ee[0]:C(U-(le.length+Ee.length),ge,Z)}e.quickSelect=C;function k(U,j){const Z=[];let re;for(const le of U.slice(0).sort(j))!re||j(re[0],le)!==0?(re=[le],Z.push(re)):re.push(le);return Z}e.groupBy=k;function y(U,j,Z){const re=[];function le(De,Ce,ke){if(Ce===0&&ke.length===0)return;const Te=re[re.length-1];Te&&Te.start+Te.deleteCount===De?(Te.deleteCount+=Ce,Te.toInsert.push(...ke)):re.push({start:De,deleteCount:Ce,toInsert:ke})}let ge=0,Ee=0;for(;;){if(ge===U.length){le(ge,0,j.slice(Ee));break}if(Ee===j.length){le(ge,U.length-ge,[]);break}const De=U[ge],Ce=j[Ee],ke=Z(De,Ce);ke===0?(ge+=1,Ee+=1):ke<0?(le(ge,1,[]),ge+=1):ke>0&&(le(ge,0,[Ce]),Ee+=1)}return re}e.sortedDiff=y;function g(U,j,Z){const re=y(U,j,Z),le=[],ge=[];for(const Ee of re)le.push(...U.slice(Ee.start,Ee.start+Ee.deleteCount)),ge.push(...Ee.toInsert);return{removed:le,added:ge}}e.delta=g;function u(U,j,Z){if(Z===0)return[];const re=U.slice(0,Z).sort(j);return m(U,j,re,Z,U.length),re}e.top=u;function b(U,j,Z,re,le){return Z===0?Promise.resolve([]):new Promise((ge,Ee)=>{(async()=>{const De=U.length,Ce=U.slice(0,Z).sort(j);for(let ke=Z,Te=Math.min(Z+re,De);ke<De;ke=Te,Te=Math.min(Te+re,De)){if(ke>Z&&await new Promise(ue=>setTimeout(ue)),le&&le.isCancellationRequested)throw new S.CancellationError;m(U,j,Ce,ke,Te)}return Ce})().then(ge,Ee)})}e.topAsync=b;function m(U,j,Z,re,le){for(const ge=Z.length;re<le;re++){const Ee=U[re];if(j(Ee,Z[ge-1])<0){Z.pop();const De=p(Z,Ce=>j(Ee,Ce)<0);Z.splice(De,0,Ee)}}}function E(U){return U.filter(j=>!!j)}e.coalesce=E;function I(U){let j=0;for(let Z=0;Z<U.length;Z++)U[Z]&&(U[j]=U[Z],j+=1);U.length=j}e.coalesceInPlace=I;function w(U,j,Z){U.splice(Z,0,U.splice(j,1)[0])}e.move=w;function h(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=h;function l(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=l;function r(U,j=Z=>Z){const Z=new Set;return U.filter(re=>{const le=j(re);return Z.has(le)?!1:(Z.add(le),!0)})}e.distinct=r;function n(U){const j=new Set;return Z=>{const re=U(Z);return j.has(re)?!1:(j.add(re),!0)}}e.uniqueFilter=n;function i(U,j){const Z=s(U,j);if(Z!==-1)return U[Z]}e.findLast=i;function s(U,j){for(let Z=U.length-1;Z>=0;Z--){const re=U[Z];if(j(re))return Z}return-1}e.lastIndex=s;function o(U,j){return U.length>0?U[0]:j}e.firstOrDefault=o;function a(U,j){return U.length>0?U[U.length-1]:j}e.lastOrDefault=a;function c(U,j,Z=(re,le)=>re===le){let re=0;for(let le=0,ge=Math.min(U.length,j.length);le<ge&&Z(U[le],j[le]);le++)re++;return re}e.commonPrefixLength=c;function d(U){return[].concat(...U)}e.flatten=d;function P(U,j){let Z=typeof j=="number"?U:0;typeof j=="number"?Z=U:(Z=0,j=U);const re=[];if(Z<=j)for(let le=Z;le<j;le++)re.push(le);else for(let le=Z;le>j;le--)re.push(le);return re}e.range=P;function L(U,j,Z){return U.reduce((re,le)=>(re[j(le)]=Z?Z(le):le,re),Object.create(null))}e.index=L;function T(U,j){return U.push(j),()=>W(U,j)}e.insert=T;function W(U,j){const Z=U.indexOf(j);if(Z>-1)return U.splice(Z,1),j}e.remove=W;function q(U,j,Z){const re=U.slice(0,j),le=U.slice(j);return re.concat(Z,le)}e.arrayInsert=q;function ee(U,j){let Z;if(typeof j=="number"){let re=j;Z=()=>{const le=Math.sin(re++)*179426549;return le-Math.floor(le)}}else Z=Math.random;for(let re=U.length-1;re>0;re-=1){const le=Math.floor(Z()*(re+1)),ge=U[re];U[re]=U[le],U[le]=ge}}e.shuffle=ee;function se(U,j){const Z=U.indexOf(j);Z>-1&&(U.splice(Z,1),U.unshift(j))}e.pushToStart=se;function ae(U,j){const Z=U.indexOf(j);Z>-1&&(U.splice(Z,1),U.push(j))}e.pushToEnd=ae;function te(U,j){for(const Z of j)U.push(Z)}e.pushMany=te;function ce(U,j){return Array.isArray(U)?U.map(j):j(U)}e.mapArrayOrNot=ce;function H(U){return Array.isArray(U)?U:[U]}e.asArray=H;function ne(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=ne;function F(U,j){for(const Z of U){const re=j(Z);if(re!==void 0)return re}}e.mapFind=F;function _(U,j,Z){const re=G(U,j),le=U.length,ge=Z.length;U.length=le+ge;for(let Ee=le-1;Ee>=re;Ee--)U[Ee+ge]=U[Ee];for(let Ee=0;Ee<ge;Ee++)U[Ee+re]=Z[Ee]}e.insertInto=_;function B(U,j,Z,re){const le=G(U,j),ge=U.splice(le,Z);return _(U,le,re),ge}e.splice=B;function G(U,j){return j<0?Math.max(j+U.length,0):Math.min(j,U.length)}var ie;(function(U){function j(le){return le<0}U.isLessThan=j;function Z(le){return le>0}U.isGreaterThan=Z;function re(le){return le===0}U.isNeitherLessOrGreaterThan=re,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function V(U,j){return(Z,re)=>j(U(Z),U(re))}e.compareBy=V;function Q(...U){return(j,Z)=>{for(const re of U){const le=re(j,Z);if(!ie.isNeitherLessOrGreaterThan(le))return le}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=Q;const A=(U,j)=>U-j;e.numberComparator=A;function O(U,j){if(U.length===0)return;let Z=U[0];for(let re=1;re<U.length;re++){const le=U[re];j(le,Z)>0&&(Z=le)}return Z}e.findMaxBy=O;function N(U,j){if(U.length===0)return;let Z=U[0];for(let re=1;re<U.length;re++){const le=U[re];j(le,Z)>=0&&(Z=le)}return Z}e.findLastMaxBy=N;function $(U,j){return O(U,(Z,re)=>-j(Z,re))}e.findMinBy=$;class Y{constructor(j){this.items=j,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(j){let Z=this.firstIdx;for(;Z<this.items.length&&j(this.items[Z]);)Z++;const re=Z===this.firstIdx?null:this.items.slice(this.firstIdx,Z);return this.firstIdx=Z,re}takeFromEndWhile(j){let Z=this.lastIdx;for(;Z>=0&&j(this.items[Z]);)Z--;const re=Z===this.lastIdx?null:this.items.slice(Z+1,this.lastIdx+1);return this.lastIdx=Z,re}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const j=this.items[this.firstIdx];return this.firstIdx++,j}removeLast(){const j=this.items[this.lastIdx];return this.lastIdx--,j}takeCount(j){const Z=this.items.slice(this.firstIdx,this.firstIdx+j);return this.firstIdx+=j,Z}}e.ArrayQueue=Y}),define(X[48],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(t){const D=this;let R=!1,M;return function(){return R||(R=!0,M=t.apply(D,arguments)),M}}e.once=S}),define(X[54],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(t){function D(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=D;const R=Object.freeze([]);function M(){return R}t.empty=M;function*v(n){yield n}t.single=v;function f(n){return n||R}t.from=f;function p(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=p;function C(n){return n[Symbol.iterator]().next().value}t.first=C;function k(n,i){for(const s of n)if(i(s))return!0;return!1}t.some=k;function y(n,i){for(const s of n)if(i(s))return s}t.find=y;function*g(n,i){for(const s of n)i(s)&&(yield s)}t.filter=g;function*u(n,i){let s=0;for(const o of n)yield i(o,s++)}t.map=u;function*b(...n){for(const i of n)for(const s of i)yield s}t.concat=b;function*m(n){for(const i of n)for(const s of i)yield s}t.concatNested=m;function E(n,i,s){let o=s;for(const a of n)o=i(o,a);return o}t.reduce=E;function I(n,i){let s=0;for(const o of n)i(o,s++)}t.forEach=I;function*w(n,i,s=n.length){for(i<0&&(i+=n.length),s<0?s+=n.length:s>n.length&&(s=n.length);i<s;i++)yield n[i]}t.slice=w;function h(n,i=Number.POSITIVE_INFINITY){const s=[];if(i===0)return[s,n];const o=n[Symbol.iterator]();for(let a=0;a<i;a++){const c=o.next();if(c.done)return[s,t.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return o}}]}t.consume=h;function l(n){return h(n)[0]}t.collect=l;function r(n,i,s=(o,a)=>o===a){const o=n[Symbol.iterator](),a=i[Symbol.iterator]();for(;;){const c=o.next(),d=a.next();if(c.done!==d.done)return!1;if(c.done)return!0;if(!s(c.value,d.value))return!1}}t.equals=r})(S=e.Iterable||(e.Iterable={}))}),define(X[49],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(r){r.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function M(r,n=!1){let i=0;const s=r.length;let o="",a=0,c=16,d=0;function P(ae){let te=0,ce=0;for(;te<ae;){const H=r.charCodeAt(i);if(H>=48&&H<=57)ce=ce*16+H-48;else if(H>=65&&H<=70)ce=ce*16+H-65+10;else if(H>=97&&H<=102)ce=ce*16+H-97+10;else break;i++,te++}return te<ae&&(ce=-1),ce}function L(ae){i=ae,o="",a=0,c=16,d=0}function T(){const ae=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&p(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&p(r.charCodeAt(i)))for(i++;i<r.length&&p(r.charCodeAt(i));)i++;else return d=3,r.substring(ae,i);let te=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&p(r.charCodeAt(i))){for(i++;i<r.length&&p(r.charCodeAt(i));)i++;te=i}else d=3;return r.substring(ae,te)}function W(){let ae="",te=i;for(;;){if(i>=s){ae+=r.substring(te,i),d=2;break}const ce=r.charCodeAt(i);if(ce===34){ae+=r.substring(te,i),i++;break}if(ce===92){if(ae+=r.substring(te,i),i++,i>=s){d=2;break}switch(r.charCodeAt(i++)){case 34:ae+='"';break;case 92:ae+="\\";break;case 47:ae+="/";break;case 98:ae+="\b";break;case 102:ae+="\f";break;case 110:ae+=`
`;break;case 114:ae+="\r";break;case 116:ae+="	";break;case 117:{const ne=P(4);ne>=0?ae+=String.fromCharCode(ne):d=4;break}default:d=5}te=i;continue}if(ce>=0&&ce<=31)if(f(ce)){ae+=r.substring(te,i),d=2;break}else d=6;i++}return ae}function q(){if(o="",d=0,a=i,i>=s)return a=s,c=17;let ae=r.charCodeAt(i);if(v(ae)){do i++,o+=String.fromCharCode(ae),ae=r.charCodeAt(i);while(v(ae));return c=15}if(f(ae))return i++,o+=String.fromCharCode(ae),ae===13&&r.charCodeAt(i)===10&&(i++,o+=`
`),c=14;switch(ae){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,o=W(),c=10;case 47:{const te=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<s&&!f(r.charCodeAt(i));)i++;return o=r.substring(te,i),c=12}if(r.charCodeAt(i+1)===42){i+=2;const ce=s-1;let H=!1;for(;i<ce;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,H=!0;break}i++}return H||(i++,d=1),o=r.substring(te,i),c=13}return o+=String.fromCharCode(ae),i++,c=16}case 45:if(o+=String.fromCharCode(ae),i++,i===s||!p(r.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),c=11;default:for(;i<s&&ee(ae);)i++,ae=r.charCodeAt(i);if(a!==i){switch(o=r.substring(a,i),o){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return o+=String.fromCharCode(ae),i++,c=16}}function ee(ae){if(v(ae)||f(ae))return!1;switch(ae){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ae;do ae=q();while(ae>=12&&ae<=15);return ae}return{setPosition:L,getPosition:()=>i,scan:n?se:q,getToken:()=>c,getTokenValue:()=>o,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>d}}e.createScanner=M;function v(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function f(r){return r===10||r===13||r===8232||r===8233}function p(r){return r>=48&&r<=57}var C;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(C||(C={}));function k(r,n){const i=[],s=new Object;let o;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function d(P,L,T,W){a.value=P,a.offset=L,a.length=T,a.type=W,a.colonOffset=void 0,o=a}try{w(r,{onObjectBegin:(P,L)=>{if(n<=P)throw s;o=void 0,c=n>P,i.push("")},onObjectProperty:(P,L,T)=>{if(n<L||(d(P,L,T,"property"),i[i.length-1]=P,n<=L+T))throw s},onObjectEnd:(P,L)=>{if(n<=P)throw s;o=void 0,i.pop()},onArrayBegin:(P,L)=>{if(n<=P)throw s;o=void 0,i.push(0)},onArrayEnd:(P,L)=>{if(n<=P)throw s;o=void 0,i.pop()},onLiteralValue:(P,L,T)=>{if(n<L||(d(P,L,T,l(P)),n<=L+T))throw s},onSeparator:(P,L,T)=>{if(n<=L)throw s;if(P===":"&&o&&o.type==="property")o.colonOffset=L,c=!1,o=void 0;else if(P===","){const W=i[i.length-1];typeof W=="number"?i[i.length-1]=W+1:(c=!0,i[i.length-1]=""),o=void 0}}})}catch(P){if(P!==s)throw P}return{path:i,previousNode:o,isAtPropertyKey:c,matches:P=>{let L=0;for(let T=0;L<P.length&&T<i.length;T++)if(P[L]===i[T]||P[L]==="*")L++;else if(P[L]!=="**")return!1;return L===P.length}}}e.getLocation=k;function y(r,n=[],i=R.DEFAULT){let s=null,o=[];const a=[];function c(P){Array.isArray(o)?o.push(P):s!==null&&(o[s]=P)}return w(r,{onObjectBegin:()=>{const P={};c(P),a.push(o),o=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const P=[];c(P),a.push(o),o=P,s=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:c,onError:(P,L,T)=>{n.push({error:P,offset:L,length:T})}},i),o[0]}e.parse=y;function g(r,n=[],i=R.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(P){s.type==="property"&&(s.length=P-s.offset,s=s.parent)}function a(P){return s.children.push(P),P}w(r,{onObjectBegin:P=>{s=a({type:"object",offset:P,length:-1,parent:s,children:[]})},onObjectProperty:(P,L,T)=>{s=a({type:"property",offset:L,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:P,offset:L,length:T,parent:s})},onObjectEnd:(P,L)=>{s.length=P+L-s.offset,s=s.parent,o(P+L)},onArrayBegin:(P,L)=>{s=a({type:"array",offset:P,length:-1,parent:s,children:[]})},onArrayEnd:(P,L)=>{s.length=P+L-s.offset,s=s.parent,o(P+L)},onLiteralValue:(P,L,T)=>{a({type:l(P),offset:L,length:T,parent:s,value:P}),o(L+T)},onSeparator:(P,L,T)=>{s.type==="property"&&(P===":"?s.colonOffset=L:P===","&&o(L))},onError:(P,L,T)=>{n.push({error:P,offset:L,length:T})}},i);const d=s.children[0];return d&&delete d.parent,d}e.parseTree=g;function u(r,n){if(!r)return;let i=r;for(const s of n)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===s){i=a.children[1],o=!0;break}if(!o)return}else{const o=s;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=u;function b(r){if(!r.parent||!r.parent.children)return[];const n=b(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;n.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&n.push(i)}return n}e.getNodePath=b;function m(r){switch(r.type){case"array":return r.children.map(m);case"object":{const n=Object.create(null);for(const i of r.children){const s=i.children[1];s&&(n[i.children[0].value]=m(s))}return n}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=m;function E(r,n,i=!1){return n>=r.offset&&n<r.offset+r.length||i&&n===r.offset+r.length}e.contains=E;function I(r,n,i=!1){if(E(r,n,i)){const s=r.children;if(Array.isArray(s))for(let o=0;o<s.length&&s[o].offset<=n;o++){const a=I(s[o],n,i);if(a)return a}return r}}e.findNodeAtOffset=I;function w(r,n,i=R.DEFAULT){const s=M(r,!1);function o(V){return V?()=>V(s.getTokenOffset(),s.getTokenLength()):()=>!0}function a(V){return V?Q=>V(Q,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=o(n.onObjectBegin),d=a(n.onObjectProperty),P=o(n.onObjectEnd),L=o(n.onArrayBegin),T=o(n.onArrayEnd),W=a(n.onLiteralValue),q=a(n.onSeparator),ee=o(n.onComment),se=a(n.onError),ae=i&&i.disallowComments,te=i&&i.allowTrailingComma;function ce(){for(;;){const V=s.scan();switch(s.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:ae||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(V){case 12:case 13:ae?H(10):ee();break;case 16:H(1);break;case 15:case 14:break;default:return V}}}function H(V,Q=[],A=[]){if(se(V),Q.length+A.length>0){let O=s.getToken();for(;O!==17;){if(Q.indexOf(O)!==-1){ce();break}else if(A.indexOf(O)!==-1)break;O=ce()}}}function ne(V){const Q=s.getTokenValue();return V?W(Q):d(Q),ce(),!0}function F(){switch(s.getToken()){case 11:{let V=0;try{V=JSON.parse(s.getTokenValue()),typeof V!="number"&&(H(2),V=0)}catch{H(2)}W(V);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return ce(),!0}function _(){return s.getToken()!==10?(H(3,[],[2,5]),!1):(ne(!1),s.getToken()===6?(q(":"),ce(),ie()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function B(){c(),ce();let V=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(V||H(4,[],[]),q(","),ce(),s.getToken()===2&&te)break}else V&&H(6,[],[]);_()||H(4,[],[2,5]),V=!0}return P(),s.getToken()!==2?H(7,[2],[]):ce(),!0}function G(){L(),ce();let V=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(V||H(4,[],[]),q(","),ce(),s.getToken()===4&&te)break}else V&&H(6,[],[]);ie()||H(4,[],[4,5]),V=!0}return T(),s.getToken()!==4?H(8,[4],[]):ce(),!0}function ie(){switch(s.getToken()){case 3:return G();case 1:return B();case 10:return ne(!0);default:return F()}}return ce(),s.getToken()===17?i.allowEmptyContent?!0:(H(4,[],[]),!1):ie()?(s.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=w;function h(r,n){const i=M(r),s=[];let o,a=0,c;do switch(c=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:a!==c&&s.push(r.substring(a,c)),n!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,n)),a=i.getPosition();break}while(o!==17);return s.join("")}e.stripComments=h;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(X[119],J([0,1,49]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(p,C,k){let y,g,u,b,m;if(C){for(b=C.offset,m=b+C.length,u=b;u>0&&!f(p,u-1);)u--;let c=m;for(;c<p.length&&!f(p,c);)c++;g=p.substring(u,c),y=M(g,k)}else g=p,y=0,u=0,b=0,m=p.length;const E=v(k,p);let I=!1,w=0,h;k.insertSpaces?h=R(" ",k.tabSize||4):h="	";const l=(0,S.createScanner)(g,!1);let r=!1;function n(){return E+R(h,y+w)}function i(){let c=l.scan();for(I=!1;c===15||c===14;)I=I||c===14,c=l.scan();return r=c===16||l.getTokenError()!==0,c}const s=[];function o(c,d,P){!r&&d<m&&P>b&&p.substring(d,P)!==c&&s.push({offset:d,length:P-d,content:c})}let a=i();if(a!==17){const c=l.getTokenOffset()+u,d=R(h,y);o(d,u,c)}for(;a!==17;){let c=l.getTokenOffset()+l.getTokenLength()+u,d=i(),P="";for(;!I&&(d===12||d===13);){const T=l.getTokenOffset()+u;o(" ",c,T),c=l.getTokenOffset()+l.getTokenLength()+u,P=d===12?n():"",d=i()}if(d===2)a!==1&&(w--,P=n());else if(d===4)a!==3&&(w--,P=n());else{switch(a){case 3:case 1:w++,P=n();break;case 5:case 12:P=n();break;case 13:I?P=n():P=" ";break;case 6:P=" ";break;case 10:if(d===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?P=" ":d!==5&&d!==17&&(r=!0);break;case 16:r=!0;break}I&&(d===12||d===13)&&(P=n())}const L=l.getTokenOffset()+u;o(P,c,L),a=d}return s}e.format=t;function D(p,C){const k=JSON.stringify(p,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?k.replace(/\r\n|\r|\n/g,C.eol):k}e.toFormattedString=D;function R(p,C){let k="";for(let y=0;y<C;y++)k+=p;return k}function M(p,C){let k=0,y=0;const g=C.tabSize||4;for(;k<p.length;){const u=p.charAt(k);if(u===" ")y++;else if(u==="	")y+=g;else break;k++}return Math.floor(y/g)}function v(p,C){for(let k=0;k<C.length;k++){const y=C.charAt(k);if(y==="\r")return k+1<C.length&&C.charAt(k+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=v;function f(p,C){return`\r
`.indexOf(p.charAt(C))!==-1}e.isEOL=f}),define(X[120],J([0,1,49,119]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(p,C,k){return R(p,C,void 0,k)}e.removeProperty=D;function R(p,C,k,y,g){const u=C.slice(),b=[],m=(0,S.parseTree)(p,b);let E,I;for(;u.length>0&&(I=u.pop(),E=(0,S.findNodeAtLocation)(m,u),E===void 0&&k!==void 0);)typeof I=="string"?k={[I]:k}:k=[k];if(E)if(E.type==="object"&&typeof I=="string"&&Array.isArray(E.children)){const w=(0,S.findNodeAtLocation)(E,[I]);if(w!==void 0)if(k===void 0){if(!w.parent)throw new Error("Malformed AST");const h=E.children.indexOf(w.parent);let l,r=w.parent.offset+w.parent.length;if(h>0){const n=E.children[h-1];l=n.offset+n.length}else l=E.offset+1,E.children.length>1&&(r=E.children[1].offset);return M(p,{offset:l,length:r-l,content:""},y)}else return M(p,{offset:w.offset,length:w.length,content:JSON.stringify(k)},y);else{if(k===void 0)return[];const h=`${JSON.stringify(I)}: ${JSON.stringify(k)}`,l=g?g(E.children.map(n=>n.children[0].value)):E.children.length;let r;if(l>0){const n=E.children[l-1];r={offset:n.offset+n.length,length:0,content:","+h}}else E.children.length===0?r={offset:E.offset+1,length:0,content:h}:r={offset:E.offset+1,length:0,content:h+","};return M(p,r,y)}}else if(E.type==="array"&&typeof I=="number"&&Array.isArray(E.children))if(k!==void 0){const w=`${JSON.stringify(k)}`;let h;if(E.children.length===0||I===0)h={offset:E.offset+1,length:0,content:E.children.length===0?w:w+","};else{const l=I===-1||I>E.children.length?E.children.length:I,r=E.children[l-1];h={offset:r.offset+r.length,length:0,content:","+w}}return M(p,h,y)}else{const w=I,h=E.children[w];let l;if(E.children.length===1)l={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===w){const r=E.children[w-1],n=r.offset+r.length,i=E.offset+E.length;l={offset:n,length:i-2-n,content:""}}else l={offset:h.offset,length:E.children[w+1].offset-h.offset,content:""};return M(p,l,y)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${E.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return M(p,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(k)},y)}}e.setProperty=R;function M(p,C,k){let y=v(p,C),g=C.offset,u=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;g>0&&!(0,t.isEOL)(y,g-1);)g--;for(;u<y.length&&!(0,t.isEOL)(y,u);)u++}const b=(0,t.format)(y,{offset:g,length:u-g},k);for(let E=b.length-1;E>=0;E--){const I=b[E];y=v(y,I),g=Math.min(g,I.offset),u=Math.max(u,I.offset+I.length),u+=I.content.length-I.length}const m=p.length-(y.length-u)-g;return[{offset:g,length:m,content:y.substring(g,u)}]}e.withFormatting=M;function v(p,C){return p.substring(0,C.offset)+C.content+p.substring(C.offset+C.length)}e.applyEdit=v;function f(p,C){const k=C.slice(0).sort((g,u)=>{const b=g.offset-u.offset;return b===0?g.length-u.length:b});let y=p.length;for(let g=k.length-1;g>=0;g--){const u=k[g];if(u.offset+u.length<=y)p=v(p,u);else throw new Error("Overlapping edit");y=u.offset}return p}e.applyEdits=f}),define(X[121],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class S{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new S(()=>D(this.getValue()))}}e.Lazy=S}),define(X[2],J([0,1,48,54]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let R=null;function M(o){R=o}if(e.setDisposableTracker=M,D){const o="__is_disposable_tracked__";M(new class{trackDisposable(a){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[o]||console.log(c)},3e3)}setParent(a,c){if(a&&a!==I.None)try{a[o]=!0}catch{}}markAsDisposed(a){if(a&&a!==I.None)try{a[o]=!0}catch{}}markAsSingleton(a){}})}function v(o){return R?.trackDisposable(o),o}function f(o){R?.markAsDisposed(o)}function p(o,a){R?.setParent(o,a)}function C(o,a){if(!!R)for(const c of o)R.setParent(c,a)}function k(o){return R?.markAsSingleton(o),o}e.markAsSingleton=k;class y extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=y;function g(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=g;function u(o){if(t.Iterable.is(o)){const a=[];for(const c of o)if(c)try{c.dispose()}catch(d){a.push(d)}if(a.length===1)throw a[0];if(a.length>1)throw new y(a);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=u;function b(...o){const a=m(()=>u(o));return C(o,a),a}e.combinedDisposable=b;function m(o){const a=v({dispose:(0,S.once)(()=>{f(a),o()})});return a}e.toDisposable=m;class E{constructor(){this._toDispose=new Set,this._isDisposed=!1,v(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return p(a,this),this._isDisposed?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=E,E.DISABLE_DISPOSED_WARNING=!1;class I{constructor(){this._store=new E,v(this),p(this._store,this)}dispose(){f(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=I,I.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,v(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&p(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&p(a,null),a}}e.MutableDisposable=w;class h{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(a){let c=a;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,f(this))},this}}e.SafeDisposable=l;class r{constructor(){this.references=new Map}acquire(a,...c){let d=this.references.get(a);d||(d={counter:0,object:this.createReferencedObject(a,...c)},this.references.set(a,d));const{object:P}=d,L=(0,S.once)(()=>{--d.counter==0&&(this.destroyReferencedObject(a,d.object),this.references.delete(a))});return d.counter++,{object:P,dispose:L}}}e.ReferenceCollection=r;class n{constructor(a){this.referenceCollection=a}async acquire(a,...c){const d=this.referenceCollection.acquire(a,...c);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(P){throw d.dispose(),P}}}e.AsyncReferenceCollection=n;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function s(o){const a=new E;try{o(a)}finally{a.dispose()}}e.disposeOnReturn=s}),define(X[122],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(R){this.element=R,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class t{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){let R=this._first;for(;R!==S.Undefined;){const M=R.next;R.prev=S.Undefined,R.next=S.Undefined,R=M}this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,M){const v=new S(R);if(this._first===S.Undefined)this._first=v,this._last=v;else if(M){const p=this._last;this._last=v,v.prev=p,p.next=v}else{const p=this._first;this._first=v,v.next=p,p.prev=v}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(v))}}shift(){if(this._first!==S.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==S.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==S.Undefined&&R.next!==S.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===S.Undefined&&R.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):R.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):R.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==S.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function z(D){const R=[];typeof D=="number"&&R.push("code/timeOrigin",D);function M(f){R.push(f,Date.now())}function v(){const f=[];for(let p=0;p<R.length;p+=2)f.push({name:R[p],startTime:R[p+1]});return f}return{mark:M,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(D+M.startTime)});return R}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function S(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=S(t))}(),define(X[123],J([0,1]),function(z,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(v,f,p){this.level=v,this.key=f,this.value=p,this.forward=[]}}const D=void 0;class R{constructor(v,f=2**16){this.comparator=v,this[S]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(f)|0),this._header=new t(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,D,D)}has(v){return Boolean(R._search(this,v,this.comparator))}get(v){return R._search(this,v,this.comparator)?.value}set(v,f){return R._insert(this,v,f,this.comparator)&&(this._size+=1),this}delete(v){const f=R._delete(this,v,this.comparator);return f&&(this._size-=1),f}forEach(v,f){let p=this._header.forward[0];for(;p;)v.call(f,p.value,p.key,this),p=p.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let v=this._header.forward[0];for(;v;)yield[v.key,v.value],v=v.forward[0]}*keys(){let v=this._header.forward[0];for(;v;)yield v.key,v=v.forward[0]}*values(){let v=this._header.forward[0];for(;v;)yield v.value,v=v.forward[0]}toString(){let v="[SkipList]:",f=this._header.forward[0];for(;f;)v+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return v}static _search(v,f,p){let C=v._header;for(let k=v._level-1;k>=0;k--)for(;C.forward[k]&&p(C.forward[k].key,f)<0;)C=C.forward[k];if(C=C.forward[0],C&&p(C.key,f)===0)return C}static _insert(v,f,p,C){const k=[];let y=v._header;for(let g=v._level-1;g>=0;g--){for(;y.forward[g]&&C(y.forward[g].key,f)<0;)y=y.forward[g];k[g]=y}if(y=y.forward[0],y&&C(y.key,f)===0)return y.value=p,!1;{const g=R._randomLevel(v);if(g>v._level){for(let u=v._level;u<g;u++)k[u]=v._header;v._level=g}y=new t(g,f,p);for(let u=0;u<g;u++)y.forward[u]=k[u].forward[u],k[u].forward[u]=y;return!0}}static _randomLevel(v,f=.5){let p=1;for(;Math.random()<f&&p<v._maxLevel;)p+=1;return p}static _delete(v,f,p){const C=[];let k=v._header;for(let y=v._level-1;y>=0;y--){for(;k.forward[y]&&p(k.forward[y].key,f)<0;)k=k.forward[y];C[y]=k}if(k=k.forward[0],!k||p(k.key,f)!==0)return!1;for(let y=0;y<v._level&&C[y].forward[y]===k;y++)C[y].forward[y]=k.forward[y];for(;v._level>0&&v._header.forward[v._level-1]===D;)v._level-=1;return!0}}e.SkipList=R}),define(X[55],J([0,1,19,2]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(h){const l=h;return l?typeof l.read=="function":!1}e.isReadable=D;function R(h){const l=h;return l?[l.on,l.pause,l.resume,l.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=R;function M(h){const l=h;return l?R(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=M;function v(h,l){return new f(h,l)}e.newWriteableStream=v;class f{constructor(l,r){this.reducer=l,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(r=>r(l))}emitError(l){this.listeners.error.length===0?(0,S.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(r=>r(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,r){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(l,r){if(this.state.destroyed)return;let n;switch(l){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const i=n.indexOf(r);i>=0&&n.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(h,l){const r=[];let n;for(;(n=h.read())!==null;)r.push(n);return l(r)}e.consumeReadable=p;function C(h,l,r){const n=[];let i;for(;(i=h.read())!==null&&n.length<r;)n.push(i);return i===null&&n.length>0?l(n):{read:()=>{if(n.length>0)return n.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return h.read()}}}e.peekReadable=C;function k(h,l){return new Promise((r,n)=>{const i=[];y(h,{onData:s=>{l&&i.push(s)},onError:s=>{l?n(s):r(void 0)},onEnd:()=>{r(l?l(i):void 0)}})})}e.consumeStream=k;function y(h,l){let r=!1;return h.on("error",n=>{r||l.onError(n)}),h.on("end",()=>{r||l.onEnd()}),h.on("data",n=>{r||l.onData(n)}),(0,t.toDisposable)(()=>r=!0)}e.listenStream=y;function g(h,l){return new Promise((r,n)=>{const i=new t.DisposableStore,s=[],o=d=>{if(s.push(d),s.length>l)return i.dispose(),h.pause(),r({stream:h,buffer:s,ended:!1})},a=d=>n(d),c=()=>r({stream:h,buffer:s,ended:!0});i.add((0,t.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),i.add((0,t.toDisposable)(()=>h.removeListener("end",c))),h.on("end",c),i.add((0,t.toDisposable)(()=>h.removeListener("data",o))),h.on("data",o)})}e.peekStream=g;function u(h,l){const r=v(l);return r.end(h),r}e.toStream=u;function b(){const h=v(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=b;function m(h){let l=!1;return{read:()=>l?null:(l=!0,h)}}e.toReadable=m;function E(h,l,r){const n=v(r);return y(h,{onData:i=>n.write(l.data(i)),onError:i=>n.error(l.error?l.error(i):i),onEnd:()=>n.end()}),n}e.transform=E;function I(h,l,r){let n=!1;return{read:()=>{const i=l.read();return n?i:(n=!0,i!==null?r([h,i]):h)}}}e.prefixedReadable=I;function w(h,l,r){let n=!1;const i=v(r);return y(l,{onData:s=>n?i.write(s):(n=!0,i.write(r([h,s]))),onError:s=>i.error(s),onEnd:()=>{n||(n=!0,i.write(h)),i.end()}}),i}e.prefixedStream=w}),define(X[17],J([0,1,55]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let D,R;class M{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return t?new M(Buffer.allocUnsafe(d)):new M(new Uint8Array(d))}static wrap(d){return t&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new M(d)}static fromString(d,P){return!(P?.dontUseNodeBuffer||!1)&&t?new M(Buffer.from(d)):(D||(D=new TextEncoder),new M(D.encode(d)))}static fromByteArray(d){const P=M.alloc(d.length);for(let L=0,T=d.length;L<T;L++)P.buffer[L]=d[L];return P}static concat(d,P){if(typeof P=="undefined"){P=0;for(let W=0,q=d.length;W<q;W++)P+=d[W].byteLength}const L=M.alloc(P);let T=0;for(let W=0,q=d.length;W<q;W++){const ee=d[W];L.set(ee,T),T+=ee.byteLength}return L}clone(){const d=M.alloc(this.byteLength);return d.set(this),d}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(d,P){return new M(this.buffer.subarray(d,P))}set(d,P){if(d instanceof M)this.buffer.set(d.buffer,P);else if(d instanceof Uint8Array)this.buffer.set(d,P);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),P);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return p(this.buffer,d)}writeUInt32BE(d,P){C(this.buffer,d,P)}readUInt32LE(d){return k(this.buffer,d)}writeUInt32LE(d,P){y(this.buffer,d,P)}readUInt8(d){return g(this.buffer,d)}writeUInt8(d,P){u(this.buffer,d,P)}}e.VSBuffer=M;function v(c,d){return c[d+0]<<0>>>0|c[d+1]<<8>>>0}e.readUInt16LE=v;function f(c,d,P){c[P+0]=d&255,d=d>>>8,c[P+1]=d&255}e.writeUInt16LE=f;function p(c,d){return c[d]*2**24+c[d+1]*2**16+c[d+2]*2**8+c[d+3]}e.readUInt32BE=p;function C(c,d,P){c[P+3]=d,d=d>>>8,c[P+2]=d,d=d>>>8,c[P+1]=d,d=d>>>8,c[P]=d}e.writeUInt32BE=C;function k(c,d){return c[d+0]<<0>>>0|c[d+1]<<8>>>0|c[d+2]<<16>>>0|c[d+3]<<24>>>0}e.readUInt32LE=k;function y(c,d,P){c[P+0]=d&255,d=d>>>8,c[P+1]=d&255,d=d>>>8,c[P+2]=d&255,d=d>>>8,c[P+3]=d&255}e.writeUInt32LE=y;function g(c,d){return c[d]}e.readUInt8=g;function u(c,d,P){c[P]=d}e.writeUInt8=u;function b(c){return S.consumeReadable(c,d=>M.concat(d))}e.readableToBuffer=b;function m(c){return S.toReadable(c)}e.bufferToReadable=m;function E(c){return S.consumeStream(c,d=>M.concat(d))}e.streamToBuffer=E;async function I(c){return c.ended?M.concat(c.buffer):M.concat([...c.buffer,await E(c.stream)])}e.bufferedStreamToBuffer=I;function w(c){return S.toStream(c,d=>M.concat(d))}e.bufferToStream=w;function h(c){return S.transform(c,{data:d=>typeof d=="string"?M.fromString(d):M.wrap(d)},d=>M.concat(d))}e.streamToBufferReadableStream=h;function l(c){return S.newWriteableStream(d=>M.concat(d),c)}e.newWriteableBufferStream=l;function r(c,d){return S.prefixedReadable(c,d,P=>M.concat(P))}e.prefixedBufferReadable=r;function n(c,d){return S.prefixedStream(c,d,P=>M.concat(P))}e.prefixedBufferStream=n;function i(c){let d=0,P=0,L=0;const T=new Uint8Array(Math.floor(c.length/4*3)),W=ee=>{switch(P){case 3:T[L++]=d|ee,P=0;break;case 2:T[L++]=d|ee>>>2,d=ee<<6,P=3;break;case 1:T[L++]=d|ee>>>4,d=ee<<4,P=2;break;default:d=ee<<2,P=1}};for(let ee=0;ee<c.length;ee++){const se=c.charCodeAt(ee);if(se>=65&&se<=90)W(se-65);else if(se>=97&&se<=122)W(se-97+26);else if(se>=48&&se<=57)W(se-48+52);else if(se===43||se===45)W(62);else if(se===47||se===95)W(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${c[ee]}`)}}const q=L;for(;P>0;)W(0);return M.wrap(T).slice(0,q)}e.decodeBase64=i;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:c},d=!0,P=!1){const L=P?o:s;let T="";const W=c.byteLength%3;let q=0;for(;q<c.byteLength-W;q+=3){const ee=c[q+0],se=c[q+1],ae=c[q+2];T+=L[ee>>>2],T+=L[(ee<<4|se>>>4)&63],T+=L[(se<<2|ae>>>6)&63],T+=L[ae&63]}if(W===1){const ee=c[q+0];T+=L[ee>>>2],T+=L[ee<<4&63],d&&(T+="==")}else if(W===2){const ee=c[q+0],se=c[q+1];T+=L[ee>>>2],T+=L[(ee<<4|se>>>4)&63],T+=L[se<<2&63],d&&(T+="=")}return T}e.encodeBase64=a}),define(X[13],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function S(c){return Array.isArray(c)}e.isArray=S;function t(c){return typeof c=="string"}e.isString=t;function D(c){return Array.isArray(c)&&c.every(d=>t(d))}e.isStringArray=D;function R(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=R;function M(c){const d=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof d}e.isTypedArray=M;function v(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=v;function f(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=f;function p(c){return c===!0||c===!1}e.isBoolean=p;function C(c){return typeof c=="undefined"}e.isUndefined=C;function k(c){return!y(c)}e.isDefined=k;function y(c){return C(c)||c===null}e.isUndefinedOrNull=y;function g(c,d){if(!c)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}e.assertType=g;function u(c){if(y(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=u;function b(...c){const d=[];for(let P=0;P<c.length;P++){const L=c[P];if(y(L))throw new Error(`Assertion Failed: argument at index ${P} is undefined or null`);d.push(L)}return d}e.assertAllDefined=b;const m=Object.prototype.hasOwnProperty;function E(c){if(!R(c))return!1;for(const d in c)if(m.call(c,d))return!1;return!0}e.isEmptyObject=E;function I(c){return typeof c=="function"}e.isFunction=I;function w(...c){return c.length>0&&c.every(I)}e.areFunctions=w;function h(c,d){const P=Math.min(c.length,d.length);for(let L=0;L<P;L++)l(c[L],d[L])}e.validateConstraints=h;function l(c,d){if(t(d)){if(typeof c!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(I(d)){try{if(c instanceof d)return}catch{}if(!y(c)&&c.constructor===d||d.length===1&&d.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function r(c){let d=[],P=Object.getPrototypeOf(c);for(;Object.prototype!==P;)d=d.concat(Object.getOwnPropertyNames(P)),P=Object.getPrototypeOf(P);return d}e.getAllPropertyNames=r;function n(c){const d=[];for(const P of r(c))typeof c[P]=="function"&&d.push(P);return d}e.getAllMethodNames=n;function i(c,d){const P=T=>function(){const W=Array.prototype.slice.call(arguments,0);return d(T,W)},L={};for(const T of c)L[T]=P(T);return L}e.createProxyObject=i;function s(c){return c===null?void 0:c}e.withNullAsUndefined=s;function o(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=o;function a(c,d="Unreachable"){throw new Error(d)}e.assertNever=a}),define(X[50],J([0,1,13]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const b=Array.isArray(u)?[]:{};return Object.keys(u).forEach(m=>{u[m]&&typeof u[m]=="object"?b[m]=t(u[m]):b[m]=u[m]}),b}e.deepClone=t;function D(u){if(!u||typeof u!="object")return u;const b=[u];for(;b.length>0;){const m=b.shift();Object.freeze(m);for(const E in m)if(R.call(m,E)){const I=m[E];typeof I=="object"&&!Object.isFrozen(I)&&!(0,S.isTypedArray)(I)&&b.push(I)}}return u}e.deepFreeze=D;const R=Object.prototype.hasOwnProperty;function M(u,b){return v(u,b,new Set)}e.cloneAndChange=M;function v(u,b,m){if((0,S.isUndefinedOrNull)(u))return u;const E=b(u);if(typeof E!="undefined")return E;if((0,S.isArray)(u)){const I=[];for(const w of u)I.push(v(w,b,m));return I}if((0,S.isObject)(u)){if(m.has(u))throw new Error("Cannot clone recursive data-structure");m.add(u);const I={};for(const w in u)R.call(u,w)&&(I[w]=v(u[w],b,m));return m.delete(u),I}return u}function f(u,b,m=!0){return(0,S.isObject)(u)?((0,S.isObject)(b)&&Object.keys(b).forEach(E=>{E in u?m&&((0,S.isObject)(u[E])&&(0,S.isObject)(b[E])?f(u[E],b[E],m):u[E]=b[E]):u[E]=b[E]}),u):b}e.mixin=f;function p(u,b){if(u===b)return!0;if(u==null||b===null||b===void 0||typeof u!=typeof b||typeof u!="object"||Array.isArray(u)!==Array.isArray(b))return!1;let m,E;if(Array.isArray(u)){if(u.length!==b.length)return!1;for(m=0;m<u.length;m++)if(!p(u[m],b[m]))return!1}else{const I=[];for(E in u)I.push(E);I.sort();const w=[];for(E in b)w.push(E);if(w.sort(),!p(I,w))return!1;for(m=0;m<I.length;m++)if(!p(u[I[m]],b[I[m]]))return!1}return!0}e.equals=p;function C(u){const b=new Set;return JSON.stringify(u,(m,E)=>{if((0,S.isObject)(E)||Array.isArray(E)){if(b.has(E))return"[Circular]";b.add(E)}return E})}e.safeStringify=C;function k(u,b){const m=Object.create(null);return!u||!b||Object.keys(b).forEach(I=>{const w=u[I],h=b[I];p(w,h)||(m[I]=h)}),m}e.distinct=k;function y(u,b){const m=b.toLowerCase(),E=Object.keys(u).find(I=>I.toLowerCase()===m);return E?u[E]:u[b]}e.getCaseInsensitive=y;function g(u,b){const m=Object.create(null);for(const[E,I]of Object.entries(u))b(E,I)&&(m[E]=I);return m}e.filter=g}),define(X[27],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return S.test(D)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(v){for(let f=0;f<v.length;f++)v[f]=Math.floor(Math.random()*256);return v};const R=new Uint8Array(16),M=[];for(let v=0;v<256;v++)M.push(v.toString(16).padStart(2,"0"));return function(){D(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let f=0,p="";return p+=M[R[f++]],p+=M[R[f++]],p+=M[R[f++]],p+=M[R[f++]],p+="-",p+=M[R[f++]],p+=M[R[f++]],p+="-",p+=M[R[f++]],p+=M[R[f++]],p+="-",p+=M[R[f++]],p+=M[R[f++]],p+="-",p+=M[R[f++]],p+=M[R[f++]],p+=M[R[f++]],p+=M[R[f++]],p+=M[R[f++]],p+=M[R[f++]],p}}()}),define(X[124],J([0,1,75,28,48]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(M,v){if(await new Promise((C,k)=>{const y=t.createReadStream(M),g=S.createHash("sha1");y.pipe(g);const u=(0,D.once)((b,m)=>{y.removeAllListeners(),g.removeAllListeners(),b?k(b):C(m)});y.once("error",u),y.once("end",u),g.once("error",u),g.once("data",b=>u(void 0,b.toString("hex")))})!==v)throw new Error("Hash mismatch")}e.checksum=R}),define(X[125],J([0,1,126]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(R="utf8"){this.stringDecoder=new S.StringDecoder(R),this.remaining=null}write(R){const M=[],v=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(v.length<1)return M;let f=0,p,C=f;for(;C<v.length;)if(p=v.charCodeAt(C),p===13||p===10){if(M.push(v.substring(f,C)),C++,C<v.length){const k=p;p=v.charCodeAt(C),(k===13&&p===10||k===10&&p===13)&&C++}f=C}else C++;return this.remaining=f<v.length?v.substr(f):null,M}end(){return this.remaining}}e.LineDecoder=t}),define(X[127],J([0,1,29]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(M){const v=M.replace(/\-/g,":").toLowerCase();return!t.has(v)}function R(){const M=(0,S.networkInterfaces)();for(const v in M){const f=M[v];if(f){for(const{mac:p}of f)if(D(p))return p}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(X[90],J([0,1,76]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(v,f,p,C=1){let k=!1;return new Promise(y=>{const g=setTimeout(()=>{if(!k)return k=!0,y(0)},p);D(v,f,C,u=>{if(!k)return k=!0,clearTimeout(g),y(u)})})}e.findFreePort=t;function D(v,f,p,C){if(f===0)return C(0);const k=new S.Socket;k.once("connect",()=>(M(k),D(v+p,f-1,p,C))),k.once("data",()=>{}),k.once("error",y=>(M(k),y.code!=="ECONNREFUSED"?D(v+p,f-1,p,C):C(v))),k.connect(v,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(v,f,p){let C=!1,k,y=1;const g=S.createServer({pauseOnConnect:!0});function u(b,m){C||(C=!0,g.removeAllListeners(),g.close(),k&&clearTimeout(k),m(b))}return new Promise(b=>{k=setTimeout(()=>{u(0,b)},p),g.on("listening",()=>{u(v,b)}),g.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&y<f?(v++,y++,g.listen(v,"127.0.0.1")):u(0,b)}),g.on("close",()=>{u(0,b)}),g.listen(v,"127.0.0.1")})}e.findFreePortFaster=R;function M(v){try{v.removeAllListeners("connect"),v.removeAllListeners("error"),v.end(),v.destroy(),v.unref()}catch(f){console.error(f)}}}),define(X[128],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(X[129],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class S{constructor(D,R){this.sender=D,this.onMessage=R}send(D){try{this.sender.send("vscode:message",D.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=S}),define(X[38],J([0,1,14,19]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class D{constructor(){this.mapListenerToWrapper=new WeakMap}on(M,v){const f=(p,...C)=>{this.validateEvent(M,p)&&v(p,...C)};return this.mapListenerToWrapper.set(v,f),S.ipcMain.on(M,f),this}once(M,v){return S.ipcMain.once(M,(f,...p)=>{this.validateEvent(M,f)&&v(f,...p)}),this}handle(M,v){return S.ipcMain.handle(M,(f,...p)=>this.validateEvent(M,f)?v(f,...p):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return S.ipcMain.removeHandler(M),this}removeListener(M,v){const f=this.mapListenerToWrapper.get(v);return f&&(S.ipcMain.removeListener(M,f),this.mapListenerToWrapper.delete(v)),this}validateEvent(M,v){if(!M||!M.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const f=v.senderFrame,p=f.url;if(!p)return!0;let C="unknown";try{C=new URL(p).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${p}'.`),!1}return C!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${C}'.`),!1):f.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${C}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new D}),define(X[130],J([0,1,14,38,13,128]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(f,p,C,k,y)=>{const g=v(f,k,C);g.popup({window:(0,D.withNullAsUndefined)(S.BrowserWindow.fromWebContents(f.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{g&&f.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,p)}})})}e.registerContextMenuListener=M;function v(f,p,C){const k=new S.Menu;return C.forEach(y=>{let g;y.type==="separator"?g=new S.MenuItem({type:y.type}):Array.isArray(y.submenu)?g=new S.MenuItem({submenu:v(f,p,y.submenu),label:y.label}):g=new S.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(u,b,m)=>f.sender.send(p,y.id,m)}),k.append(g)}),k}}),define(X[131],J([11,10]),function(z,e){return z.create("vs/base/common/date",e)}),define(X[132],J([0,1,131]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,R=D*24,M=R*7,v=R*30,f=R*365;function p(k,y,g){typeof k!="number"&&(k=k.getTime());const u=Math.round((new Date().getTime()-k)/1e3);if(u<-30)return(0,S.localize)(0,null,p(new Date().getTime()+u*1e3,!1));if(u<30)return(0,S.localize)(1,null);let b;return u<t?(b=u,y?b===1?g?(0,S.localize)(2,null,b):(0,S.localize)(3,null,b):g?(0,S.localize)(4,null,b):(0,S.localize)(5,null,b):b===1?g?(0,S.localize)(6,null,b):(0,S.localize)(7,null,b):g?(0,S.localize)(8,null,b):(0,S.localize)(9,null,b)):u<D?(b=Math.floor(u/t),y?b===1?g?(0,S.localize)(10,null,b):(0,S.localize)(11,null,b):g?(0,S.localize)(12,null,b):(0,S.localize)(13,null,b):b===1?g?(0,S.localize)(14,null,b):(0,S.localize)(15,null,b):g?(0,S.localize)(16,null,b):(0,S.localize)(17,null,b)):u<R?(b=Math.floor(u/D),y?b===1?g?(0,S.localize)(18,null,b):(0,S.localize)(19,null,b):g?(0,S.localize)(20,null,b):(0,S.localize)(21,null,b):b===1?g?(0,S.localize)(22,null,b):(0,S.localize)(23,null,b):g?(0,S.localize)(24,null,b):(0,S.localize)(25,null,b)):u<M?(b=Math.floor(u/R),y?b===1?(0,S.localize)(26,null,b):(0,S.localize)(27,null,b):b===1?(0,S.localize)(28,null,b):(0,S.localize)(29,null,b)):u<v?(b=Math.floor(u/M),y?b===1?g?(0,S.localize)(30,null,b):(0,S.localize)(31,null,b):g?(0,S.localize)(32,null,b):(0,S.localize)(33,null,b):b===1?g?(0,S.localize)(34,null,b):(0,S.localize)(35,null,b):g?(0,S.localize)(36,null,b):(0,S.localize)(37,null,b)):u<f?(b=Math.floor(u/v),y?b===1?g?(0,S.localize)(38,null,b):(0,S.localize)(39,null,b):g?(0,S.localize)(40,null,b):(0,S.localize)(41,null,b):b===1?g?(0,S.localize)(42,null,b):(0,S.localize)(43,null,b):g?(0,S.localize)(44,null,b):(0,S.localize)(45,null,b)):(b=Math.floor(u/f),y?b===1?g?(0,S.localize)(46,null,b):(0,S.localize)(47,null,b):g?(0,S.localize)(48,null,b):(0,S.localize)(49,null,b):b===1?g?(0,S.localize)(50,null,b):(0,S.localize)(51,null,b):g?(0,S.localize)(52,null,b):(0,S.localize)(53,null,b))}e.fromNow=p;function C(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(X[133],J([11,10]),function(z,e){return z.create("vs/base/common/errorMessage",e)}),define(X[41],J([0,1,25,13,133]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(k,y){return y&&(k.stack||k.stacktrace)?D.localize(0,null,v(k),M(k.stack)||M(k.stacktrace)):v(k)}function M(k){return Array.isArray(k)?k.join(`
`):k}function v(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?D.localize(1,null,k.message):k.message||D.localize(2,null)}function f(k=null,y=!1){if(!k)return D.localize(3,null);if(Array.isArray(k)){const g=S.coalesce(k),u=f(g[0],y);return g.length>1?D.localize(4,null,u,g.length):u}if(t.isString(k))return k;if(k.detail){const g=k.detail;if(g.error)return R(g.error,y);if(g.exception)return R(g.exception,y)}return k.stack?R(k,y):k.message?k.message:D.localize(5,null)}e.toErrorMessage=f;function p(k){const y=k;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=p;function C(k,y){let g;return typeof k=="string"?g=new Error(k):g=k,g.actions=y,g}e.createErrorWithActions=C}),define(X[134],J([11,10]),function(z,e){return z.create("vs/base/common/platform",e)}),define(X[4],J([0,1,134]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let D=!1,R=!1,M=!1,v=!1,f=!1,p=!1,C=!1,k=!1,y=!1,g,u=t,b,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let E;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?E=e.globals.vscode.process:typeof process!="undefined"&&(E=process);const I=typeof E?.versions?.electron=="string",w=I&&E?.type==="renderer";if(typeof navigator=="object"&&!w)m=navigator.userAgent,D=m.indexOf("Windows")>=0,R=m.indexOf("Macintosh")>=0,k=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=m.indexOf("Linux")>=0,p=!0,g=S.getConfiguredDefaultLocale(S.localize(0,null))||t,u=g;else if(typeof E=="object"){D=E.platform==="win32",R=E.platform==="darwin",M=E.platform==="linux",v=M&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,C=I,y=!!E.env.CI||!!E.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=t,u=t;const c=E.env.VSCODE_NLS_CONFIG;if(c)try{const d=JSON.parse(c),P=d.availableLanguages["*"];g=d.locale,u=P||t,b=d._translationsConfigFile}catch{}f=!0}else console.error("Unable to resolve platform.");var h;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function l(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let r=0;R?r=1:D?r=3:M&&(r=2),e.isWindows=D,e.isMacintosh=R,e.isLinux=M,e.isLinuxSnap=v,e.isNative=f,e.isElectron=C,e.isWeb=p,e.isWebWorker=p&&typeof e.globals.importScripts=="function",e.isIOS=k,e.isCI=y,e.platform=r,e.userAgent=m,e.language=u;var n;(function(c){function d(){return e.language}c.value=d;function P(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=P;function L(){return e.language==="en"}c.isDefault=L})(n=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=b,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const c=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let L=0,T=c.length;L<T;L++){const W=c[L];if(W.id===P.data.vscodeScheduleAsyncWork){c.splice(L,1),W.callback();return}}});let d=0;return P=>{const L=++d;c.push({id:L,callback:P}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return c=>setTimeout(c)})();var i;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||k?2:D?1:3;let s=!0,o=!1;function a(){if(!o){o=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,s=new Uint16Array(c.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(X[36],J([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof S.globals.vscode!="undefined"&&typeof S.globals.vscode.process!="undefined"){const D=S.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(X[9],J([0,1,36]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,R=90,M=122,v=46,f=47,p=92,C=58,k=63;class y extends Error{constructor(h,l,r){let n;typeof l=="string"&&l.indexOf("not ")===0?(n="must not be",l=l.replace(/^not /,"")):n="must be";const i=h.indexOf(".")!==-1?"property":"argument";let s=`The "${h}" ${i} ${n} of type ${l}`;s+=`. Received type ${typeof r}`;super(s);this.code="ERR_INVALID_ARG_TYPE"}}function g(w,h){if(typeof w!="string")throw new y(h,"string",w)}function u(w){return w===f||w===p}function b(w){return w===f}function m(w){return w>=t&&w<=R||w>=D&&w<=M}function E(w,h,l,r){let n="",i=0,s=-1,o=0,a=0;for(let c=0;c<=w.length;++c){if(c<w.length)a=w.charCodeAt(c);else{if(r(a))break;a=f}if(r(a)){if(!(s===c-1||o===1))if(o===2){if(n.length<2||i!==2||n.charCodeAt(n.length-1)!==v||n.charCodeAt(n.length-2)!==v){if(n.length>2){const d=n.lastIndexOf(l);d===-1?(n="",i=0):(n=n.slice(0,d),i=n.length-1-n.lastIndexOf(l)),s=c,o=0;continue}else if(n.length!==0){n="",i=0,s=c,o=0;continue}}h&&(n+=n.length>0?`${l}..`:"..",i=2)}else n.length>0?n+=`${l}${w.slice(s+1,c)}`:n=w.slice(s+1,c),i=c-s-1;s=c,o=0}else a===v&&o!==-1?++o:o=-1}return n}function I(w,h){if(h===null||typeof h!="object")throw new y("pathObject","Object",h);const l=h.dir||h.root,r=h.base||`${h.name||""}${h.ext||""}`;return l?l===h.root?`${l}${r}`:`${l}${w}${r}`:r}e.win32={resolve(...w){let h="",l="",r=!1;for(let n=w.length-1;n>=-1;n--){let i;if(n>=0){if(i=w[n],g(i,"path"),i.length===0)continue}else h.length===0?i=S.cwd():(i=S.env[`=${h}`]||S.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==h.toLowerCase()&&i.charCodeAt(2)===p)&&(i=`${h}\\`));const s=i.length;let o=0,a="",c=!1;const d=i.charCodeAt(0);if(s===1)u(d)&&(o=1,c=!0);else if(u(d))if(c=!0,u(i.charCodeAt(1))){let P=2,L=P;for(;P<s&&!u(i.charCodeAt(P));)P++;if(P<s&&P!==L){const T=i.slice(L,P);for(L=P;P<s&&u(i.charCodeAt(P));)P++;if(P<s&&P!==L){for(L=P;P<s&&!u(i.charCodeAt(P));)P++;(P===s||P!==L)&&(a=`\\\\${T}\\${i.slice(L,P)}`,o=P)}}}else o=1;else m(d)&&i.charCodeAt(1)===C&&(a=i.slice(0,2),o=2,s>2&&u(i.charCodeAt(2))&&(c=!0,o=3));if(a.length>0)if(h.length>0){if(a.toLowerCase()!==h.toLowerCase())continue}else h=a;if(r){if(h.length>0)break}else if(l=`${i.slice(o)}\\${l}`,r=c,c&&h.length>0)break}return l=E(l,!r,"\\",u),r?`${h}\\${l}`:`${h}${l}`||"."},normalize(w){g(w,"path");const h=w.length;if(h===0)return".";let l=0,r,n=!1;const i=w.charCodeAt(0);if(h===1)return b(i)?"\\":w;if(u(i))if(n=!0,u(w.charCodeAt(1))){let o=2,a=o;for(;o<h&&!u(w.charCodeAt(o));)o++;if(o<h&&o!==a){const c=w.slice(a,o);for(a=o;o<h&&u(w.charCodeAt(o));)o++;if(o<h&&o!==a){for(a=o;o<h&&!u(w.charCodeAt(o));)o++;if(o===h)return`\\\\${c}\\${w.slice(a)}\\`;o!==a&&(r=`\\\\${c}\\${w.slice(a,o)}`,l=o)}}}else l=1;else m(i)&&w.charCodeAt(1)===C&&(r=w.slice(0,2),l=2,h>2&&u(w.charCodeAt(2))&&(n=!0,l=3));let s=l<h?E(w.slice(l),!n,"\\",u):"";return s.length===0&&!n&&(s="."),s.length>0&&u(w.charCodeAt(h-1))&&(s+="\\"),r===void 0?n?`\\${s}`:s:n?`${r}\\${s}`:`${r}${s}`},isAbsolute(w){g(w,"path");const h=w.length;if(h===0)return!1;const l=w.charCodeAt(0);return u(l)||h>2&&m(l)&&w.charCodeAt(1)===C&&u(w.charCodeAt(2))},join(...w){if(w.length===0)return".";let h,l;for(let i=0;i<w.length;++i){const s=w[i];g(s,"path"),s.length>0&&(h===void 0?h=l=s:h+=`\\${s}`)}if(h===void 0)return".";let r=!0,n=0;if(typeof l=="string"&&u(l.charCodeAt(0))){++n;const i=l.length;i>1&&u(l.charCodeAt(1))&&(++n,i>2&&(u(l.charCodeAt(2))?++n:r=!1))}if(r){for(;n<h.length&&u(h.charCodeAt(n));)n++;n>=2&&(h=`\\${h.slice(n)}`)}return e.win32.normalize(h)},relative(w,h){if(g(w,"from"),g(h,"to"),w===h)return"";const l=e.win32.resolve(w),r=e.win32.resolve(h);if(l===r||(w=l.toLowerCase(),h=r.toLowerCase(),w===h))return"";let n=0;for(;n<w.length&&w.charCodeAt(n)===p;)n++;let i=w.length;for(;i-1>n&&w.charCodeAt(i-1)===p;)i--;const s=i-n;let o=0;for(;o<h.length&&h.charCodeAt(o)===p;)o++;let a=h.length;for(;a-1>o&&h.charCodeAt(a-1)===p;)a--;const c=a-o,d=s<c?s:c;let P=-1,L=0;for(;L<d;L++){const W=w.charCodeAt(n+L);if(W!==h.charCodeAt(o+L))break;W===p&&(P=L)}if(L!==d){if(P===-1)return r}else{if(c>d){if(h.charCodeAt(o+L)===p)return r.slice(o+L+1);if(L===2)return r.slice(o+L)}s>d&&(w.charCodeAt(n+L)===p?P=L:L===2&&(P=3)),P===-1&&(P=0)}let T="";for(L=n+P+1;L<=i;++L)(L===i||w.charCodeAt(L)===p)&&(T+=T.length===0?"..":"\\..");return o+=P,T.length>0?`${T}${r.slice(o,a)}`:(r.charCodeAt(o)===p&&++o,r.slice(o,a))},toNamespacedPath(w){if(typeof w!="string")return w;if(w.length===0)return"";const h=e.win32.resolve(w);if(h.length<=2)return w;if(h.charCodeAt(0)===p){if(h.charCodeAt(1)===p){const l=h.charCodeAt(2);if(l!==k&&l!==v)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(m(h.charCodeAt(0))&&h.charCodeAt(1)===C&&h.charCodeAt(2)===p)return`\\\\?\\${h}`;return w},dirname(w){g(w,"path");const h=w.length;if(h===0)return".";let l=-1,r=0;const n=w.charCodeAt(0);if(h===1)return u(n)?w:".";if(u(n)){if(l=r=1,u(w.charCodeAt(1))){let o=2,a=o;for(;o<h&&!u(w.charCodeAt(o));)o++;if(o<h&&o!==a){for(a=o;o<h&&u(w.charCodeAt(o));)o++;if(o<h&&o!==a){for(a=o;o<h&&!u(w.charCodeAt(o));)o++;if(o===h)return w;o!==a&&(l=r=o+1)}}}}else m(n)&&w.charCodeAt(1)===C&&(l=h>2&&u(w.charCodeAt(2))?3:2,r=l);let i=-1,s=!0;for(let o=h-1;o>=r;--o)if(u(w.charCodeAt(o))){if(!s){i=o;break}}else s=!1;if(i===-1){if(l===-1)return".";i=l}return w.slice(0,i)},basename(w,h){h!==void 0&&g(h,"ext"),g(w,"path");let l=0,r=-1,n=!0,i;if(w.length>=2&&m(w.charCodeAt(0))&&w.charCodeAt(1)===C&&(l=2),h!==void 0&&h.length>0&&h.length<=w.length){if(h===w)return"";let s=h.length-1,o=-1;for(i=w.length-1;i>=l;--i){const a=w.charCodeAt(i);if(u(a)){if(!n){l=i+1;break}}else o===-1&&(n=!1,o=i+1),s>=0&&(a===h.charCodeAt(s)?--s==-1&&(r=i):(s=-1,r=o))}return l===r?r=o:r===-1&&(r=w.length),w.slice(l,r)}for(i=w.length-1;i>=l;--i)if(u(w.charCodeAt(i))){if(!n){l=i+1;break}}else r===-1&&(n=!1,r=i+1);return r===-1?"":w.slice(l,r)},extname(w){g(w,"path");let h=0,l=-1,r=0,n=-1,i=!0,s=0;w.length>=2&&w.charCodeAt(1)===C&&m(w.charCodeAt(0))&&(h=r=2);for(let o=w.length-1;o>=h;--o){const a=w.charCodeAt(o);if(u(a)){if(!i){r=o+1;break}continue}n===-1&&(i=!1,n=o+1),a===v?l===-1?l=o:s!==1&&(s=1):l!==-1&&(s=-1)}return l===-1||n===-1||s===0||s===1&&l===n-1&&l===r+1?"":w.slice(l,n)},format:I.bind(null,"\\"),parse(w){g(w,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(w.length===0)return h;const l=w.length;let r=0,n=w.charCodeAt(0);if(l===1)return u(n)?(h.root=h.dir=w,h):(h.base=h.name=w,h);if(u(n)){if(r=1,u(w.charCodeAt(1))){let P=2,L=P;for(;P<l&&!u(w.charCodeAt(P));)P++;if(P<l&&P!==L){for(L=P;P<l&&u(w.charCodeAt(P));)P++;if(P<l&&P!==L){for(L=P;P<l&&!u(w.charCodeAt(P));)P++;P===l?r=P:P!==L&&(r=P+1)}}}}else if(m(n)&&w.charCodeAt(1)===C){if(l<=2)return h.root=h.dir=w,h;if(r=2,u(w.charCodeAt(2))){if(l===3)return h.root=h.dir=w,h;r=3}}r>0&&(h.root=w.slice(0,r));let i=-1,s=r,o=-1,a=!0,c=w.length-1,d=0;for(;c>=r;--c){if(n=w.charCodeAt(c),u(n)){if(!a){s=c+1;break}continue}o===-1&&(a=!1,o=c+1),n===v?i===-1?i=c:d!==1&&(d=1):i!==-1&&(d=-1)}return o!==-1&&(i===-1||d===0||d===1&&i===o-1&&i===s+1?h.base=h.name=w.slice(s,o):(h.name=w.slice(s,i),h.base=w.slice(s,o),h.ext=w.slice(i,o))),s>0&&s!==r?h.dir=w.slice(0,s-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...w){let h="",l=!1;for(let r=w.length-1;r>=-1&&!l;r--){const n=r>=0?w[r]:S.cwd();g(n,"path"),n.length!==0&&(h=`${n}/${h}`,l=n.charCodeAt(0)===f)}return h=E(h,!l,"/",b),l?`/${h}`:h.length>0?h:"."},normalize(w){if(g(w,"path"),w.length===0)return".";const h=w.charCodeAt(0)===f,l=w.charCodeAt(w.length-1)===f;return w=E(w,!h,"/",b),w.length===0?h?"/":l?"./":".":(l&&(w+="/"),h?`/${w}`:w)},isAbsolute(w){return g(w,"path"),w.length>0&&w.charCodeAt(0)===f},join(...w){if(w.length===0)return".";let h;for(let l=0;l<w.length;++l){const r=w[l];g(r,"path"),r.length>0&&(h===void 0?h=r:h+=`/${r}`)}return h===void 0?".":e.posix.normalize(h)},relative(w,h){if(g(w,"from"),g(h,"to"),w===h||(w=e.posix.resolve(w),h=e.posix.resolve(h),w===h))return"";const l=1,r=w.length,n=r-l,i=1,s=h.length-i,o=n<s?n:s;let a=-1,c=0;for(;c<o;c++){const P=w.charCodeAt(l+c);if(P!==h.charCodeAt(i+c))break;P===f&&(a=c)}if(c===o)if(s>o){if(h.charCodeAt(i+c)===f)return h.slice(i+c+1);if(c===0)return h.slice(i+c)}else n>o&&(w.charCodeAt(l+c)===f?a=c:c===0&&(a=0));let d="";for(c=l+a+1;c<=r;++c)(c===r||w.charCodeAt(c)===f)&&(d+=d.length===0?"..":"/..");return`${d}${h.slice(i+a)}`},toNamespacedPath(w){return w},dirname(w){if(g(w,"path"),w.length===0)return".";const h=w.charCodeAt(0)===f;let l=-1,r=!0;for(let n=w.length-1;n>=1;--n)if(w.charCodeAt(n)===f){if(!r){l=n;break}}else r=!1;return l===-1?h?"/":".":h&&l===1?"//":w.slice(0,l)},basename(w,h){h!==void 0&&g(h,"ext"),g(w,"path");let l=0,r=-1,n=!0,i;if(h!==void 0&&h.length>0&&h.length<=w.length){if(h===w)return"";let s=h.length-1,o=-1;for(i=w.length-1;i>=0;--i){const a=w.charCodeAt(i);if(a===f){if(!n){l=i+1;break}}else o===-1&&(n=!1,o=i+1),s>=0&&(a===h.charCodeAt(s)?--s==-1&&(r=i):(s=-1,r=o))}return l===r?r=o:r===-1&&(r=w.length),w.slice(l,r)}for(i=w.length-1;i>=0;--i)if(w.charCodeAt(i)===f){if(!n){l=i+1;break}}else r===-1&&(n=!1,r=i+1);return r===-1?"":w.slice(l,r)},extname(w){g(w,"path");let h=-1,l=0,r=-1,n=!0,i=0;for(let s=w.length-1;s>=0;--s){const o=w.charCodeAt(s);if(o===f){if(!n){l=s+1;break}continue}r===-1&&(n=!1,r=s+1),o===v?h===-1?h=s:i!==1&&(i=1):h!==-1&&(i=-1)}return h===-1||r===-1||i===0||i===1&&h===r-1&&h===l+1?"":w.slice(h,r)},format:I.bind(null,"/"),parse(w){g(w,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(w.length===0)return h;const l=w.charCodeAt(0)===f;let r;l?(h.root="/",r=1):r=0;let n=-1,i=0,s=-1,o=!0,a=w.length-1,c=0;for(;a>=r;--a){const d=w.charCodeAt(a);if(d===f){if(!o){i=a+1;break}continue}s===-1&&(o=!1,s=a+1),d===v?n===-1?n=a:c!==1&&(c=1):n!==-1&&(c=-1)}if(s!==-1){const d=i===0&&l?1:i;n===-1||c===0||c===1&&n===s-1&&n===i+1?h.base=h.name=w.slice(d,s):(h.name=w.slice(d,n),h.base=w.slice(d,s),h.ext=w.slice(n,s))}return i>0?h.dir=w.slice(0,i-1):l&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(X[77],J([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(v,...f){const p=f.reduce((y,g)=>(y[g]=!0,y),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(y=>!p[y]).forEach(y=>{for(let g=0;g<C.length;g++)if(y.search(C[g])!==-1){delete v[y];break}})}e.sanitizeProcessEnvironment=R;function M(v){!v||(delete v.DEBUG,S.isMacintosh&&delete v.DYLD_LIBRARY_PATH,S.isLinux&&delete v.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(X[78],J([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=S.globals.performance&&typeof S.globals.performance.now=="function";class D{constructor(M){this._highResolution=t&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new D(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=D}),define(X[3],J([0,1,19,48,2,122,78]),function(z,e,S,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const v=!1,f=!1;var p;(function(a){a.None=()=>D.Disposable.None;function c(O){if(f){const{onListenerDidAdd:N}=O,$=u.create();let Y=0;O.onListenerDidAdd=()=>{++Y==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$.print()),N?.()}}}function d(O){return(N,$=null,Y)=>{let U=!1,j;return j=O(Z=>{if(!U)return j?j.dispose():U=!0,N.call($,Z)},null,Y),U&&j.dispose(),j}}a.once=d;function P(O,N,$){return se((Y,U=null,j)=>O(Z=>Y.call(U,N(Z)),null,j),$)}a.map=P;function L(O,N,$){return se((Y,U=null,j)=>O(Z=>{N(Z),Y.call(U,Z)},null,j),$)}a.forEach=L;function T(O,N,$){return se((Y,U=null,j)=>O(Z=>N(Z)&&Y.call(U,Z),null,j),$)}a.filter=T;function W(O){return O}a.signal=W;function q(...O){return(N,$=null,Y)=>(0,D.combinedDisposable)(...O.map(U=>U(j=>N.call($,j),null,Y)))}a.any=q;function ee(O,N,$,Y){let U=$;return P(O,j=>(U=N(U,j),U),Y)}a.reduce=ee;function se(O,N){let $;const Y={onFirstListenerAdd(){$=O(U.fire,U)},onLastListenerRemove(){$?.dispose()}};N||c(Y);const U=new m(Y);return N?.add(U),U.event}function ae(O,N,$=100,Y=!1,U,j){let Z,re,le,ge=0;const Ee={leakWarningThreshold:U,onFirstListenerAdd(){Z=O(Ce=>{ge++,re=N(re,Ce),Y&&!le&&(De.fire(re),re=void 0),clearTimeout(le),le=setTimeout(()=>{const ke=re;re=void 0,le=void 0,(!Y||ge>1)&&De.fire(ke),ge=0},$)})},onLastListenerRemove(){Z.dispose()}};j||c(Ee);const De=new m(Ee);return j?.add(De),De.event}a.debounce=ae;function te(O,N=(Y,U)=>Y===U,$){let Y=!0,U;return T(O,j=>{const Z=Y||!N(j,U);return Y=!1,U=j,Z},$)}a.latch=te;function ce(O,N,$){return[a.filter(O,N,$),a.filter(O,Y=>!N(Y),$)]}a.split=ce;function H(O,N=!1,$=[]){let Y=$.slice(),U=O(re=>{Y?Y.push(re):Z.fire(re)});const j=()=>{Y?.forEach(re=>Z.fire(re)),Y=null},Z=new m({onFirstListenerAdd(){U||(U=O(re=>Z.fire(re)))},onFirstListenerDidAdd(){Y&&(N?setTimeout(j):j())},onLastListenerRemove(){U&&U.dispose(),U=null}});return Z.event}a.buffer=H;class ne{constructor(N){this.event=N,this.disposables=new D.DisposableStore}map(N){return new ne(P(this.event,N,this.disposables))}forEach(N){return new ne(L(this.event,N,this.disposables))}filter(N){return new ne(T(this.event,N,this.disposables))}reduce(N,$){return new ne(ee(this.event,N,$,this.disposables))}latch(){return new ne(te(this.event,void 0,this.disposables))}debounce(N,$=100,Y=!1,U){return new ne(ae(this.event,N,$,Y,U,this.disposables))}on(N,$,Y){return this.event(N,$,Y)}once(N,$,Y){return d(this.event)(N,$,Y)}dispose(){this.disposables.dispose()}}function F(O){return new ne(O)}a.chain=F;function _(O,N,$=Y=>Y){const Y=(...re)=>Z.fire($(...re)),U=()=>O.on(N,Y),j=()=>O.removeListener(N,Y),Z=new m({onFirstListenerAdd:U,onLastListenerRemove:j});return Z.event}a.fromNodeEventEmitter=_;function B(O,N,$=Y=>Y){const Y=(...re)=>Z.fire($(...re)),U=()=>O.addEventListener(N,Y),j=()=>O.removeEventListener(N,Y),Z=new m({onFirstListenerAdd:U,onLastListenerRemove:j});return Z.event}a.fromDOMEventEmitter=B;function G(O){return new Promise(N=>d(O)(N))}a.toPromise=G;function ie(O,N){return N(void 0),O($=>N($))}a.runAndSubscribe=ie;function V(O,N){let $=null;function Y(j){$?.dispose(),$=new D.DisposableStore,N(j,$)}Y(void 0);const U=O(j=>Y(j));return(0,D.toDisposable)(()=>{U.dispose(),$?.dispose()})}a.runAndSubscribeWithStore=V;class Q{constructor(N,$){this.obs=N,this._counter=0,this._hasChanged=!1;const Y={onFirstListenerAdd:()=>{N.addObserver(this)},onLastListenerRemove:()=>{N.removeObserver(this)}};$||c(Y),this.emitter=new m(Y),$&&$.add(this.emitter)}beginUpdate(N){this._counter++}handleChange(N,$){this._hasChanged=!0}endUpdate(N){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function A(O,N){return new Q(O,N).emitter.event}a.fromObservable=A})(p=e.Event||(e.Event={}));class C{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${C._idPool++}`}start(c){this._stopWatch=new M.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let k=-1;function y(a){const c=k;return k=a,{dispose(){k=c}}}e.setGlobalLeakWarningThreshold=y;class g{constructor(c,d=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,d){let P=k;if(typeof this.customThreshold=="number"&&(P=this.customThreshold),P<=0||d<P)return;this._stacks||(this._stacks=new Map);const L=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,L+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=P*.5;let T,W=0;for(const[q,ee]of this._stacks)(!T||W<ee)&&(T=q,W=ee);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${W}):`),console.warn(T)}return()=>{const T=this._stacks.get(c.value)||0;this._stacks.set(c.value,T-1)}}}class u{constructor(c){this.value=c}static create(){return new u(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(c,d,P){this.callback=c,this.callbackThis=d,this.stack=P,this.subscription=new D.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class m{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=k>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(v){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const d of c)d.subscription.isset()&&(d.subscription.unset(),d.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,d,P)=>{this._listeners||(this._listeners=new R.LinkedList);const L=this._listeners.isEmpty();L&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let T,W;this._leakageMon&&this._listeners.size>=30&&(W=u.create(),T=this._leakageMon.check(W,this._listeners.size+1)),v&&(W=W??u.create());const q=new b(c,d,W),ee=this._listeners.push(q);L&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,d);const se=q.subscription.set(()=>{T?.(),this._disposed||(ee(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return P instanceof D.DisposableStore?P.add(se):Array.isArray(P)&&P.push(se),se}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new I);for(const d of this._listeners)this._deliveryQueue.push(this,d,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=m;class E{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(c,d,P){this._queue.push(new w(c,d,P))}clear(c){const d=new R.LinkedList;for(const P of this._queue)P.emitter!==c&&d.push(P);this._queue=d}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(d){(0,S.onUnexpectedError)(d)}}}}e.EventDeliveryQueue=E;class I extends E{clear(c){this._queue.clear()}}class w{constructor(c,d,P){this.emitter=c,this.listener=d,this.event=P}}class h extends m{async fireAsync(c,d,P){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const L of this._listeners)this._asyncDeliveryQueue.push([L,c]);for(;this._asyncDeliveryQueue.size>0&&!d.isCancellationRequested;){const[L,T]=this._asyncDeliveryQueue.shift(),W=[],q={...T,token:d,waitUntil:ee=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");P&&(ee=P(ee,L.callback)),W.push(ee)}};try{L.invoke(q)}catch(ee){(0,S.onUnexpectedError)(ee);continue}Object.freeze(W),await Promise.allSettled(W).then(ee=>{for(const se of ee)se.status==="rejected"&&(0,S.onUnexpectedError)(se.reason)})}}}}e.AsyncEmitter=h;class l extends m{constructor(c){super(c);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=l;class r extends l{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=r;class n extends m{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(d=>super.fire(d)),this._queuedEvents=[]})}}e.MicrotaskEmitter=n;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const d={event:c,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const P=()=>{this.hasListeners&&this.unhook(d);const L=this.events.indexOf(d);this.events.splice(L,1)};return(0,D.toDisposable)((0,t.once)(P))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(d=>this.emitter.fire(d))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class s{constructor(){this.buffers=[]}wrapEvent(c){return(d,P,L)=>c(T=>{const W=this.buffers[this.buffers.length-1];W?W.push(()=>d.call(P,T)):d.call(P,T)},void 0,L)}bufferEvents(c){const d=[];this.buffers.push(d);const P=c();return this.buffers.pop(),d.forEach(L=>L()),P}}e.EventBufferer=s;class o{constructor(){this.listening=!1,this.inputEvent=p.None,this.inputEventListener=D.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(X[21],J([0,1,3]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(v,f){const p=setTimeout(v.bind(f),0);return{dispose(){clearTimeout(p)}}});var D;(function(v){function f(p){return p===v.None||p===v.Cancelled||p instanceof R?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}v.isCancellationToken=f,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=D.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=M}),define(X[135],J([0,1,21]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(v){this.task=v,this.result=null}get(){if(this.result)return this.result;const v=new S.CancellationTokenSource,f=this.task(v.token);return this.result={promise:f,dispose:()=>{this.result=null,v.cancel(),v.dispose()}},this.result}}e.Cache=t;class D{constructor(v){this.fn=v,this.lastCache=void 0,this.lastArgKey=void 0}get(v){const f=JSON.stringify(v);return this.lastArgKey!==f&&(this.lastArgKey=f,this.lastCache=this.fn(v)),this.lastCache}}e.LRUCachedFunction=D;class R{constructor(v){this.fn=v,this._map=new Map}get cachedValues(){return this._map}get(v){if(this._map.has(v))return this._map.get(v);const f=this.fn(v);return this._map.set(v,f),f}}e.CachedFunction=R}),define(X[91],J([0,1,3,2]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=M=>({onDidChange:S.Event.None,value:M});e.staticObservableValue=D;class R extends t.Disposable{constructor(v){super();this._value=v,this.changeEmitter=this._register(new S.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(v){v!==this._value&&(this._value=v,this.changeEmitter.fire(v))}}e.MutableObservableValue=R}),define(X[31],J([0,1,135,121]),function(z,e,S,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=R;const M=/{(\d+)}/g;function v(K,...oe){return oe.length===0?K:K.replace(M,function(he,me){const be=parseInt(me,10);return isNaN(be)||be<0||be>=oe.length?he:oe[be]})}e.format=v;const f=/{([^}]+)}/g;function p(K,oe){return K.replace(f,(he,me)=>oe[me]??he)}e.format2=p;function C(K){return K.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=C;function k(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function y(K,oe){let he=0;const me=oe.charCodeAt(0);for(let be=K.length-1;be>=0;be--)K.charCodeAt(be)===me&&he++;return he}e.count=y;function g(K,oe,he="\u2026"){return K.length<=oe?K:`${K.substr(0,oe)}${he}`}e.truncate=g;function u(K,oe=" "){const he=b(K,oe);return m(he,oe)}e.trim=u;function b(K,oe){if(!K||!oe)return K;const he=oe.length;if(he===0||K.length===0)return K;let me=0;for(;K.indexOf(oe,me)===me;)me=me+he;return K.substring(me)}e.ltrim=b;function m(K,oe){if(!K||!oe)return K;const he=oe.length,me=K.length;if(he===0||me===0)return K;let be=me,Le=-1;for(;Le=K.lastIndexOf(oe,be-1),!(Le===-1||Le+he!==be);){if(Le===0)return"";be=Le}return K.substring(0,be)}e.rtrim=m;function E(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=E;function I(K){return K.replace(/\*/g,"")}e.stripWildcards=I;function w(K,oe,he={}){if(!K)throw new Error("Cannot create regex from empty string");oe||(K=k(K)),he.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(K,me)}e.createRegExp=w;function h(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function l(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function r(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=r;function n(K){return K.split(/\r\n|\r|\n/)}e.splitLines=n;function i(K){for(let oe=0,he=K.length;oe<he;oe++){const me=K.charCodeAt(oe);if(me!==32&&me!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function s(K,oe=0,he=K.length){for(let me=oe;me<he;me++){const be=K.charCodeAt(me);if(be!==32&&be!==9)return K.substring(oe,me)}return K.substring(oe,he)}e.getLeadingWhitespace=s;function o(K,oe=K.length-1){for(let he=oe;he>=0;he--){const me=K.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=o;function a(K,oe,he){const me=[];let be=0;for(const Le of K.matchAll(oe)){if(me.push(K.slice(be,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");be=Le.index+Le[0].length,me.push(he(Le[0],...Le.slice(1),Le.index,K,Le.groups))}return me.push(K.slice(be)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=a;function c(K,oe){return K<oe?-1:K>oe?1:0}e.compare=c;function d(K,oe,he=0,me=K.length,be=0,Le=oe.length){for(;he<me&&be<Le;he++,be++){const et=K.charCodeAt(he),qe=oe.charCodeAt(be);if(et<qe)return-1;if(et>qe)return 1}const He=me-he,nt=Le-be;return He<nt?-1:He>nt?1:0}e.compareSubstring=d;function P(K,oe){return L(K,oe,0,K.length,0,oe.length)}e.compareIgnoreCase=P;function L(K,oe,he=0,me=K.length,be=0,Le=oe.length){for(;he<me&&be<Le;he++,be++){let et=K.charCodeAt(he),qe=oe.charCodeAt(be);if(et===qe)continue;if(et>=128||qe>=128)return d(K.toLowerCase(),oe.toLowerCase(),he,me,be,Le);W(et)&&(et-=32),W(qe)&&(qe-=32);const Je=et-qe;if(Je!==0)return Je}const He=me-he,nt=Le-be;return He<nt?-1:He>nt?1:0}e.compareSubstringIgnoreCase=L;function T(K){return K>=48&&K<=57}e.isAsciiDigit=T;function W(K){return K>=97&&K<=122}e.isLowerAsciiLetter=W;function q(K){return K>=65&&K<=90}e.isUpperAsciiLetter=q;function ee(K,oe){return K.length===oe.length&&L(K,oe)===0}e.equalsIgnoreCase=ee;function se(K,oe){const he=oe.length;return oe.length>K.length?!1:L(K,oe,0,he)===0}e.startsWithIgnoreCase=se;function ae(K,oe){const he=Math.min(K.length,oe.length);let me;for(me=0;me<he;me++)if(K.charCodeAt(me)!==oe.charCodeAt(me))return me;return he}e.commonPrefixLength=ae;function te(K,oe){const he=Math.min(K.length,oe.length);let me;const be=K.length-1,Le=oe.length-1;for(me=0;me<he;me++)if(K.charCodeAt(be-me)!==oe.charCodeAt(Le-me))return me;return he}e.commonSuffixLength=te;function ce(K){return 55296<=K&&K<=56319}e.isHighSurrogate=ce;function H(K){return 56320<=K&&K<=57343}e.isLowSurrogate=H;function ne(K,oe){return(K-55296<<10)+(oe-56320)+65536}e.computeCodePoint=ne;function F(K,oe,he){const me=K.charCodeAt(he);if(ce(me)&&he+1<oe){const be=K.charCodeAt(he+1);if(H(be))return ne(me,be)}return me}e.getNextCodePoint=F;function _(K,oe){const he=K.charCodeAt(oe-1);if(H(he)&&oe>1){const me=K.charCodeAt(oe-2);if(ce(me))return ne(me,he)}return he}class B{constructor(oe,he=0){this._str=oe,this._len=oe.length,this._offset=he}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=_(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=F(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class G{constructor(oe,he=0){this._iterator=new B(oe,he)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=Ae.getInstance(),he=this._iterator,me=he.offset;let be=oe.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Le=he.offset,He=oe.getGraphemeBreakType(he.nextCodePoint());if(Re(be,He)){he.setOffset(Le);break}be=He}return he.offset-me}prevGraphemeLength(){const oe=Ae.getInstance(),he=this._iterator,me=he.offset;let be=oe.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Le=he.offset,He=oe.getGraphemeBreakType(he.prevCodePoint());if(Re(He,be)){he.setOffset(Le);break}be=He}return me-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=G;function ie(K,oe){return new G(K,oe).nextGraphemeLength()}e.nextCharLength=ie;function V(K,oe){return new G(K,oe).prevGraphemeLength()}e.prevCharLength=V;function Q(K,oe){oe>0&&H(K.charCodeAt(oe))&&oe--;const he=oe+ie(K,oe);return[he-V(K,he),he]}e.getCharContainingOffset=Q;const A=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function O(K){return A.test(K)}e.containsRTL=O;const N=/^[\t\n\r\x20-\x7E]*$/;function $(K){return N.test(K)}e.isBasicASCII=$,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Y(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Y;function U(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=U;function j(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=j;function Z(K,oe){if(K.length<oe)return K;const he=/\b/g;let me=0;for(;he.test(K)&&!(K.length-he.lastIndex<oe);)me=he.lastIndex,he.lastIndex+=1;return K.substring(me).replace(/^\s/,"")}e.lcut=Z;const re=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function Ee(K){return K&&(K=K.replace(re,""),K=K.replace(le,""),K=K.replace(ge,"")),K}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function De(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=De;function Ce(K){return De(K)?K.substr(1):K}e.stripUTF8BOM=Ce;function ke(K,oe){if(!K||!oe||K.length<oe.length)return!1;const he=oe.length,me=K.toLowerCase();let be=0,Le=-1;for(;be<he;){const He=me.indexOf(oe[be],Le+1);if(He<0)return!1;Le=He,be++}return!0}e.fuzzyContains=ke;function Te(K,oe=!1){return K?(oe&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Te;function ue(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=ue;function de(K,oe=1){if(oe===0)return"";let he=-1;do he=K.indexOf(`
`,he+1),oe--;while(oe>0&&he>=0);return he===-1?K:(K[he-1]==="\r"&&he--,K.substr(0,he))}e.getNLines=de;function pe(K){const oe=90-65+1;return K=K%(2*oe),K<oe?String.fromCharCode(97+K):String.fromCharCode(65+K-oe)}e.singleLetterHash=pe;function Ie(K){return Ae.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Ie;function Re(K,oe){return K===0?oe!==5&&oe!==7:K===2&&oe===3?!1:K===4||K===2||K===3||oe===4||oe===2||oe===3?!0:!(K===8&&(oe===8||oe===9||oe===11||oe===12)||(K===11||K===9)&&(oe===9||oe===10)||(K===12||K===10)&&oe===10||oe===5||oe===13||oe===7||K===1||K===13&&oe===14||K===6&&oe===6)}var Xe;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{constructor(){this._data=Oe()}static getInstance(){return Ae._INSTANCE||(Ae._INSTANCE=new Ae),Ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const he=this._data,me=he.length/3;let be=1;for(;be<=me;)if(oe<he[3*be])be=2*be;else if(oe>he[3*be+1])be=2*be+1;else return he[3*be+2];return 0}}Ae._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(K,oe){if(K===0)return 0;const he=Ye(K,oe);if(he!==void 0)return he;const me=new B(oe,K);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=We;function Ye(K,oe){const he=new B(oe,K);let me=he.prevCodePoint();for(;Qe(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!j(me))return;let be=he.offset;return be>0&&he.prevCodePoint()===8205&&(be=he.offset),be}function Qe(K){return 127995<=K&&K<=127999}var Ze;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),e.noBreakWhitespace="\xA0";class $e{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return $e.cache.get(Array.from(oe))}static getLocales(){return $e._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=$e,D=$e,$e.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),$e.cache=new S.LRUCachedFunction(K=>{function oe(qe){const Je=new Map;for(let xe=0;xe<qe.length;xe+=2)Je.set(qe[xe],qe[xe+1]);return Je}function he(qe,Je){const xe=new Map(qe);for(const[ct,lt]of Je)xe.set(ct,lt);return xe}function me(qe,Je){if(!qe)return Je;const xe=new Map;for(const[ct,lt]of qe)Je.has(ct)&&xe.set(ct,lt);return xe}const be=D.ambiguousCharacterData.getValue();let Le=K.filter(qe=>!qe.startsWith("_")&&qe in be);Le.length===0&&(Le=["_default"]);let He;for(const qe of Le){const Je=oe(be[qe]);He=me(He,Je)}const nt=oe(be._common),et=he(nt,He);return new $e(et)}),$e._locales=new t.Lazy(()=>Object.keys($e.ambiguousCharacterData.getValue()).filter(K=>!K.startsWith("_")));class je{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(je.getRawData())),this._data}static isInvisibleCharacter(oe){return je.getData().has(oe)}static get codePoints(){return je.getData()}}e.InvisibleCharacters=je,je._data=void 0}),define(X[30],J([0,1,9,4,31,13]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(o){return o===47||o===92}e.isPathSeparator=M;function v(o){return o.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=v;function f(o){return o.indexOf("/")===-1&&(o=v(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=f;function p(o,a=S.posix.sep){if(!o)return"";const c=o.length,d=o.charCodeAt(0);if(M(d)){if(M(o.charCodeAt(1))&&!M(o.charCodeAt(2))){let L=3;const T=L;for(;L<c&&!M(o.charCodeAt(L));L++);if(T!==L&&!M(o.charCodeAt(L+1))){for(L+=1;L<c;L++)if(M(o.charCodeAt(L)))return o.slice(0,L+1).replace(/[\\/]/g,a)}}return a}else if(E(d)&&o.charCodeAt(1)===58)return M(o.charCodeAt(2))?o.slice(0,2)+a:o.slice(0,2);let P=o.indexOf("://");if(P!==-1){for(P+=3;P<c;P++)if(M(o.charCodeAt(P)))return o.slice(0,P+1)}return""}e.getRoot=p;function C(o){if(!t.isWindows||!o||o.length<5)return!1;let a=o.charCodeAt(0);if(a!==92||(a=o.charCodeAt(1),a!==92))return!1;let c=2;const d=c;for(;c<o.length&&(a=o.charCodeAt(c),a!==92);c++);return!(d===c||(a=o.charCodeAt(c+1),isNaN(a)||a===92))}e.isUNC=C;const k=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(o,a=t.isWindows){const c=a?k:y;return!(!o||o.length===0||/^\s+$/.test(o)||(c.lastIndex=0,c.test(o))||a&&g.test(o)||o==="."||o===".."||a&&o[o.length-1]==="."||a&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=u;function b(o,a,c){const d=o===a;return!c||d?d:!o||!a?!1:(0,D.equalsIgnoreCase)(o,a)}e.isEqual=b;function m(o,a,c,d=S.sep){if(o===a)return!0;if(!o||!a||a.length>o.length)return!1;if(c){if(!(0,D.startsWithIgnoreCase)(o,a))return!1;if(a.length===o.length)return!0;let L=a.length;return a.charAt(a.length-1)===d&&L--,o.charAt(L)===d}return a.charAt(a.length-1)!==d&&(a+=d),o.indexOf(a)===0}e.isEqualOrParent=m;function E(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=E;function I(o,a){return t.isWindows&&o.endsWith(":")&&(o+=S.sep),(0,S.isAbsolute)(o)||(o=(0,S.join)(a,o)),o=(0,S.normalize)(o),t.isWindows?(o=(0,D.rtrim)(o,S.sep),o.endsWith(":")&&(o+=S.sep)):(o=(0,D.rtrim)(o,S.sep),o||(o=S.sep)),o}e.sanitizeFilePath=I;function w(o){const a=(0,S.normalize)(o);return t.isWindows?o.length>3?!1:h(a)&&(o.length===2||a.charCodeAt(2)===92):a===S.posix.sep}e.isRootOrDriveLetter=w;function h(o,a=t.isWindows){return a?E(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function l(o){return h(o)?o[0]:void 0}e.getDriveLetter=l;function r(o,a,c){return a.length>o.length?-1:o===a?0:(c&&(o=o.toLowerCase(),a=a.toLowerCase()),o.indexOf(a))}e.indexOfPath=r;function n(o){const a=o.split(":");let c,d,P;for(const L of a){const T=Number(L);(0,R.isNumber)(T)?d===void 0?d=T:P===void 0&&(P=T):c=c?[c,L].join(":"):L}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:d!==void 0?d:void 0,column:P!==void 0?P:d!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(o,a,c=8){let d="";for(let L=0;L<c;L++)d+=i.charAt(Math.floor(Math.random()*i.length));let P;return a?P=`${a}-${d}`:P=d,o?(0,S.join)(o,P):P}e.randomPath=s}),define(X[65],J([0,1,31]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(E){return D(E,0)}e.hash=t;function D(E,I){switch(typeof E){case"object":return E===null?R(349,I):Array.isArray(E)?f(E,I):p(E,I);case"string":return v(E,I);case"boolean":return M(E,I);case"number":return R(E,I);case"undefined":return R(937,I);default:return R(617,I)}}e.doHash=D;function R(E,I){return(I<<5)-I+E|0}e.numberHash=R;function M(E,I){return R(E?433:863,I)}function v(E,I){I=R(149417,I);for(let w=0,h=E.length;w<h;w++)I=R(E.charCodeAt(w),I);return I}e.stringHash=v;function f(E,I){return I=R(104579,I),E.reduce((w,h)=>D(h,w),I)}function p(E,I){return I=R(181387,I),Object.keys(E).sort().reduce((w,h)=>(w=v(h,w),D(E[h],w)),I)}class C{constructor(){this._value=0}get value(){return this._value}hash(I){return this._value=D(I,this._value),this._value}}e.Hasher=C;var k;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function y(E,I,w=32){const h=w-I,l=~((1<<h)-1);return(E<<I|(l&E)>>>h)>>>0}function g(E,I=0,w=E.byteLength,h=0){for(let l=0;l<w;l++)E[I+l]=h}function u(E,I,w="0"){for(;E.length<I;)E=w+E;return E}function b(E,I=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(w=>w.toString(16).padStart(2,"0")).join(""):u((E>>>0).toString(16),I/4)}e.toHexString=b;class m{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(I){const w=I.length;if(w===0)return;const h=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,n,i;for(r!==0?(n=r,i=-1,r=0):(n=I.charCodeAt(0),i=0);;){let s=n;if(S.isHighSurrogate(n))if(i+1<w){const o=I.charCodeAt(i+1);S.isLowSurrogate(o)?(i++,s=S.computeCodePoint(n,o)):s=65533}else{r=n;break}else S.isLowSurrogate(n)&&(s=65533);if(l=this._push(h,l,s),i++,i<w)n=I.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(I,w,h){return h<128?I[w++]=h:h<2048?(I[w++]=192|(h&1984)>>>6,I[w++]=128|(h&63)>>>0):h<65536?(I[w++]=224|(h&61440)>>>12,I[w++]=128|(h&4032)>>>6,I[w++]=128|(h&63)>>>0):(I[w++]=240|(h&1835008)>>>18,I[w++]=128|(h&258048)>>>12,I[w++]=128|(h&4032)>>>6,I[w++]=128|(h&63)>>>0),w>=64&&(this._step(),w-=64,this._totalLen+=64,I[0]=I[64+0],I[1]=I[64+1],I[2]=I[64+2]),w}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const I=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(I/4294967296),!1),this._buffDV.setUint32(60,I%4294967296,!1),this._step()}_step(){const I=m._bigBlock32,w=this._buffDV;for(let c=0;c<64;c+=4)I.setUint32(c,w.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)I.setUint32(c,y(I.getUint32(c-12,!1)^I.getUint32(c-32,!1)^I.getUint32(c-56,!1)^I.getUint32(c-64,!1),1),!1);let h=this._h0,l=this._h1,r=this._h2,n=this._h3,i=this._h4,s,o,a;for(let c=0;c<80;c++)c<20?(s=l&r|~l&n,o=1518500249):c<40?(s=l^r^n,o=1859775393):c<60?(s=l&r|l&n|r&n,o=2400959708):(s=l^r^n,o=3395469782),a=y(h,5)+s+i+o+I.getUint32(c*4,!1)&4294967295,i=n,n=r,r=y(l,30),l=h,h=a;this._h0=this._h0+h&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=m,m._bigBlock32=new DataView(new ArrayBuffer(320))});var At=this&&this.__classPrivateFieldSet||function(z,e,S,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?z!==e||!D:!e.has(z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(z,S):D?D.value=S:e.set(z,S),S},ot=this&&this.__classPrivateFieldGet||function(z,e,S,t){if(S==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?z!==e||!t:!e.has(z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?t:S==="a"?t.call(z):t?t.value:e.get(z)};define(X[33],J([0,1,25,31]),function(z,e,S,t){"use strict";var D,R,M,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function f(o,a,c){let d=o.get(a);return d===void 0&&(d=c,o.set(a,d)),d}e.getOrSet=f;function p(o){const a=[];return o.forEach((c,d)=>{a.push(`${d} => ${c}`)}),`Map(${o.size}) {${a.join(", ")}}`}e.mapToString=p;function C(o){const a=[];return o.forEach(c=>{a.push(c)}),`Set(${o.size}) {${a.join(", ")}}`}e.setToString=C;class k{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const c=a.charCodeAt(0),d=this._value.charCodeAt(this._pos);return c-d}value(){return this._value[this._pos]}}e.StringIterator=k;class y{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,t.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class g{constructor(a=!0,c=!0){this._splitOnBackslash=a,this._caseSensitive=c}reset(a){this._from=0,this._to=0,this._value=a,this._valueLen=a.length;for(let c=a.length-1;c>=0;c--,this._valueLen--){const d=this._value.charCodeAt(c);if(!(d===47||this._splitOnBackslash&&d===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let a=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,t.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var u;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(u||(u={}));class b{constructor(a,c){this._ignorePathCasing=a,this._ignoreQueryAndFragment=c,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(a)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===4)return(0,t.compare)(a,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=b;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(E||(E={}));class I{constructor(a){this._iter=a}static forUris(a=()=>!1,c=()=>!1){return new I(new b(a,c))}static forPaths(a=!1){return new I(new g(void 0,!a))}static forStrings(){return new I(new k)}static forConfigKeys(){return new I(new y)}clear(){this._root=void 0}fill(a,c){if(c){const d=c.slice(0);(0,S.shuffle)(d);for(const P of d)this.set(P,a)}else{const d=a.slice(0);(0,S.shuffle)(d);for(const P of d)this.set(P[0],P[1])}}set(a,c){const d=this._iter.reset(a);let P;this._root||(this._root=new m,this._root.segment=d.value());const L=[];for(P=this._root;;){const W=d.cmp(P.segment);if(W>0)P.left||(P.left=new m,P.left.segment=d.value()),L.push([-1,P]),P=P.left;else if(W<0)P.right||(P.right=new m,P.right.segment=d.value()),L.push([1,P]),P=P.right;else if(d.hasNext())d.next(),P.mid||(P.mid=new m,P.mid.segment=d.value()),L.push([0,P]),P=P.mid;else break}const T=P.value;P.value=c,P.key=a;for(let W=L.length-1;W>=0;W--){const q=L[W][1];q.updateHeight();const ee=q.balanceFactor();if(ee<-1||ee>1){const se=L[W][0],ae=L[W+1][0];if(se===1&&ae===1)L[W][1]=q.rotateLeft();else if(se===-1&&ae===-1)L[W][1]=q.rotateRight();else if(se===1&&ae===-1)q.right=L[W+1][1]=L[W+1][1].rotateRight(),L[W][1]=q.rotateLeft();else if(se===-1&&ae===1)q.left=L[W+1][1]=L[W+1][1].rotateLeft(),L[W][1]=q.rotateRight();else throw new Error;if(W>0)switch(L[W-1][0]){case-1:L[W-1][1].left=L[W][1];break;case 1:L[W-1][1].right=L[W][1];break;case 0:L[W-1][1].mid=L[W][1];break}else this._root=L[0][1]}}return T}get(a){return this._getNode(a)?.value}_getNode(a){const c=this._iter.reset(a);let d=this._root;for(;d;){const P=c.cmp(d.segment);if(P>0)d=d.left;else if(P<0)d=d.right;else if(c.hasNext())c.next(),d=d.mid;else break}return d}has(a){const c=this._getNode(a);return!(c?.value===void 0&&c?.mid===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,c){const d=this._iter.reset(a),P=[];let L=this._root;for(;L;){const T=d.cmp(L.segment);if(T>0)P.push([-1,L]),L=L.left;else if(T<0)P.push([1,L]),L=L.right;else if(d.hasNext())d.next(),P.push([0,L]),L=L.mid;else break}if(!!L){if(c?(L.left=void 0,L.mid=void 0,L.right=void 0,L.height=1):(L.key=void 0,L.value=void 0),!L.mid&&!L.value)if(L.left&&L.right){const T=this._min(L.right),{key:W,value:q,segment:ee}=T;this._delete(T.key,!1),L.key=W,L.value=q,L.segment=ee}else{const T=L.left??L.right;if(P.length>0){const[W,q]=P[P.length-1];switch(W){case-1:q.left=T;break;case 0:q.mid=T;break;case 1:q.right=T;break}}else this._root=T}for(let T=P.length-1;T>=0;T--){const W=P[T][1];W.updateHeight();const q=W.balanceFactor();if(q>1?(W.right.balanceFactor()>=0||(W.right=W.right.rotateRight()),P[T][1]=W.rotateLeft()):q<-1&&(W.left.balanceFactor()<=0||(W.left=W.left.rotateLeft()),P[T][1]=W.rotateRight()),T>0)switch(P[T-1][0]){case-1:P[T-1][1].left=P[T][1];break;case 1:P[T-1][1].right=P[T][1];break;case 0:P[T-1][1].mid=P[T][1];break}else this._root=P[0][1]}}}_min(a){for(;a.left;)a=a.left;return a}findSubstr(a){const c=this._iter.reset(a);let d=this._root,P;for(;d;){const L=c.cmp(d.segment);if(L>0)d=d.left;else if(L<0)d=d.right;else if(c.hasNext())c.next(),P=d.value||P,d=d.mid;else break}return d&&d.value||P}findSuperstr(a){const c=this._iter.reset(a);let d=this._root;for(;d;){const P=c.cmp(d.segment);if(P>0)d=d.left;else if(P<0)d=d.right;else if(c.hasNext())c.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(a){for(const[c,d]of this)a(d,c)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(a){const c=[];return this._dfsEntries(a,c),c[Symbol.iterator]()}_dfsEntries(a,c){!a||(a.left&&this._dfsEntries(a.left,c),a.value&&c.push([a.key,a.value]),a.mid&&this._dfsEntries(a.mid,c),a.right&&this._dfsEntries(a.right,c))}_isBalanced(){const a=c=>{if(!c)return!0;const d=c.balanceFactor();return d<-1||d>1?!1:a(c.left)&&a(c.right)};return a(this._root)}}e.TernarySearchTree=I;class w{constructor(a,c){this.uri=a,this.value=c}}class h{constructor(a,c){this[D]="ResourceMap",a instanceof h?(this.map=new Map(a.map),this.toKey=c??h.defaultToKey):(this.map=new Map,this.toKey=a??h.defaultToKey)}set(a,c){return this.map.set(this.toKey(a),new w(a,c)),this}get(a){return this.map.get(this.toKey(a))?.value}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,c){typeof c!="undefined"&&(a=a.bind(c));for(const[d,P]of this.map)a(P.value,P.uri,this)}*values(){for(const a of this.map.values())yield a.value}*keys(){for(const a of this.map.values())yield a.uri}*entries(){for(const a of this.map.values())yield[a.uri,a.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.map)yield[a.uri,a.value]}}e.ResourceMap=h,h.defaultToKey=o=>o.toString();class l{constructor(a,c){this[R]="ResourceSet",!a||typeof a=="function"?this._map=new h(a):(this._map=new h(c),a.forEach(this.add,this))}get size(){return this._map.size}add(a){return this._map.set(a,a),this}clear(){this._map.clear()}delete(a){return this._map.delete(a)}forEach(a,c){this._map.forEach((d,P)=>a.call(c,P,P,this))}has(a){return this._map.has(a)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=l;var r;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class n{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(a){return this._map.has(a)}get(a,c=0){const d=this._map.get(a);if(!!d)return c!==0&&this.touch(d,c),d.value}set(a,c,d=0){let P=this._map.get(a);if(P)P.value=c,d!==0&&this.touch(P,d);else{switch(P={key:a,value:c,next:void 0,previous:void 0},d){case 0:this.addItemLast(P);break;case 1:this.addItemFirst(P);break;case 2:this.addItemLast(P);break;default:this.addItemLast(P);break}this._map.set(a,P),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const c=this._map.get(a);if(!!c)return this._map.delete(a),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}forEach(a,c){const d=this._state;let P=this._head;for(;P;){if(c?a.bind(c)(P.value,P.key,this):a(P.value,P.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");P=P.next}}keys(){const a=this,c=this._state;let d=this._head;const P={[Symbol.iterator](){return P},next(){if(a._state!==c)throw new Error("LinkedMap got modified during iteration.");if(d){const L={value:d.key,done:!1};return d=d.next,L}else return{value:void 0,done:!0}}};return P}values(){const a=this,c=this._state;let d=this._head;const P={[Symbol.iterator](){return P},next(){if(a._state!==c)throw new Error("LinkedMap got modified during iteration.");if(d){const L={value:d.value,done:!1};return d=d.next,L}else return{value:void 0,done:!0}}};return P}entries(){const a=this,c=this._state;let d=this._head;const P={[Symbol.iterator](){return P},next(){if(a._state!==c)throw new Error("LinkedMap got modified during iteration.");if(d){const L={value:[d.key,d.value],done:!1};return d=d.next,L}else return{value:void 0,done:!0}}};return P}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(a>=this.size)return;if(a===0){this.clear();return}let c=this._head,d=this.size;for(;c&&d>a;)this._map.delete(c.key),c=c.next,d--;this._head=c,this._size=d,c&&(c.previous=void 0),this._state++}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const c=a.next,d=a.previous;if(!c||!d)throw new Error("Invalid list");c.previous=d,d.next=c}a.next=void 0,a.previous=void 0,this._state++}touch(a,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(a===this._head)return;const d=a.next,P=a.previous;a===this._tail?(P.next=void 0,this._tail=P):(d.previous=P,P.next=d),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(c===2){if(a===this._tail)return;const d=a.next,P=a.previous;a===this._head?(d.previous=void 0,this._head=d):(d.previous=P,P.next=d),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((c,d)=>{a.push([d,c])}),a}fromJSON(a){this.clear();for(const[c,d]of a)this.set(c,d)}}e.LinkedMap=n;class i extends n{constructor(a,c=1){super();this._limit=a,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,c=2){return super.get(a,c)}peek(a){return super.get(a,0)}set(a,c){return super.set(a,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class s{constructor(a){v.set(this,void 0),At(this,v,a,"f")}get size(){return ot(this,v,"f").size}forEach(a,c){ot(this,v,"f").forEach(a,c)}get(a){return ot(this,v,"f").get(a)}has(a){return ot(this,v,"f").has(a)}entries(){return ot(this,v,"f").entries()}keys(){return ot(this,v,"f").keys()}values(){return ot(this,v,"f").values()}[(v=new WeakMap,Symbol.iterator)](){return ot(this,v,"f").entries()}}e.ReadonlyMapView=s}),define(X[79],J([0,1,33]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new S.LRUCache(1e4);function D(p){return f(p,"NFC",t)}e.normalizeNFC=D;const R=new S.LRUCache(1e4);function M(p){return f(p,"NFD",R)}e.normalizeNFD=M;const v=/[^\u0000-\u0080]/;function f(p,C,k){if(!p)return p;const y=k.get(p);if(y)return y;let g;return v.test(p)?g=p.normalize(C):g=p,k.set(p,g),g}e.removeAccents=function(){const p=/[\u0300-\u036f]/g;return function(C){return M(C).replace(p,"")}}()}),define(X[7],J([0,1,9,4]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function v(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!D.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,s){return!i&&!s?"file":i}function p(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==k&&(s=k+s):s=k;break}return s}const C="",k="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(s,o,a,c,d,P=!1){typeof s=="object"?(this.scheme=s.scheme||C,this.authority=s.authority||C,this.path=s.path||C,this.query=s.query||C,this.fragment=s.fragment||C):(this.scheme=f(s,P),this.authority=o||C,this.path=p(this.scheme,a||C),this.query=c||C,this.fragment=d||C,v(this,P))}static isUri(s){return s instanceof g?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return w(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:a,path:c,query:d,fragment:P}=s;return o===void 0?o=this.scheme:o===null&&(o=C),a===void 0?a=this.authority:a===null&&(a=C),c===void 0?c=this.path:c===null&&(c=C),d===void 0?d=this.query:d===null&&(d=C),P===void 0?P=this.fragment:P===null&&(P=C),o===this.scheme&&a===this.authority&&c===this.path&&d===this.query&&P===this.fragment?this:new b(o,a,c,d,P)}static parse(s,o=!1){const a=y.exec(s);return a?new b(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),o):new b(C,C,C,C,C)}static file(s){let o=C;if(t.isWindows&&(s=s.replace(/\\/g,k)),s[0]===k&&s[1]===k){const a=s.indexOf(k,2);a===-1?(o=s.substring(2),s=k):(o=s.substring(2,a),s=s.substring(a)||k)}return new b("file",o,s,C,C)}static from(s){const o=new b(s.scheme,s.authority,s.path,s.query,s.fragment);return v(o,!0),o}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&s.scheme==="file"?a=g.file(S.win32.join(w(s,!0),...o)).path:a=S.posix.join(s.path,...o),s.with({path:a})}toString(s=!1){return h(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof g)return s;{const o=new b(s);return o._formatted=s.external,o._fsPath=s._sep===u?s.fsPath:null,o}}else return s}}e.URI=g;const u=t.isWindows?1:void 0;class b extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(s=!1){return s?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=u),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(i,s){let o,a=-1;for(let c=0;c<i.length;c++){const d=i.charCodeAt(c);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||s&&d===47)a!==-1&&(o+=encodeURIComponent(i.substring(a,c)),a=-1),o!==void 0&&(o+=i.charAt(c));else{o===void 0&&(o=i.substr(0,c));const P=m[d];P!==void 0?(a!==-1&&(o+=encodeURIComponent(i.substring(a,c)),a=-1),o+=P):a===-1&&(a=c)}}return a!==-1&&(o+=encodeURIComponent(i.substring(a))),o!==void 0?o:i}function I(i){let s;for(let o=0;o<i.length;o++){const a=i.charCodeAt(o);a===35||a===63?(s===void 0&&(s=i.substr(0,o)),s+=m[a]):s!==void 0&&(s+=i[o])}return s!==void 0?s:i}function w(i,s){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=w;function h(i,s){const o=s?I:E;let a="",{scheme:c,authority:d,path:P,query:L,fragment:T}=i;if(c&&(a+=c,a+=":"),(d||c==="file")&&(a+=k,a+=k),d){let W=d.indexOf("@");if(W!==-1){const q=d.substr(0,W);d=d.substr(W+1),W=q.indexOf(":"),W===-1?a+=o(q,!1):(a+=o(q.substr(0,W),!1),a+=":",a+=o(q.substr(W+1),!1)),a+="@"}d=d.toLowerCase(),W=d.indexOf(":"),W===-1?a+=o(d,!1):(a+=o(d.substr(0,W),!1),a+=d.substr(W))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const W=P.charCodeAt(1);W>=65&&W<=90&&(P=`/${String.fromCharCode(W+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const W=P.charCodeAt(0);W>=65&&W<=90&&(P=`${String.fromCharCode(W+32)}:${P.substr(2)}`)}a+=o(P,!0)}return L&&(a+="?",a+=o(L,!1)),T&&(a+="#",a+=s?T:E(T,!1)),a}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(r)?i.replace(r,s=>l(s)):i}}),define(X[136],J([0,1,7]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(p){const C=p;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=t;function D(p){const C=[];let k;try{const y=JSON.parse(p.arguments),g=y[y.length-1];g&&g.__$stack&&(y.pop(),k=g.__$stack),C.push(...y)}catch{C.push("Unable to log remote console arguments",p.arguments)}return{args:C,stack:k}}e.parse=D;function R(p){if(typeof p!="string")return R(D(p).stack);const C=p;if(C){const k=M(C),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=R;function M(p){if(!p)return p;const C=p.indexOf(`
`);return C===-1?p:p.substring(0,C)}function v(p,C){const{args:k,stack:y}=D(p),g=typeof k[0]=="string"&&k.length===1;let u=M(y);u&&(u=`(${u.trim()})`);let b=[];if(typeof k[0]=="string"?u&&g?b=[`%c[${C}] %c${k[0]} %c${u}`,f("blue"),f(""),f("grey")]:b=[`%c[${C}] %c${k[0]}`,f("blue"),f(""),...k.slice(1)]:b=[`%c[${C}]%`,f("blue"),...k],u&&!g&&b.push(u),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,b)}e.log=v;function f(p){return`color: ${p}`}}),define(X[66],J([0,1,17,31,7]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(p){return JSON.stringify(p,v)}e.stringify=R;function M(p){let C=JSON.parse(p);return C=f(C),C}e.parse=M;function v(p,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,t.regExpFlags)(C)}:C}function f(p,C=0){if(!p||C>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return D.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 14:return new Date(p.source)}if(p instanceof S.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let k=0;k<p.length;++k)p[k]=f(p[k],C+1);else for(const k in p)Object.hasOwnProperty.call(p,k)&&(p[k]=f(p[k],C+1))}return p}e.revive=f}),define(X[12],J([0,1,4,7]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebook="vscode-notebook",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractive="vscode-interactive",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}setServerRootPath(f){this._remoteResourcesPath=`${f}/${D.vscodeRemoteResource}`}set(f,p,C){this._hosts[f]=p,this._ports[f]=C}setConnectionToken(f,p){this._connectionTokens[f]=p}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(f){if(this._delegate)return this._delegate(f);const p=f.authority;let C=this._hosts[p];C&&C.indexOf(":")!==-1&&(C=`[${C}]`);const k=this._ports[p],y=this._connectionTokens[p];let g=`path=${encodeURIComponent(f.path)}`;return typeof y=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),t.URI.from({scheme:S.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${C}:${k}`,path:this._remoteResourcesPath,query:g})}}e.RemoteAuthorities=new R;class M{asBrowserUri(f,p){const C=this.toUri(f,p);return C.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===D.file&&(S.isNative||S.isWebWorker&&S.globals.origin===`${D.vscodeFileResource}://${M.FALLBACK_AUTHORITY}`)?C.with({scheme:D.vscodeFileResource,authority:C.authority||M.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(f,p){const C=this.toUri(f,p);return C.scheme===D.vscodeFileResource?C.with({scheme:D.file,authority:C.authority!==M.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(f,p){return t.URI.isUri(f)?f:t.URI.parse(p.toUrl(f))}}M.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new M}),define(X[16],J([0,1,30,12,9,4,31,7]),function(z,e,S,t,D,R,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(g){return(0,v.uriToFsPath)(g,!0)}e.originalFSPath=f;class p{constructor(u){this._ignorePathCasing=u}compare(u,b,m=!1){return u===b?0:(0,M.compare)(this.getComparisonKey(u,m),this.getComparisonKey(b,m))}isEqual(u,b,m=!1){return u===b?!0:!u||!b?!1:this.getComparisonKey(u,m)===this.getComparisonKey(b,m)}getComparisonKey(u,b=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,b,m=!1){if(u.scheme===b.scheme){if(u.scheme===t.Schemas.file)return S.isEqualOrParent(f(u),f(b),this._ignorePathCasing(u))&&u.query===b.query&&(m||u.fragment===b.fragment);if((0,e.isEqualAuthority)(u.authority,b.authority))return S.isEqualOrParent(u.path,b.path,this._ignorePathCasing(u),"/")&&u.query===b.query&&(m||u.fragment===b.fragment)}return!1}joinPath(u,...b){return v.URI.joinPath(u,...b)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return D.posix.basename(u.path)}extname(u){return D.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let b;return u.scheme===t.Schemas.file?b=v.URI.file(D.dirname(f(u))).path:(b=D.posix.dirname(u.path),u.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),b="/")),u.with({path:b})}normalizePath(u){if(!u.path.length)return u;let b;return u.scheme===t.Schemas.file?b=v.URI.file(D.normalize(f(u))).path:b=D.posix.normalize(u.path),u.with({path:b})}relativePath(u,b){if(u.scheme!==b.scheme||!(0,e.isEqualAuthority)(u.authority,b.authority))return;if(u.scheme===t.Schemas.file){const I=D.relative(f(u),f(b));return R.isWindows?S.toSlashes(I):I}let m=u.path||"/";const E=b.path||"/";if(this._ignorePathCasing(u)){let I=0;for(const w=Math.min(m.length,E.length);I<w&&!(m.charCodeAt(I)!==E.charCodeAt(I)&&m.charAt(I).toLowerCase()!==E.charAt(I).toLowerCase());I++);m=E.substr(0,I)+m.substr(I)}return D.posix.relative(m,E)}resolvePath(u,b){if(u.scheme===t.Schemas.file){const m=v.URI.file(D.resolve(f(u),b));return u.with({authority:m.authority,path:m.path})}return b=S.toPosixPath(b),u.with({path:D.posix.resolve(u.path,b)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,b){return u===b||u!==void 0&&b!==void 0&&(0,M.equalsIgnoreCase)(u,b)}hasTrailingPathSeparator(u,b=D.sep){if(u.scheme===t.Schemas.file){const m=f(u);return m.length>S.getRoot(m).length&&m[m.length-1]===b}else{const m=u.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,b=D.sep){return(0,e.hasTrailingPathSeparator)(u,b)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,b=D.sep){let m=!1;if(u.scheme===t.Schemas.file){const E=f(u);m=E!==void 0&&E.length===S.getRoot(E).length&&E[E.length-1]===b}else{b="/";const E=u.path;m=E.length===1&&E.charCodeAt(E.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(u,b)?u.with({path:u.path+"/"}):u}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(g=>g.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new p(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(g,u){const b=[];for(let m=0;m<g.length;m++){const E=u(g[m]);g.some((I,w)=>w===m?!1:(0,e.isEqualOrParent)(E,u(I)))||b.push(g[m])}return b}e.distinctParents=C;var k;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function u(b){const m=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(w=>{const[h,l]=w.split(":");h&&l&&m.set(h,l)});const I=b.path.substring(0,b.path.indexOf(";"));return I&&m.set(g.META_DATA_MIME,I),m}g.parseMetaData=u})(k=e.DataUri||(e.DataUri={}));function y(g,u,b){if(u){let m=g.path;return m&&m[0]!==D.posix.sep&&(m=D.posix.sep+m),g.with({scheme:b,authority:u,path:m})}return g.with({scheme:b})}e.toLocalResource=y}),define(X[8],J([0,1,21,19,3,2,16,4]),function(z,e,S,t,D,R,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function f(Q){return!!Q&&typeof Q.then=="function"}e.isThenable=f;function p(Q){const A=new S.CancellationTokenSource,O=Q(A.token),N=new Promise(($,Y)=>{const U=A.token.onCancellationRequested(()=>{U.dispose(),A.dispose(),Y(new t.CancellationError)});Promise.resolve(O).then(j=>{U.dispose(),A.dispose(),$(j)},j=>{U.dispose(),A.dispose(),Y(j)})});return new class{cancel(){A.cancel()}then($,Y){return N.then($,Y)}catch($){return this.then(void 0,$)}finally($){return N.finally($)}}}e.createCancelablePromise=p;function C(Q,A,O){return new Promise((N,$)=>{const Y=A.onCancellationRequested(()=>{Y.dispose(),N(O)});Q.then(N,$).finally(()=>Y.dispose())})}e.raceCancellation=C;function k(Q,A){return new Promise((O,N)=>{const $=A.onCancellationRequested(()=>{$.dispose(),N(new t.CancellationError)});Q.then(O,N).finally(()=>$.dispose())})}e.raceCancellationError=k;async function y(Q){let A=-1;const O=Q.map(($,Y)=>$.then(U=>(A=Y,U))),N=await Promise.race(O);return Q.forEach(($,Y)=>{Y!==A&&$.cancel()}),N}e.raceCancellablePromises=y;function g(Q,A,O){let N;const $=setTimeout(()=>{N?.(void 0),O?.()},A);return Promise.race([Q.finally(()=>clearTimeout($)),new Promise(Y=>N=Y)])}e.raceTimeout=g;function u(Q){return new Promise((A,O)=>{const N=Q();f(N)?N.then(A,O):A(N)})}e.asPromise=u;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(O,O).then(N)})}return new Promise((O,N)=>{this.queuedPromise.then(O,N)})}return this.activePromise=A(),new Promise((O,N)=>{this.activePromise.then($=>{this.activePromise=null,O($)},$=>{this.activePromise=null,N($)})})}}e.Throttler=b;class m{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=m;class E{constructor(){this.promiseMap=new Map}queue(A,O){const $=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(A)===$&&this.promiseMap.delete(A)});return this.promiseMap.set(A,$),$}}e.SequencerByKey=E;const I=(Q,A)=>{let O=!0;const N=setTimeout(()=>{O=!1,A()},Q);return{isTriggered:()=>O,dispose:()=>{clearTimeout(N),O=!1}}},w=Q=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,Q())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,O=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,Y)=>{this.doResolve=$,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}}));const N=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?w(N):I(O,N),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=h;class l{constructor(A){this.delayer=new h(A),this.throttler=new b}trigger(A,O){return this.delayer.trigger(()=>this.throttler.queue(A),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class r{constructor(){this._isOpen=!1,this._promise=new Promise((A,O)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class n extends r{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function i(Q,A){return A?new Promise((O,N)=>{const $=setTimeout(()=>{Y.dispose(),O()},Q),Y=A.onCancellationRequested(()=>{clearTimeout($),Y.dispose(),N(new t.CancellationError)})}):p(O=>i(Q,O))}e.timeout=i;function s(Q,A=0){const O=setTimeout(Q,A);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=s;function o(Q){const A=[];let O=0;const N=Q.length;function $(){return O<N?Q[O++]():null}function Y(U){U!=null&&A.push(U);const j=$();return j?j.then(Y):Promise.resolve(A)}return Promise.resolve(null).then(Y)}e.sequence=o;function a(Q,A=N=>!!N,O=null){let N=0;const $=Q.length,Y=()=>{if(N>=$)return Promise.resolve(O);const U=Q[N++];return Promise.resolve(U()).then(Z=>A(Z)?Promise.resolve(Z):Y())};return Y()}e.first=a;function c(Q,A=N=>!!N,O=null){if(Q.length===0)return Promise.resolve(O);let N=Q.length;const $=()=>{N=-1;for(const Y of Q)Y.cancel?.()};return new Promise((Y,U)=>{for(const j of Q)j.then(Z=>{--N>=0&&A(Z)?($(),Y(Z)):N===0&&Y(O)}).catch(Z=>{--N>=0&&($(),U(Z))})})}e.firstParallel=c;class d{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(A){return this._size++,new Promise((O,N)=>{this.outstandingPromises.push({factory:A,c:O,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const O=A.factory();O.then(A.c,A.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=d;class P extends d{constructor(){super(1)}}e.Queue=P;class L{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new F;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,O=M.extUri){const N=O.getComparisonKey(A);let $=this.queues.get(N);return $||($=new P,D.Event.once($.onDrained)(()=>{$?.dispose(),this.queues.delete(N),this.onDidQueueDrain()}),this.queues.set(N,$)),$}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=L;class T{constructor(A,O){this._token=-1,typeof A=="function"&&typeof O=="number"&&this.setIfNotSet(A,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},O)}setIfNotSet(A,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},O))}}e.TimeoutTimer=T;class W{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setInterval(()=>{A()},O)}}e.IntervalTimer=W;class q{constructor(A,O){this.timeoutToken=-1,this.runner=A,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=q;class ee{constructor(A,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=ee;class se extends q{constructor(A,O){super(A,O);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner?.(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=se;class ae extends R.Disposable{constructor(A,O){super();this.options=A,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ae,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Q=>{(0,v.setTimeout0)(()=>{if(A)return;const O=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(Q,A)=>{const O=requestIdleCallback(Q,typeof A=="number"?{timeout:A}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(O))}}}}();class te{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=te;async function ce(Q,A,O){let N;for(let $=0;$<O;$++)try{return await Q()}catch(Y){N=Y,await i(A)}throw N}e.retry=ce;class H{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,O,N){return this._pending={taskId:A,cancel:()=>N?.(),promise:O},O.then(()=>this.donePending(A),()=>this.donePending(A)),O}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let O,N;const $=new Promise((Y,U)=>{O=Y,N=U});this._next={run:A,promise:$,promiseResolve:O,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=H;class ne{constructor(A,O=()=>Date.now()){this.interval=A,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=ne;class F{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,O)=>{this.completeCallback=A,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(O=>{this.completeCallback(A),this.resolved=!0,O()})}error(A){return new Promise(O=>{this.errorCallback(A),this.rejected=!0,O()})}cancel(){new Promise(A=>{this.errorCallback(new t.CancellationError),this.rejected=!0,A()})}}e.DeferredPromise=F;var _;(function(Q){async function A(N){let $;const Y=await Promise.all(N.map(U=>U.then(j=>j,j=>{$||($=j)})));if(typeof $!="undefined")throw $;return Y}Q.settled=A;function O(N){return new Promise(async($,Y)=>{try{await N($,Y)}catch(U){Y(U)}})}Q.withAsyncBody=O})(_=e.Promises||(e.Promises={}));var B;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(B||(B={}));class G{constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const O={emitOne:N=>this.emitOne(N),emitMany:N=>this.emitMany(N),reject:N=>this.reject(N)};try{await Promise.resolve(A(O)),this.resolve()}catch(N){this.reject(N)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(A){return new G(O=>{O.emitMany(A)})}static fromPromise(A){return new G(async O=>{O.emitMany(await A)})}static fromPromises(A){return new G(async O=>{await Promise.all(A.map(async N=>O.emitOne(await N)))})}static merge(A){return new G(async O=>{await Promise.all(A.map(async N=>{for await(const $ of N)O.emitOne($)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,O){return new G(async N=>{for await(const $ of A)N.emitOne(O($))})}map(A){return G.map(this,A)}static filter(A,O){return new G(async N=>{for await(const $ of A)O($)&&N.emitOne($)})}filter(A){return G.filter(this,A)}static coalesce(A){return G.filter(A,O=>!!O)}coalesce(){return G.coalesce(this)}static async toPromise(A){const O=[];for await(const N of A)O.push(N);return O}toPromise(){return G.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=G,G.EMPTY=G.fromArray([]);class ie extends G{constructor(A,O){super(O);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ie;function V(Q){const A=new S.CancellationTokenSource,O=Q(A.token);return new ie(A,async N=>{const $=A.token.onCancellationRequested(()=>{$.dispose(),A.dispose(),N.reject(new t.CancellationError)});try{for await(const Y of O){if(A.token.isCancellationRequested)return;N.emitOne(Y)}$.dispose(),A.dispose()}catch(Y){$.dispose(),A.dispose(),N.reject(Y)}})}e.createCancelableAsyncIterable=V}),define(X[92],J([0,1,25,8,30,33,9,4,31]),function(z,e,S,t,D,R,M,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function p(){return Object.create(null)}e.getEmptyExpression=p,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",k="[^/\\\\]",y=/\//g;function g(F,_){switch(F){case 0:return"";case 1:return`${k}*?`;default:return`(?:${C}|${k}+${C}${_?`|${C}${k}+`:""})*?`}}function u(F,_){if(!F)return[];const B=[];let G=!1,ie=!1,V="";for(const Q of F){switch(Q){case _:if(!G&&!ie){B.push(V),V="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}V+=Q}return V&&B.push(V),B}e.splitGlobAware=u;function b(F){if(!F)return"";let _="";const B=u(F,e.GLOB_SPLIT);if(B.every(G=>G===e.GLOBSTAR))_=".*";else{let G=!1;B.forEach((ie,V)=>{if(ie===e.GLOBSTAR){if(G)return;_+=g(2,V===B.length-1)}else{let Q=!1,A="",O=!1,N="";for(const $ of ie){if($!=="}"&&Q){A+=$;continue}if(O&&($!=="]"||!N)){let Y;$==="-"?Y=$:($==="^"||$==="!")&&!N?Y="^":$===e.GLOB_SPLIT?Y="":Y=(0,f.escapeRegExpCharacters)($),N+=Y;continue}switch($){case"{":Q=!0;continue;case"[":O=!0;continue;case"}":{_+=`(?:${u(A,",").map(j=>b(j)).join("|")})`,Q=!1,A="";break}case"]":{_+="["+N+"]",O=!1,N="";break}case"?":_+=k;continue;case"*":_+=g(1);continue;default:_+=(0,f.escapeRegExpCharacters)($)}}V<B.length-1&&(B[V+1]!==e.GLOBSTAR||V+2<B.length)&&(_+=C)}G=ie===e.GLOBSTAR})}return _}const m=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new R.LRUCache(1e4),n=function(){return!1},i=function(){return null};function s(F,_){if(!F)return i;let B;typeof F!="string"?B=F.pattern:B=F,B=B.trim();const G=`${B}_${!!_.trimForExclusions}`;let ie=r.get(G);if(ie)return o(ie,F);let V;return m.test(B)?ie=c(B.substr(4),B):(V=E.exec(a(B,_)))?ie=d(V[1],B):(_.trimForExclusions?w:I).test(B)?ie=P(B,_):(V=h.exec(a(B,_)))?ie=L(V[1].substr(1),B,!0):(V=l.exec(a(B,_)))?ie=L(V[1],B,!1):ie=T(B),r.set(G,ie),o(ie,F)}function o(F,_){if(typeof _=="string")return F;const B=function(G,ie){return(0,D.isEqualOrParent)(G,_.base,!v.isLinux)?F(G.substr(_.base.length+1),ie):null};return B.allBasenames=F.allBasenames,B.allPaths=F.allPaths,B.basenames=F.basenames,B.patterns=F.patterns,B}function a(F,_){return _.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function c(F,_){return function(B,G){return typeof B=="string"&&B.endsWith(F)?_:null}}function d(F,_){const B=`/${F}`,G=`\\${F}`,ie=function(Q,A){return typeof Q!="string"?null:A?A===F?_:null:Q===F||Q.endsWith(B)||Q.endsWith(G)?_:null},V=[F];return ie.basenames=V,ie.patterns=[_],ie.allBasenames=V,ie}function P(F,_){const B=H(F.slice(1,-1).split(",").map(A=>s(A,_)).filter(A=>A!==i),F),G=B.length;if(!G)return i;if(G===1)return B[0];const ie=function(A,O){for(let N=0,$=B.length;N<$;N++)if(B[N](A,O))return F;return null},V=B.find(A=>!!A.allBasenames);V&&(ie.allBasenames=V.allBasenames);const Q=B.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return Q.length&&(ie.allPaths=Q),ie}function L(F,_,B){const G=M.sep===M.posix.sep,ie=G?F:F.replace(y,M.sep),V=M.sep+ie,Q=M.posix.sep+F;let A;return B?A=function(O,N){return typeof O=="string"&&(O===ie||O.endsWith(V)||!G&&(O===F||O.endsWith(Q)))?_:null}:A=function(O,N){return typeof O=="string"&&(O===ie||!G&&O===F)?_:null},A.allPaths=[(B?"*/":"./")+F],A}function T(F){try{const _=new RegExp(`^${b(F)}$`);return function(B){return _.lastIndex=0,typeof B=="string"&&_.test(B)?F:null}}catch{return i}}function W(F,_,B){return!F||typeof _!="string"?!1:q(F)(_,void 0,B)}e.match=W;function q(F,_={}){if(!F)return n;if(typeof F=="string"||ee(F)){const B=s(F,_);if(B===i)return n;const G=function(ie,V){return!!B(ie,V)};return B.allBasenames&&(G.allBasenames=B.allBasenames),B.allPaths&&(G.allPaths=B.allPaths),G}return te(F,_)}e.parse=q;function ee(F){const _=F;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.isRelativePattern=ee;function se(F){return F.allBasenames||[]}e.getBasenameTerms=se;function ae(F){return F.allPaths||[]}e.getPathTerms=ae;function te(F,_){const B=H(Object.getOwnPropertyNames(F).map(A=>ce(A,F[A],_)).filter(A=>A!==i)),G=B.length;if(!G)return i;if(!B.some(A=>!!A.requiresSiblings)){if(G===1)return B[0];const A=function($,Y){let U;for(let j=0,Z=B.length;j<Z;j++){const re=B[j]($,Y);if(typeof re=="string")return re;(0,t.isThenable)(re)&&(U||(U=[]),U.push(re))}return U?(async()=>{for(const j of U){const Z=await j;if(typeof Z=="string")return Z}return null})():null},O=B.find($=>!!$.allBasenames);O&&(A.allBasenames=O.allBasenames);const N=B.reduce(($,Y)=>Y.allPaths?$.concat(Y.allPaths):$,[]);return N.length&&(A.allPaths=N),A}const ie=function(A,O,N){let $,Y;for(let U=0,j=B.length;U<j;U++){const Z=B[U];Z.requiresSiblings&&N&&(O||(O=(0,M.basename)(A)),$||($=O.substr(0,O.length-(0,M.extname)(A).length)));const re=Z(A,O,$,N);if(typeof re=="string")return re;(0,t.isThenable)(re)&&(Y||(Y=[]),Y.push(re))}return Y?(async()=>{for(const U of Y){const j=await U;if(typeof j=="string")return j}return null})():null},V=B.find(A=>!!A.allBasenames);V&&(ie.allBasenames=V.allBasenames);const Q=B.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return Q.length&&(ie.allPaths=Q),ie}function ce(F,_,B){if(_===!1)return i;const G=s(F,B);if(G===i)return i;if(typeof _=="boolean")return G;if(_){const ie=_.when;if(typeof ie=="string"){const V=(Q,A,O,N)=>{if(!N||!G(Q,A))return null;const $=ie.replace("$(basename)",O),Y=N($);return(0,t.isThenable)(Y)?Y.then(U=>U?F:null):Y?F:null};return V.requiresSiblings=!0,V}}return G}function H(F,_){const B=F.filter(A=>!!A.basenames);if(B.length<2)return F;const G=B.reduce((A,O)=>{const N=O.basenames;return N?A.concat(N):A},[]);let ie;if(_){ie=[];for(let A=0,O=G.length;A<O;A++)ie.push(_)}else ie=B.reduce((A,O)=>{const N=O.patterns;return N?A.concat(N):A},[]);const V=function(A,O){if(typeof A!="string")return null;if(!O){let $;for($=A.length;$>0;$--){const Y=A.charCodeAt($-1);if(Y===47||Y===92)break}O=A.substr($)}const N=G.indexOf(O);return N!==-1?ie[N]:null};V.basenames=G,V.patterns=ie,V.allBasenames=G;const Q=F.filter(A=>!A.basenames);return Q.push(V),Q}function ne(F,_){return(0,S.equals)(F,_,(B,G)=>typeof B=="string"&&typeof G=="string"?B===G:typeof B!="string"&&typeof G!="string"?B.base===G.base&&B.pattern===G.pattern:!1)}e.patternsEquals=ne}),define(X[34],J([0,1,25,30,9,4,16,31]),function(z,e,S,t,D,R,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function f(i,s){const{os:o,tildify:a,relative:c}=s;if(c){const L=p(i,c,o);if(typeof L=="string")return L}let d=i.fsPath;if(o===1&&!R.isWindows?d=d.replace(/\//g,"\\"):o!==1&&R.isWindows&&(d=d.replace(/\\/g,"/")),o!==1&&a?.userHome){const L=a.userHome.fsPath;let T;i.scheme!==a.userHome.scheme&&i.path.startsWith(D.posix.sep)?T=a.userHome.with({path:i.path}).fsPath:T=i.fsPath,d=y(T,L,o)}return(o===1?D.win32:D.posix).normalize(C(d,o===1))}e.getPathLabel=f;function p(i,s,o){const a=o===1?D.win32:D.posix,c=o===3?M.extUri:M.extUriIgnorePathCase,d=s.getWorkspace(),P=(0,S.firstOrDefault)(d.folders);if(!P)return;i.scheme!==P.uri.scheme&&i.path.startsWith(D.posix.sep)&&(i=P.uri.with({path:i.path}));const L=s.getWorkspaceFolder(i);if(!L)return;let T;if(c.isEqual(L.uri,i)?T="":T=c.relativePath(L.uri,i)??"",T&&(T=a.normalize(T)),d.folders.length>1&&!s.noPrefix){const W=L.name?L.name:c.basenameOrAuthority(L.uri);T=T?`${W} \u2022 ${T}`:W}return T}function C(i,s=R.isWindows){return(0,t.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let k=Object.create(null);function y(i,s,o=R.OS){if(o===1||!i||!s)return i;let a=k.original===s?k.normalized:void 0;a||(a=s,R.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,v.rtrim)(a,D.posix.sep)}${D.posix.sep}`,k={original:s,normalized:a});let c=i;return R.isWindows&&(c=(0,t.toSlashes)(c)),(o===3?c.startsWith(a):(0,v.startsWithIgnoreCase)(c,a))?`~/${c.substr(a.length)}`:i}e.tildify=y;function g(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=g;const u="\u2026",b="\\\\",m="~";function E(i,s=D.sep){const o=new Array(i.length);let a=!1;for(let c=0;c<i.length;c++){const d=i[c];if(d===""){o[c]=`.${s}`;continue}if(!d){o[c]=d;continue}a=!0;let P="",L=d;L.indexOf(b)===0?(P=L.substr(0,L.indexOf(b)+b.length),L=L.substr(L.indexOf(b)+b.length)):L.indexOf(s)===0?(P=L.substr(0,L.indexOf(s)+s.length),L=L.substr(L.indexOf(s)+s.length)):L.indexOf(m)===0&&(P=L.substr(0,L.indexOf(m)+m.length),L=L.substr(L.indexOf(m)+m.length));const T=L.split(s);for(let W=1;a&&W<=T.length;W++)for(let q=T.length-W;a&&q>=0;q--){a=!1;let ee=T.slice(q,q+W).join(s);for(let se=0;!a&&se<i.length;se++)if(se!==c&&i[se]&&i[se].indexOf(ee)>-1){const ae=q+W===T.length,te=q>0&&i[se].indexOf(s)>-1?s+ee:ee,ce=i[se].endsWith(te);a=!ae||ce}if(!a){let se="";(T[0].endsWith(":")||P!=="")&&(q===1&&(q=0,W++,ee=T[0]+s+ee),q>0&&(se=T[0]+s),se=P+se),q>0&&(se=se+u+s),se=se+ee,q+W<T.length&&(se=se+s+u),o[c]=se}}a&&(o[c]=d)}return o}e.shorten=E;var I;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(I||(I={}));function w(i,s=Object.create(null)){const o=[];let a=!1,c="";for(const d of i)if(d==="$"||a&&d==="{")c&&o.push({value:c,type:I.TEXT}),c="",a=!0;else if(d==="}"&&a){const P=s[c];if(typeof P=="string")P.length&&o.push({value:P,type:I.VARIABLE});else if(P){const L=o[o.length-1];(!L||L.type!==I.SEPARATOR)&&o.push({value:P.label,type:I.SEPARATOR})}c="",a=!1}else c+=d;return c&&!a&&o.push({value:c,type:I.TEXT}),o.filter((d,P)=>{if(d.type===I.SEPARATOR){const L=o[P-1],T=o[P+1];return[L,T].every(W=>W&&(W.type===I.VARIABLE||W.type===I.TEXT)&&W.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=w;function h(i,s){return R.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function l(i,s){return R.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function n(i){const s=i.indexOf("/")!==-1?D.posix:D.win32,o=s.basename(i),a=s.dirname(i);return o.length?{name:o,parentPath:a}:{name:a,parentPath:""}}e.splitName=n}),define(X[137],J([0,1,7]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(C){return C.toJSON()}class D{constructor(k){this._uriTransformer=k}transformIncoming(k){const y=this._uriTransformer.transformIncoming(k);return y===k?k:t(S.URI.from(y))}transformOutgoing(k){const y=this._uriTransformer.transformOutgoing(k);return y===k?k:t(S.URI.from(y))}transformOutgoingURI(k){const y=this._uriTransformer.transformOutgoing(k);return y===k?k:S.URI.from(y)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,k,y){if(!C||y>200)return null;if(typeof C=="object"){if(C instanceof S.URI)return k.transformOutgoing(C);for(const g in C)if(Object.hasOwnProperty.call(C,g)){const u=R(C[g],k,y+1);u!==null&&(C[g]=u)}}return null}function M(C,k){const y=R(C,k,0);return y===null?C:y}e.transformOutgoingURIs=M;function v(C,k,y,g){if(!C||g>200)return null;if(typeof C=="object"){if(C.$mid===1)return y?S.URI.revive(k.transformIncoming(C)):k.transformIncoming(C);for(const u in C)if(Object.hasOwnProperty.call(C,u)){const b=v(C[u],k,y,g+1);b!==null&&(C[u]=b)}}return null}function f(C,k){const y=v(C,k,!1,0);return y===null?C:y}e.transformIncomingURIs=f;function p(C,k){const y=v(C,k,!0,0);return y===null?C:y}e.transformAndReviveIncomingURIs=p}),define(X[80],J([0,1,29,19,33,27,127]),function(z,e,S,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(C){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(C)}value(){if(this._value===void 0){let C=0,k=0;const y=(0,S.networkInterfaces)();for(const g in y){const u=y[g];if(u)for(const{mac:b,internal:m}of u)m||(k+=1,this._isVirtualMachineMacAddress(b.toUpperCase())&&(C+=1))}this._value=k>0?C/k:0}return this._value}};let v;async function f(){return v||(v=(async()=>await p()||R.generateUuid())()),v}e.getMachineId=f;async function p(){try{const C=await new Promise((y,g)=>{z(["crypto"],y,g)}),k=(0,M.getMac)();return C.createHash("sha256").update(k,"utf8").digest("hex")}catch(C){t.onUnexpectedError(C);return}}}),define(X[23],J([0,1,28,29,138,8,30,79,9,4,16,7]),function(z,e,S,t,D,R,M,v,f,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(te){te[te.UNLINK=0]="UNLINK",te[te.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function g(te,ce=y.UNLINK){if((0,M.isRootOrDriveLetter)(te))throw new Error("rimraf - will refuse to recursively delete root");return ce===y.UNLINK?b(te):u(te)}async function u(te){try{const ce=(0,M.randomPath)((0,t.tmpdir)());try{await S.promises.rename(te,ce)}catch{return b(te)}b(ce).catch(H=>{})}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function b(te){return(0,D.promisify)(S.rm)(te,{recursive:!0,force:!0,maxRetries:3})}function m(te){if((0,M.isRootOrDriveLetter)(te))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(te,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function E(te,ce){return h(await(ce?I(te):(0,D.promisify)(S.readdir)(te)))}async function I(te){try{return await(0,D.promisify)(S.readdir)(te,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const ce=[],H=await E(te);for(const ne of H){let F=!1,_=!1,B=!1;try{const G=await e.Promises.lstat((0,f.join)(te,ne));F=G.isFile(),_=G.isDirectory(),B=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}ce.push({name:ne,isFile:()=>F,isDirectory:()=>_,isSymbolicLink:()=>B})}return ce}function w(te){return h(S.readdirSync(te))}e.readdirSync=w;function h(te){return te.map(ce=>typeof ce=="string"?p.isMacintosh?(0,v.normalizeNFC)(ce):ce:(ce.name=p.isMacintosh?(0,v.normalizeNFC)(ce.name):ce.name,ce))}async function l(te){const ce=await E(te),H=[];for(const ne of ce)await n.existsDirectory((0,f.join)(te,ne))&&H.push(ne);return H}function r(te,ce=1e3){return new Promise(H=>{let ne=!1;const F=setInterval(()=>{ne||(ne=!0,S.access(te,_=>{ne=!1,_&&(clearInterval(F),H(void 0))}))},ce)})}e.whenDeleted=r;var n;(function(te){async function ce(F){let _;try{if(_=await e.Promises.lstat(F),!_.isSymbolicLink())return{stat:_}}catch{}try{return{stat:await e.Promises.stat(F),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(p.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw G}throw B}}te.stat=ce;async function H(F){try{const{stat:_,symbolicLink:B}=await te.stat(F);return _.isFile()&&B?.dangling!==!0}catch{}return!1}te.existsFile=H;async function ne(F){try{const{stat:_,symbolicLink:B}=await te.stat(F);return _.isDirectory()&&B?.dangling!==!0}catch{}return!1}te.existsDirectory=ne})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function s(te,ce,H){return i.queueFor(k.URI.file(te),C.extUriBiasedIgnorePathCase).queue(()=>{const ne=P(H);return new Promise((F,_)=>c(te,ce,ne,B=>B?_(B):F()))})}let o=!0;function a(te){o=te}e.configureFlushOnWrite=a;function c(te,ce,H,ne){if(!o)return S.writeFile(te,ce,{mode:H.mode,flag:H.flag},ne);S.open(te,H.flag,H.mode,(F,_)=>{if(F)return ne(F);S.writeFile(_,ce,B=>{if(B)return S.close(_,()=>ne(B));S.fdatasync(_,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),a(!1)),S.close(_,ie=>ne(ie))))})})}function d(te,ce,H){const ne=P(H);if(!o)return S.writeFileSync(te,ce,{mode:ne.mode,flag:ne.flag});const F=S.openSync(te,ne.flag,ne.mode);try{S.writeFileSync(F,ce);try{S.fdatasyncSync(F)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),a(!1)}}finally{S.closeSync(F)}}e.writeFileSync=d;function P(te){return te?{mode:typeof te.mode=="number"?te.mode:438,flag:typeof te.flag=="string"?te.flag:"w"}:{mode:438,flag:"w"}}async function L(te,ce){if(te!==ce)try{await e.Promises.rename(te,ce)}catch(H){if(te.toLowerCase()!==ce.toLowerCase()&&H.code==="EXDEV"||te.endsWith("."))await T(te,ce,{preserveSymlinks:!1}),await g(te,y.MOVE);else throw H}}async function T(te,ce,H){return q(te,ce,{root:{source:te,target:ce},options:H,handledSourcePaths:new Set})}const W=511;async function q(te,ce,H){if(H.handledSourcePaths.has(te))return;H.handledSourcePaths.add(te);const{stat:ne,symbolicLink:F}=await n.stat(te);if(F){if(H.options.preserveSymlinks)try{return await ae(te,ce,H)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(F.dangling)return}return ne.isDirectory()?ee(te,ce,ne.mode&W,H):se(te,ce,ne.mode&W)}async function ee(te,ce,H,ne){await e.Promises.mkdir(ce,{recursive:!0,mode:H});const F=await E(te);for(const _ of F)await q((0,f.join)(te,_),(0,f.join)(ce,_),ne)}async function se(te,ce,H){await e.Promises.copyFile(te,ce),await e.Promises.chmod(ce,H)}async function ae(te,ce,H){let ne=await e.Promises.readlink(te);(0,M.isEqualOrParent)(ne,H.root.source,!p.isLinux)&&(ne=(0,f.join)(H.root.target,ne.substr(H.root.source.length+1))),await e.Promises.symlink(ne,ce)}e.Promises=new class{get access(){return(0,D.promisify)(S.access)}get stat(){return(0,D.promisify)(S.stat)}get lstat(){return(0,D.promisify)(S.lstat)}get utimes(){return(0,D.promisify)(S.utimes)}get read(){return(te,ce,H,ne,F)=>new Promise((_,B)=>{S.read(te,ce,H,ne,F,(G,ie,V)=>G?B(G):_({bytesRead:ie,buffer:V}))})}get readFile(){return(0,D.promisify)(S.readFile)}get write(){return(te,ce,H,ne,F)=>new Promise((_,B)=>{S.write(te,ce,H,ne,F,(G,ie,V)=>G?B(G):_({bytesWritten:ie,buffer:V}))})}get appendFile(){return(0,D.promisify)(S.appendFile)}get fdatasync(){return(0,D.promisify)(S.fdatasync)}get truncate(){return(0,D.promisify)(S.truncate)}get rename(){return(0,D.promisify)(S.rename)}get copyFile(){return(0,D.promisify)(S.copyFile)}get open(){return(0,D.promisify)(S.open)}get close(){return(0,D.promisify)(S.close)}get symlink(){return(0,D.promisify)(S.symlink)}get readlink(){return(0,D.promisify)(S.readlink)}get chmod(){return(0,D.promisify)(S.chmod)}get mkdir(){return(0,D.promisify)(S.mkdir)}get unlink(){return(0,D.promisify)(S.unlink)}get rmdir(){return(0,D.promisify)(S.rmdir)}get realpath(){return(0,D.promisify)(S.realpath)}async exists(te){try{return await e.Promises.access(te),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return l}get writeFile(){return s}get rm(){return g}get move(){return L}get copy(){return T}}}),define(X[93],J([0,1,28,9,4,31,23]),function(z,e,S,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function v(y){if(D.isLinux)return y;const g=(0,t.dirname)(y);if(y===g)return y;const u=((0,t.basename)(y)||y).toLowerCase();try{const m=(0,M.readdirSync)(g).filter(E=>E.toLowerCase()===u);if(m.length===1){const E=v(g);if(E)return(0,t.join)(E,m[0])}else if(m.length>1){const E=m.indexOf(u);if(E>=0){const I=v(g);if(I)return(0,t.join)(I,m[E])}}}catch{}return null}e.realcaseSync=v;async function f(y){if(D.isLinux)return y;const g=(0,t.dirname)(y);if(y===g)return y;const u=((0,t.basename)(y)||y).toLowerCase();try{const m=(await M.Promises.readdir(g)).filter(E=>E.toLowerCase()===u);if(m.length===1){const E=await f(g);if(E)return(0,t.join)(E,m[0])}else if(m.length>1){const E=m.indexOf(u);if(E>=0){const I=await f(g);if(I)return(0,t.join)(I,m[E])}}}catch{}return null}e.realcase=f;async function p(y){try{return await M.Promises.realpath(y)}catch{const u=k(y);return await M.Promises.access(u,S.constants.R_OK),u}}e.realpath=p;function C(y){try{return S.realpathSync(y)}catch{const u=k(y);return S.accessSync(u,S.constants.R_OK),u}}e.realpathSync=C;function k(y){return(0,R.rtrim)((0,t.normalize)(y),t.sep)}}),define(X[139],J([0,1,29,9,23]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,M=/^Microsoft.PowerShell_.*/,v=/^Microsoft.PowerShellPreview_.*/;var f;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(f||(f={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class k{constructor(l,r,n){this.exePath=l,this.displayName=r,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:h=!1}={}){return h?p===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:h=!1,findPreview:l=!1}={}){const r=y({useAlternateBitness:h});if(!r)return null;const n=t.join(r,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(n))return null;let i=-1,s=null;for(const c of await D.Promises.readdir(n)){let d=-1;if(l){const L=c.indexOf("-");if(L<0)continue;const T=c.substring(0,L);if(!R.test(T)||c.substring(L+1)!=="preview")continue;d=parseInt(T,10)}else{if(!R.test(c))continue;d=parseInt(c,10)}if(d<=i)continue;const P=t.join(n,c,"pwsh.exe");!await D.SymlinkSupport.existsFile(P)||(s=P,i=d)}if(!s)return null;const o=r.includes("x86")?" (x86)":"",a=l?" Preview":"";return new k(s,`PowerShell${a}${o}`,!0)}async function u({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:n}=h?{pwshMsixDirRegex:v,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const i of await D.Promises.readdir(l))if(r.test(i)){const s=t.join(l,i,"pwsh.exe");return new k(s,n)}return null}function b(){const h=t.join(S.homedir(),".dotnet","tools","pwsh.exe");return new k(h,".NET Core PowerShell Global Tool")}function m(){const h=t.join(process.env.windir,p===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(h,"Windows PowerShell",!0)}async function*E(){let h=await g();h&&(yield h),h=await g({useAlternateBitness:!0}),h&&(yield h),h=await u(),h&&(yield h),h=b(),h&&(yield h),h=await g({findPreview:!0}),h&&(yield h),h=await u({findPreview:!0}),h&&(yield h),h=await g({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=m(),h&&(yield h)}async function*I(){for await(const h of E())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=I;async function w(){for await(const h of I())return h;return null}e.getFirstAvailablePowerShellInstallation=w}),define(X[94],J([0,1,42,12]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(M){return new Promise((v,f)=>{let p;const C=new Map;function k(g,u,b,m,E){const I=C.get(u);if(g===M||I){const w={name:y(b),cmd:b,pid:g,ppid:u,load:m,mem:E};C.set(g,w),g===M&&(p=w),I&&(I.children||(I.children=[]),I.children.push(w),I.children.length>1&&(I.children=I.children.sort((h,l)=>h.pid-l.pid)))}}function y(g){const u=/--vscode-window-kind=shared-process/,b=/--vscode-window-kind=issue-reporter/,m=/--vscode-window-kind=process-explorer/,E=/--utility-sub-type=network/,I=/--utility-sub-type=node.mojom.NodeService/,w=/--crashes-directory/,h=/\\pipe\\winpty-control/,l=/conhost\.exe/,r=/--type=([a-zA-Z-]+)/;if(w.exec(g))return"electron-crash-reporter";if(h.exec(g))return"winpty-process";if(l.exec(g))return"console-window-host (Windows internal process)";let n=r.exec(g);if(n&&n.length===2){if(n[1]==="renderer")return u.exec(g)?"shared-process":b.exec(g)?"issue-reporter":m.exec(g)?"process-explorer":"window";if(n[1]==="utility"){if(E.exec(g))return"utility-network-service";if(I.exec(g))return"extension-host"}return n[1]}const i=/[a-zA-Z-]+\.js/g;let s="";do n=i.exec(g),n&&(s+=n+" ");while(n);return s&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${s}`:g}if(process.platform==="win32"){const g=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,b)=>{z(["windows-process-tree"],u,b)}).then(u=>{u.getProcessList(M,b=>{if(!b){f(new Error(`Root process ${M} not found`));return}u.getProcessCpuUsage(b,m=>{const E=new Map;m.forEach(I=>{const w=g(I.commandLine||"");E.set(I.pid,{name:y(w),cmd:w,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),p=E.get(M),p?(E.forEach(I=>{const w=E.get(I.ppid);w&&(w.children||(w.children=[]),w.children.push(I))}),E.forEach(I=>{I.children&&(I.children=I.children.sort((w,h)=>w.pid-h.pid))}),v(p)):f(new Error(`Root process ${M} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let g=function(){let u=[p];const b=[];for(;u.length;){const E=u.shift();E&&(b.push(E.pid),E.children&&(u=u.concat(E.children)))}let m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",z).fsPath);m+=" "+b.join(" "),(0,S.exec)(m,{},(E,I,w)=>{if(E||w)f(E||new Error(w.toString()));else{const h=I.toString().split(`
`);for(let l=0;l<b.length;l++){const r=C.get(b[l]);r.load=parseFloat(h[l])}if(!p){f(new Error(`Root process ${M} not found`));return}v(p)}})};(0,S.exec)("which ps",{},(u,b,m)=>{if(u||m)if(process.platform!=="linux")f(u||new Error(m.toString()));else{const E=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",z).fsPath);(0,S.exec)(E,{},(I,w,h)=>{I||h?f(I||new Error(h.toString())):(R(w,k),g())})}else{const E=b.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${E} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(w,h,l)=>{w||l&&!l.includes("screen size is bogus")?f(w||new Error(l.toString())):(R(h,k),process.platform==="linux"?g():p?v(p):f(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=D;function R(M,v){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=M.toString().split(`
`);for(const C of p){const k=f.exec(C.trim());k&&k.length===6&&v(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}});var fe=this&&this.__decorate||function(z,e,S,t){var D=arguments.length,R=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,S):t,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(z,e,S,t);else for(var v=z.length-1;v>=0;v--)(M=z[v])&&(R=(D<3?M(R):D>3?M(e,S,R):M(e,S))||R);return D>3&&R&&Object.defineProperty(e,S,R),R};define(X[43],J([0,1,25,8,17,21,51,19,3,2,66,31,13]),function(z,e,S,t,D,R,M,v,f,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function u(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(b=e.ResponseType||(e.ResponseType={}));function m(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(E||(E={}));class I{constructor(_){this.buffer=_,this.pos=0}read(_){const B=this.buffer.slice(this.pos,this.pos+_);return this.pos+=B.byteLength,B}}class w{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}var h;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(h||(h={}));function l(F){const _=D.VSBuffer.alloc(4);return _.writeUInt32BE(F,0),_}function r(F){return F.read(4).readUInt32BE(0)}function n(F){const _=D.VSBuffer.alloc(1);return _.writeUInt8(F,0),_}const i={Undefined:n(h.Undefined),String:n(h.String),Buffer:n(h.Buffer),VSBuffer:n(h.VSBuffer),Array:n(h.Array),Object:n(h.Object)},s=typeof Buffer!="undefined";function o(F,_){if(typeof _=="undefined")F.write(i.Undefined);else if(typeof _=="string"){const B=D.VSBuffer.fromString(_);F.write(i.String),F.write(l(B.byteLength)),F.write(B)}else if(s&&Buffer.isBuffer(_)){const B=D.VSBuffer.wrap(_);F.write(i.Buffer),F.write(l(B.byteLength)),F.write(B)}else if(_ instanceof D.VSBuffer)F.write(i.VSBuffer),F.write(l(_.byteLength)),F.write(_);else if(Array.isArray(_)){F.write(i.Array),F.write(l(_.length));for(const B of _)o(F,B)}else{const B=D.VSBuffer.fromString(JSON.stringify(_));F.write(i.Object),F.write(l(B.byteLength)),F.write(B)}}function a(F){switch(F.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return F.read(r(F)).toString();case h.Buffer:return F.read(r(F)).buffer;case h.VSBuffer:return F.read(r(F));case h.Array:{const B=r(F),G=[];for(let ie=0;ie<B;ie++)G.push(a(F));return G}case h.Object:return JSON.parse(F.read(r(F)).toString())}}class c{constructor(_,B,G=null,ie=1e3){this.protocol=_,this.ctx=B,this.logger=G,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(_,B){this.channels.set(_,B),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const B=this.send([_.type]);this.logger?.logOutgoing(B,0,1,m(_.type));return}case 201:case 202:case 204:case 203:{const B=this.send([_.type,_.id],_.data);this.logger?.logOutgoing(B,_.id,1,m(_.type),_.data);return}}}send(_,B=void 0){const G=new w;return o(G,_),o(G,B),this.sendBuffer(G.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onRawMessage(_){const B=new I(_),G=a(B),ie=a(B),V=G[0];switch(V){case 100:return this.logger?.logIncoming(_.byteLength,G[1],1,`${u(V)}: ${G[2]}.${G[3]}`,ie),this.onPromise({type:V,id:G[1],channelName:G[2],name:G[3],arg:ie});case 102:return this.logger?.logIncoming(_.byteLength,G[1],1,`${u(V)}: ${G[2]}.${G[3]}`,ie),this.onEventListen({type:V,id:G[1],channelName:G[2],name:G[3],arg:ie});case 101:return this.logger?.logIncoming(_.byteLength,G[1],1,`${u(V)}`),this.disposeActiveRequest({type:V,id:G[1]});case 103:return this.logger?.logIncoming(_.byteLength,G[1],1,`${u(V)}`),this.disposeActiveRequest({type:V,id:G[1]})}}onPromise(_){const B=this.channels.get(_.channelName);if(!B){this.collectPendingRequest(_);return}const G=new R.CancellationTokenSource;let ie;try{ie=B.call(this.ctx,_.name,_.arg,G.token)}catch(A){ie=Promise.reject(A)}const V=_.id;ie.then(A=>{this.sendResponse({id:V,data:A,type:201}),this.activeRequests.delete(_.id)},A=>{A instanceof Error?this.sendResponse({id:V,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:V,data:A,type:203}),this.activeRequests.delete(_.id)});const Q=(0,p.toDisposable)(()=>G.cancel());this.activeRequests.set(_.id,Q)}onEventListen(_){const B=this.channels.get(_.channelName);if(!B){this.collectPendingRequest(_);return}const G=_.id,V=B.listen(this.ctx,_.name,_.arg)(Q=>this.sendResponse({id:G,data:Q,type:204}));this.activeRequests.set(_.id,V)}disposeActiveRequest(_){const B=this.activeRequests.get(_.id);B&&(B.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let B=this.pendingRequests.get(_.channelName);B||(B=[],this.pendingRequests.set(_.channelName,B));const G=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);B.push({request:_,timeoutTimer:G})}flushPendingRequests(_){const B=this.pendingRequests.get(_);if(B){for(const G of B)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var d;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class P{constructor(_,B=null){this.protocol=_,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=B}getChannel(_){const B=this;return{call(G,ie,V){return B.isDisposed?Promise.reject(v.canceled()):B.requestPromise(_,G,ie,V)},listen(G,ie){return B.isDisposed?f.Event.None:B.requestEvent(_,G,ie)}}}requestPromise(_,B,G,ie=R.CancellationToken.None){const V=this.lastRequestId++,A={id:V,type:100,channelName:_,name:B,arg:G};if(ie.isCancellationRequested)return Promise.reject(v.canceled());let O;return new Promise(($,Y)=>{if(ie.isCancellationRequested)return Y(v.canceled());const U=()=>{const le=ge=>{switch(ge.type){case 201:this.handlers.delete(V),$(ge.data);break;case 202:{this.handlers.delete(V);const Ee=new Error(ge.data.message);Ee.stack=ge.data.stack,Ee.name=ge.data.name,Y(Ee);break}case 203:this.handlers.delete(V),Y(ge.data);break}};this.handlers.set(V,le),this.sendRequest(A)};let j=null;this.state===E.Idle?U():(j=(0,t.createCancelablePromise)(le=>this.whenInitialized()),j.then(()=>{j=null,U()}));const Z=()=>{j?(j.cancel(),j=null):this.sendRequest({id:V,type:101}),Y(v.canceled())},re=ie.onCancellationRequested(Z);O=(0,p.combinedDisposable)((0,p.toDisposable)(Z),re),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(_,B,G){const ie=this.lastRequestId++,Q={id:ie,type:102,channelName:_,name:B,arg:G};let A=null;const O=new f.Emitter({onFirstListenerAdd:()=>{A=(0,t.createCancelablePromise)($=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(O),this.sendRequest(Q)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(O),this.sendRequest({id:ie,type:103}))}}),N=$=>O.fire($.data);return this.handlers.set(ie,N),O.event}sendRequest(_){switch(_.type){case 100:case 102:{const B=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger?.logOutgoing(B,_.id,0,`${u(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const B=this.send([_.type,_.id]);this.logger?.logOutgoing(B,_.id,0,u(_.type));return}}}send(_,B=void 0){const G=new w;return o(G,_),o(G,B),this.sendBuffer(G.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onBuffer(_){const B=new I(_),G=a(B),ie=a(B),V=G[0];switch(V){case 200:return this.logger?.logIncoming(_.byteLength,0,0,m(V)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(_.byteLength,G[1],0,m(V),ie),this.onResponse({type:G[0],id:G[1],data:ie})}}onResponse(_){if(_.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}this.handlers.get(_.id)?.(_)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}fe([M.memoize],P.prototype,"onDidInitializePromise",null),e.ChannelClient=P;class L{constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,_(({protocol:B,onDidClientDisconnect:G})=>{f.Event.once(B.onMessage)(V=>{const Q=new I(V),A=a(Q),O=new c(B,A),N=new P(B);this.channels.forEach((Y,U)=>O.registerChannel(U,Y));const $={channelServer:O,channelClient:N,ctx:A};this._connections.add($),this._onDidAddConnection.fire($),G(()=>{O.dispose(),N.dispose(),this._connections.delete($),this._onDidRemoveConnection.fire($)})})})}get connections(){const _=[];return this._connections.forEach(B=>_.push(B)),_}getChannel(_,B){const G=this;return{call(ie,V,Q){let A;if((0,y.isFunction)(B)){const N=(0,S.getRandomElement)(G.connections.filter(B));A=N?Promise.resolve(N):f.Event.toPromise(f.Event.filter(G.onDidAddConnection,B))}else A=B.routeCall(G,ie,V);const O=A.then(N=>N.channelClient.getChannel(_));return W(O).call(ie,V,Q)},listen(ie,V){if((0,y.isFunction)(B))return G.getMulticastEvent(_,B,ie,V);const Q=B.routeEvent(G,ie,V).then(A=>A.channelClient.getChannel(_));return W(Q).listen(ie,V)}}}getMulticastEvent(_,B,G,ie){const V=this;let Q=new p.DisposableStore;const A=new f.Emitter({onFirstListenerAdd:()=>{Q=new p.DisposableStore;const O=new f.EventMultiplexer,N=new Map,$=U=>{const Z=U.channelClient.getChannel(_).listen(G,ie),re=O.add(Z);N.set(U,re)},Y=U=>{const j=N.get(U);!j||(j.dispose(),N.delete(U))};V.connections.filter(B).forEach($),f.Event.filter(V.onDidAddConnection,B)($,void 0,Q),V.onDidRemoveConnection(Y,void 0,Q),O.event(A.fire,A,Q),Q.add(O)},onLastListenerRemove:()=>{Q.dispose()}});return A.event}registerChannel(_,B){this.channels.set(_,B),this._connections.forEach(G=>{G.channelServer.registerChannel(_,B)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class T{constructor(_,B,G=null){const ie=new w;o(ie,B),_.send(ie.buffer),this.channelClient=new P(_,G),this.channelServer=new c(_,B,G)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,B){this.channelServer.registerChannel(_,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function W(F){return{call(_,B,G){return F.then(ie=>ie.call(_,B,G))},listen(_,B){const G=new f.Relay;return F.then(ie=>G.input=ie.listen(_,B)),G.event}}}e.getDelayedChannel=W;function q(F){let _=!1;return{call(B,G,ie){return _?F.call(B,G,ie):(0,t.timeout)(0).then(()=>_=!0).then(()=>F.call(B,G,ie))},listen(B,G){if(_)return F.listen(B,G);const ie=new f.Relay;return(0,t.timeout)(0).then(()=>_=!0).then(()=>ie.input=F.listen(B,G)),ie.event}}}e.getNextTickChannel=q;class ee{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const B of _.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await f.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=ee;var se;(function(F){function _(V,Q){const A=V,O=Q&&Q.disableMarshalling,N=new Map;for(const $ in A)G($)&&N.set($,f.Event.buffer(A[$],!0));return new class{listen($,Y,U){const j=N.get(Y);if(j)return j;if(ie(Y)){const Z=A[Y];if(typeof Z=="function")return Z.call(A,U)}throw new Error(`Event not found: ${Y}`)}call($,Y,U){const j=A[Y];if(typeof j=="function"){if(!O&&Array.isArray(U))for(let Z=0;Z<U.length;Z++)U[Z]=(0,C.revive)(U[Z]);return j.apply(A,U)}throw new Error(`Method not found: ${Y}`)}}}F.fromService=_;function B(V,Q){const A=Q&&Q.disableMarshalling;return new Proxy({},{get(O,N){if(typeof N=="string")return Q?.properties?.has(N)?Q.properties.get(N):ie(N)?function($){return V.listen(N,$)}:G(N)?V.listen(N):async function(...$){let Y;Q&&!(0,y.isUndefinedOrNull)(Q.context)?Y=[Q.context,...$]:Y=$;const U=await V.call(N,Y);return A?U:(0,C.revive)(U)};throw new Error(`Property not found: ${String(N)}`)}})}F.toService=B;function G(V){return V[0]==="o"&&V[1]==="n"&&k.isUpperAsciiLetter(V.charCodeAt(2))}function ie(V){return/^onDynamic/.test(V)&&k.isUpperAsciiLetter(V.charCodeAt(9))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const _=F.toString();if(_!=="[object Object]")return _}return F}function ce(F){return Array.isArray(F)?F.map(te):te(F)}function H(F,_,B,G,ie,V,Q){Q=ce(Q);const A=ae[ie],O=A[G%A.length];let N=[`%c[${F}]%c[${String(_).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(V)?(N=N.concat(Q),N.push(")")):N.push(Q),console.log.apply(console,N)}e.logWithColors=H;class ne{constructor(_,B){this._outgoingPrefix=_,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,B,G,ie,V){this._totalOutgoing+=_,H(this._outgoingPrefix,this._totalOutgoing,_,B,G,ie,V)}logIncoming(_,B,G,ie,V){this._totalIncoming+=_,H(this._incomingPrefix,this._totalIncoming,_,B,G,ie,V)}}e.IPCLogger=ne}),define(X[140],J([0,1,17,3,43]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(f){this.port=f,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",p=>S.VSBuffer.wrap(p.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class M extends D.IPCClient{constructor(f,p){const C=new R(f);super(C,p);this.protocol=C}dispose(){this.protocol.disconnect()}}e.Client=M}),define(X[95],J([0,1,17,3,2,43]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var v;(function(s){s.enableDiagnostics=!1,s.records=[];const o=new WeakMap;let a=0;function c(P,L){if(!o.has(P)){const T=String(++a);o.set(P,T)}return o.get(P)}function d(P,L,T,W){if(!s.enableDiagnostics)return;const q=c(P,L);if(W instanceof S.VSBuffer||W instanceof Uint8Array||W instanceof ArrayBuffer||ArrayBuffer.isView(W)){const ee=S.VSBuffer.alloc(W.byteLength);ee.set(W),s.records.push({timestamp:Date.now(),id:q,label:L,type:T,buff:ee})}else s.records.push({timestamp:Date.now(),id:q,label:L,type:T,data:W})}s.traceSocketEvent=d})(v=e.SocketDiagnostics||(e.SocketDiagnostics={}));var f;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let p=null;function C(){return p||(p=S.VSBuffer.alloc(0)),p}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,a){if(o===0)return C();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const L=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=o),L}if(this._chunks[0].byteLength>o){const L=this._chunks[0].slice(0,o);return a&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),L}const c=S.VSBuffer.alloc(o);let d=0,P=0;for(;o>0;){const L=this._chunks[P];if(L.byteLength>o){const T=L.slice(0,o);c.set(T,d),d+=o,a&&(this._chunks[P]=L.slice(o),this._totalLength-=o),o-=o}else c.set(L,d),d+=L.byteLength,a?(this._chunks.shift(),this._totalLength-=L.byteLength):P++,o-=L.byteLength}return c}}e.ChunkStream=k;var y;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume"})(y||(y={}));function g(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var u;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(u=e.ProtocolConstants||(e.ProtocolConstants={}));class b{constructor(o,a,c,d){this.type=o,this.id=a,this.ack=c,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends D.Disposable{constructor(o){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:g(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,d=this._state.id,P=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new b(c,d,P,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class E{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=S.VSBuffer.alloc(13);a.writeUInt8(o.type,0),a.writeUInt32BE(o.id,1),a.writeUInt32BE(o.ack,5),a.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:g(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(a,o.data)}_bufferAdd(o,a){const c=this._totalLength===0;return this._data.push(o,a),this._totalLength+=o.byteLength+a.byteLength,c}_bufferTake(){const o=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,a){this._bufferAdd(o,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class I extends D.Disposable{constructor(o){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new E(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new b(1,0,0,o))}}e.Protocol=I;class w extends R.IPCClient{constructor(o,a,c=null){super(o,a,c);this.protocol=o}static fromSocket(o,a){return new w(new I(o),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=w;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class l{constructor(o){this.data=o,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){const o=[];let a=0,c=this._first;for(;c;)o[a++]=c.data,c=c.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const a=new l(o);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class n{constructor(){this.lastRuns=[];const o=Date.now();for(let a=0;a<n._HISTORY_LENGTH;a++)this.lastRuns[a]=o-1e3*a;setInterval(()=>{for(let a=n._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const o=Date.now(),a=(1+n._HISTORY_LENGTH)*1e3;let c=0;for(let d=0;d<n._HISTORY_LENGTH;d++)o-this.lastRuns[d]<=a&&c++;return 1-c/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class i{constructor(o,a=null,c=n.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new b(5,0,0,C());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new b(7,0,0,C());this._socketWriter.write(o)}sendResume(){const o=new b(8,0,0,C());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new b(3,0,this._incomingAckId,C());this._socketWriter.write(o);const a=this._outgoingUnackMsg.toArray();for(let c=0,d=a.length;c<d;c++)this._socketWriter.write(a[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new b(6,0,0,C())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let c=0,d=a.length;c<d;c++)this._socketWriter.write(a[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new b(1,a,this._incomingAckId,o);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(o){const a=new b(2,0,0,o);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),a=Date.now()-o.writtenTime,c=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&c>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const P=Math.max(2e4-a,2e4-c,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},P)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new b(3,0,this._incomingAckId,C());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(X[141],J([0,1,38,17,3,2,43,129]),function(z,e,S,t,D,R,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(C,k){const y=D.Event.fromNodeEventEmitter(S.validatedIpcMain,k,(u,b)=>({event:u,message:b})),g=D.Event.filter(y,({event:u})=>u.sender.id===C);return D.Event.map(g,({message:u})=>u&&t.VSBuffer.wrap(u))}class p extends M.IPCServer{constructor(){super(p.getOnDidClientConnect())}static getOnDidClientConnect(){const k=D.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:hello",({sender:y})=>y);return D.Event.map(k,y=>{const g=y.id,u=p.Clients.get(g);u&&u.dispose();const b=new D.Emitter;p.Clients.set(g,(0,R.toDisposable)(()=>b.fire()));const m=f(g,"vscode:message"),E=D.Event.any(D.Event.signal(f(g,"vscode:disconnect")),b.event);return{protocol:new v.Protocol(y,m),onDidClientDisconnect:E}})}}e.Server=p,p.Clients=new Map}),define(X[96],J([0,1,38,3,27,140]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends R.Client{constructor(p,C){super({addEventListener:(k,y)=>p.addListener(k,y),removeEventListener:(k,y)=>p.removeListener(k,y),postMessage:k=>p.postMessage(k),start:()=>p.start(),close:()=>p.close()},C)}}e.Client=M;async function v(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const p=(0,D.generateUuid)();f.webContents.send("vscode:createMessageChannel",p);const C=t.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:createMessageChannelResult",(y,g)=>({nonce:g,port:y.ports[0]})),{port:k}=await t.Event.toPromise(t.Event.once(t.Event.filter(C,y=>y.nonce===p)));return k}e.connect=v}),define(X[81],J([0,1,17,19,3,2,9,4,27,43,95]),function(z,e,S,t,D,R,M,v,f,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:z.__$__nodeRequire("crypto"),zlib:z.__$__nodeRequire("zlib"),net:z.__$__nodeRequire("net"),os:z.__$__nodeRequire("os")}}class y{constructor(c,d=""){this.debugLabel=d,this.socket=c,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener)}traceSocketEvent(c,d){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,c,d)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(c){const d=P=>{this.traceSocketEvent("read",P),c(S.VSBuffer.wrap(P))};return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(c){const d=P=>{this.traceSocketEvent("close",{hadError:P}),c({type:0,hadError:P,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(c){const d=()=>{this.traceSocketEvent("nodeEndReceived"),c()};return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(c){if(!this.socket.destroyed)try{this.traceSocketEvent("write",c),this.socket.write(c.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,t.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,t.onUnexpectedError)(d)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((c,d)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),c();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),c()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=y;var g;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var u;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(u||(u={}));class b extends R.Disposable{constructor(c,d,P,L){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:d,inflateBytesLength:P?.byteLength||0,recordInflateBytes:L}),this._flowManager=this._register(new m(this,d,P,L,this._onData,(T,W)=>this._write(T,W))),this._register(this._flowManager.onError(T=>{console.error(T),(0,t.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(c,d){this.socket.traceSocketEvent(c,d)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this._onData.event(c)}onClose(c){return this._onClose.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){this._flowManager.writeMessage(c)}_write(c,d){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",c);let P=2;c.byteLength<126?P+=0:c.byteLength<2**16?P+=2:P+=8;const L=S.VSBuffer.alloc(P);if(d?L.writeUInt8(194,0):L.writeUInt8(130,0),c.byteLength<126)L.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){L.writeUInt8(126,1);let T=1;L.writeUInt8(c.byteLength>>>8&255,++T),L.writeUInt8(c.byteLength>>>0&255,++T)}else{L.writeUInt8(127,1);let T=1;L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(c.byteLength>>>24&255,++T),L.writeUInt8(c.byteLength>>>16&255,++T),L.writeUInt8(c.byteLength>>>8&255,++T),L.writeUInt8(c.byteLength>>>0&255,++T)}this.socket.write(S.VSBuffer.concat([L,c]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(c){if(c.byteLength!==0){for(this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),P=d.readUInt8(0),L=(P&128)>>>7,T=(P&64)>>>6,W=d.readUInt8(1),q=(W&128)>>>7,ee=W&127;this._state.state=2,this._state.readLen=2+(q?4:0)+(ee===126?2:0)+(ee===127?8:0),this._state.fin=L,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(T)),this._state.firstFrameOfMessage=Boolean(L),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),P=d.readUInt8(1),L=(P&128)>>>7;let T=P&127,W=1;T===126?T=d.readUInt8(++W)*2**8+d.readUInt8(++W):T===127&&(T=d.readUInt8(++W)*0+d.readUInt8(++W)*0+d.readUInt8(++W)*0+d.readUInt8(++W)*0+d.readUInt8(++W)*2**24+d.readUInt8(++W)*2**16+d.readUInt8(++W)*2**8+d.readUInt8(++W));let q=0;L&&(q=d.readUInt8(++W)*2**24+d.readUInt8(++W)*2**16+d.readUInt8(++W)*2**8+d.readUInt8(++W)),this._state.state=3,this._state.readLen=T,this._state.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",d),w(d,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",d),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(d,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class m extends R.Disposable{constructor(c,d,P,L,T,W){super();this._tracer=c,this._onData=T,this._writeFn=W,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,d?(this._zlibInflateStream=this._register(new E(this._tracer,L,P,{windowBits:15})),this._zlibDeflateStream=this._register(new I(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(q=>this._onError.fire(q))),this._register(this._zlibDeflateStream.onError(q=>this._onError.fire(q)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:S.VSBuffer.alloc(0)}writeMessage(c){this._writeQueue.push(c),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const c=this._writeQueue.shift();if(this._zlibDeflateStream){const d=await this._deflateMessage(this._zlibDeflateStream,c);this._writeFn(d,!0)}else this._writeFn(c,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(c,d){return new Promise((P,L)=>{c.write(d),c.flush(T=>P(T))})}acceptFrame(c,d,P){this._readQueue.push({data:c,isCompressed:d,isLastFrameOfMessage:P}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const c=this._readQueue.shift();if(this._zlibInflateStream&&c.isCompressed){const d=await this._inflateFrame(this._zlibInflateStream,c.data,c.isLastFrameOfMessage);this._onData.fire(d)}else this._onData.fire(c.data)}this._isProcessingReadQueue=!1}}_inflateFrame(c,d,P){return new Promise((L,T)=>{c.write(d),P&&c.write(S.VSBuffer.fromByteArray([0,0,255,255])),c.flush(W=>L(W))})}}class E extends R.Disposable{constructor(c,d,P,L){super();this._tracer=c,this._recordInflateBytes=d,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(L),this._zlibInflate.on("error",T=>{this._tracer.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibInflate.on("data",T=>{this._tracer.traceSocketEvent("zlibInflateData",T),this._pendingInflateData.push(S.VSBuffer.wrap(T))}),P&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this._zlibInflate.write(P.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?S.VSBuffer.concat(this._recordedInflateBytes):S.VSBuffer.alloc(0)}write(c){this._recordInflateBytes&&this._recordedInflateBytes.push(c.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",c),this._zlibInflate.write(c.buffer)}flush(c){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const d=S.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,c(d)})}}class I extends R.Disposable{constructor(c,d){super();this._tracer=c,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",P=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this._onError.fire(P)}),this._zlibDeflate.on("data",P=>{this._tracer.traceSocketEvent("zlibDeflateData",P),this._pendingDeflateData.push(S.VSBuffer.wrap(P))})}write(c){this._tracer.traceSocketEvent("zlibDeflateWrite",c.buffer),this._zlibDeflate.write(c.buffer)}flush(c){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let d=S.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.byteLength-4),c(d)})}}function w(a,c){if(c===0)return;const d=a.byteLength>>>2;for(let ee=0;ee<d;ee++){const se=a.readUInt32BE(ee*4);a.writeUInt32BE(se^c,ee*4)}const P=d*4,L=a.byteLength-P,T=c>>>24&255,W=c>>>16&255,q=c>>>8&255;L>=1&&a.writeUInt8(a.readUInt8(P)^T,P),L>=2&&a.writeUInt8(a.readUInt8(P+1)^W,P+1),L>=3&&a.writeUInt8(a.readUInt8(P+2)^q,P+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function l(){const a=(0,f.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let c;return e.XDG_RUNTIME_DIR?c=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):c=(0,M.join)(k().os.tmpdir(),`vscode-ipc-${a}.sock`),n(c),c}e.createRandomIPCHandle=l;function r(a,c,d){const P=k().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${d}-${c}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-${P.substr(0,8)}-${d}-${c}.sock`):L=(0,M.join)(a,`${d}-${c}.sock`),n(L),L}e.createStaticIPCHandle=r;function n(a){const c=h[v.platform];typeof c=="number"&&a.length>=c&&console.warn(`WARNING: IPC handle "${a}" is longer than ${c} chars, try a shorter --user-data-dir`)}class i extends p.IPCServer{constructor(c){super(i.toClientConnectionEvent(c));this.server=c}static toClientConnectionEvent(c){const d=D.Event.fromNodeEventEmitter(c,"connection");return D.Event.map(d,P=>({protocol:new C.Protocol(new y(P,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(P,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function s(a){return new Promise((c,d)=>{const P=k().net.createServer();P.on("error",d),P.listen(a,()=>{P.removeListener("error",d),c(new i(P))})})}e.serve=s;function o(a,c){return new Promise((d,P)=>{const L=k().net.createConnection(a,()=>{L.removeListener("error",P),d(C.Client.fromSocket(new y(L,`ipc-client${c}`),c))});L.once("error",P)})}e.connect=o}),define(X[97],J([0,1,8,3,2,13]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function v(k){const y=k;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=v;var f;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(f=e.StorageState||(e.StorageState={}));class p extends D.Disposable{constructor(y,g=Object.create(null)){super();this.database=y,this.options=g,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new S.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){y.changed?.forEach((g,u)=>this.accept(u,g)),y.deleted?.forEach(g=>this.accept(g,void 0))}accept(y,g){if(this.state===f.Closed)return;let u=!1;(0,R.isUndefinedOrNull)(g)?u=this.cache.delete(y):this.cache.get(y)!==g&&(this.cache.set(y,g),u=!0),u&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,g){const u=this.cache.get(y);return(0,R.isUndefinedOrNull)(u)?g:u}getBoolean(y,g){const u=this.get(y);return(0,R.isUndefinedOrNull)(u)?g:u==="true"}getNumber(y,g){const u=this.get(y);return(0,R.isUndefinedOrNull)(u)?g:parseInt(u,10)}async set(y,g){if(this.state===f.Closed)return;if((0,R.isUndefinedOrNull)(g))return this.delete(y);const u=String(g);if(this.cache.get(y)!==u)return this.cache.set(y,u),this.pendingInserts.set(y,u),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async delete(y){if(!(this.state===f.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(y){if(!!this.hasPending)return this.doFlush(y)}async doFlush(y){return this.flushDelayer.trigger(()=>this.flushPending(),y)}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert?.forEach((g,u)=>this.items.set(u,g)),y.delete?.forEach(g=>this.items.delete(g))}async close(){}}e.InMemoryStorageDatabase=C}),define(X[142],J([0,1,8,3,33,9,23]),function(z,e,S,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class v{constructor(C,k=Object.create(null)){this.path=C,this.options=k,this.name=(0,R.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const C=await this.whenConnected,k=new Map;return(await this.all(C,"SELECT * FROM ItemTable")).forEach(g=>k.set(g.key,g.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${k.size} rows`),k}async updateItems(C){const k=await this.whenConnected;return this.doUpdateItems(k,C)}doUpdateItems(C,k){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${k.insert?(0,D.mapToString)(k.insert):"0"}), delete(${k.delete?(0,D.setToString)(k.delete):"0"})`),this.transaction(C,()=>{const y=k.insert,g=k.delete;if(y&&y.size>0){const u=[];u.push([]);let b=0;y.forEach((m,E)=>{let I=u[b];I.length>v.MAX_HOST_PARAMETERS&&(b++,I=[],u.push(I)),I.push(E,m)}),u.forEach(m=>{this.prepare(C,`INSERT INTO ItemTable VALUES ${new Array(m.length/2).fill("(?,?)").join(",")}`,E=>E.run(m),()=>{const E=[];let I=0;return y.forEach((w,h)=>{E.push(h),I+=w.length}),`Keys: ${E.join(", ")} Length: ${I}`})})}if(g&&g.size){const u=[];u.push([]);let b=0;g.forEach(m=>{let E=u[b];E.length>v.MAX_HOST_PARAMETERS&&(b++,E=[],u.push(E)),E.push(m)}),u.forEach(m=>{this.prepare(C,`DELETE FROM ItemTable WHERE key IN (${new Array(m.length).fill("?").join(",")})`,E=>E.run(m),()=>{const E=[];return g.forEach(I=>{E.push(I)}),`Keys: ${E.join(", ")}`})})}})}async close(C){this.logger.trace(`[storage ${this.name}] close()`);const k=await this.whenConnected;return this.doClose(k,C)}doClose(C,k){return new Promise((y,g)=>{C.db.close(u=>(u&&this.handleSQLiteError(C,`[storage ${this.name}] close(): ${u}`),this.path===v.IN_MEMORY_PATH?y():!C.isErroneous&&!C.isInMemory?this.backup().then(y,b=>(this.logger.error(`[storage ${this.name}] backup(): ${b}`),y())):typeof k=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(b=>{const m=()=>this.doClose(b,void 0);return this.doUpdateItems(b,{insert:k()}).then(()=>m(),E=>(m(),Promise.reject(E)))})).then(y,g):g(u||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const C=this.toBackupPath(this.path);return M.Promises.copy(this.path,C,{preserveSymlinks:!1})}toBackupPath(C){return`${C}.backup`}async checkIntegrity(C){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${C})`);const k=await this.whenConnected,y=await this.get(k,C?"PRAGMA integrity_check":"PRAGMA quick_check"),g=C?y.integrity_check:y.quick_check;return k.isErroneous?`${g} (last error: ${k.lastError})`:k.isInMemory?`${g} (in-memory!)`:g}async connect(C,k=!0){this.logger.trace(`[storage ${this.name}] open(${C}, retryOnBusy: ${k})`);try{return await this.doConnect(C)}catch(y){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&k)return await(0,S.timeout)(v.BUSY_OPEN_TIMEOUT),this.connect(C,!1);try{await M.Promises.unlink(C);try{await M.Promises.rename(this.toBackupPath(C),C)}catch{}return await this.doConnect(C)}catch(g){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${g}`),this.doConnect(v.IN_MEMORY_PATH)}}}handleSQLiteError(C,k){C.isErroneous=!0,C.lastError=k,this.logger.error(k)}doConnect(C){return new Promise((k,y)=>{new Promise((g,u)=>{z(["@vscode/sqlite3"],g,u)}).then(g=>{const u={db:new(this.logger.isTracing?g.verbose().Database:g.Database)(C,b=>b?u.db&&b.code!=="SQLITE_CANTOPEN"?u.db.close(()=>y(b)):y(b):this.exec(u,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>k(u),m=>u.db.close(()=>y(m)))),isInMemory:C===v.IN_MEMORY_PATH};u.db.on("error",b=>this.handleSQLiteError(u,`[storage ${this.name}] Error (event): ${b}`)),this.logger.isTracing&&u.db.on("trace",b=>this.logger.trace(`[storage ${this.name}] Trace (event): ${b}`))},y)})}exec(C,k){return new Promise((y,g)=>{C.db.exec(k,u=>u?(this.handleSQLiteError(C,`[storage ${this.name}] exec(): ${u}`),g(u)):y())})}get(C,k){return new Promise((y,g)=>{C.db.get(k,(u,b)=>u?(this.handleSQLiteError(C,`[storage ${this.name}] get(): ${u}`),g(u)):y(b))})}all(C,k){return new Promise((y,g)=>{C.db.all(k,(u,b)=>u?(this.handleSQLiteError(C,`[storage ${this.name}] all(): ${u}`),g(u)):y(b))})}transaction(C,k){return new Promise((y,g)=>{C.db.serialize(()=>{C.db.run("BEGIN TRANSACTION"),k(),C.db.run("END TRANSACTION",u=>u?(this.handleSQLiteError(C,`[storage ${this.name}] transaction(): ${u}`),g(u)):y())})})}prepare(C,k,y,g){const u=C.db.prepare(k),b=m=>{this.handleSQLiteError(C,`[storage ${this.name}] prepare(): ${m} (${k}). Details: ${g()}`)};u.on("error",b),y(u),u.finalize(m=>{m&&b(m),u.removeListener("error",b)})}}e.SQLiteStorageDatabase=v,v.IN_MEMORY_PATH=":memory:",v.BUSY_OPEN_TIMEOUT=2e3,v.MAX_HOST_PARAMETERS=256;class f{constructor(C){C&&typeof C.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=C.logTrace),C&&typeof C.logError=="function"&&(this.logError=C.logError)}get isTracing(){return!!this.logTrace}trace(C){this.logTrace?.(C)}error(C){this.logError?.(C)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(X[143],J([11,10]),function(z,e){return z.create("vs/base/node/processes",e)}),define(X[82],J([0,1,42,30,12,50,9,4,36,77,13,125,23,143]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return p.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return p.TerminateResponseCode}});function u(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function b(l,r){if(v.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};r&&(n.cwd=r);const i=S.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],n);return new Promise(s=>{i.once("error",o=>{s({success:!1,error:o})}),i.once("exit",(o,a)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?u(n.status):1})}else if(v.isLinux||v.isMacintosh)try{const n=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",z).fsPath;return new Promise(i=>{S.execFile(n,[l.pid.toString()],{encoding:"utf8",shell:!0},(s,o,a)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function m(l=f.env){return l.comspec||"cmd.exe"}e.getWindowsShell=m;class E{constructor(r,n,i,s){if(n!==void 0&&i!==void 0&&s!==void 0)this.cmd=r,this.args=n,this.shell=i,this.options=s;else{const o=r;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(f.env).forEach(a=>{o[a]=f.env[a]}),Object.keys(this.options.env).forEach(a=>{o[a]=this.options.env[a]}),this.options.env=o}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const n=r.lastIndexOf(M.sep);return n!==-1&&(r=r.substring(n+1)),E.WellKnowCommands[r]?r:"other"}start(r){return v.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(f.cwd()))?Promise.reject(new Error(g.localize(0,null))):this.useExec().then(n=>{let i,s;const o=new Promise((a,c)=>{i=a,s=c});if(n){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=S.exec(a,this.options,(c,d,P)=>{this.childProcess=null;const L=c;L&&L.killed?s({killed:this.terminateRequested,stdout:d.toString(),stderr:P.toString()}):this.handleExec(i,r,c,d,P)})}else{let a=null;const c=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,i,r,s);const P={terminated:this.terminateRequested};C.isNumber(d)&&(P.cmdCode=d),i(P)};if(this.shell&&v.isWindows){const d=R.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let P=!1,L=!1;const T=[];let W=this.ensureQuotes(this.cmd);T.push(W.value),P=W.quoted,this.args&&this.args.forEach(ee=>{W=this.ensureQuotes(ee),T.push(W.value),L=L&&W.quoted});const q=["/s","/c"];P?L?q.push('"'+T.join(" ")+'"'):T.length>1?q.push('"'+T[0]+'" '+T.slice(1).join(" ")):q.push('"'+T[0]+'"'):q.push(T.join(" ")),a=S.spawn(m(),q,d)}else this.cmd&&(a=S.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(C.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",d=>{this.childProcess=null,s({terminated:this.terminateRequested,error:d})}),a.pid&&(this.childProcess.on("close",c),this.handleSpawn(a,i,r,s,!0)))}return o})}handleClose(r,n,i,s){}ensureQuotes(r){return E.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,b(r,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!v.isWindows)return r(!1);const n=S.spawn(m(),["/s","/c"]);n.on("error",i=>r(!0)),n.on("exit",i=>r(!1))})}}e.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class I extends E{constructor(r,n,i,s){super(r,n,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,n,i,s,o){[s,o].forEach((a,c)=>{const d=new k.LineDecoder;d.write(a).forEach(T=>{n({line:T,source:c===0?0:1})});const L=d.end();L&&n({line:L,source:c===0?0:1})}),r({terminated:this.terminateRequested,error:i})}handleSpawn(r,n,i,s,o){const a=new k.LineDecoder,c=new k.LineDecoder;r.stdout.on("data",d=>{a.write(d).forEach(L=>i({line:L,source:0}))}),r.stderr.on("data",d=>{c.write(d).forEach(L=>i({line:L,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=c}handleClose(r,n,i,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}e.LineProcess=I;function w(l){let r=[],n=!1;const i=function(s){if(n){r.push(s);return}(!l.send(s,a=>{if(a&&console.error(a),n=!1,r.length>0){const c=r.slice(0);r=[],c.forEach(d=>i(d))}})||v.isWindows)&&(n=!0)};return{send:i}}e.createQueuedSender=w;var h;(function(l){async function r(n,i,s){if(M.isAbsolute(n))return n;if(i===void 0&&(i=f.cwd()),M.dirname(n)!=="."||(s===void 0&&C.isString(f.env.PATH)&&(s=f.env.PATH.split(M.delimiter)),s===void 0||s.length===0))return M.join(i,n);async function a(c){if(await y.Promises.exists(c)){let d;try{d=await y.Promises.stat(c)}catch(P){P.message.startsWith("EACCES")&&(d=await y.Promises.lstat(c))}return d?!d.isDirectory():!1}return!1}for(const c of s){let d;if(M.isAbsolute(c)?d=M.join(c,n):d=M.join(i,c,n),await a(d))return d;let P=d+".com";if(await a(P)||(P=d+".exe",await a(P)))return P}return M.join(i,n)}l.findExecutable=r})(h=e.win32||(e.win32={}))}),define(X[144],J([0,1,29,4,139,82]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(g,u){return g===1?t.isWindows?k():R.getWindowsShell(u):p(g,u)}e.getSystemShell=M;function v(g,u){return g===1?t.isWindows?y(u):R.getWindowsShell(u):p(g,u)}e.getSystemShellSync=v;let f=null;function p(g,u){if(t.isLinux&&g===2||t.isMacintosh&&g===3)return"/bin/bash";if(!f){let b;if(t.isWindows)b="/bin/bash";else{if(b=u.SHELL,!b)try{b=(0,S.userInfo)().shell}catch{}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}f=b}return f}let C=null;async function k(){return C||(C=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),C}function y(g){if(C)return C;const u=t.isWindows&&parseFloat((0,S.release)())>=10,b=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${g.windir}\\${b?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?m:R.getWindowsShell(g)}}),define(X[145],J([0,1,42,8,17,21,136,19,3,2,50,82,77,43]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends g.ChannelServer{constructor(E){super({send:I=>{try{process.send?.(I.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",I=>D.VSBuffer.wrap(Buffer.from(I,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=u;class b{constructor(E,I){this.modulePath=E,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new t.Delayer(w),this.child=null,this._client=null}getChannel(E){const I=this;return{call(w,h,l){return I.requestPromise(E,w,h,l)},listen(w,h){return I.requestEvent(E,w,h)}}}requestPromise(E,I,w,h=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(v.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(E),r=(0,t.createCancelablePromise)(s=>l.call(I,w,s)),n=h.onCancellationRequested(()=>r.cancel()),i=(0,p.toDisposable)(()=>r.cancel());return this.activeRequests.add(i),r.finally(()=>{n.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),r}requestEvent(E,I,w){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let h;const l=new f.Emitter({onFirstListenerAdd:()=>{h=this.getCachedChannel(E).listen(I,w)(l.fire,l),this.activeRequests.add(h)},onLastListenerRemove:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(I.env={...I.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,y.removeDangerousEnvVariables)(I.env),this.child=(0,S.fork)(this.modulePath,E,I);const w=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,M.isRemoteConsoleLog)(o)){(0,M.log)(o,`IPC Library: ${this.options.serverName}`);return}w.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const l=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,r=o=>this.child&&this.child.connected&&l.send(o.buffer.toString("base64")),n=w.event,i={send:r,onMessage:n};this._client=new g.ChannelClient(i);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,a)=>{process.removeListener("exit",s),this.activeRequests.forEach(c=>(0,p.dispose)(c)),this.activeRequests.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:a})})}return this._client}getCachedChannel(E){let I=this.channels.get(E);return I||(I=this.client.getChannel(E),this.channels.set(E,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=b}),define(X[146],J([11,10]),function(z,e){return z.create("vs/code/electron-main/app",e)}),define(X[147],J([11,10]),function(z,e){return z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(X[148],J([11,10]),function(z,e){return z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(X[149],J([11,10]),function(z,e){return z.create("vs/platform/environment/node/argv",e)}),define(X[150],J([11,10]),function(z,e){return z.create("vs/platform/environment/node/argvHelper",e)}),define(X[151],J([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(X[152],J([11,10]),function(z,e){return z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(X[153],J([11,10]),function(z,e){return z.create("vs/platform/files/common/fileService",e)}),define(X[154],J([11,10]),function(z,e){return z.create("vs/platform/files/common/files",e)}),define(X[155],J([11,10]),function(z,e){return z.create("vs/platform/files/common/io",e)}),define(X[156],J([11,10]),function(z,e){return z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(X[157],J([11,10]),function(z,e){return z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(X[158],J([11,10]),function(z,e){return z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(X[159],J([11,10]),function(z,e){return z.create("vs/platform/menubar/electron-main/menubar",e)}),define(X[160],J([11,10]),function(z,e){return z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(X[161],J([11,10]),function(z,e){return z.create("vs/platform/request/common/request",e)}),define(X[162],J([11,10]),function(z,e){return z.create("vs/platform/shell/node/shellEnv",e)}),define(X[163],J([11,10]),function(z,e){return z.create("vs/platform/telemetry/common/telemetryService",e)}),define(X[164],J([11,10]),function(z,e){return z.create("vs/platform/update/common/update.config.contribution",e)}),define(X[165],J([11,10]),function(z,e){return z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(X[166],J([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/window",e)}),define(X[167],J([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(X[168],J([11,10]),function(z,e){return z.create("vs/platform/workspace/common/workspace",e)}),define(X[169],J([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(X[170],J([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(X[171],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function S(D){return D&&D.hasOwnProperty("folderUri")}e.isFolderBackupInfo=S;function t(D){return D&&D.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(X[172],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function S(t){return typeof t?.backupFolder=="string"}e.isEmptyWindowBackupInfo=S}),define(X[173],J([0,1,3,2]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new S.Emitter,this._onReloadEmitter=new S.Emitter,this._onTerminateEmitter=new S.Emitter,this._onAttachEmitter=new S.Emitter}call(v,f,p){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:p[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:p[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:p[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:p[0],port:p[1],subId:p[2]}))}throw new Error("Method not implemented.")}listen(v,f,p){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(v){super();this.channel=v}reload(v){this.channel.call("reload",[v])}get onReload(){return this.channel.listen("reload")}close(v){this.channel.call("close",[v])}get onClose(){return this.channel.listen("close")}attachSession(v,f,p){this.channel.call("attach",[v,f,p])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(v,f){this.channel.call("terminate",[v,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(v,f){return this.channel.call("openExtensionDevelopmentHostWindow",[v,f])}}e.ExtensionHostDebugChannelClient=R}),define(X[174],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class S{constructor(D){this.machineId=D}encryption(){return new Promise((D,R)=>z(["vscode-encrypt"],D,R))}async encrypt(D){try{return(await this.encryption()).encrypt(this.machineId,D)}catch{return D}}async decrypt(D){try{return(await this.encryption()).decrypt(this.machineId,D)}catch{return D}}}e.EncryptionMainService=S}),define(X[175],J([0,1,132,51,12,9,36,16,7]),function(z,e,S,t,D,R,M,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class p{constructor(b,m,E){this._args=b,this.paths=m,this.productService=E,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(D.FileAccess.asFileUri("",z).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,v.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,v.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const b=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",b)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return f.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,v.joinPath)(f.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,v.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,v.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,v.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const b=M.env.VSCODE_PORTABLE;return b?f.URI.file((0,R.join)(b,"argv.json")):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const b=this.args["builtin-extensions-dir"];return b?(0,R.resolve)(b):(0,R.normalize)((0,R.join)(D.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const b=this.args["extensions-download-dir"];return b?(0,R.resolve)(b):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const b=this.args["extensions-dir"];if(b)return(0,R.resolve)(b);const m=M.env.VSCODE_EXTENSIONS;if(m)return m;const E=M.env.VSCODE_PORTABLE;return E?(0,R.join)(E,"extensions"):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const b=this.args.extensionDevelopmentPath;if(Array.isArray(b))return b.map(m=>/^[^:/?#]+?:\/\//.test(m)?f.URI.parse(m):f.URI.file((0,R.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(b=>b==="ui"||b==="workspace"||b==="web"?b:"workspace")}get extensionTestsLocationURI(){const b=this.args.extensionTestsPath;if(b)return/^[^:/?#]+?:\/\//.test(b)?f.URI.parse(b):f.URI.file((0,R.normalize)(b))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const b=this.args["disable-extension"];if(b){if(typeof b=="string")return[b];if(Array.isArray(b)&&b.length>0)return b}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,v.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return f.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const b=M.env.VSCODE_PORTABLE;return b?f.URI.file((0,R.join)(b,"policy.json")):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}fe([t.memoize],p.prototype,"appRoot",null),fe([t.memoize],p.prototype,"userHome",null),fe([t.memoize],p.prototype,"userDataPath",null),fe([t.memoize],p.prototype,"appSettingsHome",null),fe([t.memoize],p.prototype,"tmpDir",null),fe([t.memoize],p.prototype,"cacheHome",null),fe([t.memoize],p.prototype,"stateResource",null),fe([t.memoize],p.prototype,"userRoamingDataHome",null),fe([t.memoize],p.prototype,"userDataSyncHome",null),fe([t.memoize],p.prototype,"userDataSyncLogResource",null),fe([t.memoize],p.prototype,"editSessionsLogResource",null),fe([t.memoize],p.prototype,"sync",null),fe([t.memoize],p.prototype,"machineSettingsResource",null),fe([t.memoize],p.prototype,"workspaceStorageHome",null),fe([t.memoize],p.prototype,"localHistoryHome",null),fe([t.memoize],p.prototype,"keyboardLayoutResource",null),fe([t.memoize],p.prototype,"argvResource",null),fe([t.memoize],p.prototype,"isExtensionDevelopment",null),fe([t.memoize],p.prototype,"untitledWorkspacesHome",null),fe([t.memoize],p.prototype,"installSourcePath",null),fe([t.memoize],p.prototype,"builtinExtensionsPath",null),fe([t.memoize],p.prototype,"extensionsPath",null),fe([t.memoize],p.prototype,"extensionDevelopmentLocationURI",null),fe([t.memoize],p.prototype,"extensionDevelopmentKind",null),fe([t.memoize],p.prototype,"extensionTestsLocationURI",null),fe([t.memoize],p.prototype,"debugExtensionHost",null),fe([t.memoize],p.prototype,"serviceMachineIdResource",null),fe([t.memoize],p.prototype,"telemetryLogResource",null),fe([t.memoize],p.prototype,"disableWorkspaceTrust",null),fe([t.memoize],p.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=p;function C(u,b){return g(u["inspect-extensions"],u["inspect-brk-extensions"],5870,b,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=C;function k(u,b){return g(u["inspect-search"],u["inspect-brk-search"],5876,b,u.extensionEnvironment)}e.parseSearchPort=k;function y(u,b){return g(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,b,u.extensionEnvironment)}e.parsePtyHostPort=y;function g(u,b,m,E,I,w){const l=Number(b||u)||(E?null:m),r=l?Boolean(!!b):!1;let n;if(w)try{n=JSON.parse(w)}catch{}return{port:l,break:r,debugId:I,env:n}}}),define(X[98],J([0,1,260,4,149]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(11,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(12,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(13,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(15,null)},category:{type:"string",cat:"e",description:(0,D.localize)(16,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(17,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(18,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(19,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(20,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(21,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(22,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(23,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(24,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(25,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(26,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(27,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(28,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(29,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(30,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(32,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(33,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function v(u,b,m=M){const E={},I=["_"],w=[];for(const n in b){const i=b[n];i.alias&&(E[n]=i.alias),i.type==="string"||i.type==="string[]"?(I.push(n),i.deprecates&&I.push(...i.deprecates)):i.type==="boolean"&&(w.push(n),i.deprecates&&w.push(...i.deprecates))}const h=S(u,{string:I,boolean:w,alias:E}),l={},r=h;l._=h._.map(n=>String(n)).filter(n=>n.length>0),delete r._;for(const n in b){const i=b[n];i.alias&&delete r[i.alias];let s=r[n];if(i.deprecates)for(const o of i.deprecates)r.hasOwnProperty(o)&&(s||(s=r[o],s&&m.onDeprecatedOption(o,i.deprecationMessage||(0,D.localize)(34,null,n))),delete r[o]);if(typeof s!="undefined"){if(i.type==="string[]"){if(Array.isArray(s)||(s=[s]),!i.allowEmptyValue){const o=s.filter(a=>a.length>0);o.length!==s.length&&(m.onEmptyValue(n),s=o.length>0?o:void 0)}}else i.type==="string"&&(Array.isArray(s)?(s=s.pop(),m.onMultipleValues(n,s)):!s&&!i.allowEmptyValue&&(m.onEmptyValue(n),s=void 0));l[n]=s,i.deprecationMessage&&m.onDeprecatedOption(n,i.deprecationMessage)}delete r[n]}for(const n in r)m.onUnknownOption(n);return l}e.parseArgs=v;function f(u,b){let m="";return b.args&&(Array.isArray(b.args)?m=` <${b.args.join("> <")}>`:m=` <${b.args}>`),b.alias?`-${b.alias} --${u}${m}`:`--${u}${m}`}function p(u,b){let m=0;const E=[];for(const l in u){const r=u[l],n=f(l,r);m=Math.max(m,n.length),E.push([n,r.description])}const I=m+2+1;if(b-I<25)return E.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);const w=b-I-1,h=[];for(const l of E){const r=l[0],n=k(l[1],w),i=C(I-r.length-2);h.push("  "+r+i+n[0]);for(let s=1;s<n.length;s++)h.push(C(I)+n[s])}return h}e.formatOptions=p;function C(u){return" ".repeat(u)}function k(u,b){const m=[];for(;u.length;){const E=u.length<b?u.length:u.lastIndexOf(" ",b),I=u.slice(0,E).trim();u=u.slice(E),m.push(I)}return m}function y(u,b,m,E,I){const w=process.stdout.isTTY&&process.stdout.columns||80,h=I?.noInputFiles!==!0?`[${(0,D.localize)(35,null)}...]`:"",l=[`${u} ${m}`];l.push(""),l.push(`${(0,D.localize)(36,null)}: ${b} [${(0,D.localize)(37,null)}]${h}`),l.push(""),I?.noPipe!==!0&&(t.isWindows?l.push((0,D.localize)(38,null,b)):l.push((0,D.localize)(39,null,b)),l.push(""));const r={};for(const n in E){const i=E[n];if(i.description&&i.cat){let s=r[i.cat];s||(r[i.cat]=s={}),s[n]=i}}for(const n in r){const i=n,s=r[i];s&&(l.push(R[i]),l.push(...p(s,w)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=y;function g(u,b){return`${u||(0,D.localize)(40,null)}
${b||(0,D.localize)(41,null)}
${process.arch}`}e.buildVersionMessage=g}),define(X[176],J([0,1,76,173,98]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(v){super();this.windowsMainService=v}call(v,f,p){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(p[0],p[1]):super.call(v,f,p)}async openExtensionDevelopmentHostWindow(v,f){const p=(0,D.parseArgs)(v,D.OPTIONS);p.debugRenderer=f;const C=p.extensionDevelopmentPath;if(!C)return{success:!1};const[k]=this.windowsMainService.openExtensionDevelopmentHostWindow(C,{context:5,cli:p});if(!f)return{success:!0};const y=k.win;if(!y)return{success:!0};const g=y.webContents.debugger;let u=g.isAttached()?1/0:0;const b=(0,S.createServer)(m=>{u++==0&&g.attach();let E=!1;const I=l=>{E||m.write(JSON.stringify(l)+"\0")},w=(l,r,n,i)=>I({method:r,params:n,sessionId:i});y.on("close",()=>{g.removeListener("message",w),m.end(),E=!0}),g.addListener("message",w);let h=Buffer.alloc(0);m.on("data",l=>{h=Buffer.concat([h,l]);for(let r=h.indexOf(0);r!==-1;r=h.indexOf(0)){let n;try{const i=h.slice(0,r).toString("utf8");h=h.slice(r+1),n=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}g.sendCommand(n.method,n.params,n.sessionId).then(i=>I({id:n.id,sessionId:n.sessionId,result:i})).catch(i=>I({id:n.id,sessionId:n.sessionId,error:{code:0,message:i.message}}))}}),m.on("error",l=>{console.error("error on cdp pipe:",l)}),m.on("close",()=>{E=!0,--u==0&&g.detach()})});return await new Promise(m=>b.listen(0,m)),y.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(X[56],J([0,1,261,150,98]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function M(y,g){const u={onUnknownOption:m=>{console.warn((0,t.localize)(0,null,m))},onMultipleValues:(m,E)=>{console.warn((0,t.localize)(1,null,m,E))},onEmptyValue:m=>{console.warn((0,t.localize)(2,null,m))},onDeprecatedOption:(m,E)=>{console.warn((0,t.localize)(3,null,m,E))}},b=(0,D.parseArgs)(y,D.OPTIONS,g?u:void 0);return b.goto&&b._.forEach(m=>S(/^(\w:)?[^:]+(:\d*){0,2}$/.test(m),(0,t.localize)(4,null))),b["max-memory"]&&S(parseInt(b["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),b}function v(y){const g=y.findIndex(u=>!/^-/.test(u));if(g>-1)return[...y.slice(0,g),...y.slice(g+1)]}function f(y){let[,...g]=y;process.env.VSCODE_DEV&&(g=v(g)||[]);const u=!k(process.env);return M(g,u)}e.parseMainProcessArgv=f;function p(y){const[,,...g]=y;return M(g,!0)}e.parseCLIProcessArgv=p;function C(y,...g){const u=y.indexOf("--");return u===-1?y.push(...g):y.splice(u,0,...g),y}e.addArg=C;function k(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),function(){"use strict";function z(e,S,t,D){function R(v){const f=M(v),p=[f];return e.isAbsolute(f)||p.unshift(D),e.resolve(...p)}function M(v){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let p=process.env.VSCODE_APPDATA;if(p)return e.join(p,t);const C=v["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(p=process.env.APPDATA,!p){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");p=e.join(k,"AppData","Roaming")}break;case"darwin":p=e.join(S.homedir(),"Library","Application Support");break;case"linux":p=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(p,t)}return{getUserDataPath:R}}if(typeof define=="function")define(X[177],J([0,262,29,12,16,36]),function(e,S,t,D,R,M){const v=R.dirname(D.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(R.joinPath(v,"package.json").fsPath);return z(S,t,f.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),S=require("path"),t=require("os");module.exports=z(S,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(X[178],J([0,1,29,175,177]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(v,f){super(v,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,D.getUserDataPath)(v)},f)}}e.NativeEnvironmentService=R}),define(X[179],J([0,1,28,29,30]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function R(M){const v=(0,D.randomPath)((0,t.tmpdir)());try{return(0,S.writeFileSync)(v,""),M&&console.log(`Marker file for --wait created: ${v}`),v}catch(f){M&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=R}),define(X[180],J([0,1,17,27]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(R,M,v){let f=v&&v.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const C=(await M.readFile(R.serviceMachineIdResource)).value.toString();f=(0,t.isUUID)(C)?C:null}catch{f=null}if(!f){f=(0,t.generateUuid)();try{await M.writeFile(R.serviceMachineIdResource,S.VSBuffer.fromString(f))}catch{}}return v?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=D}),define(X[67],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(D,R=[],M=!1){this.ctor=D,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=S}),define(X[181],J([0,1,67]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function D(M,v,f){v instanceof S.SyncDescriptor||(v=new S.SyncDescriptor(v,[],f)),t.push([M,v])}e.registerSingleton=D;function R(){return t}e.getSingletonServiceDescriptors=R}),define(X[182],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=S;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const M of this._nodes.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const v=this.lookupOrInsertNode(R),f=this.lookupOrInsertNode(M);v.outgoing.set(this._hashFn(M),f),f.incoming.set(this._hashFn(R),v)}removeNode(R){const M=this._hashFn(R);this._nodes.delete(M);for(const v of this._nodes.values())v.outgoing.delete(M),v.incoming.delete(M)}lookupOrInsertNode(R){const M=this._hashFn(R);let v=this._nodes.get(M);return v||(v=new S(R),this._nodes.set(M,v)),v}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[M,v]of this._nodes)R.push(`${M}, (incoming)[${[...v.incoming.keys()].join(", ")}], (outgoing)[${[...v.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this._nodes){const v=new Set([R]),f=this._findCycle(M,v);if(f)return f}}_findCycle(R,M){for(const[v,f]of R.outgoing){if(M.has(v))return[...M,v].join(" -> ");M.add(v);const p=this._findCycle(f,M);if(p)return p;M.delete(v)}}}e.Graph=t}),define(X[5],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function v(f){return f[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=v})(S=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(M,v,f){v[S.DI_TARGET]===v?v[S.DI_DEPENDENCIES].push({id:M,index:f}):(v[S.DI_DEPENDENCIES]=[{id:M,index:f}],v[S.DI_TARGET]=v)}function D(M){if(S.serviceIds.has(M))return S.serviceIds.get(M);const v=function(f,p,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(v,f,C)};return v.toString=()=>M,S.serviceIds.set(M,v),v}e.createDecorator=D;function R(M){return M}e.refineServiceDecorator=R}),define(X[57],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,S.createDecorator)("backupMainService")}),define(X[18],J([0,1,13,7,5]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function R(E){return E&&typeof E=="object"&&(!E.overrideIdentifier||typeof E.overrideIdentifier=="string")&&(!E.resource||E.resource instanceof t.URI)}e.isConfigurationOverrides=R;function M(E){return E&&typeof E=="object"&&(!E.overrideIdentifiers||S.isArray(E.overrideIdentifiers))&&!E.overrideIdentifier&&(!E.resource||E.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=M;var v;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.USER=2]="USER",E[E.USER_LOCAL=3]="USER_LOCAL",E[E.USER_REMOTE=4]="USER_REMOTE",E[E.WORKSPACE=5]="WORKSPACE",E[E.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",E[E.DEFAULT=7]="DEFAULT",E[E.MEMORY=8]="MEMORY"})(v=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(E){switch(E){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function p(E,I){const w=Object.create(null);for(const h in E)C(w,h,E[h],I);return w}e.toValuesTree=p;function C(E,I,w,h){const l=I.split("."),r=l.pop();let n=E;for(let i=0;i<l.length;i++){const s=l[i];let o=n[s];switch(typeof o){case"undefined":o=n[s]=Object.create(null);break;case"object":break;default:h(`Ignoring ${I} as ${l.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[r]=w}catch{h(`Ignoring ${I} as ${l.join(".")} is ${JSON.stringify(n)}`)}else h(`Ignoring ${I} as ${l.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=C;function k(E,I){const w=I.split(".");y(E,w)}e.removeFromValueTree=k;function y(E,I){const w=I.shift();if(I.length===0){delete E[w];return}if(Object.keys(E).indexOf(w)!==-1){const h=E[w];typeof h=="object"&&!Array.isArray(h)&&(y(h,I),Object.keys(h).length===0&&delete E[w])}}function g(E,I,w){function h(n,i){let s=n;for(const o of i){if(typeof s!="object"||s===null)return;s=s[o]}return s}const l=I.split("."),r=h(E,l);return typeof r=="undefined"?w:r}e.getConfigurationValue=g;function u(E,I,w){Object.keys(I).forEach(h=>{h!=="__proto__"&&(h in E?S.isObject(E[h])&&S.isObject(I[h])?u(E[h],I[h],w):w&&(E[h]=I[h]):E[h]=I[h])})}e.merge=u;function b(E,I,w){const h=E.inspect(I),l=E.inspect(w);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:h.defaultValue}e.getMigratedSettingValue=b;function m(E){return E.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=m}),define(X[68],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,S.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,S.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,M){return this.secretVault[R]?.[M]??null}async setPassword(R,M,v){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][M]=v}async deletePassword(R,M){return this.secretVault[R]?.[M]?(delete this.secretVault[R][M],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const M=[];for(const v of Object.keys(this.secretVault[R]||{}))M.push({account:v,password:this.secretVault[R][v]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(X[83],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class D{async getPerformanceInfo(M,v){return{}}async getSystemInfo(M,v){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,v){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=D}),define(X[99],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,S.createDecorator)("encryptionMainService")}),define(X[39],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(X[26],J([0,1,51,9,81,39,178,5]),function(z,e,S,t,D,R,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,v.refineServiceDecorator)(R.IEnvironmentService);class f extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,t.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}fe([S.memoize],f.prototype,"cachedLanguagesPath",null),fe([S.memoize],f.prototype,"backupHome",null),fe([S.memoize],f.prototype,"backupWorkspacesPath",null),fe([S.memoize],f.prototype,"mainIPCHandle",null),fe([S.memoize],f.prototype,"mainLockfile",null),fe([S.memoize],f.prototype,"disableUpdates",null),fe([S.memoize],f.prototype,"disableKeytar",null),fe([S.memoize],f.prototype,"codeCachePath",null),fe([S.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(X[100],J([0,1,151,5]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDefaultExtensionsProfileInitService=e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(E){switch(E){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function R(E){switch(E){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function M(E,I){switch(E){case 3:return I==="x64"?"win32-x64":I==="ia32"?"win32-ia32":I==="arm64"?"win32-arm64":"unknown";case 2:return I==="x64"?"linux-x64":I==="arm64"?"linux-arm64":I==="arm"?"linux-armhf":"unknown";case"alpine":return I==="x64"?"alpine-x64":I==="arm64"?"alpine-arm64":"unknown";case 1:return I==="x64"?"darwin-x64":I==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function v(E,I){return I==="web"&&!E.includes("web")}e.isNotWebExtensionInWebTargetPlatform=v;function f(E,I,w){return v(I,w)?!1:E==="undefined"||E==="universal"?!0:E==="unknown"?!1:E===w?!0:p(w).includes(E)}e.isTargetPlatformCompatible=f;function p(E){switch(E){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=p;function C(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=C;var k;(function(E){E[E.NoneOrRelevance=0]="NoneOrRelevance",E[E.LastUpdatedDate=1]="LastUpdatedDate",E[E.Title=2]="Title",E[E.PublisherName=3]="PublisherName",E[E.InstallCount=4]="InstallCount",E[E.PublishedDate=10]="PublishedDate",E[E.AverageRating=6]="AverageRating",E[E.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var y;(function(E){E[E.Default=0]="Default",E[E.Ascending=1]="Ascending",E[E.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var g;(function(E){E.Install="install",E.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var u;(function(E){E[E.None=1]="None",E[E.Install=2]="Install",E[E.Update=3]="Update",E[E.Migrate=4]="Migrate"})(u=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var b;(function(E){E.Unsupported="Unsupported",E.Deprecated="Deprecated",E.Malicious="Malicious",E.Incompatible="Incompatible",E.IncompatiblePreRelease="IncompatiblePreRelease",E.IncompatibleTargetPlatform="IncompatibleTargetPlatform",E.ReleaseVersionNotFound="ReleaseVersionNotFound",E.Invalid="Invalid",E.Download="Download",E.Extract="Extract",E.Delete="Delete",E.Rename="Rename",E.CorruptZip="CorruptZip",E.IncompleteZip="IncompleteZip",E.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class m extends Error{constructor(I,w){super(I);this.code=w,this.name=w}}e.ExtensionManagementError=m,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,S.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService"),e.IDefaultExtensionsProfileInitService=(0,t.createDecorator)("IDefaultExtensionsProfileInitService")}),define(X[183],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,S.createDecorator)("extensionUrlTrustService")}),define(X[184],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,S.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(X[101],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,S.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,S.createDecorator)("externalTerminal")}),define(X[185],J([0,1,42,12,9,4,77,23,82,152,101]),function(z,e,S,t,D,R,M,v,f,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=p.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends y{openTerminal(h,l){return this.spawnTerminal(S,h,f.getWindowsShell(),l)}spawnTerminal(h,l,r,n){const i=l.windowsExec||g.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const s=D.basename(i).toLowerCase();if(s==="cmder"||s==="cmder.exe")return h.spawn(i,n?[n]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),(s==="wt"||s==="wt.exe")&&o.push("-d ."),new Promise((a,c)=>{const d=m(process),P=h.spawn(r,o,{cwd:n,env:d});P.on("error",c),P.on("exit",()=>a())})}runInTerminal(h,l,r,n,i){const s="windowsExec"in i&&i.windowsExec?i.windowsExec:g.getDefaultTerminalWindows();return new Promise((o,a)=>{const c=`"${l} - ${k}"`,d=`""${r.join('" "')}" & pause"`,P=["/c","start",c,"/wait",s,"/c",d],L=Object.assign({},m(process),n);Object.keys(L).filter(q=>L[q]===null).forEach(q=>delete L[q]);const T={cwd:l,env:L,windowsVerbatimArguments:!0};S.spawn(g.CMD,P,T).on("error",q=>{a(E(q))}),o(void 0)})}static getDefaultTerminalWindows(){if(!g._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return g._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=g,g.CMD="cmd.exe";class u extends y{openTerminal(h,l){return this.spawnTerminal(S,h,l)}runInTerminal(h,l,r,n,i){const s=i.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((o,a)=>{if(s===C.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const c=s===C.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",P=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,z).fsPath,"-t",h||k,"-w",l];for(const W of r)P.push("-a"),P.push(W);if(n){const W=Object.assign({},m(process),n);for(const q in W){const ee=W[q];ee===null?(P.push("-u"),P.push(q)):(P.push("-e"),P.push(`${q}=${ee}`))}}let L="";const T=S.spawn(u.OSASCRIPT,P);T.on("error",W=>{a(E(W))}),T.stderr.on("data",W=>{L+=W.toString()}),T.on("exit",W=>{if(W===0)o(void 0);else if(L){const q=L.split(`
`,1);a(new Error(q[0]))}else a(new Error(p.localize(1,null,c,W)))})}else a(new Error(p.localize(2,null,s)))})}spawnTerminal(h,l,r){const n=l.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((i,s)=>{const o=["-a",n];r&&o.push(r);const a=m(process),c=h.spawn("/usr/bin/open",o,{cwd:r,env:a});c.on("error",s),c.on("exit",()=>i())})}}e.MacExternalTerminalService=u,u.OSASCRIPT="/usr/bin/osascript";class b extends y{openTerminal(h,l){return this.spawnTerminal(S,h,l)}runInTerminal(h,l,r,n,i){const s=i.linuxExec?Promise.resolve(i.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((o,a)=>{const c=[];s.then(d=>{d.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const P=`${I(r)}; echo; read -p "${b.WAIT_MESSAGE}" -n1;`;c.push(`''${P}''`);const L=Object.assign({},m(process),n);Object.keys(L).filter(ee=>L[ee]===null).forEach(ee=>delete L[ee]);const T={cwd:l,env:L};let W="";const q=S.spawn(d,c,T);q.on("error",ee=>{a(E(ee))}),q.stderr.on("data",ee=>{W+=ee.toString()}),q.on("exit",ee=>{if(ee===0)o(void 0);else if(W){const se=W.split(`
`,1);a(new Error(se[0]))}else a(new Error(p.localize(4,null,d,ee)))})})})}static async getDefaultTerminalLinuxReady(){if(!b._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)b._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const h=await v.Promises.exists("/etc/debian_version");b._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{h?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return b._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,l,r){const n=l.linuxExec?Promise.resolve(l.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{n.then(o=>{const a=m(process),c=h.spawn(o,[],{cwd:r,env:a});c.on("error",s),c.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=b,b.WAIT_MESSAGE=p.localize(3,null);function m(w){const h={...w.env};return(0,M.sanitizeProcessEnvironment)(h),h}function E(w){return"errno"in w&&w.errno==="ENOENT"&&"path"in w&&typeof w.path=="string"?new Error(p.localize(5,null,w.path)):w}function I(w){let h="";for(const l of w)l.indexOf(" ")>=0?h+='"'+l+'"':h+=l,h+=" ";return h}}),define(X[15],J([0,1,33,9,31,13,7,154,5]),function(z,e,S,t,D,R,M,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function p(H){return H.create===!0}e.isFileOpenForWriteOptions=p;var C;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var k;(function(H){H[H.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var y;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=g;function u(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=u;function b(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=b;function m(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function E(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=E;function I(H){return g(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=I;var w;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(ne,F){super(ne);this.code=F}}e.FileSystemProviderError=h;function l(H,ne){const F=new h(H.toString(),ne);return n(F,ne),F}e.createFileSystemProviderError=l;function r(H){return H||l((0,v.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=r;function n(H,ne){return H.name=ne?`${ne} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=n;function i(H){if(!H)return w.Unknown;if(H instanceof h)return H.code;const ne=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!ne)return w.Unknown;switch(ne[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=i;function s(H){if(H instanceof L)return H.fileOperationResult;switch(i(H)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var o;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class a{constructor(ne,F,_){this.resource=ne,this.operation=F,this.target=_}isOperation(ne){return this.operation===ne}}e.FileOperationEvent=a;var c;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class d{constructor(ne,F){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=ne;const _=new Map;for(const B of ne){const G=_.get(B.type);switch(G?G.push([B.resource,B]):_.set(B.type,[[B.resource,B]]),B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}}for(const[B,G]of _)switch(B){case 1:this.added=S.TernarySearchTree.forUris(()=>F),this.added.fill(G);break;case 0:this.updated=S.TernarySearchTree.forUris(()=>F),this.updated.fill(G);break;case 2:this.deleted=S.TernarySearchTree.forUris(()=>F),this.deleted.fill(G);break}}contains(ne,...F){return this.doContains(ne,{includeChildren:!1},...F)}affects(ne,...F){return this.doContains(ne,{includeChildren:!0},...F)}doContains(ne,F,..._){if(!ne)return!1;const B=_.length>0;return!!((!B||_.includes(1))&&(this.added?.get(ne)||F.includeChildren&&this.added?.findSuperstr(ne))||(!B||_.includes(0))&&(this.updated?.get(ne)||F.includeChildren&&this.updated?.findSuperstr(ne))||(!B||_.includes(2))&&(this.deleted?.findSubstr(ne)||F.includeChildren&&this.deleted?.findSuperstr(ne)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=d;function P(H,ne,F){return!H||!ne||H===ne||ne.length>H.length?!1:(ne.charAt(ne.length-1)!==t.sep&&(ne+=t.sep),F?(0,D.startsWithIgnoreCase)(H,ne):H.indexOf(ne)===0)}e.isParent=P;class L extends Error{constructor(ne,F,_){super(ne);this.fileOperationResult=F,this.options=_}}e.FileOperationError=L;class T extends L{constructor(ne,F,_){super(ne,2,_);this.stat=F}}e.NotModifiedSinceFileOperationError=T;var W;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(W=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var q;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(q=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ee(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=ee;async function se(H,ne){if(!ne.hasProvider(M.URI.from({scheme:H.scheme})))return new Promise(F=>{const _=ne.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===H.scheme&&B.added&&(_.dispose(),F())})})}e.whenProviderRegistered=se,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ae{static formatSize(ne){return(0,R.isNumber)(ne)||(ne=0),ne<ae.KB?(0,v.localize)(1,null,ne.toFixed(0)):ne<ae.MB?(0,v.localize)(2,null,(ne/ae.KB).toFixed(2)):ne<ae.GB?(0,v.localize)(3,null,(ne/ae.MB).toFixed(2)):ne<ae.TB?(0,v.localize)(4,null,(ne/ae.GB).toFixed(2)):(0,v.localize)(5,null,(ne/ae.TB).toFixed(2))}}e.ByteSize=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;var te;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(te=e.Arch||(e.Arch={}));function ce(H){return{maxFileSize:H===0?300*ae.MB:16*ae.GB,maxHeapSize:H===0?700*ae.MB:2*700*ae.MB}}e.getPlatformLimits=ce}),define(X[186],J([0,1,17,41,19,3,2,55,7,27,15]),function(z,e,S,t,D,R,M,v,f,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class k extends M.Disposable{constructor(g,u){super();this.channel=g,this.extraCapabilities=u,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,p.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(g){return this.channel.call("stat",[g])}readdir(g){return this.channel.call("readdir",[g])}async readFile(g,u){const{buffer:b}=await this.channel.call("readFile",[g,u]);return b}readFileStream(g,u,b){const m=(0,v.newWriteableStream)(I=>S.VSBuffer.concat(I.map(w=>S.VSBuffer.wrap(w))).buffer),E=this.channel.listen("readFileStream",[g,u])(I=>{if(I instanceof S.VSBuffer)m.write(I.buffer);else{if(I==="end")m.end();else{let w=I;w instanceof Error||(w=(0,C.createFileSystemProviderError)((0,t.toErrorMessage)(w),C.FileSystemProviderErrorCode.Unknown)),m.error(w),m.end()}E.dispose()}});return b.onCancellationRequested(()=>{m.error((0,D.canceled)()),m.end(),E.dispose()}),m}writeFile(g,u,b){return this.channel.call("writeFile",[g,S.VSBuffer.wrap(u),b])}open(g,u){return this.channel.call("open",[g,u])}close(g){return this.channel.call("close",[g])}async read(g,u,b,m,E){const[I,w]=await this.channel.call("read",[g,u,E]);return b.set(I.buffer.slice(0,w),m),w}write(g,u,b,m,E){return this.channel.call("write",[g,u,S.VSBuffer.wrap(b),m,E])}mkdir(g){return this.channel.call("mkdir",[g])}delete(g,u){return this.channel.call("delete",[g,u])}rename(g,u,b){return this.channel.call("rename",[g,u,b])}copy(g,u,b){return this.channel.call("copy",[g,u,b])}cloneFile(g,u){return this.channel.call("cloneFile",[g,u])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(g=>{if(Array.isArray(g)){const u=g;this._onDidChange.fire(u.map(b=>({resource:f.URI.revive(b.resource),type:b.type})))}else{const u=g;this._onDidWatchError.fire(u)}}))}watch(g,u){const b=(0,p.generateUuid)();return this.channel.call("watch",[this.sessionId,b,g,u]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,b]))}}e.DiskFileSystemProviderClient=k}),define(X[102],J([0,1,17,19,155,15]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(C,k,y,g,u,b){let m;try{await v(C,k,y,g,u,b)}catch(E){m=E}finally{m&&u.errorTransformer&&(m=u.errorTransformer(m)),typeof m!="undefined"&&y.error(m),y.end()}}e.readFileIntoStream=M;async function v(C,k,y,g,u,b){f(b);const m=await C.open(k,{create:!1});try{f(b);let E=0,I=0,w=u&&typeof u.length=="number"?u.length:void 0,h=S.VSBuffer.alloc(Math.min(u.bufferSize,typeof w=="number"?w:u.bufferSize)),l=u&&typeof u.position=="number"?u.position:0,r=0;do I=await C.read(m,l,h.buffer,r,h.byteLength-r),l+=I,r+=I,E+=I,typeof w=="number"&&(w-=I),r===h.byteLength&&(await y.write(g(h)),h=S.VSBuffer.alloc(Math.min(u.bufferSize,typeof w=="number"?w:u.bufferSize)),r=0);while(I>0&&(typeof w!="number"||w>0)&&f(b)&&p(E,u));if(r>0){let n=r;typeof w=="number"&&(n=Math.min(r,w)),y.write(g(h.slice(0,n)))}}catch(E){throw(0,R.ensureFileSystemProviderError)(E)}finally{await C.close(m)}}function f(C){if(C.isCancellationRequested)throw(0,t.canceled)();return!0}function p(C,k){if(k?.limits){if(typeof k.limits.memory=="number"&&C>k.limits.memory)throw(0,R.createFileSystemProviderError)((0,D.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&C>k.limits.size)throw(0,R.createFileSystemProviderError)((0,D.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(X[69],J([0,1,92,2,9,4,7,15]),function(z,e,S,t,D,R,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function f(E){return E.recursive===!0}e.isRecursiveWatchRequest=f;class p extends t.Disposable{constructor(I,w,h,l){super();this.onFileChanges=I,this.onLogMessage=w,this.verboseLogging=h,this.options=l,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const I=new t.DisposableStore;this.watcherDisposables.value=I,this.watcher=this.createWatcher(I),this.watcher.setVerboseLogging(this.verboseLogging),I.add(this.watcher.onDidChangeFile(w=>this.onFileChanges(w))),I.add(this.watcher.onDidLogMessage(w=>this.onLogMessage(w))),I.add(this.watcher.onDidError(w=>this.onError(w)))}onError(I){this.options.restartOnError?this.restartCounter<p.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${I}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${I}`):this.error(I)}restart(I){this.restartCounter++,this.init(),this.watch(I)}async watch(I){this.requests=I,await this.watcher?.watch(I)}async setVerboseLogging(I){this.verboseLogging=I,await this.watcher?.setVerboseLogging(I)}error(I){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${I}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=p,p.MAX_RESTARTS=5;class C extends p{constructor(I,w,h){super(I,w,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class k extends p{constructor(I,w,h){super(I,w,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=k;function y(E){return E.map(I=>({type:I.type,resource:M.URI.file(I.path)}))}e.toFileChanges=y;function g(E){const I=new m;for(const w of E)I.processEvent(w);return I.coalesce()}e.coalesceEvents=g;function u(E,I){return typeof I=="string"&&!I.startsWith(S.GLOBSTAR)&&!(0,D.isAbsolute)(I)?{base:E,pattern:I}:I}e.normalizeWatcherPattern=u;function b(E,I){const w=[];for(const h of I)w.push((0,S.parse)(u(E,h)));return w}e.parseWatcherPatterns=b;class m{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(I){return R.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const w=this.mapPathToChange.get(this.toKey(I));let h=!1;if(w){const l=w.type,r=I.type;w.path!==I.path&&(I.type===2||I.type===1)?h=!0:l===1&&r===2?(this.mapPathToChange.delete(this.toKey(I)),this.coalesced.delete(w)):l===2&&r===1?w.type=0:l===1&&r===0||(w.type=r)}else h=!0;h&&(this.coalesced.add(I),this.mapPathToChange.set(this.toKey(I),I))}coalesce(){const I=[],w=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(I.push(h),!1):!0).sort((h,l)=>h.path.length-l.path.length).filter(h=>w.some(l=>(0,v.isParent)(h.path,l,!R.isLinux))?!1:(w.push(h.path),!0)).concat(I)}}}),define(X[187],J([0,1,28,8,21,30,2,79,9,4,93,23,69]),function(z,e,S,t,D,R,M,v,f,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends M.Disposable{constructor(m,E,I,w){super();this.request=m,this.onDidFilesChange=E,this.onLogMessage=I,this.verboseLogging=w,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.onDidFilesChange(h)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(g.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,y.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,y.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const m=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const E=await k.Promises.stat(m);this._register(await this.doWatch(m,E.isDirectory()))}catch(m){m.code!=="ENOENT"?this.error(m):this.trace(m)}}async normalizePath(m){let E=m.path;try{E=await k.Promises.realpath(m.path),m.path===E&&(E=await(0,C.realcase)(m.path)??m.path),m.path!==E&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${E})`)}catch{}return E}async doWatch(m,E){if(p.isMacintosh&&(0,R.isEqualOrParent)(m,"/Volumes/",!0))return this.error(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const I=new D.CancellationTokenSource(this.cts.token),w=new M.DisposableStore;try{const h=(0,f.basename)(m),l=(0,S.watch)(m);w.add((0,M.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${m}'`);const r=new Set;if(E)try{for(const i of await k.Promises.readdir(m))r.add(i)}catch(i){this.error(i)}const n=new Map;w.add((0,M.toDisposable)(()=>{for(const[,i]of n)i.dispose();n.clear()})),l.on("error",(i,s)=>{this.error(`Failed to watch ${m} for changes using fs.watch() (${i}, ${s})`),this.dispose()}),l.on("change",(i,s)=>{if(I.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${s}`);let o="";if(s&&(o=s.toString(),p.isMacintosh&&(o=(0,v.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(E)if(i==="rename"){n.get(o)?.dispose();const a=setTimeout(async()=>{if(n.delete(o),o===h&&!await k.Promises.exists(m)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.existsChildStrictCase((0,f.join)(m,o));if(I.token.isCancellationRequested)return;let d;c?r.has(o)?d=0:(d=1,r.add(o)):(r.delete(o),d=2),this.onFileChange({path:(0,f.join)(this.request.path,o),type:d})},g.FILE_DELETE_HANDLER_DELAY);n.set(o,(0,M.toDisposable)(()=>clearTimeout(a)))}else{let a;r.has(o)?a=0:(a=1,r.add(o)),this.onFileChange({path:(0,f.join)(this.request.path,o),type:a})}else if(i==="rename"||o!==h){const a=setTimeout(async()=>{const c=await k.Promises.exists(m);I.token.isCancellationRequested||(c?(this.onFileChange({path:this.request.path,type:0},!0),w.add(await this.doWatch(m,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},g.FILE_DELETE_HANDLER_DELAY);w.clear(),w.add((0,M.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(h){await k.Promises.exists(m)&&!I.token.isCancellationRequested&&this.error(`Failed to watch ${m} for changes using fs.watch() (${h.toString()})`)}return(0,M.toDisposable)(()=>{I.dispose(!0),w.dispose()})}async onFileChange(m,E=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),!E&&this.excludes.some(I=>I(m.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${m.path}`):!E&&this.includes&&this.includes.length>0&&!this.includes.some(I=>I(m.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${m.path}`):this.fileChangesBuffer.push(m);try{await this.fileChangesDelayer.trigger(async()=>{const I=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,y.coalesceEvents)(I);if(w.length>0){if(this.verboseLogging)for(const l of w)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(w)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${w[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${w.length}, most recent change: ${w[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(m){if(p.isLinux)return k.Promises.exists(m);try{const E=(0,f.basename)(m);return(await k.Promises.readdir((0,f.dirname)(m))).some(w=>w===E)}catch(E){return this.trace(E),!1}}setVerboseLogging(m){this.verboseLogging=m}error(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}warn(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}trace(m){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=g,g.FILE_DELETE_HANDLER_DELAY=100,g.FILE_CHANGES_HANDLER_DELAY=50;async function u(b,m,E,I,w=512){const h=await k.Promises.open(b,"r"),l=Buffer.allocUnsafe(w),r=new D.CancellationTokenSource(I);let n,i=!1;const s={path:b,excludes:[],recursive:!1},o=new g(s,a=>{(async()=>{for(const{type:c}of a)if(c===0){if(i)return;i=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:d}=await k.Promises.read(h,l,0,w,null);if(!d||r.token.isCancellationRequested)break;m(l.slice(0,d))}}catch(d){n=new Error(d),r.dispose(!0)}finally{i=!1}}})()});return await o.ready,E(),new Promise((a,c)=>{r.token.onCancellationRequested(async()=>{o.dispose();try{await k.Promises.close(h)}catch(d){n=new Error(d)}n?c(n):a()})})}e.watchFileContents=u}),define(X[188],J([0,1,3,92,2,4,187]),function(z,e,S,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class v extends D.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new S.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new S.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=S.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(p){const C=this.normalizeRequests(p),k=C.filter(g=>{const u=this.watchers.get(g.path);return u?!(0,t.patternsEquals)(u.request.excludes,g.excludes)||!(0,t.patternsEquals)(u.request.includes,g.includes):!0}),y=Array.from(this.watchers.values()).filter(({request:g})=>!C.find(u=>u.path===g.path&&(0,t.patternsEquals)(u.excludes,g.excludes)&&(0,t.patternsEquals)(u.includes,g.includes))).map(({request:g})=>g.path);k.length&&this.trace(`Request to start watching: ${k.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),y.length&&this.trace(`Request to stop watching: ${y.join(",")}`);for(const g of y)this.stopWatching(g);for(const g of k)this.startWatching(g)}startWatching(p){const C=new M.NodeJSFileWatcherLibrary(p,y=>this._onDidChangeFile.fire(y),y=>this._onDidLogMessage.fire(y),this.verboseLogging),k={request:p,instance:C};this.watchers.set(p.path,k)}async stop(){for(const[p]of this.watchers)this.stopWatching(p);this.watchers.clear()}stopWatching(p){const C=this.watchers.get(p);C&&(this.watchers.delete(p),C.instance.dispose())}normalizeRequests(p){const C=new Map;for(const k of p){const y=R.isLinux?k.path:k.path.toLowerCase();C.set(y,k)}return Array.from(C.values())}async setVerboseLogging(p){this.verboseLogging=p;for(const[,C]of this.watchers)C.instance.setVerboseLogging(p)}trace(p){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(p)})}toMessage(p,C){return C?`[File Watcher (node.js)] ${p} (path: ${C.request.path})`:`[File Watcher (node.js)] ${p}`}}e.NodeJSWatcher=v}),define(X[189],J([0,1,69,188]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends S.AbstractNonRecursiveWatcherClient{constructor(M,v,f){super(M,v,f);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(X[190],J([0,1,12,43,145,69]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends R.AbstractUniversalWatcherClient{constructor(f,p,C){super(f,p,C);this.init()}createWatcher(f){const p=f.add(new D.Client(S.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(p.onDidProcessExit(({code:C,signal:k})=>this.onError(`terminated by itself with code ${C}, signal: ${k}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(p.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(X[84],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...D){this._entries=new Map;for(const[R,M]of D)this.set(R,M)}set(D,R){const M=this._entries.get(D);return this._entries.set(D,R),M}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=S}),define(X[191],J([0,1,8,19,67,182,5,84]),function(z,e,S,t,D,R,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const f=!1;class p extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class C{constructor(u=new v.ServiceCollection,b=!1,m){this._activeInstantiations=new Set,this._services=u,this._strict=b,this._parent=m,this._services.set(M.IInstantiationService,this)}createChild(u){return new C(u,this._strict,this)}invokeFunction(u,...b){const m=y.traceInvocation(u);let E=!1;try{return u({get:w=>{if(E)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(w,m);if(!h)throw new Error(`[invokeFunction] unknown service '${w}'`);return h}},...b)}finally{E=!0,m.stop()}}createInstance(u,...b){let m,E;return u instanceof D.SyncDescriptor?(m=y.traceCreation(u.ctor),E=this._createInstance(u.ctor,u.staticArguments.concat(b),m)):(m=y.traceCreation(u),E=this._createInstance(u,b,m)),m.stop(),E}_createInstance(u,b=[],m){const E=M._util.getServiceDependencies(u).sort((h,l)=>h.index-l.index),I=[];for(const h of E){const l=this._getOrCreateServiceInstance(h.id,m);l||this._throwIfStrict(`[createInstance] ${u.name} depends on UNKNOWN service ${h.id}.`,!1),I.push(l)}const w=E.length>0?E[0].index:b.length;if(b.length!==w){console.trace(`[createInstance] First service dependency of ${u.name} at position ${w+1} conflicts with ${b.length} static arguments`);const h=w-b.length;h>0?b=b.concat(new Array(h)):b=b.slice(0,w)}return new u(...[...b,...I])}_setServiceInstance(u,b){if(this._services.get(u)instanceof D.SyncDescriptor)this._services.set(u,b);else if(this._parent)this._parent._setServiceInstance(u,b);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){const b=this._services.get(u);return!b&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):b}_getOrCreateServiceInstance(u,b){const m=this._getServiceInstanceOrDescriptor(u);return m instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,m,b.branch(u,!0)):(b.branch(u,!1),m)}_safeCreateAndCacheServiceInstance(u,b,m){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,b,m)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,b,m){const E=new R.Graph(h=>h.id.toString());let I=0;const w=[{id:u,desc:b,_trace:m}];for(;w.length;){const h=w.pop();if(E.lookupOrInsertNode(h),I++>1e3)throw new p(E);for(const l of M._util.getServiceDependencies(h.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(l.id);if(r||this._throwIfStrict(`[createInstance] ${u} depends on ${l.id} which is NOT registered.`,!0),r instanceof D.SyncDescriptor){const n={id:l.id,desc:r,_trace:h._trace.branch(l.id,!0)};E.insertEdge(h,n),w.push(n)}}}for(;;){const h=E.roots();if(h.length===0){if(!E.isEmpty())throw new p(E);break}for(const{data:l}of h){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const n=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,n)}E.removeNode(l)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,b,m=[],E,I){if(this._services.get(u)instanceof D.SyncDescriptor)return this._createServiceInstance(b,m,E,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,b,m,E,I);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}_createServiceInstance(u,b=[],m,E){if(m){const I=new S.IdleValue(()=>this._createInstance(u,b,E));return new Proxy(Object.create(null),{get(w,h){if(h in w)return w[h];const l=I.value;let r=l[h];return typeof r!="function"||(r=r.bind(l),w[h]=r),r},set(w,h,l){return I.value[h]=l,!0}})}else return this._createInstance(u,b,E)}_throwIfStrict(u,b){if(b&&console.warn(u),this._strict)throw new Error(u)}}e.InstantiationService=C;var k;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(k||(k={}));class y{constructor(u,b){this.type=u,this.name=b,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return f?new y(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(u){return f?new y(0,u.name):y._None}branch(u,b){const m=new y(2,u.toString());return this._dep.push([u,b,m]),m}stop(){const u=Date.now()-this._start;y._totals+=u;let b=!1;function m(I,w){const h=[],l=new Array(I+1).join("	");for(const[r,n,i]of w._dep)if(n&&i){b=!0,h.push(`${l}CREATES -> ${r}`);const s=m(I+1,i);s&&h.push(s)}else h.push(`${l}uses -> ${r}`);return h.join(`
`)}const E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(u>2||b)&&console.log(E.join(`
`))}}e.Trace=y,y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(X[6],J([0,1,41,3,2,4,5]),function(z,e,S,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function v(){return new Date().toISOString()}var f;(function(n){n[n.Trace=0]="Trace",n[n.Debug=1]="Debug",n[n.Info=2]="Info",n[n.Warning=3]="Warning",n[n.Error=4]="Error",n[n.Critical=5]="Critical",n[n.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;function p(n,i,s){switch(i){case f.Trace:n.trace(s);break;case f.Debug:n.debug(s);break;case f.Info:n.info(s);break;case f.Warning:n.warn(s);break;case f.Error:n.error(s);break;case f.Critical:n.critical(s);break;default:throw new Error("Invalid log level")}}e.log=p;function C(n){let i="";for(let s=0;s<n.length;s++){let o=n[s];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(s>0?" ":"")+o}return i}e.format=C;class k extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class y extends k{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...s){this.checkLogLevel(f.Trace)&&this.log(f.Trace,C([i,...s]))}debug(i,...s){this.checkLogLevel(f.Debug)&&this.log(f.Debug,C([i,...s]))}info(i,...s){this.checkLogLevel(f.Info)&&this.log(f.Info,C([i,...s]))}warn(i,...s){this.checkLogLevel(f.Warning)&&this.log(f.Warning,C([i,...s]))}error(i,...s){if(this.checkLogLevel(f.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(f.Error,C(o))}else this.log(f.Error,C([i,...s]))}critical(i,...s){this.checkLogLevel(f.Critical)&&this.log(f.Critical,C([i,...s]))}flush(){}}e.AbstractMessageLogger=y;class g extends k{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!R.isWindows}trace(i,...s){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${v()}][0m`,i,...s):console.log(`[main ${v()}]`,i,...s))}debug(i,...s){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${v()}][0m`,i,...s):console.log(`[main ${v()}]`,i,...s))}info(i,...s){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${v()}][0m`,i,...s):console.log(`[main ${v()}]`,i,...s))}warn(i,...s){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${v()}][0m`,i,...s):console.warn(`[main ${v()}]`,i,...s))}error(i,...s){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${v()}][0m`,i,...s):console.error(`[main ${v()}]`,i,...s))}critical(i,...s){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${v()}][0m`,i,...s):console.error(`[main ${v()}]`,i,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class u extends k{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...s){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...s)}debug(i,...s){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...s)}info(i,...s){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...s)}warn(i,...s){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...s)}error(i,...s){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...s)}critical(i,...s){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...s)}dispose(){}flush(){}}e.ConsoleLogger=u;class b extends k{constructor(i,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(s)}trace(i,...s){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...s])}debug(i,...s){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...s])}info(i,...s){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...s])}warn(i,...s){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...s])}error(i,...s){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...s])}critical(i,...s){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...s])}extractMessage(i){return typeof i=="string"?i:(0,S.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class m extends k{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const s of this.logServices)s.setLevel(i);super.setLevel(i)}trace(i,...s){for(const o of this.logServices)o.trace(i,...s)}debug(i,...s){for(const o of this.logServices)o.debug(i,...s)}info(i,...s){for(const o of this.logServices)o.info(i,...s)}warn(i,...s){for(const o of this.logServices)o.warn(i,...s)}error(i,...s){for(const o of this.logServices)o.error(i,...s)}critical(i,...s){for(const o of this.logServices)o.critical(i,...s)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=m;class E extends D.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...s){this.logger.trace(i,...s)}debug(i,...s){this.logger.debug(i,...s)}info(i,...s){this.logger.info(i,...s)}warn(i,...s){this.logger.warn(i,...s)}error(i,...s){this.logger.error(i,...s)}critical(i,...s){this.logger.critical(i,...s)}flush(){this.logger.flush()}}e.LogService=E;class I extends D.Disposable{constructor(i,s){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,s){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,s?.always?f.Trace:this.logLevel,s),this.loggers.set(i.toString(),o),s?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class w{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...s){}debug(i,...s){}info(i,...s){}warn(i,...s){}error(i,...s){}critical(i,...s){}dispose(){}flush(){}}e.NullLogService=w;function h(n){if(n.verbose)return f.Trace;if(typeof n.logLevel=="string"){const i=l(n.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function l(n){switch(n){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=l;function r(n){switch(n){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=r});var x=this&&this.__param||function(z,e){return function(S,t){e(S,t,z)}};define(X[192],J([0,1,68,3,2,6,4]),function(z,e,S,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let v=class yt extends D.Disposable{constructor(p){super();this.logService=p,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(p,C){let k;try{k=await this.withKeytar()}catch{return null}const y=await k.getPassword(p,C);if(y)try{let{content:g,hasNextChunk:u}=JSON.parse(y);if(!g||!u)return y;let b=1;for(;u;){const m=await k.getPassword(p,`${C}-${b}`),E=JSON.parse(m);g+=E.content,u=E.hasNextChunk,b++}return g}catch{return y}return y}async setPassword(p,C,k){let y;try{y=await this.withKeytar()}catch(b){throw this.surfaceKeytarLoadError?.(b),b}const g=3,u=async(b,m,E)=>{let I=0,w;for(;I<g;)try{await y.setPassword(b,m,E);return}catch(h){w=h,this.logService.warn("Error attempting to set a password: ",h?.message??h),I++,await new Promise(l=>setTimeout(l,200))}throw w};if(M.isWindows&&k.length>yt.MAX_PASSWORD_LENGTH){let b=0,m=0,E=!0;for(;E;){const I=k.substring(b,b+yt.PASSWORD_CHUNK_SIZE);b+=yt.PASSWORD_CHUNK_SIZE,E=k.length-b>0;const w={content:I,hasNextChunk:E};await u(p,m?`${C}-${m}`:C,JSON.stringify(w)),m++}}else await u(p,C,k);this._onDidChangePassword.fire({service:p,account:C})}async deletePassword(p,C){let k;try{k=await this.withKeytar()}catch(u){throw this.surfaceKeytarLoadError?.(u),u}const y=await k.getPassword(p,C);if(!y)return!1;const g=await k.deletePassword(p,C);try{let{content:u,hasNextChunk:b}=JSON.parse(y);if(u&&b){let m=1;for(;b;){const E=`${C}-${m}`,I=await k.getPassword(p,E);await k.deletePassword(p,E),b=JSON.parse(I).hasNextChunk,m++}}}catch{}return g&&this._onDidChangePassword.fire({service:p,account:C}),g}async findPassword(p){let C;try{C=await this.withKeytar()}catch{return null}return C.findPassword(p)}async findCredentials(p){let C;try{C=await this.withKeytar()}catch{return[]}return C.findCredentials(p)}clear(){return this._keytarCache instanceof S.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};v.MAX_PASSWORD_LENGTH=2500,v.PASSWORD_CHUNK_SIZE=v.MAX_PASSWORD_LENGTH-100,v=fe([x(0,R.ILogService)],v),e.BaseCredentialsMainService=v}),define(X[193],J([0,1,25,8,19,3,2,9,69,6]),function(z,e,S,t,D,R,M,v,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends M.Disposable{constructor(y,g){super();this.logService=y,this.options=g,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(y,g){return g.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(y,g):this.watchNonRecursive(y,g)}watchUniversal(y,g){const u={path:this.toFilePath(y),excludes:g.excludes,includes:g.includes,recursive:g.recursive},b=(0,S.insert)(this.universalPathsToWatch,u);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{b(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(y=>(0,D.onUnexpectedError)(y))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(g=>this._onDidChangeFile.fire((0,f.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)})));const y=this.options?.watcher?.recursive?.usePolling;if(y===!0)for(const g of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const g of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(g)&&y.includes(g.path)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(y,g){const u={path:this.toFilePath(y),excludes:g.excludes,includes:g.includes,recursive:!1},b=(0,S.insert)(this.nonRecursivePathsToWatch,u);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{b(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(y=>(0,D.onUnexpectedError)(y))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(y=>this._onDidChangeFile.fire((0,f.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(y){y.type==="error"&&this._onDidWatchError.fire(y.message),this.logService[y.type](y.message)}toFilePath(y){return(0,v.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(X[194],J([0,1,25,8,17,21,3,65,54,2,33,12,70,16,55,153,15,102,6]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends p.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(l,r){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${l}`);const n=new p.DisposableStore;return this.provider.set(l,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:r}),n.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new m.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&n.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),n.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:l}))),(0,p.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:r}),this.provider.delete(l),(0,p.dispose)(n)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(n){r.push(n)}}),!this.provider.has(l)&&await t.Promises.settled(r)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,r){const n=this.provider.get(l.scheme);return!!(n&&n.capabilities&r)}listCapabilities(){return f.Iterable.map(this.provider,([l,r])=>({scheme:l,capabilities:r.capabilities}))}async withProvider(l){if(!(0,g.isAbsolutePath)(l))throw new m.FileOperationError((0,b.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const r=this.provider.get(l.scheme);if(!r){const n=new Error;throw n.name="ENOPRO",n.message=(0,b.localize)(1,null,l.toString()),n}return r}async withReadProvider(l){const r=await this.withProvider(l);if((0,m.hasOpenReadWriteCloseCapability)(r)||(0,m.hasReadWriteCapability)(r)||(0,m.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const r=await this.withProvider(l);if((0,m.hasOpenReadWriteCloseCapability)(r)||(0,m.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,r){try{return await this.doResolveFile(l,r)}catch(n){throw(0,m.toFileSystemProviderErrorCode)(n)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,b.localize)(2,null,this.resourceForError(l)),1):(0,m.ensureFileSystemProviderError)(n)}}async doResolveFile(l,r){const n=await this.withProvider(l),i=this.isPathCaseSensitive(n),s=r?.resolveTo,o=r?.resolveSingleChildDescendants,a=r?.resolveMetadata,c=await n.stat(l);let d;return this.toFileStat(n,l,c,void 0,!!a,(P,L)=>(d||(d=C.TernarySearchTree.forUris(()=>!i),d.set(l,!0),s&&d.fill(!0,s)),d.get(P.resource)||d.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&o?L===1:!1))}async toFileStat(l,r,n,i,s,o){const{providerExtUri:a}=this.getExtUri(l),c={resource:r,name:a.basename(r),isFile:(n.type&m.FileType.File)!=0,isDirectory:(n.type&m.FileType.Directory)!=0,isSymbolicLink:(n.type&m.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&m.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,m.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(c.isDirectory&&o(c,i)){try{const d=await l.readdir(r),P=await t.Promises.settled(d.map(async([L,T])=>{try{const W=a.joinPath(r,L),q=s?await l.stat(W):{type:T};return await this.toFileStat(l,W,q,d.length,s,o)}catch(W){return this.logService.trace(W),null}}));c.children=(0,S.coalesce)(P)}catch(d){this.logService.trace(d),c.children=[]}return c}return c}async resolveAll(l){return t.Promises.settled(l.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(l){const r=await this.withProvider(l),n=await r.stat(l);return this.toFileStat(r,l,n,void 0,!0,()=>!1)}async exists(l){const r=await this.withProvider(l);try{return!!await r.stat(l)}catch{return!1}}async canCreateFile(l,r){try{await this.doValidateCreateFile(l,r)}catch(n){return n}return!0}async doValidateCreateFile(l,r){if(!r?.overwrite&&await this.exists(l))throw new m.FileOperationError((0,b.localize)(3,null,this.resourceForError(l)),3,r)}async createFile(l,r=D.VSBuffer.fromString(""),n){await this.doValidateCreateFile(l,n);const i=await this.writeFile(l,r);return this._onDidRunOperation.fire(new m.FileOperationEvent(l,0,i)),i}async writeFile(l,r,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:s}=this.getExtUri(i);try{await this.validateWriteFile(i,l,n)||await this.mkdirp(i,s.dirname(l));let a;if((0,m.hasReadWriteCapability)(i)&&!(r instanceof D.VSBuffer))if((0,u.isReadableStream)(r)){const c=await(0,u.peekStream)(r,3);c.ended?a=D.VSBuffer.concat(c.buffer):a=c}else a=(0,u.peekReadable)(r,c=>D.VSBuffer.concat(c),3);else a=r;!(0,m.hasOpenReadWriteCloseCapability)(i)||(0,m.hasReadWriteCapability)(i)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(i,l,n,a):await this.doWriteBuffered(i,l,n,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a),this._onDidRunOperation.fire(new m.FileOperationEvent(l,4))}catch(o){throw new m.FileOperationError((0,b.localize)(4,null,this.resourceForError(l),(0,m.ensureFileSystemProviderError)(o).toString()),(0,m.toFileOperationResult)(o),n)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,r,n){if(!!n?.unlock&&!(l.capabilities&8192))throw new Error((0,b.localize)(5,null,this.resourceForError(r)));let s;try{s=await l.stat(r)}catch{return}if((s.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,b.localize)(6,null,this.resourceForError(r)),0,n);if(this.throwIfFileIsReadonly(r,s),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==m.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&n.mtime<s.mtime&&n.etag!==(0,m.etag)({mtime:n.mtime,size:s.size}))throw new m.FileOperationError((0,b.localize)(7,null),3,n);return s}async readFile(l,r,n){const i=await this.withReadProvider(l);return r?.atomic?this.doReadFileAtomic(i,l,r,n):this.doReadFile(i,l,r,n)}async doReadFileAtomic(l,r,n,i){return new Promise((s,o)=>{this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(l,r,n,i);s(a)}catch(a){o(a)}})})}async doReadFile(l,r,n,i){const s=await this.doReadFileStream(l,r,{...n,preferUnbuffered:!0},i);return{...s,value:await(0,D.streamToBuffer)(s.value)}}async readFileStream(l,r,n){const i=await this.withReadProvider(l);return this.doReadFileStream(i,l,r,n)}async doReadFileStream(l,r,n,i){const s=new R.CancellationTokenSource(i),o=this.validateReadFile(r,n).then(c=>c,c=>{throw s.cancel(),c});let a;try{return typeof n?.etag=="string"&&n.etag!==m.ETAG_DISABLED&&await o,n?.atomic&&(0,m.hasFileAtomicReadCapability)(l)||!((0,m.hasOpenReadWriteCloseCapability)(l)||(0,m.hasFileReadStreamCapability)(l))||(0,m.hasReadWriteCapability)(l)&&n?.preferUnbuffered?a=this.readFileUnbuffered(l,r,n):(0,m.hasFileReadStreamCapability)(l)?a=this.readFileStreamed(l,r,s.token,n):a=this.readFileBuffered(l,r,s.token,n),{...await o,value:a}}catch(c){a&&await(0,u.consumeStream)(a);const d=(0,b.localize)(8,null,this.resourceForError(r),(0,m.ensureFileSystemProviderError)(c).toString());throw c instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(d,c.stat,n):new m.FileOperationError(d,(0,m.toFileOperationResult)(c),n)}}readFileStreamed(l,r,n,i=Object.create(null)){const s=l.readFileStream(r,i,n);return(0,u.transform)(s,{data:o=>o instanceof D.VSBuffer?o:D.VSBuffer.wrap(o),error:o=>new m.FileOperationError((0,b.localize)(9,null,this.resourceForError(r),(0,m.ensureFileSystemProviderError)(o).toString()),(0,m.toFileOperationResult)(o),i)},o=>D.VSBuffer.concat(o))}readFileBuffered(l,r,n,i=Object.create(null)){const s=(0,D.newWriteableBufferStream)();return(0,E.readFileIntoStream)(l,r,s,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new m.FileOperationError((0,b.localize)(10,null,this.resourceForError(r),(0,m.ensureFileSystemProviderError)(o).toString()),(0,m.toFileOperationResult)(o),i)},n),s}readFileUnbuffered(l,r,n){const i=(0,u.newWriteableStream)(s=>D.VSBuffer.concat(s));return(async()=>{try{let s;n?.atomic&&(0,m.hasFileAtomicReadCapability)(l)?s=await l.readFile(r,{atomic:!0}):s=await l.readFile(r),typeof n?.position=="number"&&(s=s.slice(n.position)),typeof n?.length=="number"&&(s=s.slice(0,n.length)),this.validateReadFileLimits(r,s.byteLength,n),i.end(D.VSBuffer.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async validateReadFile(l,r){const n=await this.resolve(l,{resolveMetadata:!0});if(n.isDirectory)throw new m.FileOperationError((0,b.localize)(11,null,this.resourceForError(l)),0,r);if(typeof r?.etag=="string"&&r.etag!==m.ETAG_DISABLED&&r.etag===n.etag)throw new m.NotModifiedSinceFileOperationError((0,b.localize)(12,null),n,r);return this.validateReadFileLimits(l,n.size,r),n}validateReadFileLimits(l,r,n){if(n?.limits){let i;if(typeof n.limits.memory=="number"&&r>n.limits.memory&&(i=9),typeof n.limits.size=="number"&&r>n.limits.size&&(i=7),typeof i=="number")throw new m.FileOperationError((0,b.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,r,n){return this.doCanMoveCopy(l,r,"move",n)}async canCopy(l,r,n){return this.doCanMoveCopy(l,r,"copy",n)}async doCanMoveCopy(l,r,n,i){if(l.toString()!==r.toString())try{const s=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(s,l,o,r,n,i)}catch(s){return s}return!0}async move(l,r,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,l,s,r,"move",!!n),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(l,o==="move"?2:3,a)),a}async copy(l,r,n){const i=await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,l,s,r,"copy",!!n),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(l,o==="copy"?3:2,a)),a}async doMoveCopy(l,r,n,i,s,o){if(r.toString()===i.toString())return s;const{exists:a,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(l,r,n,i,s,o);if(a&&!c&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i)),s==="copy"){if(l===n&&(0,m.hasFileFolderCopyCapability)(l))await l.copy(r,i,{overwrite:o});else{const d=await this.resolve(r);d.isDirectory?await this.doCopyFolder(l,d,n,i):await this.doCopyFile(l,r,n,i)}return s}else return l===n?(await l.rename(r,i,{overwrite:o}),s):(await this.doMoveCopy(l,r,n,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(l,r,n,i){if((0,m.hasOpenReadWriteCloseCapability)(l)&&(0,m.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(l,r,n,i);if((0,m.hasOpenReadWriteCloseCapability)(l)&&(0,m.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(l,r,n,i);if((0,m.hasReadWriteCapability)(l)&&(0,m.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(l,r,n,i);if((0,m.hasReadWriteCapability)(l)&&(0,m.hasReadWriteCapability)(n))return this.doPipeUnbuffered(l,r,n,i)}async doCopyFolder(l,r,n,i){await n.mkdir(i),Array.isArray(r.children)&&await t.Promises.settled(r.children.map(async s=>{const o=this.getExtUri(n).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.doCopyFolder(l,await this.resolve(s.resource),n,o):this.doCopyFile(l,s.resource,n,o)}))}async doValidateMoveCopy(l,r,n,i,s,o){let a=!1;if(l===n){const{providerExtUri:d,isPathCaseSensitive:P}=this.getExtUri(l);if(P||(a=d.isEqual(r,i)),a&&s==="copy")throw new Error((0,b.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!a&&d.isEqualOrParent(i,r))throw new Error((0,b.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const c=await this.exists(i);if(c&&!a){if(!o)throw new m.FileOperationError((0,b.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(l===n){const{providerExtUri:d}=this.getExtUri(l);if(d.isEqualOrParent(r,i))throw new Error((0,b.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:c,isSameResourceWithDifferentPathCase:a}}getExtUri(l){const r=this.isPathCaseSensitive(l);return{providerExtUri:r?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(r,l);const n=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(l,0,n)),n}async mkdirp(l,r){const n=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(r,i.dirname(r));)try{if(((await l.stat(r)).type&m.FileType.Directory)==0)throw new Error((0,b.localize)(18,null,this.resourceForError(r)));break}catch(s){if((0,m.toFileSystemProviderErrorCode)(s)!==m.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(i.basename(r)),r=i.dirname(r)}for(let s=n.length-1;s>=0;s--){r=i.joinPath(r,n[s]);try{await l.mkdir(r)}catch(o){if((0,m.toFileSystemProviderErrorCode)(o)!==m.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(l,r){try{await this.doValidateDelete(l,r)}catch(n){return n}return!0}async doValidateDelete(l,r){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!r?.useTrash&&!(n.capabilities&4096))throw new Error((0,b.localize)(19,null,this.resourceForError(l)));let s;try{s=await n.stat(l)}catch{}if(s)this.throwIfFileIsReadonly(l,s);else throw new m.FileOperationError((0,b.localize)(20,null,this.resourceForError(l)),1);if(!!!r?.recursive){const a=await this.resolve(l);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,b.localize)(21,null,this.resourceForError(l)))}return n}async del(l,r){const n=await this.doValidateDelete(l,r),i=!!r?.useTrash,s=!!r?.recursive;await n.delete(l,{recursive:s,useTrash:i}),this._onDidRunOperation.fire(new m.FileOperationEvent(l,1))}async cloneFile(l,r){const n=await this.withProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(n===i&&this.getExtUri(n).providerExtUri.isEqual(l,r))return;if(n===i&&(0,m.hasFileCloneCapability)(n))return n.cloneFile(l,r);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(r));const s=this.writeQueue.queueFor(l,this.getExtUri(n).providerExtUri);return n===i&&(0,m.hasFileFolderCopyCapability)(n)?s.queue(()=>n.copy(l,r,{overwrite:!0})):s.queue(()=>this.doCopyFile(n,l,i,r))}watch(l,r={recursive:!1,excludes:[]}){const n=new p.DisposableStore;let i=!1,s=()=>{i=!0};return n.add((0,p.toDisposable)(()=>s())),(async()=>{try{const o=await this.doWatch(l,r);i?(0,p.dispose)(o):s=()=>(0,p.dispose)(o)}catch(o){this.logService.error(o)}})(),n}async doWatch(l,r){const n=await this.withProvider(l),i=(0,v.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(l),r]);let s=this.activeWatchers.get(i);return s||(s={count:0,disposable:n.watch(l,r)},this.activeWatchers.set(i,s)),s.count+=1,(0,p.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,p.dispose)(s.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,p.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,r,n,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{const s=await l.open(r,{create:!0,unlock:n?.unlock??!1});try{(0,u.isReadableStream)(i)||(0,u.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,s,i):await this.doWriteReadableBufferedQueued(l,s,i)}catch(o){throw(0,m.ensureFileSystemProviderError)(o)}finally{await l.close(s)}})}async doWriteStreamBufferedQueued(l,r,n){let i=0,s;if((0,u.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=D.VSBuffer.concat(n.buffer);await this.doWriteBuffer(l,r,o,o.byteLength,i,0),i+=o.byteLength}if(n.ended)return;s=n.stream}else s=n;return new Promise((o,a)=>{(0,u.listenStream)(s,{onData:async c=>{s.pause();try{await this.doWriteBuffer(l,r,c,c.byteLength,i,0)}catch(d){return a(d)}i+=c.byteLength,setTimeout(()=>s.resume())},onError:c=>a(c),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(l,r,n){let i=0,s;for(;(s=n.read())!==null;)await this.doWriteBuffer(l,r,s,s.byteLength,i,0),i+=s.byteLength}async doWriteBuffer(l,r,n,i,s,o){let a=0;for(;a<i;)a+=await l.write(r,s+a,n.buffer,o+a,i-a)}async doWriteUnbuffered(l,r,n,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,r,n,i))}async doWriteUnbufferedQueued(l,r,n,i){let s;i instanceof D.VSBuffer?s=i:(0,u.isReadableStream)(i)?s=await(0,D.streamToBuffer)(i):(0,u.isReadableBufferedStream)(i)?s=await(0,D.bufferedStreamToBuffer)(i):s=(0,D.readableToBuffer)(i),await l.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(l,r,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,r,n,i))}async doPipeBufferedQueued(l,r,n,i){let s,o;try{s=await l.open(r,{create:!1}),o=await n.open(i,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,d=0,P=0;do P=await l.read(s,c,a.buffer,d,a.byteLength-d),await this.doWriteBuffer(n,o,a,P,c,d),c+=P,d+=P,d===a.byteLength&&(d=0);while(P>0)}catch(a){throw(0,m.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof s=="number"?l.close(s):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(l,r,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,r,n,i))}async doPipeUnbufferedQueued(l,r,n,i){return n.writeFile(i,await l.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,r,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,r,n,i))}async doPipeUnbufferedToBufferedQueued(l,r,n,i){const s=await n.open(i,{create:!0,unlock:!1});try{const o=await l.readFile(r);await this.doWriteBuffer(n,s,D.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,m.ensureFileSystemProviderError)(o)}finally{await n.close(s)}}async doPipeBufferedToUnbuffered(l,r,n,i){const s=await(0,D.streamToBuffer)(this.readFileBuffered(l,r,R.CancellationToken.None));await this.doWriteUnbuffered(n,i,void 0,s)}throwIfFileSystemIsReadonly(l,r){if(l.capabilities&2048)throw new m.FileOperationError((0,b.localize)(22,null,this.resourceForError(r)),6);return l}throwIfFileIsReadonly(l,r){if((r.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,b.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===k.Schemas.file?l.fsPath:l.toString(!0)}};w=fe([x(0,I.ILogService)],w),e.FileService=w}),define(X[85],J([0,1,28,263,8,33,17,3,30,2,9,4,16,55,23,157,15,102,193,41,190,189]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E,I,w,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(S)}catch(n){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(n)}`)}})();class r extends I.AbstractDiskFileSystemProvider{constructor(i,s){super(i,s);this.onDidChangeCapabilities=v.Event.None,this.resourceLocks=new R.ResourceMap(o=>y.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:s,symbolicLink:o}=await u.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(s,o),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(i){try{const s=await u.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(s.map(async a=>{try{let c;a.isSymbolicLink()?c=(await this.stat((0,y.joinPath)(i,a.name))).type:c=this.toType(a),o.push([a.name,c])}catch(c){this.logService.trace(c)}})),o}catch(s){throw this.toFileSystemProviderError(s)}}toType(i,s){let o;return s?.dangling?o=m.FileType.Unknown:i.isFile()?o=m.FileType.File:i.isDirectory()?o=m.FileType.Directory:o=m.FileType.Unknown,s&&(o|=m.FileType.SymbolicLink),o}async createResourceLock(i){const s=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let o;for(;o=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await o.wait();const a=new D.Barrier;return this.resourceLocks.set(i,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,p.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),a.open()})}async readFile(i,s){let o;try{s?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const a=this.toFilePath(i);return await u.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{o?.dispose()}}readFileStream(i,s,o){const a=(0,g.newWriteableStream)(c=>M.VSBuffer.concat(c.map(d=>M.VSBuffer.wrap(d))).buffer);return(0,E.readFileIntoStream)(this,i,a,c=>c.buffer,{...s,bufferSize:256*1024},o),a}async writeFile(i,s,o){let a;try{const c=this.toFilePath(i);if(!o.create||!o.overwrite){if(await u.Promises.exists(c)){if(!o.overwrite)throw(0,m.createFileSystemProviderError)((0,b.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,m.createFileSystemProviderError)((0,b.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(a,0,s,0,s.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(i,c)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){r.canFlush=i}async open(i,s){const o=this.toFilePath(i);let a;(0,m.isFileOpenForWriteOptions)(s)&&(a=await this.createResourceLock(i));let c;try{if((0,m.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:P}=await u.SymlinkSupport.stat(o);P.mode&128||await u.Promises.chmod(o,P.mode|128)}catch(P){this.logService.trace(P)}let d;if((0,m.isFileOpenForWriteOptions)(s)){if(k.isWindows)try{await u.Promises.truncate(o,0),d="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}d||(d="w")}else d="r";c=await u.Promises.open(o,d)}catch(d){throw a?.dispose(),(0,m.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(i,d):this.toFileSystemProviderError(d)}if(this.mapHandleToPos.set(c,0),(0,m.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(c,i),a){const d=this.mapHandleToLock.get(c);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${o})`),this.mapHandleToLock.set(c,a),d&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${o})`),d.dispose())}return c}async close(i){const s=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&r.canFlush)try{await u.Promises.fdatasync(i)}catch(o){r.configureFlushOnWrite(!1),this.logService.error(o)}return await u.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{s&&(this.mapHandleToLock.get(i)===s&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,o,a,c){const d=this.normalizePos(i,s);let P=null;try{P=(await u.Promises.read(i,o,a,c,d)).bytesRead}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(i,d,P)}return P}normalizePos(i,s){return s===this.mapHandleToPos.get(i)?null:s}updatePos(i,s,o){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof s=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,a+o):this.mapHandleToPos.delete(i)))}async write(i,s,o,a,c){return(0,D.retry)(()=>this.doWrite(i,s,o,a,c),100,3)}async doWrite(i,s,o,a,c){const d=this.normalizePos(i,s);let P=null;try{P=(await u.Promises.write(i,o,a,c,d)).bytesWritten}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),L)}finally{this.updatePos(i,d,P)}return P}async mkdir(i){try{await u.Promises.mkdir(this.toFilePath(i))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(i,s){try{const o=this.toFilePath(i);s.recursive?await u.Promises.rm(o,u.RimRafMode.MOVE):await u.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,s,o){const a=this.toFilePath(i),c=this.toFilePath(s);if(a!==c)try{await this.validateTargetDeleted(i,s,"move",o.overwrite),await u.Promises.move(a,c)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,b.localize)(2,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(c)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(i,s,o){const a=this.toFilePath(i),c=this.toFilePath(s);if(a!==c)try{await this.validateTargetDeleted(i,s,"copy",o.overwrite),await u.Promises.copy(a,c,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,b.localize)(3,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(c)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(i,s,o,a){const c=this.toFilePath(i),d=this.toFilePath(s);let P=!1;if(!!(this.capabilities&1024)||(P=(0,f.isEqual)(c,d,!0)),P&&o==="copy")throw(0,m.createFileSystemProviderError)((0,b.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(!P&&await u.Promises.exists(d)){if(!a)throw(0,m.createFileSystemProviderError)((0,b.localize)(5,null),m.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(i,s){return this.doCloneFile(i,s,!1)}async doCloneFile(i,s,o){const a=this.toFilePath(i),c=this.toFilePath(s),d=!!(this.capabilities&1024);if((0,f.isEqual)(a,c,!d))return;const P=new p.DisposableStore;try{const[L,T]=await Promise.all([this.createResourceLock(i),this.createResourceLock(s)]);P.add(L),P.add(T),o&&await u.Promises.mkdir((0,C.dirname)(c),{recursive:!0}),await u.Promises.copyFile(a,c)}catch(L){if(L.code==="ENOENT"&&!o)return this.doCloneFile(i,s,!0);throw this.toFileSystemProviderError(L)}finally{P.dispose()}}createUniversalWatcher(i,s,o){return new h.UniversalWatcherClient(a=>i(a),a=>s(a),o)}createNonRecursiveWatcher(i,s,o){return new l.NodeJSWatcherClient(a=>i(a),a=>s(a),o)}toFileSystemProviderError(i){if(i instanceof m.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=m.FileSystemProviderErrorCode.NoPermissions;break;default:s=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(i,s)}async toFileSystemProviderWriteError(i,s){let o=this.toFileSystemProviderError(s);if(i&&o.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await u.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(o=(0,m.createFileSystemProviderError)(s,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return o}}e.DiskFileSystemProvider=r,r.canFlush=!0}),define(X[195],J([0,1,3,85,2,17,55,21]),function(z,e,S,t,D,R,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class f extends D.Disposable{constructor(k,y){super();this.provider=k,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(k,y,g){const u=this.getUriTransformer(k);switch(y){case"stat":return this.stat(u,g[0]);case"readdir":return this.readdir(u,g[0]);case"open":return this.open(u,g[0],g[1]);case"close":return this.close(g[0]);case"read":return this.read(g[0],g[1],g[2]);case"readFile":return this.readFile(u,g[0],g[1]);case"write":return this.write(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.writeFile(u,g[0],g[1],g[2]);case"rename":return this.rename(u,g[0],g[1],g[2]);case"copy":return this.copy(u,g[0],g[1],g[2]);case"cloneFile":return this.cloneFile(u,g[0],g[1]);case"mkdir":return this.mkdir(u,g[0]);case"delete":return this.delete(u,g[0],g[1]);case"watch":return this.watch(u,g[0],g[1],g[2],g[3]);case"unwatch":return this.unwatch(g[0],g[1])}throw new Error(`IPC Command ${y} not found`)}listen(k,y,g){const u=this.getUriTransformer(k);switch(y){case"fileChange":return this.onFileChange(u,g[0]);case"readFileStream":return this.onReadFileStream(u,g[0],g[1])}throw new Error(`Unknown event ${y}`)}stat(k,y){const g=this.transformIncoming(k,y,!0);return this.provider.stat(g)}readdir(k,y){const g=this.transformIncoming(k,y);return this.provider.readdir(g)}async readFile(k,y,g){const u=this.transformIncoming(k,y,!0),b=await this.provider.readFile(u,g);return R.VSBuffer.wrap(b)}onReadFileStream(k,y,g){const u=this.transformIncoming(k,y,!0),b=new v.CancellationTokenSource,m=new S.Emitter({onLastListenerRemove:()=>{b.cancel()}}),E=this.provider.readFileStream(u,g,b.token);return(0,M.listenStream)(E,{onData:I=>m.fire(R.VSBuffer.wrap(I)),onError:I=>m.fire(I),onEnd:()=>{m.fire("end"),m.dispose(),b.dispose()}}),m.event}writeFile(k,y,g,u){const b=this.transformIncoming(k,y);return this.provider.writeFile(b,g.buffer,u)}open(k,y,g){const u=this.transformIncoming(k,y,!0);return this.provider.open(u,g)}close(k){return this.provider.close(k)}async read(k,y,g){const u=R.VSBuffer.alloc(g),b=0,m=await this.provider.read(k,y,u.buffer,b,g);return[u,m]}write(k,y,g,u,b){return this.provider.write(k,y,g.buffer,u,b)}mkdir(k,y){const g=this.transformIncoming(k,y);return this.provider.mkdir(g)}delete(k,y,g){const u=this.transformIncoming(k,y);return this.provider.delete(u,g)}rename(k,y,g,u){const b=this.transformIncoming(k,y),m=this.transformIncoming(k,g);return this.provider.rename(b,m,u)}copy(k,y,g,u){const b=this.transformIncoming(k,y),m=this.transformIncoming(k,g);return this.provider.copy(b,m,u)}cloneFile(k,y,g){const u=this.transformIncoming(k,y),b=this.transformIncoming(k,g);return this.provider.cloneFile(u,b)}onFileChange(k,y){const g=new S.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(k,g))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return g.event}async watch(k,y,g,u,b){const m=this.sessionToWatcher.get(y);if(m){const E=this.transformIncoming(k,u),I=m.watch(g,E,b);this.watchRequests.set(y+g,I)}}async unwatch(k,y){const g=k+y,u=this.watchRequests.get(g);u&&((0,D.dispose)(u),this.watchRequests.delete(g))}dispose(){super.dispose();for(const[,k]of this.watchRequests)k.dispose();this.watchRequests.clear();for(const[,k]of this.sessionToWatcher)k.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=f;class p extends D.Disposable{constructor(k,y,g,u){super();this.uriTransformer=k,this.logService=g,this.environmentService=u,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(y)}registerListeners(k){const y=this._register(new S.Emitter);this._register(y.event(g=>{k.fire(g.map(u=>({resource:this.uriTransformer.transformOutgoingURI(u.resource),type:u.type})))})),this._register(this.fileWatcher.onDidChangeFile(g=>y.fire(g))),this._register(this.fileWatcher.onDidWatchError(g=>k.fire(g)))}getRecursiveWatcherOptions(k){}getExtraExcludes(k){}watch(k,y,g){const u=this.getExtraExcludes(this.environmentService);return Array.isArray(u)&&(g.excludes=[...g.excludes,...u]),this.watcherRequests.set(k,this.fileWatcher.watch(y,g)),(0,D.toDisposable)(()=>{(0,D.dispose)(this.watcherRequests.get(k)),this.watcherRequests.delete(k)})}dispose(){super.dispose();for(const[,k]of this.watcherRequests)k.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=p}),define(X[196],J([0,1,14,156,4,7,15,9,195,137]),function(z,e,S,t,D,R,M,v,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class C extends f.AbstractDiskFileSystemProviderChannel{constructor(g,u,b){super(g,u);this.environmentService=b}getUriTransformer(g){return p.DefaultURITransformer}transformIncoming(g,u){return R.URI.revive(u)}async delete(g,u,b){if(!b.useTrash)return super.delete(g,u,b);const m=this.transformIncoming(g,u),E=(0,v.normalize)(m.fsPath);try{await S.shell.trashItem(E)}catch{throw(0,M.createFileSystemProviderError)(D.isWindows?(0,t.localize)(0,null,(0,v.basename)(E)):(0,t.localize)(1,null,(0,v.basename)(E)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(g,u){return new k(g,u,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=C;class k extends f.AbstractSessionFileWatcher{watch(g,u,b){if(b.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(g,u,b)}}}),define(X[103],J([0,1,6]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,M){switch(M){case S.LogLevel.Trace:return R.trace;case S.LogLevel.Debug:return R.debug;case S.LogLevel.Info:return R.info;case S.LogLevel.Warning:return R.warn;case S.LogLevel.Error:return R.error;case S.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class D extends S.AbstractLogger{constructor(M=S.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(v=>{this._logger?.setLevel(v)}))}set logger(M){this._logger=M;for(const{level:v,args:f}of this.buffer)t(M,v).apply(M,f);this.buffer=[]}_log(M,...v){this._logger?t(this._logger,M).apply(this._logger,v):this.getLevel()<=M&&this.buffer.push({level:M,args:v})}trace(M,...v){this._log(S.LogLevel.Trace,M,...v)}debug(M,...v){this._log(S.LogLevel.Debug,M,...v)}info(M,...v){this._log(S.LogLevel.Info,M,...v)}warn(M,...v){this._log(S.LogLevel.Warning,M,...v)}error(M,...v){this._log(S.LogLevel.Error,M,...v)}critical(M,...v){this._log(S.LogLevel.Critical,M,...v)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(X[197],J([0,1,8,17,16,15,5,103,6]),function(z,e,S,t,D,R,M,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const p=5*R.ByteSize.MB;let C=class extends f.AbstractLogger{constructor(g,u,b,m,E){super();this.name=g,this.resource=u,this.donotUseFormatters=m,this.fileService=E,this.backupIndex=1,this.setLevel(b),this.queue=this._register(new S.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,(0,f.format)(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,(0,f.format)(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,(0,f.format)(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,(0,f.format)(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const g=arguments[0];if(g instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=g.stack,this._log(f.LogLevel.Error,(0,f.format)(u))}else this._log(f.LogLevel.Error,(0,f.format)(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,(0,f.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(g){if(g.fileOperationResult!==3)throw g}}_log(g,u){this.queue.queue(async()=>{await this.initializePromise;let b=await this.loadContent();b.length>p&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(b)),b=""),this.donotUseFormatters?b+=u:b+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(g)}] ${u}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(b))})}getCurrentTimestamp(){const g=m=>m<10?`0${m}`:m,u=m=>m<10?`00${m}`:m<100?`0${m}`:m,b=new Date;return`${b.getFullYear()}-${g(b.getMonth()+1)}-${g(b.getDate())} ${g(b.getHours())}:${g(b.getMinutes())}:${g(b.getSeconds())}.${u(b.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(g){switch(g){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}};C=fe([x(4,R.IFileService)],C),e.FileLogger=C;let k=class extends f.AbstractLoggerService{constructor(g,u,b){super(g.getLevel(),g.onDidChangeLogLevel);this.instantiationService=u,this.fileService=b}doCreateLogger(g,u,b){const m=new v.BufferLogService(u);return(0,R.whenProviderRegistered)(g,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(C,b?.name||(0,D.basename)(g),g,m.getLevel(),!!b?.donotUseFormatters)),m}};k=fe([x(0,f.ILogService),x(1,M.IInstantiationService),x(2,R.IFileService)],k),e.FileLoggerService=k}),define(X[198],J([0,1,3,7,6]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(y){this.service=y,this.onDidChangeLogLevel=S.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(y,g,u){switch(g){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=R;class M{constructor(y){this.channel=y}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(y){M.setLevel(this.channel,y)}static setLevel(y,g){return y.call("setLevel",g)}}e.LogLevelChannelClient=M;class v{constructor(y){this.loggerService=y,this.loggers=new Map}listen(y,g){throw new Error(`Event not found: ${g}`)}async call(y,g,u){switch(g){case"createLogger":this.createLogger(t.URI.revive(u[0]),u[1]);return;case"log":return this.log(t.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${g}`)}createLogger(y,g){this.loggers.set(y.toString(),this.loggerService.createLogger(y,g))}consoleLog(y,g){let u=console.log;switch(y){case D.LogLevel.Error:u=console.error;break;case D.LogLevel.Warning:u=console.warn;break;case D.LogLevel.Info:u=console.info;break}u.call(console,...g)}log(y,g){const u=this.loggers.get(y.toString());if(!u)throw new Error("Create the logger before logging");for(const[b,m]of g)(0,D.log)(u,b,m)}}e.LoggerChannel=v;class f extends D.AbstractLoggerService{constructor(y,g,u){super(y,g);this.channel=u}createConsoleMainLogger(){return new D.AdapterLogger({log:(y,g)=>{this.channel.call("consoleLog",[y,g])}})}doCreateLogger(y,g,u){return new p(this.channel,y,g,u)}}e.LoggerChannelClient=f;class p extends D.AbstractMessageLogger{constructor(y,g,u,b){super(b?.always);this.channel=y,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[g,b]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,g){const u=[[y,g]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(y){this.channel.call("log",[this.file,y])}}class C extends D.LogService{constructor(y,g){super(g);this.parent=y,this._register(y.onDidChangeLogLevel(u=>g.setLevel(u)))}setLevel(y){super.setLevel(y),this.parent.setLevel(y)}}e.FollowerLogService=C}),define(X[104],J([0,1,15,6]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(v,f,p,C,k){try{const y=await new Promise((u,b)=>{z(["spdlog"],u,b)});y.setFlushOn(t.LogLevel.Trace);const g=await y.createAsyncRotatingLogger(v,f,p,C);return k&&g.clearFormatters(),g}catch(y){console.error(y)}return null}function R(v,f,p){switch(f){case t.LogLevel.Trace:v.trace(p);break;case t.LogLevel.Debug:v.debug(p);break;case t.LogLevel.Info:v.info(p);break;case t.LogLevel.Warning:v.warn(p);break;case t.LogLevel.Error:v.error(p);break;case t.LogLevel.Critical:v.critical(p);break;default:throw new Error("Invalid log level")}}class M extends t.AbstractMessageLogger{constructor(f,p,C,k,y){super();this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(f,p,C,k),this._register(this.onDidChangeLogLevel(g=>{this._logger?.setLevel(g)}))}async _createSpdLogLogger(f,p,C,k){const y=C?6:1,g=30/y*S.ByteSize.MB,u=await D(f,p,g,y,k);if(u){this._logger=u,this._logger.setLevel(this.getLevel());for(const{level:b,message:m}of this.buffer)R(this._logger,b,m);this.buffer=[]}}log(f,p){this._logger?R(this._logger,f,p):this.getLevel()<=f&&this.buffer.push({level:f,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=M}),define(X[199],J([0,1,12,16,27,15,197,6,104]),function(z,e,S,t,D,R,M,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let p=class extends v.AbstractLoggerService{constructor(k,y){super(k.getLevel(),k.onDidChangeLogLevel);this.fileService=y}doCreateLogger(k,y,g){return k.scheme===S.Schemas.file?new f.SpdLogLogger(g?.name||(0,D.generateUuid)(),k.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,y):new M.FileLogger(g?.name??(0,t.basename)(k),k,y,!!g?.donotUseFormatters,this.fileService)}};p=fe([x(0,v.ILogService),x(1,R.IFileService)],p),e.LoggerService=p}),define(X[200],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function S(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=S;function t(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function D(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function R(M){return!S(M)&&!t(M)&&!D(M)}e.isMenubarMenuItemAction=R}),define(X[37],J([0,1,3,54,2,5]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class M extends D.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(p){const C=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...p,...this.policyDefinitions},C!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(p),t.Iterable.reduce(this.policies.entries(),(k,[y,g])=>({...k,[y]:g}),{})}getPolicyValue(p){return this.policies.get(p)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(p,[C,k])=>({...p,[C]:{definition:k,value:this.policies.get(C)}}),{})}}e.AbstractPolicyService=M;class v{constructor(){this.onDidChange=S.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=v}),define(X[201],J([0,1,8,3,54,13,15,6,37]),function(z,e,S,t,D,R,M,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function p(k,y){const g=[];for(const u of D.Iterable.concat(k.keys(),y.keys()))k.get(u)!==y.get(u)&&g.push(u);return g}let C=class extends f.AbstractPolicyService{constructor(y,g,u){super();this.file=y,this.fileService=g,this.logService=u,this.throttledDelayer=this._register(new S.ThrottledDelayer(500));const b=t.Event.filter(g.onDidFilesChange,m=>m.affects(y));this._register(g.watch(y)),this._register(b(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(y){await this.refresh()}async read(){const y=new Map;try{const g=await this.fileService.readFile(this.file),u=JSON.parse(g.value.toString());if(!(0,R.isObject)(u))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(u))this.policyDefinitions[b]&&y.set(b,u[b])}catch(g){g.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",g)}return y}async refresh(){const y=await this.read(),g=p(this.policies,y);this.policies=y,g.length>0&&this._onDidChange.fire(g)}};C=fe([x(1,M.IFileService),x(2,v.ILogService)],C),e.FilePolicyService=C}),define(X[202],J([0,1,3,2,37]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(f){this.service=f,this.disposables=new t.DisposableStore}listen(f,p){switch(p){case"onDidChange":return S.Event.map(this.service.onDidChange,C=>C.reduce((k,y)=>({...k,[y]:this.service.getPolicyValue(y)??null}),{}),this.disposables)}throw new Error(`Event not found: ${p}`)}call(f,p,C){switch(p){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(C)}throw new Error(`Call not found: ${p}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class M extends D.AbstractPolicyService{constructor(f,p){super();this.channel=p;for(const C in f){const{definition:k,value:y}=f[C];this.policyDefinitions[C]=k,y!==void 0&&this.policies.set(C,y)}this.channel.listen("onDidChange")(C=>{for(const k in C){const y=C[k];y===null?this.policies.delete(k):this.policies.set(k,y)}this._onDidChange.fire(Object.keys(C))})}async initializePolicies(f){const p=await this.channel.call("registerPolicyDefinitions",f);for(const C in p)this.policies.set(C,p[C])}}e.PolicyChannelClient=M}),define(X[58],J([0,1,12,4,36,16]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const v=t.globals.vscode.context.configuration();if(v)M=v.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof z?.__$__nodeRequire=="function"){const v=(0,R.dirname)(S.FileAccess.asFileUri("",z));M=z.__$__nodeRequire((0,R.joinPath)(v,"product.json").fsPath);const f=z.__$__nodeRequire((0,R.joinPath)(v,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),Object.assign(M,{version:f.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(X[20],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(X[203],J([0,1,75,6,20]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(v,f){this.productService=v,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(v,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const p=/^(.*)#([^#]+)$/.exec(f);if(!p)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,C,k]=p;let y=this.trustedExtensionUrlPublicKeys.get(v);if(!y){if(y=this.productService.trustedExtensionUrlPublicKeys[v],!y||y.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",v),!1;this.trustedExtensionUrlPublicKeys.set(v,[...y])}const g=Buffer.from(decodeURIComponent(k),"base64");if(g.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const u=g.slice(0,6),b=g.readUIntBE(0,6),m=Date.now()-b;if(m<0||m>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const E=g.slice(6),I=S.createVerify("SHA256");I.write(u),I.write(Buffer.from(C)),I.end();for(let w=0;w<y.length;w++){let h=y[w];if(h!==null){if(typeof h=="string")try{h=S.createPublicKey({key:Buffer.from(h,"base64"),format:"der",type:"spki"}),y[w]=h}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${w+1} for ${v}:`,l),y[w]=null;continue}if(I.verify(h,E))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};R=fe([x(0,D.IProductService),x(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(X[59],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,S.createDecorator)("protocolMainService")}),define(X[44],J([0,1,116,13]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(M,v){S.ok(t.isString(M)),S.ok(t.isObject(v)),S.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,v)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new D}),define(X[204],J([0,1,3,44]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class R{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,p){this.schemasById[D(f)]=p,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new R;t.Registry.add(e.Extensions.JSONContribution,M)}),define(X[60],J([0,1,25,3,13,147,18,204,44]),function(z,e,S,t,D,R,M,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var p;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(p=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=f.Registry.as(v.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,n=!0){this.registerConfigurations([r],n)}registerConfigurations(r,n=!0){const i=this.doRegisterConfigurations(r,n);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(r){const n=this.doDeregisterConfigurations(r);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:r,remove:n}){const i=[];i.push(...this.doDeregisterConfigurations(n)),i.push(...this.doRegisterConfigurations(r,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,S.distinct)(i)})}registerDefaultConfigurations(r){const n=[],i=[];for(const{overrides:s,source:o}of r)for(const a in s)if(n.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const c=this.configurationDefaultsOverrides.get(a),d=c?.valuesSources??new Map;if(o)for(const W of Object.keys(s[a]))d.set(W,o);const P={...c?.value||{},...s[a]};this.configurationDefaultsOverrides.set(a,{source:o,value:P,valuesSources:d});const L=(0,M.getLanguageTagSettingPlainKey)(a),T={type:"object",default:P,description:R.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:P,source:D.isString(o)?void 0:o,defaultValueSource:o};i.push(...b(a)),this.configurationProperties[a]=T,this.defaultLanguageConfigurationOverridesNode.properties[a]=T}else{this.configurationDefaultsOverrides.set(a,{value:s[a],source:o});const c=this.configurationProperties[a];c&&(this.updatePropertyDefaultValue(a,c),this.updateSchema(a,c))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const n=[];for(const{overrides:i,source:s}of r)for(const o in i){const a=this.configurationDefaultsOverrides.get(o),c=D.isString(s)?s:s?.id,d=D.isString(a?.source)?a?.source:a?.source?.id;if(c===d)if(n.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const P=this.configurationProperties[o];P&&(this.updatePropertyDefaultValue(o,P),this.updateSchema(o,P))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const n of r)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,n){const i=[];return r.forEach(s=>{i.push(...this.validateAndRegisterProperties(s,n,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),i}doDeregisterConfigurations(r){const n=[],i=s=>{if(s.properties)for(const o in s.properties){n.push(o);const a=this.configurationProperties[o];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,s.properties[o])}s.allOf?.forEach(o=>i(o))};for(const s of r){i(s);const o=this.configurationContributors.indexOf(s);o!==-1&&this.configurationContributors.splice(o,1)}return n}validateAndRegisterProperties(r,n=!0,i,s,o=3){o=D.isUndefinedOrNull(r.scope)?o:r.scope;const a=[],c=r.properties;if(c)for(const P in c){const L=c[P];if(n&&w(P,L)){delete c[P];continue}if(L.source=i,L.defaultDefaultValue=c[P].default,this.updatePropertyDefaultValue(P,L),e.OVERRIDE_PROPERTY_REGEX.test(P)?L.scope=void 0:(L.scope=D.isUndefinedOrNull(L.scope)?o:L.scope,L.restricted=D.isUndefinedOrNull(L.restricted)?!!s?.includes(P):L.restricted),c[P].hasOwnProperty("included")&&!c[P].included){this.excludedConfigurationProperties[P]=c[P],delete c[P];continue}else this.configurationProperties[P]=c[P],c[P].policy?.name&&this.policyConfigurations.set(c[P].policy.name,P);!c[P].deprecationMessage&&c[P].markdownDeprecationMessage&&(c[P].deprecationMessage=c[P].markdownDeprecationMessage),a.push(P)}const d=r.allOf;if(d)for(const P of d)a.push(...this.validateAndRegisterProperties(P,n,i,s,o));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const n=i=>{const s=i.properties;if(s)for(const a in s)this.updateSchema(a,s[a]);i.allOf?.forEach(n)};n(r)}updateSchema(r,n){switch(e.allSettings.properties[r]=n,n.scope){case 1:e.applicationSettings.properties[r]=n;break;case 2:e.machineSettings.properties[r]=n;break;case 6:e.machineOverridableSettings.properties[r]=n;break;case 3:e.windowSettings.properties[r]=n;break;case 4:e.resourceSettings.properties[r]=n;break;case 5:e.resourceSettings.properties[r]=n,this.resourceLanguageSettingsSchema.properties[r]=n;break}}removeFromSchema(r,n){switch(delete e.allSettings.properties[r],n.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const n=`[${r}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,i),e.allSettings.properties[n]=i,e.applicationSettings.properties[n]=i,e.machineSettings.properties[n]=i,e.machineOverridableSettings.properties[n]=i,e.windowSettings.properties[n]=i,e.resourceSettings.properties[n]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,n){const i=this.configurationDefaultsOverrides.get(r);let s=i?.value,o=i?.source;D.isUndefined(s)&&(s=n.defaultDefaultValue,o=void 0),D.isUndefined(s)&&(s=E(n.type)),n.default=s,n.defaultValueSource=o}}const g="\\[([^\\]]+)\\]",u=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(l){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let n=u.exec(l);for(;n?.length;){const i=n[1].trim();i&&r.push(i),n=u.exec(l)}}return(0,S.distinct)(r)}e.overrideIdentifiersFromKey=b;function m(l){return l.reduce((r,n)=>`${r}[${n}]`,"")}e.keyFromOverrideIdentifiers=m;function E(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const I=new y;f.Registry.add(e.Extensions.Configuration,I);function w(l,r){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?R.localize(7,null,l):I.getConfigurationProperties()[l]!==void 0?R.localize(8,null,l):r.policy?.name&&I.getPolicyConfigurations().get(r.policy?.name)!==void 0?R.localize(9,null,l,r.policy?.name,I.getPolicyConfigurations().get(r.policy?.name)):null:R.localize(6,null)}e.validateProperty=w;function h(){const l=[],r=I.getConfigurationProperties();for(const n of Object.keys(r))l.push([n,r[n].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=h}),define(X[105],J([0,1,25,3,49,2,33,50,13,7,18,60,44]),function(z,e,S,t,D,R,M,v,f,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class g{constructor(n={},i=[],s=[]){this._contents=n,this._keys=i,this._overrides=s,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,C.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,i){const s=this.getContentsForOverrideIdentifer(i);return s?n?(0,C.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const s of this.overrides)s.identifiers.includes(n)&&i.push(...s.keys);return S.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return S.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=v.deepClone(this.contents),s=v.deepClone(this.overrides),o=[...this.keys];for(const a of n)if(!a.isEmpty()){this.mergeContents(i,a.contents);for(const c of a.overrides){const[d]=s.filter(P=>S.equals(P.identifiers,c.identifiers));d?(this.mergeContents(d.contents,c.contents),d.keys.push(...c.keys),d.keys=S.distinct(d.keys)):s.push(v.deepClone(c))}for(const c of a.keys)o.indexOf(c)===-1&&o.push(c)}return new g(i,o,s)}freeze(){return this.frozen=!0,this}clone(){return new g(v.deepClone(this.contents),[...this.keys],v.deepClone(this.overrides))}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const o of S.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[o];const c=i[o];c&&(typeof a=="object"&&typeof c=="object"?(a=v.deepClone(a),this.mergeContents(a,c)):a=c),s[o]=a}return new g(s,this.keys,this.overrides)}mergeContents(n,i){for(const s of Object.keys(i)){if(s in n&&f.isObject(n[s])&&f.isObject(i[s])){this.mergeContents(n[s],i[s]);continue}n[s]=v.deepClone(i[s])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?v.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let i=null,s=null;const o=a=>{a&&(s?this.mergeContents(s,a):s=v.deepClone(a))};for(const a of this.overrides)S.equals(a.identifiers,[n])?i=a.contents:a.identifiers.includes(n)&&o(a.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,i){this.addKey(n),(0,C.addToValueTree)(this.contents,n,i,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,C.removeFromValueTree)(this.contents,n)}addKey(n){let i=this.keys.length;for(let s=0;s<i;s++)n.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,n)}removeKey(n){const i=this.keys.indexOf(n);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class u{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!f.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:s,keys:o,overrides:a,restricted:c}=this.doParseRaw(n,i);this._configurationModel=new g(s,o,a),this._restrictedConfigurations=c||[]}doParseContent(n){let i={},s=null,o=[];const a=[],c=[];function d(L){Array.isArray(o)?o.push(L):s!==null&&(o[s]=L)}const P={onObjectBegin:()=>{const L={};d(L),a.push(o),o=L,s=null},onObjectProperty:L=>{s=L},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const L=[];d(L),a.push(o),o=L,s=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:d,onError:(L,T,W)=>{c.push({error:L,offset:T,length:W})}};if(n)try{D.visit(n,P),i=o[0]||{}}catch(L){console.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return i}doParseRaw(n,i){const s=y.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,s,!0,i);n=o.raw;const a=(0,C.toValuesTree)(n,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),c=Object.keys(n),d=this.toOverrides(n,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:a,keys:c,overrides:d,restricted:o.restricted}}filter(n,i,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[]};const a={},c=[];for(const d in n)if(k.OVERRIDE_PROPERTY_REGEX.test(d)&&s){const P=this.filter(n[d],i,!1,o);a[d]=P.raw,c.push(...P.restricted)}else{const P=i[d],L=P?typeof P.scope!="undefined"?P.scope:3:void 0;P?.restricted&&c.push(d),(L===void 0||o.scopes===void 0||o.scopes.includes(L))&&(o.skipRestricted&&P?.restricted||(a[d]=n[d]))}return{raw:a,restricted:c}}toOverrides(n,i){const s=[];for(const o of Object.keys(n))if(k.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const c in n[o])a[c]=n[o][c];s.push({identifiers:(0,k.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,C.toValuesTree)(a,i)})}return s}}e.ConfigurationModelParser=u;class b extends R.Disposable{constructor(n,i,s,o){super();this.userSettingsResource=n,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&s.isEqual(a.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class m{constructor(n,i,s,o,a=new g,c=new g,d=new M.ResourceMap,P=new g,L=new M.ResourceMap,T=!0){this._defaultConfiguration=n,this._policyConfiguration=i,this._applicationConfiguration=s,this._localUserConfiguration=o,this._remoteUserConfiguration=a,this._workspaceConfiguration=c,this._folderConfigurations=d,this._memoryConfiguration=P,this._memoryConfigurationByResource=L,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(n,i,s){return this.getConsolidatedConfigurationModel(n,i,s).getValue(n)}updateValue(n,i,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new g,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(n):o.setValue(n,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,s){const o=this.getConsolidatedConfigurationModel(n,i,s),a=this.getFolderConfigurationModelForResource(i.resource,s),c=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,d=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),P=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),L=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),T=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),W=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),q=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),ee=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,se=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(n):a.freeze().getValue(n):void 0,ae=i.overrideIdentifier?c.override(i.overrideIdentifier).getValue(n):c.getValue(n),te=o.getValue(n),ce=S.distinct(o.overrides.map(H=>H.identifiers).flat()).filter(H=>o.getOverrideValue(n,H)!==void 0);return{defaultValue:d,policyValue:P,applicationValue:L,userValue:T,userLocalValue:W,userRemoteValue:q,workspaceValue:ee,workspaceFolderValue:se,memoryValue:ae,value:te,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,policy:P!==void 0?{value:P}:void 0,application:L!==void 0?{value:L,override:i.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userRemote:q!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspace:ee!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspaceFolder:se!==void 0?{value:a?.freeze().getValue(n),override:i.overrideIdentifier?a?.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,memory:ae!==void 0?{value:c.getValue(n),override:i.overrideIdentifier?c.getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ce.length?ce:void 0}}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const s=[];if(!i){const{added:o,updated:a,removed:c}=h(this._defaultConfiguration,n);i=[...o,...a,...c]}for(const o of i)for(const a of(0,k.overrideIdentifiersFromKey)(o)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(a),d=n.getKeysForOverrideIdentifier(a),P=[...d.filter(L=>c.indexOf(L)===-1),...c.filter(L=>d.indexOf(L)===-1),...c.filter(L=>!v.equals(this._defaultConfiguration.override(a).getValue(L),n.override(a).getValue(L)))];s.push([a,P])}return this.updateDefaultConfiguration(n),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:s,removed:o}=h(this._policyConfiguration,n),a=[...i,...s,...o];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:s,removed:o,overrides:a}=h(this.applicationConfiguration,n),c=[...i,...s,...o];return c.length&&this.updateApplicationConfiguration(n),{keys:c,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:s,removed:o,overrides:a}=h(this.localUserConfiguration,n),c=[...i,...s,...o];return c.length&&this.updateLocalUserConfiguration(n),{keys:c,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:s,removed:o,overrides:a}=h(this.remoteUserConfiguration,n),c=[...i,...s,...o];return c.length&&this.updateRemoteUserConfiguration(n),{keys:c,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:s,removed:o,overrides:a}=h(this.workspaceConfiguration,n),c=[...i,...s,...o];return c.length&&this.updateWorkspaceConfiguration(n),{keys:c,overrides:a}}compareAndUpdateFolderConfiguration(n,i){const s=this.folderConfigurations.get(n),{added:o,updated:a,removed:c,overrides:d}=h(s,i),P=[...o,...a,...c];return(P.length||!s)&&this.updateFolderConfiguration(n,i),{keys:P,overrides:d}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:o,removed:a,overrides:c}=h(i,void 0);return{keys:[...s,...o,...a],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,i,s){let o=this.getConsolidatedConfigurationModelForResource(i,s);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:n},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const o=i.getFolder(n);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const a=this._memoryConfigurationByResource.get(n);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(i=s.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(n,i)):i=s}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const s=i.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:s,overrides:o,keys:a}=this._folderConfigurations.get(i);return n.push([i,{contents:s,overrides:o,keys:a}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>n.add(i)),this.userConfiguration.freeze().keys.forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.policy),o=this.parseConfigurationModel(n.application),a=this.parseConfigurationModel(n.user),c=this.parseConfigurationModel(n.workspace),d=n.folders.reduce((P,L)=>(P.set(p.URI.revive(L[0]),this.parseConfigurationModel(L[1])),P),new M.ResourceMap);return new m(i,s,o,a,new g,c,d,new g,new M.ResourceMap,!1)}static parseConfigurationModel(n){return new g(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=m;function E(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const n=new Set,i=new Map;for(const o of r)o.keys.forEach(a=>n.add(a)),o.overrides.forEach(([a,c])=>{const d=(0,M.getOrSet)(i,a,new Set);c.forEach(P=>d.add(P))});const s=[];return i.forEach((o,a)=>s.push([a,[...o.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=E;class I{constructor(n,i,s,o){this.change=n,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;n.keys.forEach(d=>a.add(d)),n.overrides.forEach(([,d])=>d.forEach(P=>a.add(P))),this.affectedKeys=[...a.values()];const c=new g;this.affectedKeys.forEach(d=>c.setValue(d,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!v.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(n,i){let s=(0,C.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(n=n[o],!n)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=I;class w extends I{constructor(n,i,s,o){super({keys:n.allKeys(),overrides:[]},void 0,n,i);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=w;function h(r,n){const{added:i,removed:s,updated:o}=l(n,r),a=[],c=r?.getAllOverrideIdentifiers()||[],d=n?.getAllOverrideIdentifiers()||[];if(n){const P=d.filter(L=>!c.includes(L));for(const L of P)a.push([L,n.getKeysForOverrideIdentifier(L)])}if(r){const P=c.filter(L=>!d.includes(L));for(const L of P)a.push([L,r.getKeysForOverrideIdentifier(L)])}if(n&&r){for(const P of c)if(d.includes(P)){const L=l({contents:r.getOverrideValue(void 0,P)||{},keys:r.getKeysForOverrideIdentifier(P)},{contents:n.getOverrideValue(void 0,P)||{},keys:n.getKeysForOverrideIdentifier(P)});a.push([P,[...L.added,...L.removed,...L.updated]])}}return{added:i,removed:s,updated:o,overrides:a}}function l(r,n){const i=r?n?r.keys.filter(a=>n.keys.indexOf(a)===-1):[...r.keys]:[],s=n?r?n.keys.filter(a=>r.keys.indexOf(a)===-1):[...n.keys]:[],o=[];if(r&&n){for(const a of n.keys)if(r.keys.indexOf(a)!==-1){const c=(0,C.getConfigurationValue)(n.contents,a),d=(0,C.getConfigurationValue)(r.contents,a);v.equals(c,d)||o.push(a)}}return{added:i,removed:s,updated:o}}}),define(X[205],J([0,1,25,3,2,50,13,18,105,60,6,37,44]),function(z,e,S,t,D,R,M,v,f,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class g extends D.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new u(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(y.Registry.as(p.Extensions.Configuration).onDidUpdateConfiguration(({properties:I,defaultsOverrides:w})=>this.onDidUpdateConfiguration(I,w))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(I,w){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:I})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=g;class u extends f.ConfigurationModel{constructor(I={}){const w=y.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(w),l=Object.create(null),r=[];for(const n in w){const i=I[n],s=i!==void 0?i:w[n].default;(0,v.addToValueTree)(l,n,s,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(l))p.OVERRIDE_PROPERTY_REGEX.test(n)&&r.push({identifiers:(0,p.overrideIdentifiersFromKey)(n),keys:Object.keys(l[n]),contents:(0,v.toValuesTree)(l[n],i=>console.error(`Conflict in default settings file: ${i}`))});super(l,h,r)}}e.DefaultConfigurationModel=u;class b{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new f.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=b;let m=class extends D.Disposable{constructor(I,w,h){super();this.defaultConfiguration=I,this.policyService=w,this.logService=h,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new f.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(I=>this.onDidChangePolicies(I))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:I})=>this.update(await this.registerPolicyDefinitions(I),!0))),this._configurationModel}async registerPolicyDefinitions(I){const w={},h=[],l=y.Registry.as(p.Extensions.Configuration).getConfigurationProperties();for(const r of I){const n=l[r];if(!n){h.push(r);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}h.push(r),w[n.policy.name]={type:n.type}}}return(0,M.isEmptyObject)(w)||await this.policyService.registerPolicyDefinitions(w),h}onDidChangePolicies(I){const w=y.Registry.as(p.Extensions.Configuration).getPolicyConfigurations(),h=(0,S.coalesce)(I.map(l=>w.get(l)));this.update(h,!0)}update(I,w){const h=y.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),l=[],r=this._configurationModel.isEmpty();for(const n of I){const i=h[n]?.policy?.name;if(i){const s=this.policyService.getPolicyValue(i);(r?s!==void 0:!(0,R.equals)(this._configurationModel.getValue(n),s))&&l.push([n,s])}else this._configurationModel.getValue(n)!==void 0&&l.push([n,void 0])}if(l.length){const n=this._configurationModel;this._configurationModel=new f.ConfigurationModel;for(const i of n.keys)this._configurationModel.setValue(i,n.getValue(i));for(const[i,s]of l)s===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,s);w&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};m=fe([x(1,k.IPolicyService),x(2,C.ILogService)],m),e.PolicyConfiguration=m}),define(X[206],J([0,1,8,3,2,16,18,105,205,37]),function(z,e,S,t,D,R,M,v,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends D.Disposable{constructor(y,g,u,b){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new f.DefaultConfiguration),this.policyConfiguration=u instanceof p.NullPolicyService?new f.NullPolicyConfiguration:this._register(new f.PolicyConfiguration(this.defaultConfiguration,u,b)),this.userConfiguration=this._register(new v.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,g)),this.configuration=new v.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new v.ConfigurationModel,new v.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:m,properties:E})=>this.onDidDefaultConfigurationChange(m,E))),this._register(this.policyConfiguration.onDidChangeConfiguration(m=>this.onDidPolicyConfigurationChange(m))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[y,g,u]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new v.Configuration(y,g,new v.ConfigurationModel,u)}getConfigurationData(){return this.configuration.toData()}getValue(y,g){const u=typeof y=="string"?y:void 0,b=(0,M.isConfigurationOverrides)(y)?y:(0,M.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(u,b,void 0)}updateValue(y,g,u,b){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const g=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(u,g,2)}onDidDefaultConfigurationChange(y,g){const u=this.configuration.toData(),b=this.configuration.compareAndUpdateDefaultConfiguration(y,g);this.trigger(b,u,7)}onDidPolicyConfigurationChange(y){const g=this.configuration.toData(),u=this.configuration.compareAndUpdatePolicyConfiguration(y);this.trigger(u,g,7)}trigger(y,g,u){const b=new v.ConfigurationChangeEvent(y,{data:g},this.configuration);b.source=u,b.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(b)}getTargetConfiguration(y){switch(y){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(X[207],J([0,1,19,5]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends S.ErrorNoTelemetry{constructor(v,f=D.Unknown,p){super(v);this._message=v,this._code=f,this._detail=p,this.isHandled=f===D.NotAvailable&&p===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(v){return v instanceof R&&v._code===D.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof R&&v._code===D.NoResolverFound}static isHandled(v){return v instanceof R&&v.isHandled}}e.RemoteAuthorityResolverError=R}),define(X[71],J([0,1,12]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(p){return p.scheme===S.Schemas.vscodeRemote?p.authority:void 0}e.getRemoteAuthority=t;function D(p){if(!p)return;const C=p.indexOf("+");return C<0?p:p.substr(0,C)}e.getRemoteName=D;function R(p){return`/${p.quality??"oss"}-${p.commit??"dev"}`}e.getRemoteServerRootPath=R;function M(p){const{host:C,port:k}=f(p);if(typeof k=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:k}}e.parseAuthorityWithPort=M;function v(p,C){let{host:k,port:y}=f(p);return typeof y=="undefined"&&(y=C),{host:k,port:y}}e.parseAuthorityWithOptionalPort=v;function f(p){const C=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const k=p.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const y=p.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:p,port:void 0}}}),define(X[208],J([0,1,8,17,21,19,3,2,27,95,207,71]),function(z,e,S,t,D,R,M,v,f,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var g;(function(V){V[V.Management=1]="Management",V[V.ExtensionHost=2]="ExtensionHost",V[V.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function u(V){switch(V){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function b(V){const Q=new D.CancellationTokenSource;return setTimeout(()=>Q.cancel(),V),Q.token}function m(V,Q){if(V.isCancellationRequested||Q.isCancellationRequested)return D.CancellationToken.Cancelled;const A=new D.CancellationTokenSource;return V.onCancellationRequested(()=>A.cancel()),Q.onCancellationRequested(()=>A.cancel()),A.token}class E{constructor(Q){this._state="pending",this._disposables=new v.DisposableStore,this.promise=new Promise((A,O)=>{this._resolvePromise=A,this._rejectPromise=O}),Q.isCancellationRequested?this._timeout():this._disposables.add(Q.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Q){this._state==="pending"?this._disposables.add(Q):Q.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Q))}reject(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Q))}}function I(V,Q){const A=new E(Q);return A.registerDisposable(V.onControlMessage(O=>{const N=JSON.parse(O.toString()),$=F(N);$?A.reject($):A.resolve(N)})),A.promise}function w(V,Q,A,O,N,$,Y,U){const j=new E(U);return Q.connect(A,O,N,$,Y,(Z,re)=>{j.didTimeout?(Z&&V.error(Z),re?.dispose()):Z||!re?j.reject(Z):j.resolve(re)}),j.promise}function h(V,Q){const A=new E(Q);return V.then(O=>{A.didTimeout||A.resolve(O)},O=>{A.didTimeout||A.reject(O)}),A.promise}async function l(V,Q,A,O){const N=G(V,Q);V.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let $;try{$=await w(V.logService,V.socketFactory,V.host,V.port,(0,k.getRemoteServerRootPath)(V),`reconnectionToken=${V.reconnectionToken}&reconnection=${V.reconnectionProtocol?"true":"false"}`,`renderer-${u(Q)}-${V.reconnectionToken}`,O)}catch(re){throw V.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),V.logService.error(re),re}V.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let Y,U;V.reconnectionProtocol?(V.reconnectionProtocol.beginAcceptReconnection($,null),Y=V.reconnectionProtocol,U=!1):(Y=new p.PersistentProtocol($,null),U=!0),V.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const j=await h(V.signService.createNewMessage((0,f.generateUuid)()),O),Z={type:"auth",auth:V.connectionToken||"00000000000000000000",data:j.data};Y.sendControl(t.VSBuffer.fromString(JSON.stringify(Z)));try{const re=await I(Y,m(O,b(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(V.logService.trace(`${N} 4/6. received SignRequest control message.`),!await h(V.signService.validate(j,re.signedData),O)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const ge=await h(V.signService.sign(re.data),O),Ee={type:"connectionType",commit:V.commit,signedData:ge,desiredConnectionType:Q};return A&&(Ee.args=A),V.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(t.VSBuffer.fromString(JSON.stringify(Ee))),{protocol:Y,ownsProtocol:U}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(V.logService.error(`${N} the handshake timed out. Error:`),V.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(V.logService.error(`${N} received error control message when negotiating connection. Error:`),V.logService.error(re)),U&&ne(Y),re}}async function r(V,Q,A,O){const N=Date.now(),$=G(V,Q),{protocol:Y,ownsProtocol:U}=await l(V,Q,A,O),j=new E(O);return j.registerDisposable(Y.onControlMessage(Z=>{const re=JSON.parse(Z.toString()),le=F(re);le?(V.logService.error(`${$} received error control message when negotiating connection. Error:`),V.logService.error(le),U&&ne(Y),j.reject(le)):(V.reconnectionProtocol&&V.reconnectionProtocol.endAcceptReconnection(),V.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${ie(N)}!`),j.resolve({protocol:Y,firstMessage:re}))})),j.promise}async function n(V,Q){const{protocol:A}=await r(V,1,void 0,Q);return{protocol:A}}async function i(V,Q,A){const{protocol:O,firstMessage:N}=await r(V,2,Q,A),$=N&&N.debugPort;return{protocol:O,debugPort:$}}async function s(V,Q,A){const O=Date.now(),N=G(V,3),{protocol:$}=await l(V,3,Q,A);return V.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${ie(O)}!`),$}async function o(V,Q,A){const{host:O,port:N,connectionToken:$}=await V.addressProvider.getAddress();return{commit:V.commit,quality:V.quality,host:O,port:N,connectionToken:$,reconnectionToken:Q,reconnectionProtocol:A,socketFactory:V.socketFactory,signService:V.signService,logService:V.logService}}async function a(V,Q,A){return d(V,async O=>{const{protocol:N}=await n(O,D.CancellationToken.None);return new ce(V,Q,A,O.reconnectionToken,N)})}e.connectRemoteAgentManagement=a;async function c(V,Q){return d(V,async A=>{const{protocol:O,debugPort:N}=await i(A,Q,D.CancellationToken.None);return new H(V,Q,A.reconnectionToken,O,N)})}e.connectRemoteAgentExtensionHost=c;async function d(V,Q){const A=5;for(let O=1;;O++)try{const N=(0,f.generateUuid)(),$=await o(V,N,null);return await Q($)}catch(N){if(O<A)V.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),V.logService.error(N);else throw V.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),V.logService.error(N),te.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(N)),N}}async function P(V,Q,A){const O=await o(V,(0,f.generateUuid)(),null);return await s(O,{host:Q,port:A},D.CancellationToken.None)}e.connectRemoteAgentTunnel=P;function L(V){return(0,S.createCancelablePromise)(Q=>new Promise((A,O)=>{const N=setTimeout(A,V*1e3);Q.onCancellationRequested(()=>{clearTimeout(N),A()})}))}var T;(function(V){V[V.ConnectionLost=0]="ConnectionLost",V[V.ReconnectionWait=1]="ReconnectionWait",V[V.ReconnectionRunning=2]="ReconnectionRunning",V[V.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",V[V.ConnectionGain=4]="ConnectionGain"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class W{constructor(Q,A){this.reconnectionToken=Q,this.millisSinceLastIncomingData=A,this.type=0}}e.ConnectionLostEvent=W;class q{constructor(Q,A,O,N){this.reconnectionToken=Q,this.millisSinceLastIncomingData=A,this.durationSeconds=O,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=q;class ee{constructor(Q,A,O){this.reconnectionToken=Q,this.millisSinceLastIncomingData=A,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=ee;class se{constructor(Q,A,O){this.reconnectionToken=Q,this.millisSinceLastIncomingData=A,this.attempt=O,this.type=4}}e.ConnectionGainEvent=se;class ae{constructor(Q,A,O,N){this.reconnectionToken=Q,this.millisSinceLastIncomingData=A,this.attempt=O,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=ae;class te extends v.Disposable{constructor(Q,A,O,N,$){super();this._connectionType=Q,this._options=A,this.reconnectionToken=O,this.protocol=N,this._reconnectionFailureIsFatal=$,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new se(this.reconnectionToken,0,0)),this._register(N.onSocketClose(Y=>{const U=B(this._connectionType,this.reconnectionToken,!0);Y?Y.type===0?(this._options.logService.info(`${U} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this._options.logService.error(Y.error)):(this._options.logService.info(`${U} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this._options.logService.error(Y.event)):this._options.logService.info(`${U} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(()=>{const Y=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Y} received socket timeout event.`),this._beginReconnecting()})),te._instances.push(this),this._register((0,v.toDisposable)(()=>{const Y=te._instances.indexOf(this);Y>=0&&te._instances.splice(Y,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(te._permanentFailureMillisSinceLastIncomingData,te._permanentFailureAttempt,te._permanentFailureHandled)}static triggerPermanentFailure(Q,A,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Q,this._permanentFailureAttempt=A,this._permanentFailureHandled=O,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Q=>Q._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Q=>Q._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||te._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const Q=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const A=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const N=O<A.length?A[O]:A[A.length-1];try{if(N>0){const Y=L(N);this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,Y)),this._options.logService.info(`${Q} waiting for ${N} seconds before reconnecting...`);try{await Y}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${Q} resolving connection...`);const $=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Q} connecting to ${$.host}:${$.port}...`),await this._reconnect($,b(y)),this._options.logService.info(`${Q} reconnected!`),this._onDidStateChange.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this._options.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this._options.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if((0,R.isCancellationError)($)){this._options.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if($ instanceof C.RemoteAuthorityResolverError){this._options.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,C.RemoteAuthorityResolverError.isHandled($));break}this._options.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error($),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(Q,A,O){this._reconnectionFailureIsFatal?te.triggerPermanentFailure(Q,A,O):this._gotoPermanentFailure(Q,A,O)}_gotoPermanentFailure(Q,A,O){this._onDidStateChange.fire(new ae(this.reconnectionToken,Q,A,O)),ne(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=te,te._permanentFailure=!1,te._permanentFailureMillisSinceLastIncomingData=0,te._permanentFailureAttempt=0,te._permanentFailureHandled=!1,te._instances=[];class ce extends te{constructor(Q,A,O,N,$){super(1,Q,N,$,!0);this.client=this._register(new p.Client($,{remoteAuthority:A,clientId:O},Q.ipcLogger))}async _reconnect(Q,A){await n(Q,A)}}e.ManagementPersistentConnection=ce;class H extends te{constructor(Q,A,O,N,$){super(2,Q,O,N,!1);this._startArguments=A,this.debugPort=$}async _reconnect(Q,A){await i(Q,this._startArguments,A)}}e.ExtensionHostPersistentConnection=H;function ne(V){try{V.acceptDisconnect();const Q=V.getSocket();V.dispose(),Q.dispose()}catch(Q){(0,R.onUnexpectedError)(Q)}}function F(V){if(V&&V.type==="error"){const Q=new Error(`Connection error: ${V.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function _(V,Q){for(;V.length<Q;)V+=" ";return V}function B(V,Q,A){return`[remote-connection][${_(u(V),13)}][${Q.substr(0,5)}\u2026][${A?"reconnect":"initial"}]`}function G(V,Q){return`${B(Q,V.reconnectionToken,!!V.reconnectionProtocol)}[${V.host}:${V.port}]`}function ie(V){return`${Date.now()-V} ms`}}),define(X[209],J([0,1,76,81]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,R,M,v,f,p){const C=y=>p(y,void 0),k=S.createConnection({host:D,port:R},()=>{k.removeListener("error",C);const y=Buffer.alloc(16);for(let m=0;m<16;m++)y[m]=Math.round(Math.random()*256);const g=y.toString("base64"),u=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${R}${M}?${v}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];k.write(u.join(`\r
`)+`\r
\r
`);const b=m=>{m.toString().indexOf(`\r
\r
`)>=0&&(k.off("data",b),p(void 0,new t.NodeSocket(k,f)))};k.on("data",b)});k.setNoDelay(!0),k.once("error",C)}}}),define(X[52],J([0,1,17,161,60,5,44]),function(z,e,S,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function v(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}e.isSuccess=v;function f(b){return b.res.statusCode===204}async function p(b){return f(b)?null:(await(0,S.streamToBuffer)(b.stream)).toString()}e.asText=p;async function C(b){if(!v(b))throw new Error("Server returned "+b.res.statusCode);return p(b)}e.asTextOrError=C;async function k(b){if(!v(b))throw new Error("Server returned "+b.res.statusCode);if(f(b))return null;const E=(await(0,S.streamToBuffer)(b.stream)).toString();try{return JSON.parse(E)}catch(I){throw I.message+=`:
`+E,I}}e.asJson=k;function y(b){u(b)}e.updateProxyConfigurationsScope=y;let g;function u(b){const m=M.Registry.as(D.Extensions.Configuration),E=g;g={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},m.updateConfigurations({add:[g],remove:E?[E]:[]})}u(2)}),define(X[210],J([0,1,17,21]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(v){this.service=v}listen(v,f){throw new Error("Invalid listen")}call(v,f,p,C=t.CancellationToken.None){switch(f){case"request":return this.service.request(p[0],C).then(async({res:k,stream:y})=>{const g=await(0,S.streamToBuffer)(y);return[{statusCode:k.statusCode,headers:k.headers},g]});case"resolveProxy":return this.service.resolveProxy(p[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class R{constructor(v){this.channel=v}async request(v,f){const[p,C]=await this.channel.call("request",[v],f);return{res:p,stream:(0,S.bufferToStream)(C)}}async resolveProxy(v){return this.channel.call("resolveProxy",[v])}}e.RequestChannelClient=R}),define(X[211],J([0,1,212,13]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(M,v){return M.protocol==="http:"?v.HTTP_PROXY||v.http_proxy||null:M.protocol==="https:"&&(v.HTTPS_PROXY||v.https_proxy||v.HTTP_PROXY||v.http_proxy)||null}async function R(M,v,f={}){const p=(0,S.parse)(M),C=f.proxyUrl||D(p,v);if(!C)return null;const k=(0,S.parse)(C);if(!/^https?:$/.test(k.protocol||""))return null;const y={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,t.isBoolean)(f.strictSSL)?f.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((g,u)=>{z(["http-proxy-agent"],g,u)}))(y):new(await new Promise((g,u)=>{z(["https-proxy-agent"],g,u)}))(y)}e.getProxyAgent=R}),define(X[106],J([0,1,42,9,162,21,41,19,4,27,144,56,8]),function(z,e,S,t,D,R,M,v,f,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const g=1e4;let u;async function b(E,I,w){return I["force-disable-user-env"]?(E.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(E.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(w)&&!I["force-user-env"]?(E.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(w)?E.trace("resolveShellEnv(): running (--force-user-env)"):E.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=y.Promises.withAsyncBody(async(h,l)=>{const r=new R.CancellationTokenSource,n=setTimeout(()=>{r.dispose(!0),l(new Error((0,D.localize)(0,null)))},g);try{h(await m(E,r.token))}catch(i){!(0,v.isCancellationError)(i)&&!r.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,M.toErrorMessage)(i)))):h({})}finally{clearTimeout(n),r.dispose()}})),u)}e.getResolvedShellEnv=b;async function m(E,I){const w=process.env.ELECTRON_RUN_AS_NODE;E.trace("getUnixShellEnvironment#runAsNode",w);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;E.trace("getUnixShellEnvironment#noAttach",h);const l=(0,p.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};E.trace("getUnixShellEnvironment#env",n);const i=await(0,C.getSystemShell)(f.OS,n);return E.trace("getUnixShellEnvironment#shell",i),new Promise((s,o)=>{if(I.isCancellationRequested)return o((0,v.canceled)());const a=(0,t.basename)(i);let c,d;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(c=`& '${process.execPath}' ${P} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,d=["-Login","-Command"]):(c=`'${process.execPath}' ${P} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,a==="tcsh"?d=["-ic"]:d=["-ilc"]),E.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),c);const L=(0,S.spawn)(i,[...d,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});I.onCancellationRequested(()=>(L.kill(),o((0,v.canceled)()))),L.on("error",q=>{E.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(q)),o(q)});const T=[];L.stdout.on("data",q=>T.push(q));const W=[];L.stderr.on("data",q=>W.push(q)),L.on("close",(q,ee)=>{const se=Buffer.concat(T).toString("utf8");E.trace("getUnixShellEnvironment#raw",se);const ae=Buffer.concat(W).toString("utf8");if(ae.trim()&&E.trace("getUnixShellEnvironment#stderr",ae),q||ee)return o(new Error((0,D.localize)(2,null,q,ee)));const te=r.exec(se),ce=te?te[1]:"{}";try{const H=JSON.parse(ce);w?H.ELECTRON_RUN_AS_NODE=w:delete H.ELECTRON_RUN_AS_NODE,h?H.ELECTRON_NO_ATTACH_CONSOLE=h:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,E.trace("getUnixShellEnvironment#result",H),s(H)}catch(H){E.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(H)),o(H)}})})}}),define(X[86],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,S.createDecorator)(e.SIGN_SERVICE_ID)}),define(X[213],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class S{constructor(){this.validators=new Map}vsda(){return new Promise((D,R)=>z(["vsda"],D,R))}async createNewMessage(D){try{const R=await this.vsda(),M=new R.validator;if(M){const v=String(S._nextId++);return this.validators.set(v,M),{id:v,data:M.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,R){if(!D.id)return!0;const M=this.validators.get(D.id);if(!M)return!1;this.validators.delete(D.id);try{return M.validate(R)==="ok"}catch{return!1}}async sign(D){try{const R=await this.vsda(),M=new R.signer;if(M)return M.sign(D)}catch{}return D}}e.SignService=S,S._nextId=1}),define(X[45],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,S.createDecorator)("stateMainService")}),define(X[22],J([0,1,14,38,8,3,2,4,36,13,5,6,45]),function(z,e,S,t,D,R,M,v,f,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,C.createDecorator)("lifecycleMainService");var g;(function(m){m[m.QUIT=1]="QUIT",m[m.KILL=2]="KILL"})(g=e.ShutdownReason||(e.ShutdownReason={}));var u;(function(m){m[m.Starting=1]="Starting",m[m.Ready=2]="Ready",m[m.AfterWindowOpen=3]="AfterWindowOpen"})(u=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let b=class bt extends M.Disposable{constructor(E,I){super();this.logService=E,this.stateMainService=I,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(bt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(bt.QUIT_AND_RESTART_KEY)}registerListeners(){const E=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),v.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};S.app.addListener("before-quit",E);const I=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!v.isMacintosh)&&S.app.quit()};S.app.addListener("window-all-closed",I),S.app.once("will-quit",w=>{this.logService.trace("Lifecycle#app.on(will-quit)"),w.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),S.app.removeListener("before-quit",E),S.app.removeListener("window-all-closed",I),S.app.quit()})})}fireOnWillShutdown(E){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const I=[];return this._onWillShutdown.fire({reason:E,join(w){I.push(w)}}),this.pendingWillShutdownPromise=(async()=>{try{await D.Promises.settled(I)}catch(w){this.logService.error(w)}try{await this.stateMainService.close()}catch(w){this.logService.error(w)}})(),this.pendingWillShutdownPromise}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===E)return;this.logService.trace(`lifecycle (main): phase changed (value: ${E})`),this._phase=E;const I=this.phaseWhen.get(this._phase);I&&(I.open(),this.phaseWhen.delete(this._phase))}async when(E){if(E<=this._phase)return;let I=this.phaseWhen.get(E);I||(I=new D.Barrier,this.phaseWhen.set(E,I)),await I.wait()}registerWindow(E){const I=new M.DisposableStore;this.windowCounter++,I.add(E.onWillLoad(h=>this._onWillLoadWindow.fire({window:E,workspace:h.workspace,reason:h.reason})));const w=(0,p.assertIsDefined)(E.win);w.on("close",h=>{const l=E.id;if(this.windowToCloseRequest.has(l)){this.windowToCloseRequest.delete(l);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${E.id}`),h.preventDefault(),this.unload(E,1).then(r=>{if(r){this.windowToCloseRequest.delete(l);return}this.windowToCloseRequest.add(l),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this._onBeforeCloseWindow.fire(E),E.close()})}),w.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.windowCounter--,I.dispose(),this.windowCounter===0&&(!v.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(E,I){await this.unload(E,3)||E.reload(I)}unload(E,I){const w=this.mapWindowIdToPendingUnload.get(E.id);if(w)return w;const h=this.doUnload(E,I).finally(()=>{this.mapWindowIdToPendingUnload.delete(E.id)});return this.mapWindowIdToPendingUnload.set(E.id,h),h}async doUnload(E,I){if(!E.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${E.id}`);const w=this._quitRequested?2:I,h=await this.onBeforeUnloadWindowInRenderer(E,w);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.handleWindowUnloadVeto(h)):(await this.onWillUnloadWindowInRenderer(E,w),!1)}handleWindowUnloadVeto(E){return E?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(E){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(E),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(E,I){return new Promise(w=>{const h=this.oneTimeListenerTokenGenerator++,l=`vscode:ok${h}`,r=`vscode:cancel${h}`;t.validatedIpcMain.once(l,()=>{w(!1)}),t.validatedIpcMain.once(r,()=>{w(!0)}),E.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:r,reason:I})})}onWillUnloadWindowInRenderer(E,I){return new Promise(w=>{const l=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(l,()=>w()),E.send("vscode:onWillUnload",{replyChannel:l,reason:I})})}quit(E){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${E}`),E&&this.stateMainService.setItem(bt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(I=>{this.pendingQuitPromiseResolve=I,this.logService.trace("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.pendingQuitPromise)}async relaunch(E){this.logService.trace("Lifecycle#relaunch()");const I=process.argv.slice(1);if(E?.addArgs&&I.push(...E.addArgs),E?.removeArgs)for(const l of E.removeArgs){const r=I.indexOf(l);r>=0&&I.splice(r,1)}const w=()=>{try{if(v.isWindows){const l=(0,f.cwd)();l!==process.cwd()&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:I})};S.app.once("quit",w),await this.quit(!0)&&S.app.removeListener("quit",w)}async kill(E){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,D.timeout)(1e3),(async()=>{for(const I of S.BrowserWindow.getAllWindows())if(I&&!I.isDestroyed()){let w;I.webContents&&!I.webContents.isDestroyed()?w=new Promise(h=>I.once("closed",h)):w=Promise.resolve(),I.destroy(),await w}})()]),S.app.exit(E)}};b.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",b=fe([x(0,k.ILogService),x(1,y.IStateMainService)],b),e.LifecycleMainService=b}),define(X[214],J([0,1,4,3,2,5,22]),function(z,e,S,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let v=class extends D.Disposable{constructor(C){super();this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,C.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const C=await new Promise((k,y)=>{z(["native-keymap"],k,y)});this._keyboardLayoutData=f(C),S.isCI||C.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=f(C),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};v=fe([x(0,M.ILifecycleMainService)],v),e.KeyboardLayoutMainService=v;function f(p){const C=p.getKeyMap(),k=p.getCurrentKeyboardLayout();return{keyboardMapping:C,keyboardLayoutInfo:k}}}),define(X[215],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,S.createDecorator)("stateService")}),define(X[216],J([0,1,8,17,13,39,15,6]),function(z,e,S,t,D,R,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class f{constructor(k,y,g){this.storagePath=k,this.logService=y,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new S.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(k){k.fileOperationResult!==1&&this.logService.error(k)}}getItem(k,y){const g=this.storage[k];return(0,D.isUndefinedOrNull)(g)?y:g}setItem(k,y){this.setItems([{key:k,data:y}])}setItems(k){let y=!1;for(const{key:g,data:u}of k)this.storage[g]!==u&&((0,D.isUndefinedOrNull)(u)?(0,D.isUndefined)(this.storage[g])||(this.storage[g]=void 0,y=!0):(this.storage[g]=u,y=!0));y&&this.save()}removeItem(k){(0,D.isUndefined)(this.storage[k])||(this.storage[k]=void 0,this.save())}async save(k){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),k)}async doSave(){if(!this.initializing)return;await this.initializing;const k=JSON.stringify(this.storage,null,4);if(k!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(k)),this.lastSavedStorageContents=k}catch(y){this.logService.error(y)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=f;let p=class{constructor(k,y,g){this.fileStorage=new f(k.stateResource,y,g)}async init(){await this.fileStorage.init()}getItem(k,y){return this.fileStorage.getItem(k,y)}};p=fe([x(0,R.IEnvironmentService),x(1,v.ILogService),x(2,M.IFileService)],p),e.StateService=p}),define(X[217],J([0,1,216]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends S.StateService{setItem(R,M){this.fileStorage.setItem(R,M)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(X[107],J([0,1,4,36,7,27]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(p){if(S.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function v(p,C,k,y,g,u,b,m,E,I){const w=Object.create(null);w["common.machineId"]=b,w.sessionID=(0,R.generateUuid)()+Date.now(),w.commitHash=g,w.version=u,w["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,S.PlatformToString)(S.platform),w["common.nodePlatform"]=t.platform,w["common.nodeArch"]=y,w["common.product"]=I||"desktop",m&&(w["common.msftInternal"]=m);let h=0;const l=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),S.isLinuxSnap&&(w["common.snap"]="true");const r=M(k);r&&(w["common.platformDetail"]=r);try{const n=await p.readFile(D.URI.file(E));w["common.source"]=n.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=v;function f(p){const C=t.env.USERDNSDOMAIN;if(!C)return!1;const k=C.toLowerCase();return p.some(y=>k===y)}e.verifyMicrosoftInternalDomain=f}),define(X[35],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(X[218],J([0,1,29,54,8,49,12,9,4,7,80,23,94,83,15,20,35]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const E=new Map;async function I(n,i){const s=`${n}::${i.join(":")}`,o=E.get(s);if(o)return o;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,d=new Map,P=2e4;function L(W,q,ee,se){const ae=q.substring(W.length+1);return D.Promises.withAsyncBody(async te=>{let ce;try{ce=await k.Promises.readdir(q,{withFileTypes:!0})}catch{te();return}if(se.count>=P){se.count+=ce.length,se.maxReached=!0,te();return}let H=ce.length;if(H===0){te();return}let ne=ce;se.count+ce.length>P&&(se.maxReached=!0,H=P-se.count,ne=ce.slice(0,H)),se.count+=ce.length;for(const F of ne)if(F.isDirectory()){if(ee.includes(F.name)||await L(W,(0,v.join)(q,F.name),ee,se),--H==0){te();return}}else{const _=F.name.lastIndexOf(".");if(_>=0){const B=F.name.substring(_+1);B&&c.set(B,(c.get(B)??0)+1)}for(const B of a)B.relativePathPattern?.test(ae)!==!1&&B.filePattern.test(F.name)&&d.set(B.tag,(d.get(B.tag)??0)+1);if(--H==0){te();return}}})}const T=D.Promises.withAsyncBody(async W=>{const q={count:0,maxReached:!1};await L(n,n,i,q);const ee=await l(n);W({configFiles:w(d),fileTypes:w(c),fileCount:q.count,maxFilesReached:q.maxReached,launchConfigFiles:ee})});return E.set(s,T),T}e.collectWorkspaceStats=I;function w(n){return[...t.Iterable.map(n.entries(),([i,s])=>({name:i,count:s}))].sort((i,s)=>s.count-i.count)}function h(){const n={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(C.virtualMachineHint.value()*100)}%`},i=S.cpus();return i&&i.length>0&&(n.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),n}e.getMachineInfo=h;async function l(n){try{const i=new Map,s=(0,v.join)(n,".vscode","launch.json"),o=await k.Promises.readFile(s),a=[],c=(0,R.parse)(o.toString(),a);if(a.length)return console.log(`Unable to parse ${s}`),[];if((0,R.getNodeType)(c)==="object"&&c.configurations)for(const d of c.configurations){const P=d.type;P&&(i.has(P)?i.set(P,i.get(P)+1):i.set(P,1))}return w(i)}catch{return[]}}e.collectLaunchConfigs=l;let r=class{constructor(i,s){this.telemetryService=i,this.productService=s}formatMachineInfo(i){const s=[];return s.push(`OS Version:       ${i.os}`),s.push(`CPUs:             ${i.cpus}`),s.push(`Memory (System):  ${i.memory}`),s.push(`VM:               ${i.vmHint}`),s.join(`
`)}formatEnvironment(i){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const o=S.cpus();return o&&o.length>0&&s.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),s.push(`Memory (System):  ${(S.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),f.isWindows||s.push(`Load (avg):       ${S.loadavg().map(a=>Math.round(a)).join(", ")}`),s.push(`VM:               ${Math.round(C.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${i.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(i,s){return Promise.all([(0,y.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[a,c]=o,d=this.formatProcessList(i,a);return s.forEach(P=>{if((0,g.isRemoteDiagnosticError)(P))d+=`
${P.errorMessage}`,c+=`
${P.errorMessage}`;else if(d+=`

Remote: ${P.hostName}`,P.processes&&(d+=`
${this.formatProcessList(i,P.processes)}`),P.workspaceMetadata){c+=`
|  Remote: ${P.hostName}`;for(const L of Object.keys(P.workspaceMetadata)){const T=P.workspaceMetadata[L];let W=`${T.fileCount} files`;T.maxFilesReached&&(W=`more than ${W}`),c+=`|    Folder (${L}): ${W}`,c+=this.formatWorkspaceStats(T)}}}),{processInfo:d,workspaceInfo:c}})}async getSystemInfo(i,s){const{memory:o,vmHint:a,os:c,cpus:d}=h(),P={os:c,memory:o,cpus:d,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:s};return f.isWindows||(P.load=`${S.loadavg().map(L=>Math.round(L)).join(", ")}`),f.isLinux&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(i,s){const o=[];return(0,y.listProcesses)(i.mainPID).then(async a=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,a)),i.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),s.forEach(c=>{if((0,g.isRemoteDiagnosticError)(c))o.push(`
${c.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${c.hostName}`),o.push(this.formatMachineInfo(c.machineInfo)),c.processes&&o.push(this.formatProcessList(i,c.processes)),c.workspaceMetadata)for(const d of Object.keys(c.workspaceMetadata)){const P=c.workspaceMetadata[d];let L=`${P.fileCount} files`;P.maxFilesReached&&(L=`more than ${L}`),o.push(`Folder (${d}): ${L}`),o.push(this.formatWorkspaceStats(P))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const s=[],o=60;let a=0;const c=(T,W)=>{const q=` ${T}(${W})`;a+q.length>o?(s.push(d),d="|                 ",a=d.length):a+=q.length,d+=q};let d="|      File types:";const P=10,L=i.fileTypes.length>P?P:i.fileTypes.length;for(let T=0;T<L;T++){const W=i.fileTypes[T];c(W.name,W.count)}if(s.push(d),i.configFiles.length>=0&&(d="|      Conf files:",a=0,i.configFiles.forEach(T=>{c(T.name,T.count)}),s.push(d)),i.launchConfigFiles.length>0){let T="|      Launch Configs:";i.launchConfigFiles.forEach(W=>{T+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),s.push(T)}return s.join(`
`)}expandGPUFeatures(i){const s=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(s-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const s=[],o=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(s.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const d=p.URI.revive(c);if(d.scheme===M.Schemas.file){const P=d.fsPath;o.push(I(P,["node_modules",".git"]).then(L=>{let T=`${L.fileCount} files`;L.maxFilesReached&&(T=`more than ${T}`),s.push(`|    Folder (${(0,v.basename)(P)}): ${T}`),s.push(this.formatWorkspaceStats(L))}).catch(L=>{s.push(`|      Error: Unable to collect workspace stats for folder ${P} (${L.toString()})`)}))}else s.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>s.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,s){const o=new Map;i.windows.forEach(c=>o.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(i.mainPID,o,a,s,0),a.join(`
`)}formatProcessItem(i,s,o,a,c){const d=c===0;let P;d?P=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(P=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(P=`${P} (${s.get(a.pid)})`));const L=process.platform==="win32"?a.mem:S.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(L/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(a.children)&&a.children.forEach(T=>this.formatProcessItem(i,s,o,T,c+1))}async getWorkspaceFileExtensions(i){const s=new Set;for(const{uri:o}of i.folders){const a=p.URI.revive(o);if(a.scheme!==M.Schemas.file)continue;const c=a.fsPath;try{(await I(c,["node_modules",".git"])).fileTypes.forEach(P=>s.add(P.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(i){for(const{uri:s}of i.folders){const o=p.URI.revive(s);if(o.scheme!==M.Schemas.file)continue;const a=o.fsPath;try{const c=await I(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),c.fileTypes.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:d.name,count:d.count})}),c.launchConfigFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:d.name,count:d.count})}),c.configFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:d.name,count:d.count})})}catch{}}}};r=fe([x(0,m.ITelemetryService),x(1,b.IProductService)],r),e.DiagnosticsService=r}),define(X[219],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(R){this.appenders=R}listen(R,M){throw new Error(`Event not found: ${M}`)}call(R,M,{eventName:v,data:f}){return this.appenders.forEach(p=>p.log(v,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class t{constructor(R){this.channel=R}log(R,M){return this.channel.call("log",{eventName:R,data:M}).then(void 0,v=>`Failed to log telemetry: ${console.warn(v)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(X[72],J([0,1,50,91,13,18,107,35]),function(z,e,S,t,D,R,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class f{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(r,n){return Promise.resolve(void 0)}publicLog2(r,n){return this.publicLog(r,n)}publicLogError(r,n){return Promise.resolve(void 0)}publicLogError2(r,n){return this.publicLogError(r,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=f,e.NullTelemetryService=new f;class p{async publicLog(r,n,i){}async publicLogError(r,n,i){}}e.NullEndpointTelemetryService=p,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(l,r){return r.onDidChangeConfiguration(n=>{n.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(n.source),configurationKeys:E(n.sourceConfig)})})}e.configurationTelemetry=C;function k(l,r){return!(r.disableTelemetry||!l.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=k;function y(l){const r=l.getValue(v.TELEMETRY_SETTING_ID),n=l.getValue("telemetry.enableCrashReporter");if(l.getValue(v.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function g(l){const r={},n={},i={};m(l,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const o=i[s];typeof o=="number"?n[s]=o:typeof o=="boolean"?n[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(r[s]=o)}return{properties:r,measurements:n}}e.validateTelemetryData=g;const u=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function b(l){if(!l)return"none";for(const r of u)if(l.startsWith(`${r}+`))return r;return"other"}e.cleanRemoteAuthority=b;function m(l,r,n=0,i){if(!!l)for(const s of Object.getOwnPropertyNames(l)){const o=l[s],a=i?i+s:s;Array.isArray(o)?r[a]=(0,S.safeStringify)(o):o instanceof Date?r[a]=o.toISOString():(0,D.isObject)(o)?n<2?m(o,r,n+1,a+"."):r[a]=(0,S.safeStringify)(o):r[a]=o}}function E(l){if(!l)return[];const r=[];return I(r,"",l),r}function I(l,r,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(i=>I(l,r?`${r}.${i}`:i,n[i])):l.push(r)}function w(l,r){const n=l.msftInternalDomains||[],i=r.getValue("telemetry.internalTesting");return(0,M.verifyMicrosoftInternalDomain)(n)||i}e.isInternalTelemetry=w;function h(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=h}),define(X[220],J([0,1,180,72]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(R,M,v,f,p,C,k){const y={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${M.nameShort})`},g=await(0,S.getServiceMachineId)(v,p,C),{sessionId:u}=await k.getTelemetryInfo();return(0,t.supportsTelemetry)(M,v)&&(0,t.getTelemetryLevel)(f)===3&&(y["X-Market-User-Id"]=g,y["VSCode-SessionId"]=u),y}e.resolveMarketplaceHeaders=D}),define(X[221],J([0,1,2,50,91,4,31,163,18,60,58,20,44,35,72]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(I,w,h){this._configurationService=w,this._productService=h,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appenders=I.appenders,this._commonProperties=I.commonProperties||Promise.resolve({}),this._piiPaths=I.piiPaths||[],this._sendErrorTelemetry=!!I.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(I,w){this._experimentProperties[I]=w}_updateTelemetryLevel(){let I=(0,u.getTelemetryLevel)(this._configurationService);const w=this._productService.enabledTelemetryLevels;if(w){this._sendErrorTelemetry=this.sendErrorTelemetry?w.error:!1;const h=w.usage?3:w.error?2:0;I=Math.min(I,h)}this.telemetryLevel.value=I}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const I=await this._commonProperties,w=I.sessionID,h=I["common.machineId"],l=I["common.firstSessionDate"],r=I["common.msftInternal"];return{sessionId:w,machineId:h,firstSessionDate:l,msftInternal:r}}dispose(){this._disposables.dispose()}_log(I,w,h,l){return this.telemetryLevel.value<w?Promise.resolve(void 0):this._commonProperties.then(r=>{h=(0,t.mixin)(h,r),h=(0,t.mixin)(h,this._experimentProperties),h=(0,t.cloneAndChange)(h,n=>{if(typeof n=="string")return this._cleanupInfo(n,l)}),this._appenders.forEach(n=>n.log(I,h))},r=>{console.error(r)})}publicLog(I,w,h){return this._log(I,3,w,h)}publicLog2(I,w,h){return this.publicLog(I,w,h)}publicLogError(I,w){return this._sendErrorTelemetry?this._log(I,2,w,!0):Promise.resolve(void 0)}publicLogError2(I,w){return this.publicLogError(I,w)}_anonymizeFilePaths(I){let w=I;const h=[];for(const i of this._cleanupPatterns)for(;;){const s=i.exec(I);if(!s)break;h.push([s.index,i.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let n=0;for(w="";;){const i=r.exec(I);if(!i)break;!l.test(i[0])&&h.every(([s,o])=>i.index<s||i.index>=o)&&(w+=I.substring(n,i.index)+"<REDACTED: user-file-path>",n=r.lastIndex)}return n<I.length&&(w+=I.substr(n)),w}_removePropertiesWithPossibleUserInfo(I){if(!I)return I;const w=I.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const l of h)if(l.regex.test(w))return`<REDACTED: ${l.label}>`;return I}_cleanupInfo(I,w){let h=I;w&&(h=this._anonymizeFilePaths(h));for(const l of this._cleanupPatterns)h=h.replace(l,"");return h=this._removePropertiesWithPossibleUserInfo(h),h}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=fe([x(1,f.IConfigurationService),x(2,k.IProductService)],b),e.TelemetryService=b;function m(){const E=(0,v.localize)(0,null,C.default.nameLong),I=C.default.privacyStatementUrl?(0,v.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,v.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=R.isWeb?"":(0,v.localize)(3,null),h=(0,v.localize)(4,null),l=(0,v.localize)(5,null),r=(0,v.localize)(6,null),n=(0,v.localize)(7,null),i=`
|       | ${h} | ${l} | ${r} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,v.localize)(8,null);return`
${E} ${I} ${w}

&nbsp;

${n}
${i}

&nbsp;

${s}
`}y.Registry.as(p.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,v.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,v.localize)(10,null),(0,v.localize)(11,null),(0,v.localize)(12,null),(0,v.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(p.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,v.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,v.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,v.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,v.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(X[222],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var S;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(S=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===S.HIGH_CONTRAST_DARK||R===S.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function D(R){return R===S.DARK||R===S.HIGH_CONTRAST_DARK}e.isDark=D}),define(X[223],J([0,1,117,3,2,5,44,222]),function(z,e,S,t,D,R,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var f;(function(m){function E(I){return I&&typeof I=="object"&&typeof I.id=="string"}m.isThemeColor=E})(f=e.ThemeColor||(e.ThemeColor={}));function p(m){return{id:m}}e.themeColorFromId=p;var C;(function(m){function E(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||f.isThemeColor(s.color))}m.isThemeIcon=E;const I=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function w(s){const o=I.exec(s);if(!o)return;const[,a]=o;return{id:a}}m.fromString=w;function h(s){return{id:s}}m.fromId=h;function l(s,o){let a=s.id;const c=a.lastIndexOf("~");return c!==-1&&(a=a.substring(0,c)),o&&(a=`${a}~${o}`),{id:a}}m.modify=l;function r(s){const o=s.id.lastIndexOf("~");if(o!==-1)return s.id.substring(o+1)}m.getModifier=r;function n(s,o){return s.id===o.id&&s.color?.id===o.color?.id}m.isEqual=n;function i(s,o){return{id:s.id,color:o?p(o):void 0}}m.asThemeIcon=i,m.asClassNameArray=S.CSSIcon.asClassNameArray,m.asClassName=S.CSSIcon.asClassName,m.asCSSSelector=S.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function k(m){switch(m){case v.ColorScheme.DARK:return"vs-dark";case v.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case v.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class y{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),(0,D.toDisposable)(()=>{const I=this.themingParticipants.indexOf(E);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const g=new y;M.Registry.add(e.Extensions.ThemingContribution,g);function u(m){return g.onColorThemeChange(m)}e.registerThemingParticipant=u;class b extends D.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,I){let w=this.theme.getColor(E);return w&&I&&(w=I(w,this.theme)),w?w.toString():null}}e.Themable=b}),define(X[61],J([0,1,14,3,2,4,18,5,45]),function(z,e,S,t,D,R,M,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const p="#FFFFFF",C="#1E1E1E",k="#000000",y="#FFFFFF",g="theme",u="themeBackground",b="windowSplash";e.IThemeMainService=(0,v.createDecorator)("themeMainService");let m=class extends D.Disposable{constructor(I,w){super();this.stateMainService=I,this.configurationService=w,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,S.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const I=this.getColorScheme();if(I.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return I.dark?k:y;let w=this.stateMainService.getItem(u,null);if(!w)switch(this.stateMainService.getItem(g,"vs-dark").split(" ")[0]){case"vs":w=p;break;case"hc-black":w=k;break;case"hc-light":w=y;break;default:w=C}return R.isMacintosh&&w.toUpperCase()===C&&(w="#171717"),w}saveWindowSplash(I,w){this.stateMainService.setItems([{key:g,data:w.baseTheme},{key:u,data:w.colorInfo.background},{key:b,data:w}]),typeof I=="number"&&this.updateBackgroundColor(I,w)}updateBackgroundColor(I,w){for(const h of S.BrowserWindow.getAllWindows())if(h.id===I){h.setBackgroundColor(w.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(b)}};m=fe([x(0,f.IStateMainService),x(1,M.IConfigurationService)],m),e.ThemeMainService=m}),define(X[108],J([0,1,3,4,5,6]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var M;(function(b){b.Http="http",b.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var v;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(v=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function p(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=p,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=k;function y(b,m){return m?m!==1&&b<1024:!t.isWindows&&b<1024}e.isPortPrivileged=y;class g{constructor(m,E,I){this.remoteAddress=m,this.localAddress=E,this._dispose=I,this._onDispose=new S.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let u=class{constructor(m){this.logService=m,this._onTunnelOpened=new S.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new S.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new S.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(m){return this._tunnelProvider=m,m?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this._canElevate=m.elevation,this._privacyOptions=m.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],E=Array.from(this._tunnels.values());for(const I of E){const w=Array.from(I.values());for(const h of w){const l=await h.value;l&&m.push(l)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:E}of m.values())await E.then(I=>I?.dispose());m.clear()}this._tunnels.clear()}openTunnel(m,E,I,w,h=!1,l,r){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${I} on local port ${w}.`),!m)return;if(E||(E="localhost"),this._tunnelProvider&&this._factoryInProgress.has(I)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.retainOrCreateTunnel(m,E,I,w,h,l,r);return n?n.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,I);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(i);return(i.tunnelRemoteHost!==E||i.tunnelRemotePort!==I)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const E=this._tunnels.get(m.tunnelRemoteHost);if(E){const I=E.get(m.tunnelRemotePort);I&&(I.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,I))}}}}async tryDisposeTunnel(m,E,I){if(I.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${E}.`);const w=I.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(E),w}}async closeTunnel(m,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${E} `);const I=this._tunnels.get(m);if(I&&I.has(E)){const w=I.get(E);w.refcount=0,await this.tryDisposeTunnel(m,E,w)}}addTunnelToMap(m,E,I){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(E,{refcount:1,value:I})}async removeEmptyTunnelFromMap(m,E){const I=this._tunnels.get(m);I&&(await I.get(E)||I.delete(E),I.size===0&&this._tunnels.delete(m))}getTunnelFromMap(m,E){const I=[m];C(m)?(I.push(...e.LOCALHOST_ADDRESSES),I.push(...e.ALL_INTERFACES_ADDRESSES)):k(m)&&I.push(...e.ALL_INTERFACES_ADDRESSES);const w=I.map(h=>this._tunnels.get(h));for(const h of w){const l=h?.get(E);if(l)return l}}canTunnel(m){return!!p(m)}createWithProvider(m,E,I,w,h,l,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${I} on local port ${w}.`);const n=I;this._factoryInProgress.add(n);const s={elevationRequired:h?y(w===void 0?I:w):!1},o={remoteAddress:{host:E,port:I},localAddressPort:w,privacy:l,public:l?l!==v.Private:void 0,protocol:r},a=m.forwardPort(o,s);return a?(this.addTunnelToMap(E,I,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(n)})):this._factoryInProgress.delete(n),a}};u=fe([x(0,R.ILogService)],u),e.AbstractTunnelService=u}),define(X[224],J([0,1,76,90,209,8,2,18,6,20,208,108,86]),function(z,e,S,t,D,R,M,v,f,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(I,w,h,l,r){let n;for(let i=3;i&&(n&&n.dispose(),n=await new u(I,w,h,l,r).waitForReady(),!(r&&t.BROWSER_RESTRICTED_PORTS[r]||!t.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));i--);return n}class u extends M.Disposable{constructor(w,h,l,r,n){super();this.defaultTunnelHost=h,this.suggestedLocalPort=n,this.privacy=k.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=w,this._server=S.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let w=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(w,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(w=0,this._server.listen(w,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(w){w.pause();const h=(0,k.isLocalhost)(this.tunnelRemoteHost)||(0,k.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,C.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),r=l.getSocket().socket,n=l.readEntireBuffer();l.dispose(),n.byteLength>0&&w.write(n.buffer),w.on("end",()=>{w.localAddress&&this._socketsDispose.delete(w.localAddress),r.end()}),w.on("close",()=>r.end()),w.on("error",()=>{w.localAddress&&this._socketsDispose.delete(w.localAddress),r.destroy()}),r.on("end",()=>w.end()),r.on("close",()=>w.end()),r.on("error",()=>{w.destroy()}),w.pipe(r),r.pipe(w),w.localAddress&&this._socketsDispose.set(w.localAddress,()=>{w.end(),r.end()})}}let b=class extends k.AbstractTunnelService{constructor(w,h,l,r,n){super(h);this.socketFactory=w,this.signService=l,this.productService=r,this.configurationService=n}get defaultTunnelHost(){const w=this.configurationService.getValue("remote.localPortHost");return!w||w==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(w,h,l,r,n,i,s){const o=this.getTunnelFromMap(h,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,l,r,n,i,s);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${l} on local port ${r}.`);const a={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:w,signService:this.signService,logService:this.logService,ipcLogger:null},c=g(a,this.defaultTunnelHost,h,l,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,l,c),c}}};b=fe([x(1,f.ILogService),x(2,y.ISignService),x(3,p.IProductService),x(4,v.IConfigurationService)],b),e.BaseTunnelService=b;let m=class extends b{constructor(w,h,l,r){super(D.nodeSocketFactory,w,h,l,r)}};m=fe([x(0,f.ILogService),x(1,y.ISignService),x(2,p.IProductService),x(3,v.IConfigurationService)],m),e.TunnelService=m;let E=class extends M.Disposable{constructor(w,h,l,r){super();this.logService=w,this.productService=h,this.signService=l,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(w,h,l,r,n,i,s,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${n}.`),!this._tunnelServices.has(w)){const a=new m(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(w,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(w))})}return this._tunnelServices.get(w).openTunnel(h,l,r,n,i,s,o)}};E=fe([x(0,f.ILogService),x(1,p.IProductService),x(2,y.ISignService),x(3,v.IConfigurationService)],E),e.SharedTunnelsService=E}),define(X[46],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var D;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,M)=>({type:"idle",updateType:R,error:M}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,S.createDecorator)("updateService")}),define(X[225],J([0,1,4,164,60,44]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(X[226],J([0,1,3,46]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(v){this.service=v}listen(v,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(v,f,p){switch(f){case"checkForUpdates":return this.service.checkForUpdates(p);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(p)}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=D;class R{constructor(v){this.channel=v,this._onStateChange=new S.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(v){this._state=v,this._onStateChange.fire(v)}checkForUpdates(v){return this.channel.call("checkForUpdates",v)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(v){return this.channel.call("_applySpecificUpdate",v)}}e.UpdateChannelClient=R}),define(X[87],J([0,1,8,21,3,18,26,22,6,20,52,46]),function(z,e,S,t,D,R,M,v,f,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(u,b,m){return`${m.updateUrl}/api/update/${u}/${b}/${m.commit}`}e.createUpdateURL=y;let g=class{constructor(b,m,E,I,w,h){this.lifecycleMainService=b,this.configurationService=m,this.environmentMainService=E,this.requestService=I,this.logService=w,this.productService=h,this._state=k.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(b){this.logService.info("update#setState",b.type),this._state=b,this._onStateChange.fire(b)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.getUpdateMode(),m=this.getProductQuality(b);if(!m){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(m),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(k.State.Idle(this.getUpdateType())),b==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,E=>this.logService.error(E))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(b){return b==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(b=60*60*1e3){return(0,S.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(b){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(b)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(b){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(b=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(b){}getUpdateType(){return 1}doQuitAndInstall(){}};g=fe([x(0,v.ILifecycleMainService),x(1,R.IConfigurationService),x(2,M.IEnvironmentMainService),x(3,C.IRequestService),x(4,f.ILogService),x(5,p.IProductService)],g),e.AbstractUpdateService=g}),define(X[227],J([0,1,14,51,3,2,18,26,22,6,20,52,35,46,87]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let b=class extends u.AbstractUpdateService{constructor(E,I,w,h,l,r,n){super(E,I,h,l,r,n);this.telemetryService=w,this.disposables=new R.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(S.autoUpdater,"error",(E,I)=>I)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(E,I,w)=>({url:I,version:w,productVersion:w}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(E,I,w,h)=>({releaseNotes:I,version:w,productVersion:w,date:h}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(E){this.logService.error("UpdateService error:",E);const w=(this.state.type==="checking for updates"?this.state.explicit:!0)?E:void 0;this.setState(g.State.Idle(1,w))}buildUpdateFeedUrl(E){let I;this.productService.darwinUniversalAssetId?I=this.productService.darwinUniversalAssetId:I=process.arch==="x64"?"darwin":"darwin-arm64";const w=(0,u.createUpdateURL)(I,E,this.productService);try{S.autoUpdater.setFeedURL({url:w})}catch(h){this.logService.error("Failed to set update feed URL",h);return}return w}doCheckForUpdates(E){this.setState(g.State.CheckingForUpdates(E)),S.autoUpdater.checkForUpdates()}onUpdateAvailable(E){this.state.type==="checking for updates"&&this.setState(g.State.Downloading(E))}onUpdateDownloaded(E){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:E.version}),this.setState(g.State.Ready(E)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(g.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};fe([t.memoize],b.prototype,"onRawError",null),fe([t.memoize],b.prototype,"onRawUpdateNotAvailable",null),fe([t.memoize],b.prototype,"onRawUpdateAvailable",null),fe([t.memoize],b.prototype,"onRawUpdateDownloaded",null),b=fe([x(0,f.ILifecycleMainService),x(1,M.IConfigurationService),x(2,y.ITelemetryService),x(3,v.IEnvironmentMainService),x(4,k.IRequestService),x(5,p.ILogService),x(6,C.IProductService)],b),e.DarwinUpdateService=b}),define(X[228],J([0,1,42,28,8,3,9,26,22,6,35,46]),function(z,e,S,t,D,R,M,v,f,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{constructor(b,m,E){if(this.lifecycleMainService=b,this.logService=E,this._state=k.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,m.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(k.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,I=>this.logService.error(I))}get state(){return this._state}setState(b){this.logService.info("update#setState",b.type),this._state=b,this._onStateChange.fire(b)}scheduleCheckForUpdates(b=60*60*1e3){return(0,D.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(b){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(b)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(b){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(b=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(b){}};y=fe([x(0,f.ILifecycleMainService),x(1,v.IEnvironmentMainService),x(2,p.ILogService)],y);let g=class extends y{constructor(b,m,E,I,w,h){super(E,I,w);this.snap=b,this.snapRevision=m,this.telemetryService=h;const l=(0,t.watch)(M.dirname(this.snap)),r=R.Event.fromNodeEventEmitter(l,"change",(o,a)=>a),n=R.Event.filter(r,o=>o==="current"),s=R.Event.debounce(n,(o,a)=>a,2e3)(()=>this.checkForUpdates(!1));E.onWillShutdown(()=>{s.dispose(),l.close()})}doCheckForUpdates(){this.setState(k.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(b=>{b?this.setState(k.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2)))},b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2,b.message||b))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const b=await new Promise((E,I)=>(0,t.realpath)(`${M.dirname(this.snap)}/current`,(w,h)=>w?I(w):E(h))),m=M.basename(b);return this.snapRevision!==m}isLatestVersion(){return this.isUpdateAvailable().then(void 0,b=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};g=fe([x(2,f.ILifecycleMainService),x(3,v.IEnvironmentMainService),x(4,p.ILogService),x(5,C.ITelemetryService)],g),e.SnapUpdateService=g}),define(X[62],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,S.createDecorator)("IUriIdentityService")}),define(X[229],J([0,1,62,181,15,16,123,3,2]),function(z,e,S,t,D,R,M,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class p{constructor(y){this.uri=y,this.time=p._clock++}touch(){return this.time=p._clock++,this}}p._clock=0;let C=class{constructor(y){this._fileService=y,this._dispooables=new f.DisposableStore,this._limit=2**16;const g=new Map,u=b=>{let m=g.get(b.scheme);return m===void 0&&(m=y.hasProvider(b)&&!this._fileService.hasCapability(b,1024),g.set(b.scheme,m)),m};this._dispooables.add(v.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(b=>{g.delete(b.scheme)})),this.extUri=new R.ExtUri(u),this._canonicalUris=new M.SkipList((b,m)=>this.extUri.compare(b,m,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(y){this._fileService.hasProvider(y)&&(y=(0,R.normalizePath)(y));const g=this._canonicalUris.get(y);return g?g.touch().uri.with({fragment:y.fragment}):(this._canonicalUris.set(y,new p(y)),this._checkTrim(),y)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const y=[...this._canonicalUris.entries()].sort((u,b)=>u[1].touch<b[1].touch?1:u[1].touch>b[1].touch?-1:0);p._clock=0,this._canonicalUris.clear();const g=this._limit*.5;for(let u=0;u<g;u++)this._canonicalUris.set(y[u][0],y[u][1].touch())}};C=fe([x(0,D.IFileService)],C),e.UriIdentityService=C,(0,t.registerSingleton)(S.IUriIdentityService,C,!0)}),define(X[109],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,S.createDecorator)("urlService")}),define(X[230],J([0,1,7]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(v){this.handler=v}listen(v,f){throw new Error(`Event not found: ${f}`)}call(v,f,p){switch(f){case"handleURL":return this.handler.handleURL(S.URI.revive(p[0]),p[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=t;class D{constructor(v){this.channel=v}handleURL(v,f){return this.channel.call("handleURL",[v.toJSON(),f])}}e.URLHandlerChannelClient=D;class R{constructor(v){this.next=v}async routeCall(v,f,p,C){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(p){const k=S.URI.revive(p);if(k&&k.query){const y=/\bwindowId=(\d+)/.exec(k.query);if(y){const g=y[1],u=new RegExp(`window:${g}`),b=v.connections.find(m=>u.test(m.ctx));if(b)return b}}}return this.next.routeCall(v,f,p,C)}routeEvent(v,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=R}),define(X[231],J([0,1,8,2,7,20]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends t.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(p,C){const k=[...this.handlers.values()];return(0,S.first)(k.map(y=>()=>y.handleURL(p,C)),void 0,!1).then(y=>y||!1)}registerHandler(p){return this.handlers.add(p),(0,t.toDisposable)(()=>this.handlers.delete(p))}}e.AbstractURLService=M;let v=class extends M{constructor(p){super();this.productService=p}create(p){let{authority:C,path:k,query:y,fragment:g}=p||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return C&&k&&k.indexOf("/")!==0&&(k=`/${k}`),D.URI.from({scheme:this.productService.urlProtocol,authority:C,path:k,query:y,fragment:g})}};v=fe([x(0,R.IProductService)],v),e.NativeURLService=v}),define(X[232],J([0,1,14,8,3,2,4,7]),function(z,e,S,t,D,R,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(C){try{return v.URI.parse(C)}catch{return null}}class p{constructor(k,y,g,u,b){if(this.urlService=y,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=k,M.isWindows){const I=u.isBuilt?[]:[`"${u.appRoot}"`];I.push("--open-url","--"),S.app.setAsDefaultProtocolClient(b.urlProtocol,process.execPath,I)}const m=D.Event.map(D.Event.fromNodeEventEmitter(S.app,"open-url",(I,w)=>({event:I,url:w})),({event:I,url:w})=>(I.preventDefault(),w));this.disposables.add(m(I=>{const w=f(I);!w||this.urlService.open(w,{originalUrl:I})})),g.getWindows().filter(I=>I.isReady).length>0?this.flush():D.Event.once(g.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const k=[];for(const y of this.uris)await this.urlService.open(y.uri,{originalUrl:y.url})||k.push(y);k.length!==0&&(this.uris=k,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=p}),define(X[233],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,S.createDecorator)("webviewManagerService")}),define(X[234],J([0,1,14,2,12,7]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends t.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);S.protocol.registerFileProtocol(D.Schemas.vscodeWebview,f)}handleWebviewRequest(f,p){try{const C=R.URI.parse(f.url),k=M.validWebviewFilePaths.get(C.path);if(typeof k=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${k}`,g=D.FileAccess.asFileUri(y,z);return p(decodeURIComponent(g.fsPath))}else return p({error:-10})}catch{}return p({error:-2})}}e.WebviewProtocolProvider=M,M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(X[73],J([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(C){return!!C.workspaceUri}e.isWorkspaceToOpen=t;function D(C){return!!C.folderUri}e.isFolderToOpen=D;function R(C){return!!C.fileUri}e.isFileToOpen=R;function M(C){const k=v(C),y=C.getValue("window.menuBarVisibility");return y==="default"||k==="native"&&y==="compact"||S.isMacintosh&&S.isNative?"classic":y}e.getMenuBarVisibility=M;function v(C){if(S.isWeb)return"custom";const k=C.getValue("window");if(k){if(S.isMacintosh&&k.nativeTabs===!0||S.isMacintosh&&k.nativeFullScreen===!1)return"native";const u=C.getValue("workbench.colorCustomizations");if(u?.["window.activeBorder"]||u?.["window.inactiveBorder"])return"custom";const b=k.titleBarStyle;if(b==="native"||b==="custom")return b}return S.isLinux?"native":"custom"}e.getTitleBarStyle=v;function f(C,k){return!S.isWindows||S.isWeb||!k.isBuilt||v(C)==="native"?!1:C.getValue("window.experimental.windowControlsOverlay.enabled")}e.useWindowControlsOverlay=f;function p(C=0){return Math.pow(1.2,C)}e.zoomLevelToZoomFactor=p}),define(X[110],J([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var S;(function(v){v[v.INITIAL=1]="INITIAL",v[v.LOAD=2]="LOAD",v[v.RELOAD=3]="RELOAD"})(S=e.LoadReason||(e.LoadReason={}));var t;(function(v){v[v.CLOSE=1]="CLOSE",v[v.QUIT=2]="QUIT",v[v.RELOAD=3]="RELOAD",v[v.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const D=function(v=1){return{width:1024,height:768,mode:v}};e.defaultWindowState=D;var R;(function(v){v[v.Maximized=0]="Maximized",v[v.Normal=1]="Normal",v[v.Minimized=2]="Minimized",v[v.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var M;(function(v){v[v.UNRESPONSIVE=1]="UNRESPONSIVE",v[v.CRASHED=2]="CRASHED",v[v.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(X[32],J([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,S.createDecorator)("windowsMainService");var t;(function(D){D[D.CLI=0]="CLI",D[D.DOCK=1]="DOCK",D[D.MENU=2]="MENU",D[D.DIALOG=3]="DIALOG",D[D.DESKTOP=4]="DESKTOP",D[D.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(X[235],J([0,1,14,21,3,65,2,27,68,99,6,20,32]),function(z,e,S,t,D,R,M,v,f,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var g;(function(b){b[b.Initial=1]="Initial",b[b.StoredCredentialsUsed=2]="StoredCredentialsUsed",b[b.LoginDialogShown=3]="LoginDialogShown"})(g||(g={}));let u=class extends M.Disposable{constructor(m,E,I,w,h){super();this.logService=m,this.windowsMainService=E,this.credentialsService=I,this.encryptionMainService=w,this.productService=h,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=g.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const m=D.Event.fromNodeEventEmitter(S.app,"login",(E,I,w,h,l)=>({event:E,webContents:I,req:w,authInfo:h,callback:l}));this._register(m(this.onLogin,this))}async onLogin({event:m,authInfo:E,req:I,callback:w}){if(!E.isProxy)return;if(!this.pendingProxyResolve&&this.state===g.LoginDialogShown&&I.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let h;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(E);try{h=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}w(h?.username,h?.password)}async resolveProxyCredentials(m){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const E=await this.doResolveProxyCredentials(m);if(E)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),E;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(m){this.logService.trace("auth#doResolveProxyCredentials - enter",m);const E=String((0,R.hash)({scheme:m.scheme,host:m.host,port:m.port}));let I,w;try{const n=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,E);if(n){const i=JSON.parse(await this.encryptionMainService.decrypt(n));I=i.username,w=i.password}}catch(n){this.logService.error(n)}if(this.state!==g.StoredCredentialsUsed&&typeof I=="string"&&typeof w=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=g.StoredCredentialsUsed,{username:I,password:w};const h=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!h){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const l={authInfo:m,username:this.sessionCredentials?.username??I,password:this.sessionCredentials?.password??w,replyChannel:`vscode:proxyAuthResponse:${(0,v.generateUuid)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,l),this.state=g.LoginDialogShown;const r=await new Promise(n=>{const i=async(s,o,a)=>{if(o===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",i),a){const c={username:a.username,password:a.password};try{if(a.remember){const d=await this.encryptionMainService.encrypt(JSON.stringify(c));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,E,d)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,E)}catch(d){this.logService.error(d)}n({username:c.username,password:c.password})}else n(void 0)};h.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=r,r}};u=fe([x(0,C.ILogService),x(1,y.IWindowsMainService),x(2,f.ICredentialsMainService),x(3,p.IEncryptionMainService),x(4,k.IProductService)],u),e.ProxyAuthHandler=u}),define(X[236],J([0,1,68,6,39,20,32,192]),function(z,e,S,t,D,R,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let f=class extends v.BaseCredentialsMainService{constructor(C,k,y,g){super(C);this.environmentMainService=k,this.productService=y,this.windowsMainService=g,this.surfaceKeytarLoadError=u=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",u.message??u)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new S.InMemoryCredentialsProvider,this._keytarCache;const C=await new Promise((k,y)=>{z(["keytar"],k,y)});return await C.findCredentials("test-keytar-loads"),this._keytarCache=C,this._keytarCache}};f=fe([x(0,t.ILogService),x(1,D.INativeEnvironmentService),x(2,R.IProductService),x(3,M.IWindowsMainService)],f),e.CredentialsNativeMainService=f}),define(X[237],J([0,1,19,2,3,6,22,78,42,126,8,12,50,4,36,14,32]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const E=b.UtilityProcess,I=typeof E!="undefined";let w=class Rt{constructor(n,i,s){this._logService=n,this._windowsMainService=s,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(o=>{this._shutdown=!0,o.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(n){const i=this._extHosts.get(n);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(n){return this._getExtHost(n).onStdout}onDynamicStderr(n){return this._getExtHost(n).onStderr}onDynamicMessage(n){return this._getExtHost(n).onMessage}onDynamicError(n){return this._getExtHost(n).onError}onDynamicExit(n){return this._getExtHost(n).onExit}async canUseUtilityProcess(){return I}async createExtensionHost(n){if(this._shutdown)throw(0,S.canceled)();const i=String(++Rt._lastId);let s;if(n){if(!I)throw new Error("Cannot use UtilityProcess!");s=new l(i,this._logService,this._windowsMainService)}else s=new h(i,this._logService);return this._extHosts.set(i,s),s.onExit(({pid:o,code:a,signal:c})=>{this._logService.info(`Extension host with pid ${o} exited with code: ${a}, signal: ${c}.`),setTimeout(()=>{s.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(n,i){if(this._shutdown)throw(0,S.canceled)();return this._getExtHost(n).start(i)}async enableInspectPort(n){if(this._shutdown)throw(0,S.canceled)();const i=this._extHosts.get(n);return i?i.enableInspectPort():!1}async kill(n){if(this._shutdown)throw(0,S.canceled)();const i=this._extHosts.get(n);!i||i.kill()}async _killAllNow(){for(const[,n]of this._extHosts)n.kill()}async _waitForAllExit(n){const i=[];for(const[,s]of this._extHosts)i.push(s.waitForExit(n));return C.Promises.settled(i).then(()=>{})}};w._lastId=0,w=fe([x(0,R.ILogService),x(1,M.ILifecycleMainService),x(2,m.IWindowsMainService)],w),e.ExtensionHostStarter=w;let h=class extends t.Disposable{constructor(n,i){super();this.id=n,this._logService=i,this._onStdout=this._register(new D.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new D.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new D.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._onExit=this._register(new D.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(n){g.isCI&&this._logService.info("Calling fork to start extension host...");const i=v.StopWatch.create(!1);this._process=(0,f.fork)(k.FileAccess.asFileUri("bootstrap-fork",z).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,y.mixin)({cwd:(0,u.cwd)()},n));const s=i.elapsed(),o=this._process.pid;this._logService.info(`Starting extension host with pid ${o} (fork() took ${s} ms).`);const a=new p.StringDecoder("utf-8");this._process.stdout?.on("data",d=>{const P=typeof d=="string"?d:a.write(d);this._onStdout.fire(P)});const c=new p.StringDecoder("utf-8");this._process.stderr?.on("data",d=>{const P=typeof d=="string"?d:c.write(d);this._onStderr.fire(P)}),this._process.on("message",d=>{this._onMessage.fire(d)}),this._process.on("error",d=>{this._onError.fire({error:(0,S.transformErrorForSerialization)(d)})}),this._process.on("exit",(d,P)=>{this._hasExited=!0,this._onExit.fire({pid:o,code:d,signal:P})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(n){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([D.Event.toPromise(this.onExit),(0,C.timeout)(n)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${n}ms.`),this._process.kill())}};h=fe([x(1,R.ILogService)],h);let l=class extends t.Disposable{constructor(n,i,s){super();this.id=n,this._logService=i,this._windowsMainService=s,this.onStdout=D.Event.None,this.onStderr=D.Event.None,this.onError=D.Event.None,this._onMessage=this._register(new D.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new D.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(n){const i=this._windowsMainService.getWindowById(n.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=i.win;if(!s||s.isDestroyed()||s.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const o=`extensionHost${this.id}`,a=k.FileAccess.asFileUri("bootstrap-fork.js",z).fsPath,c=["--type=extensionHost","--skipWorkspaceStorageLock"],d=n.execArgv||[],P={...n.env};for(const q of Object.keys(P))P[q]=String(P[q]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new E(a,c,{serviceName:o,env:P,execArgv:d}),this._register(D.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)})),this._register(D.Event.fromNodeEventEmitter(this._process,"exit")(q=>{q=q||0,this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${q}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:q,signal:""})}));const L=(q,ee)=>{ee.type==="Utility"&&ee.name===o&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${ee.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:ee.exitCode,signal:""}))};b.app.on("child-process-gone",L),this._register((0,t.toDisposable)(()=>{b.app.off("child-process-gone",L)}));const{port1:T,port2:W}=new b.MessageChannelMain;this._process.postMessage("port",null,[W]),s.webContents.postMessage(n.responseChannel,n.responseNonce,[T])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(n){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([D.Event.toPromise(this.onExit),(0,C.timeout)(n)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${n}ms, will kill it now.`),this._process.kill())}};l=fe([x(1,R.ILogService),x(2,m.IWindowsMainService)],l)}),define(X[238],J([0,1,14,3,2,234,32]),function(z,e,S,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let v=class extends D.Disposable{constructor(p){super();this.windowsMainService=p,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(p,C){let k;if(typeof p.windowId=="number"){const{windowId:y}=p,g=this.windowsMainService.getWindowById(y);if(!g?.win)throw new Error(`Invalid windowId: ${y}`);k=g.win.webContents}else{const{webContentsId:y}=p;if(k=S.webContents.fromId(y),!k)throw new Error(`Invalid webContentsId: ${y}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(C)}async findInFrame(p,C,k,y){const u=this.getFrameByName(p,C);if(typeof u.findInFrame=="function"){u.findInFrame(k,{findNext:y.findNext,forward:y.forward});const b=(m,E)=>{E.finalUpdate&&(this._onFoundInFrame.fire(E),u.removeListener("found-in-frame",b))};u.on("found-in-frame",b)}}async stopFindInFrame(p,C,k){const g=this.getFrameByName(p,C);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(k.keepSelection?"keepSelection":"clearSelection")}getFrameByName(p,C){const k=this.windowsMainService.getWindowById(p.windowId);if(!k?.win)throw new Error(`Invalid windowId: ${p}`);const y=k.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===C);if(!y)throw new Error(`Unknown frame: ${C}`);return y}};v=fe([x(0,M.IWindowsMainService)],v),e.WebviewMainService=v}),define(X[239],J([0,1,8,3,2]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends D.Disposable{constructor({onDidOpenWindow:v,onDidFocusWindow:f,getActiveWindowId:p}){super();this.disposables=this._register(new D.DisposableStore),t.Event.latch(t.Event.any(v,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,S.createCancelablePromise)(()=>p()),(async()=>{try{const k=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:k}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(v){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=v}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(X[24],J([0,1,168,9,33,16,7,5,12]),function(z,e,S,t,D,R,M,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,v.createDecorator)("contextService");function p(i){const s=i;return typeof s?.id=="string"&&M.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=p;function C(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=C;function k(i){const s=i;return typeof s?.id=="string"&&M.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=k;function y(i){const s=i;if(s?.uri)return{id:s.id,uri:M.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:M.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=y;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function u(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=u;function b(i){const s=i;return!!(s&&typeof s=="object"&&M.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=b;class m{constructor(s,o,a,c,d){this._id=s,this._transient=a,this._configuration=c,this._ignorePathCasing=d,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=m;class E{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,R.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=E;function I(i){return new E({uri:i,index:0,name:(0,R.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=I,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function h(i,s){return R.extUriBiasedIgnorePathCase.isEqualOrParent(i,s.untitledWorkspacesHome)}e.isUntitledWorkspace=h;function l(i){let s;return M.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=l;function r(i,s){return!h(i,s)&&!l(i)}e.isSavedWorkspace=r;function n(i){return(typeof i=="string"?(0,t.extname)(i):(0,R.extname)(i))===w}e.hasWorkspaceFileExtension=n}),define(X[240],J([0,1,75,28,30,12,9,4,16,7,23,172,18,26,15,6,171,24]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let I=class{constructor(h,l,r){this.configurationService=l,this.logService=r,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(n,i)=>(0,D.isEqual)(n,i,!v.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await C.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let l=[];try{Array.isArray(h.rootURIWorkspaces)&&(l=h.rootURIWorkspaces.map(n=>({workspace:{id:n.id,configPath:p.URI.parse(n.configURIPath)},remoteAuthority:n.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(l);let r=[];try{Array.isArray(h.folderWorkspaceInfos)?r=h.folderWorkspaceInfos.map(n=>({folderUri:p.URI.parse(n.folderUri),remoteAuthority:n.remoteAuthority})):Array.isArray(h.folderURIWorkspaces)&&(r=h.folderURIWorkspaces.map(n=>({folderUri:p.URI.parse(n),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(r),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==u.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,l){this.workspaces.some(n=>h.workspace.id===n.workspace.id)||(this.workspaces.push(h),this.saveSync());const r=this.getBackupPath(h.workspace.id);return l&&this.moveBackupFolderSync(r,l),r}moveBackupFolderSync(h,l){if(t.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),t.existsSync(l))try{t.renameSync(l,h)}catch(r){this.logService.error(`Backup: Could not move backup folder to new location: ${r.toString()}`)}}unregisterWorkspaceBackupSync(h){const l=h.id,r=this.workspaces.findIndex(n=>n.workspace.id===l);r!==-1&&(this.workspaces.splice(r,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(l=>this.backupUriComparer.isEqual(h.folderUri,l.folderUri))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const l=this.folders.findIndex(r=>this.backupUriComparer.isEqual(h,r.folderUri));l!==-1&&(this.folders.splice(l,1),this.saveSync())}registerEmptyWindowBackupSync(h,l){const r=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,r))||(this.emptyWindows.push({backupFolder:r,remoteAuthority:l}),this.saveSync()),this.getBackupPath(r)}unregisterEmptyWindowBackupSync(h){const l=this.emptyWindows.findIndex(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,h));l!==-1&&(this.emptyWindows.splice(l,1),this.saveSync())}getBackupPath(h){return(0,M.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const l=new Set,r=[];for(const n of h){const i=n.workspace;if(!(0,E.isWorkspaceIdentifier)(i))return[];if(!l.has(i.id)){l.add(i.id);const s=this.getBackupPath(i.id);await this.doHasBackups(s)?i.configPath.scheme!==R.Schemas.file||await C.Promises.exists(i.configPath.fsPath)?r.push(n):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return r}async validateFolders(h){if(!Array.isArray(h))return[];const l=[],r=new Set;for(const n of h){const i=n.folderUri,s=this.backupUriComparer.getComparisonKey(i);if(!r.has(s)){r.add(s);const o=this.getBackupPath(this.getFolderHash(n));await this.doHasBackups(o)?i.scheme!==R.Schemas.file||await C.Promises.exists(i.fsPath)?l.push(n):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return l}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const l=[],r=new Set;for(const n of h){const i=n.backupFolder;if(typeof i!="string")return[];if(!r.has(i)){r.add(i);const s=this.getBackupPath(i);await this.doHasBackups(s)?l.push(n):await this.deleteStaleBackup(s)}}return l}async deleteStaleBackup(h){try{await C.Promises.exists(h)&&await C.Promises.rm(h,C.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}async convertToEmptyWindowBackup(h){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,l));)l=this.getRandomEmptyWindowId();const r=this.getBackupPath(l);try{await C.Promises.rename(h,r)}catch(n){return this.logService.error(`Backup: Could not rename backup folder: ${n.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}convertToEmptyWindowBackupSync(h){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,l));)l=this.getRandomEmptyWindowId();const r=this.getBackupPath(l);try{t.renameSync(h,r)}catch(n){return this.logService.error(`Backup: Could not rename backup folder: ${n.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}async getDirtyWorkspaces(){const h=[];for(const l of this.workspaces)await this.hasBackups(l)&&h.push(l);for(const l of this.folders)await this.hasBackups(l)&&h.push(l);return h}hasBackups(h){let l;return(0,k.isEmptyWindowBackupInfo)(h)?l=h.backupFolder:(0,m.isFolderBackupInfo)(h)?l=this.getBackupPath(this.getFolderHash(h)):l=this.getBackupPath(h.workspace.id),this.doHasBackups(l)}async doHasBackups(h){try{const l=await C.Promises.readdir(h);for(const r of l)try{if((await C.Promises.readdir((0,M.join)(h,r))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,C.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await C.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderWorkspaceInfos:this.folders.map(h=>({folderUri:h.folderUri.toString(),remoteAuthority:h.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){const l=h.folderUri;let r;return l.scheme===R.Schemas.file?r=v.isLinux?l.fsPath:l.fsPath.toLowerCase():r=l.toString().toLowerCase(),(0,S.createHash)("md5").update(r).digest("hex")}};I=fe([x(0,g.IEnvironmentMainService),x(1,y.IConfigurationService),x(2,b.ILogService)],I),e.BackupMainService=I}),define(X[53],J([0,1,14,8,65,34,2,79,4,13,23,148,5,6,24]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let b=class{constructor(E){this.logService=E,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(E,I){return this.doPick({...E,pickFolders:!0,pickFiles:!0,title:(0,k.localize)(0,null)},I)}pickFolder(E,I){return this.doPick({...E,pickFolders:!0,title:(0,k.localize)(1,null)},I)}pickFile(E,I){return this.doPick({...E,pickFiles:!0,title:(0,k.localize)(2,null)},I)}pickWorkspace(E,I){const w=(0,k.localize)(3,null),h=(0,R.mnemonicButtonLabel)((0,k.localize)(4,null)),l=u.WORKSPACE_FILTER;return this.doPick({...E,pickFiles:!0,title:w,filters:l,buttonLabel:h},I)}async doPick(E,I){const w={title:E.title,buttonLabel:E.buttonLabel,filters:E.filters,defaultPath:E.defaultPath};(typeof E.pickFiles=="boolean"||typeof E.pickFolders=="boolean")&&(w.properties=void 0,E.pickFiles&&E.pickFolders&&(w.properties=["multiSelections","openDirectory","openFile","createDirectory"])),w.properties||(w.properties=["multiSelections",E.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&w.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(w,(0,p.withNullAsUndefined)(I||S.BrowserWindow.getFocusedWindow()));if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}getWindowDialogQueue(E){if(E){let I=this.windowDialogQueues.get(E.id);return I||(I=new t.Queue,this.windowDialogQueues.set(E.id,I)),I}else return this.noWindowDialogueQueue}showMessageBox(E,I){return this.getWindowDialogQueue(I).queue(async()=>I?S.dialog.showMessageBox(I,E):S.dialog.showMessageBox(E))}async showSaveDialog(E,I){const w=this.acquireFileDialogLock(E,I);if(!w)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(I).queue(async()=>{let h;return I?h=await S.dialog.showSaveDialog(I,E):h=await S.dialog.showSaveDialog(E),h.filePath=this.normalizePath(h.filePath),h})}finally{(0,M.dispose)(w)}}normalizePath(E){return E&&f.isMacintosh&&(E=(0,v.normalizeNFC)(E)),E}normalizePaths(E){return E.map(I=>this.normalizePath(I))}async showOpenDialog(E,I){E.defaultPath&&(await C.Promises.exists(E.defaultPath)||(E.defaultPath=void 0));const w=this.acquireFileDialogLock(E,I);if(!w)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(I).queue(async()=>{let h;return I?h=await S.dialog.showOpenDialog(I,E):h=await S.dialog.showOpenDialog(E),h.filePaths=this.normalizePaths(h.filePaths),h})}finally{(0,M.dispose)(w)}}acquireFileDialogLock(E,I){if(!I)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",E);let w=this.windowFileDialogLocks.get(I.id);w||(w=new Set,this.windowFileDialogLocks.set(I.id,w));const h=(0,D.hash)(E);if(!w.has(h))return this.logService.trace("[DialogMainService]: new file dialog lock created",E),w.add(h),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",E),w?.delete(h),w?.size===0&&this.windowFileDialogLocks.delete(I.id)})}};b=fe([x(0,g.ILogService)],b),e.DialogMainService=b}),define(X[241],J([0,1,3,2,66,24]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends t.Disposable{constructor(f,p){super();this.logService=f,this.storageMainService=p,this.onDidChangeApplicationStorageEmitter=this._register(new S.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(p.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(f,p){this._register(S.Event.debounce(f.onDidChangeStorage,(C,k)=>(C?C.push(k):C=[k],C),M.STORAGE_CHANGE_DEBOUNCE_TIME)(C=>{C.length&&p.fire(this.serializeStorageChangeEvents(C,f))}))}serializeStorageChangeEvents(f,p){const C=new Map,k=new Set;return f.forEach(y=>{const g=p.get(y.key);typeof g=="string"?C.set(y.key,g):k.add(y.key)}),{changed:Array.from(C.entries()),deleted:Array.from(k.values())}}listen(f,p,C){switch(p){case"onDidChangeStorage":{const k=C.profile?(0,D.revive)(C.profile):void 0;if(!k)return this.onDidChangeApplicationStorageEmitter.event;let y=this.mapProfileToOnDidChangeProfileStorageEmitter.get(k.id);return y||(y=this._register(new S.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(k),y),this.mapProfileToOnDidChangeProfileStorageEmitter.set(k.id,y)),y.event}}throw new Error(`Event not found: ${p}`)}async call(f,p,C){const k=C.profile?(0,D.revive)(C.profile):void 0,y=(0,R.reviveIdentifier)(C.workspace),g=await this.withStorageInitialized(k,y);switch(p){case"getItems":return Array.from(g.items.entries());case"updateItems":{const u=C;if(u.insert)for(const[b,m]of u.insert)g.set(b,m);u.delete?.forEach(b=>g.delete(b));break}default:throw new Error(`Call not found: ${p}`)}}async withStorageInitialized(f,p){let C;p?C=this.storageMainService.workspaceStorage(p):f?C=this.storageMainService.profileStorage(f):C=this.storageMainService.applicationStorage;try{await C.init()}catch(k){this.logService.error(`StorageIPC#init: Unable to init ${p?"workspace":f?"profile":"application"} storage due to ${k}`)}return C}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(X[40],J([0,1,65,3,2,16,13,7,165,39,15,5,6,24,33,62,8,27]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function I(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&v.URI.isUri(n.location)&&v.URI.isUri(n.globalStorageHome)&&v.URI.isUri(n.settingsResource)&&v.URI.isUri(n.keybindingsResource)&&v.URI.isUri(n.tasksResource)&&v.URI.isUri(n.snippetsHome)&&((0,M.isUndefined)(n.extensionsResource)||v.URI.isUri(n.extensionsResource)))}e.isUserDataProfile=I,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,k.createDecorator)("IUserDataProfilesService");function w(r,n){return{id:r.id,isDefault:r.isDefault,name:r.name,location:v.URI.revive(r.location).with({scheme:n}),globalStorageHome:v.URI.revive(r.globalStorageHome).with({scheme:n}),settingsResource:v.URI.revive(r.settingsResource).with({scheme:n}),keybindingsResource:v.URI.revive(r.keybindingsResource).with({scheme:n}),tasksResource:v.URI.revive(r.tasksResource).with({scheme:n}),snippetsHome:v.URI.revive(r.snippetsHome).with({scheme:n}),extensionsResource:v.URI.revive(r.extensionsResource)?.with({scheme:n})}}e.reviveProfile=w,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function h(r,n,i){return{id:(0,S.hash)(n.path).toString(16),name:r,location:n,isDefault:!1,globalStorageHome:(0,R.joinPath)(n,"globalStorage"),settingsResource:(0,R.joinPath)(n,"settings.json"),keybindingsResource:(0,R.joinPath)(n,"keybindings.json"),tasksResource:(0,R.joinPath)(n,"tasks.json"),snippetsHome:(0,R.joinPath)(n,"snippets"),extensionsResource:(0,R.joinPath)(n,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:i}}e.toUserDataProfile=h;let l=class extends D.Disposable{constructor(n,i,s,o){super();this.environmentService=n,this.fileService=i,this.uriIdentityService=s,this.logService=o,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return this.profilesObject.profiles}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(a=>h(a.name,a.location,a.useDefaultFlags)):[];let i;const s=new u.ResourceMap;if(n.length){const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[c,d]of Object.entries(a.workspaces)){const P=v.URI.parse(c),L=v.URI.parse(d),T=n.find(W=>this.uriIdentityService.extUri.isEqual(W.location,L));T&&s.set(P,T)}if(a.emptyWindow){const c=v.URI.parse(a.emptyWindow);i=n.find(d=>this.uriIdentityService.extUri.isEqual(d.location,c))}}const o=h((0,f.localize)(0,null),this.environmentService.userRoamingDataHome);n.unshift({...o,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0?o.extensionsResource:void 0}),this._profilesObject={profiles:n,workspaces:s,emptyWindow:i}}return this._profilesObject}getProfile(n){const i=this.getWorkspace(n);return(v.URI.isUri(i)?this.profilesObject.workspaces.get(i):this.profilesObject.emptyWindow)??this.defaultProfile}getWorkspace(n){return(0,g.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,g.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}async createProfile(n,i,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(this.getStoredProfiles().some(c=>c.name===n))throw new Error(`Profile with name ${n} already exists`);const o=h(n,(0,R.joinPath)(this.profilesHome,(0,S.hash)((0,E.generateUuid)()).toString(16)),i);await this.fileService.createFolder(o.location);const a=[];return this._onWillCreateProfile.fire({profile:o,join(c){a.push(c)}}),await m.Promises.settled(a),this.updateProfiles([o],[],[]),s&&await this.setProfileForWorkspace(o,s),o}async updateProfile(n,i,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(a=>a.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);return o=h(i,o.location,s),this.updateProfiles([],[],[o]),o}async setProfileForWorkspace(n,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(o=>o.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);this.updateWorkspaceAssociation(i,s)}async unsetWorkspace(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n)}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const i=this.profiles.find(o=>o.id===n.id);if(!i)throw new Error(`Profile '${n.name}' does not exist`);const s=[];this._onWillRemoveProfile.fire({profile:i,join(o){s.push(o)}}),await m.Promises.settled(s),i.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const o of[...this.profilesObject.workspaces.keys()])i.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[i],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(i.location,{recursive:!0})}catch(o){this.logService.error(o)}}updateProfiles(n,i,s){const o=[];for(let a of[...this.profilesObject.profiles,...n])a.isDefault||i.some(c=>a.id===c.id)||(a=s.find(c=>a.id===c.id)??a,o.push({location:a.location,name:a.name,useDefaultFlags:a.useDefaultFlags}));this.saveStoredProfiles(o),this._profilesObject=void 0,this.triggerProfilesChanges(n,i,s)}triggerProfilesChanges(n,i,s){this._onDidChangeProfiles.fire({added:n,removed:i,updated:s,all:this.profiles})}updateWorkspaceAssociation(n,i){const s=this.getWorkspace(n);v.URI.isUri(s)?(this.profilesObject.workspaces.delete(s),i&&!i.isDefault&&this.profilesObject.workspaces.set(s,i)):this.profilesObject.emptyWindow=i?.isDefault?void 0:i,this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[s,o]of this.profilesObject.workspaces.entries())n[s.toString()]=o.location.toString();const i=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:i}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};l.PROFILES_KEY="userDataProfiles",l.PROFILE_ASSOCIATIONS_KEY="profileAssociations",l=fe([x(0,p.IEnvironmentService),x(1,C.IFileService),x(2,b.IUriIdentityService),x(3,y.ILogService)],l),e.UserDataProfilesService=l}),define(X[242],J([0,1,14,38,2,33,12,9,4,7,27,39,6,40]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let u=class extends D.Disposable{constructor(m,E,I){super();this.logService=I,this.validRoots=R.TernarySearchTree.forPaths(!f.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(m.appRoot),this.addValidFileRoot(m.extensionsPath),this.addValidFileRoot(E.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(m.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:m}=S.session;m.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(E,I)=>this.handleResourceRequest(E,I)),m.protocol.interceptFileProtocol(M.Schemas.file,(E,I)=>this.handleFileRequest(E,I)),this._register((0,D.toDisposable)(()=>{m.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),m.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(m){const E=(0,v.normalize)(m);return this.validRoots.get(E)?D.Disposable.None:(this.validRoots.set(E,!0),(0,D.toDisposable)(()=>this.validRoots.delete(E)))}handleFileRequest(m,E){const I=p.URI.parse(m.url);return this.logService.error(`Refused to load resource ${I.fsPath} from ${M.Schemas.file}: protocol (original URL: ${m.url})`),E({error:-3})}handleResourceRequest(m,E){const I=this.requestToNormalizedFilePath(m);return this.validRoots.findSubstr(I)?E({path:I}):this.validExtensions.has((0,v.extname)(I))?E({path:I}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${I} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${m.url})`),E({error:-3}))}requestToNormalizedFilePath(m){const E=p.URI.parse(m.url),I=M.FileAccess.asFileUri(E);return(0,v.normalize)(I.fsPath)}createIPCObjectUrl(){let m;const E=p.URI.from({scheme:"vscode",path:(0,C.generateUuid)()}),I=E.toString(),w=async()=>m;return t.validatedIpcMain.handle(I,w),this.logService.trace(`IPC Object URL: Registered new channel ${I}.`),{resource:E,update:h=>m=h,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${I}.`),t.validatedIpcMain.removeHandler(I)}}}};u=fe([x(0,k.INativeEnvironmentService),x(1,g.IUserDataProfilesService),x(2,y.ILogService)],u),e.ProtocolMainService=u}),define(X[243],J([0,1,14,38,8,3,2,12,13,96,26,22,6,58,59,61,41,40,37]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let w=class extends M.Disposable{constructor(l,r,n,i,s,o,a,c,d){super();this.machineId=l,this.userEnv=r,this.environmentMainService=n,this.userDataProfilesService=i,this.lifecycleMainService=s,this.logService=o,this.policyService=a,this.themeMainService=c,this.protocolMainService=d,this.firstWindowConnectionBarrier=new D.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(l,r)=>this.onWindowConnection(l,r)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(l,r)=>this.onWorkerConnection(l,r)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(l,r){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const n=await this.connect();if(l.sender.isDestroyed())return n.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",r,[n])}onWorkerConnection(l,r){this.logService.trace("SharedProcess: onWorkerConnection",r);const n=new M.DisposableStore,i=o=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${o}')`,r),n.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",r))},s=S.BrowserWindow.fromId(r.reply.windowId);if(!s||s.isDestroyed()||s.webContents.isDestroyed()||!r.reply.channel){i("unavailable");return}n.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,o=>o.window.win===s)(()=>i("load"))),n.add(R.Event.fromNodeEventEmitter(s,"closed")(()=>i("closed"))),s.webContents.postMessage(r.reply.channel,r.reply.nonce,l.ports)}onWillShutdown(){const l=this.window;!l||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(l.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{l.close()}catch{}this.window=void 0},0))}send(l,...r){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${l}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(l,...r)}catch(n){this.logService.warn(`Error sending IPC message to channel '${l}' of shared process: ${(0,m.toErrorMessage)(n)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),l()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),l()}))})()),this._whenIpcReady}createWindow(){const l=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new S.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:v.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),l.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:g.default,policiesData:this.policyService.serialize()}),this.window.loadURL(v.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",z).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=l=>{this.logService.trace("SharedProcess#close prevented"),l.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(l,r)=>this._onDidError.fire({type:2,details:r})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(l,r,n)=>this._onDidError.fire({type:3,details:{reason:n,exitCode:r}})))}async connect(){await this.whenIpcReady;const l=(0,f.assertIsDefined)(this.window);return(0,p.connect)(l)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const l=this.window;return l?!l.isDestroyed()&&!l.webContents.isDestroyed():!1}};w=fe([x(2,C.IEnvironmentMainService),x(3,E.IUserDataProfilesService),x(4,k.ILifecycleMainService),x(5,y.ILogService),x(6,I.IPolicyService),x(7,b.IThemeMainService),x(8,u.IProtocolMainService)],w),e.SharedProcess=w}),define(X[111],J([0,1,8,3,2,70,13,97,5,40]),function(z,e,S,t,D,R,M,v,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,f.createDecorator)("storageService");var k;(function(I){I[I.NONE=0]="NONE",I[I.SHUTDOWN=1]="SHUTDOWN"})(k=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(I){I[I.APPLICATION=-1]="APPLICATION",I[I.PROFILE=0]="PROFILE",I[I.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var g;(function(I){I[I.USER=0]="USER",I[I.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class u extends D.Disposable{constructor(w={flushInterval:u.DEFAULT_FLUSH_INTERVAL}){super();this.options=w,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new S.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,S.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(w,h){if(h===C){switch(w){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:w})}else this._onDidChangeValue.fire({scope:w,key:h,target:this.getKeyTargets(w)[h]})}emitWillSaveState(w){this._onWillSaveState.fire({reason:w})}get(w,h,l){return this.getStorage(h)?.get(w,l)}getBoolean(w,h,l){return this.getStorage(h)?.getBoolean(w,l)}getNumber(w,h,l){return this.getStorage(h)?.getNumber(w,l)}store(w,h,l,r){if((0,M.isUndefinedOrNull)(h)){this.remove(w,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(w,l,r),this.getStorage(l)?.set(w,h)})}remove(w,h){this.withPausedEmitters(()=>{this.updateKeyTarget(w,h,void 0),this.getStorage(h)?.delete(w)})}withPausedEmitters(w){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{w()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(w,h){const l=[],r=this.getKeyTargets(w);for(const n of Object.keys(r))r[n]===h&&l.push(n);return l}updateKeyTarget(w,h,l){const r=this.getKeyTargets(h);typeof l=="number"?r[w]!==l&&(r[w]=l,this.getStorage(h)?.set(C,JSON.stringify(r))):typeof r[w]=="number"&&(delete r[w],this.getStorage(h)?.set(C,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(w){switch(w){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(w){const h=this.get(C,w);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(w=k.NONE){this._onWillSaveState.fire({reason:w});const h=this.getStorage(-1),l=this.getStorage(0),r=this.getStorage(1);switch(w){case k.NONE:await S.Promises.settled([h?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case k.SHUTDOWN:await S.Promises.settled([h?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.getStorage(-1)?.items??new Map,h=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return E(w,h,l,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(w,h){return this.emitWillSaveState(k.NONE),(0,p.isUserDataProfile)(w)?this.switchToProfile(w,h):this.switchToWorkspace(w,h)}canSwitchProfile(w,h){return!(w.id===h.id||b(h)&&b(w))}switchData(w,h,l,r){this.withPausedEmitters(()=>{if(r)for(const[n,i]of w)h.set(n,i);else{const n=new Set;for(const[i,s]of w)n.add(i),h.get(i)!==s&&this.emitDidChangeValue(l,i);for(const[i]of h.items)n.has(i)||this.emitDidChangeValue(l,i)}})}}e.AbstractStorageService=u,u.DEFAULT_FLUSH_INTERVAL=60*1e3;function b(I){return I.isDefault||!!I.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=b;class m extends u{constructor(){super();this.applicationStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this.profileStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(w=>this.emitDidChangeValue(1,w))),this._register(this.profileStorage.onDidChangeStorage(w=>this.emitDidChangeValue(0,w))),this._register(this.applicationStorage.onDidChangeStorage(w=>this.emitDidChangeValue(-1,w)))}getStorage(w){switch(w){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=m;async function E(I,w,h,l,r,n){const i=W=>{try{return JSON.parse(W)}catch{return W}},s=new Map,o=new Map;I.forEach((W,q)=>{s.set(q,W),o.set(q,i(W))});const a=new Map,c=new Map;w.forEach((W,q)=>{a.set(q,W),c.set(q,i(W))});const d=new Map,P=new Map;h.forEach((W,q)=>{d.set(q,W),P.set(q,i(W))}),console.group(l!==r?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const L=[];if(s.forEach((W,q)=>{L.push({key:q,value:W})}),console.table(L),console.groupEnd(),console.log(o),l!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const W=[];a.forEach((q,ee)=>{W.push({key:ee,value:q})}),console.table(W),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${n})`);const T=[];d.forEach((W,q)=>{T.push({key:q,value:W})}),console.table(T),console.groupEnd(),console.log(P)}e.logStorage=E}),define(X[244],J([0,1,25,8,3,2,9,78,7,23,97,142,6,111,35,24]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class m extends R.Disposable{constructor(n,i){super();this.logService=n,this.fileService=i,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new D.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new C.Storage(new C.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=C.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===C.StorageState.None)try{const n=await this.doCreate();this._storage.dispose(),this._storage=n,this._register(n.onDidChangeStorage(s=>this._onDidChangeStorage.fire({key:s}))),await this.doInit(n);const i=n.getBoolean(g.IS_NEW_KEY);i===void 0?n.set(g.IS_NEW_KEY,!0):i&&n.set(g.IS_NEW_KEY,!1)}catch(n){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${n}`)}finally{this.state=C.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===y.LogLevel.Trace?n=>this.logService.trace(n):void 0,logError:n=>this.logService.error(n)}}doInit(n){return n.init()}get items(){return this._storage.items}get(n,i){return this._storage.get(n,i)}set(n,i){return this._storage.set(n,i)}delete(n){return this._storage.delete(n)}async close(){const n=new v.StopWatch(!1);await this.doClose(),n.stop(),n.elapsed()>m.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(n),this._onDidCloseStorage.fire()}async logSlowClose(n){if(!!this.path)try{const i=(0,S.top)(Array.from(this._storage.items.entries()).map(([o,a])=>({key:o,length:a.length})),(o,a)=>a.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),s=(await this.fileService.stat(f.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${n.elapsed()}ms, DB size: ${s}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=C.StorageState.Closed,await this._storage.close()}}m.LOG_SLOW_CLOSE_THRESHOLD=2e3;class E extends m{constructor(n,i,s,o){super(s,o);this.profile=n,this.options=i}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.profile.globalStorageHome.fsPath,E.STORAGE_NAME)}async doCreate(){return new C.Storage(new k.SQLiteStorageDatabase(this.path??k.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}E.STORAGE_NAME="state.vscdb";class I extends E{constructor(n,i,s,o){super(n,i,s,o)}}e.ProfileStorageMain=I;class w extends E{constructor(n,i,s,o){super(i.defaultProfile,n,s,o)}async doInit(n){await super.doInit(n),this.updateTelemetryState(n)}updateTelemetryState(n){n.get(u.firstSessionDateStorageKey,void 0)===void 0&&n.set(u.firstSessionDateStorageKey,new Date().toUTCString());const s=n.get(u.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();n.set(u.lastSessionDateStorageKey,typeof s=="undefined"?null:s),n.set(u.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=w;class h extends m{constructor(n,i,s,o,a){super(s,a);this.workspace=n,this.options=i,this.environmentService=o}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,h.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:n,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new C.Storage(new k.SQLiteStorageDatabase(n,{logging:this.createLoggingOptions()}),{hint:i?C.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:k.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const n=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,M.join)(n,h.WORKSPACE_STORAGE_NAME);return await p.Promises.exists(n)?{storageFilePath:i,wasCreated:!1}:(await p.Promises.mkdir(n,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(n),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(n){let i;if((0,b.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const s=(0,M.join)(n,h.WORKSPACE_META_NAME);await p.Promises.exists(s)||await p.Promises.writeFile(s,JSON.stringify(i,void 0,2))}catch(s){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}e.WorkspaceStorageMain=h,h.WORKSPACE_STORAGE_NAME="state.vscdb",h.WORKSPACE_META_NAME="workspace.json";class l extends m{get path(){}async doCreate(){return new C.Storage(new C.InMemoryStorageDatabase)}}e.InMemoryStorageMain=l}),define(X[245],J([0,1,66,39,15,6,215,62,40]),function(z,e,S,t,D,R,M,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let p=class kt extends f.UserDataProfilesService{constructor(k,y,g,u,b){super(g,u,y,b);this.stateService=k}getStoredProfiles(){return(0,S.revive)(this.stateService.getItem(kt.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,S.revive)(this.stateService.getItem(kt.PROFILE_ASSOCIATIONS_KEY,{}))}};p=fe([x(0,M.IStateService),x(1,v.IUriIdentityService),x(2,t.IEnvironmentService),x(3,D.IFileService),x(4,R.ILogService)],p),e.UserDataProfilesService=p}),define(X[63],J([0,1,7,39,15,5,6,45,62,40,245]),function(z,e,S,t,D,R,M,v,f,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(p.IUserDataProfilesService);let k=class Et extends C.UserDataProfilesService{constructor(g,u,b,m,E){super(g,u,b,m,E);this.stateMainService=g}isEnabled(){return this.enabled}saveStoredProfiles(g){this.stateMainService.setItem(Et.PROFILES_KEY,g)}saveStoredProfileAssociations(g){this.stateMainService.setItem(Et.PROFILE_ASSOCIATIONS_KEY,g)}getStoredProfileAssociations(){const g="workspaceAndProfileInfo",u=this.stateMainService.getItem(g,void 0);if(u){this.stateMainService.removeItem(g);const b=u.reduce((m,{workspace:E,profile:I})=>(m[S.URI.revive(E).toString()]=S.URI.revive(I).toString(),m),{});this.stateMainService.setItem(Et.PROFILE_ASSOCIATIONS_KEY,{workspaces:b})}return super.getStoredProfileAssociations()}};k=fe([x(0,v.IStateMainService),x(1,f.IUriIdentityService),x(2,t.IEnvironmentService),x(3,D.IFileService),x(4,M.ILogService)],k),e.UserDataProfilesMainService=k}),define(X[246],J([0,1,2,100,63]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let R=class extends S.Disposable{constructor(v,f){super();this.defaultExtensionsProfileInitService=v,this._register(f.onWillCreateProfile(p=>{f.profiles.length===1&&p.join(this.defaultExtensionsProfileInitService.initialize())})),this._register(f.onDidChangeProfiles(p=>{f.profiles.length===1&&this.defaultExtensionsProfileInitService.uninitialize()}))}};R=fe([x(0,t.IDefaultExtensionsProfileInitService),x(1,D.IUserDataProfilesMainService)],R),e.DefaultExtensionsProfileInitHandler=R}),define(X[88],J([0,1,48,2,39,15,5,22,6,111,244,40,63]),function(z,e,S,t,D,R,M,v,f,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let g=class extends t.Disposable{constructor(m,E,I,w,h){super();this.logService=m,this.environmentService=E,this.userDataProfilesService=I,this.lifecycleMainService=w,this.fileService=h,this.shutdownReason=void 0,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.applicationStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(m=>{m.window.profile&&this.profileStorage(m.window.profile).init(),m.workspace&&this.workspaceStorage(m.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(m=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=m.reason,m.join(this.applicationStorage.close());for(const[,E]of this.mapProfileToStorage)m.join(E.close());for(const[,E]of this.mapWorkspaceToStorage)m.join(E.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(m=>{m.join((async()=>{await this.fileService.exists(m.profile.globalStorageHome)||await this.fileService.createFolder(m.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(m=>{const E=this.mapProfileToStorage.get(m.profile.id);E&&m.join(E.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const m=new C.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,S.once)(m.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),m}profileStorage(m){if((0,p.isProfileUsingDefaultStorage)(m))return this.applicationStorage;let E=this.mapProfileToStorage.get(m.id);return E||(this.logService.trace(`StorageMainService: creating profile storage (${m.name})`),E=this.createProfileStorage(m),this.mapProfileToStorage.set(m.id,E),(0,S.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${m.name})`),this.mapProfileToStorage.delete(m.id)})),E}createProfileStorage(m){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService,this.fileService):new C.ProfileStorageMain(m,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(m){let E=this.mapWorkspaceToStorage.get(m.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${m.id})`),E=this.createWorkspaceStorage(m),this.mapWorkspaceToStorage.set(m.id,E),(0,S.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${m.id})`),this.mapWorkspaceToStorage.delete(m.id)})),E}createWorkspaceStorage(m){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService,this.fileService):new C.WorkspaceStorageMain(m,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}};g=fe([x(0,f.ILogService),x(1,D.IEnvironmentService),x(2,y.IUserDataProfilesMainService),x(3,v.ILifecycleMainService),x(4,R.IFileService)],g),e.StorageMainService=g,e.IApplicationStorageMainService=(0,M.createDecorator)("applicationStorageMainService");let u=class extends p.AbstractStorageService{constructor(m,E){super();this.userDataProfilesService=m,this.storageMainService=E,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(m){if(m===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(m){if(m===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}};u=fe([x(0,k.IUserDataProfilesService),x(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(X[112],J([0,1,16,7,24]),function(z,e,S,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function R(f,p,C){for(const y of f){const g=y.openedWorkspace;if((0,D.isWorkspaceIdentifier)(g)){const u=C(g);if(u){if(u.folders.some(b=>S.extUriBiasedIgnorePathCase.isEqualOrParent(p,b.uri)))return y}else if(S.extUriBiasedIgnorePathCase.isEqualOrParent(p,g.configPath))return y}}const k=f.filter(y=>(0,D.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqualOrParent(p,y.openedWorkspace.uri));if(k.length)return k.sort((y,g)=>-(y.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function M(f,p){for(const C of f)if((0,D.isWorkspaceIdentifier)(C.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.configPath,p)||(0,D.isSingleFolderWorkspaceIdentifier)(C.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.uri,p))return C}e.findWindowOnWorkspaceOrFolder=M;function v(f,p){const C=k=>p.some(y=>S.extUriBiasedIgnorePathCase.isEqual(t.URI.file(y),t.URI.file(k)));for(const k of f)if(k.config?.extensionDevelopmentPath?.some(y=>C(y)))return k}e.findWindowOnExtensionDevelopmentPath=v}),define(X[247],J([0,1,14,2,4,16,7,18,22,6,45,32,110,24]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let u=class Mt extends t.Disposable{constructor(h,l,r,n,i){super();this.windowsMainService=h,this.stateMainService=l,this.lifecycleMainService=r,this.logService=n,this.configurationService=i,this._state=b(this.stateMainService.getItem(Mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){S.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let n=this.windowsMainService.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),n&&(h.lastActiveWindow=this.toWindowState(n))}const l=this.windowsMainService.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);l&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(l)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>this.toWindowState(n)));const r=E(h);this.stateMainService.setItem(Mt.windowsStateStorageKey,r),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",r)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const l=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(r=>{const n=(0,g.isWorkspaceIdentifier)(h.openedWorkspace)&&r.workspace?.id===h.openedWorkspace.id,i=(0,g.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&r.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(r.folderUri,h.openedWorkspace.uri);(n||i)&&(r.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}toWindowState(h){return{workspace:(0,g.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const l=this.doGetNewWindowState(h),r=this.configurationService.getValue("window");let n;return l.hasDefaultState?n=!!(r?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(r.newWindowDimensions)>=0):(n=!!(this.lifecycleMainService.wasRestarted||r?.restoreFullscreen),n&&D.isMacintosh&&this.windowsMainService.getWindows().some(i=>i.isFullScreen)&&(n=!1)),l.mode===3&&!n&&(l.mode=1),l}doGetNewWindowState(h){const l=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=h.workspace;if((0,g.isWorkspaceIdentifier)(a)){const d=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===a.id).map(P=>P.uiState);if(d.length)return d[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(a)){const d=this.state.openedWindows.filter(P=>P.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(P.folderUri,a.uri)).map(P=>P.uiState);if(d.length)return d[0]}else if(h.backupPath){const d=this.state.openedWindows.filter(P=>P.backupPath===h.backupPath).map(P=>P.uiState);if(d.length)return d[0]}const c=this.lastClosedState||this.state.lastActiveWindow;if(!l&&c)return c.uiState}let r;const n=S.screen.getAllDisplays();if(n.length===1)r=n[0];else{if(D.isMacintosh){const a=S.screen.getCursorScreenPoint();r=S.screen.getDisplayNearestPoint(a)}!r&&l&&(r=S.screen.getDisplayMatching(l.getBounds())),r||(r=S.screen.getPrimaryDisplay()||n[0])}let i=(0,y.defaultWindowState)();i.x=Math.round(r.bounds.x+r.bounds.width/2-i.width/2),i.y=Math.round(r.bounds.y+r.bounds.height/2-i.height/2);const s=this.configurationService.getValue("window");let o=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&l){const a=l.serializeWindowState();a.mode===3?i.mode=3:i=a,o=i.mode!==3&&s.newWindowDimensions==="offset"}}return o&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const l=this.windowsMainService.getWindows().map(r=>r.getBounds());for(;l.some(r=>r.x===h.x||r.y===h.y);)h.x+=30,h.y+=30;return h}};u.windowsStateStorageKey="windowsState",u=fe([x(0,k.IWindowsMainService),x(1,C.IStateMainService),x(2,f.ILifecycleMainService),x(3,p.ILogService),x(4,v.IConfigurationService)],u),e.WindowsStateHandler=u;function b(w){const h={openedWindows:[]},l=w||{openedWindows:[]};return l.lastActiveWindow&&(h.lastActiveWindow=m(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=m(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(h.openedWindows=l.openedWindows.map(r=>m(r))),h}e.restoreWindowsState=b;function m(w){const h={uiState:w.uiState};return w.backupPath&&(h.backupPath=w.backupPath),w.remoteAuthority&&(h.remoteAuthority=w.remoteAuthority),w.folder&&(h.folderUri=M.URI.parse(w.folder)),w.workspaceIdentifier&&(h.workspace={id:w.workspaceIdentifier.id,configPath:M.URI.parse(w.workspaceIdentifier.configURIPath)}),h}function E(w){return{lastActiveWindow:w.lastActiveWindow&&I(w.lastActiveWindow),lastPluginDevelopmentHostWindow:w.lastPluginDevelopmentHostWindow&&I(w.lastPluginDevelopmentHostWindow),openedWindows:w.openedWindows.map(h=>I(h))}}e.getWindowsStateStoreData=E;function I(w){return{workspaceIdentifier:w.workspace&&{id:w.workspace.id,configURIPath:w.workspace.configPath.toString()},folder:w.folderUri&&w.folderUri.toString(),backupPath:w.backupPath,remoteAuthority:w.remoteAuthority,uiState:w.uiState}}}),define(X[89],J([0,1,30,49,120,34,12,9,4,16,7,5,71,24]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,k.createDecorator)("workspacesService");function u(P){return P.hasOwnProperty("workspace")}e.isRecentWorkspace=u;function b(P){return P.hasOwnProperty("folderUri")}e.isRecentFolder=b;function m(P){return P.hasOwnProperty("fileUri")}e.isRecentFile=m;function E(P){return I(P)||w(P)}e.isStoredWorkspaceFolder=E;function I(P){const L=P;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function w(P){const L=P;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function h(P,L,T,W,q=!f.isWindows,ee){if(P.scheme!==W.scheme)return{name:T,uri:P.toString(!0)};let se=L?void 0:ee.relativePath(W,P);if(se!==void 0)se.length===0?se=".":f.isWindows&&P.scheme===M.Schemas.file&&!q&&(se=se.replace(/\//g,"\\"));else if(P.scheme===M.Schemas.file)se=P.fsPath,f.isWindows&&(se=(0,R.normalizeDriveLetter)(se),q&&(se=(0,S.toSlashes)(se)));else{if(!ee.isEqualAuthority(P.authority,W.authority))return{name:T,uri:P.toString(!0)};se=P.path}return{name:T,path:se}}e.getStoredWorkspaceFolder=h;function l(P,L,T){const W=[],q=new Set,ee=T.dirname(L);for(const se of P){let ae;if(I(se))se.path&&(ae=T.resolvePath(ee,se.path));else if(w(se))try{ae=C.URI.parse(se.uri),ae.path[0]!=="/"&&(ae=ae.with({path:"/"+ae.path}))}catch(te){console.warn(te)}if(ae){const te=T.getComparisonKey(ae);if(!q.has(te)){q.add(te);const ce=se.name||T.basenameOrAuthority(ae);W.push(new g.WorkspaceFolder({uri:ae,name:ce,index:W.length},se))}}}return W}e.toWorkspaceFolders=l;function r(P,L,T,W,q){const ee=n(L,P),se=q.dirname(L),ae=q.dirname(W),te=[],ce=i(ee.folders);for(const _ of ee.folders){const B=I(_)?q.resolvePath(se,_.path):C.URI.parse(_.uri);let G;T?G=!1:G=!I(_)||(0,v.isAbsolute)(_.path),te.push(h(B,G,_.name,ae,ce,q))}const H={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},ne=D.setProperty(P,["folders"],te,H);let F=D.applyEdits(P,ne);return(0,p.isEqualAuthority)(ee.remoteAuthority,(0,y.getRemoteAuthority)(W))&&(F=D.applyEdits(F,D.removeProperty(F,["remoteAuthority"],H))),F}e.rewriteWorkspaceFileForNewLocation=r;function n(P,L){const T=t.parse(L);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(W=>E(W));else throw new Error(`${P} looks like an invalid workspace file.`);return T}function i(P){return f.isWindows?P.some(L=>I(L)&&L.path.indexOf("/")>=0):!0}e.useSlashForPath=i;function s(P){return P.workspace&&typeof P.workspace=="object"&&typeof P.workspace.id=="string"&&typeof P.workspace.configPath=="string"}function o(P){return typeof P.folderUri=="string"}function a(P){return typeof P.fileUri=="string"}function c(P,L){const T={workspaces:[],files:[]};if(P){const W=function(ee,se){for(let ae=0;ae<ee.length;ae++)try{se(ee[ae],ae)}catch(te){L.warn(`Error restoring recent entry ${JSON.stringify(ee[ae])}: ${te.toString()}. Skip entry.`)}},q=P;Array.isArray(q.entries)&&W(q.entries,ee=>{const se=ee.label,ae=ee.remoteAuthority;s(ee)?T.workspaces.push({label:se,remoteAuthority:ae,workspace:{id:ee.workspace.id,configPath:C.URI.parse(ee.workspace.configPath)}}):o(ee)?T.workspaces.push({label:se,remoteAuthority:ae,folderUri:C.URI.parse(ee.folderUri)}):a(ee)&&T.files.push({label:se,remoteAuthority:ae,fileUri:C.URI.parse(ee.fileUri)})})}return T}e.restoreRecentlyOpened=c;function d(P){const L={entries:[]};for(const T of P.workspaces)b(T)?L.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):L.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of P.files)L.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return L}e.toStoreData=d}),define(X[113],J([0,1,75,28,12,4,16]),function(z,e,S,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function v(p){function C(){let k=p.scheme===D.Schemas.file?(0,M.originalFSPath)(p):p.toString();return R.isLinux||(k=k.toLowerCase()),(0,S.createHash)("md5").update(k).digest("hex")}return{id:C(),configPath:p}}e.getWorkspaceIdentifier=v;function f(p,C){function k(){if(p.scheme!==D.Schemas.file)return(0,S.createHash)("md5").update(p.toString()).digest("hex");if(!C)try{C=(0,t.statSync)(p.fsPath)}catch{return}let g;return R.isLinux?g=C.ino:R.isMacintosh?g=C.birthtime.getTime():R.isWindows&&(typeof C.birthtimeMs=="number"?g=Math.floor(C.birthtimeMs):g=C.birthtime.getTime()),(0,S.createHash)("md5").update(p.fsPath).update(g?String(g):"").digest("hex")}const y=k();if(typeof y=="string")return{id:y,uri:p}}e.getSingleFolderWorkspaceIdentifier=f}),define(X[47],J([0,1,14,28,3,49,34,2,12,9,4,16,13,23,170,57,53,26,5,6,20,63,112,24,89,113]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E,I,w,h,l,r,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,I.createDecorator)("workspacesManagementMainService");let o=class extends v.Disposable{constructor(c,d,P,L,T,W){super();this.environmentMainService=c,this.logService=d,this.userDataProfilesMainService=P,this.backupMainService=L,this.dialogMainService=T,this.productService=W,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(c){return this.doResolveLocalWorkspace(c,d=>(0,t.readFileSync)(d,"utf8"))}resolveLocalWorkspace(c){return this.doResolveLocalWorkspace(c,d=>g.Promises.readFile(d,"utf8"))}doResolveLocalWorkspace(c,d){if(!!this.isWorkspacePath(c)&&c.scheme===f.Schemas.file)try{const P=d(c.fsPath);return P instanceof Promise?P.then(L=>this.doResolveWorkspace(c,L),L=>{}):this.doResolveWorkspace(c,P)}catch{return}}isWorkspacePath(c){return(0,n.isUntitledWorkspace)(c,this.environmentMainService)||(0,n.hasWorkspaceFileExtension)(c)}doResolveWorkspace(c,d){try{const P=this.doParseStoredWorkspace(c,d),L=(0,s.getWorkspaceIdentifier)(c);return{id:L.id,configPath:L.configPath,folders:(0,i.toWorkspaceFolders)(P.folders,L.configPath,k.extUriBiasedIgnorePathCase),remoteAuthority:P.remoteAuthority,transient:P.transient}}catch(P){this.logService.warn(P.toString())}}doParseStoredWorkspace(c,d){const P=(0,R.parse)(d);if(P&&Array.isArray(P.folders))P.folders=P.folders.filter(L=>(0,i.isStoredWorkspaceFolder)(L));else throw new Error(`${c.toString(!0)} looks like an invalid workspace file.`);return P}async createUntitledWorkspace(c,d){const{workspace:P,storedWorkspace:L}=this.newUntitledWorkspace(c,d),T=P.configPath.fsPath;return await g.Promises.mkdir((0,p.dirname)(T),{recursive:!0}),await g.Promises.writeFile(T,JSON.stringify(L,null,"	")),P}createUntitledWorkspaceSync(c,d){const{workspace:P,storedWorkspace:L}=this.newUntitledWorkspace(c,d),T=P.configPath.fsPath;return(0,t.mkdirSync)((0,p.dirname)(T),{recursive:!0}),(0,g.writeFileSync)(T,JSON.stringify(L,null,"	")),P}newUntitledWorkspace(c=[],d){const P=(Date.now()+Math.round(Math.random()*1e3)).toString(),L=(0,k.joinPath)(this.untitledWorkspacesHome,P),T=(0,k.joinPath)(L,n.UNTITLED_WORKSPACE_NAME),W=[];for(const q of c)W.push((0,i.getStoredWorkspaceFolder)(q.uri,!0,q.name,L,!C.isWindows,k.extUriBiasedIgnorePathCase));return{workspace:(0,s.getWorkspaceIdentifier)(T),storedWorkspace:{folders:W,remoteAuthority:d}}}async getWorkspaceIdentifier(c){return(0,s.getWorkspaceIdentifier)(c)}isUntitledWorkspace(c){return(0,n.isUntitledWorkspace)(c.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(c){!this.isUntitledWorkspace(c)||(this.doDeleteUntitledWorkspaceSync(c),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(c),this._onDidDeleteUntitledWorkspace.fire(c))}async deleteUntitledWorkspace(c){this.deleteUntitledWorkspaceSync(c)}doDeleteUntitledWorkspaceSync(c){const d=(0,k.originalFSPath)(c.configPath);try{(0,g.rimrafSync)((0,p.dirname)(d));const P=(0,p.join)(this.environmentMainService.workspaceStorageHome.fsPath,c.id);(0,t.existsSync)(P)&&(0,g.writeFileSync)((0,p.join)(P,"obsolete"),"")}catch(P){this.logService.warn(`Unable to delete untitled workspace ${d} (${P}).`)}}getUntitledWorkspacesSync(){const c=[];try{const d=(0,g.readdirSync)(this.untitledWorkspacesHome.fsPath).map(P=>(0,k.joinPath)(this.untitledWorkspacesHome,P,n.UNTITLED_WORKSPACE_NAME));for(const P of d){const L=(0,s.getWorkspaceIdentifier)(P),T=this.resolveLocalWorkspaceSync(P);T?c.push({workspace:L,remoteAuthority:T.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(L)}}catch(d){d.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${d}).`)}return c}async enterWorkspace(c,d,P){if(!c||!c.win||!c.isReady||!await this.isValidTargetWorkspacePath(c,d,P))return;const T=this.doEnterWorkspace(c,(0,s.getWorkspaceIdentifier)(P));if(!!T)return this._onDidEnterWorkspace.fire({window:c,workspace:T.workspace}),T}async isValidTargetWorkspacePath(c,d,P){if(!P)return!0;if((0,n.isWorkspaceIdentifier)(c.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqual(c.openedWorkspace.configPath,P))return!1;if((0,r.findWindowOnWorkspaceOrFolder)(d,P)){const L={title:this.productService.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,u.localize)(0,null))],message:(0,u.localize)(1,null,(0,k.basename)(P)),detail:(0,u.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(L,(0,y.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(c,d){if(!c.config)return;c.focus();let P;return c.config.extensionDevelopmentPath||(P=this.backupMainService.registerWorkspaceBackupSync({workspace:d,remoteAuthority:c.remoteAuthority},c.config.backupPath)),(0,n.isWorkspaceIdentifier)(c.openedWorkspace)&&this.isUntitledWorkspace(c.openedWorkspace)&&this.deleteUntitledWorkspaceSync(c.openedWorkspace),c.config.workspace=d,c.config.backupPath=P,{workspace:d,backupPath:P}}};o=fe([x(0,E.IEnvironmentMainService),x(1,w.ILogService),x(2,l.IUserDataProfilesMainService),x(3,b.IBackupMainService),x(4,m.IDialogMainService),x(5,h.IProductService)],o),e.WorkspacesManagementMainService=o}),define(X[114],J([0,1,38,21,5,32,24,47]),function(z,e,S,t,D,R,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,D.createDecorator)(e.ID);let f=class{constructor(C,k){this.windowsMainService=C,this.workspacesManagementMainService=k}async getRemoteDiagnostics(C){const k=this.windowsMainService.getWindows();return(await Promise.all(k.map(g=>new Promise(u=>{const b=g.remoteAuthority;if(b){const m=`vscode:getDiagnosticInfoResponse${g.id}`,E={includeProcesses:C.includeProcesses,folders:C.includeWorkspaceMetadata?this.getFolderURIs(g):void 0};g.sendWhenReady("vscode:getDiagnosticInfo",t.CancellationToken.None,{replyChannel:m,args:E}),S.validatedIpcMain.once(m,(I,w)=>{w||u({hostName:b,errorMessage:`Unable to resolve connection to '${b}'.`}),u(w)}),setTimeout(()=>{u({hostName:b,errorMessage:`Connection to '${b}' could not be established`})},5e3)}else u(void 0)})))).filter(g=>!!g)}getFolderURIs(C){const k=[],y=C.openedWorkspace;if((0,M.isSingleFolderWorkspaceIdentifier)(y))k.push(y.uri);else if((0,M.isWorkspaceIdentifier)(y)){const g=this.workspacesManagementMainService.resolveLocalWorkspaceSync(y.configPath);g&&g.folders.forEach(b=>{k.push(b.uri)})}return k}};f=fe([x(0,R.IWindowsMainService),x(1,v.IWorkspacesManagementMainService)],f),e.DiagnosticsMainService=f}),define(X[115],J([0,1,14,25,4,13,7,23,18,56,5,6,109,32,24,47]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,C.createDecorator)(e.ID);let m=class{constructor(I,w,h,l,r){this.logService=I,this.windowsMainService=w,this.urlService=h,this.workspacesManagementMainService=l,this.configurationService=r}async start(I,w){this.logService.trace("Received data from other instance: ",I,w),D.isMacintosh&&S.app.focus({steal:!0});const h=this.parseOpenUrl(I);if(h.length){let l=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(l=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),l.then(()=>{for(const{uri:r,url:n}of h)this.urlService.open(r,{originalUrl:n})})}else return this.startOpenWindow(I,w)}parseOpenUrl(I){return I["open-url"]&&I._urls&&I._urls.length>0?(0,t.coalesce)(I._urls.map(w=>{try{return{uri:M.URI.parse(w),url:w}}catch{return null}})):[]}async startOpenWindow(I,w){const h=(0,p.isLaunchedFromCli)(w)?0:4;let l=[];const r=I.wait&&I.waitMarkerFilePath?M.URI.file(I.waitMarkerFilePath):void 0,n=I.remote||void 0,i={context:h,cli:I,userEnv:w,waitMarkerFileURI:r,remoteAuthority:n};if(I.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(I.extensionDevelopmentPath,i);else if(!I._.length&&!I["folder-uri"]&&!I["file-uri"]){let s=!1;if(I["new-window"]||I["unity-launch"])s=!0;else if(I["reuse-window"])s=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":s=!0;break;case"off":s=!1;break;default:s=!D.isMacintosh}if(s)l=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,i),l=[o]):l=this.windowsMainService.open({...i,forceEmpty:!0})}}else l=this.windowsMainService.open({...i,forceNewWindow:I["new-window"],preferNewWindow:!I["reuse-window"]&&!I.wait,forceReuseWindow:I["reuse-window"],diffMode:I.diff,mergeMode:I.merge,addMode:I.add,noRecentEntry:!!I["skip-add-to-recently-opened"],gotoLineMode:I.goto});if(r&&l.length===1&&l[0])return Promise.race([l[0].whenClosedOrLoaded,(0,v.whenDeleted)(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const I=[];return S.BrowserWindow.getAllWindows().forEach(w=>{const h=this.windowsMainService.getWindowById(w.id);h?I.push(this.codeWindowToInfo(h)):I.push(this.browserWindowToInfo(w))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:I,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}getFolderURIs(I){const w=[],h=I.openedWorkspace;if((0,u.isSingleFolderWorkspaceIdentifier)(h))w.push(h.uri);else if((0,u.isWorkspaceIdentifier)(h)){const l=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.configPath);l&&l.folders.forEach(n=>{w.push(n.uri)})}return w}codeWindowToInfo(I){const w=this.getFolderURIs(I),h=(0,R.assertIsDefined)(I.win);return this.browserWindowToInfo(h,w,I.remoteAuthority)}browserWindowToInfo(I,w=[],h){return{pid:I.webContents.getOSProcessId(),title:I.getTitle(),folderURIs:w,remoteAuthority:h}}};m=fe([x(0,k.ILogService),x(1,g.IWindowsMainService),x(2,y.IURLService),x(3,b.IWorkspacesManagementMainService),x(4,f.IConfigurationService)],m),e.LaunchMainService=m}),define(X[64],J([0,1,42,14,29,138,51,3,34,2,12,9,4,7,93,80,23,90,160,53,26,5,22,6,20,61,32,24,47,17]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E,I,w,h,l,r,n,i,s,o,a,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,l.createDecorator)("nativeHostMainService");let P=class extends p.Disposable{constructor(T,W,q,ee,se,ae,te,ce,H){super();this.sharedProcess=T,this.windowsMainService=W,this.dialogMainService=q,this.lifecycleMainService=ee,this.environmentMainService=se,this.logService=ae,this.productService=te,this.themeMainService=ce,this.workspacesManagementMainService=H,this.onDidOpenWindow=v.Event.map(this.windowsMainService.onDidOpenWindow,ne=>ne.id),this.onDidTriggerSystemContextMenu=v.Event.filter(v.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:ne,x:F,y:_})=>({windowId:ne.id,x:F,y:_})),({windowId:ne})=>!!this.windowsMainService.getWindowById(ne)),this.onDidMaximizeWindow=v.Event.filter(v.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(ne,F)=>F.id),ne=>!!this.windowsMainService.getWindowById(ne)),this.onDidUnmaximizeWindow=v.Event.filter(v.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(ne,F)=>F.id),ne=>!!this.windowsMainService.getWindowById(ne)),this.onDidBlurWindow=v.Event.filter(v.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(ne,F)=>F.id),ne=>!!this.windowsMainService.getWindowById(ne)),this.onDidFocusWindow=v.Event.any(v.Event.map(v.Event.filter(v.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),ne=>!!ne),ne=>ne.id),v.Event.filter(v.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(ne,F)=>F.id),ne=>!!this.windowsMainService.getWindowById(ne))),this.onDidResumeOS=v.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new v.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=v.Event.debounce(v.Event.any(v.Event.filter(v.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(ne,F,_)=>_),ne=>!(Array.isArray(ne)&&ne.length===1&&ne[0]==="workArea")),v.Event.fromNodeEventEmitter(t.screen,"display-added"),v.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(T){return this.windowsMainService.getWindowCount()}async getActiveWindowId(T){const W=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(T,W,q){return Array.isArray(W)?this.doOpenWindow(T,W,q):this.doOpenEmptyWindow(T,W)}async doOpenWindow(T,W,q=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:T,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:q.forceNewWindow,forceReuseWindow:q.forceReuseWindow,preferNewWindow:q.preferNewWindow,diffMode:q.diffMode,mergeMode:q.mergeMode,addMode:q.addMode,gotoLineMode:q.gotoLineMode,noRecentEntry:q.noRecentEntry,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:q.remoteAuthority||void 0})}async doOpenEmptyWindow(T,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:T},W)}async toggleFullScreen(T){const W=this.windowById(T);W&&W.toggleFullScreen()}async handleTitleDoubleClick(T){const W=this.windowById(T);W&&W.handleTitleDoubleClick()}async isMaximized(T){const W=this.windowById(T);return W?.win?W.win.isMaximized():!1}async maximizeWindow(T){const W=this.windowById(T);W?.win&&W.win.maximize()}async unmaximizeWindow(T){const W=this.windowById(T);W?.win&&W.win.unmaximize()}async minimizeWindow(T){const W=this.windowById(T);W?.win&&W.win.minimize()}async updateTitleBarOverlay(T,W){const q=this.windowById(T);q?.win&&q.win.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0})}async focusWindow(T,W){W&&typeof W.windowId=="number"&&(T=W.windowId),this.windowById(T)?.focus({force:W?.force??!1})}async setMinimumSize(T,W,q){const ee=this.windowById(T);if(ee?.win){const[se,ae]=ee.win.getSize(),[te,ce]=ee.win.getMinimumSize(),[H,ne]=[W??te,q??ce],[F,_]=[Math.max(se,H),Math.max(ae,ne)];(te!==H||ce!==ne)&&ee.win.setMinimumSize(H,ne),(se!==F||ae!==_)&&ee.win.setSize(F,_)}}async saveWindowSplash(T,W){this.themeMainService.saveWindowSplash(T,W)}async installShellCommand(T){const{source:W,target:q}=await this.getShellCommandLink();try{const{symbolicLink:ee}=await m.SymlinkSupport.stat(W);if(ee&&!ee.dangling){const se=await(0,u.realpath)(W);if(q===se)return}await m.Promises.unlink(W)}catch(ee){if(ee.code!=="ENOENT")throw ee}try{await m.Promises.symlink(q,W)}catch(ee){if(ee.code!=="EACCES"&&ee.code!=="ENOENT")throw ee;const{response:se}=await this.showMessageBox(T,{title:this.productService.nameLong,type:"info",message:(0,I.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,I.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,I.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${q}' '${W}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(ae)}catch{throw new Error((0,I.localize)(3,null,W))}}}async uninstallShellCommand(T){const{source:W}=await this.getShellCommandLink();try{await m.Promises.unlink(W)}catch(q){switch(q.code){case"EACCES":{const{response:ee}=await this.showMessageBox(T,{title:this.productService.nameLong,type:"info",message:(0,I.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,I.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,I.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ee===0)try{const se=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(se)}catch{throw new Error((0,I.localize)(7,null,W))}break}case"ENOENT":break;default:throw q}}}async getShellCommandLink(){const T=(0,k.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await m.Promises.exists(T))throw new Error((0,I.localize)(8,null,T));return{source:W,target:T}}async showMessageBox(T,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(T))}async showSaveDialog(T,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(T))}async showOpenDialog(T,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(T))}toBrowserWindow(T){const W=this.windowById(T);if(W?.win)return W.win}async pickFileFolderAndOpen(T,W){const q=await this.dialogMainService.pickFileFolder(W);q&&this.doOpenPicked(await Promise.all(q.map(async ee=>await m.SymlinkSupport.existsDirectory(ee)?{folderUri:g.URI.file(ee)}:{fileUri:g.URI.file(ee)})),W,T)}async pickFolderAndOpen(T,W){const q=await this.dialogMainService.pickFolder(W);q&&this.doOpenPicked(q.map(ee=>({folderUri:g.URI.file(ee)})),W,T)}async pickFileAndOpen(T,W){const q=await this.dialogMainService.pickFile(W);q&&this.doOpenPicked(q.map(ee=>({fileUri:g.URI.file(ee)})),W,T)}async pickWorkspaceAndOpen(T,W){const q=await this.dialogMainService.pickWorkspace(W);q&&this.doOpenPicked(q.map(ee=>({workspaceUri:g.URI.file(ee)})),W,T)}doOpenPicked(T,W,q){this.windowsMainService.open({context:3,contextWindowId:q,cli:this.environmentMainService.args,urisToOpen:T,forceNewWindow:W.forceNewWindow})}async showItemInFolder(T,W){t.shell.showItemInFolder(W)}async setRepresentedFilename(T,W){this.windowById(T)?.setRepresentedFilename(W)}async setDocumentEdited(T,W){this.windowById(T)?.setDocumentEdited(W)}async openExternal(T,W){return y.isLinuxSnap?this.safeSnapOpenExternal(W):t.shell.openExternal(W),!0}safeSnapOpenExternal(T){const W=process.env.GDK_PIXBUF_MODULE_FILE,q=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(T),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=q}moveItemToTrash(T,W){return t.shell.trashItem(W)}async isAdmin(){let T;return y.isWindows?T=(await new Promise((W,q)=>{z(["native-is-elevated"],W,q)}))():T=process.getuid()===0,T}async writeElevated(T,W,q,ee){const se=await new Promise((ae,te)=>{z(["@vscode/sudo-prompt"],ae,te)});return new Promise((ae,te)=>{const ce=[`"${this.cliPath}"`];ee?.unlock&&ce.push("--file-chmod"),ce.push("--file-write",`"${W.fsPath}"`,`"${q.fsPath}"`);const H={name:this.productService.nameLong.replace("-",""),icns:y.isMacintosh&&this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(ce.join(" "),H,(ne,F,_)=>{F&&this.logService.trace(`[sudo-prompt] received stdout: ${F}`),_&&this.logService.trace(`[sudo-prompt] received stderr: ${_}`),ne?te(ne):ae(void 0)})})}get cliPath(){return y.isWindows?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):y.isLinux?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,k.join)(this.environmentMainService.appRoot,"bin","code"):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return b.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(T,W,q){process.kill(W,q)}async readClipboardText(T,W){return t.clipboard.readText(W)}async writeClipboardText(T,W,q){return t.clipboard.writeText(W,q)}async readClipboardFindText(T){return t.clipboard.readFindText()}async writeClipboardFindText(T,W){return t.clipboard.writeFindText(W)}async writeClipboardBuffer(T,W,q,ee){return t.clipboard.writeBuffer(W,Buffer.from(q.buffer),ee)}async readClipboardBuffer(T,W){return d.VSBuffer.wrap(t.clipboard.readBuffer(W))}async hasClipboard(T,W,q){return t.clipboard.has(W,q)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(T,W){this.windowById(T)?.updateTouchBar(W)}async notifyReady(T){const W=this.windowById(T);W&&W.setReady()}async relaunch(T,W){return this.lifecycleMainService.relaunch(W)}async reload(T,W){const q=this.windowById(T);if(q){if((0,a.isWorkspaceIdentifier)(q.openedWorkspace)){const ee=q.openedWorkspace.configPath;if(ee.scheme===C.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ee))?.transient)return this.openWindow(q.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(q,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(T){this.closeWindowById(T,T)}async closeWindowById(T,W){const q=this.windowById(W);if(q?.win)return q.win.close()}async quit(T){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(T,W){await this.lifecycleMainService.kill(W)}async resolveProxy(T,W){const ee=this.windowById(T)?.win?.webContents?.session;if(ee)return ee.resolveProxy(W)}findFreePort(T,W,q,ee,se=1){return(0,E.findFreePort)(W,q,ee,se)}async openDevTools(T,W){const q=this.windowById(T);q?.win&&q.win.webContents.openDevTools(W)}async toggleDevTools(T){const W=this.windowById(T);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(T,W){const q=this.windowById(T);q?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&q.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(T,W,q,ee){if(!y.isWindows)return;const se=await new Promise((ae,te)=>{z(["@vscode/windows-registry"],ae,te)});try{return se.GetStringRegKey(W,q,ee)}catch{return}}windowById(T){if(typeof T=="number")return this.windowsMainService.getWindowById(T)}};fe([M.memoize],P.prototype,"cliPath",null),P=fe([x(1,o.IWindowsMainService),x(2,w.IDialogMainService),x(3,r.ILifecycleMainService),x(4,h.IEnvironmentMainService),x(5,n.ILogService),x(6,i.IProductService),x(7,s.IThemeMainService),x(8,c.IWorkspacesManagementMainService)],P),e.NativeHostMainService=P}),define(X[248],J([0,1,14,38,29,34,2,12,4,94,158,83,114,53,26,5,115,6,64,58,20,59,73]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E,I,w,h,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,b.createDecorator)("issueMainService");let n=class Lt{constructor(s,o,a,c,d,P,L,T,W,q){this.userEnv=s,this.environmentMainService=o,this.launchMainService=a,this.logService=c,this.diagnosticsService=d,this.diagnosticsMainService=P,this.dialogMainService=L,this.nativeHostMainService=T,this.protocolMainService=W,this.productService=q,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[o,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),c=await this.diagnosticsService.getSystemInfo(o,a);this.safeSend(s,"vscode:issueSystemInfoResponse",c)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const o=[];try{const a=await this.launchMainService.getMainProcessId();o.push({name:(0,C.localize)(0,null),rootProcess:await(0,p.listProcesses)(a)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(d=>{(0,k.isRemoteDiagnosticError)(d)?o.push({name:d.hostName,rootProcess:d}):d.processes&&o.push({name:d.hostName,rootProcess:d.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(s,"vscode:listProcessesResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const o={title:this.productService.nameLong,message:(0,C.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,C.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(o,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const o=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,C.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,C.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,o)=>{const{id:a,from:c,args:d}=o;let P;switch(c){case"issueReporter":P=this.issueReporterParentWindow;break;case"processExplorer":P=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${c}`)}P?.webContents.send("vscode:runAction",{id:a,from:c,args:d})}),t.validatedIpcMain.on("vscode:openExternal",(s,o)=>{this.nativeHostMainService.openExternal(void 0,o)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const o=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",o.windows)})}safeSend(s,o,...a){s.sender.isDestroyed()||s.sender.send(o,...a)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const o=new M.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(c,a,{backgroundColor:s.styles.backgroundColor,title:(0,C.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:w.default}),this.issueReporterWindow.loadURL(v.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",z).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,o.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,o.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const o=new M.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(c,a,{backgroundColor:s.styles.backgroundColor,title:(0,C.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:w.default}),this.processExplorerWindow.loadURL(v.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",z).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,o.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,o.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,o,a,c){const d=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:a.title,backgroundColor:a.backgroundColor||Lt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:v.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`,`--vscode-window-kind=${c}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,r.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return d.setMenuBarVisibility(!1),d}async getSystemStatus(){const[s,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,o)}getWindowPosition(s,o,a){let c;const d=S.screen.getAllDisplays();if(d.length===1)c=d[0];else{if(f.isMacintosh){const T=S.screen.getCursorScreenPoint();c=S.screen.getDisplayNearestPoint(T)}!c&&s&&(c=S.screen.getDisplayMatching(s.getBounds())),c||(c=S.screen.getPrimaryDisplay()||d[0])}const P={width:o,height:a},L=c.bounds;return P.x=L.x+L.width/2-P.width/2,P.y=L.y+L.height/2-P.height/2,L.width>0&&L.height>0&&(P.x<L.x&&(P.x=L.x),P.y<L.y&&(P.y=L.y),P.x>L.x+L.width&&(P.x=L.x),P.y>L.y+L.height&&(P.y=L.y),P.width>L.width&&(P.width=L.width),P.height>L.height&&(P.height=L.height)),P}async getPerformanceInfo(){try{const[s,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,o)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};n.DEFAULT_BACKGROUND_COLOR="#1E1E1E",n=fe([x(1,u.IEnvironmentMainService),x(2,m.ILaunchMainService),x(3,E.ILogService),x(4,k.IDiagnosticsService),x(5,y.IDiagnosticsMainService),x(6,g.IDialogMainService),x(7,I.INativeHostMainService),x(8,l.IProtocolMainService),x(9,h.IProductService)],n),e.IssueMainService=n}),define(X[249],J([0,1,21,18,26,22,6,64,20,52,35,46,87]),function(z,e,S,t,D,R,M,v,f,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends y.AbstractUpdateService{constructor(b,m,E,I,w,h,l,r){super(b,m,I,w,h,r);this.telemetryService=E,this.nativeHostMainService=l}buildUpdateFeedUrl(b){return(0,y.createUpdateURL)(`linux-${process.arch}`,b,this.productService)}doCheckForUpdates(b){!this.url||(this.setState(k.State.CheckingForUpdates(b)),this.requestService.request({url:this.url},S.CancellationToken.None).then(p.asJson).then(m=>{!m||!m.url||!m.version||!m.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b}),this.setState(k.State.Idle(1))):this.setState(k.State.AvailableForDownload(m))}).then(void 0,m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b});const E=b?m.message||m:void 0;this.setState(k.State.Idle(1,E))}))}async doDownloadUpdate(b){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):b.update.url&&this.nativeHostMainService.openExternal(void 0,b.update.url),this.setState(k.State.Idle(1))}};g=fe([x(0,R.ILifecycleMainService),x(1,t.IConfigurationService),x(2,C.ITelemetryService),x(3,D.IEnvironmentMainService),x(4,p.IRequestService),x(5,M.ILogService),x(6,v.INativeHostMainService),x(7,f.IProductService)],g),e.LinuxUpdateService=g}),define(X[250],J([0,1,42,28,29,8,21,51,9,7,124,23,18,26,15,22,6,64,20,52,35,46,87]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E,I,w,h,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function n(a,c=1e3){for(;!a();)await(0,R.timeout)(c)}let i;function s(){return typeof i=="undefined"&&(i=t.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=class extends r.AbstractUpdateService{constructor(c,d,P,L,T,W,q,ee,se){super(c,d,L,T,W,se);this.telemetryService=P,this.fileService=q,this.nativeHostMainService=ee}get cachePath(){const c=f.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return k.Promises.mkdir(c,{recursive:!0}).then(()=>c)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(c){let d="win32";return process.arch!=="ia32"&&(d+=`-${process.arch}`),s()===1?d+="-archive":this.productService.target==="user"&&(d+="-user"),(0,r.createUpdateURL)(d,c,this.productService)}doCheckForUpdates(c){!this.url||(this.setState(l.State.CheckingForUpdates(c)),this.requestService.request({url:this.url},M.CancellationToken.None).then(w.asJson).then(d=>{const P=s();return!d||!d.url||!d.version||!d.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!c}),this.setState(l.State.Idle(P)),Promise.resolve(null)):P===1?(this.setState(l.State.AvailableForDownload(d)),Promise.resolve(null)):(this.setState(l.State.Downloading(d)),this.cleanup(d.version).then(()=>this.getUpdatePackagePath(d.version).then(L=>k.Promises.exists(L).then(T=>{if(T)return Promise.resolve(L);const W=d.url,q=d.hash,ee=`${L}.tmp`;return this.requestService.request({url:W},M.CancellationToken.None).then(se=>this.fileService.writeFile(p.URI.file(ee),se.stream)).then(q?()=>(0,C.checksum)(ee,d.hash):()=>{}).then(()=>k.Promises.rename(ee,L)).then(()=>L)})).then(L=>{const T=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:L},T&&d.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(d)):this.setState(l.State.Ready(d))})))}).then(void 0,d=>{this.logService.error(d),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!c});const P=c?d.message||d:void 0;this.setState(l.State.Idle(s(),P))}))}async doDownloadUpdate(c){c.update.url&&this.nativeHostMainService.openExternal(void 0,c.update.url),this.setState(l.State.Idle(s()))}async getUpdatePackagePath(c){const d=await this.cachePath;return f.join(d,`CodeSetup-${this.productService.quality}-${c}.exe`)}async cleanup(c=null){const d=c?W=>!new RegExp(`${this.productService.quality}-${c}\\.exe$`).test(W):()=>!0,P=await this.cachePath,T=(await k.Promises.readdir(P)).filter(d).map(async W=>{try{await k.Promises.unlink(f.join(P,W))}catch{}});await Promise.all(T)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const c=this.state.update;this.setState(l.State.Updating(c));const d=await this.cachePath;this.availableUpdate.updateFilePath=f.join(d,`CodeSetup-${this.productService.quality}-${c.version}.flag`),await k.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,S.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(s()))});const L=`${this.productService.win32MutexName}-ready`,T=await new Promise((W,q)=>{z(["windows-mutex"],W,q)});n(()=>T.isActive(L)).then(()=>this.setState(l.State.Ready(c)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,S.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return s()}async _applySpecificUpdate(c){if(this.state.type!=="idle")return;const d=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),P={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!d};this.setState(l.State.Downloading(P)),this.availableUpdate={packagePath:c},d?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(P)):this.setState(l.State.Ready(P))}};fe([v.memoize],o.prototype,"cachePath",null),o=fe([x(0,b.ILifecycleMainService),x(1,y.IConfigurationService),x(2,h.ITelemetryService),x(3,g.IEnvironmentMainService),x(4,w.IRequestService),x(5,m.ILogService),x(6,u.IFileService),x(7,E.INativeHostMainService),x(8,I.IProductService)],o),e.Win32UpdateService=o}),define(X[251],J([0,1,14,8,21,41,3,34,2,12,9,70,4,7,166,57,18,53,26,56,15,22,6,20,59,220,88,35,223,61,73,32,24,47,110,118,37,40,66]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E,I,w,h,l,r,n,i,s,o,a,c,d,P,L,T,W,q,ee,se,ae,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ce;(function(ne){ne[ne.NONE=0]="NONE",ne[ne.NAVIGATING=1]="NAVIGATING",ne[ne.READY=2]="READY"})(ce||(ce={}));let H=class extends f.Disposable{constructor(F,_,B,G,ie,V,Q,A,O,N,$,Y,U,j,Z,re,le,ge){super();this.logService=_,this.environmentMainService=B,this.policyService=G,this.userDataProfilesService=ie,this.fileService=V,this.applicationStorageMainService=Q,this.storageMainService=A,this.configurationService=O,this.themeMainService=N,this.workspacesManagementMainService=$,this.backupMainService=Y,this.telemetryService=U,this.dialogMainService=j,this.lifecycleMainService=Z,this.productService=re,this.protocolMainService=le,this.windowsMainService=ge,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new M.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Ee,De]=this.restoreWindowState(F.state);this.windowState=Ee,this.logService.trace("window#ctor: using window state",Ee);const Ce=this.windowState.mode===0||this.windowState.mode===3,ke=this.configurationService.getValue("window"),Te={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:P.WindowMinimumSize.WIDTH,minHeight:P.WindowMinimumSize.HEIGHT,show:!Ce,title:this.productService.nameLong,webPreferences:{preload:p.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,P.zoomLevelToZoomFactor)(ke?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...ke?.experimental?.useSandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};y.isLinux?Te.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):y.isWindows&&!this.environmentMainService.isBuilt&&(Te.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.useNativeFullScreen()&&(Te.fullscreenable=!1),y.isMacintosh&&(Te.acceptFirstMouse=!0,ke?.clickThroughInactive===!1&&(Te.acceptFirstMouse=!1));const ue=y.isMacintosh&&ke?.nativeTabs===!0;ue&&(Te.tabbingIdentifier=this.productService.nameShort);const de=(0,P.getTitleBarStyle)(this.configurationService)==="custom";if(de&&(Te.titleBarStyle="hidden",y.isMacintosh||(Te.frame=!1),(0,P.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const pe=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Ie=ee.Color.fromHex(pe).isDarker()?"#FFFFFF":"#000000";Te.titleBarOverlay={height:29,color:pe,symbolColor:Ie}}if((0,k.mark)("code/willCreateCodeBrowserWindow"),this._win=new S.BrowserWindow(Te),(0,k.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,y.isMacintosh&&de&&this.updateTrafficLightPosition(),y.isMacintosh&&de&&this._win.setSheetOffset(22),y.isWindows&&de){const pe=278;this._win.hookWindowMessage(pe,()=>{const[Ie,Re]=this._win.getPosition(),Xe=S.screen.getCursorScreenPoint(),Ae=Xe.x-Ie,Oe=Xe.y-Re;return(()=>!(Ae>30&&Oe>=0&&Oe<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Ae,y:Oe})),0})}if(y.isMacintosh&&De&&(!ue||S.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(pe=>typeof pe=="number")){const pe=this.windowState;this._win.setBounds({width:pe.width,height:pe.height,x:pe.x,y:pe.y})}Ce&&((0,k.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,k.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this._profile||(this._profile=(0,te.revive)(this._config?.profiles.current)),this._profile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(F){y.isMacintosh&&!this.customTrafficLightPosition?this._win.setRepresentedFilename(F):this.representedFilename=F}getRepresentedFilename(){return y.isMacintosh&&!this.customTrafficLightPosition?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(F){y.isMacintosh&&this._win.setDocumentEdited(F),this.documentEdited=F}isDocumentEdited(){return y.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(F){y.isMacintosh&&F?.force&&S.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(F=>{if(this.isReady)return F(this);this.whenReadyCallbacks.push(F)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(F=>{function _(){B.dispose(),G.dispose(),F()}const B=this.onDidClose(()=>_()),G=this.onWillLoad(()=>_())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(_,B)=>this.onWindowError(2,B)),this._win.webContents.on("did-fail-load",(_,B,G)=>this.onWindowError(3,{reason:G,exitCode:B})),this._win.webContents.on("will-prevent-unload",_=>{_.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",_=>{this._config&&(this._config.maximized=!0),S.app.emit("browser-window-maximize",_,this._win)}),this._win.on("unmaximize",_=>{this._config&&(this._config.maximized=!1),S.app.emit("browser-window-unmaximize",_,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(_=>this.onConfigurationUpdated(_))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(_=>this.onDidDeleteUntitledWorkspace(_)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(_,B)=>{const G=await this.getMarketplaceHeaders();B({cancel:!1,requestHeaders:Object.assign(_.requestHeaders,G)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,s.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(F,_){switch(F){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${_?.reason||"<unknown>"}, code: ${_?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${_?.reason||"<unknown>"}, code: ${_?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:F,reason:_?.reason,code:_?.exitCode}),F){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(F===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const B=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,v.mnemonicButtonLabel)((0,u.localize)(0,null)),(0,v.mnemonicButtonLabel)((0,u.localize)(1,null)),(0,v.mnemonicButtonLabel)((0,u.localize)(2,null))],message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,u.localize)(5,null):void 0},this._win);if(B.response!==1){const G=B.response===0;this.destroyWindow(G,B.checkboxChecked)}}else if(F===2){let B;_?B=(0,u.localize)(7,null,_.reason,_.exitCode??"<unknown>"):B=(0,u.localize)(6,null);const G=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,v.mnemonicButtonLabel)((0,u.localize)(8,null)),(0,v.mnemonicButtonLabel)((0,u.localize)(9,null))],message:B,detail:(0,u.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,u.localize)(11,null):void 0},this._win),ie=G.response===0;this.destroyWindow(ie,G.checkboxChecked)}break}}async destroyWindow(F,_){const B=this._config?.workspace;if(_&&B)try{const G=this.storageMainService.workspaceStorage(B);await G.init(),G.delete("memento/workbench.parts.editor"),await G.close()}catch(G){this.logService.error(G)}if(this._onDidDestroy.fire(),this._win?.destroy(),F&&this._config){let G,ie;(0,T.isSingleFolderWorkspaceIdentifier)(B)?G={folderUri:B.uri}:(0,T.isWorkspaceIdentifier)(B)?G={workspaceUri:B.configPath}:ie=!0;const[V]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:G?[G]:void 0,forceEmpty:ie,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});V.focus()}}onDidDeleteUntitledWorkspace(F){this._config?.workspace?.id===F.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(F){const _=this.getMenuBarVisibility();_!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=_,this.setMenuBarVisibility(_)),this.updateTrafficLightPosition(F);let B=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;B?.endsWith("/")&&(B=B.substr(0,B.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((B||"").indexOf("@")===-1&&(B!==this.currentHttpProxy||G!==this.currentNoProxy)){this.currentHttpProxy=B,this.currentNoProxy=G;const ie=B||"",V=G?`${G},<local>`:"<local>";this.logService.trace(`Setting proxy to '${ie}', bypassing '${V}'`),this._win.webContents.session.setProxy({proxyRules:ie,proxyBypassRules:V,pacScript:""})}}addTabbedWindow(F){y.isMacintosh&&F.win&&this._win.addTabbedWindow(F.win)}load(F,_=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!_.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),_.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(F,_),this.readyState===0?this._config=F:this.pendingLoadConfig=F,this.readyState=1,this._win.loadURL(p.FileAccess.asBrowserUri("vs/code/electron-sandbox/workbench/workbench.html",z).toString(!0));const B=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:F.workspace,reason:_.isReload?3:B?2:1})}updateConfiguration(F,_){const B=(this._config??this.pendingLoadConfig)?.userEnv;if(B){const G=(0,w.isLaunchedFromCli)(B)&&!(0,w.isLaunchedFromCli)(F.userEnv),ie=this.isExtensionDevelopmentHost;(G||ie)&&(F.userEnv={...B,...F.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(F.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),_.disableExtensions!==void 0&&(F["disable-extensions"]=_.disableExtensions),F.fullscreen=this.isFullScreen,F.maximized=this._win.isMaximized(),F.partsSplash=this.themeMainService.getWindowSplash(),(0,k.mark)("code/willOpenNewWindow"),F.perfMarks=(0,k.getMarks)(),this.configObjectUrl.update(F)}async reload(F){const _=Object.assign({},this._config);_.workspace=await this.validateWorkspaceBeforeReload(_),delete _.filesToOpenOrCreate,delete _.filesToDiff,delete _.filesToMerge,delete _.filesToWait,this.isExtensionDevelopmentHost&&F&&(_.verbose=F.verbose,_.debugId=F.debugId,_.extensionEnvironment=F.extensionEnvironment,_["inspect-extensions"]=F["inspect-extensions"],_["inspect-brk-extensions"]=F["inspect-brk-extensions"],_["extensions-dir"]=F["extensions-dir"]),_.isInitialStartup=!1,_.policiesData=this.policyService.serialize(),_.editSessionId=this.environmentMainService.editSessionId,_.profiles={all:this.userDataProfilesService.profiles,current:this.userDataProfilesService.getProfile(_.workspace??"empty-window")},this.load(_,{isReload:!0,disableExtensions:F?.["disable-extensions"]})}async validateWorkspaceBeforeReload(F){if((0,T.isWorkspaceIdentifier)(F.workspace)){const _=F.workspace.configPath;if(_.scheme===p.Schemas.file&&!await this.fileService.exists(_))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(F.workspace)){const _=F.workspace.uri;if(_.scheme===p.Schemas.file&&!await this.fileService.exists(_))return}return F.workspace}serializeWindowState(){if(!this._win)return(0,q.defaultWindowState)();if(this.isFullScreen){let B;try{B=S.screen.getDisplayMatching(this.getBounds())}catch{}const G=(0,q.defaultWindowState)();return{mode:3,display:B?B.id:void 0,width:this.windowState.width||G.width,height:this.windowState.height||G.height,x:this.windowState.x||0,y:this.windowState.y||0}}const F=Object.create(null);let _;if(!y.isMacintosh&&this._win.isMaximized()?_=0:_=1,_===0?F.mode=0:F.mode=1,_===1||_===0){let B;_===1?B=this.getBounds():B=this._win.getNormalBounds(),F.x=B.x,F.y=B.y,F.width=B.width,F.height=B.height}return F}restoreWindowState(F){(0,k.mark)("code/willRestoreCodeWindowState");let _=!1;if(F)try{const B=S.screen.getAllDisplays();_=B.length>1,F=this.validateWindowState(F,B)}catch(B){this.logService.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,k.mark)("code/didRestoreCodeWindowState"),[F||(0,q.defaultWindowState)(),_]}validateWindowState(F,_){if(this.logService.trace(`window#validateWindowState: validating window state on ${_.length} display(s)`,F),typeof F.x!="number"||typeof F.y!="number"||typeof F.width!="number"||typeof F.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(F.width<=0||F.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(_.length===1){const ie=this.getWorkingArea(_[0]);if(ie){let V=function(){!F||typeof F.x!="number"||typeof F.y!="number"||!ie||(F.x<ie.x&&(F.x=ie.x),F.y<ie.y&&(F.y=ie.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",ie),V(),F.width>ie.width&&(F.width=ie.width),F.height>ie.height&&(F.height=ie.height),F.x>ie.x+ie.width-128&&(F.x=ie.x+ie.width-F.width),F.y>ie.y+ie.height-128&&(F.y=ie.y+ie.height-F.height),V()}return F}if(F.display&&F.mode===3){const ie=_.find(V=>V.id===F.display);if(ie&&typeof ie.bounds?.x=="number"&&typeof ie.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const V=(0,q.defaultWindowState)(3);return V.x=ie.bounds.x,V.y=ie.bounds.y,V}}let B,G;try{B=S.screen.getDisplayMatching({x:F.x,y:F.y,width:F.width,height:F.height}),G=this.getWorkingArea(B)}catch{}if(B&&G&&F.x+F.width>G.x&&F.y+F.height>G.y&&F.x<G.x+G.width&&F.y<G.y+G.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",G),F}getWorkingArea(F){if(F.workArea.width>0&&F.workArea.height>0)return F.workArea;if(F.bounds.width>0&&F.bounds.height>0)return F.bounds}getBounds(){const[F,_]=this._win.getPosition(),[B,G]=this._win.getSize();return{x:F,y:_,width:B,height:G}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(F){this.useNativeFullScreen()?this.setNativeFullScreen(F):this.setSimpleFullScreen(F),this.sendWhenReady(F?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(F){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(F)}setSimpleFullScreen(F){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(F),this._win.webContents.focus()}useNativeFullScreen(){const F=this.configurationService.getValue("window");return!F||typeof F.nativeFullScreen!="boolean"||F.nativeTabs?!0:F.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let F=(0,P.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(F)<0&&(F="classic"),F}setMenuBarVisibility(F,_=!0){y.isMacintosh||(F==="toggle"&&_&&this.send("vscode:showInfoMessage",(0,u.localize)(12,null)),F==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(F)}):this.doSetMenuBarVisibility(F))}doSetMenuBarVisibility(F){const _=this.isFullScreen;switch(F){case"classic":this._win.setMenuBarVisibility(!_),this._win.autoHideMenuBar=_;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}updateTrafficLightPosition(F){if(!y.isMacintosh)return;const _="window.commandCenter";if(F&&!F.affectsConfiguration(_)||!((0,P.getTitleBarStyle)(this.configurationService)==="custom"))return;const G=this.configurationService.getValue(_);G?(this.defaultTrafficLightPosition||(this.defaultTrafficLightPosition=this._win.getTrafficLightPosition()),this._win.setTrafficLightPosition({x:7,y:10})):this.defaultTrafficLightPosition&&this._win.setTrafficLightPosition(this.defaultTrafficLightPosition),this.customTrafficLightPosition=G}handleTitleDoubleClick(){if(y.isMacintosh)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(F,_,...B){this.isReady?this.send(F,...B):this.ready().then(()=>{_.isCancellationRequested||this.send(F,...B)})}send(F,..._){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${F}' for window that is destroyed`);return}try{this._win.webContents.send(F,..._)}catch(B){this.logService.warn(`Error sending IPC message to channel '${F}' of window ${this._id}: ${(0,R.toErrorMessage)(B)}`)}}}updateTouchBar(F){!y.isMacintosh||this.touchBarGroups.forEach((_,B)=>{const G=F[B];_.segments=this.createTouchBarGroupSegments(G)})}createTouchBar(){if(!!y.isMacintosh){for(let F=0;F<10;F++){const _=this.createTouchBarGroup();this.touchBarGroups.push(_)}this._win.setTouchBar(new S.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(F=[]){const _=this.createTouchBarGroupSegments(F),B=new S.TouchBar.TouchBarSegmentedControl({segments:_,mode:"buttons",segmentStyle:"automatic",change:G=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:B.segments[G].id,from:"touchbar"})}});return B}createTouchBarGroupSegments(F=[]){return F.map(B=>{let G;B.icon&&!c.ThemeIcon.isThemeIcon(B.icon)&&B.icon?.dark?.scheme===p.Schemas.file&&(G=S.nativeImage.createFromPath(g.URI.revive(B.icon.dark).fsPath),G.isEmpty()&&(G=void 0));let ie;return typeof B.title=="string"?ie=B.title:ie=B.title.value,{id:B.id,label:G?void 0:ie,icon:G}})}dispose(){super.dispose(),this._win=null}};H=fe([x(1,r.ILogService),x(2,I.IEnvironmentMainService),x(3,se.IPolicyService),x(4,ae.IUserDataProfilesService),x(5,h.IFileService),x(6,o.IApplicationStorageMainService),x(7,o.IStorageMainService),x(8,m.IConfigurationService),x(9,d.IThemeMainService),x(10,W.IWorkspacesManagementMainService),x(11,b.IBackupMainService),x(12,a.ITelemetryService),x(13,E.IDialogMainService),x(14,l.ILifecycleMainService),x(15,n.IProductService),x(16,i.IProtocolMainService),x(17,L.IWindowsMainService)],H),e.CodeWindow=H}),define(X[74],J([0,1,14,25,8,3,34,2,12,4,16,7,23,169,5,22,6,88,89,24,47]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E,I,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,u.createDecorator)("workspacesHistoryMainService");let l=class tt extends v.Disposable{constructor(n,i,s,o){super();this.logService=n,this.workspacesManagementMainService=i,this.lifecycleMainService=s,this.applicationStorageMainService=o,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){const i=[],s=[];for(const o of n)if((0,I.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&this.indexOfWorkspace(i,o.workspace)===-1&&i.push(o);else if((0,I.isRecentFolder)(o))this.indexOfFolder(i,o.folderUri)===-1&&i.push(o);else{const a=this.indexOfFile(s,o.fileUri)>=0,c=o.fileUri.scheme===f.Schemas.file&&tt.COMMON_FILES_FILTER.indexOf((0,C.basename)(o.fileUri))>=0;!a&&!c&&(s.push(o),p.isWindows&&o.fileUri.scheme===f.Schemas.file&&S.app.addRecentDocument(o.fileUri.fsPath))}await this.addEntriesFromStorage(i,s),i.length>tt.MAX_TOTAL_RECENT_ENTRIES&&(i.length=tt.MAX_TOTAL_RECENT_ENTRIES),s.length>tt.MAX_TOTAL_RECENT_ENTRIES&&(s.length=tt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:s}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(n){const i=c=>{const d=this.location(c);for(const P of n)if(C.extUriBiasedIgnorePathCase.isEqual(P,d))return!1;return!0},s=await this.getRecentlyOpened(),o=s.workspaces.filter(i),a=s.files.filter(i);(o.length!==s.workspaces.length||a.length!==s.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:o}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(n){const i=[],s=[];if(n){const a=n.config?.workspace;(0,w.isWorkspaceIdentifier)(a)&&!this.workspacesManagementMainService.isUntitledWorkspace(a)?i.push({workspace:a,remoteAuthority:n.remoteAuthority}):(0,w.isSingleFolderWorkspaceIdentifier)(a)&&i.push({folderUri:a.uri,remoteAuthority:n.remoteAuthority})}const o=n?.config?.filesToOpenOrCreate;if(o)for(const a of o){const c=a.fileUri;c&&this.indexOfFile(s,c)===-1&&s.push({fileUri:c})}return await this.addEntriesFromStorage(i,s),{workspaces:i,files:s}}async addEntriesFromStorage(n,i){const s=await this.getRecentlyOpenedFromStorage();for(const o of s.workspaces){const a=(0,I.isRecentFolder)(o)?this.indexOfFolder(n,o.folderUri):this.indexOfWorkspace(n,o.workspace);a>=0?n[a].label=n[a].label||o.label:n.push(o)}for(const o of s.files){const a=this.indexOfFile(i,o.fileUri);a>=0?i[a].label=i[a].label||o.label:i.push(o)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let n;const i=this.applicationStorageMainService.get(tt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof i=="string")try{n=JSON.parse(i)}catch(s){this.logService.error("Unexpected error parsing opened paths list",s)}return(0,I.restoreRecentlyOpened)(n,this.logService)}async saveRecentlyOpened(n){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(tt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,I.toStoreData)(n)),-1,1)}location(n){return(0,I.isRecentFolder)(n)?n.folderUri:(0,I.isRecentFile)(n)?n.fileUri:n.workspace.configPath}indexOfWorkspace(n,i){return n.findIndex(s=>(0,I.isRecentWorkspace)(s)&&s.workspace.id===i.id)}indexOfFolder(n,i){return n.findIndex(s=>(0,I.isRecentFolder)(s)&&C.extUriBiasedIgnorePathCase.isEqual(s.folderUri,i))}indexOfFile(n,i){return n.findIndex(s=>C.extUriBiasedIgnorePathCase.isEqual(s.fileUri,i))}async handleWindowsJumpList(){!p.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!p.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(0,null),description:(0,g.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const a of S.app.getJumpListSettings().removedItems){const c=a.args;if(c){const d=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(c);d&&i.push(k.URI.parse(d[2]))}}await this.removeRecentlyOpened(i);let s=!1;const o=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,tt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const c=(0,I.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:d,description:P}=this.getWindowsJumpListLabel(c,a.label);let L;return k.URI.isUri(c)?L=`--folder-uri "${c.toString()}"`:(s=!0,L=`--file-uri "${c.configPath.toString()}"`),{type:"task",title:d.substr(0,255),description:P.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));o.length>0&&n.push({type:"custom",name:s?(0,g.localize)(2,null):(0,g.localize)(3,null),items:o})}n.push({type:"recent"});try{const i=S.app.setJumpList(n);i&&i!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(n,i){if(i)return{title:(0,M.splitName)(i).name,description:i};if(k.URI.isUri(n))return{title:(0,C.basename)(n),description:this.renderJumpListPathDescription(n)};if(this.workspacesManagementMainService.isUntitledWorkspace(n))return{title:(0,g.localize)(4,null),description:""};let s=(0,C.basename)(n.configPath);return s.endsWith(w.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-w.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(5,null,s),description:this.renderJumpListPathDescription(n.configPath)}}renderJumpListPathDescription(n){return n.scheme==="file"?(0,M.normalizeDriveLetter)(n.fsPath):n.toString()}async updateMacOSRecentDocuments(){if(!p.isMacintosh)return;S.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),i=[];let s=0;for(let a=0;a<n.workspaces.length&&s<tt.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const c=this.location(n.workspaces[a]);if(c.scheme===f.Schemas.file){const d=(0,C.originalFSPath)(c);await y.Promises.exists(d)&&(i.push(d),s++)}}const o=[];for(let a=0;a<n.files.length&&s<tt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const c=this.location(n.files[a]);if(c.scheme===f.Schemas.file){const d=(0,C.originalFSPath)(c);if(tt.COMMON_FILES_FILTER.includes((0,C.basename)(c))||i.includes(d))continue;await y.Promises.exists(d)&&(o.push(d),s++)}}o.reverse().forEach(a=>S.app.addRecentDocument(a)),i.reverse().forEach(a=>S.app.addRecentDocument(a))}};l.MAX_TOTAL_RECENT_ENTRIES=500,l.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",l.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,l.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,l.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,l.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],l=fe([x(0,m.ILogService),x(1,h.IWorkspacesManagementMainService),x(2,b.ILifecycleMainService),x(3,E.IApplicationStorageMainService)],l),e.WorkspacesHistoryMainService=l}),define(X[252],J([0,1,14,8,21,34,4,7,159,18,26,22,6,200,64,20,45,35,46,73,32,74]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E,I,w,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const r="menu";let n=class Dt{constructor(o,a,c,d,P,L,T,W,q,ee,se){this.updateService=o,this.configurationService=a,this.windowsMainService=c,this.environmentMainService=d,this.telemetryService=P,this.workspacesHistoryMainService=L,this.stateMainService=T,this.lifecycleMainService=W,this.logService=q,this.nativeHostMainService=ee,this.productService=se,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,w.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(Dt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(L,T,W)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(L,T,W)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(L,T,W)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(W),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(L,T,W)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(W),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(L,T,W)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(W),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const c=this.productService.reportIssueUrl;c&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(c,"openReportIssues"));const d=this.productService.licenseUrl;d&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const L=d.indexOf("?")>0?"&":"?";this.openUrl(`${d}${L}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(d,"openLicenseUrl")});const P=this.productService.privacyStatementUrl;P&&d&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(P,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;const o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,a){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(Dt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!M.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=S.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(M.isMacintosh?new S.Menu:null);return}const a=new S.Menu;let c;if(M.isMacintosh){const P=new S.Menu;c=new S.MenuItem({label:this.productService.nameShort,submenu:P}),this.setMacApplicationMenu(P),a.append(c)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const P=new S.Menu;P.append(new S.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(P)}if(this.shouldDrawMenu("File")){const P=new S.Menu,L=new S.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:P});this.setMenuById(P,"File"),a.append(L)}if(this.shouldDrawMenu("Edit")){const P=new S.Menu,L=new S.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:P});this.setMenuById(P,"Edit"),a.append(L)}if(this.shouldDrawMenu("Selection")){const P=new S.Menu,L=new S.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:P});this.setMenuById(P,"Selection"),a.append(L)}if(this.shouldDrawMenu("View")){const P=new S.Menu,L=new S.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:P});this.setMenuById(P,"View"),a.append(L)}if(this.shouldDrawMenu("Go")){const P=new S.Menu,L=new S.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:P});this.setMenuById(P,"Go"),a.append(L)}if(this.shouldDrawMenu("Run")){const P=new S.Menu,L=new S.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:P});this.setMenuById(P,"Run"),a.append(L)}if(this.shouldDrawMenu("Terminal")){const P=new S.Menu,L=new S.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:P});this.setMenuById(P,"Terminal"),a.append(L)}let d;if(this.shouldDrawMenu("Window")){const P=new S.Menu;d=new S.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:P,role:"window"}),this.setMacWindowMenu(P)}if(d&&a.append(d),this.shouldDrawMenu("Help")){const P=new S.Menu,L=new S.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:P,role:"help"});this.setMenuById(P,"Help"),a.append(L)}a.items&&a.items.length>0?S.Menu.setApplicationMenu(a):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const a=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),c=this.getUpdateMenuItems();let d;if(this.shouldDrawMenu("Preferences")){const ae=new S.Menu;this.setMenuById(ae,"Preferences"),d=new S.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:ae})}const P=new S.Menu,L=new S.MenuItem({label:f.localize(12,null),role:"services",submenu:P}),T=new S.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),W=new S.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),q=new S.MenuItem({label:f.localize(15,null),role:"unhide"}),ee=new S.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:async(ae,te,ce)=>{const H=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||H?.isMinimized())&&await this.confirmBeforeQuit(ce)&&this.nativeHostMainService.quit(void 0)}})),se=[a];se.push(...c),d&&se.push(i(),d),se.push(i(),L,i(),T,W,q,i(),ee),se.forEach(ae=>o.append(ae))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const a=this.configurationService.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.isKeyboardEvent(o)){const c={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(f.localize(17,null)),(0,R.mnemonicButtonLabel)(f.localize(18,null))],message:f.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:d}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,c);return d===0}return!0}shouldDrawMenu(o){if(!M.isMacintosh&&(0,w.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,a){a.forEach(c=>{if((0,g.isMenubarMenuItemSeparator)(c))o.append(i());else if((0,g.isMenubarMenuItemSubmenu)(c)){const d=new S.Menu,P=new S.MenuItem({label:this.mnemonicLabel(c.label),submenu:d});this.setMenu(d,c.submenu.items),o.append(P)}else(0,g.isMenubarMenuItemRecentAction)(c)?o.append(this.createOpenRecentMenuItem(c)):(0,g.isMenubarMenuItemAction)(c)&&(c.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[c.id]?o.append(new S.MenuItem(this.likeAction(c.id,{label:this.mnemonicLabel(c.label),click:this.fallbackMenuHandlers[c.id]}))):o.append(this.createMenuItem(c.label,c.id,!1,c.checked)):o.append(this.createMenuItem(c.label,c.id,c.enabled!==!1,!!c.checked)):o.append(this.createMenuItem(c.label,c.id,c.enabled!==!1,!!c.checked)))})}setMenuById(o,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(o,this.menubarMenus[a].items)}insertCheckForUpdatesItems(o){const a=this.getUpdateMenuItems();a.length&&(a.forEach(c=>o.append(c)),o.append(i()))}createOpenRecentMenuItem(o){const a=v.URI.revive(o.uri),c=o.id,d=c==="openRecentFile"?{fileUri:a}:c==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new S.MenuItem(this.likeAction(c,{label:o.label,click:(P,L,T)=>{const W=this.isOptionClick(T);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[d],forceNewWindow:W,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(o){return!!(o&&(!M.isMacintosh&&(o.ctrlKey||o.shiftKey)||M.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,a,c){const d={label:this.mnemonicLabel(o),role:c,enabled:!0};return new S.MenuItem(this.withKeybinding(a,d))}setMacWindowMenu(o){const a=new S.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),c=new S.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),d=new S.MenuItem({label:f.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),P=this.createMenuItem(f.localize(23,null),"workbench.action.switchWindow"),L=[];this.currentEnableNativeTabs&&(L.push(i()),L.push(this.createMenuItem(f.localize(24,null),"workbench.action.newWindowTab")),L.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.createRoleMenuItem(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.createRoleMenuItem(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.createRoleMenuItem(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,c,i(),P,...L,i(),d].forEach(T=>o.append(T))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(f.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(f.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(f.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(f.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,a,c,d){const P=this.mnemonicLabel(o),L=typeof a=="function"?a:(se,ae,te)=>{const ce=se?se.userSettingsLabel:null;let H=a;Array.isArray(a)&&(H=this.isOptionClick(te)?a[1]:a[0]),ce&&te.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ce}):this.runActionInRenderer({type:"commandId",commandId:H})},T=typeof c=="boolean"?c:this.windowsMainService.getWindowCount()>0,W=typeof d=="boolean"?d:!1,q={label:P,click:L,enabled:T};W&&(q.type="checkbox",q.checked=W);let ee;return typeof a=="string"?ee=a:Array.isArray(a)&&(ee=a[0]),M.isMacintosh&&(ee==="editor.action.clipboardCutAction"?q.role="cut":ee==="editor.action.clipboardCopyAction"?q.role="copy":ee==="editor.action.clipboardPasteAction"&&(q.role="paste"),ee==="undo"?q.click=this.makeContextAwareClickHandler(L,{inDevTools:se=>se.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):ee==="redo"?q.click=this.makeContextAwareClickHandler(L,{inDevTools:se=>se.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):ee==="editor.action.selectAll"&&(q.click=this.makeContextAwareClickHandler(L,{inDevTools:se=>se.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(ee,q))}makeContextAwareClickHandler(o,a){return(c,d,P)=>{const L=S.BrowserWindow.getFocusedWindow();if(!L)return a.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return a.inDevTools(L.webContents.devToolsWebContents);o(c,d||L,P)}}runActionInRenderer(o){let a=S.BrowserWindow.getFocusedWindow();if(!a){const d=this.windowsMainService.getLastActiveWindow();d?.isMinimized()&&(a=d.win)}const c=a?this.windowsMainService.getWindowById(a.id):void 0;if(c){if(this.logService.trace("menubar#runActionInRenderer",o),M.isMacintosh&&!this.environmentMainService.isBuilt&&!c.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const d={id:o.commandId,from:"menu"};c.sendWhenReady("vscode:runAction",D.CancellationToken.None,d)}else{const d={userSettingsLabel:o.userSettingsLabel};c.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,d)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,a){const c=typeof o=="string"?this.keybindings[o]:void 0;if(c?.label){if(c.isNative!==!1)a.accelerator=c.label,a.userSettingsLabel=c.userSettingsLabel;else if(typeof a.label=="string"){const d=a.label.indexOf("[");d>=0?a.label=`${a.label.substr(0,d)} [${c.label}]`:a.label=`${a.label} [${c.label}]`}}else a.accelerator=void 0;return a}likeAction(o,a,c=!a.accelerator){c&&(a=this.withKeybinding(o,a));const d=a.click;return a.click=(P,L,T)=>{this.reportMenuActionTelemetry(o),d?.(P,L,T)},a}openUrl(o,a){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:r})}mnemonicLabel(o){return(0,R.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};n.lastKnownMenubarStorageKey="lastKnownMenubarData",n=fe([x(0,I.IUpdateService),x(1,p.IConfigurationService),x(2,h.IWindowsMainService),x(3,C.IEnvironmentMainService),x(4,E.ITelemetryService),x(5,l.IWorkspacesHistoryMainService),x(6,m.IStateMainService),x(7,k.ILifecycleMainService),x(8,y.ILogService),x(9,u.INativeHostMainService),x(10,b.IProductService)],n),e.Menubar=n;function i(){return new S.MenuItem({type:"separator"})}}),define(X[253],J([0,1,5,22,6,252]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,S.createDecorator)("menubarMainService");let M=class{constructor(f,p,C){this.instantiationService=f,this.lifecycleMainService=p,this.logService=C,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(f,p){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(p,f)}};M=fe([x(0,S.IInstantiationService),x(1,t.ILifecycleMainService),x(2,D.ILogService)],M),e.MenubarMainService=M}),define(X[254],J([0,1,14,28,29,25,21,3,30,48,34,2,12,9,70,4,36,16,13,7,167,57,18,53,26,15,5,22,6,58,20,59,71,45,73,251,112,247,24,113,74,47,61,40,37]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E,I,w,h,l,r,n,i,s,o,a,c,d,P,L,T,W,q,ee,se,ae,te,ce,H,ne,F,_,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function G(Q){return(0,te.isWorkspaceIdentifier)(Q?.workspace)}function ie(Q){return(0,te.isSingleFolderWorkspaceIdentifier)(Q?.workspace)}let V=class ht extends k.Disposable{constructor(A,O,N,$,Y,U,j,Z,re,le,ge,Ee,De,Ce,ke,Te,ue,de){super();this.machineId=A,this.initialUserEnv=O,this.logService=N,this.stateMainService=$,this.policyService=Y,this.environmentMainService=U,this.userDataProfilesService=j,this.lifecycleMainService=Z,this.backupMainService=re,this.configurationService=le,this.workspacesHistoryMainService=ge,this.workspacesManagementMainService=Ee,this.instantiationService=De,this.dialogMainService=Ce,this.fileService=ke,this.productService=Te,this.protocolMainService=ue,this.themeMainService=de,this._onDidOpenWindow=this._register(new v.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new v.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new v.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new v.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new v.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ae.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const O=new k.DisposableStore;if(O.add(v.Event.any(A.onDidClose,A.onDidDestroy)(()=>O.dispose())),A.config.extensionDevelopmentPath)for(const N of A.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(N));A.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,O){const N=this.environmentMainService.args,$=O?.remoteAuthority||void 0,Y=!0,U=O?.forceReuseWindow,j=!U;return this.open({...A,cli:N,forceEmpty:Y,forceNewWindow:j,forceReuseWindow:U,remoteAuthority:$})}openExistingWindow(A,O){A.focus(),this.handleWaitMarkerFile(O,[A])}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const O=[],N=[],$=[],Y=[],U=[];let j,Z=0;const re=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",re);for(const Ce of re)ie(Ce)?A.addMode?O.push(Ce):N.push(Ce):G(Ce)?$.push(Ce):Ce.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ce.remoteAuthority}),j.filesToOpenOrCreate.push(Ce)):Ce.backupPath?U.push({backupFolder:(0,g.basename)(Ce.backupPath),remoteAuthority:Ce.remoteAuthority}):Z++;A.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),A.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&A.waitMarkerFileURI&&(j.filesToWait={paths:(0,R.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(Y.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),$.push(...Y),U.push(...this.backupMainService.getEmptyWindowBackupPaths())):U.length=0;const{windows:le,filesOpenedInWindow:ge}=this.doOpen(A,$,N,U,Z,j,O);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${$.length}, foldersToOpen: ${N.length}, emptyToRestore: ${U.length}, emptyToOpen: ${Z})`),le.length>1)if(ge)ge.focus();else{const Ce=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let ke=!0,Te=!0;if(Ce){const ue=le.filter(de=>this.windowsStateHandler.state.lastActiveWindow&&de.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ue.length&&(ue[0].focus(),ke=!1,Te=!1)}if(ke)for(let ue=le.length-1;ue>=0;ue--){const de=le[ue];if(!(de.openedWorkspace&&Y.some(pe=>de.openedWorkspace&&pe.workspace.id===de.openedWorkspace.id)||de.backupPath&&U.some(pe=>de.backupPath&&pe.backupFolder===(0,g.basename)(de.backupPath)))){de.focus(),Te=!1;break}}Te&&le[le.length-1].focus()}const Ee=j&&j.filesToDiff.length>0,De=j&&j.filesToMerge.length>0;if(!le.some(Ce=>Ce.isExtensionDevelopmentHost)&&!Ee&&!De&&!A.noRecentEntry){const Ce=[];for(const ke of re)G(ke)&&!ke.transient?Ce.push({label:ke.label,workspace:ke.workspace,remoteAuthority:ke.remoteAuthority}):ie(ke)?Ce.push({label:ke.label,folderUri:ke.workspace.uri,remoteAuthority:ke.remoteAuthority}):ke.fileUri&&Ce.push({label:ke.label,fileUri:ke.fileUri,remoteAuthority:ke.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Ce)}return this.handleWaitMarkerFile(A,le),le}handleWaitMarkerFile(A,O){const N=A.waitMarkerFileURI;A.context===0&&N&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(N)}catch{}})()}doOpen(A,O,N,$,Y,U,j){const Z=[];let re;function le(ue,de){Z.push(ue),de&&(re=ue,U=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:Ee}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&j.length>0){const ue=j[0].remoteAuthority,de=this.getLastActiveWindowForAuthority(ue);de&&le(this.doAddFoldersToExistingWindow(de,j.map(pe=>pe.workspace.uri)))}const De=N.length+O.length+$.length;if(U&&De===0){const ue=U.filesToOpenOrCreate[0]||U.filesToDiff[0]||U.filesToMerge[3],de=this.getWindows().filter(Ie=>U&&(0,E.isEqualAuthority)(Ie.remoteAuthority,U.remoteAuthority));let pe;ue?.fileUri&&!Ee&&((A.context===4||A.context===0||A.context===1)&&(pe=(0,se.findWindowOnFile)(de,ue.fileUri,Ie=>Ie.configPath.scheme===y.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Ie.configPath):void 0)),pe||(pe=this.doGetLastActiveWindow(de))),pe?(0,te.isWorkspaceIdentifier)(pe.openedWorkspace)?O.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):(0,te.isSingleFolderWorkspaceIdentifier)(pe.openedWorkspace)?N.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):le(this.doOpenFilesInExistingWindow(A,pe,U),!0):le(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:U,forceNewWindow:!0,remoteAuthority:U.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const Ce=(0,R.distinct)(O,ue=>ue.workspace.id);if(Ce.length>0){const ue=(0,R.coalesce)(Ce.map(de=>(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),de.workspace.configPath)));if(ue.length>0){const de=ue[0],pe=(0,E.isEqualAuthority)(U?.remoteAuthority,de.remoteAuthority)?U:void 0;le(this.doOpenFilesInExistingWindow(A,de,pe),!!pe),ge=!0}Ce.forEach(de=>{if(ue.some(Re=>Re.openedWorkspace&&Re.openedWorkspace.id===de.workspace.id))return;const pe=de.remoteAuthority,Ie=(0,E.isEqualAuthority)(U?.remoteAuthority,pe)?U:void 0;le(this.doOpenFolderOrWorkspace(A,de,ge,Ie),!!Ie),ge=!0})}const ke=(0,R.distinct)(N,ue=>E.extUriBiasedIgnorePathCase.getComparisonKey(ue.workspace.uri));if(ke.length>0){const ue=(0,R.coalesce)(ke.map(de=>(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),de.workspace.uri)));if(ue.length>0){const de=ue[0],pe=(0,E.isEqualAuthority)(U?.remoteAuthority,de.remoteAuthority)?U:void 0;le(this.doOpenFilesInExistingWindow(A,de,pe),!!pe),ge=!0}ke.forEach(de=>{if(ue.some(Re=>(0,te.isSingleFolderWorkspaceIdentifier)(Re.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(Re.openedWorkspace.uri,de.workspace.uri)))return;const pe=de.remoteAuthority,Ie=(0,E.isEqualAuthority)(U?.remoteAuthority,pe)?U:void 0;le(this.doOpenFolderOrWorkspace(A,de,ge,Ie),!!Ie),ge=!0})}const Te=(0,R.distinct)($,ue=>ue.backupFolder);if(Te.length>0&&Te.forEach(ue=>{const de=ue.remoteAuthority,pe=(0,E.isEqualAuthority)(U?.remoteAuthority,de)?U:void 0;le(this.doOpenEmpty(A,!0,de,pe,ue),!!pe),ge=!0}),Z.length===0||U){U&&!Y&&Y++;const ue=U?U.remoteAuthority:A.remoteAuthority;for(let de=0;de<Y;de++)le(this.doOpenEmpty(A,ge,ue,U),!!U),ge=!0}return{windows:(0,R.distinct)(Z),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(A,O,N){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:N}),O.focus();const $={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToMerge:N?.filesToMerge,filesToWait:N?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",M.CancellationToken.None,$),O}doAddFoldersToExistingWindow(A,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),A.focus();const N={foldersToAdd:O};return A.sendWhenReady("vscode:addFolders",M.CancellationToken.None,N),A}doOpenEmpty(A,O,N,$,Y){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Y,remoteAuthority:N,filesToOpen:$,forceNewWindow:O});let U;return!O&&typeof A.contextWindowId=="number"&&(U=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:N,forceNewWindow:O,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:$,windowToUse:U,emptyWindowBackupInfo:Y})}doOpenFolderOrWorkspace(A,O,N,$,Y){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:$}),!N&&!Y&&typeof A.contextWindowId=="number"&&(Y=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:$,windowToUse:Y})}getPathsToOpen(A){let O,N=!1,$=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(A),N=!0):A.forceEmpty?O=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(O=this.doExtractPathsFromCLI(A.cli),O.length===0&&O.push(Object.create(null)),N=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),$=!0),!A.addMode&&N){const Y=O.filter(U=>ie(U));if(Y.length>1){const U=Y[0].remoteAuthority;if(Y.every(j=>(0,E.isEqualAuthority)(j.remoteAuthority,U))){const j=this.workspacesManagementMainService.createUntitledWorkspaceSync(Y.map(Z=>({uri:Z.workspace.uri})));O.push({workspace:j,remoteAuthority:U}),O=O.filter(Z=>!ie(Z))}}}return A.initialStartup&&!$&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(Y=>G(Y)||ie(Y)||Y.backupPath)),O}doExtractPathsFromAPI(A){const O=[],N={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const $ of(0,R.coalesce)(A.urisToOpen||[])){const Y=this.resolveOpenable($,N);if(Y)Y.label=$.label,O.push(Y);else{const U=this.resourceFromOpenable($),j={title:this.productService.nameLong,type:"info",buttons:[(0,C.mnemonicButtonLabel)((0,h.localize)(0,null))],defaultId:0,message:U.scheme===y.Schemas.file?(0,h.localize)(1,null):(0,h.localize)(2,null),detail:U.scheme===y.Schemas.file?(0,h.localize)(3,null,(0,C.getPathLabel)(U,{os:b.OS,tildify:this.environmentMainService})):(0,h.localize)(4,null,U.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(j,(0,I.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(A){const O=[],N={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},$=A["folder-uri"];if($)for(const j of $){const Z=this.cliArgToUri(j);if(Z){const re=this.resolveOpenable({folderUri:Z},N);re&&O.push(re)}}const Y=A["file-uri"];if(Y)for(const j of Y){const Z=this.cliArgToUri(j);if(Z){const re=this.resolveOpenable((0,te.hasWorkspaceFileExtension)(j)?{workspaceUri:Z}:{fileUri:Z},N);re&&O.push(re)}}const U=A._;for(const j of U){const Z=N.remoteAuthority?this.doResolvePathRemote(j,N):this.doResolveFilePath(j,N);Z&&O.push(Z)}return O}cliArgToUri(A){try{const O=w.URI.parse(A);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${A}, ${O.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];A!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const N=[];for(const $ of O)if($.workspace){const Y=this.resolveOpenable({workspaceUri:$.workspace.configPath},{remoteAuthority:$.remoteAuthority,rejectTransientWorkspaces:!0});G(Y)&&N.push(Y)}else if($.folderUri){const Y=this.resolveOpenable({folderUri:$.folderUri},{remoteAuthority:$.remoteAuthority});ie(Y)&&N.push(Y)}else A!=="folders"&&$.backupPath&&N.push({backupPath:$.backupPath,remoteAuthority:$.remoteAuthority});return N}}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,O=Object.create(null)){const N=this.resourceFromOpenable(A);return N.scheme===y.Schemas.file?((0,q.isFileToOpen)(A)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(N.fsPath,O)):this.doResolveRemoteOpenable(A,O)}doResolveRemoteOpenable(A,O){let N=this.resourceFromOpenable(A);const $=(0,T.getRemoteAuthority)(N)||O.remoteAuthority;if(N=(0,E.removeTrailingPathSeparator)((0,E.normalizePath)(N)),(0,q.isFileToOpen)(A)){if(O.gotoLineMode){const{path:Y,line:U,column:j}=(0,f.parseLineAndColumnAware)(N.path);return{fileUri:N.with({path:Y}),options:{selection:U?{startLineNumber:U,startColumn:j||1}:void 0},remoteAuthority:$}}return{fileUri:N,remoteAuthority:$}}else if((0,q.isWorkspaceToOpen)(A))return{workspace:(0,ce.getWorkspaceIdentifier)(N),remoteAuthority:$};return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(N),remoteAuthority:$}}resourceFromOpenable(A){return(0,q.isWorkspaceToOpen)(A)?A.workspaceUri:(0,q.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,O){let N,$;O.gotoLineMode&&({path:A,line:N,column:$}=(0,f.parseLineAndColumnAware)(A)),A=(0,f.sanitizeFilePath)((0,g.normalize)(A),(0,m.cwd)());try{const Y=(0,t.statSync)(A);if(Y.isFile()){if(!O.forceOpenWorkspaceAsFile){const U=this.workspacesManagementMainService.resolveLocalWorkspaceSync(w.URI.file(A));if(U)return U.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:U.id,configPath:U.configPath},type:s.FileType.File,exists:!0,remoteAuthority:U.remoteAuthority,transient:U.transient}}return{fileUri:w.URI.file(A),type:s.FileType.File,exists:!0,options:{selection:N?{startLineNumber:N,startColumn:$||1}:void 0}}}else{if(Y.isDirectory())return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(w.URI.file(A),Y),type:s.FileType.Directory,exists:!0};if(!b.isWindows&&A==="/dev/null")return{fileUri:w.URI.file(A),type:s.FileType.File,exists:!0}}}catch{const U=w.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([U]),O.ignoreFileNotFound)return{fileUri:U,type:s.FileType.File,exists:!1}}}doResolvePathRemote(A,O){const N=A.charCodeAt(0),$=O.remoteAuthority;let Y,U;O.gotoLineMode&&({path:A,line:Y,column:U}=(0,f.parseLineAndColumnAware)(A)),N!==47&&((0,f.isWindowsDriveLetter)(N)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,f.toSlashes)(A)),A=`/${A}`);const j=w.URI.from({scheme:y.Schemas.vscodeRemote,authority:$,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,te.hasWorkspaceFileExtension)(A))return O.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:Y?{startLineNumber:Y,startColumn:U||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,ce.getWorkspaceIdentifier)(j),remoteAuthority:$};if(O.gotoLineMode||g.posix.basename(A).indexOf(".")!==-1)return{fileUri:j,options:{selection:Y?{startLineNumber:Y,startColumn:U||1}:void 0},remoteAuthority:$}}return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:$}}shouldOpenNewWindow(A){const O=this.configurationService.getValue("window"),N=O?.openFoldersInNewWindow||"default",$=O?.openFilesInNewWindow||"off";let Y=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(N==="on"||N==="off")&&(Y=N==="on");let U=!1;return A.forceNewWindow||A.forceReuseWindow?U=!!A.forceNewWindow&&!A.forceReuseWindow:(b.isMacintosh?A.context===1&&(U=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(U=!0),!A.cli.extensionDevelopmentPath&&($==="on"||$==="off")&&(U=$==="on")),{openFolderInNewWindow:!!Y,openFilesInNewWindow:U}}openExtensionDevelopmentHostWindow(A,O){const N=(0,se.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(N)return this.lifecycleMainService.reload(N,O.cli),N.focus(),[N];let $=O.cli["folder-uri"]||[],Y=O.cli["file-uri"]||[],U=O.cli._;if(!U.length&&!$.length&&!Y.length&&!O.cli.extensionTestsPath){const le=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ge=le&&(le.workspace||le.folderUri);ge&&(w.URI.isUri(ge)?ge.scheme===y.Schemas.file?U=[ge.fsPath]:$=[ge.toString()]:ge.configPath.scheme===y.Schemas.file?U=[(0,E.originalFSPath)(ge.configPath)]:Y=[ge.configPath.toString()])}let j=O.remoteAuthority;for(const le of A)if(le.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ge=w.URI.parse(le),Ee=(0,T.getRemoteAuthority)(ge);Ee&&(j?(0,E.isEqualAuthority)(Ee,j)||this.logService.error("more than one extension development path authority"):j=Ee)}U=U.filter(le=>{const ge=w.URI.file(le);return(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge)?!1:(0,E.isEqualAuthority)((0,T.getRemoteAuthority)(ge),j)}),$=$.filter(le=>{const ge=this.cliArgToUri(le);return ge&&!!(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge)?!1:ge?(0,E.isEqualAuthority)((0,T.getRemoteAuthority)(ge),j):!1}),Y=Y.filter(le=>{const ge=this.cliArgToUri(le);return ge&&!!(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge)?!1:ge?(0,E.isEqualAuthority)((0,T.getRemoteAuthority)(ge),j):!1}),O.cli._=U,O.cli["folder-uri"]=$,O.cli["file-uri"]=Y;const Z=!U.length&&!$.length&&!Y.length,re={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:Z,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:j};return this.open(re)}openInBrowserWindow(A){const O=this.configurationService.getValue("window"),N={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,g.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesService.profiles,current:this.userDataProfilesService.getProfile(A.workspace??"empty-window")},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:d.default,isInitialStartup:A.initialStartup,perfMarks:(0,u.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),editSessionId:this.environmentMainService.editSessionId};let $;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&($=A.windowToUse||this.getLastActiveWindow(),$&&$.focus()),$){const Y=$.config;!N.extensionDevelopmentPath&&Y&&!!Y.extensionDevelopmentPath&&(N.extensionDevelopmentPath=Y.extensionDevelopmentPath,N.verbose=Y.verbose,N["inspect-brk-extensions"]=Y["inspect-brk-extensions"],N.debugId=Y.debugId,N.extensionEnvironment=Y.extensionEnvironment,N["inspect-extensions"]=Y["inspect-extensions"],N["extensions-dir"]=Y["extensions-dir"])}else{const Y=this.windowsStateHandler.getNewWindowState(N);(0,u.mark)("code/willCreateCodeWindow");const U=$=this.instantiationService.createInstance(ee.CodeWindow,{state:Y,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});(0,u.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(U),ht.WINDOWS.push(U),this._onDidOpenWindow.fire(U),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,p.once)(U.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(U)),(0,p.once)(U.onDidClose)(()=>this.onWindowClosed(U)),(0,p.once)(U.onDidDestroy)(()=>this._onDidDestroyWindow.fire(U)),U.onDidTriggerSystemContextMenu(({x:Z,y:re})=>this._onDidTriggerSystemContextMenu.fire({window:U,x:Z,y:re}));const j=(0,I.assertIsDefined)(U.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.lifecycleMainService.reload(U)),this.lifecycleMainService.registerWindow(U)}return N.windowId=$.id,$.isReady?this.lifecycleMainService.unload($,4).then(Y=>{Y||this.doOpenInBrowserWindow($,N,A)}):this.doOpenInBrowserWindow($,N,A),$}doOpenInBrowserWindow(A,O,N){if(!O.extensionDevelopmentPath)if((0,te.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,te.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority});else{const $=N.emptyWindowBackupInfo&&N.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync($,O.remoteAuthority)}A.load(O)}onWindowClosed(A){const O=ht.WINDOWS.indexOf(A);ht.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=S.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,E.isEqualAuthority)(O.remoteAuthority,A)))}doGetLastActiveWindow(A){const O=Math.max.apply(Math,A.map(N=>N.lastFocusTime));return A.find(N=>N.lastFocusTime===O)}sendToFocused(A,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,M.CancellationToken.None,...O)}sendToAll(A,O,N){for(const $ of this.getWindows())N&&N.indexOf($.id)>=0||$.sendWhenReady(A,M.CancellationToken.None,O)}getWindows(){return ht.WINDOWS}getWindowCount(){return ht.WINDOWS.length}getWindowById(A){const O=this.getWindows().filter(N=>N.id===A);return(0,R.firstOrDefault)(O)}getWindowByWebContents(A){const O=S.BrowserWindow.fromWebContents(A);if(!!O)return this.getWindowById(O.id)}};V.WINDOWS=[],V=fe([x(2,c.ILogService),x(3,W.IStateMainService),x(4,B.IPolicyService),x(5,i.IEnvironmentMainService),x(6,_.IUserDataProfilesService),x(7,a.ILifecycleMainService),x(8,l.IBackupMainService),x(9,r.IConfigurationService),x(10,H.IWorkspacesHistoryMainService),x(11,ne.IWorkspacesManagementMainService),x(12,o.IInstantiationService),x(13,n.IDialogMainService),x(14,s.IFileService),x(15,P.IProductService),x(16,L.IProtocolMainService),x(17,F.IThemeMainService)],V),e.WindowsMainService=V}),define(X[255],J([0,1,57,32,74,47]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(f,p,C,k){this.workspacesManagementMainService=f,this.windowsMainService=p,this.workspacesHistoryMainService=C,this.backupMainService=k,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,p){const C=this.windowsMainService.getWindowById(f);if(C)return this.workspacesManagementMainService.enterWorkspace(C,this.windowsMainService.getWindows(),p)}createUntitledWorkspace(f,p,C){return this.workspacesManagementMainService.createUntitledWorkspace(p,C)}deleteUntitledWorkspace(f,p){return this.workspacesManagementMainService.deleteUntitledWorkspace(p)}getWorkspaceIdentifier(f,p){return this.workspacesManagementMainService.getWorkspaceIdentifier(p)}getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}addRecentlyOpened(f,p){return this.workspacesHistoryMainService.addRecentlyOpened(p)}removeRecentlyOpened(f,p){return this.workspacesHistoryMainService.removeRecentlyOpened(p)}clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=fe([x(0,R.IWorkspacesManagementMainService),x(1,t.IWindowsMainService),x(2,D.IWorkspacesHistoryMainService),x(3,S.IBackupMainService)],M),e.WorkspacesMainService=M}),define(X[256],J([0,1,14,38,28,29,17,41,19,30,48,49,34,2,12,9,4,13,7,27,80,130,43,141,96,235,146,57,240,18,68,176,83,114,53,99,174,26,56,106,183,203,184,237,101,185,186,15,196,85,67,5,84,248,214,115,22,6,198,253,64,20,71,243,86,45,241,88,107,35,219,221,72,46,226,227,249,228,250,109,230,231,232,233,238,32,254,239,24,89,74,255,47,236,37,202,63,100,246,210,52]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E,I,w,h,l,r,n,i,s,o,a,c,d,P,L,T,W,q,ee,se,ae,te,ce,H,ne,F,_,B,G,ie,V,Q,A,O,N,$,Y,U,j,Z,re,le,ge,Ee,De,Ce,ke,Te,ue,de,pe,Ie,Re,Xe,Ae,Oe,We,Ye,Qe,Ze,$e,je,K,oe,he,me,be,Le,He,nt,et,qe,Je,xe,ct,lt,Tt,Wt,Ot,Ft,_t,Ut,Nt,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ct=class extends g.Disposable{constructor(we,Se,ye,ve,Me,_e,Fe,Ue,Pe,Ne){super();this.mainProcessNodeIpcServer=we,this.userEnv=Se,this.mainInstantiationService=ye,this.logService=ve,this.environmentMainService=Me,this.lifecycleMainService=_e,this.configurationService=Fe,this.stateMainService=Ue,this.fileService=Pe,this.productService=Ne,this.configureSession(),this.registerListeners()}configureSession(){const we=Pe=>Pe?.startsWith(`${u.Schemas.vscodeWebview}://`),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((Pe,Ne,ze,Ve)=>we(Ve.requestingUrl)?ze(Se.has(Ne)):ze(!1)),S.session.defaultSession.setPermissionCheckHandler((Pe,Ne,ze,Ve)=>we(Ve.requestingUrl)?Se.has(Ne):!1);const ye=new Set([u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemoteResource,"devtools"]),ve=Pe=>{for(let Ne=Pe;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${u.Schemas.vscodeWebview}://`))return!0;return!1},Me=Pe=>Pe.resourceType==="xhr"||ve(Pe.frame),_e=Pe=>{const Ne=Pe.frame;if(!Ne||!this.windowsMainService)return!1;const ze=S.BrowserWindow.getAllWindows();for(const Ve of ze)if(Ne.processId===Ve.webContents.mainFrame.processId)return!0;return!1},Fe=(Pe,Ne)=>{if(Pe.path!=="/index.html")return!0;const ze=Ne.frame;if(!ze||!this.windowsMainService)return!1;for(const Ve of this.windowsMainService.getWindows())if(Ve.win&&ze.processId===Ve.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((Pe,Ne)=>{const ze=I.URI.parse(Pe.url);return ze.scheme===u.Schemas.vscodeWebview&&!Fe(ze,Pe)?(this.logService.error("Blocked vscode-webview request",Pe.url),Ne({cancel:!0})):ze.scheme===u.Schemas.vscodeFileResource&&!_e(Pe)?(this.logService.error("Blocked vscode-file request",Pe.url),Ne({cancel:!0})):ze.path.endsWith(".svg")&&!ye.has(ze.scheme)?Ne({cancel:!Me(Pe)}):Ne({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((Pe,Ne)=>{const ze=Pe.responseHeaders,Ve=ze["content-type"]||ze["Content-Type"];if(Ve&&Array.isArray(Ve)){const rt=I.URI.parse(Pe.url);if(rt.path.endsWith(".svg")&&ye.has(rt.scheme))return ze["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:ze});if(!rt.path.endsWith(u.Schemas.vscodeRemoteResource)&&Ve.some(dt=>dt.toLowerCase().includes("image/svg")))return Ne({cancel:!Me(Pe)})}return Ne({cancel:!1})});const Ue=S.session.defaultSession;typeof Ue.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ue.setCodeCachePath((0,b.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,f.setUnexpectedErrorHandler)(ye=>this.onUnexpectedError(ye)),process.on("uncaughtException",ye=>(0,f.onUnexpectedError)(ye)),process.on("unhandledRejection",ye=>(0,f.onUnexpectedError)(ye)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,l.registerContextMenuListener)(),S.app.on("accessibility-support-changed",(ye,ve)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ve)}),S.app.on("activate",(ye,ve)=>{this.logService.trace("app#activate"),ve||this.windowsMainService?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(ye,ve)=>{ve.on("will-navigate",Me=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Me.preventDefault()}),ve.setWindowOpenHandler(({url:Me})=>(this.nativeHostMainService?.openExternal(void 0,Me),{action:"deny"}))});let we=[],Se;S.app.on("open-file",(ye,ve)=>{this.logService.trace("app#open-file: ",ve),ye.preventDefault(),we.push(this.getWindowOpenableFromPathSync(ve)),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],Se=void 0},100)}),S.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",ye=>{const ve=this.windowsMainService?.getWindowByWebContents(ye.sender);let Me,_e;return ve?.config?(Me=ve.config,_e={...process.env,...ve.config.userEnv}):(Me=this.environmentMainService.args,_e=process.env),this.resolveShellEnvironment(Me,_e,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(ye,ve,Me)=>{const _e=this.validateNlsPath([ve]);if(!_e||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(_e,M.VSBuffer.fromString(Me))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(ye,...ve)=>{const Me=this.validateNlsPath(ve);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Me)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",ye=>ye.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",ye=>ye.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",ye=>ye.sender.reload())}validateNlsPath(we){let Se;for(const ye of we)typeof ye=="string"&&(typeof Se!="string"?Se=ye:Se=(0,b.join)(Se,ye));if(!(typeof Se!="string"||!(0,b.isAbsolute)(Se)||!(0,p.isEqualOrParent)(Se,this.environmentMainService.cachedLanguagesPath,!m.isLinux)))return I.URI.file(Se)}onUnexpectedError(we){if(we){const Se={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;m.isWindows&&we&&S.app.setAppUserModelId(we);try{m.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Pe){this.logService.error(Pe)}const Se=new n.Server;this.lifecycleMainService.onWillShutdown(Pe=>{Pe.reason===2&&Se.dispose()}),this.logService.trace("Resolving machine identifier...");const ye=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ye}`);const{sharedProcess:ve,sharedProcessReady:Me,sharedProcessClient:_e}=this.setupSharedProcess(ye),Fe=await this.initServices(ye,ve,Me);this.setUpHandlers(Fe),Fe.invokeFunction(Pe=>this.initChannels(Pe,Se,_e));const Ue=Fe.invokeFunction(Pe=>this.openFirstWindow(Pe,Se));Fe.invokeFunction(Pe=>this.afterWindowOpen(Pe,ve)),this.environmentMainService.args.trace&&Fe.invokeFunction(Pe=>this.stopTracingEventually(Pe,Ue))}setUpHandlers(we){this._register(we.createInstance(s.ProxyAuthHandler)),this._register(we.createInstance(Ut.DefaultExtensionsProfileInitHandler))}async resolveMachineId(){let we=this.stateMainService.getItem(Re.machineIdKey);return(!we||m.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,h.getMachineId)(),this.stateMainService.setItem(Re.machineIdKey,we)),we}setupSharedProcess(we){const Se=this._register(this.mainInstantiationService.createInstance(ke.SharedProcess,we,this.userEnv)),ye=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Me=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(Me,"main")})(),ve=(async()=>(await Se.whenReady(),ye))();return{sharedProcess:Se,sharedProcessReady:ve,sharedProcessClient:ye}}async initServices(we,Se,ye){const ve=new $.ServiceCollection;switch(process.platform){case"win32":ve.set(We.IUpdateService,new O.SyncDescriptor(je.Win32UpdateService));break;case"linux":m.isLinuxSnap?ve.set(We.IUpdateService,new O.SyncDescriptor($e.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(We.IUpdateService,new O.SyncDescriptor(Ze.LinuxUpdateService));break;case"darwin":ve.set(We.IUpdateService,new O.SyncDescriptor(Qe.DarwinUpdateService));break}ve.set(He.IWindowsMainService,new O.SyncDescriptor(nt.WindowsMainService,[we,this.userEnv])),ve.set(q.IDialogMainService,new O.SyncDescriptor(q.DialogMainService)),ve.set(j.ILaunchMainService,new O.SyncDescriptor(j.LaunchMainService)),ve.set(W.IDiagnosticsMainService,new O.SyncDescriptor(W.DiagnosticsMainService)),ve.set(T.IDiagnosticsService,r.ProxyChannel.toService((0,r.getDelayedChannel)(ye.then(_e=>_e.getChannel("diagnostics"))))),ve.set(Y.IIssueMainService,new O.SyncDescriptor(Y.IssueMainService,[this.userEnv])),ve.set(ee.IEncryptionMainService,new O.SyncDescriptor(se.EncryptionMainService,[we])),ve.set(U.IKeyboardLayoutMainService,new O.SyncDescriptor(U.KeyboardLayoutMainService)),ve.set(Ee.INativeHostMainService,new O.SyncDescriptor(Ee.NativeHostMainService,[Se])),ve.set(P.ICredentialsMainService,new O.SyncDescriptor(Tt.CredentialsNativeMainService)),ve.set(be.IWebviewManagerService,new O.SyncDescriptor(Le.WebviewMainService)),ve.set(Je.IWorkspacesService,new O.SyncDescriptor(ct.WorkspacesMainService)),ve.set(lt.IWorkspacesManagementMainService,new O.SyncDescriptor(lt.WorkspacesManagementMainService)),ve.set(xe.IWorkspacesHistoryMainService,new O.SyncDescriptor(xe.WorkspacesHistoryMainService)),ve.set(ge.IMenubarMainService,new O.SyncDescriptor(ge.MenubarMainService)),ve.set(H.IExtensionUrlTrustService,new O.SyncDescriptor(ne.ExtensionUrlTrustService)),ve.set(F.IExtensionHostStarter,new O.SyncDescriptor(_.ExtensionHostStarter)),ve.set(pe.IStorageMainService,new O.SyncDescriptor(pe.StorageMainService)),ve.set(pe.IApplicationStorageMainService,new O.SyncDescriptor(pe.ApplicationStorageMainService)),m.isWindows?ve.set(B.IExternalTerminalMainService,new O.SyncDescriptor(G.WindowsExternalTerminalService)):m.isMacintosh?ve.set(B.IExternalTerminalMainService,new O.SyncDescriptor(G.MacExternalTerminalService)):m.isLinux&&ve.set(B.IExternalTerminalMainService,new O.SyncDescriptor(G.LinuxExternalTerminalService));const Me=new c.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ve.set(a.IBackupMainService,Me),ve.set(K.IURLService,new O.SyncDescriptor(he.NativeURLService)),(0,Oe.supportsTelemetry)(this.productService,this.environmentMainService)){const _e=(0,Oe.isInternalTelemetry)(this.productService,this.configurationService),Fe=(0,r.getDelayedChannel)(ye.then(Ve=>Ve.getChannel("telemetryAppender"))),Ue=new Xe.TelemetryAppenderClient(Fe),Pe=(0,Ie.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,we,_e,this.environmentMainService.installSourcePath),Ne=(0,Oe.getPiiPathsFromEnvironment)(this.environmentMainService),ze={appenders:[Ue],commonProperties:Pe,piiPaths:Ne,sendErrorTelemetry:!0};ve.set(Re.ITelemetryService,new O.SyncDescriptor(Ae.TelemetryService,[ze]))}else ve.set(Re.ITelemetryService,Oe.NullTelemetryService);return ve.set(_t.IDefaultExtensionsProfileInitService,r.ProxyChannel.toService((0,r.getDelayedChannel)(ye.then(_e=>_e.getChannel("IDefaultExtensionsProfileInitService"))))),await Me.initialize(),this.mainInstantiationService.createChild(ve)}initChannels(we,Se,ye){const ve=r.ProxyChannel.fromService(we.get(j.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ve);const Me=r.ProxyChannel.fromService(we.get(W.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Me);const _e=new Ot.PolicyChannel(we.get(Wt.IPolicyService));Se.registerChannel("policy",_e),ye.then(Ge=>Ge.registerChannel("policy",_e));const Fe=this.fileService.getProvider(u.Schemas.file);(0,E.assertType)(Fe instanceof A.DiskFileSystemProvider);const Ue=new Q.DiskFileSystemProviderChannel(Fe,this.logService,this.environmentMainService);Se.registerChannel(ie.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Ue),ye.then(Ge=>Ge.registerChannel(ie.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Ue));const Pe=r.ProxyChannel.fromService(we.get(Ft.IUserDataProfilesMainService));Se.registerChannel("userDataProfiles",Pe),ye.then(Ge=>Ge.registerChannel("userDataProfiles",Pe));const Ne=new Nt.RequestChannel(we.get(Bt.IRequestService));ye.then(Ge=>Ge.registerChannel("request",Ne));const ze=new Ye.UpdateChannel(we.get(We.IUpdateService));Se.registerChannel("update",ze);const Ve=r.ProxyChannel.fromService(we.get(Y.IIssueMainService));Se.registerChannel("issue",Ve);const rt=r.ProxyChannel.fromService(we.get(ee.IEncryptionMainService));Se.registerChannel("encryption",rt);const dt=r.ProxyChannel.fromService(we.get(P.ICredentialsMainService));Se.registerChannel("credentials",dt);const Pt=r.ProxyChannel.fromService(we.get(Te.ISignService));Se.registerChannel("sign",Pt);const Ke=r.ProxyChannel.fromService(we.get(U.IKeyboardLayoutMainService));Se.registerChannel("keyboardLayout",Ke),this.nativeHostMainService=we.get(Ee.INativeHostMainService);const ft=r.ProxyChannel.fromService(this.nativeHostMainService);Se.registerChannel("nativeHost",ft),ye.then(Ge=>Ge.registerChannel("nativeHost",ft));const gt=r.ProxyChannel.fromService(we.get(Je.IWorkspacesService));Se.registerChannel("workspaces",gt);const mt=r.ProxyChannel.fromService(we.get(ge.IMenubarMainService));Se.registerChannel("menubar",mt);const pt=r.ProxyChannel.fromService(we.get(K.IURLService));Se.registerChannel("url",pt);const vt=r.ProxyChannel.fromService(we.get(H.IExtensionUrlTrustService));Se.registerChannel("extensionUrlTrust",vt);const wt=r.ProxyChannel.fromService(we.get(be.IWebviewManagerService));Se.registerChannel("webview",wt);const ut=this._register(new de.StorageDatabaseChannel(this.logService,we.get(pe.IStorageMainService)));Se.registerChannel("storage",ut),ye.then(Ge=>Ge.registerChannel("storage",ut));const St=r.ProxyChannel.fromService(we.get(B.IExternalTerminalMainService));Se.registerChannel("externalTerminal",St);const Be=new le.LogLevelChannel(we.get(re.ILogService));Se.registerChannel("logLevel",Be),ye.then(Ge=>Ge.registerChannel("logLevel",Be));const it=new le.LoggerChannel(we.get(re.ILoggerService));Se.registerChannel("logger",it),ye.then(Ge=>Ge.registerChannel("logger",it));const at=new L.ElectronExtensionHostDebugBroadcastChannel(we.get(He.IWindowsMainService));Se.registerChannel("extensionhostdebugservice",at);const st=r.ProxyChannel.fromService(we.get(F.IExtensionHostStarter));Se.registerChannel(F.ipcExtensionHostStarterChannelName,st)}openFirstWindow(we,Se){const ye=this.windowsMainService=we.get(He.IWindowsMainService),ve=we.get(K.IURLService),Me=we.get(Ee.INativeHostMainService);this.lifecycleMainService.phase=2;const _e=[],Fe=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Be=>{try{return{uri:I.URI.parse(Be),url:Be}}catch{return}}).filter(Be=>{if(!Be||this.shouldBlockURI(Be.uri))return!1;const it=this.getWindowOpenableFromProtocolLink(Be.uri);return it?(_e.push(it),!1):!0}),Ue=this,Pe=this.environmentMainService,Ne=this.productService,ze=this.logService;ve.registerHandler({async handleURL(Be,it){if(ze.trace("app#handleURL: ",Be.toString(!0),it),Be.scheme===Ne.urlProtocol&&Be.path==="workspace"&&(Be=Be.with({authority:"file",path:I.URI.parse(Be.query).path,query:""})),Ue.shouldBlockURI(Be))return!0;let at=!1;const st=new URLSearchParams(Be.query);st.get("windowId")==="_blank"&&(st.delete("windowId"),Be=Be.with({query:st.toString()}),at=!0),at||(at=m.isMacintosh&&ye.getWindowCount()===0),st.get("editSessionId")!==null&&(Pe.editSessionId=st.get("editSessionId")??void 0,st.delete("editSessionId"),Be=Be.with({query:st.toString()}));const Ge=Ue.getWindowOpenableFromProtocolLink(Be);if(ze.trace("app#handleURL: windowOpenableFromProtocolLink = ",Ge),Ge){const[It]=ye.open({context:5,cli:{...Pe.args},urisToOpen:[Ge],forceNewWindow:at,gotoLineMode:!0});return It.focus(),!0}if(at){const[It]=ye.open({context:5,cli:{...Pe.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ce.getRemoteAuthority)(Be)});return await It.ready(),ve.open(Be,it)}return!1}});const Ve=this._register(new et.ActiveWindowManager({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),rt=new r.StaticRouter(Be=>Ve.getActiveClientId().then(it=>Be===it)),dt=new oe.URLHandlerRouter(rt),Pt=Se.getChannel("urlHandler",dt);ve.registerHandler(new oe.URLHandlerChannelClient(Pt)),this._register(new me.ElectronURLListener(Fe,ve,ye,this.environmentMainService,this.productService));const Ke=this.environmentMainService.args,ft=global.macOpenFiles,gt=(0,te.isLaunchedFromCli)(process.env)?0:4,mt=Ke._.length,pt=!!Ke["folder-uri"],vt=!!Ke["file-uri"],wt=Ke["skip-add-to-recently-opened"]===!0,ut=Ke.wait&&Ke.waitMarkerFilePath?I.URI.file(Ke.waitMarkerFilePath):void 0,St=Ke.remote||void 0;return _e.length>0?ye.open({context:gt,cli:Ke,urisToOpen:_e,gotoLineMode:!0,initialStartup:!0}):Ke["new-window"]&&!mt&&!pt&&!vt?ye.open({context:gt,cli:Ke,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:St}):ft.length&&!mt&&!pt&&!vt?ye.open({context:1,cli:Ke,urisToOpen:ft.map(Be=>this.getWindowOpenableFromPathSync(Be)),noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0}):ye.open({context:gt,cli:Ke,forceNewWindow:Ke["new-window"]||!mt&&Ke["unity-launch"],diffMode:Ke.diff,mergeMode:Ke.merge,noRecentEntry:wt,waitMarkerFileURI:ut,gotoLineMode:Ke.goto,initialStartup:!0,remoteAuthority:St})}shouldBlockURI(we){return!!(we.authority===u.Schemas.file&&m.isWindows&&S.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,y.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,y.getPathLabel)(we,{os:m.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===u.Schemas.file){const Se=I.URI.file(we.fsPath);return(0,qe.hasWorkspaceFileExtension)(Se)?{workspaceUri:Se}:{fileUri:Se}}else if(we.authority===u.Schemas.vscodeRemote){const Se=we.path.indexOf(b.posix.sep,1);if(Se!==-1){const ye=we.path.substring(1,Se),ve=we.path.substring(Se),Me=I.URI.from({scheme:u.Schemas.vscodeRemote,authority:ye,path:ve,query:we.query,fragment:we.fragment});return(0,qe.hasWorkspaceFileExtension)(ve)?{workspaceUri:Me}:/:[\d]+$/.test(ve)?{fileUri:Me}:{folderUri:Me}}}}}getWindowOpenableFromPathSync(we){try{if((0,D.statSync)(we).isDirectory())return{folderUri:I.URI.file(we)};if((0,qe.hasWorkspaceFileExtension)(we))return{workspaceUri:I.URI.file(we)}}catch{}return{fileUri:I.URI.file(we)}}async afterWindowOpen(we,Se){this.lifecycleMainService.phase=3;let ye=!1;(0,C.once)(this.lifecycleMainService.onWillShutdown)(()=>ye=!0);const ve=we.get(Re.ITelemetryService);this._register(Se.onDidError(({type:Fe,details:Ue})=>{let Pe;switch(Fe){case 1:Pe="SharedProcess: detected unresponsive window";break;case 2:Pe=`SharedProcess: crashed (detail: ${Ue?.reason??"<unknown>"}, code: ${Ue?.exitCode??"<unknown>"})`;break;case 3:Pe=`SharedProcess: failed to load (detail: ${Ue?.reason??"<unknown>"}, code: ${Ue?.exitCode??"<unknown>"})`;break}(0,f.onUnexpectedError)(new Error(Pe)),ve.publicLog2("sharedprocesserror",{type:Fe,reason:Ue?.reason,code:Ue?.exitCode,visible:Se.isVisible(),shuttingdown:ye})}));const Me=this.productService.win32MutexName;if(m.isWindows&&Me)try{const Fe=z.__$__nodeRequire("windows-mutex").Mutex,Ue=new Fe(Me);(0,C.once)(this.lifecycleMainService.onWillShutdown)(()=>Ue.release())}catch(Fe){this.logService.error(Fe)}S.protocol.registerHttpProtocol(u.Schemas.vscodeRemoteResource,(Fe,Ue)=>{Ue({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})});const _e=we.get(We.IUpdateService);(_e instanceof je.Win32UpdateService||_e instanceof Ze.LinuxUpdateService||_e instanceof Qe.DarwinUpdateService)&&await _e.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Ue=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,k.stripComments)(Ue))["enable-crash-reporter"]===void 0){const ze=(0,Oe.getTelemetryLevel)(this.configurationService)>=1,Ve=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ze},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,w.generateUuid)()}"`,"}"],rt=Ue.substring(0,Ue.length-2).concat(`,
`,Ve.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(rt))}}catch(Fe){this.logService.error(Fe)}}async resolveShellEnvironment(we,Se,ye){try{return await(0,ce.getResolvedShellEnv)(this.logService,we,Se)}catch(ve){const Me=(0,v.toErrorMessage)(ve);ye?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Me):this.logService.error(Me)}return{}}stopTracingEventually(we,Se){this.logService.info("Tracing: waiting for windows to get ready...");const ye=we.get(q.IDialogMainService);let ve=!1;const Me=async Fe=>{if(ve)return;ve=!0;const Ue=await S.contentTracing.stopRecording(`${(0,p.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Fe?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ue}`):ye.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,Ue),buttons:[(0,y.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,E.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow()))},_e=setTimeout(()=>Me(!0),3e4);Promise.all(Se.map(Fe=>Fe.ready())).then(()=>{clearTimeout(_e),Me(!1)})}};Ct=fe([x(2,N.IInstantiationService),x(3,re.ILogService),x(4,ae.IEnvironmentMainService),x(5,Z.ILifecycleMainService),x(6,d.IConfigurationService),x(7,ue.IStateMainService),x(8,V.IFileService),x(9,De.IProductService)],Ct),e.CodeApplication=Ct}),define(X[257],J([0,1,37,8,264,2]),function(z,e,S,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class M extends S.AbstractPolicyService{constructor(f){super();this.productName=f,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(f){await this.throttler.queue(()=>new Promise((p,C)=>{try{this.watcher.value=(0,D.createWatcher)(this.productName,f,k=>{for(const y in k){const g=k[y];g===void 0?this.policies.delete(y):this.policies.set(y,g)}this._onDidChange.fire(Object.keys(k)),p()})}catch(k){C(k)}}))}}e.NativePolicyService=M}),define(X[258],J([0,1,212,8,17,19,2,13,18,39,106,6,211,265]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let u=class extends M.Disposable{constructor(m,E,I){super();this.environmentService=E,this.logService=I,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,E){this.logService.trace("RequestService#request (node) - begin",m.url);const{proxyUrl:I,strictSSL:w}=this;let h;try{h=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",n))}const l={...process.env,...h},r=m.agent?m.agent:await(0,y.getProxyAgent)(m.url||"",l,{proxyUrl:I,strictSSL:w});m.agent=r,m.strictSSL=w,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization});try{const n=await this._request(m,E);return this.logService.trace("RequestService#request (node) - success",m.url),n}catch(n){throw this.logService.trace("RequestService#request (node) - error",m.url,n),n}}async getNodeRequest(m){return((0,S.parse)(m.url).protocol==="https:"?await new Promise((w,h)=>{z(["https"],w,h)}):await new Promise((w,h)=>{z(["http"],w,h)})).request}_request(m,E){return t.Promises.withAsyncBody(async(I,w)=>{const h=(0,S.parse)(m.url),l=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),r={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,v.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(r.auth=m.user+":"+m.password);const n=l(r,i=>{const s=(0,v.isNumber)(m.followRedirects)?m.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)this._request({...m,url:i.headers.location,followRedirects:s-1},E).then(I,w);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,g.createGunzip)())),I({res:i,stream:(0,D.streamToBufferReadableStream)(o)})}});n.on("error",w),m.timeout&&n.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&n.write(m.data),n.end(),E.onCancellationRequested(()=>{n.abort(),w(new R.CancellationError)})})}async resolveProxy(m){}};u=fe([x(0,f.IConfigurationService),x(1,p.INativeEnvironmentService),x(2,k.ILogService)],u),e.RequestService=u}),define(X[259],J([0,1,14,258]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(M){return S.net.request}class R extends t.RequestService{request(v,f){return super.request({...v||{},getRawRequest:D},f)}}e.RequestMainService=R}),define(X[266],J([0,1,14,28,7,25,8,41,19,30,48,34,12,9,70,4,36,31,23,43,81,256,10,18,206,218,26,56,179,15,194,85,67,191,84,22,103,6,199,104,58,20,59,242,108,224,52,259,86,213,45,217,72,61,63,37,257,201,2,62,229,40,225]),function(z,e,S,t,D,R,M,v,f,p,C,k,y,g,u,b,m,E,I,w,h,l,r,n,i,s,o,a,c,d,P,L,T,W,q,ee,se,ae,te,ce,H,ne,F,_,B,G,ie,V,Q,A,O,N,$,Y,U,j,Z,re,le,ge,Ee,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ce{main(){try{this.startup()}catch(ue){console.error(ue.message),S.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(We=>console.error(We));const[ue,de,pe,Ie,Re,Xe,Ae,Oe]=this.createServices();try{try{await this.initServices(pe,Oe,Ie,Re)}catch(We){throw this.handleStartupDataDirError(pe,Ae.nameLong,We),We}await ue.invokeFunction(async We=>{const Ye=We.get(ae.ILogService),Qe=We.get(ee.ILifecycleMainService),Ze=We.get(d.IFileService),$e=await this.claimInstance(Ye,pe,Qe,ue,Ae,!0);return I.Promises.writeFile(pe.mainLockfile,String(process.pid)).catch(je=>{Ye.warn(`Error writing main lockfile: ${je.stack}`)}),Xe.logger=new ce.SpdLogLogger("main",(0,g.join)(pe.logsPath,"main.log"),!0,!1,Xe.getLevel()),(0,C.once)(Qe.onWillShutdown)(je=>{Ze.dispose(),Ie.dispose(),je.join(I.Promises.unlink(pe.mainLockfile).catch(()=>{}))}),ue.createInstance(l.CodeApplication,$e,de).startup()})}catch(We){ue.invokeFunction(this.quit,We)}}createServices(){const ue=new q.ServiceCollection,de=new le.DisposableStore;process.once("exit",()=>de.dispose());const pe={_serviceBrand:void 0,...H.default};ue.set(ne.IProductService,pe);const Ie=new o.EnvironmentMainService(this.resolveArgs(),pe),Re=this.patchEnvironment(Ie);ue.set(o.IEnvironmentMainService,Ie);const Xe=new se.BufferLogService,Ae=de.add(new ae.MultiplexLogService([new ae.ConsoleMainLogger((0,ae.getLogLevel)(Ie)),Xe]));ue.set(ae.ILogService,Ae);const Oe=new P.FileService(Ae);ue.set(d.IFileService,Oe);const We=new L.DiskFileSystemProvider(Ae);Oe.registerProvider(y.Schemas.file,We);const Ye=new Ee.UriIdentityService(Oe);ue.set(ge.IUriIdentityService,Ye),ue.set(ae.ILoggerService,new te.LoggerService(Ae,Oe));const Qe=new N.StateMainService(Ie,Ae,Oe);ue.set(O.IStateMainService,Qe);const Ze=new U.UserDataProfilesMainService(Qe,Ye,Ie,Oe,Ae);ue.set(U.IUserDataProfilesMainService,Ze);const $e=b.isWindows&&pe.win32RegValueName?de.add(new Z.NativePolicyService(pe.win32RegValueName)):Ie.policyFile?de.add(new re.FilePolicyService(Ie.policyFile,Oe,Ae)):new j.NullPolicyService;ue.set(j.IPolicyService,$e);const je=new i.ConfigurationService(Ze.defaultProfile.settingsResource,Oe,$e,Ae);return ue.set(n.IConfigurationService,je),ue.set(ee.ILifecycleMainService,new T.SyncDescriptor(ee.LifecycleMainService)),ue.set(ie.IRequestService,new T.SyncDescriptor(V.RequestMainService)),ue.set(Y.IThemeMainService,new T.SyncDescriptor(Y.ThemeMainService)),ue.set(Q.ISignService,new T.SyncDescriptor(A.SignService)),ue.set(B.ITunnelService,new T.SyncDescriptor(G.TunnelService)),ue.set(F.IProtocolMainService,new T.SyncDescriptor(_.ProtocolMainService)),[new W.InstantiationService(ue,!0),Re,Ie,je,Qe,Xe,pe,Ze]}patchEnvironment(ue){const de={VSCODE_IPC_HOOK:ue.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(pe=>{const Ie=process.env[pe];typeof Ie=="string"&&(de[pe]=Ie)}),Object.assign(process.env,de),de}async initServices(ue,de,pe,Ie){await M.Promises.settled([Promise.all([ue.extensionsPath,ue.codeCachePath,ue.logsPath,de.defaultProfile.globalStorageHome.fsPath,ue.workspaceStorageHome.fsPath,ue.localHistoryHome.fsPath,ue.backupHome].map(Re=>Re?I.Promises.mkdir(Re,{recursive:!0}):void 0)),Ie.init(),pe.initialize()]),de.setEnablement(!!pe.getValue(De.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(ue,de,pe,Ie,Re,Xe){let Ae;try{(0,u.mark)("code/willStartMainServer"),Ae=await(0,h.serve)(de.mainIPCHandle),(0,u.mark)("code/didStartMainServer"),(0,C.once)(pe.onWillShutdown)(()=>Ae.dispose())}catch(Oe){if(Oe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(de,Re.nameLong,Oe),Oe;let We;try{We=await(0,h.connect)(de.mainIPCHandle,"main")}catch($e){if(!Xe||b.isWindows||$e.code!=="ECONNREFUSED")throw $e.code==="EPERM"&&this.showStartupWarningDialog((0,r.localize)(0,null,Re.nameShort),(0,r.localize)(1,null),Re.nameLong),$e;try{(0,t.unlinkSync)(de.mainIPCHandle)}catch(je){throw ue.warn("Could not delete obsolete instance handle",je),je}return this.claimInstance(ue,de,pe,Ie,Re,!1)}if(de.extensionTestsLocationURI&&!de.debugExtensionHost.break){const $e="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ue.error($e),We.dispose(),new Error($e)}let Ye;!de.args.wait&&!de.args.status&&(Ye=setTimeout(()=>{this.showStartupWarningDialog((0,r.localize)(2,null,Re.nameShort),(0,r.localize)(3,null),Re.nameLong)},1e4));const Qe=w.ProxyChannel.toService(We.getChannel("launch"),{disableMarshalling:!0}),Ze=w.ProxyChannel.toService(We.getChannel("diagnostics"),{disableMarshalling:!0});if(de.args.status)return Ie.invokeFunction(async()=>{const $e=new s.DiagnosticsService($.NullTelemetryService,Re),je=await Qe.getMainProcessInfo(),K=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),oe=await $e.getDiagnostics(je,K);throw console.log(oe),new f.ExpectedError});throw b.isWindows&&await this.windowsAllowSetForegroundWindow(Qe,ue),ue.trace("Sending env to running instance..."),await Qe.start(de.args,process.env),We.dispose(),Ye&&clearTimeout(Ye),new f.ExpectedError("Sent env to running instance. Terminating...")}if(de.args.status)throw ue.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ae}handleStartupDataDirError(ue,de,pe){if(pe.code==="EACCES"||pe.code==="EPERM"){const Ie=(0,R.coalesce)([ue.userDataPath,ue.extensionsPath,h.XDG_RUNTIME_DIR]).map(Re=>(0,k.getPathLabel)(D.URI.file(Re),{os:b.OS,tildify:ue}));this.showStartupWarningDialog((0,r.localize)(4,null),(0,r.localize)(5,null,(0,v.toErrorMessage)(pe),Ie.join(`
`)),de)}}showStartupWarningDialog(ue,de,pe){S.dialog.showMessageBoxSync({title:pe,type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,r.localize)(6,null))],message:ue,detail:de,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ue,de){if(b.isWindows){const pe=await ue.getMainProcessId();de.trace("Sending some foreground love to the running instance:",pe);try{(await new Promise((Ie,Re)=>{z(["windows-foreground-love"],Ie,Re)})).allowSetForegroundWindow(pe)}catch(Ie){de.error(Ie)}}}quit(ue,de){const pe=ue.get(ae.ILogService),Ie=ue.get(ee.ILifecycleMainService);let Re=0;de&&(de.isExpected?de.message&&pe.trace(de.message):(Re=1,de.stack?pe.error(de.stack):pe.error(`Startup error: ${de.toString()}`))),Ie.kill(Re)}resolveArgs(){const ue=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(ue.wait&&!ue.waitMarkerFilePath){const de=(0,c.createWaitMarkerFile)(ue.verbose);de&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",de),ue.waitMarkerFilePath=de)}return ue}validatePaths(ue){if(ue["open-url"]&&(ue._urls=ue._,ue._=[]),!ue.remote){const de=this.doValidatePaths(ue._,ue.goto);ue._=de}return ue}doValidatePaths(ue,de){const pe=(0,m.cwd)(),Ie=ue.map(Ae=>{let Oe=String(Ae),We;de&&(We=(0,p.parseLineAndColumnAware)(Oe),Oe=We.path),Oe&&(Oe=this.preparePath(pe,Oe));const Ye=(0,p.sanitizeFilePath)(Oe,pe),Qe=(0,g.basename)(Ye);return Qe&&!(0,p.isValidBasename)(Qe)?null:de&&We?(We.path=Ye,this.toPath(We)):Ye}),Re=b.isWindows||b.isMacintosh,Xe=(0,R.distinct)(Ie,Ae=>Ae&&Re?Ae.toLowerCase():Ae||"");return(0,R.coalesce)(Xe)}preparePath(ue,de){return b.isWindows&&(de=(0,E.rtrim)(de,'"')),de=(0,E.trim)((0,E.trim)(de," "),"	"),b.isWindows&&(de=(0,g.resolve)(ue,de),de=(0,E.rtrim)(de,".")),de}toPath(ue){const de=[ue.path];return typeof ue.line=="number"&&de.push(String(ue.line)),typeof ue.column=="number"&&de.push(String(ue.column)),de.join(":")}}new Ce().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/electron-main/main.js.map
