/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/types","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/platform","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/cancellation","vs/platform/userDataProfile/common/userDataProfile","vs/platform/product/common/productService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/strings","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","child_process","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/base/node/decoder","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/processes","vs/base/common/extpath","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","graceful-fs","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],ee=function($){for(var t=[],D=0,C=$.length;D<C;D++)t[D]=Z[$[D]];return t};define(Z[68],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function D(C,b){if(!C)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}t.ok=D}),define(Z[50],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function D(T){return(p,a,h)=>{let I=null,w=null;if(typeof h.value=="function"?(I="value",w=h.value):typeof h.get=="function"&&(I="get",w=h.get),!w)throw new Error("not supported");h[I]=T(w,a)}}t.createDecorator=D;function C(T,p,a){let h=null,I=null;if(typeof a.value=="function"?(h="value",I=a.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(h="get",I=a.get),!I)throw new Error("not supported");const w=`$memoize$${p}`;a[h]=function(...g){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,g)}),this[w]}}t.memoize=C;function b(T,p,a){return D((h,I)=>{const w=`$debounce$${I}`,g=`$debounce$result$${I}`;return function(...E){this[g]||(this[g]=a?a():void 0),clearTimeout(this[w]),p&&(this[g]=p(this[g],...E),E=[this[g]]),this[w]=setTimeout(()=>{h.apply(this,E),this[g]=a?a():void 0},T)}})}t.debounce=b;function L(T,p,a){return D((h,I)=>{const w=`$throttle$timer$${I}`,g=`$throttle$result$${I}`,E=`$throttle$lastRun$${I}`,l=`$throttle$pending$${I}`;return function(...d){if(this[g]||(this[g]=a?a():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),p&&(this[g]=p(this[g],...d)),this[l])return;const v=this[E]+T;v<=Date.now()?(this[E]=Date.now(),h.apply(this,[this[g]]),this[g]=a?a():void 0):(this[l]=!0,this[w]=setTimeout(()=>{this[l]=!1,this[E]=Date.now(),h.apply(this,[this[g]]),this[g]=a?a():void 0},v-Date.now()))}})}t.throttle=L}),define(Z[51],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var D;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(D=t.ScanError||(t.ScanError={}));var C;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(C=t.SyntaxKind||(t.SyntaxKind={}));var b;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(b=t.ParseErrorCode||(t.ParseErrorCode={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L=t.ParseOptions||(t.ParseOptions={}));function T(i,n=!1){let e=0;const r=i.length;let o="",m=0,S=16,P=0;function k(re){let ge=0,ae=0;for(;ge<re;){const N=i.charCodeAt(e);if(N>=48&&N<=57)ae=ae*16+N-48;else if(N>=65&&N<=70)ae=ae*16+N-65+10;else if(N>=97&&N<=102)ae=ae*16+N-97+10;else break;e++,ge++}return ge<re&&(ae=-1),ae}function U(re){e=re,o="",m=0,S=16,P=0}function B(){const re=e;if(i.charCodeAt(e)===48)e++;else for(e++;e<i.length&&h(i.charCodeAt(e));)e++;if(e<i.length&&i.charCodeAt(e)===46)if(e++,e<i.length&&h(i.charCodeAt(e)))for(e++;e<i.length&&h(i.charCodeAt(e));)e++;else return P=3,i.substring(re,e);let ge=e;if(e<i.length&&(i.charCodeAt(e)===69||i.charCodeAt(e)===101))if(e++,(e<i.length&&i.charCodeAt(e)===43||i.charCodeAt(e)===45)&&e++,e<i.length&&h(i.charCodeAt(e))){for(e++;e<i.length&&h(i.charCodeAt(e));)e++;ge=e}else P=3;return i.substring(re,ge)}function q(){let re="",ge=e;for(;;){if(e>=r){re+=i.substring(ge,e),P=2;break}const ae=i.charCodeAt(e);if(ae===34){re+=i.substring(ge,e),e++;break}if(ae===92){if(re+=i.substring(ge,e),e++,e>=r){P=2;break}switch(i.charCodeAt(e++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const _=k(4);_>=0?re+=String.fromCharCode(_):P=4;break}default:P=5}ge=e;continue}if(ae>=0&&ae<=31)if(a(ae)){re+=i.substring(ge,e),P=2;break}else P=6;e++}return re}function Y(){if(o="",P=0,m=e,e>=r)return m=r,S=17;let re=i.charCodeAt(e);if(p(re)){do e++,o+=String.fromCharCode(re),re=i.charCodeAt(e);while(p(re));return S=15}if(a(re))return e++,o+=String.fromCharCode(re),re===13&&i.charCodeAt(e)===10&&(e++,o+=`
`),S=14;switch(re){case 123:return e++,S=1;case 125:return e++,S=2;case 91:return e++,S=3;case 93:return e++,S=4;case 58:return e++,S=6;case 44:return e++,S=5;case 34:return e++,o=q(),S=10;case 47:{const ge=e-1;if(i.charCodeAt(e+1)===47){for(e+=2;e<r&&!a(i.charCodeAt(e));)e++;return o=i.substring(ge,e),S=12}if(i.charCodeAt(e+1)===42){e+=2;const ae=r-1;let N=!1;for(;e<ae;){if(i.charCodeAt(e)===42&&i.charCodeAt(e+1)===47){e+=2,N=!0;break}e++}return N||(e++,P=1),o=i.substring(ge,e),S=13}return o+=String.fromCharCode(re),e++,S=16}case 45:if(o+=String.fromCharCode(re),e++,e===r||!h(i.charCodeAt(e)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=B(),S=11;default:for(;e<r&&ne(re);)e++,re=i.charCodeAt(e);if(m!==e){switch(o=i.substring(m,e),o){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return o+=String.fromCharCode(re),e++,S=16}}function ne(re){if(p(re)||a(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let re;do re=Y();while(re>=12&&re<=15);return re}return{setPosition:U,getPosition:()=>e,scan:n?ce:Y,getToken:()=>S,getTokenValue:()=>o,getTokenOffset:()=>m,getTokenLength:()=>e-m,getTokenError:()=>P}}t.createScanner=T;function p(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function a(i){return i===10||i===13||i===8232||i===8233}function h(i){return i>=48&&i<=57}var I;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(I||(I={}));function w(i,n){const e=[],r=new Object;let o;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function P(k,U,B,q){m.value=k,m.offset=U,m.length=B,m.type=q,m.colonOffset=void 0,o=m}try{y(i,{onObjectBegin:(k,U)=>{if(n<=k)throw r;o=void 0,S=n>k,e.push("")},onObjectProperty:(k,U,B)=>{if(n<U||(P(k,U,B,"property"),e[e.length-1]=k,n<=U+B))throw r},onObjectEnd:(k,U)=>{if(n<=k)throw r;o=void 0,e.pop()},onArrayBegin:(k,U)=>{if(n<=k)throw r;o=void 0,e.push(0)},onArrayEnd:(k,U)=>{if(n<=k)throw r;o=void 0,e.pop()},onLiteralValue:(k,U,B)=>{if(n<U||(P(k,U,B,s(k)),n<=U+B))throw r},onSeparator:(k,U,B)=>{if(n<=U)throw r;if(k===":"&&o&&o.type==="property")o.colonOffset=U,S=!1,o=void 0;else if(k===","){const q=e[e.length-1];typeof q=="number"?e[e.length-1]=q+1:(S=!0,e[e.length-1]=""),o=void 0}}})}catch(k){if(k!==r)throw k}return{path:e,previousNode:o,isAtPropertyKey:S,matches:k=>{let U=0;for(let B=0;U<k.length&&B<e.length;B++)if(k[U]===e[B]||k[U]==="*")U++;else if(k[U]!=="**")return!1;return U===k.length}}}t.getLocation=w;function g(i,n=[],e=L.DEFAULT){let r=null,o=[];const m=[];function S(k){Array.isArray(o)?o.push(k):r!==null&&(o[r]=k)}return y(i,{onObjectBegin:()=>{const k={};S(k),m.push(o),o=k,r=null},onObjectProperty:k=>{r=k},onObjectEnd:()=>{o=m.pop()},onArrayBegin:()=>{const k=[];S(k),m.push(o),o=k,r=null},onArrayEnd:()=>{o=m.pop()},onLiteralValue:S,onError:(k,U,B)=>{n.push({error:k,offset:U,length:B})}},e),o[0]}t.parse=g;function E(i,n=[],e=L.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(k){r.type==="property"&&(r.length=k-r.offset,r=r.parent)}function m(k){return r.children.push(k),k}y(i,{onObjectBegin:k=>{r=m({type:"object",offset:k,length:-1,parent:r,children:[]})},onObjectProperty:(k,U,B)=>{r=m({type:"property",offset:U,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:k,offset:U,length:B,parent:r})},onObjectEnd:(k,U)=>{r.length=k+U-r.offset,r=r.parent,o(k+U)},onArrayBegin:(k,U)=>{r=m({type:"array",offset:k,length:-1,parent:r,children:[]})},onArrayEnd:(k,U)=>{r.length=k+U-r.offset,r=r.parent,o(k+U)},onLiteralValue:(k,U,B)=>{m({type:s(k),offset:U,length:B,parent:r,value:k}),o(U+B)},onSeparator:(k,U,B)=>{r.type==="property"&&(k===":"?r.colonOffset=U:k===","&&o(U))},onError:(k,U,B)=>{n.push({error:k,offset:U,length:B})}},e);const P=r.children[0];return P&&delete P.parent,P}t.parseTree=E;function l(i,n){if(!i)return;let e=i;for(const r of n)if(typeof r=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let o=!1;for(const m of e.children)if(Array.isArray(m.children)&&m.children[0].value===r){e=m.children[1],o=!0;break}if(!o)return}else{const o=r;if(e.type!=="array"||o<0||!Array.isArray(e.children)||o>=e.children.length)return;e=e.children[o]}return e}t.findNodeAtLocation=l;function d(i){if(!i.parent||!i.parent.children)return[];const n=d(i.parent);if(i.parent.type==="property"){const e=i.parent.children[0].value;n.push(e)}else if(i.parent.type==="array"){const e=i.parent.children.indexOf(i);e!==-1&&n.push(e)}return n}t.getNodePath=d;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":{const n=Object.create(null);for(const e of i.children){const r=e.children[1];r&&(n[e.children[0].value]=v(r))}return n}case"null":case"string":case"number":case"boolean":return i.value;default:return}}t.getNodeValue=v;function u(i,n,e=!1){return n>=i.offset&&n<i.offset+i.length||e&&n===i.offset+i.length}t.contains=u;function f(i,n,e=!1){if(u(i,n,e)){const r=i.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const m=f(r[o],n,e);if(m)return m}return i}}t.findNodeAtOffset=f;function y(i,n,e=L.DEFAULT){const r=T(i,!1);function o(F){return F?()=>F(r.getTokenOffset(),r.getTokenLength()):()=>!0}function m(F){return F?V=>F(V,r.getTokenOffset(),r.getTokenLength()):()=>!0}const S=o(n.onObjectBegin),P=m(n.onObjectProperty),k=o(n.onObjectEnd),U=o(n.onArrayBegin),B=o(n.onArrayEnd),q=m(n.onLiteralValue),Y=m(n.onSeparator),ne=o(n.onComment),ce=m(n.onError),re=e&&e.disallowComments,ge=e&&e.allowTrailingComma;function ae(){for(;;){const F=r.scan();switch(r.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:re||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(F){case 12:case 13:re?N(10):ne();break;case 16:N(1);break;case 15:case 14:break;default:return F}}}function N(F,V=[],R=[]){if(ce(F),V.length+R.length>0){let O=r.getToken();for(;O!==17;){if(V.indexOf(O)!==-1){ae();break}else if(R.indexOf(O)!==-1)break;O=ae()}}}function _(F){const V=r.getTokenValue();return F?q(V):P(V),ae(),!0}function M(){switch(r.getToken()){case 11:{let F=0;try{F=JSON.parse(r.getTokenValue()),typeof F!="number"&&(N(2),F=0)}catch{N(2)}q(F);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return ae(),!0}function A(){return r.getToken()!==10?(N(3,[],[2,5]),!1):(_(!1),r.getToken()===6?(Y(":"),ae(),Q()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function W(){S(),ae();let F=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(F||N(4,[],[]),Y(","),ae(),r.getToken()===2&&ge)break}else F&&N(6,[],[]);A()||N(4,[],[2,5]),F=!0}return k(),r.getToken()!==2?N(7,[2],[]):ae(),!0}function G(){U(),ae();let F=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(F||N(4,[],[]),Y(","),ae(),r.getToken()===4&&ge)break}else F&&N(6,[],[]);Q()||N(4,[],[4,5]),F=!0}return B(),r.getToken()!==4?N(8,[4],[]):ae(),!0}function Q(){switch(r.getToken()){case 3:return G();case 1:return W();case 10:return _(!0);default:return M()}}return ae(),r.getToken()===17?e.allowEmptyContent?!0:(N(4,[],[]),!1):Q()?(r.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}t.visit=y;function c(i,n){const e=T(i),r=[];let o,m=0,S;do switch(S=e.getPosition(),o=e.scan(),o){case 12:case 13:case 17:m!==S&&r.push(i.substring(m,S)),n!==void 0&&r.push(e.getTokenValue().replace(/[^\r\n]/g,n)),m=e.getPosition();break}while(o!==17);return r.join("")}t.stripComments=c;function s(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function $(b){const L=[];typeof b=="number"&&L.push("code/timeOrigin",b);function T(a){L.push(a,Date.now())}function p(){const a=[];for(let h=0;h<L.length;h+=2)a.push({name:L[h],startTime:L[h+1]});return a}return{mark:T,getMarks:p}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const T of performance.getEntriesByType("mark"))L.push({name:T.name,startTime:Math.round(b+T.startTime)});return L}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function D(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=t()),b.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=D(C))}(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var D=t();for(var C in D)(typeof exports=="object"?exports:$)[C]=D[C]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function D(C){if(t[C])return t[C].exports;var b=t[C]={i:C,l:!1,exports:{}};return $[C].call(b.exports,b,b.exports,D),b.l=!0,b.exports}return D.m=$,D.c=t,D.d=function(C,b,L){D.o(C,b)||Object.defineProperty(C,b,{enumerable:!0,get:L})},D.r=function(C){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},D.t=function(C,b){if(1&b&&(C=D(C)),8&b||4&b&&typeof C=="object"&&C&&C.__esModule)return C;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:C}),2&b&&typeof C!="string")for(var T in C)D.d(L,T,function(p){return C[p]}.bind(null,T));return L},D.n=function(C){var b=C&&C.__esModule?function(){return C.default}:function(){return C};return D.d(b,"a",b),b},D.o=function(C,b){return Object.prototype.hasOwnProperty.call(C,b)},D.p="",D(D.s=0)}([function($,t,D){(function(C){var b;t=$.exports=R,b=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var L=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,p=t.re=[],a=t.src=[],h=0,I=h++;a[I]="0|[1-9]\\d*";var w=h++;a[w]="[0-9]+";var g=h++;a[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=h++;a[E]="("+a[I]+")\\.("+a[I]+")\\.("+a[I]+")";var l=h++;a[l]="("+a[w]+")\\.("+a[w]+")\\.("+a[w]+")";var d=h++;a[d]="(?:"+a[I]+"|"+a[g]+")";var v=h++;a[v]="(?:"+a[w]+"|"+a[g]+")";var u=h++;a[u]="(?:-("+a[d]+"(?:\\."+a[d]+")*))";var f=h++;a[f]="(?:-?("+a[v]+"(?:\\."+a[v]+")*))";var y=h++;a[y]="[0-9A-Za-z-]+";var c=h++;a[c]="(?:\\+("+a[y]+"(?:\\."+a[y]+")*))";var s=h++,i="v?"+a[E]+a[u]+"?"+a[c]+"?";a[s]="^"+i+"$";var n="[v=\\s]*"+a[l]+a[f]+"?"+a[c]+"?",e=h++;a[e]="^"+n+"$";var r=h++;a[r]="((?:<|>)?=?)";var o=h++;a[o]=a[w]+"|x|X|\\*";var m=h++;a[m]=a[I]+"|x|X|\\*";var S=h++;a[S]="[v=\\s]*("+a[m]+")(?:\\.("+a[m]+")(?:\\.("+a[m]+")(?:"+a[u]+")?"+a[c]+"?)?)?";var P=h++;a[P]="[v=\\s]*("+a[o]+")(?:\\.("+a[o]+")(?:\\.("+a[o]+")(?:"+a[f]+")?"+a[c]+"?)?)?";var k=h++;a[k]="^"+a[r]+"\\s*"+a[S]+"$";var U=h++;a[U]="^"+a[r]+"\\s*"+a[P]+"$";var B=h++;a[B]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=h++;a[q]="(?:~>?)";var Y=h++;a[Y]="(\\s*)"+a[q]+"\\s+",p[Y]=new RegExp(a[Y],"g");var ne=h++;a[ne]="^"+a[q]+a[S]+"$";var ce=h++;a[ce]="^"+a[q]+a[P]+"$";var re=h++;a[re]="(?:\\^)";var ge=h++;a[ge]="(\\s*)"+a[re]+"\\s+",p[ge]=new RegExp(a[ge],"g");var ae=h++;a[ae]="^"+a[re]+a[S]+"$";var N=h++;a[N]="^"+a[re]+a[P]+"$";var _=h++;a[_]="^"+a[r]+"\\s*("+n+")$|^$";var M=h++;a[M]="^"+a[r]+"\\s*("+i+")$|^$";var A=h++;a[A]="(\\s*)"+a[r]+"\\s*("+n+"|"+a[S]+")",p[A]=new RegExp(a[A],"g");var W=h++;a[W]="^\\s*("+a[S]+")\\s+-\\s+("+a[S]+")\\s*$";var G=h++;a[G]="^\\s*("+a[P]+")\\s+-\\s+("+a[P]+")\\s*$";var Q=h++;a[Q]="(<|>)?=?\\s*\\*";for(var F=0;F<35;F++)b(F,a[F]),p[F]||(p[F]=new RegExp(a[F]));function V(z,K){if(z instanceof R)return z;if(typeof z!="string"||z.length>L||!(K?p[e]:p[s]).test(z))return null;try{return new R(z,K)}catch{return null}}function R(z,K){if(z instanceof R){if(z.loose===K)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof R))return new R(z,K);b("SemVer",z,K),this.loose=K;var J=z.trim().match(K?p[e]:p[s]);if(!J)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var me=+ue;if(me>=0&&me<T)return me}return ue}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}t.parse=V,t.valid=function(z,K){var J=V(z,K);return J?J.version:null},t.clean=function(z,K){var J=V(z.trim().replace(/^[=v]+/,""),K);return J?J.version:null},t.SemVer=R,R.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},R.prototype.toString=function(){return this.version},R.prototype.compare=function(z){return b("SemVer.compare",this.version,this.loose,z),z instanceof R||(z=new R(z,this.loose)),this.compareMain(z)||this.comparePre(z)},R.prototype.compareMain=function(z){return z instanceof R||(z=new R(z,this.loose)),x(this.major,z.major)||x(this.minor,z.minor)||x(this.patch,z.patch)},R.prototype.comparePre=function(z){if(z instanceof R||(z=new R(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var K=0;do{var J=this.prerelease[K],ue=z.prerelease[K];if(b("prerelease compare",K,J,ue),J===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(J===void 0)return-1;if(J!==ue)return x(J,ue)}while(++K)},R.prototype.inc=function(z,K){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,K,J,ue){typeof J=="string"&&(ue=J,J=void 0);try{return new R(z,J).inc(K,ue).version}catch{return null}},t.diff=function(z,K){if(oe(z,K))return null;var J=V(z),ue=V(K);if(J.prerelease.length||ue.prerelease.length){for(var me in J)if((me==="major"||me==="minor"||me==="patch")&&J[me]!==ue[me])return"pre"+me;return"prerelease"}for(var me in J)if((me==="major"||me==="minor"||me==="patch")&&J[me]!==ue[me])return me},t.compareIdentifiers=x;var O=/^[0-9]+$/;function x(z,K){var J=O.test(z),ue=O.test(K);return J&&ue&&(z=+z,K=+K),J&&!ue?-1:ue&&!J?1:z<K?-1:z>K?1:0}function j(z,K,J){return new R(z,J).compare(new R(K,J))}function H(z,K,J){return j(z,K,J)>0}function X(z,K,J){return j(z,K,J)<0}function oe(z,K,J){return j(z,K,J)===0}function le(z,K,J){return j(z,K,J)!==0}function pe(z,K,J){return j(z,K,J)>=0}function ve(z,K,J){return j(z,K,J)<=0}function ie(z,K,J,ue){var me;switch(K){case"===":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),me=z===J;break;case"!==":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),me=z!==J;break;case"":case"=":case"==":me=oe(z,J,ue);break;case"!=":me=le(z,J,ue);break;case">":me=H(z,J,ue);break;case">=":me=pe(z,J,ue);break;case"<":me=X(z,J,ue);break;case"<=":me=ve(z,J,ue);break;default:throw new TypeError("Invalid operator: "+K)}return me}function se(z,K){if(z instanceof se){if(z.loose===K)return z;z=z.value}if(!(this instanceof se))return new se(z,K);b("comparator",z,K),this.loose=K,this.parse(z),this.semver===he?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}t.rcompareIdentifiers=function(z,K){return x(K,z)},t.major=function(z,K){return new R(z,K).major},t.minor=function(z,K){return new R(z,K).minor},t.patch=function(z,K){return new R(z,K).patch},t.compare=j,t.compareLoose=function(z,K){return j(z,K,!0)},t.rcompare=function(z,K,J){return j(K,z,J)},t.sort=function(z,K){return z.sort(function(J,ue){return t.compare(J,ue,K)})},t.rsort=function(z,K){return z.sort(function(J,ue){return t.rcompare(J,ue,K)})},t.gt=H,t.lt=X,t.eq=oe,t.neq=le,t.gte=pe,t.lte=ve,t.cmp=ie,t.Comparator=se;var he={};function de(z,K){if(z instanceof de)return z.loose===K?z:new de(z.raw,K);if(z instanceof se)return new de(z.value,K);if(!(this instanceof de))return new de(z,K);if(this.loose=K,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Se(z){return!z||z.toLowerCase()==="x"||z==="*"}function Oe(z,K,J,ue,me,Ce,we,Te,be,De,Me,Re,Le){return((K=Se(J)?"":Se(ue)?">="+J+".0.0":Se(me)?">="+J+"."+ue+".0":">="+K)+" "+(Te=Se(be)?"":Se(De)?"<"+(+be+1)+".0.0":Se(Me)?"<"+be+"."+(+De+1)+".0":Re?"<="+be+"."+De+"."+Me+"-"+Re:"<="+Te)).trim()}function Ae(z,K){for(var J=0;J<z.length;J++)if(!z[J].test(K))return!1;if(K.prerelease.length){for(J=0;J<z.length;J++)if(b(z[J].semver),z[J].semver!==he&&z[J].semver.prerelease.length>0){var ue=z[J].semver;if(ue.major===K.major&&ue.minor===K.minor&&ue.patch===K.patch)return!0}return!1}return!0}function Ue(z,K,J){try{K=new de(K,J)}catch{return!1}return K.test(z)}function xe(z,K,J,ue){var me,Ce,we,Te,be;switch(z=new R(z,ue),K=new de(K,ue),J){case">":me=H,Ce=ve,we=X,Te=">",be=">=";break;case"<":me=X,Ce=pe,we=H,Te="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(z,K,ue))return!1;for(var De=0;De<K.set.length;++De){var Me=K.set[De],Re=null,Le=null;if(Me.forEach(function(Fe){Fe.semver===he&&(Fe=new se(">=0.0.0")),Re=Re||Fe,Le=Le||Fe,me(Fe.semver,Re.semver,ue)?Re=Fe:we(Fe.semver,Le.semver,ue)&&(Le=Fe)}),Re.operator===Te||Re.operator===be||(!Le.operator||Le.operator===Te)&&Ce(z,Le.semver)||Le.operator===be&&we(z,Le.semver))return!1}return!0}se.prototype.parse=function(z){var K=this.loose?p[_]:p[M],J=z.match(K);if(!J)throw new TypeError("Invalid comparator: "+z);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new R(J[2],this.loose):this.semver=he},se.prototype.toString=function(){return this.value},se.prototype.test=function(z){return b("Comparator.test",z,this.loose),this.semver===he||(typeof z=="string"&&(z=new R(z,this.loose)),ie(z,this.operator,this.semver,this.loose))},se.prototype.intersects=function(z,K){if(!(z instanceof se))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new de(z.value,K),Ue(this.value,J,K);if(z.operator==="")return J=new de(this.value,K),Ue(z.semver,J,K);var ue=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Ce=this.semver.version===z.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Te=ie(this.semver,"<",z.semver,K)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),be=ie(this.semver,">",z.semver,K)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ue||me||Ce&&we||Te||be},t.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(z){var K=this.loose;z=z.trim(),b("range",z,K);var J=K?p[G]:p[W];z=z.replace(J,Oe),b("hyphen replace",z),z=z.replace(p[A],"$1$2$3"),b("comparator trim",z,p[A]),z=(z=(z=z.replace(p[Y],"$1~")).replace(p[ge],"$1^")).split(/\s+/).join(" ");var ue=K?p[_]:p[M],me=z.split(" ").map(function(Ce){return function(we,Te){return b("comp",we),we=function(be,De){return be.trim().split(/\s+/).map(function(Me){return function(Re,Le){b("caret",Re,Le);var Fe=Le?p[N]:p[ae];return Re.replace(Fe,function(Ne,ye,Ee,Pe,Ie){var ke;return b("caret",Re,Ne,ye,Ee,Pe,Ie),Se(ye)?ke="":Se(Ee)?ke=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?ke=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":Ie?(b("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+Ie+" <"+(+ye+1)+".0.0"):(b("no pr"),ke=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+" <"+(+ye+1)+".0.0"),b("caret return",ke),ke})}(Me,De)}).join(" ")}(we,Te),b("caret",we),we=function(be,De){return be.trim().split(/\s+/).map(function(Me){return function(Re,Le){var Fe=Le?p[ce]:p[ne];return Re.replace(Fe,function(Ne,ye,Ee,Pe,Ie){var ke;return b("tilde",Re,Ne,ye,Ee,Pe,Ie),Se(ye)?ke="":Se(Ee)?ke=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?ke=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":Ie?(b("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0"):ke=">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0",b("tilde return",ke),ke})}(Me,De)}).join(" ")}(we,Te),b("tildes",we),we=function(be,De){return b("replaceXRanges",be,De),be.split(/\s+/).map(function(Me){return function(Re,Le){Re=Re.trim();var Fe=Le?p[U]:p[k];return Re.replace(Fe,function(Ne,ye,Ee,Pe,Ie,ke){b("xRange",Re,Ne,ye,Ee,Pe,Ie,ke);var We=Se(Ee),ze=We||Se(Pe),Ve=ze||Se(Ie);return ye==="="&&Ve&&(ye=""),We?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Ve?(ze&&(Pe=0),Ve&&(Ie=0),ye===">"?(ye=">=",ze?(Ee=+Ee+1,Pe=0,Ie=0):Ve&&(Pe=+Pe+1,Ie=0)):ye==="<="&&(ye="<",ze?Ee=+Ee+1:Pe=+Pe+1),Ne=ye+Ee+"."+Pe+"."+Ie):ze?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Ve&&(Ne=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),b("xRange return",Ne),Ne})}(Me,De)}).join(" ")}(we,Te),b("xrange",we),we=function(be,De){return b("replaceStars",be,De),be.trim().replace(p[Q],"")}(we,Te),b("stars",we),we}(Ce,K)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Ce){return!!Ce.match(ue)})),me=me.map(function(Ce){return new se(Ce,K)})},de.prototype.intersects=function(z,K){if(!(z instanceof de))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(ue){return z.set.some(function(me){return me.every(function(Ce){return ue.intersects(Ce,K)})})})})},t.toComparators=function(z,K){return new de(z,K).set.map(function(J){return J.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},de.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new R(z,this.loose));for(var K=0;K<this.set.length;K++)if(Ae(this.set[K],z))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(z,K,J){var ue=null,me=null;try{var Ce=new de(K,J)}catch{return null}return z.forEach(function(we){Ce.test(we)&&(ue&&me.compare(we)!==-1||(me=new R(ue=we,J)))}),ue},t.minSatisfying=function(z,K,J){var ue=null,me=null;try{var Ce=new de(K,J)}catch{return null}return z.forEach(function(we){Ce.test(we)&&(ue&&me.compare(we)!==1||(me=new R(ue=we,J)))}),ue},t.validRange=function(z,K){try{return new de(z,K).range||"*"}catch{return null}},t.ltr=function(z,K,J){return xe(z,K,"<",J)},t.gtr=function(z,K,J){return xe(z,K,">",J)},t.outside=xe,t.prerelease=function(z,K){var J=V(z,K);return J&&J.prerelease.length?J.prerelease:null},t.intersects=function(z,K,J){return z=new de(z,J),K=new de(K,J),z.intersects(K)},t.coerce=function(z){if(z instanceof R)return z;if(typeof z!="string")return null;var K=z.match(p[B]);return K==null?null:V((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,D(1))},function($,t){var D,C,b=$.exports={};function L(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function p(v){if(D===setTimeout)return setTimeout(v,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(v,0);try{return D(v,0)}catch{try{return D.call(null,v,0)}catch{return D.call(this,v,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch{D=L}try{C=typeof clearTimeout=="function"?clearTimeout:T}catch{C=T}})();var a,h=[],I=!1,w=-1;function g(){I&&a&&(I=!1,a.length?h=a.concat(h):w=-1,h.length&&E())}function E(){if(!I){var v=p(g);I=!0;for(var u=h.length;u;){for(a=h,h=[];++w<u;)a&&a[w].run();w=-1,u=h.length}a=null,I=!1,function(f){if(C===clearTimeout)return clearTimeout(f);if((C===T||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(f);try{C(f)}catch{try{return C.call(null,f)}catch{return C.call(this,f)}}}(v)}}function l(v,u){this.fun=v,this.array=u}function d(){}b.nextTick=function(v){var u=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)u[f-1]=arguments[f];h.push(new l(v,u)),h.length!==1||I||p(E)},l.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=d,b.addListener=d,b.once=d,b.off=d,b.removeListener=d,b.removeAllListeners=d,b.emit=d,b.prependListener=d,b.prependOnceListener=d,b.listeners=function(v){return[]},b.binding=function(v){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(v){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Z[69],ee([0,1]),function($,t){"use strict";var D;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class C{constructor(p,a,h){this.level=p,this.key=a,this.value=h,this.forward=[]}}const b=void 0;class L{constructor(p,a=2**16){this.comparator=p,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(a)|0),this._header=new C(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new C(this._maxLevel,b,b)}has(p){return Boolean(L._search(this,p,this.comparator))}get(p){return L._search(this,p,this.comparator)?.value}set(p,a){return L._insert(this,p,a,this.comparator)&&(this._size+=1),this}delete(p){const a=L._delete(this,p,this.comparator);return a&&(this._size-=1),a}forEach(p,a){let h=this._header.forward[0];for(;h;)p.call(a,h.value,h.key,this),h=h.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let p=this._header.forward[0];for(;p;)yield[p.key,p.value],p=p.forward[0]}*keys(){let p=this._header.forward[0];for(;p;)yield p.key,p=p.forward[0]}*values(){let p=this._header.forward[0];for(;p;)yield p.value,p=p.forward[0]}toString(){let p="[SkipList]:",a=this._header.forward[0];for(;a;)p+=`node(${a.key}, ${a.value}, lvl:${a.level})`,a=a.forward[0];return p}static _search(p,a,h){let I=p._header;for(let w=p._level-1;w>=0;w--)for(;I.forward[w]&&h(I.forward[w].key,a)<0;)I=I.forward[w];if(I=I.forward[0],I&&h(I.key,a)===0)return I}static _insert(p,a,h,I){const w=[];let g=p._header;for(let E=p._level-1;E>=0;E--){for(;g.forward[E]&&I(g.forward[E].key,a)<0;)g=g.forward[E];w[E]=g}if(g=g.forward[0],g&&I(g.key,a)===0)return g.value=h,!1;{const E=L._randomLevel(p);if(E>p._level){for(let l=p._level;l<E;l++)w[l]=p._header;p._level=E}g=new C(E,a,h);for(let l=0;l<E;l++)g.forward[l]=w[l].forward[l],w[l].forward[l]=g;return!0}}static _randomLevel(p,a=.5){let h=1;for(;Math.random()<a&&h<p._maxLevel;)h+=1;return h}static _delete(p,a,h){const I=[];let w=p._header;for(let g=p._level-1;g>=0;g--){for(;w.forward[g]&&h(w.forward[g].key,a)<0;)w=w.forward[g];I[g]=w}if(w=w.forward[0],!w||h(w.key,a)!==0)return!1;for(let g=0;g<p._level&&I[g].forward[g]===w;g++)I[g].forward[g]=w.forward[g];for(;p._level>0&&p._header.forward[p._level-1]===b;)p._level-=1;return!0}}t.SkipList=L}),define(Z[43],ee([0,1,12,2]),function($,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function b(c){const s=c;return s?typeof s.read=="function":!1}t.isReadable=b;function L(c){const s=c;return s?[s.on,s.pause,s.resume,s.destroy].every(i=>typeof i=="function"):!1}t.isReadableStream=L;function T(c){const s=c;return s?L(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}t.isReadableBufferedStream=T;function p(c,s){return new a(c,s)}t.newWriteableStream=p;class a{constructor(s,i){this.reducer=s,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(i=>i(s))}emitError(s){this.listeners.error.length===0?(0,D.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(i=>i(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,i){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(s,i){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const e=n.indexOf(i);e>=0&&n.splice(e,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(c,s){const i=[];let n;for(;(n=c.read())!==null;)i.push(n);return s(i)}t.consumeReadable=h;function I(c,s,i){const n=[];let e;for(;(e=c.read())!==null&&n.length<i;)n.push(e);return e===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof e!="undefined"){const r=e;return e=void 0,r}return c.read()}}}t.peekReadable=I;function w(c,s){return new Promise((i,n)=>{const e=[];g(c,{onData:r=>{s&&e.push(r)},onError:r=>{s?n(r):i(void 0)},onEnd:()=>{i(s?s(e):void 0)}})})}t.consumeStream=w;function g(c,s){let i=!1;return c.on("error",n=>{i||s.onError(n)}),c.on("end",()=>{i||s.onEnd()}),c.on("data",n=>{i||s.onData(n)}),(0,C.toDisposable)(()=>i=!0)}t.listenStream=g;function E(c,s){return new Promise((i,n)=>{const e=new C.DisposableStore,r=[],o=P=>{if(r.push(P),r.length>s)return e.dispose(),c.pause(),i({stream:c,buffer:r,ended:!1})},m=P=>n(P),S=()=>i({stream:c,buffer:r,ended:!0});e.add((0,C.toDisposable)(()=>c.removeListener("error",m))),c.on("error",m),e.add((0,C.toDisposable)(()=>c.removeListener("end",S))),c.on("end",S),e.add((0,C.toDisposable)(()=>c.removeListener("data",o))),c.on("data",o)})}t.peekStream=E;function l(c,s){const i=p(s);return i.end(c),i}t.toStream=l;function d(){const c=p(()=>{throw new Error("not supported")});return c.end(),c}t.emptyStream=d;function v(c){let s=!1;return{read:()=>s?null:(s=!0,c)}}t.toReadable=v;function u(c,s,i){const n=p(i);return g(c,{onData:e=>n.write(s.data(e)),onError:e=>n.error(s.error?s.error(e):e),onEnd:()=>n.end()}),n}t.transform=u;function f(c,s,i){let n=!1;return{read:()=>{const e=s.read();return n?e:(n=!0,e!==null?i([c,e]):c)}}}t.prefixedReadable=f;function y(c,s,i){let n=!1;const e=p(i);return g(s,{onData:r=>n?e.write(r):(n=!0,e.write(i([c,r]))),onError:r=>e.error(r),onEnd:()=>{n||(n=!0,e.write(c)),e.end()}}),e}t.prefixedStream=y}),define(Z[15],ee([0,1,43]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const C=typeof Buffer!="undefined";let b,L;class T{constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}static alloc(P){return C?new T(Buffer.allocUnsafe(P)):new T(new Uint8Array(P))}static wrap(P){return C&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new T(P)}static fromString(P,k){return!(k?.dontUseNodeBuffer||!1)&&C?new T(Buffer.from(P)):(b||(b=new TextEncoder),new T(b.encode(P)))}static fromByteArray(P){const k=T.alloc(P.length);for(let U=0,B=P.length;U<B;U++)k.buffer[U]=P[U];return k}static concat(P,k){if(typeof k=="undefined"){k=0;for(let q=0,Y=P.length;q<Y;q++)k+=P[q].byteLength}const U=T.alloc(k);let B=0;for(let q=0,Y=P.length;q<Y;q++){const ne=P[q];U.set(ne,B),B+=ne.byteLength}return U}clone(){const P=T.alloc(this.byteLength);return P.set(this),P}toString(){return C?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(P,k){return new T(this.buffer.subarray(P,k))}set(P,k){if(P instanceof T)this.buffer.set(P.buffer,k);else if(P instanceof Uint8Array)this.buffer.set(P,k);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),k);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return h(this.buffer,P)}writeUInt32BE(P,k){I(this.buffer,P,k)}readUInt32LE(P){return w(this.buffer,P)}writeUInt32LE(P,k){g(this.buffer,P,k)}readUInt8(P){return E(this.buffer,P)}writeUInt8(P,k){l(this.buffer,P,k)}}t.VSBuffer=T;function p(S,P){return S[P+0]<<0>>>0|S[P+1]<<8>>>0}t.readUInt16LE=p;function a(S,P,k){S[k+0]=P&255,P=P>>>8,S[k+1]=P&255}t.writeUInt16LE=a;function h(S,P){return S[P]*2**24+S[P+1]*2**16+S[P+2]*2**8+S[P+3]}t.readUInt32BE=h;function I(S,P,k){S[k+3]=P,P=P>>>8,S[k+2]=P,P=P>>>8,S[k+1]=P,P=P>>>8,S[k]=P}t.writeUInt32BE=I;function w(S,P){return S[P+0]<<0>>>0|S[P+1]<<8>>>0|S[P+2]<<16>>>0|S[P+3]<<24>>>0}t.readUInt32LE=w;function g(S,P,k){S[k+0]=P&255,P=P>>>8,S[k+1]=P&255,P=P>>>8,S[k+2]=P&255,P=P>>>8,S[k+3]=P&255}t.writeUInt32LE=g;function E(S,P){return S[P]}t.readUInt8=E;function l(S,P,k){S[k]=P}t.writeUInt8=l;function d(S){return D.consumeReadable(S,P=>T.concat(P))}t.readableToBuffer=d;function v(S){return D.toReadable(S)}t.bufferToReadable=v;function u(S){return D.consumeStream(S,P=>T.concat(P))}t.streamToBuffer=u;async function f(S){return S.ended?T.concat(S.buffer):T.concat([...S.buffer,await u(S.stream)])}t.bufferedStreamToBuffer=f;function y(S){return D.toStream(S,P=>T.concat(P))}t.bufferToStream=y;function c(S){return D.transform(S,{data:P=>typeof P=="string"?T.fromString(P):T.wrap(P)},P=>T.concat(P))}t.streamToBufferReadableStream=c;function s(S){return D.newWriteableStream(P=>T.concat(P),S)}t.newWriteableBufferStream=s;function i(S,P){return D.prefixedReadable(S,P,k=>T.concat(k))}t.prefixedBufferReadable=i;function n(S,P){return D.prefixedStream(S,P,k=>T.concat(k))}t.prefixedBufferStream=n;function e(S){let P=0,k=0,U=0;const B=new Uint8Array(Math.floor(S.length/4*3)),q=ne=>{switch(k){case 3:B[U++]=P|ne,k=0;break;case 2:B[U++]=P|ne>>>2,P=ne<<6,k=3;break;case 1:B[U++]=P|ne>>>4,P=ne<<4,k=2;break;default:P=ne<<2,k=1}};for(let ne=0;ne<S.length;ne++){const ce=S.charCodeAt(ne);if(ce>=65&&ce<=90)q(ce-65);else if(ce>=97&&ce<=122)q(ce-97+26);else if(ce>=48&&ce<=57)q(ce-48+52);else if(ce===43||ce===45)q(62);else if(ce===47||ce===95)q(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${S[ne]}`)}}const Y=U;for(;k>0;)q(0);return T.wrap(B).slice(0,Y)}t.decodeBase64=e;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:S},P=!0,k=!1){const U=k?o:r;let B="";const q=S.byteLength%3;let Y=0;for(;Y<S.byteLength-q;Y+=3){const ne=S[Y+0],ce=S[Y+1],re=S[Y+2];B+=U[ne>>>2],B+=U[(ne<<4|ce>>>4)&63],B+=U[(ce<<2|re>>>6)&63],B+=U[re&63]}if(q===1){const ne=S[Y+0];B+=U[ne>>>2],B+=U[ne<<4&63],P&&(B+="==")}else if(q===2){const ne=S[Y+0],ce=S[Y+1];B+=U[ne>>>2],B+=U[(ne<<4|ce>>>4)&63],B+=U[ce<<2&63],P&&(B+="=")}return B}t.encodeBase64=m}),define(Z[24],ee([0,1,7]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function C(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const d=Array.isArray(l)?[]:{};return Object.keys(l).forEach(v=>{l[v]&&typeof l[v]=="object"?d[v]=C(l[v]):d[v]=l[v]}),d}t.deepClone=C;function b(l){if(!l||typeof l!="object")return l;const d=[l];for(;d.length>0;){const v=d.shift();Object.freeze(v);for(const u in v)if(L.call(v,u)){const f=v[u];typeof f=="object"&&!Object.isFrozen(f)&&!(0,D.isTypedArray)(f)&&d.push(f)}}return l}t.deepFreeze=b;const L=Object.prototype.hasOwnProperty;function T(l,d){return p(l,d,new Set)}t.cloneAndChange=T;function p(l,d,v){if((0,D.isUndefinedOrNull)(l))return l;const u=d(l);if(typeof u!="undefined")return u;if((0,D.isArray)(l)){const f=[];for(const y of l)f.push(p(y,d,v));return f}if((0,D.isObject)(l)){if(v.has(l))throw new Error("Cannot clone recursive data-structure");v.add(l);const f={};for(const y in l)L.call(l,y)&&(f[y]=p(l[y],d,v));return v.delete(l),f}return l}function a(l,d,v=!0){return(0,D.isObject)(l)?((0,D.isObject)(d)&&Object.keys(d).forEach(u=>{u in l?v&&((0,D.isObject)(l[u])&&(0,D.isObject)(d[u])?a(l[u],d[u],v):l[u]=d[u]):l[u]=d[u]}),l):d}t.mixin=a;function h(l,d){if(l===d)return!0;if(l==null||d===null||d===void 0||typeof l!=typeof d||typeof l!="object"||Array.isArray(l)!==Array.isArray(d))return!1;let v,u;if(Array.isArray(l)){if(l.length!==d.length)return!1;for(v=0;v<l.length;v++)if(!h(l[v],d[v]))return!1}else{const f=[];for(u in l)f.push(u);f.sort();const y=[];for(u in d)y.push(u);if(y.sort(),!h(f,y))return!1;for(v=0;v<f.length;v++)if(!h(l[f[v]],d[f[v]]))return!1}return!0}t.equals=h;function I(l){const d=new Set;return JSON.stringify(l,(v,u)=>{if((0,D.isObject)(u)||Array.isArray(u)){if(d.has(u))return"[Circular]";d.add(u)}return u})}t.safeStringify=I;function w(l,d){const v=Object.create(null);return!l||!d||Object.keys(d).forEach(f=>{const y=l[f],c=d[f];h(y,c)||(v[f]=c)}),v}t.distinct=w;function g(l,d){const v=d.toLowerCase(),u=Object.keys(l).find(f=>f.toLowerCase()===v);return u?l[u]:l[d]}t.getCaseInsensitive=g;function E(l,d){const v=Object.create(null);for(const[u,f]of Object.entries(l))d(u,f)&&(v[u]=f);return v}t.filter=E}),define(Z[29],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(b){return D.test(b)}t.isUUID=C,t.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(p){for(let a=0;a<p.length;a++)p[a]=Math.floor(Math.random()*256);return p};const L=new Uint8Array(16),T=[];for(let p=0;p<256;p++)T.push(p.toString(16).padStart(2,"0"));return function(){b(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let a=0,h="";return h+=T[L[a++]],h+=T[L[a++]],h+=T[L[a++]],h+=T[L[a++]],h+="-",h+=T[L[a++]],h+=T[L[a++]],h+="-",h+=T[L[a++]],h+=T[L[a++]],h+="-",h+=T[L[a++]],h+=T[L[a++]],h+="-",h+=T[L[a++]],h+=T[L[a++]],h+=T[L[a++]],h+=T[L[a++]],h+=T[L[a++]],h+=T[L[a++]],h}}()}),define(Z[70],ee([0,1,150]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class C{constructor(L="utf8"){this.stringDecoder=new D.StringDecoder(L),this.remaining=null}write(L){const T=[],p=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(p.length<1)return T;let a=0,h,I=a;for(;I<p.length;)if(h=p.charCodeAt(I),h===13||h===10){if(T.push(p.substring(a,I)),I++,I<p.length){const w=h;h=p.charCodeAt(I),(w===13&&h===10||w===10&&h===13)&&I++}a=I}else I++;return this.remaining=a<p.length?p.substr(a):null,T}end(){return this.remaining}}t.LineDecoder=C}),define(Z[71],ee([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(Z[72],ee([0,1,71]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const C=60,b=C*60,L=b*24,T=L*7,p=L*30,a=L*365;function h(w,g,E){typeof w!="number"&&(w=w.getTime());const l=Math.round((new Date().getTime()-w)/1e3);if(l<-30)return(0,D.localize)(0,null,h(new Date().getTime()+l*1e3,!1));if(l<30)return(0,D.localize)(1,null);let d;return l<C?(d=l,g?d===1?E?(0,D.localize)(2,null,d):(0,D.localize)(3,null,d):E?(0,D.localize)(4,null,d):(0,D.localize)(5,null,d):d===1?E?(0,D.localize)(6,null,d):(0,D.localize)(7,null,d):E?(0,D.localize)(8,null,d):(0,D.localize)(9,null,d)):l<b?(d=Math.floor(l/C),g?d===1?E?(0,D.localize)(10,null,d):(0,D.localize)(11,null,d):E?(0,D.localize)(12,null,d):(0,D.localize)(13,null,d):d===1?E?(0,D.localize)(14,null,d):(0,D.localize)(15,null,d):E?(0,D.localize)(16,null,d):(0,D.localize)(17,null,d)):l<L?(d=Math.floor(l/b),g?d===1?E?(0,D.localize)(18,null,d):(0,D.localize)(19,null,d):E?(0,D.localize)(20,null,d):(0,D.localize)(21,null,d):d===1?E?(0,D.localize)(22,null,d):(0,D.localize)(23,null,d):E?(0,D.localize)(24,null,d):(0,D.localize)(25,null,d)):l<T?(d=Math.floor(l/L),g?d===1?(0,D.localize)(26,null,d):(0,D.localize)(27,null,d):d===1?(0,D.localize)(28,null,d):(0,D.localize)(29,null,d)):l<p?(d=Math.floor(l/T),g?d===1?E?(0,D.localize)(30,null,d):(0,D.localize)(31,null,d):E?(0,D.localize)(32,null,d):(0,D.localize)(33,null,d):d===1?E?(0,D.localize)(34,null,d):(0,D.localize)(35,null,d):E?(0,D.localize)(36,null,d):(0,D.localize)(37,null,d)):l<a?(d=Math.floor(l/p),g?d===1?E?(0,D.localize)(38,null,d):(0,D.localize)(39,null,d):E?(0,D.localize)(40,null,d):(0,D.localize)(41,null,d):d===1?E?(0,D.localize)(42,null,d):(0,D.localize)(43,null,d):E?(0,D.localize)(44,null,d):(0,D.localize)(45,null,d)):(d=Math.floor(l/a),g?d===1?E?(0,D.localize)(46,null,d):(0,D.localize)(47,null,d):E?(0,D.localize)(48,null,d):(0,D.localize)(49,null,d):d===1?E?(0,D.localize)(50,null,d):(0,D.localize)(51,null,d):E?(0,D.localize)(52,null,d):(0,D.localize)(53,null,d))}t.fromNow=h;function I(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=I}),define(Z[73],ee([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(Z[30],ee([0,1,19,7,73]),function($,t,D,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.toErrorMessage=void 0;function L(w,g){return g&&(w.stack||w.stacktrace)?b.localize(0,null,p(w),T(w.stack)||T(w.stacktrace)):p(w)}function T(w){return Array.isArray(w)?w.join(`
`):w}function p(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?b.localize(1,null,w.message):w.message||b.localize(2,null)}function a(w=null,g=!1){if(!w)return b.localize(3,null);if(Array.isArray(w)){const E=D.coalesce(w),l=a(E[0],g);return E.length>1?b.localize(4,null,l,E.length):l}if(C.isString(w))return w;if(w.detail){const E=w.detail;if(E.error)return L(E.error,g);if(E.exception)return L(E.exception,g)}return w.stack?L(w,g):w.message?w.message:b.localize(5,null)}t.toErrorMessage=a;function h(w){const g=w;return g instanceof Error&&Array.isArray(g.actions)}t.isErrorWithActions=h;function I(w,g){let E;return typeof w=="string"?E=new Error(w):E=w,E.actions=g,E}t.createErrorWithActions=I}),define(Z[74],ee([5,6]),function($,t){return $.create("vs/base/common/jsonErrorMessages",t)}),define(Z[75],ee([0,1,74]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getParseErrorMessage=void 0;function C(b){switch(b){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}t.getParseErrorMessage=C}),define(Z[52],ee([0,1,13]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeDangerousEnvVariables=t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var C;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(C=t.Source||(t.Source={}));var b;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(b=t.TerminateResponseCode||(t.TerminateResponseCode={}));function L(p,...a){const h=a.reduce((g,E)=>(g[E]=!0,g),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(g=>!h[g]).forEach(g=>{for(let E=0;E<I.length;E++)if(g.search(I[E])!==-1){delete p[g];break}})}t.sanitizeProcessEnvironment=L;function T(p){!p||(delete p.DEBUG,D.isMacintosh&&delete p.DYLD_LIBRARY_PATH,D.isLinux&&delete p.LD_PRELOAD)}t.removeDangerousEnvVariables=T}),define(Z[53],ee([0,1,4,2]),function($,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MutableObservableValue=t.staticObservableValue=void 0;const b=T=>({onDidChange:D.Event.None,value:T});t.staticObservableValue=b;class L extends C.Disposable{constructor(p){super();this._value=p,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(p){p!==this._value&&(this._value=p,this.changeEmitter.fire(p))}}t.MutableObservableValue=L}),define(Z[54],ee([0,1,31]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function C(u){return b(u,0)}t.hash=C;function b(u,f){switch(typeof u){case"object":return u===null?L(349,f):Array.isArray(u)?a(u,f):h(u,f);case"string":return p(u,f);case"boolean":return T(u,f);case"number":return L(u,f);case"undefined":return L(937,f);default:return L(617,f)}}t.doHash=b;function L(u,f){return(f<<5)-f+u|0}t.numberHash=L;function T(u,f){return L(u?433:863,f)}function p(u,f){f=L(149417,f);for(let y=0,c=u.length;y<c;y++)f=L(u.charCodeAt(y),f);return f}t.stringHash=p;function a(u,f){return f=L(104579,f),u.reduce((y,c)=>b(c,y),f)}function h(u,f){return f=L(181387,f),Object.keys(u).sort().reduce((y,c)=>(y=p(c,y),b(u[c],y)),f)}class I{constructor(){this._value=0}get value(){return this._value}hash(f){return this._value=b(f,this._value),this._value}}t.Hasher=I;var w;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function g(u,f,y=32){const c=y-f,s=~((1<<c)-1);return(u<<f|(s&u)>>>c)>>>0}function E(u,f=0,y=u.byteLength,c=0){for(let s=0;s<y;s++)u[f+s]=c}function l(u,f,y="0"){for(;u.length<f;)u=y+u;return u}function d(u,f=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(y=>y.toString(16).padStart(2,"0")).join(""):l((u>>>0).toString(16),f/4)}t.toHexString=d;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const y=f.length;if(y===0)return;const c=this._buff;let s=this._buffLen,i=this._leftoverHighSurrogate,n,e;for(i!==0?(n=i,e=-1,i=0):(n=f.charCodeAt(0),e=0);;){let r=n;if(D.isHighSurrogate(n))if(e+1<y){const o=f.charCodeAt(e+1);D.isLowSurrogate(o)?(e++,r=D.computeCodePoint(n,o)):r=65533}else{i=n;break}else D.isLowSurrogate(n)&&(r=65533);if(s=this._push(c,s,r),e++,e<y)n=f.charCodeAt(e);else break}this._buffLen=s,this._leftoverHighSurrogate=i}_push(f,y,c){return c<128?f[y++]=c:c<2048?(f[y++]=192|(c&1984)>>>6,f[y++]=128|(c&63)>>>0):c<65536?(f[y++]=224|(c&61440)>>>12,f[y++]=128|(c&4032)>>>6,f[y++]=128|(c&63)>>>0):(f[y++]=240|(c&1835008)>>>18,f[y++]=128|(c&258048)>>>12,f[y++]=128|(c&4032)>>>6,f[y++]=128|(c&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=v._bigBlock32,y=this._buffDV;for(let S=0;S<64;S+=4)f.setUint32(S,y.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)f.setUint32(S,g(f.getUint32(S-12,!1)^f.getUint32(S-32,!1)^f.getUint32(S-56,!1)^f.getUint32(S-64,!1),1),!1);let c=this._h0,s=this._h1,i=this._h2,n=this._h3,e=this._h4,r,o,m;for(let S=0;S<80;S++)S<20?(r=s&i|~s&n,o=1518500249):S<40?(r=s^i^n,o=1859775393):S<60?(r=s&i|s&n|i&n,o=2400959708):(r=s^i^n,o=3395469782),m=g(c,5)+r+e+o+f.getUint32(S*4,!1)&4294967295,e=n,n=i,i=g(s,30),s=c,c=m;this._h0=this._h0+c&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+e&4294967295}}t.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[55],ee([0,1,31]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var C;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(C||(C={})),function(b){const L="error",T="warning",p="warn",a="info",h="ignore";function I(g){return g?D.equalsIgnoreCase(L,g)?b.Error:D.equalsIgnoreCase(T,g)||D.equalsIgnoreCase(p,g)?b.Warning:D.equalsIgnoreCase(a,g)?b.Info:b.Ignore:b.Ignore}b.fromValue=I;function w(g){switch(g){case b.Error:return L;case b.Warning:return T;case b.Info:return a;default:return h}}b.toString=w}(C||(C={})),t.default=C}),define(Z[76],ee([0,1,10]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function C(h){const I=h;return I&&typeof I.type=="string"&&typeof I.severity=="string"}t.isRemoteConsoleLog=C;function b(h){const I=[];let w;try{const g=JSON.parse(h.arguments),E=g[g.length-1];E&&E.__$stack&&(g.pop(),w=E.__$stack),I.push(...g)}catch{I.push("Unable to log remote console arguments",h.arguments)}return{args:I,stack:w}}t.parse=b;function L(h){if(typeof h!="string")return L(b(h).stack);const I=h;if(I){const w=T(I),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(g&&g.length===4)return{uri:D.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}t.getFirstFrame=L;function T(h){if(!h)return h;const I=h.indexOf(`
`);return I===-1?h:h.substring(0,I)}function p(h,I){const{args:w,stack:g}=b(h),E=typeof w[0]=="string"&&w.length===1;let l=T(g);l&&(l=`(${l.trim()})`);let d=[];if(typeof w[0]=="string"?l&&E?d=[`%c[${I}] %c${w[0]} %c${l}`,a("blue"),a(""),a("grey")]:d=[`%c[${I}] %c${w[0]}`,a("blue"),a(""),...w.slice(1)]:d=[`%c[${I}]%`,a("blue"),...w],l&&!E&&d.push(l),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,d)}t.log=p;function a(h){return`color: ${h}`}}),define(Z[44],ee([0,1,15,31,10]),function($,t,D,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function L(h){return JSON.stringify(h,p)}t.stringify=L;function T(h){let I=JSON.parse(h);return I=a(I),I}t.parse=T;function p(h,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,C.regExpFlags)(I)}:I}function a(h,I=0){if(!h||I>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return b.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 14:return new Date(h.source)}if(h instanceof D.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let w=0;w<h.length;++w)h[w]=a(h[w],I+1);else for(const w in h)Object.hasOwnProperty.call(h,w)&&(h[w]=a(h[w],I+1))}return h}t.revive=a}),define(Z[77],ee([0,1,38,14,20]),function($,t,D,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,T=/^Microsoft.PowerShell_.*/,p=/^Microsoft.PowerShellPreview_.*/;var a;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(a||(a={}));let h;switch(process.arch){case"ia32":case"x32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class w{constructor(s,i,n){this.exePath=s,this.displayName=i,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:c=!1}={}){return c?h===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:c=!1,findPreview:s=!1}={}){const i=g({useAlternateBitness:c});if(!i)return null;const n=C.join(i,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(n))return null;let e=-1,r=null;for(const S of await b.Promises.readdir(n)){let P=-1;if(s){const U=S.indexOf("-");if(U<0)continue;const B=S.substring(0,U);if(!L.test(B)||S.substring(U+1)!=="preview")continue;P=parseInt(B,10)}else{if(!L.test(S))continue;P=parseInt(S,10)}if(P<=e)continue;const k=C.join(n,S,"pwsh.exe");!await b.SymlinkSupport.existsFile(k)||(r=k,e=P)}if(!r)return null;const o=i.includes("x86")?" (x86)":"",m=s?" Preview":"";return new w(r,`PowerShell${m}${o}`,!0)}async function l({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const s=C.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=c?{pwshMsixDirRegex:p,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const e of await b.Promises.readdir(s))if(i.test(e)){const r=C.join(s,e,"pwsh.exe");return new w(r,n)}return null}function d(){const c=C.join(D.homedir(),".dotnet","tools","pwsh.exe");return new w(c,".NET Core PowerShell Global Tool")}function v(){const c=C.join(process.env.windir,h===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(c,"Windows PowerShell",!0)}async function*u(){let c=await E();c&&(yield c),c=await E({useAlternateBitness:!0}),c&&(yield c),c=await l(),c&&(yield c),c=d(),c&&(yield c),c=await E({findPreview:!0}),c&&(yield c),c=await l({findPreview:!0}),c&&(yield c),c=await E({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=v(),c&&(yield c)}async function*f(){for await(const c of u())await c.exists()&&(yield c)}t.enumeratePowerShellInstallations=f;async function y(){for await(const c of f())return c;return null}t.getFirstAvailablePowerShellInstallation=y});var fe=this&&this.__decorate||function($,t,D,C){var b=arguments.length,L=b<3?t:C===null?C=Object.getOwnPropertyDescriptor(t,D):C,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($,t,D,C);else for(var p=$.length-1;p>=0;p--)(T=$[p])&&(L=(b<3?T(L):b>3?T(t,D,L):T(t,D))||L);return b>3&&L&&Object.defineProperty(t,D,L),L};define(Z[56],ee([0,1,19,3,15,25,50,12,4,2,44,31,7]),function($,t,D,C,b,L,T,p,a,h,I,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var E;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(E=t.RequestType||(t.RequestType={}));function l(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(d=t.ResponseType||(t.ResponseType={}));function v(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(u||(u={}));class f{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class y{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var c;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(c||(c={}));function s(M){const A=b.VSBuffer.alloc(4);return A.writeUInt32BE(M,0),A}function i(M){return M.read(4).readUInt32BE(0)}function n(M){const A=b.VSBuffer.alloc(1);return A.writeUInt8(M,0),A}const e={Undefined:n(c.Undefined),String:n(c.String),Buffer:n(c.Buffer),VSBuffer:n(c.VSBuffer),Array:n(c.Array),Object:n(c.Object)},r=typeof Buffer!="undefined";function o(M,A){if(typeof A=="undefined")M.write(e.Undefined);else if(typeof A=="string"){const W=b.VSBuffer.fromString(A);M.write(e.String),M.write(s(W.byteLength)),M.write(W)}else if(r&&Buffer.isBuffer(A)){const W=b.VSBuffer.wrap(A);M.write(e.Buffer),M.write(s(W.byteLength)),M.write(W)}else if(A instanceof b.VSBuffer)M.write(e.VSBuffer),M.write(s(A.byteLength)),M.write(A);else if(Array.isArray(A)){M.write(e.Array),M.write(s(A.length));for(const W of A)o(M,W)}else{const W=b.VSBuffer.fromString(JSON.stringify(A));M.write(e.Object),M.write(s(W.byteLength)),M.write(W)}}function m(M){switch(M.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return M.read(i(M)).toString();case c.Buffer:return M.read(i(M)).buffer;case c.VSBuffer:return M.read(i(M));case c.Array:{const W=i(M),G=[];for(let Q=0;Q<W;Q++)G.push(m(M));return G}case c.Object:return JSON.parse(M.read(i(M)).toString())}}class S{constructor(A,W,G=null,Q=1e3){this.protocol=A,this.ctx=W,this.logger=G,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(F=>this.onRawMessage(F)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger?.logOutgoing(W,0,1,v(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(W,A.id,1,v(A.type),A.data);return}}}send(A,W=void 0){const G=new y;return o(G,A),o(G,W),this.sendBuffer(G.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new f(A),G=m(W),Q=m(W),F=G[0];switch(F){case 100:return this.logger?.logIncoming(A.byteLength,G[1],1,`${l(F)}: ${G[2]}.${G[3]}`,Q),this.onPromise({type:F,id:G[1],channelName:G[2],name:G[3],arg:Q});case 102:return this.logger?.logIncoming(A.byteLength,G[1],1,`${l(F)}: ${G[2]}.${G[3]}`,Q),this.onEventListen({type:F,id:G[1],channelName:G[2],name:G[3],arg:Q});case 101:return this.logger?.logIncoming(A.byteLength,G[1],1,`${l(F)}`),this.disposeActiveRequest({type:F,id:G[1]});case 103:return this.logger?.logIncoming(A.byteLength,G[1],1,`${l(F)}`),this.disposeActiveRequest({type:F,id:G[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const G=new L.CancellationTokenSource;let Q;try{Q=W.call(this.ctx,A.name,A.arg,G.token)}catch(R){Q=Promise.reject(R)}const F=A.id;Q.then(R=>{this.sendResponse({id:F,data:R,type:201}),this.activeRequests.delete(A.id)},R=>{R instanceof Error?this.sendResponse({id:F,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.sendResponse({id:F,data:R,type:203}),this.activeRequests.delete(A.id)});const V=(0,h.toDisposable)(()=>G.cancel());this.activeRequests.set(A.id,V)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const G=A.id,F=W.listen(this.ctx,A.name,A.arg)(V=>this.sendResponse({id:G,data:V,type:204}));this.activeRequests.set(A.id,F)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const G=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:G})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const G of W)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,h.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=S;var P;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(P=t.RequestInitiator||(t.RequestInitiator={}));class k{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new a.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=W}getChannel(A){const W=this;return{call(G,Q,F){return W.isDisposed?Promise.reject(p.canceled()):W.requestPromise(A,G,Q,F)},listen(G,Q){return W.isDisposed?a.Event.None:W.requestEvent(A,G,Q)}}}requestPromise(A,W,G,Q=L.CancellationToken.None){const F=this.lastRequestId++,R={id:F,type:100,channelName:A,name:W,arg:G};if(Q.isCancellationRequested)return Promise.reject(p.canceled());let O;return new Promise((j,H)=>{if(Q.isCancellationRequested)return H(p.canceled());const X=()=>{const ve=ie=>{switch(ie.type){case 201:this.handlers.delete(F),j(ie.data);break;case 202:{this.handlers.delete(F);const se=new Error(ie.data.message);se.stack=ie.data.stack,se.name=ie.data.name,H(se);break}case 203:this.handlers.delete(F),H(ie.data);break}};this.handlers.set(F,ve),this.sendRequest(R)};let oe=null;this.state===u.Idle?X():(oe=(0,C.createCancelablePromise)(ve=>this.whenInitialized()),oe.then(()=>{oe=null,X()}));const le=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:F,type:101}),H(p.canceled())},pe=Q.onCancellationRequested(le);O=(0,h.combinedDisposable)((0,h.toDisposable)(le),pe),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,W,G){const Q=this.lastRequestId++,V={id:Q,type:102,channelName:A,name:W,arg:G};let R=null;const O=new a.Emitter({onFirstListenerAdd:()=>{R=(0,C.createCancelablePromise)(j=>this.whenInitialized()),R.then(()=>{R=null,this.activeRequests.add(O),this.sendRequest(V)})},onLastListenerRemove:()=>{R?(R.cancel(),R=null):(this.activeRequests.delete(O),this.sendRequest({id:Q,type:103}))}}),x=j=>O.fire(j.data);return this.handlers.set(Q,x),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(W,A.id,0,`${l(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger?.logOutgoing(W,A.id,0,l(A.type));return}}}send(A,W=void 0){const G=new y;return o(G,A),o(G,W),this.sendBuffer(G.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new f(A),G=m(W),Q=m(W),F=G[0];switch(F){case 200:return this.logger?.logIncoming(A.byteLength,0,0,v(F)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,G[1],0,v(F),Q),this.onResponse({type:G[0],id:G[1],data:Q})}}onResponse(A){if(A.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return a.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,h.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}fe([T.memoize],k.prototype,"onDidInitializePromise",null),t.ChannelClient=k;class U{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new a.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new a.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:G})=>{a.Event.once(W.onMessage)(F=>{const V=new f(F),R=m(V),O=new S(W,R),x=new k(W);this.channels.forEach((H,X)=>O.registerChannel(X,H));const j={channelServer:O,channelClient:x,ctx:R};this._connections.add(j),this._onDidAddConnection.fire(j),G(()=>{O.dispose(),x.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}getChannel(A,W){const G=this;return{call(Q,F,V){let R;if((0,g.isFunction)(W)){const x=(0,D.getRandomElement)(G.connections.filter(W));R=x?Promise.resolve(x):a.Event.toPromise(a.Event.filter(G.onDidAddConnection,W))}else R=W.routeCall(G,Q,F);const O=R.then(x=>x.channelClient.getChannel(A));return q(O).call(Q,F,V)},listen(Q,F){if((0,g.isFunction)(W))return G.getMulticastEvent(A,W,Q,F);const V=W.routeEvent(G,Q,F).then(R=>R.channelClient.getChannel(A));return q(V).listen(Q,F)}}}getMulticastEvent(A,W,G,Q){const F=this;let V=new h.DisposableStore;const R=new a.Emitter({onFirstListenerAdd:()=>{V=new h.DisposableStore;const O=new a.EventMultiplexer,x=new Map,j=X=>{const le=X.channelClient.getChannel(A).listen(G,Q),pe=O.add(le);x.set(X,pe)},H=X=>{const oe=x.get(X);!oe||(oe.dispose(),x.delete(X))};F.connections.filter(W).forEach(j),a.Event.filter(F.onDidAddConnection,W)(j,void 0,V),F.onDidRemoveConnection(H,void 0,V),O.event(R.fire,R,V),V.add(O)},onLastListenerRemove:()=>{V.dispose()}});return R.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach(G=>{G.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=U;class B{constructor(A,W,G=null){const Q=new y;o(Q,W),A.send(Q.buffer),this.channelClient=new k(A,G),this.channelServer=new S(A,W,G)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=B;function q(M){return{call(A,W,G){return M.then(Q=>Q.call(A,W,G))},listen(A,W){const G=new a.Relay;return M.then(Q=>G.input=Q.listen(A,W)),G.event}}}t.getDelayedChannel=q;function Y(M){let A=!1;return{call(W,G,Q){return A?M.call(W,G,Q):(0,C.timeout)(0).then(()=>A=!0).then(()=>M.call(W,G,Q))},listen(W,G){if(A)return M.listen(W,G);const Q=new a.Relay;return(0,C.timeout)(0).then(()=>A=!0).then(()=>Q.input=M.listen(W,G)),Q.event}}}t.getNextTickChannel=Y;class ne{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await a.Event.toPromise(A.onDidAddConnection),await this.route(A)}}t.StaticRouter=ne;var ce;(function(M){function A(F,V){const R=F,O=V&&V.disableMarshalling,x=new Map;for(const j in R)G(j)&&x.set(j,a.Event.buffer(R[j],!0));return new class{listen(j,H,X){const oe=x.get(H);if(oe)return oe;if(Q(H)){const le=R[H];if(typeof le=="function")return le.call(R,X)}throw new Error(`Event not found: ${H}`)}call(j,H,X){const oe=R[H];if(typeof oe=="function"){if(!O&&Array.isArray(X))for(let le=0;le<X.length;le++)X[le]=(0,I.revive)(X[le]);return oe.apply(R,X)}throw new Error(`Method not found: ${H}`)}}}M.fromService=A;function W(F,V){const R=V&&V.disableMarshalling;return new Proxy({},{get(O,x){if(typeof x=="string")return V?.properties?.has(x)?V.properties.get(x):Q(x)?function(j){return F.listen(x,j)}:G(x)?F.listen(x):async function(...j){let H;V&&!(0,g.isUndefinedOrNull)(V.context)?H=[V.context,...j]:H=j;const X=await F.call(x,H);return R?X:(0,I.revive)(X)};throw new Error(`Property not found: ${String(x)}`)}})}M.toService=W;function G(F){return F[0]==="o"&&F[1]==="n"&&w.isUpperAsciiLetter(F.charCodeAt(2))}function Q(F){return/^onDynamic/.test(F)&&w.isUpperAsciiLetter(F.charCodeAt(9))}})(ce=t.ProxyChannel||(t.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const A=M.toString();if(A!=="[object Object]")return A}return M}function ae(M){return Array.isArray(M)?M.map(ge):ge(M)}function N(M,A,W,G,Q,F,V){V=ae(V);const R=re[Q],O=R[G%R.length];let x=[`%c[${M}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(F)?(x=x.concat(V),x.push(")")):x.push(V),console.log.apply(console,x)}t.logWithColors=N;class _{constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,G,Q,F){this._totalOutgoing+=A,N(this._outgoingPrefix,this._totalOutgoing,A,W,G,Q,F)}logIncoming(A,W,G,Q,F){this._totalIncoming+=A,N(this._incomingPrefix,this._totalIncoming,A,W,G,Q,F)}}t.IPCLogger=_}),define(Z[78],ee([0,1,3,4,2,7]),function($,t,D,C,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageState=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var T;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));function p(w){const g=w;return g?.changed instanceof Map||g?.deleted instanceof Set}t.isStorageItemsChangeEvent=p;var a;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(a=t.StorageState||(t.StorageState={}));class h extends b.Disposable{constructor(g,E=Object.create(null)){super();this.database=g,this.options=E,this._onDidChangeStorage=this._register(new C.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((E,l)=>this.accept(l,E)),g.deleted?.forEach(E=>this.accept(E,void 0))}accept(g,E){if(this.state===a.Closed)return;let l=!1;(0,L.isUndefinedOrNull)(E)?l=this.cache.delete(g):this.cache.get(g)!==E&&(this.cache.set(g,E),l=!0),l&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,E){const l=this.cache.get(g);return(0,L.isUndefinedOrNull)(l)?E:l}getBoolean(g,E){const l=this.get(g);return(0,L.isUndefinedOrNull)(l)?E:l==="true"}getNumber(g,E){const l=this.get(g);return(0,L.isUndefinedOrNull)(l)?E:parseInt(l,10)}async set(g,E){if(this.state===a.Closed)return;if((0,L.isUndefinedOrNull)(E))return this.delete(g);const l=String(E);if(this.cache.get(g)!==l)return this.cache.set(g,l),this.pendingInserts.set(g,l),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async delete(g){if(!(this.state===a.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(!!this.hasPending)return this.doFlush(g)}async doFlush(g){return this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=h,h.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert?.forEach((E,l)=>this.items.set(l,E)),g.delete?.forEach(E=>this.items.delete(E))}async close(){}}t.InMemoryStorageDatabase=I}),define(Z[79],ee([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(Z[57],ee([0,1,45,80,16,24,14,13,32,52,7,70,20,79]),function($,t,D,C,b,L,T,p,a,h,I,w,g,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return h.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return h.TerminateResponseCode}});function l(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(s,i){if(p.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};i&&(n.cwd=i);const e=D.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],n);return new Promise(r=>{e.once("error",o=>{r({success:!1,error:o})}),e.once("exit",(o,m)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?l(n.status):1})}else if(p.isLinux||p.isMacintosh)try{const n=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(e=>{D.execFile(n,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,o,m)=>{e(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function v(s=a.env){return s.comspec||"cmd.exe"}t.getWindowsShell=v;class u{constructor(i,n,e,r){if(n!==void 0&&e!==void 0&&r!==void 0)this.cmd=i,this.args=n,this.shell=e,this.options=r;else{const o=i;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(a.env).forEach(m=>{o[m]=a.env[m]}),Object.keys(this.options.env).forEach(m=>{o[m]=this.options.env[m]}),this.options.env=o}}getSanitizedCommand(){let i=this.cmd.toLowerCase();const n=i.lastIndexOf(T.sep);return n!==-1&&(i=i.substring(n+1)),u.WellKnowCommands[i]?i:"other"}start(i){return p.isWindows&&(this.options&&this.options.cwd&&C.isUNC(this.options.cwd)||!this.options&&C.isUNC(a.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(n=>{let e,r;const o=new Promise((m,S)=>{e=m,r=S});if(n){let m=this.cmd;this.args&&(m=m+" "+this.args.join(" ")),this.childProcess=D.exec(m,this.options,(S,P,k)=>{this.childProcess=null;const U=S;U&&U.killed?r({killed:this.terminateRequested,stdout:P.toString(),stderr:k.toString()}):this.handleExec(e,i,S,P,k)})}else{let m=null;const S=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,e,i,r);const k={terminated:this.terminateRequested};I.isNumber(P)&&(k.cmdCode=P),e(k)};if(this.shell&&p.isWindows){const P=L.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let k=!1,U=!1;const B=[];let q=this.ensureQuotes(this.cmd);B.push(q.value),k=q.quoted,this.args&&this.args.forEach(ne=>{q=this.ensureQuotes(ne),B.push(q.value),U=U&&q.quoted});const Y=["/s","/c"];k?U?Y.push('"'+B.join(" ")+'"'):B.length>1?Y.push('"'+B[0]+'" '+B.slice(1).join(" ")):Y.push('"'+B[0]+'"'):Y.push(B.join(" ")),m=D.spawn(v(),Y,P)}else this.cmd&&(m=D.spawn(this.cmd,this.args,this.options));m&&(this.childProcess=m,this.childProcessPromise=Promise.resolve(m),this.pidResolve&&(this.pidResolve(I.isNumber(m.pid)?m.pid:-1),this.pidResolve=void 0),m.on("error",P=>{this.childProcess=null,r({terminated:this.terminateRequested,error:P})}),m.pid&&(this.childProcess.on("close",S),this.handleSpawn(m,e,i,r,!0)))}return o})}handleClose(i,n,e,r){}ensureQuotes(i){return u.regexp.test(i)?{value:'"'+i+'"',quoted:!0}:{value:i,quoted:i.length>0&&i[0]==='"'&&i[i.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(i=>i.pid,i=>-1):new Promise(i=>{this.pidResolve=i})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(i=>(this.terminateRequested=!0,d(i,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),i=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(i=>{if(!this.shell||!p.isWindows)return i(!1);const n=D.spawn(v(),["/s","/c"]);n.on("error",e=>i(!0)),n.on("exit",e=>i(!1))})}}t.AbstractProcess=u,u.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},u.regexp=/^[^"].* .*[^"]/;class f extends u{constructor(i,n,e,r){super(i,n,e,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(i,n,e,r,o){[r,o].forEach((m,S)=>{const P=new w.LineDecoder;P.write(m).forEach(B=>{n({line:B,source:S===0?0:1})});const U=P.end();U&&n({line:U,source:S===0?0:1})}),i({terminated:this.terminateRequested,error:e})}handleSpawn(i,n,e,r,o){const m=new w.LineDecoder,S=new w.LineDecoder;i.stdout.on("data",P=>{m.write(P).forEach(U=>e({line:U,source:0}))}),i.stderr.on("data",P=>{S.write(P).forEach(U=>e({line:U,source:1}))}),this.stdoutLineDecoder=m,this.stderrLineDecoder=S}handleClose(i,n,e,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&e({line:o,source:0});const m=this.stderrLineDecoder?this.stderrLineDecoder.end():null;m&&e({line:m,source:1})}}t.LineProcess=f;function y(s){let i=[],n=!1;const e=function(r){if(n){i.push(r);return}(!s.send(r,m=>{if(m&&console.error(m),n=!1,i.length>0){const S=i.slice(0);i=[],S.forEach(P=>e(P))}})||p.isWindows)&&(n=!0)};return{send:e}}t.createQueuedSender=y;var c;(function(s){async function i(n,e,r){if(T.isAbsolute(n))return n;if(e===void 0&&(e=a.cwd()),T.dirname(n)!=="."||(r===void 0&&I.isString(a.env.PATH)&&(r=a.env.PATH.split(T.delimiter)),r===void 0||r.length===0))return T.join(e,n);async function m(S){if(await g.Promises.exists(S)){let P;try{P=await g.Promises.stat(S)}catch(k){k.message.startsWith("EACCES")&&(P=await g.Promises.lstat(S))}return P?!P.isDirectory():!1}return!1}for(const S of r){let P;if(T.isAbsolute(S)?P=T.join(S,n):P=T.join(e,S,n),await m(P))return P;let k=P+".com";if(await m(k)||(k=P+".exe",await m(k)))return k}return T.join(e,n)}s.findExecutable=i})(c=t.win32||(t.win32={}))}),define(Z[81],ee([0,1,38,13,77,57]),function($,t,D,C,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(E,l){return E===1?C.isWindows?w():L.getWindowsShell(l):h(E,l)}t.getSystemShell=T;function p(E,l){return E===1?C.isWindows?g(l):L.getWindowsShell(l):h(E,l)}t.getSystemShellSync=p;let a=null;function h(E,l){if(C.isLinux&&E===2||C.isMacintosh&&E===3)return"/bin/bash";if(!a){let d;if(C.isWindows)d="/bin/bash";else{if(d=l.SHELL,!d)try{d=(0,D.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}a=d}return a}let I=null;async function w(){return I||(I=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),I}function g(E){if(I)return I;const l=C.isWindows&&parseFloat((0,D.release)())>=10,d=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${E.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?v:L.getWindowsShell(E)}}),define(Z[82],ee([0,1,45,3,15,25,76,12,4,2,24,57,52,56]),function($,t,D,C,b,L,T,p,a,h,I,w,g,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class l extends E.ChannelServer{constructor(u){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:a.Event.fromNodeEventEmitter(process,"message",f=>b.VSBuffer.wrap(Buffer.from(f,"base64")))},u);process.once("disconnect",()=>this.dispose())}}t.Server=l;class d{constructor(u,f){this.modulePath=u,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new a.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new C.Delayer(y),this.child=null,this._client=null}getChannel(u){const f=this;return{call(y,c,s){return f.requestPromise(u,y,c,s)},listen(y,c){return f.requestEvent(u,y,c)}}}requestPromise(u,f,y,c=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(p.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(u),i=(0,C.createCancelablePromise)(r=>s.call(f,y,r)),n=c.onCancellationRequested(()=>i.cancel()),e=(0,h.toDisposable)(()=>i.cancel());return this.activeRequests.add(e),i.finally(()=>{n.dispose(),this.activeRequests.delete(e),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(u,f,y){if(!this.disposeDelayer)return a.Event.None;this.disposeDelayer.cancel();let c;const s=new a.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(u).listen(f,y)(s.fire,s),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,g.removeDangerousEnvVariables)(f.env),this.child=(0,D.fork)(this.modulePath,u,f);const y=new a.Emitter;a.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,T.isRemoteConsoleLog)(o)){(0,T.log)(o,`IPC Library: ${this.options.serverName}`);return}y.fire(b.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,i=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),n=y.event,e={send:i,onMessage:n};this._client=new E.ChannelClient(e);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,m)=>{process.removeListener("exit",r),this.activeRequests.forEach(S=>(0,h.dispose)(S)),this.activeRequests.clear(),o!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:m})})}return this._client}getCachedChannel(u){let f=this.channels.get(u);return f||(f=this.client.getChannel(u),this.channels.set(u,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=d}),define(Z[83],ee([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(Z[84],ee([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Z[85],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Z[86],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Z[87],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Z[88],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionsScannerService",t)}),define(Z[89],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Z[90],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Z[91],ee([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(Z[92],ee([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(Z[93],ee([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(Z[94],ee([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Z[95],ee([5,6]),function($,t){return $.create("vs/platform/languagePacks/common/languagePacks",t)}),define(Z[96],ee([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(Z[97],ee([5,6]),function($,t){return $.create("vs/platform/shell/node/shellEnv",t)}),define(Z[98],ee([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)}),define(Z[99],ee([5,6]),function($,t){return $.create("vs/platform/userDataProfile/common/userDataProfile",t)}),define(Z[100],ee([5,6]),function($,t){return $.create("vs/platform/workspace/common/workspace",t)}),define(Z[101],ee([0,1,72,50,16,14,32,17,10]),function($,t,D,C,b,L,T,p,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class h{constructor(d,v,u){this._args=d,this.paths=v,this.productService=u,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,L.dirname)(b.FileAccess.asFileUri("",$).fsPath)}get userHome(){return a.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return a.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return a.URI.file(this.paths.tmpDir)}get cacheHome(){return a.URI.file(this.userDataPath)}get stateResource(){return(0,p.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,p.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return a.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return a.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,p.joinPath)(a.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,p.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,p.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,p.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=T.env.VSCODE_PORTABLE;return d?a.URI.file((0,L.join)(d,"argv.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return a.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,L.resolve)(d):(0,L.normalize)((0,L.join)(b.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,L.resolve)(d):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,L.resolve)(d);const v=T.env.VSCODE_EXTENSIONS;if(v)return v;const u=T.env.VSCODE_PORTABLE;return u?(0,L.join)(u,"extensions"):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(v=>/^[^:/?#]+?:\/\//.test(v)?a.URI.parse(v):a.URI.file((0,L.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?a.URI.parse(d):a.URI.file((0,L.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,p.joinPath)(a.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return a.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=T.env.VSCODE_PORTABLE;return d?a.URI.file((0,L.join)(d,"policy.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}fe([C.memoize],h.prototype,"appRoot",null),fe([C.memoize],h.prototype,"userHome",null),fe([C.memoize],h.prototype,"userDataPath",null),fe([C.memoize],h.prototype,"appSettingsHome",null),fe([C.memoize],h.prototype,"tmpDir",null),fe([C.memoize],h.prototype,"cacheHome",null),fe([C.memoize],h.prototype,"stateResource",null),fe([C.memoize],h.prototype,"userRoamingDataHome",null),fe([C.memoize],h.prototype,"userDataSyncHome",null),fe([C.memoize],h.prototype,"userDataSyncLogResource",null),fe([C.memoize],h.prototype,"editSessionsLogResource",null),fe([C.memoize],h.prototype,"sync",null),fe([C.memoize],h.prototype,"machineSettingsResource",null),fe([C.memoize],h.prototype,"workspaceStorageHome",null),fe([C.memoize],h.prototype,"localHistoryHome",null),fe([C.memoize],h.prototype,"keyboardLayoutResource",null),fe([C.memoize],h.prototype,"argvResource",null),fe([C.memoize],h.prototype,"isExtensionDevelopment",null),fe([C.memoize],h.prototype,"untitledWorkspacesHome",null),fe([C.memoize],h.prototype,"installSourcePath",null),fe([C.memoize],h.prototype,"builtinExtensionsPath",null),fe([C.memoize],h.prototype,"extensionsPath",null),fe([C.memoize],h.prototype,"extensionDevelopmentLocationURI",null),fe([C.memoize],h.prototype,"extensionDevelopmentKind",null),fe([C.memoize],h.prototype,"extensionTestsLocationURI",null),fe([C.memoize],h.prototype,"debugExtensionHost",null),fe([C.memoize],h.prototype,"serviceMachineIdResource",null),fe([C.memoize],h.prototype,"telemetryLogResource",null),fe([C.memoize],h.prototype,"disableWorkspaceTrust",null),fe([C.memoize],h.prototype,"policyFile",null),t.AbstractNativeEnvironmentService=h;function I(l,d){return E(l["inspect-extensions"],l["inspect-brk-extensions"],5870,d,l.debugId,l.extensionEnvironment)}t.parseExtensionHostPort=I;function w(l,d){return E(l["inspect-search"],l["inspect-brk-search"],5876,d,l.extensionEnvironment)}t.parseSearchPort=w;function g(l,d){return E(l["inspect-ptyhost"],l["inspect-brk-ptyhost"],5877,d,l.extensionEnvironment)}t.parsePtyHostPort=g;function E(l,d,v,u,f,y){const s=Number(d||l)||(u?null:v),i=s?Boolean(!!d):!1;let n;if(y)try{n=JSON.parse(y)}catch{}return{port:s,break:i,debugId:f,env:n}}}),function(){"use strict";function $(t,D,C,b){function L(p){const a=T(p),h=[a];return t.isAbsolute(a)||h.unshift(b),t.resolve(...h)}function T(p){const a=process.env.VSCODE_PORTABLE;if(a)return t.join(a,"user-data");let h=process.env.VSCODE_APPDATA;if(h)return t.join(h,C);const I=p["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(h=process.env.APPDATA,!h){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");h=t.join(w,"AppData","Roaming")}break;case"darwin":h=t.join(D.homedir(),"Library","Application Support");break;case"linux":h=process.env.XDG_CONFIG_HOME||t.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(h,C)}return{getUserDataPath:L}}if(typeof define=="function")define(Z[102],ee([0,151,38,16,17,32]),function(t,D,C,b,L,T){const p=L.dirname(b.FileAccess.asFileUri("",t)),a=t.__$__nodeRequire(L.joinPath(p,"package.json").fsPath);return $(D,C,a.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),D=require("path"),C=require("os");module.exports=$(D,C,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[103],ee([0,1,38,101,102]),function($,t,D,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class L extends C.AbstractNativeEnvironmentService{constructor(p,a){super(p,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,b.getUserDataPath)(p)},a)}}t.NativeEnvironmentService=L}),define(Z[46],ee([0,1,17,55,91,39]),function($,t,D,C,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.validateExtensionManifest=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function a(u){return u=u.trim(),u==="*"||T.test(u)}t.isValidVersionStr=a;function h(u){if(!a(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=u.match(T);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}t.parseVersion=h;function I(u){if(!u)return null;const f=u.majorBase,y=u.majorMustEqual,c=u.minorBase;let s=u.minorMustEqual;const i=u.patchBase;let n=u.patchMustEqual;u.hasCaret&&(f===0||(s=!1),n=!1);let e=0;if(u.preRelease){const r=p.exec(u.preRelease);if(r){const[,o,m,S]=r;e=Date.UTC(Number(o),Number(m)-1,Number(S))}}return{majorBase:f,majorMustEqual:y,minorBase:c,minorMustEqual:s,patchBase:i,patchMustEqual:n,isMinimum:u.hasGreaterEquals,notBefore:e}}t.normalizeVersion=I;function w(u,f,y){let c;typeof u=="string"?c=I(h(u)):c=u;let s;f instanceof Date?s=f.getTime():typeof f=="string"&&(s=new Date(f).getTime());let i;if(typeof y=="string"?i=I(h(y)):i=y,!c||!i)return!1;const n=c.majorBase,e=c.minorBase,r=c.patchBase;let o=i.majorBase,m=i.minorBase,S=i.patchBase;const P=i.notBefore;let k=i.majorMustEqual,U=i.minorMustEqual,B=i.patchMustEqual;return i.isMinimum?n>o?!0:n<o?!1:e>m?!0:e<m||s&&s<P?!1:r>=S:(n===1&&o===0&&(!k||!U||!B)&&(o=1,m=0,S=0,k=!0,U=!1,B=!1),n<o?!1:n>o?!k:e<m?!1:e>m?!U:r<S?!1:r>S?!B:!(s&&s<P))}t.isValidVersion=w;function g(u,f,y,c,s){const i=[];if(typeof c.publisher!="undefined"&&typeof c.publisher!="string")return i.push([C.default.Error,b.localize(0,null)]),i;if(typeof c.name!="string")return i.push([C.default.Error,b.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([C.default.Error,b.localize(2,null,"version")]),i;if(!c.engines)return i.push([C.default.Error,b.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([C.default.Error,b.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies!="undefined"&&!v(c.extensionDependencies))return i.push([C.default.Error,b.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents!="undefined"){if(!v(c.activationEvents))return i.push([C.default.Error,b.localize(6,null,"activationEvents")]),i;if(typeof c.main=="undefined"&&typeof c.browser=="undefined")return i.push([C.default.Error,b.localize(7,null,"activationEvents","main")]),i}if(typeof c.extensionKind!="undefined"&&typeof c.main=="undefined"&&i.push([C.default.Warning,b.localize(8,null,"extensionKind")]),typeof c.main!="undefined"){if(typeof c.main!="string")return i.push([C.default.Error,b.localize(9,null,"main")]),i;{const r=(0,D.joinPath)(y,c.main);(0,D.isEqualOrParent)(r,y)||i.push([C.default.Warning,b.localize(10,null,r.path,y.path)])}if(typeof c.activationEvents=="undefined")return i.push([C.default.Error,b.localize(11,null,"activationEvents","main")]),i}if(typeof c.browser!="undefined"){if(typeof c.browser!="string")return i.push([C.default.Error,b.localize(12,null,"browser")]),i;{const r=(0,D.joinPath)(y,c.browser);(0,D.isEqualOrParent)(r,y)||i.push([C.default.Warning,b.localize(13,null,r.path,y.path)])}if(typeof c.activationEvents=="undefined")return i.push([C.default.Error,b.localize(14,null,"activationEvents","browser")]),i}if(!L.valid(c.version))return i.push([C.default.Error,b.localize(15,null)]),i;const n=[];if(!E(u,f,c,s,n))for(const r of n)i.push([C.default.Error,r]);return i}t.validateExtensionManifest=g;function E(u,f,y,c,s){return c||typeof y.main=="undefined"&&typeof y.browser=="undefined"?!0:d(u,f,y.engines.vscode,s)}t.isValidExtensionVersion=E;function l(u,f,y){return u==="*"||d(f,y,u)}t.isEngineValid=l;function d(u,f,y,c=[]){const s=I(h(y));if(!s)return c.push(b.localize(16,null,y)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return c.push(b.localize(17,null,y)),!1}else if(!s.majorMustEqual)return c.push(b.localize(18,null,y)),!1;return w(u,f,s)?!0:(c.push(b.localize(19,null,u,y)),!1)}function v(u){if(!Array.isArray(u))return!1;for(let f=0,y=u.length;f<y;f++)if(typeof u[f]!="string")return!1;return!0}}),define(Z[104],ee([0,1,15,29]),function($,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function b(L,T,p){let a=p&&p.get("storage.serviceMachineId",-1)||null;if(a)return a;try{const I=(await T.readFile(L.serviceMachineIdResource)).value.toString();a=(0,C.isUUID)(I)?I:null}catch{a=null}if(!a){a=(0,C.generateUuid)();try{await T.writeFile(L.serviceMachineIdResource,D.VSBuffer.fromString(a))}catch{}}return p?.store("storage.serviceMachineId",a,-1,1),a}t.getServiceMachineId=b}),define(Z[47],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class D{constructor(b,L=[],T=!1){this.ctor=b,this.staticArguments=L,this.supportsDelayedInstantiation=T}}t.SyncDescriptor=D}),define(Z[105],ee([0,1,47]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const C=[];function b(T,p,a){p instanceof D.SyncDescriptor||(p=new D.SyncDescriptor(p,[],a)),C.push([T,p])}t.registerSingleton=b;function L(){return C}t.getSingletonServiceDescriptors=L}),define(Z[106],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class D{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}t.Node=D;class C{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const T of this._nodes.values())T.outgoing.size===0&&L.push(T);return L}insertEdge(L,T){const p=this.lookupOrInsertNode(L),a=this.lookupOrInsertNode(T);p.outgoing.set(this._hashFn(T),a),a.incoming.set(this._hashFn(L),p)}removeNode(L){const T=this._hashFn(L);this._nodes.delete(T);for(const p of this._nodes.values())p.outgoing.delete(T),p.incoming.delete(T)}lookupOrInsertNode(L){const T=this._hashFn(L);let p=this._nodes.get(T);return p||(p=new D(L),this._nodes.set(T,p)),p}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[T,p]of this._nodes)L.push(`${T}, (incoming)[${[...p.incoming.keys()].join(", ")}], (outgoing)[${[...p.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(const[L,T]of this._nodes){const p=new Set([L]),a=this._findCycle(T,p);if(a)return a}}_findCycle(L,T){for(const[p,a]of L.outgoing){if(T.has(p))return[...T,p].join(" -> ");T.add(p);const h=this._findCycle(a,T);if(h)return h;T.delete(p)}}}t.Graph=C}),define(Z[21],ee([0,1,7,10,8]),function($,t,D,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLanguageTagSettingPlainKey=t.getMigratedSettingValue=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationUpdateOverrides=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,b.createDecorator)("configurationService");function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof C.URI)}t.isConfigurationOverrides=L;function T(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||D.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof C.URI)}t.isConfigurationUpdateOverrides=T;var p;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(p=t.ConfigurationTarget||(t.ConfigurationTarget={}));function a(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}t.ConfigurationTargetToString=a;function h(u,f){const y=Object.create(null);for(const c in u)I(y,c,u[c],f);return y}t.toValuesTree=h;function I(u,f,y,c){const s=f.split("."),i=s.pop();let n=u;for(let e=0;e<s.length;e++){const r=s[e];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:c(`Ignoring ${f} as ${s.slice(0,e+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[i]=y}catch{c(`Ignoring ${f} as ${s.join(".")} is ${JSON.stringify(n)}`)}else c(`Ignoring ${f} as ${s.join(".")} is ${JSON.stringify(n)}`)}t.addToValueTree=I;function w(u,f){const y=f.split(".");g(u,y)}t.removeFromValueTree=w;function g(u,f){const y=f.shift();if(f.length===0){delete u[y];return}if(Object.keys(u).indexOf(y)!==-1){const c=u[y];typeof c=="object"&&!Array.isArray(c)&&(g(c,f),Object.keys(c).length===0&&delete u[y])}}function E(u,f,y){function c(n,e){let r=n;for(const o of e){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=f.split("."),i=c(u,s);return typeof i=="undefined"?y:i}t.getConfigurationValue=E;function l(u,f,y){Object.keys(f).forEach(c=>{c!=="__proto__"&&(c in u?D.isObject(u[c])&&D.isObject(f[c])?l(u[c],f[c],y):y&&(u[c]=f[c]):u[c]=f[c])})}t.merge=l;function d(u,f,y){const c=u.inspect(f),s=u.inspect(y);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:c.defaultValue}t.getMigratedSettingValue=d;function v(u){return u.replace(/[\[\]]/g,"")}t.getLanguageTagSettingPlainKey=v}),define(Z[58],ee([0,1,8]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Z[18],ee([0,1,8]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,D.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,D.refineServiceDecorator)(t.IEnvironmentService)}),define(Z[22],ee([0,1,86,8]),function($,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDefaultExtensionsProfileInitService=t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IServerExtensionManagementService=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function b(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=b;function L(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=L;function T(u,f){switch(u){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=T;function p(u,f){return f==="web"&&!u.includes("web")}t.isNotWebExtensionInWebTargetPlatform=p;function a(u,f,y){return p(f,y)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===y?!0:h(y).includes(u)}t.isTargetPlatformCompatible=a;function h(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=h;function I(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}t.isIExtensionIdentifier=I;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w=t.SortBy||(t.SortBy={}));var g;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(g=t.SortOrder||(t.SortOrder={}));var E;(function(u){u.Install="install",u.Uninstall="uninstall"})(E=t.StatisticType||(t.StatisticType={}));var l;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(l=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var d;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal"})(d=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class v extends Error{constructor(f,y){super(f);this.code=y,this.name=y}}t.ExtensionManagementError=v,t.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),t.IServerExtensionManagementService=(0,C.refineServiceDecorator)(t.IExtensionManagementService),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),t.ExtensionsLabel=(0,D.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,D.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService"),t.IDefaultExtensionsProfileInitService=(0,C.createDecorator)("IDefaultExtensionsProfileInitService")}),define(Z[59],ee([0,1,15,12,93,11]),function($,t,D,C,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(I,w,g,E,l,d){let v;try{await p(I,w,g,E,l,d)}catch(u){v=u}finally{v&&l.errorTransformer&&(v=l.errorTransformer(v)),typeof v!="undefined"&&g.error(v),g.end()}}t.readFileIntoStream=T;async function p(I,w,g,E,l,d){a(d);const v=await I.open(w,{create:!1});try{a(d);let u=0,f=0,y=l&&typeof l.length=="number"?l.length:void 0,c=D.VSBuffer.alloc(Math.min(l.bufferSize,typeof y=="number"?y:l.bufferSize)),s=l&&typeof l.position=="number"?l.position:0,i=0;do f=await I.read(v,s,c.buffer,i,c.byteLength-i),s+=f,i+=f,u+=f,typeof y=="number"&&(y-=f),i===c.byteLength&&(await g.write(E(c)),c=D.VSBuffer.alloc(Math.min(l.bufferSize,typeof y=="number"?y:l.bufferSize)),i=0);while(f>0&&(typeof y!="number"||y>0)&&a(d)&&h(u,l));if(i>0){let n=i;typeof y=="number"&&(n=Math.min(i,y)),g.write(E(c.slice(0,n)))}}catch(u){throw(0,L.ensureFileSystemProviderError)(u)}finally{await I.close(v)}}function a(I){if(I.isCancellationRequested)throw(0,C.canceled)();return!0}function h(I,w){if(w?.limits){if(typeof w.limits.memory=="number"&&I>w.limits.memory)throw(0,L.createFileSystemProviderError)((0,b.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&I>w.limits.size)throw(0,L.createFileSystemProviderError)((0,b.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[107],ee([0,1,4,152,2,13,153]),function($,t,D,C,b,L,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcher=void 0;class p extends b.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(h){const I=this.normalizeRequests(h),w=I.filter(E=>{const l=this.watchers.get(E.path);return l?!(0,C.patternsEquals)(l.request.excludes,E.excludes)||!(0,C.patternsEquals)(l.request.includes,E.includes):!0}),g=Array.from(this.watchers.values()).filter(({request:E})=>!I.find(l=>l.path===E.path&&(0,C.patternsEquals)(l.excludes,E.excludes)&&(0,C.patternsEquals)(l.includes,E.includes))).map(({request:E})=>E.path);w.length&&this.trace(`Request to start watching: ${w.map(E=>`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"})`).join(",")}`),g.length&&this.trace(`Request to stop watching: ${g.join(",")}`);for(const E of g)this.stopWatching(E);for(const E of w)this.startWatching(E)}startWatching(h){const I=new T.NodeJSFileWatcherLibrary(h,g=>this._onDidChangeFile.fire(g),g=>this._onDidLogMessage.fire(g),this.verboseLogging),w={request:h,instance:I};this.watchers.set(h.path,w)}async stop(){for(const[h]of this.watchers)this.stopWatching(h);this.watchers.clear()}stopWatching(h){const I=this.watchers.get(h);I&&(this.watchers.delete(h),I.instance.dispose())}normalizeRequests(h){const I=new Map;for(const w of h){const g=L.isLinux?w.path:w.path.toLowerCase();I.set(g,w)}return Array.from(I.values())}async setVerboseLogging(h){this.verboseLogging=h;for(const[,I]of this.watchers)I.instance.setVerboseLogging(h)}trace(h){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(h)})}toMessage(h,I){return I?`[File Watcher (node.js)] ${h} (path: ${I.request.path})`:`[File Watcher (node.js)] ${h}`}}t.NodeJSWatcher=p}),define(Z[108],ee([0,1,60,107]),function($,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcherClient=void 0;class b extends D.AbstractNonRecursiveWatcherClient{constructor(T,p,a){super(T,p,a);this.init()}createWatcher(){return new C.NodeJSWatcher}}t.NodeJSWatcherClient=b}),define(Z[109],ee([0,1,16,56,82,60]),function($,t,D,C,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UniversalWatcherClient=void 0;class T extends L.AbstractUniversalWatcherClient{constructor(a,h,I){super(a,h,I);this.init()}createWatcher(a){const h=a.add(new b.Client(D.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return a.add(h.onDidProcessExit(({code:I,signal:w})=>this.onError(`terminated by itself with code ${I}, signal: ${w}`))),C.ProxyChannel.toService((0,C.getNextTickChannel)(h.getChannel("watcher")))}}t.UniversalWatcherClient=T}),define(Z[61],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class D{constructor(...b){this._entries=new Map;for(const[L,T]of b)this.set(L,T)}set(b,L){const T=this._entries.get(b);return this._entries.set(b,L),T}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}t.ServiceCollection=D}),define(Z[110],ee([0,1,3,12,47,106,8,61]),function($,t,D,C,b,L,T,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Trace=t.InstantiationService=void 0;const a=!1;class h extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class I{constructor(l=new p.ServiceCollection,d=!1,v){this._activeInstantiations=new Set,this._services=l,this._strict=d,this._parent=v,this._services.set(T.IInstantiationService,this)}createChild(l){return new I(l,this._strict,this)}invokeFunction(l,...d){const v=g.traceInvocation(l);let u=!1;try{return l({get:y=>{if(u)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(y,v);if(!c)throw new Error(`[invokeFunction] unknown service '${y}'`);return c}},...d)}finally{u=!0,v.stop()}}createInstance(l,...d){let v,u;return l instanceof b.SyncDescriptor?(v=g.traceCreation(l.ctor),u=this._createInstance(l.ctor,l.staticArguments.concat(d),v)):(v=g.traceCreation(l),u=this._createInstance(l,d,v)),v.stop(),u}_createInstance(l,d=[],v){const u=T._util.getServiceDependencies(l).sort((c,s)=>c.index-s.index),f=[];for(const c of u){const s=this._getOrCreateServiceInstance(c.id,v);s||this._throwIfStrict(`[createInstance] ${l.name} depends on UNKNOWN service ${c.id}.`,!1),f.push(s)}const y=u.length>0?u[0].index:d.length;if(d.length!==y){console.trace(`[createInstance] First service dependency of ${l.name} at position ${y+1} conflicts with ${d.length} static arguments`);const c=y-d.length;c>0?d=d.concat(new Array(c)):d=d.slice(0,y)}return new l(...[...d,...f])}_setServiceInstance(l,d){if(this._services.get(l)instanceof b.SyncDescriptor)this._services.set(l,d);else if(this._parent)this._parent._setServiceInstance(l,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){const d=this._services.get(l);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):d}_getOrCreateServiceInstance(l,d){const v=this._getServiceInstanceOrDescriptor(l);return v instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,v,d.branch(l,!0)):(d.branch(l,!1),v)}_safeCreateAndCacheServiceInstance(l,d,v){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,d,v)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,d,v){const u=new L.Graph(c=>c.id.toString());let f=0;const y=[{id:l,desc:d,_trace:v}];for(;y.length;){const c=y.pop();if(u.lookupOrInsertNode(c),f++>1e3)throw new h(u);for(const s of T._util.getServiceDependencies(c.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(s.id);if(i||this._throwIfStrict(`[createInstance] ${l} depends on ${s.id} which is NOT registered.`,!0),i instanceof b.SyncDescriptor){const n={id:s.id,desc:i,_trace:c._trace.branch(s.id,!0)};u.insertEdge(c,n),y.push(n)}}}for(;;){const c=u.roots();if(c.length===0){if(!u.isEmpty())throw new h(u);break}for(const{data:s}of c){if(this._getServiceInstanceOrDescriptor(s.id)instanceof b.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}u.removeNode(s)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,d,v=[],u,f){if(this._services.get(l)instanceof b.SyncDescriptor)return this._createServiceInstance(d,v,u,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,d,v,u,f);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(l,d=[],v,u){if(v){const f=new D.IdleValue(()=>this._createInstance(l,d,u));return new Proxy(Object.create(null),{get(y,c){if(c in y)return y[c];const s=f.value;let i=s[c];return typeof i!="function"||(i=i.bind(s),y[c]=i),i},set(y,c,s){return f.value[c]=s,!0}})}else return this._createInstance(l,d,u)}_throwIfStrict(l,d){if(d&&console.warn(l),this._strict)throw new Error(l)}}t.InstantiationService=I;var w;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(w||(w={}));class g{constructor(l,d){this.type=l,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return a?new g(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(l){return a?new g(0,l.name):g._None}branch(l,d){const v=new g(2,l.toString());return this._dep.push([l,d,v]),v}stop(){const l=Date.now()-this._start;g._totals+=l;let d=!1;function v(f,y){const c=[],s=new Array(f+1).join("	");for(const[i,n,e]of y._dep)if(n&&e){d=!0,c.push(`${s}CREATES -> ${i}`);const r=v(f+1,e);r&&c.push(r)}else c.push(`${s}uses -> ${i}`);return c.join(`
`)}const u=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(l>2||d)&&console.log(u.join(`
`))}}t.Trace=g,g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0});var te=this&&this.__param||function($,t){return function(D,C){t(D,C,$)}};define(Z[62],ee([0,1,25,2,13,95,22,8]),function($,t,D,C,b,L,T,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LanguagePackBaseService=t.ILanguagePackService=void 0,t.ILanguagePackService=(0,p.createDecorator)("languagePackService");let a=class extends C.Disposable{constructor(I){super();this.extensionGalleryService=I}async getAvailableLanguages(){const I=new D.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let w;try{w=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const E=w.firstPage.filter(l=>l.properties.localizedLanguages?.length&&l.tags.some(d=>d.startsWith("lp-"))).map(l=>{const d=l.properties.localizedLanguages?.[0],v=this.getLocale(l);return{...this.createQuickPickItem({locale:v,label:d}),extensionId:l.identifier.id,galleryExtension:l}});return E.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),E}getLocale(I){return I.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(I){const w=I.label??I.locale;let g=I.locale!==I.label?I.locale:void 0;return I.locale.toLowerCase()===b.language.toLowerCase()&&(g||(g=""),g+=(0,L.localize)(0,null)),{id:I.locale,label:w,description:g}}};a=fe([te(0,T.IExtensionGalleryService)],a),t.LanguagePackBaseService=a}),define(Z[9],ee([0,1,30,4,2,13,8]),function($,t,D,C,b,L,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.format=t.log=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,T.createDecorator)("logService"),t.ILoggerService=(0,T.createDecorator)("loggerService");function p(){return new Date().toISOString()}var a;(function(n){n[n.Trace=0]="Trace",n[n.Debug=1]="Debug",n[n.Info=2]="Info",n[n.Warning=3]="Warning",n[n.Error=4]="Error",n[n.Critical=5]="Critical",n[n.Off=6]="Off"})(a=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=a.Info;function h(n,e,r){switch(e){case a.Trace:n.trace(r);break;case a.Debug:n.debug(r);break;case a.Info:n.info(r);break;case a.Warning:n.warn(r);break;case a.Error:n.error(r);break;case a.Critical:n.critical(r);break;default:throw new Error("Invalid log level")}}t.log=h;function I(n){let e="";for(let r=0;r<n.length;r++){let o=n[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}e+=(r>0?" ":"")+o}return e}t.format=I;class w extends b.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=w;class g extends w{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...r){this.checkLogLevel(a.Trace)&&this.log(a.Trace,I([e,...r]))}debug(e,...r){this.checkLogLevel(a.Debug)&&this.log(a.Debug,I([e,...r]))}info(e,...r){this.checkLogLevel(a.Info)&&this.log(a.Info,I([e,...r]))}warn(e,...r){this.checkLogLevel(a.Warning)&&this.log(a.Warning,I([e,...r]))}error(e,...r){if(this.checkLogLevel(a.Error))if(e instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=e.stack,this.log(a.Error,I(o))}else this.log(a.Error,I([e,...r]))}critical(e,...r){this.checkLogLevel(a.Critical)&&this.log(a.Critical,I([e,...r]))}flush(){}}t.AbstractMessageLogger=g;class E extends w{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!L.isWindows}trace(e,...r){this.getLevel()<=a.Trace&&(this.useColors?console.log(`[90m[main ${p()}][0m`,e,...r):console.log(`[main ${p()}]`,e,...r))}debug(e,...r){this.getLevel()<=a.Debug&&(this.useColors?console.log(`[90m[main ${p()}][0m`,e,...r):console.log(`[main ${p()}]`,e,...r))}info(e,...r){this.getLevel()<=a.Info&&(this.useColors?console.log(`[90m[main ${p()}][0m`,e,...r):console.log(`[main ${p()}]`,e,...r))}warn(e,...r){this.getLevel()<=a.Warning&&(this.useColors?console.warn(`[93m[main ${p()}][0m`,e,...r):console.warn(`[main ${p()}]`,e,...r))}error(e,...r){this.getLevel()<=a.Error&&(this.useColors?console.error(`[91m[main ${p()}][0m`,e,...r):console.error(`[main ${p()}]`,e,...r))}critical(e,...r){this.getLevel()<=a.Critical&&(this.useColors?console.error(`[90m[main ${p()}][0m`,e,...r):console.error(`[main ${p()}]`,e,...r))}dispose(){}flush(){}}t.ConsoleMainLogger=E;class l extends w{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...r){this.getLevel()<=a.Trace&&console.log("%cTRACE","color: #888",e,...r)}debug(e,...r){this.getLevel()<=a.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...r)}info(e,...r){this.getLevel()<=a.Info&&console.log("%c INFO","color: #33f",e,...r)}warn(e,...r){this.getLevel()<=a.Warning&&console.log("%c WARN","color: #993",e,...r)}error(e,...r){this.getLevel()<=a.Error&&console.log("%c  ERR","color: #f33",e,...r)}critical(e,...r){this.getLevel()<=a.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...r)}dispose(){}flush(){}}t.ConsoleLogger=l;class d extends w{constructor(e,r=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(r)}trace(e,...r){this.getLevel()<=a.Trace&&this.adapter.log(a.Trace,[this.extractMessage(e),...r])}debug(e,...r){this.getLevel()<=a.Debug&&this.adapter.log(a.Debug,[this.extractMessage(e),...r])}info(e,...r){this.getLevel()<=a.Info&&this.adapter.log(a.Info,[this.extractMessage(e),...r])}warn(e,...r){this.getLevel()<=a.Warning&&this.adapter.log(a.Warning,[this.extractMessage(e),...r])}error(e,...r){this.getLevel()<=a.Error&&this.adapter.log(a.Error,[this.extractMessage(e),...r])}critical(e,...r){this.getLevel()<=a.Critical&&this.adapter.log(a.Critical,[this.extractMessage(e),...r])}extractMessage(e){return typeof e=="string"?e:(0,D.toErrorMessage)(e,this.getLevel()<=a.Trace)}dispose(){}flush(){}}t.AdapterLogger=d;class v extends w{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const r of this.logServices)r.setLevel(e);super.setLevel(e)}trace(e,...r){for(const o of this.logServices)o.trace(e,...r)}debug(e,...r){for(const o of this.logServices)o.debug(e,...r)}info(e,...r){for(const o of this.logServices)o.info(e,...r)}warn(e,...r){for(const o of this.logServices)o.warn(e,...r)}error(e,...r){for(const o of this.logServices)o.error(e,...r)}critical(e,...r){for(const o of this.logServices)o.critical(e,...r)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=v;class u extends b.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...r){this.logger.trace(e,...r)}debug(e,...r){this.logger.debug(e,...r)}info(e,...r){this.logger.info(e,...r)}warn(e,...r){this.logger.warn(e,...r)}error(e,...r){this.logger.error(e,...r)}critical(e,...r){this.logger.critical(e,...r)}flush(){this.logger.flush()}}t.LogService=u;class f extends b.Disposable{constructor(e,r){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(m=>m.setLevel(o))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,r){let o=this.loggers.get(e.toString());return o||(o=this.doCreateLogger(e,r?.always?a.Trace:this.logLevel,r),this.loggers.set(e.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=f;class y{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(e){}getLevel(){return a.Info}trace(e,...r){}debug(e,...r){}info(e,...r){}warn(e,...r){}error(e,...r){}critical(e,...r){}dispose(){}flush(){}}t.NullLogService=y;function c(n){if(n.verbose)return a.Trace;if(typeof n.logLevel=="string"){const e=s(n.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=c;function s(n){switch(n){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Critical;case"off":return a.Off}}t.parseLogLevel=s;function i(n){switch(n){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Critical:return"critical";case a.Off:return"off"}}t.LogLevelToString=i}),define(Z[111],ee([0,1,19,3,12,4,2,14,60,9]),function($,t,D,C,b,L,T,p,a,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class I extends T.Disposable{constructor(g,E){super();this.logService=g,this.options=E,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new C.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new C.ThrottledDelayer(0))}watch(g,E){return E.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(g,E):this.watchNonRecursive(g,E)}watchUniversal(g,E){const l={path:this.toFilePath(g),excludes:E.excludes,includes:E.includes,recursive:E.recursive},d=(0,D.insert)(this.universalPathsToWatch,l);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{d(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(g=>(0,b.onUnexpectedError)(g))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(E=>this._onDidChangeFile.fire((0,a.toFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)})));const g=this.options?.watcher?.recursive?.usePolling;if(g===!0)for(const E of this.universalPathsToWatch)(0,a.isRecursiveWatchRequest)(E)&&(E.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const E of this.universalPathsToWatch)(0,a.isRecursiveWatchRequest)(E)&&g.includes(E.path)&&(E.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(g,E){const l={path:this.toFilePath(g),excludes:E.excludes,includes:E.includes,recursive:!1},d=(0,D.insert)(this.nonRecursivePathsToWatch,l);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{d(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(g=>(0,b.onUnexpectedError)(g))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(g=>this._onDidChangeFile.fire((0,a.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,p.normalize)(g.fsPath)}}t.AbstractDiskFileSystemProvider=I}),define(Z[112],ee([0,1,19,3,15,25,4,54,63,2,36,16,113,17,43,92,11,59,9]),function($,t,D,C,b,L,T,p,a,h,I,w,g,E,l,d,v,u,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let y=class extends h.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new C.ResourceQueue)}registerProvider(s,i){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${s}`);const n=new h.DisposableStore;return this.provider.set(s,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:i}),n.add(i.onDidChangeFile(e=>this._onDidFilesChange.fire(new v.FileChangesEvent(e,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&n.add(i.onDidWatchError(e=>this._onDidWatchError.fire(new Error(e)))),n.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:s}))),(0,h.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:i}),this.provider.delete(s),(0,h.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){i.push(n)}}),!this.provider.has(s)&&await C.Promises.settled(i)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,i){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&i)}listCapabilities(){return a.Iterable.map(this.provider,([s,i])=>({scheme:s,capabilities:i.capabilities}))}async withProvider(s){if(!(0,E.isAbsolutePath)(s))throw new v.FileOperationError((0,d.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const i=this.provider.get(s.scheme);if(!i){const n=new Error;throw n.name="ENOPRO",n.message=(0,d.localize)(1,null,s.toString()),n}return i}async withReadProvider(s){const i=await this.withProvider(s);if((0,v.hasOpenReadWriteCloseCapability)(i)||(0,v.hasReadWriteCapability)(i)||(0,v.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const i=await this.withProvider(s);if((0,v.hasOpenReadWriteCloseCapability)(i)||(0,v.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,i){try{return await this.doResolveFile(s,i)}catch(n){throw(0,v.toFileSystemProviderErrorCode)(n)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,d.localize)(2,null,this.resourceForError(s)),1):(0,v.ensureFileSystemProviderError)(n)}}async doResolveFile(s,i){const n=await this.withProvider(s),e=this.isPathCaseSensitive(n),r=i?.resolveTo,o=i?.resolveSingleChildDescendants,m=i?.resolveMetadata,S=await n.stat(s);let P;return this.toFileStat(n,s,S,void 0,!!m,(k,U)=>(P||(P=I.TernarySearchTree.forUris(()=>!e),P.set(s,!0),r&&P.fill(!0,r)),P.get(k.resource)||P.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&o?U===1:!1))}async toFileStat(s,i,n,e,r,o){const{providerExtUri:m}=this.getExtUri(s),S={resource:i,name:m.basename(i),isFile:(n.type&v.FileType.File)!=0,isDirectory:(n.type&v.FileType.Directory)!=0,isSymbolicLink:(n.type&v.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&v.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,v.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(S.isDirectory&&o(S,e)){try{const P=await s.readdir(i),k=await C.Promises.settled(P.map(async([U,B])=>{try{const q=m.joinPath(i,U),Y=r?await s.stat(q):{type:B};return await this.toFileStat(s,q,Y,P.length,r,o)}catch(q){return this.logService.trace(q),null}}));S.children=(0,D.coalesce)(k)}catch(P){this.logService.trace(P),S.children=[]}return S}return S}async resolveAll(s){return C.Promises.settled(s.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const i=await this.withProvider(s),n=await i.stat(s);return this.toFileStat(i,s,n,void 0,!0,()=>!1)}async exists(s){const i=await this.withProvider(s);try{return!!await i.stat(s)}catch{return!1}}async canCreateFile(s,i){try{await this.doValidateCreateFile(s,i)}catch(n){return n}return!0}async doValidateCreateFile(s,i){if(!i?.overwrite&&await this.exists(s))throw new v.FileOperationError((0,d.localize)(3,null,this.resourceForError(s)),3,i)}async createFile(s,i=b.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const e=await this.writeFile(s,i);return this._onDidRunOperation.fire(new v.FileOperationEvent(s,0,e)),e}async writeFile(s,i,n){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:r}=this.getExtUri(e);try{await this.validateWriteFile(e,s,n)||await this.mkdirp(e,r.dirname(s));let m;if((0,v.hasReadWriteCapability)(e)&&!(i instanceof b.VSBuffer))if((0,l.isReadableStream)(i)){const S=await(0,l.peekStream)(i,3);S.ended?m=b.VSBuffer.concat(S.buffer):m=S}else m=(0,l.peekReadable)(i,S=>b.VSBuffer.concat(S),3);else m=i;!(0,v.hasOpenReadWriteCloseCapability)(e)||(0,v.hasReadWriteCapability)(e)&&m instanceof b.VSBuffer?await this.doWriteUnbuffered(e,s,n,m):await this.doWriteBuffered(e,s,n,m instanceof b.VSBuffer?(0,b.bufferToReadable)(m):m),this._onDidRunOperation.fire(new v.FileOperationEvent(s,4))}catch(o){throw new v.FileOperationError((0,d.localize)(4,null,this.resourceForError(s),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,i,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(i)));let r;try{r=await s.stat(i)}catch{return}if((r.type&v.FileType.Directory)!=0)throw new v.FileOperationError((0,d.localize)(6,null,this.resourceForError(i)),0,n);if(this.throwIfFileIsReadonly(i,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==v.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,v.etag)({mtime:n.mtime,size:r.size}))throw new v.FileOperationError((0,d.localize)(7,null),3,n);return r}async readFile(s,i,n){const e=await this.withReadProvider(s);return i?.atomic?this.doReadFileAtomic(e,s,i,n):this.doReadFile(e,s,i,n)}async doReadFileAtomic(s,i,n,e){return new Promise((r,o)=>{this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(async()=>{try{const m=await this.doReadFile(s,i,n,e);r(m)}catch(m){o(m)}})})}async doReadFile(s,i,n,e){const r=await this.doReadFileStream(s,i,{...n,preferUnbuffered:!0},e);return{...r,value:await(0,b.streamToBuffer)(r.value)}}async readFileStream(s,i,n){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,i,n)}async doReadFileStream(s,i,n,e){const r=new L.CancellationTokenSource(e),o=this.validateReadFile(i,n).then(S=>S,S=>{throw r.cancel(),S});let m;try{return typeof n?.etag=="string"&&n.etag!==v.ETAG_DISABLED&&await o,n?.atomic&&(0,v.hasFileAtomicReadCapability)(s)||!((0,v.hasOpenReadWriteCloseCapability)(s)||(0,v.hasFileReadStreamCapability)(s))||(0,v.hasReadWriteCapability)(s)&&n?.preferUnbuffered?m=this.readFileUnbuffered(s,i,n):(0,v.hasFileReadStreamCapability)(s)?m=this.readFileStreamed(s,i,r.token,n):m=this.readFileBuffered(s,i,r.token,n),{...await o,value:m}}catch(S){m&&await(0,l.consumeStream)(m);const P=(0,d.localize)(8,null,this.resourceForError(i),(0,v.ensureFileSystemProviderError)(S).toString());throw S instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(P,S.stat,n):new v.FileOperationError(P,(0,v.toFileOperationResult)(S),n)}}readFileStreamed(s,i,n,e=Object.create(null)){const r=s.readFileStream(i,e,n);return(0,l.transform)(r,{data:o=>o instanceof b.VSBuffer?o:b.VSBuffer.wrap(o),error:o=>new v.FileOperationError((0,d.localize)(9,null,this.resourceForError(i),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),e)},o=>b.VSBuffer.concat(o))}readFileBuffered(s,i,n,e=Object.create(null)){const r=(0,b.newWriteableBufferStream)();return(0,u.readFileIntoStream)(s,i,r,o=>o,{...e,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new v.FileOperationError((0,d.localize)(10,null,this.resourceForError(i),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),e)},n),r}readFileUnbuffered(s,i,n){const e=(0,l.newWriteableStream)(r=>b.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,v.hasFileAtomicReadCapability)(s)?r=await s.readFile(i,{atomic:!0}):r=await s.readFile(i),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(i,r.byteLength,n),e.end(b.VSBuffer.wrap(r))}catch(r){e.error(r),e.end()}})(),e}async validateReadFile(s,i){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new v.FileOperationError((0,d.localize)(11,null,this.resourceForError(s)),0,i);if(typeof i?.etag=="string"&&i.etag!==v.ETAG_DISABLED&&i.etag===n.etag)throw new v.NotModifiedSinceFileOperationError((0,d.localize)(12,null),n,i);return this.validateReadFileLimits(s,n.size,i),n}validateReadFileLimits(s,i,n){if(n?.limits){let e;if(typeof n.limits.memory=="number"&&i>n.limits.memory&&(e=9),typeof n.limits.size=="number"&&i>n.limits.size&&(e=7),typeof e=="number")throw new v.FileOperationError((0,d.localize)(13,null,this.resourceForError(s)),e)}}async canMove(s,i,n){return this.doCanMoveCopy(s,i,"move",n)}async canCopy(s,i,n){return this.doCanMoveCopy(s,i,"copy",n)}async doCanMoveCopy(s,i,n,e){if(s.toString()!==i.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,s,o,i,n,e)}catch(r){return r}return!0}async move(s,i,n){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(e,s,r,i,"move",!!n),m=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(s,o==="move"?2:3,m)),m}async copy(s,i,n){const e=await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(e,s,r,i,"copy",!!n),m=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(s,o==="copy"?3:2,m)),m}async doMoveCopy(s,i,n,e,r,o){if(i.toString()===e.toString())return r;const{exists:m,isSameResourceWithDifferentPathCase:S}=await this.doValidateMoveCopy(s,i,n,e,r,o);if(m&&!S&&o&&await this.del(e,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(e)),r==="copy"){if(s===n&&(0,v.hasFileFolderCopyCapability)(s))await s.copy(i,e,{overwrite:o});else{const P=await this.resolve(i);P.isDirectory?await this.doCopyFolder(s,P,n,e):await this.doCopyFile(s,i,n,e)}return r}else return s===n?(await s.rename(i,e,{overwrite:o}),r):(await this.doMoveCopy(s,i,n,e,"copy",o),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(s,i,n,e){if((0,v.hasOpenReadWriteCloseCapability)(s)&&(0,v.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,i,n,e);if((0,v.hasOpenReadWriteCloseCapability)(s)&&(0,v.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,i,n,e);if((0,v.hasReadWriteCapability)(s)&&(0,v.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,i,n,e);if((0,v.hasReadWriteCapability)(s)&&(0,v.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,i,n,e)}async doCopyFolder(s,i,n,e){await n.mkdir(e),Array.isArray(i.children)&&await C.Promises.settled(i.children.map(async r=>{const o=this.getExtUri(n).providerExtUri.joinPath(e,r.name);return r.isDirectory?this.doCopyFolder(s,await this.resolve(r.resource),n,o):this.doCopyFile(s,r.resource,n,o)}))}async doValidateMoveCopy(s,i,n,e,r,o){let m=!1;if(s===n){const{providerExtUri:P,isPathCaseSensitive:k}=this.getExtUri(s);if(k||(m=P.isEqual(i,e)),m&&r==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(i),this.resourceForError(e)));if(!m&&P.isEqualOrParent(e,i))throw new Error((0,d.localize)(15,null,this.resourceForError(i),this.resourceForError(e)))}const S=await this.exists(e);if(S&&!m){if(!o)throw new v.FileOperationError((0,d.localize)(16,null,this.resourceForError(i),this.resourceForError(e)),4);if(s===n){const{providerExtUri:P}=this.getExtUri(s);if(P.isEqualOrParent(i,e))throw new Error((0,d.localize)(17,null,this.resourceForError(i),this.resourceForError(e)))}}return{exists:S,isSameResourceWithDifferentPathCase:m}}getExtUri(s){const i=this.isPathCaseSensitive(s);return{providerExtUri:i?E.extUri:E.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(i,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(s,0,n)),n}async mkdirp(s,i){const n=[],{providerExtUri:e}=this.getExtUri(s);for(;!e.isEqual(i,e.dirname(i));)try{if(((await s.stat(i)).type&v.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,v.toFileSystemProviderErrorCode)(r)!==v.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(e.basename(i)),i=e.dirname(i)}for(let r=n.length-1;r>=0;r--){i=e.joinPath(i,n[r]);try{await s.mkdir(i)}catch(o){if((0,v.toFileSystemProviderErrorCode)(o)!==v.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,i){try{await this.doValidateDelete(s,i)}catch(n){return n}return!0}async doValidateDelete(s,i){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!i?.useTrash&&!(n.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.throwIfFileIsReadonly(s,r);else throw new v.FileOperationError((0,d.localize)(20,null,this.resourceForError(s)),1);if(!!!i?.recursive){const m=await this.resolve(s);if(m.isDirectory&&Array.isArray(m.children)&&m.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(s)))}return n}async del(s,i){const n=await this.doValidateDelete(s,i),e=!!i?.useTrash,r=!!i?.recursive;await n.delete(s,{recursive:r,useTrash:e}),this._onDidRunOperation.fire(new v.FileOperationEvent(s,1))}async cloneFile(s,i){const n=await this.withProvider(s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(n===e&&this.getExtUri(n).providerExtUri.isEqual(s,i))return;if(n===e&&(0,v.hasFileCloneCapability)(n))return n.cloneFile(s,i);await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i));const r=this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri);return n===e&&(0,v.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,i,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,s,e,i))}watch(s,i={recursive:!1,excludes:[]}){const n=new h.DisposableStore;let e=!1,r=()=>{e=!0};return n.add((0,h.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(s,i);e?(0,h.dispose)(o):r=()=>(0,h.dispose)(o)}catch(o){this.logService.error(o)}})(),n}async doWatch(s,i){const n=await this.withProvider(s),e=(0,p.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),i]);let r=this.activeWatchers.get(e);return r||(r={count:0,disposable:n.watch(s,i)},this.activeWatchers.set(e,r)),r.count+=1,(0,h.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,h.dispose)(r.disposable),this.activeWatchers.delete(e)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,h.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,i,n,e){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(async()=>{const r=await s.open(i,{create:!0,unlock:n?.unlock??!1});try{(0,l.isReadableStream)(e)||(0,l.isReadableBufferedStream)(e)?await this.doWriteStreamBufferedQueued(s,r,e):await this.doWriteReadableBufferedQueued(s,r,e)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async doWriteStreamBufferedQueued(s,i,n){let e=0,r;if((0,l.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=b.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,i,o,o.byteLength,e,0),e+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,m)=>{(0,l.listenStream)(r,{onData:async S=>{r.pause();try{await this.doWriteBuffer(s,i,S,S.byteLength,e,0)}catch(P){return m(P)}e+=S.byteLength,setTimeout(()=>r.resume())},onError:S=>m(S),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,i,n){let e=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(s,i,r,r.byteLength,e,0),e+=r.byteLength}async doWriteBuffer(s,i,n,e,r,o){let m=0;for(;m<e;)m+=await s.write(i,r+m,n.buffer,o+m,e-m)}async doWriteUnbuffered(s,i,n,e){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,i,n,e))}async doWriteUnbufferedQueued(s,i,n,e){let r;e instanceof b.VSBuffer?r=e:(0,l.isReadableStream)(e)?r=await(0,b.streamToBuffer)(e):(0,l.isReadableBufferedStream)(e)?r=await(0,b.bufferedStreamToBuffer)(e):r=(0,b.readableToBuffer)(e),await s.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,i,n,e){return this.writeQueue.queueFor(e,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,i,n,e))}async doPipeBufferedQueued(s,i,n,e){let r,o;try{r=await s.open(i,{create:!1}),o=await n.open(e,{create:!0,unlock:!1});const m=b.VSBuffer.alloc(this.BUFFER_SIZE);let S=0,P=0,k=0;do k=await s.read(r,S,m.buffer,P,m.byteLength-P),await this.doWriteBuffer(n,o,m,k,S,P),S+=k,P+=k,P===m.byteLength&&(P=0);while(k>0)}catch(m){throw(0,v.ensureFileSystemProviderError)(m)}finally{await C.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,i,n,e){return this.writeQueue.queueFor(e,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,i,n,e))}async doPipeUnbufferedQueued(s,i,n,e){return n.writeFile(e,await s.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,i,n,e){return this.writeQueue.queueFor(e,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,i,n,e))}async doPipeUnbufferedToBufferedQueued(s,i,n,e){const r=await n.open(e,{create:!0,unlock:!1});try{const o=await s.readFile(i);await this.doWriteBuffer(n,r,b.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(s,i,n,e){const r=await(0,b.streamToBuffer)(this.readFileBuffered(s,i,L.CancellationToken.None));await this.doWriteUnbuffered(n,e,void 0,r)}throwIfFileSystemIsReadonly(s,i){if(s.capabilities&2048)throw new v.FileOperationError((0,d.localize)(22,null,this.resourceForError(i)),6);return s}throwIfFileIsReadonly(s,i){if((i.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,d.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===w.Schemas.file?s.fsPath:s.toString(!0)}};y=fe([te(0,f.ILogService)],y),t.FileService=y}),define(Z[114],ee([0,1,115,154,3,36,15,4,80,2,14,13,17,43,20,94,11,59,111,30,109,108]),function($,t,D,C,b,L,T,p,a,h,I,w,g,E,l,d,v,u,f,y,c,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,C.gracefulify)(D)}catch(n){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(n)}`)}})();class i extends f.AbstractDiskFileSystemProvider{constructor(e,r){super(e,r);this.onDidChangeCapabilities=p.Event.None,this.resourceLocks=new L.ResourceMap(o=>g.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:r,symbolicLink:o}=await l.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(e){try{const r=await l.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async m=>{try{let S;m.isSymbolicLink()?S=(await this.stat((0,g.joinPath)(e,m.name))).type:S=this.toType(m),o.push([m.name,S])}catch(S){this.logService.trace(S)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(e,r){let o;return r?.dangling?o=v.FileType.Unknown:e.isFile()?o=v.FileType.File:e.isDirectory()?o=v.FileType.Directory:o=v.FileType.Unknown,r&&(o|=v.FileType.SymbolicLink),o}async createResourceLock(e){const r=this.toFilePath(e);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const m=new b.Barrier;return this.resourceLocks.set(e,m),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,h.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(e)===m&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),m.open()})}async readFile(e,r){let o;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),o=await this.createResourceLock(e));const m=this.toFilePath(e);return await l.Promises.readFile(m)}catch(m){throw this.toFileSystemProviderError(m)}finally{o?.dispose()}}readFileStream(e,r,o){const m=(0,E.newWriteableStream)(S=>T.VSBuffer.concat(S.map(P=>T.VSBuffer.wrap(P))).buffer);return(0,u.readFileIntoStream)(this,e,m,S=>S.buffer,{...r,bufferSize:256*1024},o),m}async writeFile(e,r,o){let m;try{const S=this.toFilePath(e);if(!o.create||!o.overwrite){if(await l.Promises.exists(S)){if(!o.overwrite)throw(0,v.createFileSystemProviderError)((0,d.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,v.createFileSystemProviderError)((0,d.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(e,{create:!0,unlock:o.unlock}),await this.write(m,0,r,0,r.byteLength)}catch(S){throw await this.toFileSystemProviderWriteError(e,S)}finally{typeof m=="number"&&await this.close(m)}}static configureFlushOnWrite(e){i.canFlush=e}async open(e,r){const o=this.toFilePath(e);let m;(0,v.isFileOpenForWriteOptions)(r)&&(m=await this.createResourceLock(e));let S;try{if((0,v.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:k}=await l.SymlinkSupport.stat(o);k.mode&128||await l.Promises.chmod(o,k.mode|128)}catch(k){this.logService.trace(k)}let P;if((0,v.isFileOpenForWriteOptions)(r)){if(w.isWindows)try{await l.Promises.truncate(o,0),P="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}P||(P="w")}else P="r";S=await l.Promises.open(o,P)}catch(P){throw m?.dispose(),(0,v.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(e,P):this.toFileSystemProviderError(P)}if(this.mapHandleToPos.set(S,0),(0,v.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(S,e),m){const P=this.mapHandleToLock.get(S);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${o})`),this.mapHandleToLock.set(S,m),P&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${o})`),P.dispose())}return S}async close(e){const r=this.mapHandleToLock.get(e);try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&i.canFlush)try{await l.Promises.fdatasync(e)}catch(o){i.configureFlushOnWrite(!1),this.logService.error(o)}return await l.Promises.close(e)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(e)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${e}`),this.mapHandleToLock.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${e}`),r.dispose())}}async read(e,r,o,m,S){const P=this.normalizePos(e,r);let k=null;try{k=(await l.Promises.read(e,o,m,S,P)).bytesRead}catch(U){throw this.toFileSystemProviderError(U)}finally{this.updatePos(e,P,k)}return k}normalizePos(e,r){return r===this.mapHandleToPos.get(e)?null:r}updatePos(e,r,o){const m=this.mapHandleToPos.get(e);typeof m=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(e,m+o):this.mapHandleToPos.delete(e)))}async write(e,r,o,m,S){return(0,b.retry)(()=>this.doWrite(e,r,o,m,S),100,3)}async doWrite(e,r,o,m,S){const P=this.normalizePos(e,r);let k=null;try{k=(await l.Promises.write(e,o,m,S,P)).bytesWritten}catch(U){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),U)}finally{this.updatePos(e,P,k)}return k}async mkdir(e){try{await l.Promises.mkdir(this.toFilePath(e))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(e,r){try{const o=this.toFilePath(e);r.recursive?await l.Promises.rm(o,l.RimRafMode.MOVE):await l.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(e,r,o){const m=this.toFilePath(e),S=this.toFilePath(r);if(m!==S)try{await this.validateTargetDeleted(e,r,"move",o.overwrite),await l.Promises.move(m,S)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,d.localize)(2,null,(0,I.basename)(m),(0,I.basename)((0,I.dirname)(S)),P.toString()))),this.toFileSystemProviderError(P)}}async copy(e,r,o){const m=this.toFilePath(e),S=this.toFilePath(r);if(m!==S)try{await this.validateTargetDeleted(e,r,"copy",o.overwrite),await l.Promises.copy(m,S,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,d.localize)(3,null,(0,I.basename)(m),(0,I.basename)((0,I.dirname)(S)),P.toString()))),this.toFileSystemProviderError(P)}}async validateTargetDeleted(e,r,o,m){const S=this.toFilePath(e),P=this.toFilePath(r);let k=!1;if(!!(this.capabilities&1024)||(k=(0,a.isEqual)(S,P,!0)),k&&o==="copy")throw(0,v.createFileSystemProviderError)((0,d.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(!k&&await l.Promises.exists(P)){if(!m)throw(0,v.createFileSystemProviderError)((0,d.localize)(5,null),v.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(e,r){return this.doCloneFile(e,r,!1)}async doCloneFile(e,r,o){const m=this.toFilePath(e),S=this.toFilePath(r),P=!!(this.capabilities&1024);if((0,a.isEqual)(m,S,!P))return;const k=new h.DisposableStore;try{const[U,B]=await Promise.all([this.createResourceLock(e),this.createResourceLock(r)]);k.add(U),k.add(B),o&&await l.Promises.mkdir((0,I.dirname)(S),{recursive:!0}),await l.Promises.copyFile(m,S)}catch(U){if(U.code==="ENOENT"&&!o)return this.doCloneFile(e,r,!0);throw this.toFileSystemProviderError(U)}finally{k.dispose()}}createUniversalWatcher(e,r,o){return new c.UniversalWatcherClient(m=>e(m),m=>r(m),o)}createNonRecursiveWatcher(e,r,o){return new s.NodeJSWatcherClient(m=>e(m),m=>r(m),o)}toFileSystemProviderError(e){if(e instanceof v.FileSystemProviderError)return e;let r;switch(e.code){case"ENOENT":r=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=v.FileSystemProviderErrorCode.NoPermissions;break;default:r=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(e,r)}async toFileSystemProviderWriteError(e,r){let o=this.toFileSystemProviderError(r);if(e&&o.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:m}=await l.SymlinkSupport.stat(this.toFilePath(e));m.mode&128||(o=(0,v.createFileSystemProviderError)(r,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(m){this.logService.trace(m)}return o}}t.DiskFileSystemProvider=i,i.canFlush=!0}),define(Z[116],ee([0,1,11,9]),function($,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=void 0;async function b(p,a,h,I,w){try{const g=await new Promise((l,d)=>{$(["spdlog"],l,d)});g.setFlushOn(C.LogLevel.Trace);const E=await g.createAsyncRotatingLogger(p,a,h,I);return w&&E.clearFormatters(),E}catch(g){console.error(g)}return null}function L(p,a,h){switch(a){case C.LogLevel.Trace:p.trace(h);break;case C.LogLevel.Debug:p.debug(h);break;case C.LogLevel.Info:p.info(h);break;case C.LogLevel.Warning:p.warn(h);break;case C.LogLevel.Error:p.error(h);break;case C.LogLevel.Critical:p.critical(h);break;default:throw new Error("Invalid log level")}}class T extends C.AbstractMessageLogger{constructor(a,h,I,w,g){super();this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(a,h,I,w),this._register(this.onDidChangeLogLevel(E=>{this._logger?.setLevel(E)}))}async _createSpdLogLogger(a,h,I,w){const g=I?6:1,E=30/g*D.ByteSize.MB,l=await b(a,h,E,g,w);if(l){this._logger=l,this._logger.setLevel(this.getLevel());for(const{level:d,message:v}of this.buffer)L(this._logger,d,v);this.buffer=[]}}log(a,h){this._logger?L(this._logger,a,h):this.getLevel()<=a&&this.buffer.push({level:a,message:h})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=T}),define(Z[37],ee([0,1,4,63,2,8]),function($,t,D,C,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullPolicyService=t.AbstractPolicyService=t.IPolicyService=void 0,t.IPolicyService=(0,L.createDecorator)("policy");class T extends b.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(h){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...h,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(h),C.Iterable.reduce(this.policies.entries(),(w,[g,E])=>({...w,[g]:E}),{})}getPolicyValue(h){return this.policies.get(h)}serialize(){return C.Iterable.reduce(Object.entries(this.policyDefinitions),(h,[I,w])=>({...h,[I]:{definition:w,value:this.policies.get(I)}}),{})}}t.AbstractPolicyService=T;class p{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}t.NullPolicyService=p}),define(Z[117],ee([0,1,3,4,63,7,11,9,37]),function($,t,D,C,b,L,T,p,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FilePolicyService=void 0;function h(w,g){const E=[];for(const l of b.Iterable.concat(w.keys(),g.keys()))w.get(l)!==g.get(l)&&E.push(l);return E}let I=class extends a.AbstractPolicyService{constructor(g,E,l){super();this.file=g,this.fileService=E,this.logService=l,this.throttledDelayer=this._register(new D.ThrottledDelayer(500));const d=C.Event.filter(E.onDidFilesChange,v=>v.affects(g));this._register(E.watch(g)),this._register(d(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(g){await this.refresh()}async read(){const g=new Map;try{const E=await this.fileService.readFile(this.file),l=JSON.parse(E.value.toString());if(!(0,L.isObject)(l))throw new Error("Policy file isn't a JSON object");for(const d of Object.keys(l))this.policyDefinitions[d]&&g.set(d,l[d])}catch(E){E.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",E)}return g}async refresh(){const g=await this.read(),E=h(this.policies,g);this.policies=g,E.length>0&&this._onDidChange.fire(E)}};I=fe([te(1,T.IFileService),te(2,p.ILogService)],I),t.FilePolicyService=I}),define(Z[27],ee([0,1,8]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.productSchemaId=t.IProductService=void 0,t.IProductService=(0,D.createDecorator)("productService"),t.productSchemaId="vscode://schemas/vscode-product"}),define(Z[33],ee([0,1,68,7]),function($,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class b{constructor(){this.data=new Map}add(T,p){D.ok(C.isString(T)),D.ok(C.isObject(p)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,p)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new b}),define(Z[118],ee([0,1,4,33]),function($,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function b(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class L{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(a,h){this.schemasById[b(a)]=h,this._onDidChangeSchema.fire(a)}notifySchemaChanged(a){this._onDidChangeSchema.fire(a)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new L;C.Registry.add(t.Extensions.JSONContribution,T)}),define(Z[40],ee([0,1,19,4,7,84,21,118,33]),function($,t,D,C,b,L,T,p,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.keyFromOverrideIdentifiers=t.overrideIdentifiersFromKey=t.OVERRIDE_PROPERTY_REGEX=t.OVERRIDE_PROPERTY_PATTERN=t.configurationDefaultsSchemaId=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var h;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(h=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var I;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",t.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=a.Registry.as(p.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,n=!0){this.registerConfigurations([i],n)}registerConfigurations(i,n=!0){const e=this.doRegisterConfigurations(i,n);w.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e})}deregisterConfigurations(i){const n=this.doDeregisterConfigurations(i);w.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:i,remove:n}){const e=[];e.push(...this.doDeregisterConfigurations(n)),e.push(...this.doRegisterConfigurations(i,!1)),w.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(e)})}registerDefaultConfigurations(i){const n=[],e=[];for(const{overrides:r,source:o}of i)for(const m in r)if(n.push(m),t.OVERRIDE_PROPERTY_REGEX.test(m)){const S=this.configurationDefaultsOverrides.get(m),P=S?.valuesSources??new Map;if(o)for(const q of Object.keys(r[m]))P.set(q,o);const k={...S?.value||{},...r[m]};this.configurationDefaultsOverrides.set(m,{source:o,value:k,valuesSources:P});const U=(0,T.getLanguageTagSettingPlainKey)(m),B={type:"object",default:k,description:L.localize(1,null,U),$ref:t.resourceLanguageSettingsSchemaId,defaultDefaultValue:k,source:b.isString(o)?void 0:o,defaultValueSource:o};e.push(...d(m)),this.configurationProperties[m]=B,this.defaultLanguageConfigurationOverridesNode.properties[m]=B}else{this.configurationDefaultsOverrides.set(m,{value:r[m],source:o});const S=this.configurationProperties[m];S&&(this.updatePropertyDefaultValue(m,S),this.updateSchema(m,S))}this.registerOverrideIdentifiers(e),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const n=[];for(const{overrides:e,source:r}of i)for(const o in e){const m=this.configurationDefaultsOverrides.get(o),S=b.isString(r)?r:r?.id,P=b.isString(m?.source)?m?.source:m?.source?.id;if(S===P)if(n.push(o),this.configurationDefaultsOverrides.delete(o),t.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const k=this.configurationProperties[o];k&&(this.updatePropertyDefaultValue(o,k),this.updateSchema(o,k))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const n of i)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,n){const e=[];return i.forEach(r=>{e.push(...this.validateAndRegisterProperties(r,n,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),e}doDeregisterConfigurations(i){const n=[],e=r=>{if(r.properties)for(const o in r.properties){n.push(o);const m=this.configurationProperties[o];m?.policy?.name&&this.policyConfigurations.delete(m.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>e(o))};for(const r of i){e(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return n}validateAndRegisterProperties(i,n=!0,e,r,o=3){o=b.isUndefinedOrNull(i.scope)?o:i.scope;const m=[],S=i.properties;if(S)for(const k in S){const U=S[k];if(n&&y(k,U)){delete S[k];continue}if(U.source=e,U.defaultDefaultValue=S[k].default,this.updatePropertyDefaultValue(k,U),t.OVERRIDE_PROPERTY_REGEX.test(k)?U.scope=void 0:(U.scope=b.isUndefinedOrNull(U.scope)?o:U.scope,U.restricted=b.isUndefinedOrNull(U.restricted)?!!r?.includes(k):U.restricted),S[k].hasOwnProperty("included")&&!S[k].included){this.excludedConfigurationProperties[k]=S[k],delete S[k];continue}else this.configurationProperties[k]=S[k],S[k].policy?.name&&this.policyConfigurations.set(S[k].policy.name,k);!S[k].deprecationMessage&&S[k].markdownDeprecationMessage&&(S[k].deprecationMessage=S[k].markdownDeprecationMessage),m.push(k)}const P=i.allOf;if(P)for(const k of P)m.push(...this.validateAndRegisterProperties(k,n,e,r,o));return m}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const n=e=>{const r=e.properties;if(r)for(const m in r)this.updateSchema(m,r[m]);e.allOf?.forEach(n)};n(i)}updateSchema(i,n){switch(t.allSettings.properties[i]=n,n.scope){case 1:t.applicationSettings.properties[i]=n;break;case 2:t.machineSettings.properties[i]=n;break;case 6:t.machineOverridableSettings.properties[i]=n;break;case 3:t.windowSettings.properties[i]=n;break;case 4:t.resourceSettings.properties[i]=n;break;case 5:t.resourceSettings.properties[i]=n,this.resourceLanguageSettingsSchema.properties[i]=n;break}}removeFromSchema(i,n){switch(delete t.allSettings.properties[i],n.scope){case 1:delete t.applicationSettings.properties[i];break;case 2:delete t.machineSettings.properties[i];break;case 6:delete t.machineOverridableSettings.properties[i];break;case 3:delete t.windowSettings.properties[i];break;case 4:case 5:delete t.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const n=`[${i}]`,e={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,e),t.allSettings.properties[n]=e,t.applicationSettings.properties[n]=e,t.machineSettings.properties[n]=e,t.machineOverridableSettings.properties[n]=e,t.windowSettings.properties[n]=e,t.resourceSettings.properties[n]=e}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:t.resourceLanguageSettingsSchemaId};t.allSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.applicationSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.machineSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.machineOverridableSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.windowSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.resourceSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,n){const e=this.configurationDefaultsOverrides.get(i);let r=e?.value,o=e?.source;b.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),b.isUndefined(r)&&(r=u(n.type)),n.default=r,n.defaultValueSource=o}}const E="\\[([^\\]]+)\\]",l=new RegExp(E,"g");t.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,t.OVERRIDE_PROPERTY_REGEX=new RegExp(t.OVERRIDE_PROPERTY_PATTERN);function d(s){const i=[];if(t.OVERRIDE_PROPERTY_REGEX.test(s)){let n=l.exec(s);for(;n?.length;){const e=n[1].trim();e&&i.push(e),n=l.exec(s)}}return(0,D.distinct)(i)}t.overrideIdentifiersFromKey=d;function v(s){return s.reduce((i,n)=>`${i}[${n}]`,"")}t.keyFromOverrideIdentifiers=v;function u(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=u;const f=new g;a.Registry.add(t.Extensions.Configuration,f);function y(s,i){return s.trim()?t.OVERRIDE_PROPERTY_REGEX.test(s)?L.localize(7,null,s):f.getConfigurationProperties()[s]!==void 0?L.localize(8,null,s):i.policy?.name&&f.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,s,i.policy?.name,f.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}t.validateProperty=y;function c(){const s=[],i=f.getConfigurationProperties();for(const n of Object.keys(i))s.push([n,i[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}t.getScopes=c}),define(Z[64],ee([0,1,19,4,51,2,36,24,7,10,21,40,33]),function($,t,D,C,b,L,T,p,a,h,I,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.ConfigurationModel=void 0;class E{constructor(n={},e=[],r=[]){this._contents=n,this._keys=e,this._overrides=r,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,e){const r=this.getContentsForOverrideIdentifer(e);return r?n?(0,I.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const e=[];for(const r of this.overrides)r.identifiers.includes(n)&&e.push(...r.keys);return D.distinct(e)}getAllOverrideIdentifiers(){const n=[];for(const e of this.overrides)n.push(...e.identifiers);return D.distinct(n)}override(n){let e=this.overrideConfigurations.get(n);return e||(e=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,e)),e}merge(...n){const e=p.deepClone(this.contents),r=p.deepClone(this.overrides),o=[...this.keys];for(const m of n)if(!m.isEmpty()){this.mergeContents(e,m.contents);for(const S of m.overrides){const[P]=r.filter(k=>D.equals(k.identifiers,S.identifiers));P?(this.mergeContents(P.contents,S.contents),P.keys.push(...S.keys),P.keys=D.distinct(P.keys)):r.push(p.deepClone(S))}for(const S of m.keys)o.indexOf(S)===-1&&o.push(S)}return new E(e,o,r)}freeze(){return this.frozen=!0,this}clone(){return new E(p.deepClone(this.contents),[...this.keys],p.deepClone(this.overrides))}createOverrideConfigurationModel(n){const e=this.getContentsForOverrideIdentifer(n);if(!e||typeof e!="object"||!Object.keys(e).length)return this;const r={};for(const o of D.distinct([...Object.keys(this.contents),...Object.keys(e)])){let m=this.contents[o];const S=e[o];S&&(typeof m=="object"&&typeof S=="object"?(m=p.deepClone(m),this.mergeContents(m,S)):m=S),r[o]=m}return new E(r,this.keys,this.overrides)}mergeContents(n,e){for(const r of Object.keys(e)){if(r in n&&a.isObject(n[r])&&a.isObject(e[r])){this.mergeContents(n[r],e[r]);continue}n[r]=p.deepClone(e[r])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?p.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let e=null,r=null;const o=m=>{m&&(r?this.mergeContents(r,m):r=p.deepClone(m))};for(const m of this.overrides)D.equals(m.identifiers,[n])?e=m.contents:m.identifiers.includes(n)&&o(m.contents);return o(e),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,e){this.addKey(n),(0,I.addToValueTree)(this.contents,n,e,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,I.removeFromValueTree)(this.contents,n)}addKey(n){let e=this.keys.length;for(let r=0;r<e;r++)n.indexOf(this.keys[r])===0&&(e=r);this.keys.splice(e,1,n)}removeKey(n){const e=this.keys.indexOf(n);return e!==-1?(this.keys.splice(e,1),!0):!1}}t.ConfigurationModel=E;class l{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,e){if(!a.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,e)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,e){this._raw=n;const{contents:r,keys:o,overrides:m,restricted:S}=this.doParseRaw(n,e);this._configurationModel=new E(r,o,m),this._restrictedConfigurations=S||[]}doParseContent(n){let e={},r=null,o=[];const m=[],S=[];function P(U){Array.isArray(o)?o.push(U):r!==null&&(o[r]=U)}const k={onObjectBegin:()=>{const U={};P(U),m.push(o),o=U,r=null},onObjectProperty:U=>{r=U},onObjectEnd:()=>{o=m.pop()},onArrayBegin:()=>{const U=[];P(U),m.push(o),o=U,r=null},onArrayEnd:()=>{o=m.pop()},onLiteralValue:P,onError:(U,B,q)=>{S.push({error:U,offset:B,length:q})}};if(n)try{b.visit(n,k),e=o[0]||{}}catch(U){console.error(`Error while parsing settings file ${this._name}: ${U}`),this._parseErrors=[U]}return e}doParseRaw(n,e){const r=g.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,r,!0,e);n=o.raw;const m=(0,I.toValuesTree)(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),S=Object.keys(n),P=this.toOverrides(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:m,keys:S,overrides:P,restricted:o.restricted}}filter(n,e,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[]};const m={},S=[];for(const P in n)if(w.OVERRIDE_PROPERTY_REGEX.test(P)&&r){const k=this.filter(n[P],e,!1,o);m[P]=k.raw,S.push(...k.restricted)}else{const k=e[P],U=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&S.push(P),(U===void 0||o.scopes===void 0||o.scopes.includes(U))&&(o.skipRestricted&&k?.restricted||(m[P]=n[P]))}return{raw:m,restricted:S}}toOverrides(n,e){const r=[];for(const o of Object.keys(n))if(w.OVERRIDE_PROPERTY_REGEX.test(o)){const m={};for(const S in n[o])m[S]=n[o][S];r.push({identifiers:(0,w.overrideIdentifiersFromKey)(o),keys:Object.keys(m),contents:(0,I.toValuesTree)(m,e)})}return r}}t.ConfigurationModelParser=l;class d extends L.Disposable{constructor(n,e,r,o){super();this.userSettingsResource=n,this.scopes=e,this.fileService=o,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,m=>m.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,m=>(m.isOperation(0)||m.isOperation(3)||m.isOperation(1)||m.isOperation(4))&&r.isEqual(m.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=d;class v{constructor(n,e,r,o,m=new E,S=new E,P=new T.ResourceMap,k=new E,U=new T.ResourceMap,B=!0){this._defaultConfiguration=n,this._policyConfiguration=e,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=m,this._workspaceConfiguration=S,this._folderConfigurations=P,this._memoryConfiguration=k,this._memoryConfigurationByResource=U,this._freeze=B,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(n,e,r){return this.getConsolidatedConfigurationModel(n,e,r).getValue(n)}updateValue(n,e,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new E,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,e===void 0?o.removeValue(n):o.setValue(n,e),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,e,r){const o=this.getConsolidatedConfigurationModel(n,e,r),m=this.getFolderConfigurationModelForResource(e.resource,r),S=e.resource?this._memoryConfigurationByResource.get(e.resource)||this._memoryConfiguration:this._memoryConfiguration,P=e.overrideIdentifier?this._defaultConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),k=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),U=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),B=e.overrideIdentifier?this.userConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),q=e.overrideIdentifier?this.localUserConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),Y=e.overrideIdentifier?this.remoteUserConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),ne=r?e.overrideIdentifier?this._workspaceConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,ce=m?e.overrideIdentifier?m.freeze().override(e.overrideIdentifier).getValue(n):m.freeze().getValue(n):void 0,re=e.overrideIdentifier?S.override(e.overrideIdentifier).getValue(n):S.getValue(n),ge=o.getValue(n),ae=D.distinct(o.overrides.map(N=>N.identifiers).flat()).filter(N=>o.getOverrideValue(n,N)!==void 0);return{defaultValue:P,policyValue:k,applicationValue:U,userValue:B,userLocalValue:q,userRemoteValue:Y,workspaceValue:ne,workspaceFolderValue:ce,memoryValue:re,value:ge,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,policy:k!==void 0?{value:k}:void 0,application:U!==void 0?{value:U,override:e.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,user:B!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,userLocal:q!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,userRemote:Y!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,workspace:ne!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,workspaceFolder:ce!==void 0?{value:m?.freeze().getValue(n),override:e.overrideIdentifier?m?.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,memory:re!==void 0?{value:S.getValue(n),override:e.overrideIdentifier?S.getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ae.length?ae:void 0}}keys(n){const e=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:e?e.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,e){this._folderConfigurations.set(n,e),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,e){const r=[];if(!e){const{added:o,updated:m,removed:S}=c(this._defaultConfiguration,n);e=[...o,...m,...S]}for(const o of e)for(const m of(0,w.overrideIdentifiersFromKey)(o)){const S=this._defaultConfiguration.getKeysForOverrideIdentifier(m),P=n.getKeysForOverrideIdentifier(m),k=[...P.filter(U=>S.indexOf(U)===-1),...S.filter(U=>P.indexOf(U)===-1),...S.filter(U=>!p.equals(this._defaultConfiguration.override(m).getValue(U),n.override(m).getValue(U)))];r.push([m,k])}return this.updateDefaultConfiguration(n),{keys:e,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:e,updated:r,removed:o}=c(this._policyConfiguration,n),m=[...e,...r,...o];return m.length&&this.updatePolicyConfiguration(n),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:e,updated:r,removed:o,overrides:m}=c(this.applicationConfiguration,n),S=[...e,...r,...o];return S.length&&this.updateApplicationConfiguration(n),{keys:S,overrides:m}}compareAndUpdateLocalUserConfiguration(n){const{added:e,updated:r,removed:o,overrides:m}=c(this.localUserConfiguration,n),S=[...e,...r,...o];return S.length&&this.updateLocalUserConfiguration(n),{keys:S,overrides:m}}compareAndUpdateRemoteUserConfiguration(n){const{added:e,updated:r,removed:o,overrides:m}=c(this.remoteUserConfiguration,n),S=[...e,...r,...o];return S.length&&this.updateRemoteUserConfiguration(n),{keys:S,overrides:m}}compareAndUpdateWorkspaceConfiguration(n){const{added:e,updated:r,removed:o,overrides:m}=c(this.workspaceConfiguration,n),S=[...e,...r,...o];return S.length&&this.updateWorkspaceConfiguration(n),{keys:S,overrides:m}}compareAndUpdateFolderConfiguration(n,e){const r=this.folderConfigurations.get(n),{added:o,updated:m,removed:S,overrides:P}=c(r,e),k=[...o,...m,...S];return(k.length||!r)&&this.updateFolderConfiguration(n,e),{keys:k,overrides:P}}compareAndDeleteFolderConfiguration(n){const e=this.folderConfigurations.get(n);if(!e)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:m,overrides:S}=c(e,void 0);return{keys:[...r,...o,...m],overrides:S}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,e,r){let o=this.getConsolidatedConfigurationModelForResource(e,r);return e.overrideIdentifier&&(o=o.override(e.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:n},e){let r=this.getWorkspaceConsolidatedConfiguration();if(e&&n){const o=e.getFolder(n);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const m=this._memoryConfigurationByResource.get(n);m&&(r=r.merge(m))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let e=this._foldersConsolidatedConfigurations.get(n);if(!e){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(e=r.merge(o),this._freeze&&(e=e.freeze()),this._foldersConsolidatedConfigurations.set(n,e)):e=r}return e}getFolderConfigurationModelForResource(n,e){if(e&&n){const r=e.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,e)=>{const{contents:r,overrides:o,keys:m}=this._folderConfigurations.get(e);return n.push([e,{contents:r,overrides:o,keys:m}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(e=>n.add(e)),this.userConfiguration.freeze().keys.forEach(e=>n.add(e)),this._workspaceConfiguration.freeze().keys.forEach(e=>n.add(e)),this._folderConfigurations.forEach(e=>e.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(e=>n.add(e)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(e=>n.add(e)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(e=>n.add(e)),this._folderConfigurations.forEach(e=>e.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const e=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>e.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>e.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>e.add(o))),[...e.values()]}static parse(n){const e=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.policy),o=this.parseConfigurationModel(n.application),m=this.parseConfigurationModel(n.user),S=this.parseConfigurationModel(n.workspace),P=n.folders.reduce((k,U)=>(k.set(h.URI.revive(U[0]),this.parseConfigurationModel(U[1])),k),new T.ResourceMap);return new v(e,r,o,m,new E,S,P,new E,new T.ResourceMap,!1)}static parseConfigurationModel(n){return new E(n.contents,n.keys,n.overrides).freeze()}}t.Configuration=v;function u(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const n=new Set,e=new Map;for(const o of i)o.keys.forEach(m=>n.add(m)),o.overrides.forEach(([m,S])=>{const P=(0,T.getOrSet)(e,m,new Set);S.forEach(k=>P.add(k))});const r=[];return e.forEach((o,m)=>r.push([m,[...o.values()]])),{keys:[...n.values()],overrides:r}}t.mergeChanges=u;class f{constructor(n,e,r,o){this.change=n,this.previous=e,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const m=new Set;n.keys.forEach(P=>m.add(P)),n.overrides.forEach(([,P])=>P.forEach(k=>m.add(k))),this.affectedKeys=[...m.values()];const S=new E;this.affectedKeys.forEach(P=>S.setValue(P,{})),this.affectedKeysTree=S.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,e){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(e){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,e,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,e,this.currentWorkspace);return!p.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(n,e){let r=(0,I.toValuesTree)({[e]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}t.ConfigurationChangeEvent=f;class y extends f{constructor(n,e,r,o){super({keys:n.allKeys(),overrides:[]},void 0,n,e);this.source=r,this.sourceConfig=o}}t.AllKeysConfigurationChangeEvent=y;function c(i,n){const{added:e,removed:r,updated:o}=s(n,i),m=[],S=i?.getAllOverrideIdentifiers()||[],P=n?.getAllOverrideIdentifiers()||[];if(n){const k=P.filter(U=>!S.includes(U));for(const U of k)m.push([U,n.getKeysForOverrideIdentifier(U)])}if(i){const k=S.filter(U=>!P.includes(U));for(const U of k)m.push([U,i.getKeysForOverrideIdentifier(U)])}if(n&&i){for(const k of S)if(P.includes(k)){const U=s({contents:i.getOverrideValue(void 0,k)||{},keys:i.getKeysForOverrideIdentifier(k)},{contents:n.getOverrideValue(void 0,k)||{},keys:n.getKeysForOverrideIdentifier(k)});m.push([k,[...U.added,...U.removed,...U.updated]])}}return{added:e,removed:r,updated:o,overrides:m}}function s(i,n){const e=i?n?i.keys.filter(m=>n.keys.indexOf(m)===-1):[...i.keys]:[],r=n?i?n.keys.filter(m=>i.keys.indexOf(m)===-1):[...n.keys]:[],o=[];if(i&&n){for(const m of n.keys)if(i.keys.indexOf(m)!==-1){const S=(0,I.getConfigurationValue)(n.contents,m),P=(0,I.getConfigurationValue)(i.contents,m);p.equals(S,P)||o.push(m)}}return{added:e,removed:r,updated:o}}}),define(Z[119],ee([0,1,19,4,2,24,7,21,64,40,9,37,33]),function($,t,D,C,b,L,T,p,a,h,I,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PolicyConfiguration=t.NullPolicyConfiguration=t.DefaultConfigurationModel=t.DefaultConfiguration=void 0;class E extends b.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new l(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(g.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:y})=>this.onDidUpdateConfiguration(f,y))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(f,y){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:f})}getConfigurationDefaultOverrides(){return{}}}t.DefaultConfiguration=E;class l extends a.ConfigurationModel{constructor(f={}){const y=g.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(y),s=Object.create(null),i=[];for(const n in y){const e=f[n],r=e!==void 0?e:y[n].default;(0,p.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))h.OVERRIDE_PROPERTY_REGEX.test(n)&&i.push({identifiers:(0,h.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,p.toValuesTree)(s[n],e=>console.error(`Conflict in default settings file: ${e}`))});super(s,c,i)}}t.DefaultConfigurationModel=l;class d{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=new a.ConfigurationModel}async initialize(){return this.configurationModel}}t.NullPolicyConfiguration=d;let v=class extends b.Disposable{constructor(f,y,c){super();this.defaultConfiguration=f,this.policyService=y,this.logService=c,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new a.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(f=>this.onDidChangePolicies(f))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:f})=>this.update(await this.registerPolicyDefinitions(f),!0))),this._configurationModel}async registerPolicyDefinitions(f){const y={},c=[],s=g.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const i of f){const n=s[i];if(!n){c.push(i);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}c.push(i),y[n.policy.name]={type:n.type}}}return(0,T.isEmptyObject)(y)||await this.policyService.registerPolicyDefinitions(y),c}onDidChangePolicies(f){const y=g.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),c=(0,D.coalesce)(f.map(s=>y.get(s)));this.update(c,!0)}update(f,y){const c=g.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),s=[],i=this._configurationModel.isEmpty();for(const n of f){const e=c[n]?.policy?.name;if(e){const r=this.policyService.getPolicyValue(e);(i?r!==void 0:!(0,L.equals)(this._configurationModel.getValue(n),r))&&s.push([n,r])}else this._configurationModel.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this._configurationModel;this._configurationModel=new a.ConfigurationModel;for(const e of n.keys)this._configurationModel.setValue(e,n.getValue(e));for(const[e,r]of s)r===void 0?this._configurationModel.removeValue(e):this._configurationModel.setValue(e,r);y&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};v=fe([te(1,w.IPolicyService),te(2,I.ILogService)],v),t.PolicyConfiguration=v}),define(Z[120],ee([0,1,3,4,2,17,21,64,119,37]),function($,t,D,C,b,L,T,p,a,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class I extends b.Disposable{constructor(g,E,l,d){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new a.DefaultConfiguration),this.policyConfiguration=l instanceof h.NullPolicyService?new a.NullPolicyConfiguration:this._register(new a.PolicyConfiguration(this.defaultConfiguration,l,d)),this.userConfiguration=this._register(new p.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,E)),this.configuration=new p.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new p.ConfigurationModel,new p.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:v,properties:u})=>this.onDidDefaultConfigurationChange(v,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(v=>this.onDidPolicyConfigurationChange(v))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[g,E,l]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new p.Configuration(g,E,new p.ConfigurationModel,l)}getConfigurationData(){return this.configuration.toData()}getValue(g,E){const l=typeof g=="string"?g:void 0,d=(0,T.isConfigurationOverrides)(g)?g:(0,T.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(l,d,void 0)}updateValue(g,E,l,d){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const E=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(l,E,2)}onDidDefaultConfigurationChange(g,E){const l=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(g,E);this.trigger(d,l,7)}onDidPolicyConfigurationChange(g){const E=this.configuration.toData(),l=this.configuration.compareAndUpdatePolicyConfiguration(g);this.trigger(l,E,7)}trigger(g,E,l){const d=new p.ConfigurationChangeEvent(g,{data:E},this.configuration);d.source=l,d.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(g){switch(g){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=I}),define(Z[121],ee([0,1,16]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseAuthorityWithOptionalPort=t.parseAuthorityWithPort=t.getRemoteServerRootPath=t.getRemoteName=t.getRemoteAuthority=void 0;function C(h){return h.scheme===D.Schemas.vscodeRemote?h.authority:void 0}t.getRemoteAuthority=C;function b(h){if(!h)return;const I=h.indexOf("+");return I<0?h:h.substr(0,I)}t.getRemoteName=b;function L(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}t.getRemoteServerRootPath=L;function T(h){const{host:I,port:w}=a(h);if(typeof w=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:w}}t.parseAuthorityWithPort=T;function p(h,I){let{host:w,port:g}=a(h);return typeof g=="undefined"&&(g=I),{host:w,port:g}}t.parseAuthorityWithOptionalPort=p;function a(h){const I=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const w=h.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const g=h.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:h,port:void 0}}}),define(Z[34],ee([0,1,31,8,121]),function($,t,D,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.isApplicationScopedExtension=t.ExtensionIdentifier=t.TargetPlatform=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.UNDEFINED_PUBLISHER=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.UNDEFINED_PUBLISHER="undefined_publisher",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}t.getWorkspaceSupportTypeMessage=L;function T(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}t.isIExtensionIdentifier=T,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var p;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(p=t.ExtensionType||(t.ExtensionType={}));var a;(function(l){l.WIN32_X64="win32-x64",l.WIN32_IA32="win32-ia32",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(a=t.TargetPlatform||(t.TargetPlatform={}));class h{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,v){if(typeof d=="undefined"||d===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof d=="string"||typeof v=="string"){const u=typeof d=="string"?d:d.value,f=typeof v=="string"?v:v.value;return D.equalsIgnoreCase(u,f)}return d._lower===v._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}t.ExtensionIdentifier=h;function I(l){return w(l)}t.isApplicationScopedExtension=I;function w(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}t.isLanguagePackExtension=w;function g(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=g;function E(l,d){if(d){const v=`onResolveRemoteAuthority:${(0,b.getRemoteName)(d)}`;return l.activationEvents?.indexOf(v)!==-1}return!1}t.isResolverExtension=E,t.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[23],ee([0,1,31,22,34,13,10,12,32]),function($,t,D,C,b,L,T,p,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeTargetPlatform=t.isAlpineLinux=t.getExtensionDependencies=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.getIdAndVersion=t.ExtensionKey=t.areSameExtensions=void 0;function h(n,e){return n.uuid&&e.uuid?n.uuid===e.uuid:n.id===e.id?!0:(0,D.compareIgnoreCase)(n.id,e.id)===0}t.areSameExtensions=h;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{constructor(e,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=e.id}static create(e){const r=e.manifest?e.manifest.version:e.version,o=e.manifest?e.targetPlatform:e.properties.targetPlatform;return new w(e.identifier,r,o)}static parse(e){const r=I.exec(e);return r&&r[1]&&r[2]?new w({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(e){return e instanceof w?h(this,e)&&this.version===e.version&&this.targetPlatform===e.targetPlatform:!1}}t.ExtensionKey=w;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(n){const e=g.exec(n);return e&&e[1]?[d(e[1]),e[2]]:[d(n),void 0]}t.getIdAndVersion=E;function l(n,e){return`${n}.${e}`}t.getExtensionId=l;function d(n){return n.toLocaleLowerCase()}t.adoptToGalleryExtensionId=d;function v(n,e){return d(l(n,e))}t.getGalleryExtensionId=v;function u(n,e){const r=[],o=m=>{for(const S of r)if(S.some(P=>h(e(P),e(m))))return S;return null};for(const m of n){const S=o(m);S?S.push(m):r.push([m])}return r}t.groupByExtension=u;function f(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=f;function y(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),...n.telemetryData}}t.getGalleryExtensionTelemetryData=y,t.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function c(n,e){const r=[],o=e.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const m=o.shift();if(m&&r.every(S=>!h(S.identifier,{id:m}))){const S=n.filter(P=>h(P.identifier,{id:m}));S.length===1&&(r.push(S[0]),o.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}t.getExtensionDependencies=c;async function s(n,e){if(!L.isLinux)return!1;let r;try{r=(await n.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){e.debug("Error while getting the os-release file.",(0,p.getErrorMessage)(m))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}t.isAlpineLinux=s;async function i(n,e){const r=await s(n,e),o=(0,C.getTargetPlatform)(r?"alpine":L.platform,a.arch);return e.debug("ComputeTargetPlatform:",o),o}t.computeTargetPlatform=i}),define(Z[122],ee([0,1,25,12,16,17,39,10,87,22,23,34]),function($,t,D,C,b,L,T,p,a,h,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=void 0;const g=v=>(0,a.localize)(0,null,v),E=(0,a.localize)(1,null,"ms-dotnettools.csharp");function l(v,u){return u?`${v.publisher}.${v.name}@${v.version}`:`${v.publisher}.${v.name}`}let d=class{constructor(u,f){this.extensionManagementService=u,this.extensionGalleryService=f}get location(){}async listExtensions(u,f,y=console){let c=await this.extensionManagementService.getInstalled(1);const s=w.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(f&&f!==""){if(s.indexOf(f.toLowerCase())<0){y.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}c=c.filter(n=>n.manifest.categories?n.manifest.categories.map(r=>r.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){y.log("Possible Categories: "),s.forEach(n=>{y.log(n)});return}this.location&&y.log((0,a.localize)(2,null,this.location)),c=c.sort((n,e)=>n.identifier.id.localeCompare(e.identifier.id));let i;for(const n of c)i!==n.identifier.id&&(i=n.identifier.id,y.log(l(n.manifest,u)))}async installExtensions(u,f,y,c,s=console){const i=[],n=[];u.length&&s.log(this.location?(0,a.localize)(3,null,this.location):(0,a.localize)(4,null));const e=await this.extensionManagementService.getInstalled(1),r=(P,k)=>{const U=e.find(B=>(0,I.areSameExtensions)(B.identifier,{id:P}));if(U){if(!c&&(!k||k==="prerelease"&&U.preRelease))return s.log((0,a.localize)(5,null,P,U.manifest.version,P)),!1;if(k&&U.manifest.version===k)return s.log((0,a.localize)(6,null,`${P}@${k}`)),!1}return!0},o=(P,k,U)=>{S.push({id:P,version:k!=="prerelease"?k:void 0,installOptions:{...y,isBuiltin:U,installPreReleaseVersion:k==="prerelease"||y.installPreReleaseVersion}})},m=[],S=[];for(const P of u)if(P instanceof p.URI)m.push(P);else{const[k,U]=(0,I.getIdAndVersion)(P);r(k,U)&&o(k,U,!1)}for(const P of f){const[k,U]=(0,I.getIdAndVersion)(P);r(k,U)&&o(k,U,!0)}if(m.length&&await Promise.all(m.map(async P=>{try{const k=await this.installVSIX(P,{...y,isBuiltin:!1},c,s);k&&n.push(k)}catch(k){s.error(k.message||k.stack||k),i.push(P.toString())}})),S.length){const P=await this.getGalleryExtensions(S);await Promise.all(S.map(async k=>{const U=P.get(k.id.toLowerCase());if(U)try{const B=await this.installFromGallery(k,U,e,c,s);B&&n.push(B)}catch(B){s.error(B.message||B.stack||B),i.push(k.id)}else s.error(`${g(k.version?`${k.id}@${k.version}`:k.id)}
${E}`),i.push(k.id)}))}if(i.length)throw new Error((0,a.localize)(7,null,i.join(", ")))}async installVSIX(u,f,y,c){const s=await this.extensionManagementService.getManifest(u);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,y,c))try{return await this.extensionManagementService.install(u,f),c.log((0,a.localize)(8,null,(0,L.basename)(u))),s}catch(n){if((0,C.isCancellationError)(n))return c.log((0,a.localize)(9,null,(0,L.basename)(u))),null;throw n}return null}async getGalleryExtensions(u){const f=new Map,y=u.some(s=>s.installOptions.installPreReleaseVersion),c=await this.extensionGalleryService.getExtensions(u.map(s=>({...s,preRelease:y})),D.CancellationToken.None);for(const s of c)f.set(s.identifier.id.toLowerCase(),s);return f}async installFromGallery({id:u,version:f,installOptions:y},c,s,i,n){const e=await this.extensionGalleryService.getManifest(c,D.CancellationToken.None);if(e&&!this.validateExtensionKind(e,n))return null;const r=s.find(o=>(0,I.areSameExtensions)(o.identifier,c.identifier));if(r){if(c.version===r.manifest.version)return n.log((0,a.localize)(10,null,f?`${u}@${f}`:u)),null;n.log((0,a.localize)(11,null,u,c.version))}try{y.isBuiltin?n.log(f?(0,a.localize)(12,null,u,f):(0,a.localize)(13,null,u)):n.log(f?(0,a.localize)(14,null,u,f):(0,a.localize)(15,null,u));const o=await this.extensionManagementService.installFromGallery(c,{...y,installGivenVersion:!!f});return n.log((0,a.localize)(16,null,u,o.manifest.version)),e}catch(o){if((0,C.isCancellationError)(o))return n.log((0,a.localize)(17,null,u)),null;throw o}}validateExtensionKind(u,f){return!0}async validateVSIX(u,f,y){const c={id:(0,I.getGalleryExtensionId)(u.publisher,u.name)},i=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,I.areSameExtensions)(c,n.identifier)&&(0,T.gt)(n.manifest.version,u.version));return i&&!f?(y.log((0,a.localize)(18,null,i.identifier.id,i.manifest.version,u.version)),!1):this.validateExtensionKind(u,y)}async uninstallExtensions(u,f,y=console){const c=async i=>{if(i instanceof p.URI){const n=await this.extensionManagementService.getManifest(i);return l(n)}return i},s=[];for(const i of u){const n=await c(i),r=(await this.extensionManagementService.getInstalled()).filter(o=>(0,I.areSameExtensions)(o.identifier,{id:n}));if(!r.length)throw new Error(`${this.notInstalled(n)}
${E}`);if(r.some(o=>o.type===0)){y.log((0,a.localize)(19,null,n));return}if(!f&&r.some(o=>o.isBuiltin)){y.log((0,a.localize)(20,null,n));return}y.log((0,a.localize)(21,null,n));for(const o of r)await this.extensionManagementService.uninstall(o),s.push(o);this.location?y.log((0,a.localize)(22,null,n,this.location)):y.log((0,a.localize)(23,null,n))}}async locateExtension(u,f=console){const y=await this.extensionManagementService.getInstalled();u.forEach(c=>{y.forEach(s=>{if(s.identifier.id===c&&s.location.scheme===b.Schemas.file){f.log(s.location.fsPath);return}})})}notInstalled(u){return this.location?(0,a.localize)(24,null,u,this.location):(0,a.localize)(25,null,u)}};d=fe([te(0,h.IExtensionManagementService),te(1,h.IExtensionGalleryService)],d),t.ExtensionManagementCLIService=d}),define(Z[41],ee([0,1,3,15,2,36,10,23,11,8,9]),function($,t,D,C,b,L,T,p,a,h,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsProfileScannerService=t.IExtensionsProfileScannerService=void 0,t.IExtensionsProfileScannerService=(0,h.createDecorator)("IExtensionsProfileScannerService");let w=class extends b.Disposable{constructor(E,l){super();this.fileService=E,this.logService=l,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(E){return this.withProfileExtensions(E)}addExtensionsToProfile(E,l){return this.withProfileExtensions(l,d=>(d=d.filter(v=>E.some(([u])=>!(0,p.areSameExtensions)(v.identifier,u.identifier))),d.push(...E.map(([v,u])=>({identifier:v.identifier,version:v.manifest.version,location:v.location,metadata:u}))),d))}removeExtensionFromProfile(E,l){return this.withProfileExtensions(l,d=>d.filter(v=>!(0,p.areSameExtensions)(v.identifier,E)))}async withProfileExtensions(E,l){return this.getResourceAccessQueue(E).queue(async()=>{let d=[];try{const v=await this.fileService.readFile(E),u=JSON.parse(v.value.toString());for(const f of u){if(!f.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",f);continue}if(!f.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",f);continue}if(!f.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",f);continue}d.push({identifier:f.identifier,location:T.URI.revive(f.location),version:f.version,metadata:f.metadata})}}catch(v){v.fileOperationResult!==1&&this.logService.error(v)}if(l){d=l(d);const v=d.map(u=>({identifier:u.identifier,version:u.version,location:u.location.toJSON(),metadata:u.metadata}));await this.fileService.writeFile(E,C.VSBuffer.fromString(JSON.stringify(v)))}return d})}getResourceAccessQueue(E){let l=this.resourcesAccessQueueMap.get(E);return l||(l=new D.Queue,this.resourcesAccessQueueMap.set(E,l)),l}};w=fe([te(0,a.IFileService),te(1,I.ILogService)],w),t.ExtensionsProfileScannerService=w}),define(Z[123],ee([0,1,3,12,2,13,17,39,10,29,20,18,22,23,11,9]),function($,t,D,C,b,L,T,p,a,h,I,w,g,E,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;let v=class extends b.Disposable{constructor(f,y,c,s){super();this.fileService=y,this.extensionGalleryService=c,this.logService=s,this.extensionsDownloadDir=a.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,y){await this.cleanUpPromise;const c=this.getName(f),s=(0,T.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(s)){const i=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,h.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(f,i,y);try{await this.rename(i,s,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,C.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return s}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,y,c){try{await I.Promises.rename(f.fsPath,y.fsPath)}catch(s){if(L.isWindows&&s&&s.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${f} to ${y} with 'EPERM' error. Trying again...`),this.rename(f,y,c);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const y=[],c=[];for(const n of f.children){const e=E.ExtensionKey.parse(n.name);e&&c.push([e,n])}const s=(0,E.groupByExtension)(c,([n])=>n),i=[];for(const n of s)n.sort((e,r)=>p.rcompare(e[0].version,r[0].version)),y.push(...n.slice(1).map(e=>e[1].resource)),i.push(n[0][1]);i.sort((n,e)=>n.mtime-e.mtime),y.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(y.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?E.ExtensionKey.create(f).toString().toLowerCase():(0,h.generateUuid)()}};v=fe([te(0,w.INativeEnvironmentService),te(1,l.IFileService),te(2,g.IExtensionGalleryService),te(3,d.ILogService)],v),t.ExtensionsDownloader=v}),define(Z[124],ee([0,1,2,14,20,34]),function($,t,D,C,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(a,h){super();this.environmentService=a,this.extensionsManifestCache=(0,C.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(h.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(h.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(a){a.some(h=>!!h.local)&&this.invalidate()}onDidUnInstallExtension(a){a.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(Z[125],ee([0,1,155,19,3,2,16,14,20,18,22,23,9,62]),function($,t,D,C,b,L,T,p,a,h,I,w,g,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeLanguagePackService=void 0;let l=class extends E.LanguagePackBaseService{constructor(f,y,c,s){super(c);this.extensionManagementService=f,this.logService=s,this.cache=this._register(new d(y,s)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getInstalledLanguages(){const f=await this.cache.getLanguagePacks(),y=Object.keys(f).map(c=>{const s=f[c];return{...this.createQuickPickItem({locale:c,label:s.label}),extensionId:s.extensions[0].extensionIdentifier.id}});return y.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),y}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const y=await this.cache.getLanguagePacks();Object.keys(y).some(c=>y[c]&&y[c].extensions.some(s=>(0,w.areSameExtensions)(s.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),c=await this.cache.update(y);return!(0,C.equals)(Object.keys(f),Object.keys(c))}};l=fe([te(0,I.IExtensionManagementService),te(1,h.INativeEnvironmentService),te(2,I.IExtensionGalleryService),te(3,g.ILogService)],l),t.NativeLanguagePackService=l;let d=class extends L.Disposable{constructor(f,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,p.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(y=>{Object.keys(y).forEach(c=>delete y[c]),this.createLanguagePacksFromExtensions(y,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...y){for(const c of y)c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,c);Object.keys(f).forEach(c=>this.updateHash(f[c]))}createLanguagePacksFromExtension(f,y){const c=y.identifier,s=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const i of s)if(y.location.scheme===T.Schemas.file&&v(i)){let n=f[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},f[i.languageId]=n);const e=n.extensions.filter(r=>(0,w.areSameExtensions)(r.extensionIdentifier,c))[0];e?e.version=y.manifest.version:n.extensions.push({extensionIdentifier:c,version:y.manifest.version});for(const r of i.translations)n.translations[r.id]=(0,p.join)(y.location.fsPath,r.path)}}updateHash(f){if(f){const y=(0,D.createHash)("md5");for(const c of f.extensions)y.update(c.extensionIdentifier.uuid||c.extensionIdentifier.id).update(c.version);f.hash=y.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return a.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,c=>c.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(c)).then(c=>{try{return JSON.parse(c)}catch{return{}}}).then(c=>(y=f(c),c)).then(c=>{for(const i of Object.keys(c))c[i]||delete c[i];this.languagePacks=c,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),a.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>y,c=>this.logService.error(c))})}};d=fe([te(0,h.INativeEnvironmentService),te(1,g.ILogService)],d);function v(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const f of u.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(Z[48],ee([0,1,15,96,40,8,33]),function($,t,D,C,b,L,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asTextOrError=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,L.createDecorator)("requestService");function p(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}t.isSuccess=p;function a(d){return d.res.statusCode===204}async function h(d){return a(d)?null:(await(0,D.streamToBuffer)(d.stream)).toString()}t.asText=h;async function I(d){if(!p(d))throw new Error("Server returned "+d.res.statusCode);return h(d)}t.asTextOrError=I;async function w(d){if(!p(d))throw new Error("Server returned "+d.res.statusCode);if(a(d))return null;const u=(await(0,D.streamToBuffer)(d.stream)).toString();try{return JSON.parse(u)}catch(f){throw f.message+=`:
`+u,f}}t.asJson=w;function g(d){l(d)}t.updateProxyConfigurationsScope=g;let E;function l(d){const v=T.Registry.as(b.Extensions.Configuration),u=E;E={id:"http",order:15,title:(0,C.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,C.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,C.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,C.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,C.localize)(4,null),(0,C.localize)(5,null),(0,C.localize)(6,null),(0,C.localize)(7,null)],default:"override",description:(0,C.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,C.localize)(9,null),restricted:!0}}},v.updateConfigurations({add:[E],remove:u?[u]:[]})}l(2)}),define(Z[126],ee([0,1,25,16,11,48]),function($,t,D,C,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let T=class{constructor(a,h){this.requestService=a,this.fileService=h}async download(a,h,I=D.CancellationToken.None){if(a.scheme===C.Schemas.file||a.scheme===C.Schemas.vscodeRemote){await this.fileService.copy(a,h);return}const w={type:"GET",url:a.toString(!0)},g=await this.requestService.request(w,I);if(g.res.statusCode===200)await this.fileService.writeFile(h,g.stream);else{const E=await(0,L.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${E}`)}}};T=fe([te(0,L.IRequestService),te(1,b.IFileService)],T),t.DownloadService=T}),define(Z[127],ee([0,1,128,7]),function($,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function b(T,p){return T.protocol==="http:"?p.HTTP_PROXY||p.http_proxy||null:T.protocol==="https:"&&(p.HTTPS_PROXY||p.https_proxy||p.HTTP_PROXY||p.http_proxy)||null}async function L(T,p,a={}){const h=(0,D.parse)(T),I=a.proxyUrl||b(h,p);if(!I)return null;const w=(0,D.parse)(I);if(!/^https?:$/.test(w.protocol||""))return null;const g={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,C.isBoolean)(a.strictSSL)?a.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((E,l)=>{$(["http-proxy-agent"],E,l)}))(g):new(await new Promise((E,l)=>{$(["https-proxy-agent"],E,l)}))(g)}t.getProxyAgent=L}),define(Z[129],ee([0,1,45,14,97,25,30,12,13,29,81,156,3]),function($,t,D,C,b,L,T,p,a,h,I,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getResolvedShellEnv=void 0;const E=1e4;let l;async function d(u,f,y){return f["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):a.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(y)&&!f["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(y)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),l||(l=g.Promises.withAsyncBody(async(c,s)=>{const i=new L.CancellationTokenSource,n=setTimeout(()=>{i.dispose(!0),s(new Error((0,b.localize)(0,null)))},E);try{c(await v(u,i.token))}catch(e){!(0,p.isCancellationError)(e)&&!i.token.isCancellationRequested?s(new Error((0,b.localize)(1,null,(0,T.toErrorMessage)(e)))):c({})}finally{clearTimeout(n),i.dispose()}})),l)}t.getResolvedShellEnv=d;async function v(u,f){const y=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",y);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",c);const s=(0,h.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",n);const e=await(0,I.getSystemShell)(a.OS,n);return u.trace("getUnixShellEnvironment#shell",e),new Promise((r,o)=>{if(f.isCancellationRequested)return o((0,p.canceled)());const m=(0,C.basename)(e);let S,P;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(m)?(S=`& '${process.execPath}' ${k} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,P=["-Login","-Command"]):(S=`'${process.execPath}' ${k} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,m==="tcsh"?P=["-ic"]:P=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),S);const U=(0,D.spawn)(e,[...P,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});f.onCancellationRequested(()=>(U.kill(),o((0,p.canceled)()))),U.on("error",Y=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(Y)),o(Y)});const B=[];U.stdout.on("data",Y=>B.push(Y));const q=[];U.stderr.on("data",Y=>q.push(Y)),U.on("close",(Y,ne)=>{const ce=Buffer.concat(B).toString("utf8");u.trace("getUnixShellEnvironment#raw",ce);const re=Buffer.concat(q).toString("utf8");if(re.trim()&&u.trace("getUnixShellEnvironment#stderr",re),Y||ne)return o(new Error((0,b.localize)(2,null,Y,ne)));const ge=i.exec(ce),ae=ge?ge[1]:"{}";try{const N=JSON.parse(ae);y?N.ELECTRON_RUN_AS_NODE=y:delete N.ELECTRON_RUN_AS_NODE,c?N.ELECTRON_NO_ATTACH_CONSOLE=c:delete N.ELECTRON_NO_ATTACH_CONSOLE,delete N.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",N),r(N)}catch(N){u.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(N)),o(N)}})})}}),define(Z[65],ee([0,1,8]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=(0,D.createDecorator)("stateService")}),define(Z[130],ee([0,1,3,15,7,18,11,9]),function($,t,D,C,b,L,T,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class a{constructor(w,g,E){this.storagePath=w,this.logService=g,this.fileService=E,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new D.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}}getItem(w,g){const E=this.storage[w];return(0,b.isUndefinedOrNull)(E)?g:E}setItem(w,g){this.setItems([{key:w,data:g}])}setItems(w){let g=!1;for(const{key:E,data:l}of w)this.storage[E]!==l&&((0,b.isUndefinedOrNull)(l)?(0,b.isUndefined)(this.storage[E])||(this.storage[E]=void 0,g=!0):(this.storage[E]=l,g=!0));g&&this.save()}removeItem(w){(0,b.isUndefined)(this.storage[w])||(this.storage[w]=void 0,this.save())}async save(w){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),w)}async doSave(){if(!this.initializing)return;await this.initializing;const w=JSON.stringify(this.storage,null,4);if(w!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,C.VSBuffer.fromString(w)),this.lastSavedStorageContents=w}catch(g){this.logService.error(g)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}t.FileStorage=a;let h=class{constructor(w,g,E){this.fileStorage=new a(w.stateResource,g,E)}async init(){await this.fileStorage.init()}getItem(w,g){return this.fileStorage.getItem(w,g)}};h=fe([te(0,L.IEnvironmentService),te(1,p.ILogService),te(2,T.IFileService)],h),t.StateService=h}),define(Z[66],ee([0,1,13,32,10,29]),function($,t,D,C,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function T(h){if(D.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function p(h,I,w,g,E,l,d,v,u,f){const y=Object.create(null);y["common.machineId"]=d,y.sessionID=(0,L.generateUuid)()+Date.now(),y.commitHash=E,y.version=l,y["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,D.PlatformToString)(D.platform),y["common.nodePlatform"]=C.platform,y["common.nodeArch"]=g,y["common.product"]=f||"desktop",v&&(y["common.msftInternal"]=v);let c=0;const s=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),D.isLinuxSnap&&(y["common.snap"]="true");const i=T(w);i&&(y["common.platformDetail"]=i);try{const n=await h.readFile(b.URI.file(u));y["common.source"]=n.value.toString().slice(0,30)}catch{}return y}t.resolveCommonProperties=p;function a(h){const I=C.env.USERDNSDOMAIN;if(!I)return!1;const w=I.toLowerCase();return h.some(g=>w===g)}t.verifyMicrosoftInternalDomain=a}),define(Z[35],ee([0,1,8]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,D.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(C=t.TelemetryLevel||(t.TelemetryLevel={}));var b;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(b=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Z[42],ee([0,1,24,53,7,21,66,35]),function($,t,D,C,b,L,T,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPiiPathsFromEnvironment=t.isInternalTelemetry=t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class a{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,C.staticObservableValue)(0)}publicLog(i,n){return Promise.resolve(void 0)}publicLog2(i,n){return this.publicLog(i,n)}publicLogError(i,n){return Promise.resolve(void 0)}publicLogError2(i,n){return this.publicLogError(i,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=a,t.NullTelemetryService=new a;class h{async publicLog(i,n,e){}async publicLogError(i,n,e){}}t.NullEndpointTelemetryService=h,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(s,i){return i.onDidChangeConfiguration(n=>{n.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(n.source),configurationKeys:u(n.sourceConfig)})})}t.configurationTelemetry=I;function w(s,i){return!(i.disableTelemetry||!s.enableTelemetry||i.extensionTestsLocationURI)}t.supportsTelemetry=w;function g(s){const i=s.getValue(p.TELEMETRY_SETTING_ID),n=s.getValue("telemetry.enableCrashReporter");if(s.getValue(p.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=g;function E(s){const i={},n={},e={};v(s,e);for(let r in e){r=r.length>150?r.substr(r.length-149):r;const o=e[r];typeof o=="number"?n[r]=o:typeof o=="boolean"?n[r]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${o.length}`),i[r]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(i[r]=o)}return{properties:i,measurements:n}}t.validateTelemetryData=E;const l=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function d(s){if(!s)return"none";for(const i of l)if(s.startsWith(`${i}+`))return i;return"other"}t.cleanRemoteAuthority=d;function v(s,i,n=0,e){if(!!s)for(const r of Object.getOwnPropertyNames(s)){const o=s[r],m=e?e+r:r;Array.isArray(o)?i[m]=(0,D.safeStringify)(o):o instanceof Date?i[m]=o.toISOString():(0,b.isObject)(o)?n<2?v(o,i,n+1,m+"."):i[m]=(0,D.safeStringify)(o):i[m]=o}}function u(s){if(!s)return[];const i=[];return f(i,"",s),i}function f(s,i,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(e=>f(s,i?`${i}.${e}`:e,n[e])):s.push(i)}function y(s,i){const n=s.msftInternalDomains||[],e=i.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(n)||e}t.isInternalTelemetry=y;function c(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}t.getPiiPathsFromEnvironment=c}),define(Z[131],ee([0,1,104,42]),function($,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=void 0;async function b(L,T,p,a,h,I,w){const g={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${T.nameShort})`},E=await(0,D.getServiceMachineId)(p,h,I),{sessionId:l}=await w.getTelemetryInfo();return(0,C.supportsTelemetry)(T,p)&&(0,C.getTelemetryLevel)(a)===3&&(g["X-Market-User-Id"]=E,g["VSCode-SessionId"]=l),g}t.resolveMarketplaceHeaders=b}),define(Z[132],ee([0,1,12,24,42]),function($,t,D,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function T(a,h,I){const w=await new Promise((v,u)=>{$(["@microsoft/1ds-core-js"],v,u)}),g=await new Promise((v,u)=>{$(["@microsoft/1ds-post-js"],v,u)}),E=new w.AppInsightsCore,l=new g.PostChannel,d={instrumentationKey:a,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[l]]};if(I){d.extensionConfig={};const v={alwaysUseXhrOverride:!0,httpXHROverride:I};d.extensionConfig[l.identifier]=v}return E.initialize(d,[]),E.addTelemetryInitializer(v=>{h&&(v.ext=v.ext??{},v.ext.utc=v.ext.utc??{},v.ext.utc.flags=8462029)}),E}class p{constructor(h,I,w,g,E){this._isInternalTelemetry=h,this._eventPrefix=I,this._defaultData=w,this._xhrOverride=E,this.endPointUrl=L,this._defaultData||(this._defaultData={}),typeof g=="function"?this._aiCoreOrKey=g():this._aiCoreOrKey=g,this._asyncAiCore=null}_withAIClient(h){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){h(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=T(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(I=>{h(I)},I=>{(0,D.onUnexpectedError)(I),console.error(I)})}}log(h,I){if(!this._aiCoreOrKey)return;I=(0,C.mixin)(I,this._defaultData),I=(0,b.validateTelemetryData)(I);const w=this._eventPrefix+"/"+h;try{this._withAIClient(g=>{g.pluginVersionString=I?.properties.version??"Unknown",g.track({name:w,baseData:{name:w,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(h=>{this._withAIClient(I=>{I.unload(!0,()=>{this._aiCoreOrKey=void 0,h(void 0)})})}):Promise.resolve(void 0)}}t.AbstractOneDataSystemAppender=p}),define(Z[133],ee([0,1,2,24,53,13,31,98,21,40,134,27,33,35,42]),function($,t,D,C,b,L,T,p,a,h,I,w,g,E,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let d=class{constructor(f,y,c){this._configurationService=y,this._productService=c,this._experimentProperties={},this.telemetryLevel=new b.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(f,y){this._experimentProperties[f]=y}_updateTelemetryLevel(){let f=(0,l.getTelemetryLevel)(this._configurationService);const y=this._productService.enabledTelemetryLevels;if(y){this._sendErrorTelemetry=this.sendErrorTelemetry?y.error:!1;const c=y.usage?3:y.error?2:0;f=Math.min(f,c)}this.telemetryLevel.value=f}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const f=await this._commonProperties,y=f.sessionID,c=f["common.machineId"],s=f["common.firstSessionDate"],i=f["common.msftInternal"];return{sessionId:y,machineId:c,firstSessionDate:s,msftInternal:i}}dispose(){this._disposables.dispose()}_log(f,y,c,s){return this.telemetryLevel.value<y?Promise.resolve(void 0):this._commonProperties.then(i=>{c=(0,C.mixin)(c,i),c=(0,C.mixin)(c,this._experimentProperties),c=(0,C.cloneAndChange)(c,n=>{if(typeof n=="string")return this._cleanupInfo(n,s)}),this._appenders.forEach(n=>n.log(f,c))},i=>{console.error(i)})}publicLog(f,y,c){return this._log(f,3,y,c)}publicLog2(f,y,c){return this.publicLog(f,y,c)}publicLogError(f,y){return this._sendErrorTelemetry?this._log(f,2,y,!0):Promise.resolve(void 0)}publicLogError2(f,y){return this.publicLogError(f,y)}_anonymizeFilePaths(f){let y=f;const c=[];for(const e of this._cleanupPatterns)for(;;){const r=e.exec(f);if(!r)break;c.push([r.index,e.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let n=0;for(y="";;){const e=i.exec(f);if(!e)break;!s.test(e[0])&&c.every(([r,o])=>e.index<r||e.index>=o)&&(y+=f.substring(n,e.index)+"<REDACTED: user-file-path>",n=i.lastIndex)}return n<f.length&&(y+=f.substr(n)),y}_removePropertiesWithPossibleUserInfo(f){if(!f)return f;const y=f.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const s of c)if(s.regex.test(y))return`<REDACTED: ${s.label}>`;return f}_cleanupInfo(f,y){let c=f;y&&(c=this._anonymizeFilePaths(c));for(const s of this._cleanupPatterns)c=c.replace(s,"");return c=this._removePropertiesWithPossibleUserInfo(c),c}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=fe([te(1,a.IConfigurationService),te(2,w.IProductService)],d),t.TelemetryService=d;function v(){const u=(0,p.localize)(0,null,I.default.nameLong),f=I.default.privacyStatementUrl?(0,p.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,p.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=L.isWeb?"":(0,p.localize)(3,null),c=(0,p.localize)(4,null),s=(0,p.localize)(5,null),i=(0,p.localize)(6,null),n=(0,p.localize)(7,null),e=`
|       | ${c} | ${s} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,p.localize)(8,null);return`
${u} ${f} ${y}

&nbsp;

${n}
${e}

&nbsp;

${r}
`}g.Registry.as(h.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,p.localize)(10,null),(0,p.localize)(11,null),(0,p.localize)(12,null),(0,p.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),g.Registry.as(h.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,p.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,p.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,p.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[135],ee([0,1,157,132]),function($,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OneDataSystemAppender=void 0;class b extends C.AbstractOneDataSystemAppender{constructor(T,p,a,h){const I={sendPOST:(w,g)=>{const E={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const l=D.request(w.urlString,E,d=>{d.on("data",function(v){g(d.statusCode??200,d.headers,v.toString())}),d.on("error",function(v){g(0,{})})});l.write(w.data),l.end()}catch{g(0,{})}}};super(T,p,a,h,I)}}t.OneDataSystemAppender=b}),define(Z[136],ee([0,1,14,20]),function($,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function b(L,T){const p=Object.create(null),a=(I,w)=>{const g=JSON.parse(I);p[w]=g};if(T){const I=[],w=await C.Promises.readdir(T);for(const E of w)try{(await C.Promises.stat((0,D.join)(T,E))).isDirectory()&&I.push(E)}catch{}const g=[];for(const E of I)(await C.Promises.readdir((0,D.join)(T,E))).filter(d=>d==="telemetry.json").length===1&&g.push(E);for(const E of g){const l=(await C.Promises.readFile((0,D.join)(T,E,"telemetry.json"))).toString();a(l,E)}}let h=(await C.Promises.readFile((0,D.join)(L,"telemetry-core.json"))).toString();return a(h,"vscode-core"),h=(await C.Promises.readFile((0,D.join)(L,"telemetry-extensions.json"))).toString(),a(h,"vscode-extensions"),JSON.stringify(p,null,4)}t.buildTelemetryMessage=b}),define(Z[28],ee([0,1,8]),function($,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(Z[137],ee([0,1,4,2,10,18,23,11,9,28]),function($,t,D,C,b,L,T,p,a,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let I=class extends C.Disposable{constructor(g,E,l,d,v){super();this.extensionsManagementService=g,this.logService=d,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(f=>{this.installedExtensions=f.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(f=>this.onInstallExtension(f))),this._register(g.onDidInstallExtensions(f=>this.onDidInstallExtensions(f))),this._register(g.onDidUninstallExtension(f=>this.onDidUninstallExtension(f)));const u=b.URI.file(l.extensionsPath);this._register(E.watch(u)),this._register(D.Event.filter(E.onDidFilesChange,f=>f.rawChanges.some(y=>this.doesChangeAffects(y,u)))(()=>this.onDidChange()))}doesChangeAffects(g,E){return g.type!==1&&g.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(g.resource),E)?!1:this.uriIdentityService.extUri.isEqual(g.resource,this.uriIdentityService.extUri.joinPath(E,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(g.resource).startsWith(".")}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const E of g)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(E=>!(0,T.areSameExtensions)(E,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,T.areSameExtensions)(E,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(),E=g.filter(d=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,T.areSameExtensions)(v,d.identifier))?!1:d.installedTimestamp&&d.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",d.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",d.identifier.id),!1)),l=this.installedExtensions.filter(d=>this.installingExtensions.some(v=>(0,T.areSameExtensions)(v,d))?!1:g.every(v=>!(0,T.areSameExtensions)(v.identifier,d))?(this.logService.info("Detected extension removed from another source",d.id),!0):!1);this.installedExtensions=g.map(d=>d.identifier),(E.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:l})}}};I=fe([te(1,p.IFileService),te(2,L.INativeEnvironmentService),te(3,a.ILogService),te(4,h.IUriIdentityService)],I),t.ExtensionsWatcher=I}),define(Z[138],ee([0,1,28,105,11,17,69,4,2]),function($,t,D,C,b,L,T,p,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class h{constructor(g){this.uri=g,this.time=h._clock++}touch(){return this.time=h._clock++,this}}h._clock=0;let I=class{constructor(g){this._fileService=g,this._dispooables=new a.DisposableStore,this._limit=2**16;const E=new Map,l=d=>{let v=E.get(d.scheme);return v===void 0&&(v=g.hasProvider(d)&&!this._fileService.hasCapability(d,1024),E.set(d.scheme,v)),v};this._dispooables.add(p.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(d=>{E.delete(d.scheme)})),this.extUri=new L.ExtUri(l),this._canonicalUris=new T.SkipList((d,v)=>this.extUri.compare(d,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,L.normalizePath)(g));const E=this._canonicalUris.get(g);return E?E.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new h(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((l,d)=>l[1].touch<d[1].touch?1:l[1].touch>d[1].touch?-1:0);h._clock=0,this._canonicalUris.clear();const E=this._limit*.5;for(let l=0;l<E;l++)this._canonicalUris.set(g[l][0],g[l][1].touch())}};I=fe([te(0,b.IFileService)],I),t.UriIdentityService=I,(0,C.registerSingleton)(D.IUriIdentityService,I,!0)}),define(Z[139],ee([0,1,100,14,36,17,10,8,16]),function($,t,D,C,b,L,T,p,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.hasWorkspaceFileExtension=t.isSavedWorkspace=t.isTemporaryWorkspace=t.isUntitledWorkspace=t.UNTITLED_WORKSPACE_NAME=t.WORKSPACE_FILTER=t.WORKSPACE_EXTENSION=t.toWorkspaceFolder=t.WorkspaceFolder=t.Workspace=t.isWorkspaceFolder=t.isWorkspace=t.WorkbenchState=t.reviveIdentifier=t.isWorkspaceIdentifier=t.toWorkspaceIdentifier=t.isSingleFolderWorkspaceIdentifier=t.IWorkspaceContextService=void 0,t.IWorkspaceContextService=(0,p.createDecorator)("contextService");function h(e){const r=e;return typeof r?.id=="string"&&T.URI.isUri(r.uri)}t.isSingleFolderWorkspaceIdentifier=h;function I(e){if(e.configuration)return{id:e.id,configPath:e.configuration};if(e.folders.length===1)return{id:e.id,uri:e.folders[0].uri}}t.toWorkspaceIdentifier=I;function w(e){const r=e;return typeof r?.id=="string"&&T.URI.isUri(r.configPath)}t.isWorkspaceIdentifier=w;function g(e){const r=e;if(r?.uri)return{id:r.id,uri:T.URI.revive(r.uri)};const o=e;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(e?.id)return{id:e.id}}t.reviveIdentifier=g;var E;(function(e){e[e.EMPTY=1]="EMPTY",e[e.FOLDER=2]="FOLDER",e[e.WORKSPACE=3]="WORKSPACE"})(E=t.WorkbenchState||(t.WorkbenchState={}));function l(e){const r=e;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}t.isWorkspace=l;function d(e){const r=e;return!!(r&&typeof r=="object"&&T.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}t.isWorkspaceFolder=d;class v{constructor(r,o,m,S,P){this._id=r,this._transient=m,this._configuration=S,this._ignorePathCasing=P,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}t.Workspace=v;class u{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,L.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.WorkspaceFolder=u;function f(e){return new u({uri:e,index:0,name:(0,L.basenameOrAuthority)(e)},{uri:e.toString()})}t.toWorkspaceFolder=f,t.WORKSPACE_EXTENSION="code-workspace";const y=`.${t.WORKSPACE_EXTENSION}`;t.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[t.WORKSPACE_EXTENSION]}],t.UNTITLED_WORKSPACE_NAME="workspace.json";function c(e,r){return L.extUriBiasedIgnorePathCase.isEqualOrParent(e,r.untitledWorkspacesHome)}t.isUntitledWorkspace=c;function s(e){let r;return T.URI.isUri(e)?r=e:r=e.configuration,r?.scheme===a.Schemas.tmp}t.isTemporaryWorkspace=s;function i(e,r){return!c(e,r)&&!s(e)}t.isSavedWorkspace=i;function n(e){return(typeof e=="string"?(0,C.extname)(e):(0,L.extname)(e))===y}t.hasWorkspaceFileExtension=n}),define(Z[26],ee([0,1,54,4,2,17,7,10,99,18,11,8,9,139,36,28,3,29]),function($,t,D,C,b,L,T,p,a,h,I,w,g,E,l,d,v,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataProfilesService=t.toUserDataProfile=t.EXTENSIONS_RESOURCE_NAME=t.reviveProfile=t.IUserDataProfilesService=t.PROFILES_ENABLEMENT_CONFIG=t.isUserDataProfile=void 0;function f(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&p.URI.isUri(n.location)&&p.URI.isUri(n.globalStorageHome)&&p.URI.isUri(n.settingsResource)&&p.URI.isUri(n.keybindingsResource)&&p.URI.isUri(n.tasksResource)&&p.URI.isUri(n.snippetsHome)&&((0,T.isUndefined)(n.extensionsResource)||p.URI.isUri(n.extensionsResource)))}t.isUserDataProfile=f,t.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",t.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function y(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,location:p.URI.revive(i.location).with({scheme:n}),globalStorageHome:p.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:p.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:p.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:p.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:p.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:p.URI.revive(i.extensionsResource)?.with({scheme:n})}}t.reviveProfile=y,t.EXTENSIONS_RESOURCE_NAME="extensions.json";function c(i,n,e){return{id:(0,D.hash)(n.path).toString(16),name:i,location:n,isDefault:!1,globalStorageHome:(0,L.joinPath)(n,"globalStorage"),settingsResource:(0,L.joinPath)(n,"settings.json"),keybindingsResource:(0,L.joinPath)(n,"keybindings.json"),tasksResource:(0,L.joinPath)(n,"tasks.json"),snippetsHome:(0,L.joinPath)(n,"snippets"),extensionsResource:(0,L.joinPath)(n,t.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:e}}t.toUserDataProfile=c;let s=class extends b.Disposable{constructor(n,e,r,o){super();this.environmentService=n,this.fileService=e,this.uriIdentityService=r,this.logService=o,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new C.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new C.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new C.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return this.profilesObject.profiles}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(m=>c(m.name,m.location,m.useDefaultFlags)):[];let e;const r=new l.ResourceMap;if(n.length){const m=this.getStoredProfileAssociations();if(m.workspaces)for(const[S,P]of Object.entries(m.workspaces)){const k=p.URI.parse(S),U=p.URI.parse(P),B=n.find(q=>this.uriIdentityService.extUri.isEqual(q.location,U));B&&r.set(k,B)}if(m.emptyWindow){const S=p.URI.parse(m.emptyWindow);e=n.find(P=>this.uriIdentityService.extUri.isEqual(P.location,S))}}const o=c((0,a.localize)(0,null),this.environmentService.userRoamingDataHome);n.unshift({...o,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0?o.extensionsResource:void 0}),this._profilesObject={profiles:n,workspaces:r,emptyWindow:e}}return this._profilesObject}getProfile(n){const e=this.getWorkspace(n);return(p.URI.isUri(e)?this.profilesObject.workspaces.get(e):this.profilesObject.emptyWindow)??this.defaultProfile}getWorkspace(n){return(0,E.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,E.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}async createProfile(n,e,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(this.getStoredProfiles().some(S=>S.name===n))throw new Error(`Profile with name ${n} already exists`);const o=c(n,(0,L.joinPath)(this.profilesHome,(0,D.hash)((0,u.generateUuid)()).toString(16)),e);await this.fileService.createFolder(o.location);const m=[];return this._onWillCreateProfile.fire({profile:o,join(S){m.push(S)}}),await v.Promises.settled(m),this.updateProfiles([o],[],[]),r&&await this.setProfileForWorkspace(o,r),o}async updateProfile(n,e,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(m=>m.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);return o=c(e,o.location,r),this.updateProfiles([],[],[o]),o}async setProfileForWorkspace(n,e){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);const r=this.profiles.find(o=>o.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);this.updateWorkspaceAssociation(e,r)}async unsetWorkspace(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n)}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const e=this.profiles.find(o=>o.id===n.id);if(!e)throw new Error(`Profile '${n.name}' does not exist`);const r=[];this._onWillRemoveProfile.fire({profile:e,join(o){r.push(o)}}),await v.Promises.settled(r),e.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const o of[...this.profilesObject.workspaces.keys()])e.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[e],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(e.location,{recursive:!0})}catch(o){this.logService.error(o)}}updateProfiles(n,e,r){const o=[];for(let m of[...this.profilesObject.profiles,...n])m.isDefault||e.some(S=>m.id===S.id)||(m=r.find(S=>m.id===S.id)??m,o.push({location:m.location,name:m.name,useDefaultFlags:m.useDefaultFlags}));this.saveStoredProfiles(o),this._profilesObject=void 0,this.triggerProfilesChanges(n,e,r)}triggerProfilesChanges(n,e,r){this._onDidChangeProfiles.fire({added:n,removed:e,updated:r,all:this.profiles})}updateWorkspaceAssociation(n,e){const r=this.getWorkspace(n);p.URI.isUri(r)?(this.profilesObject.workspaces.delete(r),e&&!e.isDefault&&this.profilesObject.workspaces.set(r,e)):this.profilesObject.emptyWindow=e?.isDefault?void 0:e,this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[r,o]of this.profilesObject.workspaces.entries())n[r.toString()]=o.location.toString();const e=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:e}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};s.PROFILES_KEY="userDataProfiles",s.PROFILE_ASSOCIATIONS_KEY="profileAssociations",s=fe([te(0,h.IEnvironmentService),te(1,I.IFileService),te(2,d.IUriIdentityService),te(3,g.ILogService)],s),t.UserDataProfilesService=s}),define(Z[140],ee([0,1,19,3,25,12,4,2,13,10,85,22,23,34,9,27,35,26]),function($,t,D,C,b,L,T,p,a,h,I,w,g,E,l,d,v,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let f=class extends p.Disposable{constructor(e,r,o,m,S){super();this.galleryService=e,this.telemetryService=r,this.logService=o,this.productService=m,this.userDataProfilesService=S,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,p.toDisposable)(()=>{this.installingExtensions.forEach(P=>P.cancel()),this.uninstallingExtensions.forEach(P=>P.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(e){const r=await this.getTargetPlatform();return e.allTargetPlatforms.some(o=>(0,w.isTargetPlatformCompatible)(o,e.allTargetPlatforms,r))}async installFromGallery(e,r={}){try{if(!this.galleryService.isEnabled())throw new w.ExtensionManagementError(I.localize(0,null),w.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(e,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,r)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(e),error:o}),this.logService.error("Failed to install extension.",e.identifier.id),this.logService.error(o),c(o)}}async uninstall(e,r={}){return this.logService.trace("ExtensionManagementService#uninstall",e.identifier.id),this.uninstallExtension(e,r)}async reinstallFromGallery(e){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",e.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(1,null));const r=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...e.identifier,preRelease:e.preRelease}],{targetPlatform:r,compatible:!0},b.CancellationToken.None);if(!o)throw new Error(I.localize(2,null));await this.createUninstallExtensionTask(e,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const e=new Date().getTime();return(!this.extensionsControlManifest||e-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=e),this.extensionsControlManifest}registerParticipant(e){this.participants.push(e)}async installExtension(e,r,o){const m=B=>`${g.ExtensionKey.create(B).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!h.URI.isUri(r)){const B=this.installingExtensions.get(m(r));if(B){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:q}=await B.waitUntilTaskIsFinished();return q}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const S=[],P=[],k=this.createInstallExtensionTask(e,r,o);h.URI.isUri(r)||this.installingExtensions.set(m(r),k),this._onInstallExtension.fire({identifier:k.identifier,source:r,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",k.identifier.id),S.push({task:k,manifest:e});let U=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",k.identifier.id);else try{const q=await this.getAllDepsAndPackExtensionsToInstall(k.identifier,e,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation);for(const{gallery:Y,manifest:ne}of q){U=U||!!ne.extensionDependencies?.some(re=>(0,g.areSameExtensions)({id:re},k.identifier));const ce=m(Y);if(this.installingExtensions.has(ce))this.logService.info("Extension is already requested to install",Y.identifier.id);else{const re=this.createInstallExtensionTask(ne,Y,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(ce,re),this._onInstallExtension.fire({identifier:re.identifier,source:Y,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",re.identifier.id),S.push({task:re,manifest:ne})}}}catch(q){if(h.URI.isUri(k.source))(0,D.isNonEmptyArray)(e.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",k.identifier.id,q.message),(0,D.isNonEmptyArray)(e.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",k.identifier.id,q.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",k.identifier.id),q}const B=S.reduce((q,{task:Y,manifest:ne})=>(q.set(Y.identifier.id.toLowerCase(),{task:Y,manifest:ne}),q),new Map);for(;B.size;){let q;const Y=[...B.values()].filter(({manifest:ne})=>!ne.extensionDependencies?.some(ce=>B.has(ce.toLowerCase())));Y.length?q=B.size===1?Y:Y.filter(({task:ne})=>!(ne===k&&!U)):(this.logService.info("Found extensions with circular dependencies",Y.map(({task:ne})=>ne.identifier.id)),q=[...B.values()]),await this.joinAllSettled(q.map(async({task:ne})=>{const ce=new Date().getTime();try{const{local:re}=await ne.run();if(await this.joinAllSettled(this.participants.map(ge=>ge.postInstall(re,ne.source,o,b.CancellationToken.None))),!h.URI.isUri(ne.source)){const ge=ne.operation===3,ae=ge?void 0:(new Date().getTime()-ne.source.lastUpdated)/1e3;if(s(this.telemetryService,ge?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(ne.source),duration:new Date().getTime()-ce,durationSinceUpdate:ae}),a.isWeb&&ne.operation!==3)try{await this.galleryService.reportStatistic(re.manifest.publisher,re.manifest.name,re.manifest.version,"install")}catch{}}P.push({local:re,identifier:ne.identifier,operation:ne.operation,source:ne.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:re.isApplicationScoped})}catch(re){throw h.URI.isUri(ne.source)||s(this.telemetryService,ne.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(ne.source),duration:new Date().getTime()-ce,error:re}),this.logService.error("Error while installing the extension:",ne.identifier.id),re}finally{B.delete(ne.identifier.id.toLowerCase())}}))}return P.forEach(({identifier:q})=>this.logService.info("Extension installed successfully:",q.id)),this._onDidInstallExtensions.fire(P),P.filter(({identifier:q})=>(0,g.areSameExtensions)(q,k.identifier))[0].local}catch(B){if(S.forEach(({task:q})=>q.cancel()),P.length)try{const q=await Promise.allSettled(P.map(({local:Y})=>this.createUninstallExtensionTask(Y,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let Y=0;Y<q.length;Y++){const ne=q[Y],{identifier:ce}=P[Y];ne.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ce.id):this.logService.warn("Rollback: Error while uninstalling extension",ce.id,(0,L.getErrorMessage)(ne.reason))}}catch(q){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(q),P.map(({identifier:Y})=>Y.id))}throw this._onDidInstallExtensions.fire(S.map(({task:q})=>({identifier:q.identifier,operation:2,source:q.source,context:o.context,profileLocation:o.profileLocation}))),B}finally{for(const{task:B}of S)if(!h.URI.isUri(B.source)){const q=m(B.source);this.installingExtensions.delete(q)||this.logService.warn("Installation task is not found in the cache",q)}}}async joinAllSettled(e){const r=[],o=[],m=await Promise.allSettled(e);for(const S of m)S.status==="fulfilled"?r.push(S.value):o.push(S.reason);if(o.length)throw y(o);return r}async getAllDepsAndPackExtensionsToInstall(e,r,o,m,S){if(!this.galleryService.isEnabled())return[];let P=await this.getInstalled(void 0,S);const k=[e,...P.map(q=>q.identifier)],U=[],B=async(q,Y)=>{const ne=Y.extensionDependencies||[],ce=[...ne];if(Y.extensionPack){const re=o?P.find(ge=>(0,g.areSameExtensions)(ge.identifier,q)):void 0;for(const ge of Y.extensionPack)re&&re.manifest.extensionPack&&re.manifest.extensionPack.some(ae=>(0,g.areSameExtensions)({id:ae},{id:ge}))||ce.every(ae=>!(0,g.areSameExtensions)({id:ae},{id:ge}))&&ce.push(ge)}if(ce.length){const re=[...k,...U.map(ae=>ae.gallery.identifier)],ge=ce.filter(ae=>re.every(N=>!(0,g.areSameExtensions)(N,{id:ae})));if(ge.length){const ae=await this.galleryService.getExtensions(ge.map(N=>({id:N,preRelease:m})),b.CancellationToken.None);for(const N of ae){if(re.find(A=>(0,g.areSameExtensions)(A,N.identifier)))continue;const _=ne.some(A=>(0,g.areSameExtensions)({id:A},N.identifier));let M;try{M=await this.checkAndGetCompatibleVersion(N,!1,m)}catch(A){if(A instanceof w.ExtensionManagementError&&A.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!_){this.logService.info("Skipping the packed extension as it cannot be installed",N.identifier.id);continue}else throw A}U.push({gallery:M.extension,manifest:M.manifest}),await B(M.extension.identifier,M.manifest)}}}};return await B(e,r),P=await this.getInstalled(void 0,S),U.filter(q=>!P.some(Y=>(0,g.areSameExtensions)(Y.identifier,q.gallery.identifier)))}async checkAndGetCompatibleVersion(e,r,o){if((await this.getExtensionsControlManifest()).malicious.some(k=>(0,g.areSameExtensions)(e.identifier,k)))throw new w.ExtensionManagementError(I.localize(3,null,e.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(e)){const k=await this.getTargetPlatform();throw new w.ExtensionManagementError(I.localize(4,null,e.identifier.id,this.productService.nameLong,(0,w.TargetPlatformToString)(k)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const S=await this.getCompatibleVersion(e,r,o);if(S){if(o&&!r&&e.hasPreReleaseVersion&&!S.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(I.localize(5,null,e.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&e.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([e.identifier],b.CancellationToken.None))[0]?new w.ExtensionManagementError(I.localize(6,null,e.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(I.localize(7,null,e.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",S.identifier.id);const P=await this.galleryService.getManifest(S,b.CancellationToken.None);if(P===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${e.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(P.version!==S.version)throw new w.ExtensionManagementError(`Cannot install '${e.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:S,manifest:P}}async getCompatibleVersion(e,r,o){const m=await this.getTargetPlatform();let S=null;return!r&&e.hasPreReleaseVersion&&e.properties.isPreReleaseVersion!==o&&(S=(await this.galleryService.getExtensions([{...e.identifier,preRelease:o}],{targetPlatform:m,compatible:!0},b.CancellationToken.None))[0]||null),!S&&await this.galleryService.isExtensionCompatible(e,o,m)&&(S=e),S||(r?S=(await this.galleryService.getExtensions([{...e.identifier,version:e.version}],{targetPlatform:m,compatible:!0},b.CancellationToken.None))[0]||null:S=await this.galleryService.getCompatibleExtension(e,o,m)),S}async uninstallExtension(e,r){const o=B=>`${B.id.toLowerCase()}${r.versionOnly?`-${e.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,m=this.uninstallingExtensions.get(o(e.identifier));if(m)return this.logService.info("Extensions is already requested to uninstall",e.identifier.id),m.waitUntilTaskIsFinished();const S=(B,q)=>{const Y=this.createUninstallExtensionTask(B,q);return this.uninstallingExtensions.set(o(Y.extension.identifier),Y),r.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,r.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${B.identifier.id}@${B.manifest.version}`),this._onUninstallExtension.fire({identifier:B.identifier,profileLocation:r.profileLocation,applicationScoped:B.isApplicationScoped}),Y},P=(B,q)=>{q?r.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,r.profileLocation.toString(),q.message):this.logService.error("Failed to uninstall extension:",`${B.identifier.id}@${B.manifest.version}`,q.message):r.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${B.identifier.id}@${B.manifest.version}`,r.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${B.identifier.id}@${B.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)(B),error:q}),this._onDidUninstallExtension.fire({identifier:B.identifier,version:B.manifest.version,error:q?.code,profileLocation:r.profileLocation,applicationScoped:B.isApplicationScoped})},k=[],U=[];try{k.push(S(e,r));const B=await this.getInstalled(1,r.profileLocation);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${e.identifier.id}@${e.manifest.version}`);else{const q=this.getAllPackExtensionsToUninstall(e,B);for(const Y of q)this.uninstallingExtensions.has(o(Y.identifier))?this.logService.info("Extensions is already requested to uninstall",Y.identifier.id):k.push(S(Y,r))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${e.identifier.id}@${e.manifest.version}`):this.checkForDependents(k.map(q=>q.extension),B,e),await this.joinAllSettled(k.map(async q=>{try{if(await q.run(),await this.joinAllSettled(this.participants.map(Y=>Y.postUninstall(q.extension,r,b.CancellationToken.None))),q.extension.identifier.uuid)try{await this.galleryService.reportStatistic(q.extension.manifest.publisher,q.extension.manifest.name,q.extension.manifest.version,"uninstall")}catch{}P(q.extension)}catch(Y){const ne=Y instanceof w.ExtensionManagementError?Y:new w.ExtensionManagementError((0,L.getErrorMessage)(Y),w.ExtensionManagementErrorCode.Internal);throw P(q.extension,ne),ne}finally{U.push(q)}}))}catch(B){const q=B instanceof w.ExtensionManagementError?B:new w.ExtensionManagementError((0,L.getErrorMessage)(B),w.ExtensionManagementErrorCode.Internal);for(const Y of k){try{Y.cancel()}catch{}U.includes(Y)||P(Y.extension,q)}throw q}finally{for(const B of k)this.uninstallingExtensions.delete(o(B.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",B.extension.identifier.id)}}checkForDependents(e,r,o){for(const m of e){const S=this.getDependents(m,r);if(S.length){const P=S.filter(k=>!e.some(U=>(0,g.areSameExtensions)(U.identifier,k.identifier)));if(P.length)throw new Error(this.getDependentsErrorMessage(m,P,o))}}}getDependentsErrorMessage(e,r,o){return o===e?r.length===1?I.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(9,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(10,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?I.localize(11,null,o.manifest.displayName||o.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(12,null,o.manifest.displayName||o.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(13,null,o.manifest.displayName||o.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(e,r,o=[]){if(o.indexOf(e)!==-1)return[];o.push(e);const m=e.manifest.extensionPack?e.manifest.extensionPack:[];if(m.length){const S=r.filter(k=>!k.isBuiltin&&m.some(U=>(0,g.areSameExtensions)({id:U},k.identifier))),P=[];for(const k of S)P.push(...this.getAllPackExtensionsToUninstall(k,r,o));return[...S,...P]}return[]}getDependents(e,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(m=>(0,g.areSameExtensions)({id:m},e.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const e=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",e),e}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(e,r,o){return o.profileLocation&&(0,E.isApplicationScopedExtension)(e)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(e,r,o)}createUninstallExtensionTask(e,r){return r.profileLocation&&e.isApplicationScoped&&(r={...r,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(e,r)}};f=fe([te(0,w.IExtensionGalleryService),te(1,v.ITelemetryService),te(2,l.ILogService),te(3,d.IProductService),te(4,u.IUserDataProfilesService)],f),t.AbstractExtensionManagementService=f;function y(n){const e=Array.isArray(n)?n:[n];return e.length===1?e[0]instanceof Error?e[0]:new Error(e[0]):e.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}t.joinErrors=y;function c(n){if(n instanceof w.ExtensionManagementError)return n;const e=new w.ExtensionManagementError(n.message,w.ExtensionManagementErrorCode.Internal);return e.stack=n.stack,e}function s(n,e,{extensionData:r,duration:o,error:m,durationSinceUpdate:S}){const P=m?m instanceof w.ExtensionManagementError?m.code:w.ExtensionManagementErrorCode.Internal:void 0;n.publicLog(e,{...r,success:!m,duration:o,errorcode:P,durationSinceUpdate:S})}t.reportTelemetry=s;class i{constructor(){this.barrier=new C.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,C.createCancelablePromise)(e=>this.doRun(e))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,C.createCancelablePromise)(e=>new Promise((r,o)=>{const m=e.onCancellationRequested(()=>{m.dispose(),o(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=i}),define(Z[49],ee([0,1,19,3,24,15,12,51,75,2,16,14,13,17,39,55,7,10,88,18,23,34,46,11,8,9,27,4,44,41,26,28]),function($,t,D,C,b,L,T,p,a,h,I,w,g,E,l,d,v,u,f,y,c,s,i,n,e,r,o,m,S,P,k,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeExtensionsScannerService=t.toExtensionDescription=t.AbstractExtensionsScannerService=t.IExtensionsScannerService=t.Translations=void 0;var B;(function(ae){function N(_,M){if(_===M)return!0;const A=Object.keys(_),W=new Set;for(const G of Object.keys(M))W.add(G);if(A.length!==W.size)return!1;for(const G of A){if(_[G]!==M[G])return!1;W.delete(G)}return W.size===0}ae.equals=N})(B=t.Translations||(t.Translations={})),t.IExtensionsScannerService=(0,e.createDecorator)("IExtensionsScannerService");let q=class extends h.Disposable{constructor(N,_,M,A,W,G,Q,F,V,R,O){super();this.systemExtensionsLocation=N,this.userExtensionsLocation=_,this.extensionsControlLocation=M,this.cacheLocation=A,this.userDataProfilesService=W,this.extensionsProfileScannerService=G,this.fileService=Q,this.logService=F,this.environmentService=V,this.productService=R,this.instantiationService=O,this._onDidChangeCache=this._register(new m.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,E.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ce,(0,E.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ce,(0,E.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ne,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(N,_){const[M,A]=await Promise.all([this.scanSystemExtensions(N),this.scanUserExtensions(_)]),W=await this.scanExtensionsUnderDevelopment(N,[...M,...A]);return this.dedupExtensions(M,A,W,await this.getTargetPlatform(),!0)}async scanSystemExtensions(N){const _=[];_.push(this.scanDefaultSystemExtensions(!!N.useCache,N.language)),_.push(this.scanDevSystemExtensions(N.language,!!N.checkControlFile));const[M,A]=await Promise.all(_);return this.applyScanOptions([...M,...A],0,N,!1)}async scanUserExtensions(N){this.logService.trace("Started scanning user extensions");const _=await this.createExtensionScannerInput(N.profileLocation??this.userExtensionsLocation,!!N.profileLocation,1,!N.includeUninstalled,N.language);let A=await(N.useCache&&!_.devMode&&_.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(_);return A=await this.applyScanOptions(A,1,N,!0),this.logService.trace("Scanned user extensions:",A.length),A}async scanExtensionsUnderDevelopment(N,_){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const M=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(A=>A.scheme===I.Schemas.file).map(async A=>{const W=await this.createExtensionScannerInput(A,!1,1,!0,N.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(W)).map(Q=>(Q.type=_.find(F=>(0,c.areSameExtensions)(F.identifier,Q.identifier))?.type??Q.type,this.extensionsScanner.validate(Q,W)))}))).flat();return this.applyScanOptions(M,"development",N,!0)}return[]}async scanExistingExtension(N,_,M){const A=await this.createExtensionScannerInput(N,!1,_,!0,M.language),W=await this.extensionsScanner.scanExtension(A);return!W||!M.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(N,_,M){const A=await this.createExtensionScannerInput(N,!1,_,!0,M.language),W=await this.extensionsScanner.scanOneOrMultipleExtensions(A);return this.applyScanOptions(W,_,M,!0)}async scanMetadata(N){const _=(0,E.joinPath)(N,"package.json"),M=(await this.fileService.readFile(_)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(N,_){const M=(0,E.joinPath)(N,"package.json"),A=(await this.fileService.readFile(M)).value.toString(),W=JSON.parse(A);_.isMachineScoped=_.isMachineScoped||void 0,_.isBuiltin=_.isBuiltin||void 0,_.installedTimestamp=_.installedTimestamp||void 0,W.__metadata={...W.__metadata,..._},await this.fileService.writeFile((0,E.joinPath)(N,"package.json"),L.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async applyScanOptions(N,_,M,A){return M.includeAllVersions||(N=this.dedupExtensions(_===0?N:void 0,_===1?N:void 0,_==="development"?N:void 0,await this.getTargetPlatform(),A)),M.includeInvalid||(N=N.filter(W=>W.isValid)),N.sort((W,G)=>{const Q=w.basename(W.location.fsPath),F=w.basename(G.location.fsPath);return Q<F?-1:Q>F?1:0})}dedupExtensions(N,_,M,A,W){const G=(F,V,R)=>{if(F.isValid&&!V.isValid)return!1;if(F.isValid===V.isValid){if(W&&l.gt(F.manifest.version,V.manifest.version))return this.logService.debug(`Skipping extension ${V.location.path} with lower version ${V.manifest.version} in favour of ${F.location.path} with version ${F.manifest.version}`),!1;if(l.eq(F.manifest.version,V.manifest.version)){if(F.type===0)return this.logService.debug(`Skipping extension ${V.location.path} in favour of system extension ${F.location.path} with same version`),!1;if(F.targetPlatform===A)return this.logService.debug(`Skipping extension ${V.location.path} from different target platform ${V.targetPlatform}`),!1}}return R?this.logService.warn(`Overwriting user extension ${F.location.path} with ${V.location.path}.`):this.logService.debug(`Overwriting user extension ${F.location.path} with ${V.location.path}.`),!0},Q=new Map;return N?.forEach(F=>{const V=s.ExtensionIdentifier.toKey(F.identifier.id),R=Q.get(V);(!R||G(R,F,!1))&&Q.set(V,F)}),_?.forEach(F=>{const V=s.ExtensionIdentifier.toKey(F.identifier.id),R=Q.get(V);if(!R&&N&&F.type===0){this.logService.debug(`Skipping obsolete system extension ${F.location.path}.`);return}(!R||G(R,F,!1))&&Q.set(V,F)}),M?.forEach(F=>{const V=s.ExtensionIdentifier.toKey(F.identifier.id),R=Q.get(V);(!R||G(R,F,!0))&&Q.set(V,F),Q.set(V,F)}),[...Q.values()]}async scanDefaultSystemExtensions(N,_){this.logService.trace("Started scanning system extensions");const M=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,_),W=await(N&&!M.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(M);return this.logService.trace("Scanned system extensions:",W.length),W}async scanDevSystemExtensions(N,_){const M=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!M?.length)return[];this.logService.trace("Started scanning dev system extensions");const A=_?await this.getBuiltInExtensionControl():{},W=[],G=u.URI.file(w.normalize(w.join(I.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions")));for(const F of M){const V=A[F.name]||"marketplace";switch(V){case"disabled":break;case"marketplace":W.push((0,E.joinPath)(G,F.name));break;default:W.push(u.URI.file(V));break}}const Q=await Promise.all(W.map(async F=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(F,!1,0,!0,N))));return this.logService.trace("Scanned dev system extensions:",Q.length),(0,D.coalesce)(Q)}async getBuiltInExtensionControl(){try{const N=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(N.value.toString())}catch{return{}}}async createExtensionScannerInput(N,_,M,A,W,G=!0){const Q=await this.getTranslations(W??g.language),F=await this.getMtime(N),V=_?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,R=V?await this.getMtime(V):void 0;return new Y(N,F,V,R,_,M,A,G,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,W,Q)}async getMtime(N){try{const _=await this.fileService.stat(N);if(typeof _.mtime=="number")return _.mtime}catch{}}};q=fe([te(4,k.IUserDataProfilesService),te(5,P.IExtensionsProfileScannerService),te(6,n.IFileService),te(7,r.ILogService),te(8,y.IEnvironmentService),te(9,o.IProductService),te(10,e.IInstantiationService)],q),t.AbstractExtensionsScannerService=q;class Y{constructor(N,_,M,A,W,G,Q,F,V,R,O,x,j,H){this.location=N,this.mtime=_,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=A,this.profile=W,this.type=G,this.excludeObsolete=Q,this.validate=F,this.productVersion=V,this.productDate=R,this.productCommit=O,this.devMode=x,this.language=j,this.translations=H}static createNlsConfiguration(N){return{language:N.language,pseudo:N.language==="pseudo",devMode:N.devMode,translations:N.translations}}static equals(N,_){return(0,E.isEqual)(N.location,_.location)&&N.mtime===_.mtime&&(0,E.isEqual)(N.applicationExtensionslocation,_.applicationExtensionslocation)&&N.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&N.profile===_.profile&&N.type===_.type&&N.excludeObsolete===_.excludeObsolete&&N.validate===_.validate&&N.productVersion===_.productVersion&&N.productDate===_.productDate&&N.productCommit===_.productCommit&&N.devMode===_.devMode&&N.language===_.language&&B.equals(N.translations,_.translations)}}let ne=class extends h.Disposable{constructor(N,_,M,A,W){super();this.obsoleteFile=N,this.extensionsProfileScannerService=_,this.uriIdentityService=M,this.fileService=A,this.logService=W}async scanExtensions(N){const _=N.profile?await this.scanExtensionsFromProfile(N):await this.scanExtensionsFromLocation(N);let M={};if(N.excludeObsolete&&N.type===1)try{const A=(await this.fileService.readFile(this.obsoleteFile)).value.toString();M=JSON.parse(A)}catch{}return(0,v.isEmptyObject)(M)?_:_.filter(A=>!M[c.ExtensionKey.create(A).toString()])}async scanExtensionsFromLocation(N){const _=await this.fileService.resolve(N.location);if(!_.children?.length)return[];const M=await Promise.all(_.children.map(async A=>{if(!A.isDirectory||N.type===1&&(0,E.basename)(A.resource).indexOf(".")===0)return null;const W=new Y(A.resource,N.mtime,N.applicationExtensionslocation,N.applicationExtensionslocationMtime,N.profile,N.type,N.excludeObsolete,N.validate,N.productVersion,N.productDate,N.productCommit,N.devMode,N.language,N.translations);return this.scanExtension(W)}));return(0,D.coalesce)(M).sort((A,W)=>A.location.path<W.location.path?-1:1)}async scanExtensionsFromProfile(N){let _=await this.scanExtensionsFromProfileResource(N.location,()=>!0,N);if(N.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(N.location,N.applicationExtensionslocation)){_=_.filter(A=>!A.metadata?.isApplicationScoped);const M=await this.scanExtensionsFromProfileResource(N.applicationExtensionslocation,A=>!!A.metadata?.isApplicationScoped,N);_.push(...M)}return _}async scanExtensionsFromProfileResource(N,_,M){const A=await this.extensionsProfileScannerService.scanProfileExtensions(N);if(!A.length)return[];const W=await Promise.all(A.map(async G=>{if(_(G)){const Q=new Y(G.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(Q,G.metadata)}return null}));return(0,D.coalesce)(W)}async scanOneOrMultipleExtensions(N){try{if(await this.fileService.exists((0,E.joinPath)(N.location,"package.json"))){const _=await this.scanExtension(N);return _?[_]:[]}else return await this.scanExtensions(N)}catch(_){return this.logService.error(`Error scanning extensions at ${N.location.path}:`,(0,T.getErrorMessage)(_)),[]}}async scanExtension(N,_){try{let M=await this.scanExtensionManifest(N.location);if(M){M.publisher||(M.publisher=s.UNDEFINED_PUBLISHER),_=_??M.__metadata,delete M.__metadata;const A=(0,c.getGalleryExtensionId)(M.publisher,M.name),W=_?.id?{id:A,uuid:_.id}:{id:A},G=_?.isSystem?0:N.type,Q=G===0||!!_?.isBuiltin;M=await this.translateManifest(N.location,M,Y.createNlsConfiguration(N));const F={type:G,identifier:W,manifest:M,location:N.location,isBuiltin:Q,targetPlatform:_?.targetPlatform??"undefined",metadata:_,isValid:!0,validations:[]};return N.validate?this.validate(F,N):F}}catch(M){N.type!==0&&this.logService.error(M)}return null}validate(N,_){let M=!0;const A=(0,i.validateExtensionManifest)(_.productVersion,_.productDate,_.location,N.manifest,N.isBuiltin);for(const[W,G]of A)W===d.default.Error&&(M=!1,this.logService.error(this.formatMessage(_.location,G)));return N.isValid=M,N.validations=A,N}async scanExtensionManifest(N){const _=(0,E.joinPath)(N,"package.json");let M;try{M=(await this.fileService.readFile(_)).value.toString()}catch(W){return(0,n.toFileOperationResult)(W)!==1&&this.logService.error(this.formatMessage(N,(0,f.localize)(0,null,_.path,W.message))),null}let A;try{A=JSON.parse(M)}catch{const G=[];(0,p.parse)(M,G);for(const Q of G)this.logService.error(this.formatMessage(N,(0,f.localize)(1,null,_.path,Q.offset,Q.length,(0,a.getParseErrorMessage)(Q.error))));return null}return(0,p.getNodeType)(A)!=="object"?(this.logService.error(this.formatMessage(N,(0,f.localize)(2,null,_.path))),null):A}async translateManifest(N,_,M){const A=await this.getLocalizedMessages(N,_,M);if(A)try{const W=[],G=await this.resolveOriginalMessageBundle(A.default,W);if(W.length>0)return W.forEach(F=>{this.logService.error(this.formatMessage(N,(0,f.localize)(3,null,A.default?.path,(0,a.getParseErrorMessage)(F.error))))}),_;if((0,p.getNodeType)(A)!=="object")return this.logService.error(this.formatMessage(N,(0,f.localize)(4,null,A.default?.path))),_;const Q=A.values||Object.create(null);this.replaceNLStrings(M.pseudo,_,Q,G,N)}catch{}return _}async getLocalizedMessages(N,_,M){const A=(0,E.joinPath)(N,"package.nls.json"),W=(V,R)=>{R.forEach(O=>{this.logService.error(this.formatMessage(N,(0,f.localize)(5,null,V?.path,(0,a.getParseErrorMessage)(O.error))))})},G=V=>{this.logService.error(this.formatMessage(N,(0,f.localize)(6,null,V?.path)))},Q=`${_.publisher}.${_.name}`,F=M.translations[Q];if(F)try{const V=u.URI.file(F),R=(await this.fileService.readFile(V)).value.toString(),O=[],x=(0,p.parse)(R,O);return O.length>0?(W(V,O),{values:void 0,default:A}):(0,p.getNodeType)(x)!=="object"?(G(V),{values:void 0,default:A}):{values:x.contents?x.contents.package:void 0,default:A}}catch{return{values:void 0,default:A}}else{if(!await this.fileService.exists(A))return;let R;try{R=await this.findMessageBundles(N,M)}catch{return}if(!R.localized)return{values:void 0,default:R.original};try{const O=(await this.fileService.readFile(R.localized)).value.toString(),x=[],j=(0,p.parse)(O,x);return x.length>0?(W(R.localized,x),{values:void 0,default:R.original}):(0,p.getNodeType)(j)!=="object"?(G(R.localized),{values:void 0,default:R.original}):{values:j,default:R.original}}catch{return{values:void 0,default:R.original}}}}async resolveOriginalMessageBundle(N,_){if(N)try{const M=(await this.fileService.readFile(N)).value.toString();return(0,p.parse)(M,_)}catch{return null}else return null}findMessageBundles(N,_){return new Promise((M,A)=>{const W=G=>{const Q=(0,E.joinPath)(N,`package.nls.${G}.json`);this.fileService.exists(Q).then(F=>{F&&M({localized:Q,original:(0,E.joinPath)(N,"package.nls.json")});const V=G.lastIndexOf("-");V===-1?M({localized:(0,E.joinPath)(N,"package.nls.json"),original:null}):(G=G.substring(0,V),W(G))})};if(_.devMode||_.pseudo||!_.language)return M({localized:(0,E.joinPath)(N,"package.nls.json"),original:null});W(_.language)})}replaceNLStrings(N,_,M,A,W){const G=(Q,F,V)=>{const R=Q[F];if((0,v.isString)(R)){const O=R,x=O.length;if(x>1&&O[0]==="%"&&O[x-1]==="%"){const j=O.substr(1,x-2);let H=M[j];H===void 0&&A&&(H=A[j]);let X=typeof H=="string"?H:H.message;if(X!==void 0)if(N&&(X="\uFF3B"+X.replace(/[aouei]/g,"$&$&")+"\uFF3D"),V&&A&&(F==="title"||F==="category")){const oe=A[j],le={value:X,original:typeof oe=="string"?oe:oe?.message};Q[F]=le}else Q[F]=X;else this.logService.warn(this.formatMessage(W,(0,f.localize)(7,null,j)))}}else if((0,v.isObject)(R))for(const O in R)R.hasOwnProperty(O)&&(O==="commands"?G(R,O,!0):G(R,O,V));else if((0,v.isArray)(R))for(let O=0;O<R.length;O++)G(R,O,V)};for(const Q in _)_.hasOwnProperty(Q)&&G(_,Q)}formatMessage(N,_){return`[${N.path}]: ${_}`}};ne=fe([te(1,P.IExtensionsProfileScannerService),te(2,U.IUriIdentityService),te(3,n.IFileService),te(4,r.ILogService)],ne);let ce=class extends ne{constructor(N,_,M,A,W,G){super(_,M,A,W,G);this.cacheFile=N,this.cacheValidatorThrottler=this._register(new C.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new m.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(N){const _=await this.readExtensionCache();if(this.input=N,_&&_.input&&Y.equals(_.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),_.result.map(A=>(A.location=u.URI.revive(A.location),A));const M=await super.scanExtensions(N);return await this.writeExtensionCache({input:N,result:M}),M}async readExtensionCache(){try{const N=await this.fileService.readFile(this.cacheFile),_=JSON.parse(N.value.toString());return{result:_.result,input:(0,S.revive)(_.input)}}catch(N){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(N))}return null}async writeExtensionCache(N){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify(N)))}catch(_){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(_))}}async validateCache(){if(!this.input)return;const N=await this.readExtensionCache();if(!N)return;const _=N.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!b.equals(M,_))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(A){this.logService.error(A)}}};ce=fe([te(2,P.IExtensionsProfileScannerService),te(3,U.IUriIdentityService),te(4,n.IFileService),te(5,r.ILogService)],ce);function re(ae,N){const _=(0,c.getExtensionId)(ae.manifest.publisher,ae.manifest.name);return{id:_,identifier:new s.ExtensionIdentifier(_),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:N,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}t.toExtensionDescription=re;class ge extends q{constructor(N,_,M,A,W,G,Q,F,V,R,O){super(N,_,(0,E.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,E.joinPath)(A,s.MANIFEST_CACHE_FOLDER),W,G,Q,F,V,R,O);this.translationsPromise=(async()=>{if(g.translationsConfigFile)try{const x=await this.fileService.readFile(u.URI.file(g.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}getTranslations(N){return this.translationsPromise}}t.NativeExtensionsScannerService=ge}),define(Z[141],ee([0,1,45,3,30,4,2,16,14,20,9,26]),function($,t,D,C,b,L,T,p,a,h,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let g=class extends T.Disposable{constructor(l,d){super();this.userDataProfilesService=l,this.logService=d,this.processesLimiter=new C.Limiter(5)}async postUninstall(l){const d=this.parseScript(l,"uninstall");return d&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(d.script,"uninstall",d.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${v}`)))),h.Promises.rm(this.getExtensionStoragePath(l)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(l,d){const v=`vscode:${d}`;if(l.location.scheme===p.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[v]=="string"){const u=l.manifest.scripts[v].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${v} should be a node script`),null):{script:(0,a.join)(l.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}runLifecycleHook(l,d,v,u,f){return new Promise((y,c)=>{const s=this.start(l,d,v,f);let i;const n=e=>{i&&(clearTimeout(i),i=null),e?c(e):y(void 0)};s.on("error",e=>{n((0,b.toErrorMessage)(e)||"Unknown")}),s.on("exit",(e,r)=>{n(e?`post-${d} process exited with code ${e}`:void 0)}),u&&(i=setTimeout(()=>{i=null,s.kill(),c("timed out")},5e3))})}start(l,d,v,u){const f={silent:!0,execArgv:void 0},y=(0,D.fork)(l,[`--type=extension-post-${d}`,...v],f);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const c=L.Event.fromNodeEventEmitter(y.stdout,"data"),s=L.Event.fromNodeEventEmitter(y.stderr,"data");c(e=>this.logService.info(u.identifier.id,u.manifest.version,`post-${d}`,e)),s(e=>this.logService.error(u.identifier.id,u.manifest.version,`post-${d}`,e));const i=L.Event.any(L.Event.map(c,e=>({data:`%c${e}`,format:[""]})),L.Event.map(s,e=>({data:`%c${e}`,format:["color: red"]})));return L.Event.debounce(i,(e,r)=>e?{data:e.data+r.data,format:[...e.format,...r.format]}:{data:r.data,format:r.format},100)(e=>{console.group(u.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),y}getExtensionStoragePath(l){return(0,a.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};g=fe([te(0,w.IUserDataProfilesService),te(1,I.ILogService)],g),t.ExtensionsLifecycle=g}),define(Z[142],ee([0,1,10,18,41,49,11,8,9,27,26]),function($,t,D,C,b,L,T,p,a,h,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScannerService=void 0;let w=class extends L.NativeExtensionsScannerService{constructor(E,l,d,v,u,f,y){super(D.URI.file(u.builtinExtensionsPath),D.URI.file(u.extensionsPath),u.userHome,D.URI.file(u.userDataPath),E,l,d,v,u,f,y)}};w=fe([te(0,I.IUserDataProfilesService),te(1,b.IExtensionsProfileScannerService),te(2,T.IFileService),te(3,a.ILogService),te(4,C.INativeEnvironmentService),te(5,h.IProductService),te(6,p.IInstantiationService)],w),t.ExtensionsScannerService=w}),define(Z[143],ee([0,1,3,4,2,113,7,78,8,26]),function($,t,D,C,b,L,T,p,a,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.isProfileUsingDefaultStorage=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const I="__$__targetStorageMarker";t.IStorageService=(0,a.createDecorator)("storageService");var w;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(w=t.WillSaveStateReason||(t.WillSaveStateReason={}));var g;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(g=t.StorageScope||(t.StorageScope={}));var E;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(E=t.StorageTarget||(t.StorageTarget={}));class l extends b.Disposable{constructor(y={flushInterval:l.DEFAULT_FLUSH_INTERVAL}){super();this.options=y,this._onDidChangeValue=this._register(new C.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new C.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new C.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,c){if(c===I){switch(y){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:y})}else this._onDidChangeValue.fire({scope:y,key:c,target:this.getKeyTargets(y)[c]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,c,s){return this.getStorage(c)?.get(y,s)}getBoolean(y,c,s){return this.getStorage(c)?.getBoolean(y,s)}getNumber(y,c,s){return this.getStorage(c)?.getNumber(y,s)}store(y,c,s,i){if((0,T.isUndefinedOrNull)(c)){this.remove(y,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,s,i),this.getStorage(s)?.set(y,c)})}remove(y,c){this.withPausedEmitters(()=>{this.updateKeyTarget(y,c,void 0),this.getStorage(c)?.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,c){const s=[],i=this.getKeyTargets(y);for(const n of Object.keys(i))i[n]===c&&s.push(n);return s}updateKeyTarget(y,c,s){const i=this.getKeyTargets(c);typeof s=="number"?i[y]!==s&&(i[y]=s,this.getStorage(c)?.set(I,JSON.stringify(i))):typeof i[y]=="number"&&(delete i[y],this.getStorage(c)?.set(I,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(y){switch(y){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(y){const c=this.get(I,y);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}isNew(y){return this.getBoolean(t.IS_NEW_KEY,y)===!0}async flush(y=w.NONE){this._onWillSaveState.fire({reason:y});const c=this.getStorage(-1),s=this.getStorage(0),i=this.getStorage(1);switch(y){case w.NONE:await D.Promises.settled([c?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await D.Promises.settled([c?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const y=this.getStorage(-1)?.items??new Map,c=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return u(y,c,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(y,c){return this.emitWillSaveState(w.NONE),(0,h.isUserDataProfile)(y)?this.switchToProfile(y,c):this.switchToWorkspace(y,c)}canSwitchProfile(y,c){return!(y.id===c.id||d(c)&&d(y))}switchData(y,c,s,i){this.withPausedEmitters(()=>{if(i)for(const[n,e]of y)c.set(n,e);else{const n=new Set;for(const[e,r]of y)n.add(e),c.get(e)!==r&&this.emitDidChangeValue(s,e);for(const[e]of c.items)n.has(e)||this.emitDidChangeValue(s,e)}})}}t.AbstractStorageService=l,l.DEFAULT_FLUSH_INTERVAL=60*1e3;function d(f){return f.isDefault||!!f.useDefaultFlags?.uiState}t.isProfileUsingDefaultStorage=d;class v extends l{constructor(){super();this.applicationStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.profileStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.profileStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y))),this._register(this.applicationStorage.onDidChangeStorage(y=>this.emitDidChangeValue(-1,y)))}getStorage(y){switch(y){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(y){switch(y){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}t.InMemoryStorageService=v;async function u(f,y,c,s,i,n){const e=q=>{try{return JSON.parse(q)}catch{return q}},r=new Map,o=new Map;f.forEach((q,Y)=>{r.set(Y,q),o.set(Y,e(q))});const m=new Map,S=new Map;y.forEach((q,Y)=>{m.set(Y,q),S.set(Y,e(q))});const P=new Map,k=new Map;c.forEach((q,Y)=>{P.set(Y,q),k.set(Y,e(q))}),console.group(s!==i?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const U=[];if(r.forEach((q,Y)=>{U.push({key:Y,value:q})}),console.table(U),console.groupEnd(),console.log(o),s!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const q=[];m.forEach((Y,ne)=>{q.push({key:ne,value:Y})}),console.table(q),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${n})`);const B=[];P.forEach((q,Y)=>{B.push({key:Y,value:q})}),console.table(B),console.groupEnd(),console.log(k)}t.logStorage=u}),define(Z[144],ee([0,1,19,25,12,13,32,7,10,21,18,22,23,46,11,9,27,48,131,143,35]),function($,t,D,C,b,L,T,p,a,h,I,w,g,E,l,d,v,u,f,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const s=L.isWeb?"web":(0,w.getTargetPlatform)(L.platform,T.arch);var i;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...R){return String(R.reduce((O,x)=>O|x,0))}var e;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(e||(e={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class P{constructor(O=S){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(O,x=this.state.pageSize){return new P({...this.state,pageNumber:O,pageSize:x})}withFilter(O,...x){const j=[...this.state.criteria,...x.length?x.map(H=>({filterType:O,value:H})):[{filterType:O}]];return new P({...this.state,criteria:j})}withSortBy(O){return new P({...this.state,sortBy:O})}withSortOrder(O){return new P({...this.state,sortOrder:O})}withFlags(...O){return new P({...this.state,flags:O.reduce((x,j)=>x|j,0)})}withAssetTypes(...O){return new P({...this.state,assetTypes:O})}withSource(O){return new P({...this.state,source:O})}get raw(){const{criteria:O,pageNumber:x,pageSize:j,sortBy:H,sortOrder:X,flags:oe,assetTypes:le}=this.state;return{filters:[{criteria:O,pageNumber:x,pageSize:j,sortBy:H,sortOrder:X}],assetTypes:le,flags:oe}}get searchText(){const O=this.state.criteria.filter(x=>x.filterType===e.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function k(R,O){const x=(R||[]).filter(j=>j.statisticName===O)[0];return x?x.value:0}function U(R){const O="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(j=>j.assetType.indexOf(O)===0).reduce((j,H)=>{const X=Y(R,H.assetType);return X&&j.push([H.assetType.substring(O.length),X]),j},[])}function B(R){if(R.properties){const O=R.properties.filter(H=>H.key===r.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=O.filter(H=>x.test(H.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return Y(R,r.Repository)}function q(R){return{uri:`${R.fallbackAssetUri}/${r.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${r.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function Y(R,O){return R.files.filter(j=>j.assetType===O)[0]?{uri:`${R.assetUri}/${O}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${O}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function ne(R,O){const x=R.properties?R.properties.filter(H=>H.key===O):[],j=x.length>0&&x[0].value;return j?j.split(",").map(H=>(0,g.adoptToGalleryExtensionId)(H)):[]}function ce(R){const O=R.properties?R.properties.filter(x=>x.key===o.Engine):[];return O.length>0&&O[0].value||""}function re(R){const O=R.properties?R.properties.filter(x=>x.key===o.PreRelease):[];return O.length>0&&O[0].value==="true"}function ge(R){const O=R.properties?R.properties.filter(j=>j.key===o.LocalizedLanguages):[],x=O.length>0&&O[0].value||"";return x?x.split(","):[]}function ae(R){return R.properties?.find(O=>O.key===o.SponsorLink)?.value}function N(R){return R.indexOf("preview")!==-1}function _(R){return R.targetPlatform?(0,w.toTargetPlatform)(R.targetPlatform):"undefined"}function M(R){const O=(0,D.distinct)(R.versions.map(_)),x=!!R.tags?.includes(w.WEB_EXTENSION_TAG),j=O.indexOf("web");return x?j===-1&&O.push("web"):j!==-1&&O.splice(j,1),O}function A(R,O){const x=(0,w.getFallbackTargetPlarforms)(O);for(let j=0;j<R.length;j++){const H=R[j];if(H.version===R[j-1]?.version){let X=j;const oe=_(H);if(oe===O)for(;X>0&&R[X-1].version===H.version;)X--;else if(x.includes(oe))for(;X>0&&R[X-1].version===H.version&&_(R[X-1])!==O;)X--;X!==j&&(R.splice(j,1),R.splice(X,0,H))}}return R}t.sortExtensionVersions=A;function W(R,O,x){R.telemetryData={index:O,querySource:x}}function G(R,O,x){const j=R.versions[0],H={manifest:Y(O,r.Manifest),readme:Y(O,r.Details),changelog:Y(O,r.Changelog),license:Y(O,r.License),repository:B(O),download:q(O),icon:Y(O,r.Icon),coreTranslations:U(O)};return{identifier:{id:(0,g.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:O.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:ae(j),description:R.shortDescription||"",installCount:k(R.statistics,"install"),rating:k(R.statistics,"averagerating"),ratingCount:k(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:x,assets:H,properties:{dependencies:ne(O,o.Dependency),extensionPack:ne(O,o.ExtensionPack),engine:ce(O),localizedLanguages:ge(O),targetPlatform:_(O),isPreReleaseVersion:re(O)},hasPreReleaseVersion:re(j),hasReleaseVersion:!0,preview:N(R.flags)}}let Q=class{constructor(O,x,j,H,X,oe,le,pe){this.requestService=x,this.logService=j,this.environmentService=H,this.telemetryService=X,this.fileService=oe,this.productService=le,this.configurationService=pe;const ve=le.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=(0,f.resolveMarketplaceHeaders)(le.version,le,this.environmentService,this.configurationService,this.fileService,O,this.telemetryService)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,x,j){const H=C.CancellationToken.isCancellationToken(x)?{}:x,X=C.CancellationToken.isCancellationToken(x)?x:j,oe=[],le=[],pe=[],ve=[];let ie=!0;for(const de of O){de.uuid?le.push(de.uuid):oe.push(de.id);const Se=!!(de.version||de.preRelease);pe.push({id:de.id,uuid:de.uuid,includePreRelease:Se}),de.version&&ve.push({id:de.id,uuid:de.uuid,version:de.version}),ie=ie&&!!de.hasPreRelease&&!Se}if(!le.length&&!oe.length)return[];let se=new P().withPage(1,O.length);le.length&&(se=se.withFilter(e.ExtensionId,...le)),oe.length&&(se=se.withFilter(e.ExtensionName,...oe)),(H.queryAllVersions||ie)&&(se=se.withFlags(se.flags,i.IncludeVersions)),H.source&&(se=se.withSource(H.source));const{extensions:he}=await this.queryGalleryExtensions(se,{targetPlatform:H.targetPlatform??s,includePreRelease:pe,versions:ve,compatible:!!H.compatible},X);return H.source&&he.forEach((de,Se)=>W(de,Se,H.source)),he}async getCompatibleExtension(O,x,j){if((0,w.isNotWebExtensionInWebTargetPlatform)(O.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(O,x,j))return O;const H=new P().withFlags(i.IncludeVersions).withPage(1,1).withFilter(e.ExtensionId,O.identifier.uuid),{extensions:X}=await this.queryGalleryExtensions(H,{targetPlatform:j,compatible:!0,includePreRelease:x},C.CancellationToken.None);return X[0]||null}async isExtensionCompatible(O,x,j){if(!(0,w.isTargetPlatformCompatible)(O.properties.targetPlatform,O.allTargetPlatforms,j)||!x&&O.properties.isPreReleaseVersion)return!1;let H=O.properties.engine;if(!H){const X=await this.getManifest(O,C.CancellationToken.None);if(!X)throw new Error("Manifest was not found");H=X.engines.vscode}return(0,E.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(O,x,j,H,X){if(!(0,w.isTargetPlatformCompatible)(_(O),H,X)||x!=="any"&&re(O)!==(x==="prerelease"))return!1;if(j)try{const oe=await this.getEngine(O);if(!(0,E.isEngineValid)(oe,this.productService.version,this.productService.date))return!1}catch(oe){return this.logService.error(`Error while getting the engine for the version ${O.version}.`,(0,b.getErrorMessage)(oe)),!1}return!0}async query(O,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=O.text||"";const H=O.pageSize??50;let X=new P().withPage(1,H);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,se,he)=>(X=X.withFilter(e.Category,he||se),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,se,he)=>(X=X.withFilter(e.Tag,he||se),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(e.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),X=X.withFilter(e.SearchText,j)),X=X.withSortBy(0)):O.ids?X=X.withFilter(e.ExtensionId,...O.ids):O.names?X=X.withFilter(e.ExtensionName,...O.names):X=X.withSortBy(4),typeof O.sortBy=="number"&&(X=X.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(X=X.withSortOrder(O.sortOrder)),O.source&&(X=X.withSource(O.source));const oe=async(ie,se)=>{const{extensions:he,total:de}=await this.queryGalleryExtensions(ie,{targetPlatform:s,compatible:!1,includePreRelease:!!O.includePreRelease},se);return he.forEach((Se,Oe)=>W(Se,(ie.pageNumber-1)*ie.pageSize+Oe,O.source)),{extensions:he,total:de}},{extensions:le,total:pe}=await oe(X,x),ve=async(ie,se)=>{if(se.isCancellationRequested)throw new b.CancellationError;const{extensions:he}=await oe(X.withPage(ie+1),se);return he};return{firstPage:le,total:pe,pageSize:X.pageSize,getPage:ve}}async queryGalleryExtensions(O,x,j){const H=O.flags;!!(O.flags&i.IncludeLatestVersionOnly)&&!!(O.flags&i.IncludeVersions)&&(O=O.withFlags(O.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(O.flags&i.IncludeLatestVersionOnly)&&!(O.flags&i.IncludeVersions)&&(O=O.withFlags(O.flags,i.IncludeLatestVersionOnly)),x.versions?.length&&(O=O.withFlags(O.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),O=O.withFlags(O.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:X,total:oe}=await this.queryRawGalleryExtensions(O,j);if(!(O.flags&i.IncludeLatestVersionOnly)){const ie=[];for(const se of X){const he=await this.toGalleryExtensionWithCriteria(se,x);he&&ie.push(he)}return{extensions:ie,total:oe}}const pe=[],ve=new Map;for(let ie=0;ie<X.length;ie++){const se=X[ie],he={id:(0,g.getGalleryExtensionId)(se.publisher.publisherName,se.extensionName),uuid:se.extensionId},de=(0,p.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(Oe=>(0,g.areSameExtensions)(Oe,he))?.includePreRelease;if(x.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(M(se),x.targetPlatform))continue;const Se=await this.toGalleryExtensionWithCriteria(se,x);!Se||Se.properties.isPreReleaseVersion&&(!de||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==x.targetPlatform&&Se.hasPreReleaseVersion?ve.set(se.extensionId,ie):pe.push([ie,Se])}if(ve.size){const ie=new Date().getTime(),se=new P().withFlags(H&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ve.size).withFilter(e.ExtensionId,...ve.keys()),{extensions:he}=await this.queryGalleryExtensions(se,x,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ie,count:ve.size});for(const de of he){const Se=ve.get(de.identifier.uuid);pe.push([Se,de])}}return{extensions:pe.sort((ie,se)=>ie[0]-se[0]).map(([,ie])=>ie),total:oe}}async toGalleryExtensionWithCriteria(O,x){const j={id:(0,g.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},H=x.versions?.find(pe=>(0,g.areSameExtensions)(pe,j))?.version,X=(0,p.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(pe=>(0,g.areSameExtensions)(pe,j))?.includePreRelease,oe=M(O),le=A(O.versions,x.targetPlatform);if(x.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(oe,x.targetPlatform))return null;for(let pe=0;pe<le.length;pe++){const ve=le[pe];if(!(H&&ve.version!==H)){if(await this.isValidVersion(ve,X?"any":"release",x.compatible,oe,x.targetPlatform))return G(O,ve,oe);if(H&&ve.version===H)return null}}return H||x.compatible?null:G(O,O.versions[0],oe)}async queryRawGalleryExtensions(O,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,i.ExcludeNonValidated).withFilter(e.Target,"Microsoft.VisualStudio.Code").withFilter(e.ExcludeWithFlags,n(i.Unpublished));const j=await this.commonHeadersPromise,H=JSON.stringify(O.raw),X={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},oe=new Date().getTime();let le,pe,ve=0;try{if(le=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:X},x),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:ve};const ie=await(0,u.asJson)(le);if(ie){const se=ie.results[0],he=se.extensions,de=se.resultMetadata&&se.resultMetadata.filter(Se=>Se.metadataType==="ResultCount")[0];return ve=de&&de.metadataItems.filter(Se=>Se.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:ve}}return{galleryExtensions:[],total:ve}}catch(ie){throw pe=ie,ie}finally{this.telemetryService.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-oe,success:!!le&&(0,u.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:pe?(0,b.isCancellationError)(pe)?"canceled":(0,b.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(O,x,j,H){if(!this.isEnabled())return;const X=L.isWeb?this.api(`/itemName/${O}.${x}/version/${j}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${O}/extensions/${x}/${j}/stats?statType=${H}`),oe=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:oe};try{await this.requestService.request({type:"POST",url:X,headers:pe},C.CancellationToken.None)}catch{}}async download(O,x,j){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const H=(0,g.getGalleryExtensionTelemetryData)(O),X=new Date().getTime(),oe=ie=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:ie}),le=j===2?"install":j===3?"update":"",pe=le?{uri:`${O.assets.download.uri}${a.URI.parse(O.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${O.assets.download.fallbackUri}${a.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:O.assets.download,ve=await this.getAsset(pe);await this.fileService.writeFile(x,ve.stream),oe(new Date().getTime()-X)}async getReadme(O,x){if(O.assets.readme){const j=await this.getAsset(O.assets.readme,{},x);return await(0,u.asTextOrError)(j)||""}return""}async getManifest(O,x){if(O.assets.manifest){const j=await this.getAsset(O.assets.manifest,{},x),H=await(0,u.asTextOrError)(j);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(O,x){const j=Y(O,r.Manifest);if(!j)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},X=await this.getAsset(j,{headers:H});return await(0,u.asJson)(X)}async getCoreTranslation(O,x){const j=O.assets.coreTranslations.filter(H=>H[0]===x.toUpperCase())[0];if(j){const H=await this.getAsset(j[1]),X=await(0,u.asTextOrError)(H);return X?JSON.parse(X):null}return null}async getChangelog(O,x){if(O.assets.changelog){const j=await this.getAsset(O.assets.changelog,{},x);return await(0,u.asTextOrError)(j)||""}return""}async getAllCompatibleVersions(O,x,j){let H=new P().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?H=H.withFilter(e.ExtensionId,O.identifier.uuid):H=H.withFilter(e.ExtensionName,O.identifier.id);const{galleryExtensions:X}=await this.queryRawGalleryExtensions(H,C.CancellationToken.None);if(!X.length)return[];const oe=M(X[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(oe,j))return[];const le=[];await Promise.all(X[0].versions.map(async ie=>{try{await this.isValidVersion(ie,x?"any":"release",!0,oe,j)&&le.push(ie)}catch{}}));const pe=[],ve=new Set;for(const ie of A(le,j))ve.has(ie.version)||(ve.add(ie.version),pe.push({version:ie.version,date:ie.lastUpdated,isPreReleaseVersion:re(ie)}));return pe}async getAsset(O,x={},j=C.CancellationToken.None){const H=await this.commonHeadersPromise,X={type:"GET"},oe={...H,...x.headers||{}};x={...x,...X,headers:oe};const le=O.uri,pe=O.fallbackUri,ve={...x,url:le};try{const ie=await this.requestService.request(ve,j);if(ie.res.statusCode===200)return ie;const se=await(0,u.asTextOrError)(ie);throw new Error(`Expected 200, got back ${ie.res.statusCode} instead.

${se}`)}catch(ie){if((0,b.isCancellationError)(ie))throw ie;const se=(0,b.getErrorMessage)(ie);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:se});const he={...x,url:pe};return this.requestService.request(he,j)}}async getEngine(O){let x=ce(O);if(!x){const j=await this.getManifestFromRawExtensionVersion(O,C.CancellationToken.None);if(!j)throw new Error("Manifest was not found");x=j.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},C.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,u.asJson)(O),j=[],H={};if(x){for(const X of x.malicious)j.push({id:X});if(x.migrateToPreRelease)for(const[X,oe]of Object.entries(x.migrateToPreRelease))(!oe.engine||(0,E.isEngineValid)(oe.engine,this.productService.version,this.productService.date))&&(H[X.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[X,oe]of Object.entries(x.deprecated))oe&&(H[X.toLowerCase()]=(0,p.isBoolean)(oe)?{}:oe)}return{malicious:j,deprecated:H}}};Q=fe([te(1,u.IRequestService),te(2,d.ILogService),te(3,I.IEnvironmentService),te(4,c.ITelemetryService),te(5,l.IFileService),te(6,v.IProductService),te(7,h.IConfigurationService)],Q);let F=class extends Q{constructor(O,x,j,H,X,oe,le,pe){super(O,x,j,H,X,oe,le,pe)}};F=fe([te(0,y.IStorageService),te(1,u.IRequestService),te(2,d.ILogService),te(3,I.IEnvironmentService),te(4,c.ITelemetryService),te(5,l.IFileService),te(6,v.IProductService),te(7,h.IConfigurationService)],F),t.ExtensionGalleryService=F;let V=class extends Q{constructor(O,x,j,H,X,oe,le){super(void 0,O,x,j,H,X,oe,le)}};V=fe([te(0,u.IRequestService),te(1,d.ILogService),te(2,I.IEnvironmentService),te(3,c.ITelemetryService),te(4,l.IFileService),te(5,v.IProductService),te(6,h.IConfigurationService)],V),t.ExtensionGalleryServiceWithNoStorageService=V}),define(Z[145],ee([0,1,44,18,11,9,65,28,26]),function($,t,D,C,b,L,T,p,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataProfilesService=void 0;let h=class je extends a.UserDataProfilesService{constructor(w,g,E,l,d){super(E,l,g,d);this.stateService=w}getStoredProfiles(){return(0,D.revive)(this.stateService.getItem(je.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,D.revive)(this.stateService.getItem(je.PROFILE_ASSOCIATIONS_KEY,{}))}};h=fe([te(0,T.IStateService),te(1,p.IUriIdentityService),te(2,C.IEnvironmentService),te(3,b.IFileService),te(4,L.ILogService)],h),t.UserDataProfilesService=h}),define(Z[146],ee([0,1,37,3,158,2]),function($,t,D,C,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativePolicyService=void 0;class T extends D.AbstractPolicyService{constructor(a){super();this.productName=a,this.throttler=new C.Throttler,this.watcher=this._register(new L.MutableDisposable)}async initializePolicies(a){await this.throttler.queue(()=>new Promise((h,I)=>{try{this.watcher.value=(0,b.createWatcher)(this.productName,a,w=>{for(const g in w){const E=w[g];E===void 0?this.policies.delete(g):this.policies.set(g,E)}this._onDidChange.fire(Object.keys(w)),h()})}catch(w){I(w)}}))}}t.NativePolicyService=T}),define(Z[67],ee([0,1,115,3,14,7,20,83,159,160]),function($,t,D,C,b,L,T,p,a,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class I extends Error{constructor(i,n){let e=n.message;switch(i){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=i,this.cause=n}}t.ExtractError=I;function w(s){const i=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>i&n).reduce((n,e)=>n+e,i&61440)}function g(s){if(s instanceof I)return s;let i;return/end of central directory record signature not found/.test(s.message)&&(i="CorruptZip"),new I(i,s)}function E(s,i,n,e,r,o){const m=b.dirname(i),S=b.join(e,m);if(!S.startsWith(e))return Promise.reject(new Error(p.localize(0,null,i)));const P=b.join(e,i);let k;return o.onCancellationRequested(()=>{k&&k.destroy()}),Promise.resolve(T.Promises.mkdir(S,{recursive:!0})).then(()=>new Promise((U,B)=>{if(!o.isCancellationRequested)try{k=(0,D.createWriteStream)(P,{mode:n}),k.once("close",()=>U()),k.once("error",B),s.once("error",B),s.pipe(k)}catch(q){B(q)}}))}function l(s,i,n,e){let r=(0,C.createCancelablePromise)(()=>Promise.resolve()),o=0;return e.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((m,S)=>{const P=new C.Sequencer,k=U=>{U.isCancellationRequested||(o++,s.readEntry())};s.once("error",S),s.once("close",()=>r.then(()=>{e.isCancellationRequested||s.entryCount===o?m():S(new I("Incomplete",new Error(p.localize(1,null,o,s.entryCount))))},S)),s.readEntry(),s.on("entry",U=>{if(e.isCancellationRequested)return;if(!n.sourcePathRegex.test(U.fileName)){k(e);return}const B=U.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(B)){const ne=b.join(i,B);r=(0,C.createCancelablePromise)(ce=>T.Promises.mkdir(ne,{recursive:!0}).then(()=>k(ce)).then(void 0,S));return}const q=v(s,U),Y=w(U);r=(0,C.createCancelablePromise)(ne=>P.queue(()=>q.then(ce=>E(ce,B,Y,i,n,ne).then(()=>k(ne)))).then(null,S))})})}function d(s,i=!1){return new Promise((n,e)=>{(0,a.open)(s,i?{lazyEntries:!0}:void 0,(r,o)=>{r?e(g(r)):n((0,L.assertIsDefined)(o))})})}function v(s,i){return new Promise((n,e)=>{s.openReadStream(i,(r,o)=>{r?e(g(r)):n((0,L.assertIsDefined)(o))})})}function u(s,i){return new Promise((n,e)=>{const r=new h.ZipFile;i.forEach(m=>{m.contents?r.addBuffer(typeof m.contents=="string"?Buffer.from(m.contents,"utf8"):m.contents,m.path):m.localPath&&r.addFile(m.localPath,m.path)}),r.end();const o=(0,D.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",e),o.once("error",e),o.once("finish",()=>n(s))})}t.zip=u;function f(s,i,n={},e){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=d(s,!0);return n.overwrite&&(o=o.then(m=>T.Promises.rm(i).then(()=>m))),o.then(m=>l(m,i,{sourcePathRegex:r},e))}t.extract=f;function y(s,i){return d(s).then(n=>new Promise((e,r)=>{n.on("entry",o=>{o.fileName===i&&v(n,o).then(m=>e(m),m=>r(m))}),n.once("close",()=>r(new Error(p.localize(2,null,i))))}))}function c(s,i){return y(s,i).then(n=>new Promise((e,r)=>{const o=[];n.once("error",r),n.on("data",m=>o.push(m)),n.on("end",()=>e(Buffer.concat(o)))}))}t.buffer=c}),define(Z[147],ee([0,1,67,90]),function($,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function b(L){return(0,D.buffer)(L,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,C.localize)(0,null))}})}t.getManifest=b}),define(Z[148],ee([0,1,3,30,12,2,16,14,13,17,39,7,10,29,20,67,89,58,18,140,22,23,41,49,123,141,147,124,137,34,46,11,8,9,27,35,28,26]),function($,t,D,C,b,L,T,p,a,h,I,w,g,E,l,d,v,u,f,y,c,s,i,n,e,r,o,m,S,P,k,U,B,q,Y,ne,ce,re){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=t.INativeServerExtensionManagementService=void 0,t.INativeServerExtensionManagementService=(0,B.refineServiceDecorator)(c.IServerExtensionManagementService);let ge=class extends y.AbstractExtensionManagementService{constructor(F,V,R,O,x,j,H,X,oe,le,pe,ve){super(F,V,R,le,ve);this.environmentService=O,this.extensionsScannerService=x,this.extensionsProfileScannerService=j,this.downloadService=H,this.fileService=oe,this.installGalleryExtensionsTasks=new Map;const ie=this._register(X.createInstance(r.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(ae,he=>ie.postUninstall(he))),this.manifestCache=this._register(new m.ExtensionsManifestCache(O,this)),this.extensionsDownloader=this._register(X.createInstance(e.ExtensionsDownloader));const se=this._register(new S.ExtensionsWatcher(this,oe,O,R,pe));this._register(se.onDidChangeExtensionsByAnotherSource(({added:he,removed:de})=>{he.length&&this._onDidInstallExtensions.fire(he.map(Se=>({identifier:Se.identifier,operation:1,local:Se}))),de.forEach(Se=>this._onDidUninstallExtension.fire({identifier:Se}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(F){this.logService.trace("ExtensionManagementService#zip",F.identifier.id);const V=await this.collectFiles(F),R=await(0,d.zip)((0,h.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,V);return g.URI.file(R)}async unzip(F){return this.logService.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const V=await this.downloadVsix(F),R=p.resolve(V.fsPath);return(0,o.getManifest)(R)}getInstalled(F,V){return this.extensionsScanner.scanExtensions(F??null,V)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(F,V={}){this.logService.trace("ExtensionManagementService#install",F.toString());const R=await this.downloadVsix(F),O=await(0,o.getManifest)(p.resolve(R.fsPath));if(O.engines&&O.engines.vscode&&!(0,k.isEngineValid)(O.engines.vscode,this.productService.version,this.productService.date))throw new Error(v.localize(0,null,(0,s.getGalleryExtensionId)(O.publisher,O.name),this.productService.version));return this.installExtension(O,R,V)}getMetadata(F){return this.extensionsScannerService.scanMetadata(F.location)}async updateMetadata(F,V){this.logService.trace("ExtensionManagementService#updateMetadata",F.identifier.id);const R={...V};return V.isPreReleaseVersion&&(R.preRelease=!0),F=await this.extensionsScanner.updateMetadata(F,R),this.manifestCache.invalidate(),F}async updateExtensionScope(F,V){return this.logService.trace("ExtensionManagementService#updateExtensionScope",F.identifier.id),F=await this.extensionsScanner.updateMetadata(F,{isMachineScoped:V}),this.manifestCache.invalidate(),F}removeUninstalledExtensions(F){return this.extensionsScanner.cleanUp(F)}async downloadVsix(F){if(F.scheme===T.Schemas.file)return F;const V=(0,h.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(F,V),V}doCreateInstallExtensionTask(F,V,R){let O;if(g.URI.isUri(V))O=new M(F,V,R,this.galleryService,this.extensionsScanner,this.logService);else{const x=s.ExtensionKey.create(V).toString();O=this.installGalleryExtensionsTasks.get(x),O||(this.installGalleryExtensionsTasks.set(x,O=new _(F,V,R,this.extensionsDownloader,this.extensionsScanner,this.logService)),O.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(x)))}return R.profileLocation?new A(O,R.profileLocation,this.extensionsProfileScannerService):O}doCreateUninstallExtensionTask(F,V){return V.profileLocation?new G(F,V.profileLocation,this.extensionsProfileScannerService):new W(F,V,this.extensionsScanner)}async collectFiles(F){const V=async O=>{let x=await l.Promises.readdir(O);x=x.map(X=>p.join(O,X));const j=await Promise.all(x.map(X=>l.Promises.stat(X)));let H=Promise.resolve([]);return j.forEach((X,oe)=>{const le=x[oe];X.isFile()&&(H=H.then(pe=>[...pe,le])),X.isDirectory()&&(H=H.then(pe=>V(le).then(ve=>[...pe,...ve])))}),H};return(await V(F.location.fsPath)).map(O=>({path:`extension/${p.relative(F.location.fsPath,O)}`,localPath:O}))}};ge=fe([te(0,c.IExtensionGalleryService),te(1,ne.ITelemetryService),te(2,q.ILogService),te(3,f.INativeEnvironmentService),te(4,n.IExtensionsScannerService),te(5,i.IExtensionsProfileScannerService),te(6,u.IDownloadService),te(7,B.IInstantiationService),te(8,U.IFileService),te(9,Y.IProductService),te(10,ce.IUriIdentityService),te(11,re.IUserDataProfilesService)],ge),t.ExtensionManagementService=ge;let ae=class extends L.Disposable{constructor(F,V,R,O){super();this.beforeRemovingExtension=F,this.fileService=V,this.extensionsScannerService=R,this.logService=O,this.uninstalledPath=(0,h.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(F){await this.removeUninstalledExtensions(),F&&await this.removeOutdatedExtensions()}async scanExtensions(F,V){const R={includeInvalid:!0,profileLocation:V};let O=[];return F===null||F===0?O.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},R)):F===1&&O.push(...await this.extensionsScannerService.scanUserExtensions(R)),O=F!==null?O.filter(x=>x.type===F):O,Promise.all(O.map(x=>this.toLocalExtension(x)))}async scanUserExtensions(F){const V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(V.map(R=>this.toLocalExtension(R)))}async extractUserExtension(F,V,R,O){const x=F.toString(),j=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,E.generateUuid)()}`),H=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,x);try{await l.Promises.rm(H)}catch{throw new c.ExtensionManagementError(v.localize(1,null,H,F.id),c.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(F,V,j,O),R={...R,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(g.URI.file(j),R);try{await this.rename(F,j,H,Date.now()+2*60*1e3),this.logService.info("Renamed to",H)}catch(X){try{await l.Promises.rm(j)}catch{}if(X.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(X)}. Deleted from extracted location`,j),X}return this.scanLocalExtension(g.URI.file(H),1)}async updateMetadata(F,V){return await this.extensionsScannerService.updateMetadata(F.location,V),this.scanLocalExtension(F.location,F.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...F){const V=F.map(R=>s.ExtensionKey.create(R));await this.withUninstalledExtensions(R=>{V.forEach(O=>R[O.toString()]=!0)})}async setInstalled(F){await this.withUninstalledExtensions(O=>delete O[F.toString()]);const R=(await this.scanUserExtensions(!0)).find(O=>s.ExtensionKey.create(O).equals(F))||null;return R?this.updateMetadata(R,{installedTimestamp:Date.now()}):null}async removeExtension(F,V){this.logService.trace(`Deleting ${V} extension from disk`,F.identifier.id,F.location.fsPath),await l.Promises.rm(F.location.fsPath),this.logService.info("Deleted from disk",F.identifier.id,F.location.fsPath)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.withUninstalledExtensions(V=>delete V[s.ExtensionKey.create(F).toString()])}async withUninstalledExtensions(F){return this.uninstalledFileLimiter.queue(async()=>{let V;try{V=await l.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let R={};if(V)try{R=JSON.parse(V)}catch{}return F&&(F(R),Object.keys(R).length?await l.Promises.writeFile(this.uninstalledPath,JSON.stringify(R)):await l.Promises.rm(this.uninstalledPath)),R})}async extractAtLocation(F,V,R,O){this.logService.trace(`Started extracting the extension from ${V} to ${R}`);try{await l.Promises.rm(R)}catch(x){throw new c.ExtensionManagementError(this.joinErrors(x).message,c.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(V,R,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${R}:`,F.id)}catch(x){try{await l.Promises.rm(R)}catch{}let j=c.ExtensionManagementErrorCode.Extract;throw x instanceof d.ExtractError&&(x.type==="CorruptZip"?j=c.ExtensionManagementErrorCode.CorruptZip:x.type==="Incomplete"&&(j=c.ExtensionManagementErrorCode.IncompleteZip)),new c.ExtensionManagementError(x.message,j)}}async rename(F,V,R,O){try{await l.Promises.rename(V,R)}catch(x){if(a.isWindows&&x&&x.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${V} to ${R} with 'EPERM' error. Trying again...`,F.id),this.rename(F,V,R,O);throw new c.ExtensionManagementError(x.message||v.localize(2,null,V,R),x.code||c.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(F,V){const R=await this.extensionsScannerService.scanExistingExtension(F,V,{includeInvalid:!0});if(R)return this.toLocalExtension(R);throw new Error(v.localize(3,null,F.path))}async toLocalExtension(F){const V=await this.fileService.resolve(F.location);let R,O;return V.children&&(R=V.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,O=V.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:R,changelogUrl:O,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated}}async removeUninstalledExtensions(){const F=await this.getUninstalledExtensions(),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=new Set;for(const j of V)F[s.ExtensionKey.create(j).toString()]||R.add(j.identifier.id.toLowerCase());const O=(0,s.groupByExtension)(V,j=>j.identifier);await D.Promises.settled(O.map(async j=>{const H=j.sort((X,oe)=>I.rcompare(X.manifest.version,oe.manifest.version))[0];R.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(H))}));const x=V.filter(j=>F[s.ExtensionKey.create(j).toString()]);await D.Promises.settled(x.map(j=>this.removeUninstalledExtension(j)))}async removeOutdatedExtensions(){const F=await this.extensionsScannerService.scanSystemExtensions({}),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=[],O=await this.extensionsScannerService.getTargetPlatform(),x=(0,s.groupByExtension)(V,j=>j.identifier);for(const j of x)if(j.length>1&&R.push(...j.sort((H,X)=>{const oe=I.rcompare(H.manifest.version,X.manifest.version);return oe!==0?oe:H.targetPlatform===O?-1:1}).slice(1)),j[0].type===0){const H=F.find(X=>(0,s.areSameExtensions)(X.identifier,j[0].identifier));(!H||I.gte(H.manifest.version,j[0].manifest.version))&&R.push(j[0])}await D.Promises.settled(R.map(j=>this.removeExtension(j,"outdated")))}joinErrors(F){const V=Array.isArray(F)?F:[F];return V.length===1?V[0]instanceof Error?V[0]:new Error(V[0]):V.reduce((R,O)=>new Error(`${R.message}${R.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}};ae=fe([te(1,U.IFileService),te(2,n.IExtensionsScannerService),te(3,q.ILogService)],ae);class N extends y.AbstractExtensionTask{constructor(F,V,R,O,x){super();this.identifier=F,this.source=V,this.options=R,this.extensionsScanner=O,this.logService=x,this._operation=2}get operation(){return(0,w.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(F,V){try{const R=await this.unsetUninstalledAndGetLocal(F.key);if(R)return F.metadata?this.extensionsScanner.updateMetadata(R,F.metadata):R}catch{throw a.isMacintosh?new c.ExtensionManagementError(v.localize(4,null),c.ExtensionManagementErrorCode.Internal):new c.ExtensionManagementError(v.localize(5,null),c.ExtensionManagementErrorCode.Internal)}return this.extract(F,V)}async unsetUninstalledAndGetLocal(F){if(!await this.isUninstalled(F))return null;this.logService.trace("Removing the extension from uninstalled list:",F.id);const R=await this.extensionsScanner.setInstalled(F);return this.logService.info("Removed the extension from uninstalled list:",F.id),R}async isUninstalled(F){return!!(await this.extensionsScanner.getUninstalledExtensions())[F.toString()]}async extract({zipPath:F,key:V,metadata:R},O){const x=await this.extensionsScanner.extractUserExtension(V,F,R,O);return this.logService.info("Extracting completed.",V.id),x}}class _ extends N{constructor(F,V,R,O,x,j){super(V.identifier,V,R,x,j);this.manifest=F,this.gallery=V,this.extensionsDownloader=O}async doRun(F){const R=(await this.extensionsScanner.scanExtensions(null,void 0)).find(j=>(0,s.areSameExtensions)(j.identifier,this.gallery.identifier));R&&(this._operation=3);const O={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,P.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,isSystem:R?.type===0?!0:void 0,updated:!!R,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,w.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:R?.preRelease)};if(R?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(R,O),metadata:O};const x=await this.downloadExtension(this.gallery,this._operation);try{const j=await this.installExtension({zipPath:x,key:s.ExtensionKey.create(this.gallery),metadata:O},F);return R&&!this.options.profileLocation&&(R.targetPlatform!==j.targetPlatform||I.neq(R.manifest.version,j.manifest.version))&&await this.extensionsScanner.setUninstalled(R),{local:j,metadata:O}}catch(j){throw await this.deleteDownloadedVSIX(x),j}}async deleteDownloadedVSIX(F){try{await this.extensionsDownloader.delete(g.URI.file(F))}catch(V){this.logService.warn("Error while deleting the downloaded vsix",F.toString(),(0,b.getErrorMessage)(V))}}async downloadExtension(F,V){let R;try{this.logService.trace("Started downloading extension:",F.identifier.id),R=(await this.extensionsDownloader.downloadExtension(F,V)).fsPath,this.logService.info("Downloaded extension:",F.identifier.id,R)}catch(O){throw new c.ExtensionManagementError((0,y.joinErrors)(O).message,c.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(R),R}catch(O){throw await this.deleteDownloadedVSIX(R),new c.ExtensionManagementError((0,y.joinErrors)(O).message,c.ExtensionManagementErrorCode.Invalid)}}}class M extends N{constructor(F,V,R,O,x,j){super({id:(0,s.getGalleryExtensionId)(F.publisher,F.name)},V,R,x,j);this.manifest=F,this.location=V,this.galleryService=O}async doRun(F){const V=new s.ExtensionKey(this.identifier,this.manifest.version),O=(await this.extensionsScanner.scanExtensions(1,void 0)).find(H=>(0,s.areSameExtensions)(this.identifier,H.identifier)),x=await this.getMetadata(this.identifier.id,this.manifest.version,F);if(x.isApplicationScoped=(0,P.isApplicationScopedExtension)(this.manifest),x.isMachineScoped=this.options.isMachineScoped||O?.isMachineScoped,x.isBuiltin=this.options.isBuiltin||O?.isBuiltin,O)if(this._operation=3,V.equals(new s.ExtensionKey(O.identifier,O.manifest.version)))try{await this.extensionsScanner.removeExtension(O,"existing")}catch{throw new Error(v.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&I.gt(O.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(O);else{const H=await this.unsetUninstalledAndGetLocal(V);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(v.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:p.resolve(this.location.fsPath),key:V,metadata:x},F),metadata:x}}async getMetadata(F,V,R){try{let[O]=await this.galleryService.getExtensions([{id:F,version:V}],R);if(O||([O]=await this.galleryService.getExtensions([{id:F}],R)),O)return{id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class A{constructor(F,V,R){this.task=F,this.profileLocation=V,this.extensionsProfileScannerService=R,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const F=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[F.local,F.metadata]],this.profileLocation),F}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class W extends y.AbstractExtensionTask{constructor(F,V,R){super();this.extension=F,this.options=V,this.extensionsScanner=R}async doRun(F){const V=[],R=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const O=s.ExtensionKey.create(this.extension);V.push(...R.filter(x=>O.equals(s.ExtensionKey.create(x))))}else V.push(...R.filter(O=>(0,s.areSameExtensions)(O.identifier,this.extension.identifier)));if(!V.length)throw new Error(v.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...V),this.options.remove)for(const O of V)try{F.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(O)}catch(x){throw new Error(v.localize(9,null,(0,C.toErrorMessage)(x)))}}}class G extends y.AbstractExtensionTask{constructor(F,V,R){super();this.extension=F,this.profileLocation=V,this.extensionsProfileScannerService=R}async doRun(F){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(Z[149],ee([0,1,128,3,15,12,2,7,21,18,129,9,127,161]),function($,t,D,C,b,L,T,p,a,h,I,w,g,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let l=class extends T.Disposable{constructor(v,u,f){super();this.environmentService=u,this.logService=f,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,u){this.logService.trace("RequestService#request (node) - begin",v.url);const{proxyUrl:f,strictSSL:y}=this;let c;try{c=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...c},i=v.agent?v.agent:await(0,g.getProxyAgent)(v.url||"",s,{proxyUrl:f,strictSSL:y});v.agent=i,v.strictSSL=y,this.authorization&&(v.headers={...v.headers||{},"Proxy-Authorization":this.authorization});try{const n=await this._request(v,u);return this.logService.trace("RequestService#request (node) - success",v.url),n}catch(n){throw this.logService.trace("RequestService#request (node) - error",v.url,n),n}}async getNodeRequest(v){return((0,D.parse)(v.url).protocol==="https:"?await new Promise((y,c)=>{$(["https"],y,c)}):await new Promise((y,c)=>{$(["http"],y,c)})).request}_request(v,u){return C.Promises.withAsyncBody(async(f,y)=>{const c=(0,D.parse)(v.url),s=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),i={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,p.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(i.auth=v.user+":"+v.password);const n=s(i,e=>{const r=(0,p.isNumber)(v.followRedirects)?v.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&r>0&&e.headers.location)this._request({...v,url:e.headers.location,followRedirects:r-1},u).then(f,y);else{let o=e;e.headers["content-encoding"]==="gzip"&&(o=e.pipe((0,E.createGunzip)())),f({res:e,stream:(0,b.streamToBufferReadableStream)(o)})}});n.on("error",y),v.timeout&&n.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&n.write(v.data),n.end(),u.onCancellationRequested(()=>{n.abort(),y(new L.CancellationError)})})}async resolveProxy(v){}};l=fe([te(0,a.IConfigurationService),te(1,h.INativeEnvironmentService),te(2,w.ILogService)],l),t.RequestService=l}),define(Z[162],ee([0,1,38,3,15,30,12,2,16,14,13,32,10,20,21,120,58,126,18,103,144,22,122,41,49,148,142,11,112,114,47,110,61,62,125,9,116,117,37,146,134,27,48,149,65,130,66,35,133,42,135,136,28,138,26,145]),function($,t,D,C,b,L,T,p,a,h,I,w,g,E,l,d,v,u,f,y,c,s,i,n,e,r,o,m,S,P,k,U,B,q,Y,ne,ce,re,ge,ae,N,_,M,A,W,G,Q,F,V,R,O,x,j,H,X,oe){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class le extends p.Disposable{constructor(ie){super();this.argv=ie,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[ie,se]=await this.initServices();return ie.invokeFunction(async he=>{const de=he.get(ne.ILogService),Se=he.get(m.IFileService),Oe=he.get(f.INativeEnvironmentService),Ae=he.get(s.IExtensionManagementCLIService);de.info("CLI main",this.argv),this.registerErrorHandler(de),await this.doRun(Oe,Ae,Se),await Promise.all(se.map(Ue=>{(0,C.raceTimeout)(Ue.flush(),1e3)}))})}async initServices(){const ie=new B.ServiceCollection,se={_serviceBrand:void 0,...N.default};ie.set(_.IProductService,se);const he=new y.NativeEnvironmentService(this.argv,se);ie.set(f.INativeEnvironmentService,he),await Promise.all([he.appSettingsHome.fsPath,he.extensionsPath].map(we=>we?E.Promises.mkdir(we,{recursive:!0}):void 0));const de=(0,ne.getLogLevel)(he),Se=[];Se.push(new ce.SpdLogLogger("cli",(0,h.join)(he.logsPath,"cli.log"),!0,!1,de)),de===ne.LogLevel.Trace&&Se.push(new ne.ConsoleLogger(de));const Oe=this._register(new ne.MultiplexLogService(Se));ie.set(ne.ILogService,Oe);const Ae=this._register(new S.FileService(Oe));ie.set(m.IFileService,Ae);const Ue=this._register(new P.DiskFileSystemProvider(Oe));Ae.registerProvider(a.Schemas.file,Ue);const xe=new G.StateService(he,Oe,Ae);ie.set(W.IStateService,xe);const z=new H.UriIdentityService(Ae);ie.set(j.IUriIdentityService,z);const K=new oe.UserDataProfilesService(xe,z,he,Ae,Oe);ie.set(X.IUserDataProfilesService,K);const J=I.isWindows&&se.win32RegValueName?this._register(new ae.NativePolicyService(se.win32RegValueName)):he.policyFile?this._register(new re.FilePolicyService(he.policyFile,Ae,Oe)):new ge.NullPolicyService;ie.set(ge.IPolicyService,J);const ue=this._register(new d.ConfigurationService(K.defaultProfile.settingsResource,Ae,J,Oe));ie.set(l.IConfigurationService,ue),await Promise.all([xe.init(),ue.initialize()]),K.setEnablement(!!ue.getValue(X.PROFILES_ENABLEMENT_CONFIG)),ie.set(j.IUriIdentityService,new H.UriIdentityService(Ae)),ie.set(M.IRequestService,new k.SyncDescriptor(A.RequestService)),ie.set(v.IDownloadService,new k.SyncDescriptor(u.DownloadService)),ie.set(n.IExtensionsProfileScannerService,new k.SyncDescriptor(n.ExtensionsProfileScannerService)),ie.set(e.IExtensionsScannerService,new k.SyncDescriptor(o.ExtensionsScannerService)),ie.set(r.INativeServerExtensionManagementService,new k.SyncDescriptor(r.ExtensionManagementService)),ie.set(s.IExtensionGalleryService,new k.SyncDescriptor(c.ExtensionGalleryServiceWithNoStorageService)),ie.set(s.IExtensionManagementCLIService,new k.SyncDescriptor(i.ExtensionManagementCLIService)),ie.set(q.ILanguagePackService,new k.SyncDescriptor(Y.NativeLanguagePackService));const me=[],Ce=(0,R.isInternalTelemetry)(se,ue);if((0,R.supportsTelemetry)(se,he)){se.aiConfig&&se.aiConfig.ariaKey&&me.push(new O.OneDataSystemAppender(Ce,"monacoworkbench",null,se.aiConfig.ariaKey));const{installSourcePath:we}=he,Te={appenders:me,sendErrorTelemetry:!1,commonProperties:(async()=>{let be;try{const De=await E.Promises.readFile(he.stateResource.fsPath);be=JSON.parse(De.toString())[F.machineIdKey]}catch(De){De.code!=="ENOENT"&&Oe.error(De)}return(0,Q.resolveCommonProperties)(Ae,(0,D.release)(),(0,D.hostname)(),process.arch,se.commit,se.version,be,Ce,we)})(),piiPaths:(0,R.getPiiPathsFromEnvironment)(he)};ie.set(F.ITelemetryService,new k.SyncDescriptor(V.TelemetryService,[Te]))}else ie.set(F.ITelemetryService,R.NullTelemetryService);return[new U.InstantiationService(ie),me]}registerErrorHandler(ie){(0,T.setUnexpectedErrorHandler)(se=>{const he=(0,L.toErrorMessage)(se,!0);!he||ie.error(`[uncaught exception in CLI]: ${he}`)}),process.on("uncaughtException",se=>(0,T.onUnexpectedError)(se)),process.on("unhandledRejection",se=>(0,T.onUnexpectedError)(se))}async doRun(ie,se,he){if(this.argv["install-source"])return this.setInstallSource(ie,he,this.argv["install-source"]);if(this.argv["list-extensions"])return se.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const de={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return se.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],de,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return se.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return se.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,x.buildTelemetryMessage)(ie.appRoot,ie.extensionsPath))}}asExtensionIdOrVSIX(ie){return ie.map(se=>/\.vsix$/i.test(se)?g.URI.file((0,h.isAbsolute)(se)?se:(0,h.join)((0,w.cwd)(),se)):se)}async setInstallSource(ie,se,he){await se.writeFile(g.URI.file(ie.installSourcePath),b.VSBuffer.fromString(he.slice(0,30)))}}async function pe(ve){const ie=new le(ve);try{await ie.run()}finally{ie.dispose()}}t.main=pe})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/node/cliProcessMain.js.map
